/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","vs/base/common/buffer","fs","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","util","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function(j){for(var e=[],v=0,A=j.length;v<A;v++)e[v]=J[j[v]];return e};define(J[103],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(A,R){if(!A)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=v}),define(J[46],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(M){return(i,w,p)=>{let n=null,E=null;if(typeof p.value=="function"?(n="value",E=p.value):typeof p.get=="function"&&(n="get",E=p.get),!E)throw new Error("not supported");p[n]=M(E,w)}}e.createDecorator=v;function A(M,i,w){let p=null,n=null;if(typeof w.value=="function"?(p="value",n=w.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(p="get",n=w.get),!n)throw new Error("not supported");const E=`$memoize$${i}`;w[p]=function(...P){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,P)}),this[E]}}e.memoize=A;function R(M,i,w){return v((p,n)=>{const E=`$debounce$${n}`,P=`$debounce$result$${n}`;return function(...b){this[P]||(this[P]=w?w():void 0),clearTimeout(this[E]),i&&(this[P]=i(this[P],...b),b=[this[P]]),this[E]=setTimeout(()=>{p.apply(this,b),this[P]=w?w():void 0},M)}})}e.debounce=R;function S(M,i,w){return v((p,n)=>{const E=`$throttle$timer$${n}`,P=`$throttle$result$${n}`,b=`$throttle$lastRun$${n}`,f=`$throttle$pending$${n}`;return function(...m){if(this[P]||(this[P]=w?w():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),i&&(this[P]=i(this[P],...m)),!this[f]){const D=this[b]+M;D<=Date.now()?(this[b]=Date.now(),p.apply(this,[this[P]]),this[P]=w?w():void 0):(this[f]=!0,this[E]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),p.apply(this,[this[P]]),this[P]=w?w():void 0},D-Date.now()))}}})}e.throttle=S}),define(J[18],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function A(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=A;function R(l){w(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=R;function S(l){w(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=S;function M(l){if(l instanceof Error){let{name:t,message:r}=l;const s=l.stacktrace||l.stack;return{$isError:!0,name:t,message:r,stack:s}}return l}e.transformErrorForSerialization=M;const i="Canceled";function w(l){return l instanceof Error&&l.name===i&&l.message===i}e.isPromiseCanceledError=w;class p extends Error{constructor(){super(i);this.name=this.message}}e.CancellationError=p;function n(){const l=new Error(i);return l.name=l.message,l}e.canceled=n;function E(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=E;function P(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=P;function b(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function f(l){const t=new Error(`${l} has been disposed`);return t.name="DISPOSED",t}e.disposed=f;function m(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=m;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class I extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=I;class o extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=o;function c(l){const t=l;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function a(l,t=Object.create(null)){const r=new Error(l);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=a}),define(J[35],Z([0,1,18]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function A(C,$=0){return C[C.length-(1+$)]}e.tail=A;function R(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}e.tail2=R;function S(C,$,V=(_,T)=>_===T){if(C===$)return!0;if(!C||!$||C.length!==$.length)return!1;for(let _=0,T=C.length;_<T;_++)if(!V(C[_],$[_]))return!1;return!0}e.equals=S;function M(C,$,V){let _=0,T=C.length-1;for(;_<=T;){const W=(_+T)/2|0,k=V(C[W],$);if(k<0)_=W+1;else if(k>0)T=W-1;else return W}return-(_+1)}e.binarySearch=M;function i(C,$){let V=0,_=C.length;if(_===0)return 0;for(;V<_;){const T=Math.floor((V+_)/2);$(C[T])?_=T:V=T+1}return V}e.findFirstInSorted=i;function w(C,$,V){if(C=C|0,C>=$.length)throw new TypeError("invalid index");let _=$[Math.floor($.length*Math.random())],T=[],W=[],k=[];for(let F of $){const U=V(F,_);U<0?T.push(F):U>0?W.push(F):k.push(F)}return C<T.length?w(C,T,V):C<T.length+k.length?k[0]:w(C-(T.length+k.length),W,V)}e.quickSelect=w;function p(C,$){const V=[];let _;for(const T of C.slice(0).sort($))!_||$(_[0],T)!==0?(_=[T],V.push(_)):_.push(T);return V}e.groupBy=p;function n(C,$,V){const _=[];function T(F,U,K){if(!(U===0&&K.length===0)){const G=_[_.length-1];G&&G.start+G.deleteCount===F?(G.deleteCount+=U,G.toInsert.push(...K)):_.push({start:F,deleteCount:U,toInsert:K})}}let W=0,k=0;for(;;){if(W===C.length){T(W,0,$.slice(k));break}if(k===$.length){T(W,C.length-W,[]);break}const F=C[W],U=$[k],K=V(F,U);K===0?(W+=1,k+=1):K<0?(T(W,1,[]),W+=1):K>0&&(T(W,0,[U]),k+=1)}return _}e.sortedDiff=n;function E(C,$,V){const _=n(C,$,V),T=[],W=[];for(const k of _)T.push(...C.slice(k.start,k.start+k.deleteCount)),W.push(...k.toInsert);return{removed:T,added:W}}e.delta=E;function P(C,$,V){if(V===0)return[];const _=C.slice(0,V).sort($);return f(C,$,_,V,C.length),_}e.top=P;function b(C,$,V,_,T){return V===0?Promise.resolve([]):new Promise((W,k)=>{(async()=>{const F=C.length,U=C.slice(0,V).sort($);for(let K=V,G=Math.min(V+_,F);K<F;K=G,G=Math.min(G+_,F)){if(K>V&&await new Promise(Y=>setTimeout(Y)),T&&T.isCancellationRequested)throw(0,v.canceled)();f(C,$,U,K,G)}return U})().then(W,k)})}e.topAsync=b;function f(C,$,V,_,T){for(const W=V.length;_<T;_++){const k=C[_];if($(k,V[W-1])<0){V.pop();const F=i(V,U=>$(k,U)<0);V.splice(F,0,k)}}}function m(C){return C.filter($=>!!$)}e.coalesce=m;function D(C){let $=0;for(let V=0;V<C.length;V++)C[V]&&(C[$]=C[V],$+=1);C.length=$}e.coalesceInPlace=D;function I(C,$,V){C.splice(V,0,C.splice($,1)[0])}e.move=I;function o(C){return!Array.isArray(C)||C.length===0}e.isFalsyOrEmpty=o;function c(C){return Array.isArray(C)&&C.length>0}e.isNonEmptyArray=c;function a(C,$){if(!$)return C.filter((_,T)=>C.indexOf(_)===T);const V=Object.create(null);return C.filter(_=>{const T=$(_);return V[T]?!1:(V[T]=!0,!0)})}e.distinct=a;function l(C){const $=new Set;return C.filter(V=>$.has(V)?!1:($.add(V),!0))}e.distinctES6=l;function t(C){const $=Object.create(null);return V=>{const _=C(V);return $[_]?!1:($[_]=!0,!0)}}e.uniqueFilter=t;function r(C,$){for(let V=C.length-1;V>=0;V--){const _=C[V];if($(_))return V}return-1}e.lastIndex=r;function s(C,$){return C.length>0?C[0]:$}e.firstOrDefault=s;function u(C,$,V=(_,T)=>_===T){let _=0;for(let T=0,W=Math.min(C.length,$.length);T<W&&V(C[T],$[T]);T++)_++;return _}e.commonPrefixLength=u;function h(C){return[].concat(...C)}e.flatten=h;function g(C,$){let V=typeof $=="number"?C:0;typeof $=="number"?V=C:(V=0,$=C);const _=[];if(V<=$)for(let T=V;T<$;T++)_.push(T);else for(let T=V;T>$;T--)_.push(T);return _}e.range=g;function d(C,$,V){return C.reduce((_,T)=>(_[$(T)]=V?V(T):T,_),Object.create(null))}e.index=d;function y(C,$){return C.push($),()=>L(C,$)}e.insert=y;function L(C,$){const V=C.indexOf($);if(V>-1)return C.splice(V,1),$}e.remove=L;function O(C,$,V){const _=C.slice(0,$),T=C.slice($);return _.concat(V,T)}e.arrayInsert=O;function z(C,$){let V;if(typeof $=="number"){let _=$;V=()=>{const T=Math.sin(_++)*179426549;return T-Math.floor(T)}}else V=Math.random;for(let _=C.length-1;_>0;_-=1){const T=Math.floor(V()*(_+1)),W=C[_];C[_]=C[T],C[T]=W}}e.shuffle=z;function X(C,$){const V=C.indexOf($);V>-1&&(C.splice(V,1),C.unshift($))}e.pushToStart=X;function x(C,$){const V=C.indexOf($);V>-1&&(C.splice(V,1),C.push($))}e.pushToEnd=x;function H(C,$){return Array.isArray(C)?C.map($):$(C)}e.mapArrayOrNot=H;function Q(C){return Array.isArray(C)?C:[C]}e.asArray=Q;function B(C){return C[Math.floor(Math.random()*C.length)]}e.getRandomElement=B;function N(C,$){for(const V of C){const _=$(V);if(_!==void 0)return _}}e.mapFind=N}),define(J[42],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(A){const R=this;let S=!1,M;return function(){return S||(S=!0,M=A.apply(R,arguments)),M}}e.once=v}),define(J[63],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(A){function R(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}A.is=R;const S=Object.freeze([]);function M(){return S}A.empty=M;function*i(l){yield l}A.single=i;function w(l){return l||S}A.from=w;function p(l){return!l||l[Symbol.iterator]().next().done===!0}A.isEmpty=p;function n(l){return l[Symbol.iterator]().next().value}A.first=n;function E(l,t){for(const r of l)if(t(r))return!0;return!1}A.some=E;function P(l,t){for(const r of l)if(t(r))return r}A.find=P;function*b(l,t){for(const r of l)t(r)&&(yield r)}A.filter=b;function*f(l,t){for(const r of l)yield t(r)}A.map=f;function*m(...l){for(const t of l)for(const r of t)yield r}A.concat=m;function*D(l){for(const t of l)for(const r of t)yield r}A.concatNested=D;function I(l,t,r){let s=r;for(const u of l)s=t(s,u);return s}A.reduce=I;function*o(l,t,r=l.length){for(t<0&&(t+=l.length),r<0?r+=l.length:r>l.length&&(r=l.length);t<r;t++)yield l[t]}A.slice=o;function c(l,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,l];const s=l[Symbol.iterator]();for(let u=0;u<t;u++){const h=s.next();if(h.done)return[r,A.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return s}}]}A.consume=c;function a(l,t,r=(s,u)=>s===u){const s=l[Symbol.iterator](),u=t[Symbol.iterator]();for(;;){const h=s.next(),g=u.next();if(h.done!==g.done)return!1;if(h.done)return!0;if(!r(h.value,g.value))return!1}}A.equals=a})(v=e.Iterable||(e.Iterable={}))}),define(J[43],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function M(t,r=!1){let s=0,u=t.length,h="",g=0,d=16,y=0;function L(B){let N=0,C=0;for(;N<B;){const $=t.charCodeAt(s);if($>=48&&$<=57)C=C*16+$-48;else if($>=65&&$<=70)C=C*16+$-65+10;else if($>=97&&$<=102)C=C*16+$-97+10;else break;s++,N++}return N<B&&(C=-1),C}function O(B){s=B,h="",g=0,d=16,y=0}function z(){const B=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&p(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&p(t.charCodeAt(s)))for(s++;s<t.length&&p(t.charCodeAt(s));)s++;else return y=3,t.substring(B,s);let N=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&p(t.charCodeAt(s))){for(s++;s<t.length&&p(t.charCodeAt(s));)s++;N=s}else y=3;return t.substring(B,N)}function X(){let B="",N=s;for(;;){if(s>=u){B+=t.substring(N,s),y=2;break}const C=t.charCodeAt(s);if(C===34){B+=t.substring(N,s),s++;break}if(C===92){if(B+=t.substring(N,s),s++,s>=u){y=2;break}switch(t.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const V=L(4);V>=0?B+=String.fromCharCode(V):y=4;break;default:y=5}N=s;continue}if(C>=0&&C<=31)if(w(C)){B+=t.substring(N,s),y=2;break}else y=6;s++}return B}function x(){if(h="",y=0,g=s,s>=u)return g=u,d=17;let B=t.charCodeAt(s);if(i(B)){do s++,h+=String.fromCharCode(B),B=t.charCodeAt(s);while(i(B));return d=15}if(w(B))return s++,h+=String.fromCharCode(B),B===13&&t.charCodeAt(s)===10&&(s++,h+=`
`),d=14;switch(B){case 123:return s++,d=1;case 125:return s++,d=2;case 91:return s++,d=3;case 93:return s++,d=4;case 58:return s++,d=6;case 44:return s++,d=5;case 34:return s++,h=X(),d=10;case 47:const N=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<u&&!w(t.charCodeAt(s));)s++;return h=t.substring(N,s),d=12}if(t.charCodeAt(s+1)===42){s+=2;const C=u-1;let $=!1;for(;s<C;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,$=!0;break}s++}return $||(s++,y=1),h=t.substring(N,s),d=13}return h+=String.fromCharCode(B),s++,d=16;case 45:if(h+=String.fromCharCode(B),s++,s===u||!p(t.charCodeAt(s)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=z(),d=11;default:for(;s<u&&H(B);)s++,B=t.charCodeAt(s);if(g!==s){switch(h=t.substring(g,s),h){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return h+=String.fromCharCode(B),s++,d=16}}function H(B){if(i(B)||w(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let B;do B=x();while(B>=12&&B<=15);return B}return{setPosition:O,getPosition:()=>s,scan:r?Q:x,getToken:()=>d,getTokenValue:()=>h,getTokenOffset:()=>g,getTokenLength:()=>s-g,getTokenError:()=>y}}e.createScanner=M;function i(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function E(t,r){const s=[],u=new Object;let h;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function y(L,O,z,X){g.value=L,g.offset=O,g.length=z,g.type=X,g.colonOffset=void 0,h=g}try{c(t,{onObjectBegin:(L,O)=>{if(r<=L)throw u;h=void 0,d=r>L,s.push("")},onObjectProperty:(L,O,z)=>{if(r<O||(y(L,O,z,"property"),s[s.length-1]=L,r<=O+z))throw u},onObjectEnd:(L,O)=>{if(r<=L)throw u;h=void 0,s.pop()},onArrayBegin:(L,O)=>{if(r<=L)throw u;h=void 0,s.push(0)},onArrayEnd:(L,O)=>{if(r<=L)throw u;h=void 0,s.pop()},onLiteralValue:(L,O,z)=>{if(r<O||(y(L,O,z,l(L)),r<=O+z))throw u},onSeparator:(L,O,z)=>{if(r<=O)throw u;if(L===":"&&h&&h.type==="property")h.colonOffset=O,d=!1,h=void 0;else if(L===","){const X=s[s.length-1];typeof X=="number"?s[s.length-1]=X+1:(d=!0,s[s.length-1]=""),h=void 0}}})}catch(L){if(L!==u)throw L}return{path:s,previousNode:h,isAtPropertyKey:d,matches:L=>{let O=0;for(let z=0;O<L.length&&z<s.length;z++)if(L[O]===s[z]||L[O]==="*")O++;else if(L[O]!=="**")return!1;return O===L.length}}}e.getLocation=E;function P(t,r=[],s=S.DEFAULT){let u=null,h=[];const g=[];function d(L){Array.isArray(h)?h.push(L):u!==null&&(h[u]=L)}return c(t,{onObjectBegin:()=>{const L={};d(L),g.push(h),h=L,u=null},onObjectProperty:L=>{u=L},onObjectEnd:()=>{h=g.pop()},onArrayBegin:()=>{const L=[];d(L),g.push(h),h=L,u=null},onArrayEnd:()=>{h=g.pop()},onLiteralValue:d,onError:(L,O,z)=>{r.push({error:L,offset:O,length:z})}},s),h[0]}e.parse=P;function b(t,r=[],s=S.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(L){u.type==="property"&&(u.length=L-u.offset,u=u.parent)}function g(L){return u.children.push(L),L}c(t,{onObjectBegin:L=>{u=g({type:"object",offset:L,length:-1,parent:u,children:[]})},onObjectProperty:(L,O,z)=>{u=g({type:"property",offset:O,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:L,offset:O,length:z,parent:u})},onObjectEnd:(L,O)=>{u.length=L+O-u.offset,u=u.parent,h(L+O)},onArrayBegin:(L,O)=>{u=g({type:"array",offset:L,length:-1,parent:u,children:[]})},onArrayEnd:(L,O)=>{u.length=L+O-u.offset,u=u.parent,h(L+O)},onLiteralValue:(L,O,z)=>{g({type:l(L),offset:O,length:z,parent:u,value:L}),h(O+z)},onSeparator:(L,O,z)=>{u.type==="property"&&(L===":"?u.colonOffset=O:L===","&&h(O))},onError:(L,O,z)=>{r.push({error:L,offset:O,length:z})}},s);const y=u.children[0];return y&&delete y.parent,y}e.parseTree=b;function f(t,r){if(!!t){let s=t;for(let u of r)if(typeof u=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let h=!1;for(const g of s.children)if(Array.isArray(g.children)&&g.children[0].value===u){s=g.children[1],h=!0;break}if(!h)return}else{const h=u;if(s.type!=="array"||h<0||!Array.isArray(s.children)||h>=s.children.length)return;s=s.children[h]}return s}}e.findNodeAtLocation=f;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=m;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let s of t.children){const u=s.children[1];u&&(r[s.children[0].value]=D(u))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function I(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=I;function o(t,r,s=!1){if(I(t,r,s)){const u=t.children;if(Array.isArray(u))for(let h=0;h<u.length&&u[h].offset<=r;h++){const g=o(u[h],r,s);if(g)return g}return t}}e.findNodeAtOffset=o;function c(t,r,s=S.DEFAULT){const u=M(t,!1);function h(U){return U?()=>U(u.getTokenOffset(),u.getTokenLength()):()=>!0}function g(U){return U?K=>U(K,u.getTokenOffset(),u.getTokenLength()):()=>!0}const d=h(r.onObjectBegin),y=g(r.onObjectProperty),L=h(r.onObjectEnd),O=h(r.onArrayBegin),z=h(r.onArrayEnd),X=g(r.onLiteralValue),x=g(r.onSeparator),H=h(r.onComment),Q=g(r.onError),B=s&&s.disallowComments,N=s&&s.allowTrailingComma;function C(){for(;;){const U=u.scan();switch(u.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:B||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(U){case 12:case 13:B?$(10):H();break;case 16:$(1);break;case 15:case 14:break;default:return U}}}function $(U,K=[],G=[]){if(Q(U),K.length+G.length>0){let Y=u.getToken();for(;Y!==17;){if(K.indexOf(Y)!==-1){C();break}else if(G.indexOf(Y)!==-1)break;Y=C()}}}function V(U){const K=u.getTokenValue();return U?X(K):y(K),C(),!0}function _(){switch(u.getToken()){case 11:let U=0;try{U=JSON.parse(u.getTokenValue()),typeof U!="number"&&($(2),U=0)}catch(K){$(2)}X(U);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return C(),!0}function T(){return u.getToken()!==10?($(3,[],[2,5]),!1):(V(!1),u.getToken()===6?(x(":"),C(),F()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function W(){d(),C();let U=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(U||$(4,[],[]),x(","),C(),u.getToken()===2&&N)break}else U&&$(6,[],[]);T()||$(4,[],[2,5]),U=!0}return L(),u.getToken()!==2?$(7,[2],[]):C(),!0}function k(){O(),C();let U=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(U||$(4,[],[]),x(","),C(),u.getToken()===4&&N)break}else U&&$(6,[],[]);F()||$(4,[],[4,5]),U=!0}return z(),u.getToken()!==4?$(8,[4],[]):C(),!0}function F(){switch(u.getToken()){case 3:return k();case 1:return W();case 10:return V(!0);default:return _()}}return C(),u.getToken()===17?s.allowEmptyContent?!0:($(4,[],[]),!1):F()?(u.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=c;function a(t,r){let s=M(t),u=[],h,g=0,d;do switch(d=s.getPosition(),h=s.scan(),h){case 12:case 13:case 17:g!==d&&u.push(t.substring(g,d)),r!==void 0&&u.push(s.getTokenValue().replace(/[^\r\n]/g,r)),g=s.getPosition();break}while(h!==17);return u.join("")}e.stripComments=a;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(J[104],Z([0,1,43]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function A(w,p,n){let E,P,b,f,m;if(p){for(f=p.offset,m=f+p.length,b=f;b>0&&!i(w,b-1);)b--;let g=m;for(;g<w.length&&!i(w,g);)g++;P=w.substring(b,g),E=S(P,n)}else P=w,E=0,b=0,f=0,m=w.length;const D=M(n,w);let I=!1,o=0,c;n.insertSpaces?c=R(" ",n.tabSize||4):c="	";const a=(0,v.createScanner)(P,!1);let l=!1;function t(){return D+R(c,E+o)}function r(){let g=a.scan();for(I=!1;g===15||g===14;)I=I||g===14,g=a.scan();return l=g===16||a.getTokenError()!==0,g}const s=[];function u(g,d,y){!l&&d<m&&y>f&&w.substring(d,y)!==g&&s.push({offset:d,length:y-d,content:g})}let h=r();if(h!==17){const g=a.getTokenOffset()+b,d=R(c,E);u(d,b,g)}for(;h!==17;){let g=a.getTokenOffset()+a.getTokenLength()+b,d=r(),y="";for(;!I&&(d===12||d===13);){const O=a.getTokenOffset()+b;u(" ",g,O),g=a.getTokenOffset()+a.getTokenLength()+b,y=d===12?t():"",d=r()}if(d===2)h!==1&&(o--,y=t());else if(d===4)h!==3&&(o--,y=t());else{switch(h){case 3:case 1:o++,y=t();break;case 5:case 12:y=t();break;case 13:I?y=t():y=" ";break;case 6:y=" ";break;case 10:if(d===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?y=" ":d!==5&&d!==17&&(l=!0);break;case 16:l=!0;break}I&&(d===12||d===13)&&(y=t())}const L=a.getTokenOffset()+b;u(y,g,L),h=d}return s}e.format=A;function R(w,p){let n="";for(let E=0;E<p;E++)n+=w;return n}function S(w,p){let n=0,E=0;const P=p.tabSize||4;for(;n<w.length;){const b=w.charAt(n);if(b===" ")E++;else if(b==="	")E+=P;else break;n++}return Math.floor(E/P)}function M(w,p){for(let n=0;n<p.length;n++){const E=p.charAt(n);if(E==="\r")return n+1<p.length&&p.charAt(n+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=M;function i(w,p){return`\r
`.indexOf(w.charAt(p))!==-1}e.isEOL=i}),define(J[105],Z([0,1,43,104]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(p,n,E){return S(p,n,void 0,E)}e.removeProperty=R;function S(p,n,E,P,b){const f=n.slice(),m=[],D=(0,v.parseTree)(p,m);let I,o;for(;f.length>0&&(o=f.pop(),I=(0,v.findNodeAtLocation)(D,f),I===void 0&&E!==void 0);)typeof o=="string"?E={[o]:E}:E=[E];if(I)if(I.type==="object"&&typeof o=="string"&&Array.isArray(I.children)){const c=(0,v.findNodeAtLocation)(I,[o]);if(c!==void 0)if(E===void 0){if(!c.parent)throw new Error("Malformed AST");const a=I.children.indexOf(c.parent);let l,t=c.parent.offset+c.parent.length;if(a>0){const r=I.children[a-1];l=r.offset+r.length}else l=I.offset+1,I.children.length>1&&(t=I.children[1].offset);return M(p,{offset:l,length:t-l,content:""},P)}else return M(p,{offset:c.offset,length:c.length,content:JSON.stringify(E)},P);else{if(E===void 0)return[];const a=`${JSON.stringify(o)}: ${JSON.stringify(E)}`,l=b?b(I.children.map(r=>r.children[0].value)):I.children.length;let t;if(l>0){const r=I.children[l-1];t={offset:r.offset+r.length,length:0,content:","+a}}else I.children.length===0?t={offset:I.offset+1,length:0,content:a}:t={offset:I.offset+1,length:0,content:a+","};return M(p,t,P)}}else if(I.type==="array"&&typeof o=="number"&&Array.isArray(I.children))if(E!==void 0){const c=`${JSON.stringify(E)}`;let a;if(I.children.length===0||o===0)a={offset:I.offset+1,length:0,content:I.children.length===0?c:c+","};else{const l=o===-1||o>I.children.length?I.children.length:o,t=I.children[l-1];a={offset:t.offset+t.length,length:0,content:","+c}}return M(p,a,P)}else{const c=o,a=I.children[c];let l;if(I.children.length===1)l={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===c){const t=I.children[c-1],r=t.offset+t.length,s=I.offset+I.length;l={offset:r,length:s-2-r,content:""}}else l={offset:a.offset,length:I.children[c+1].offset-a.offset,content:""};return M(p,l,P)}else throw new Error(`Can not add ${typeof o!="number"?"index":"property"} to parent of type ${I.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return M(p,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(E)},P)}}e.setProperty=S;function M(p,n,E){let P=i(p,n),b=n.offset,f=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;b>0&&!(0,A.isEOL)(P,b-1);)b--;for(;f<P.length&&!(0,A.isEOL)(P,f);)f++}const m=(0,A.format)(P,{offset:b,length:f-b},E);for(let I=m.length-1;I>=0;I--){const o=m[I];P=i(P,o),b=Math.min(b,o.offset),f=Math.max(f,o.offset+o.length),f+=o.content.length-o.length}const D=p.length-(P.length-f)-b;return[{offset:b,length:D,content:P.substring(b,f)}]}e.withFormatting=M;function i(p,n){return p.substring(0,n.offset)+n.content+p.substring(n.offset+n.length)}e.applyEdit=i;function w(p,n){let E=n.slice(0).sort((b,f)=>{const m=b.offset-f.offset;return m===0?b.length-f.length:m}),P=p.length;for(let b=E.length-1;b>=0;b--){let f=E[b];if(f.offset+f.length<=P)p=i(p,f);else throw new Error("Overlapping edit");P=f.offset}return p}e.applyEdits=w}),define(J[57],Z([0,1,18]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var A;(function(o){o[o.DependsOnKbLayout=-1]="DependsOnKbLayout",o[o.Unknown=0]="Unknown",o[o.Backspace=1]="Backspace",o[o.Tab=2]="Tab",o[o.Enter=3]="Enter",o[o.Shift=4]="Shift",o[o.Ctrl=5]="Ctrl",o[o.Alt=6]="Alt",o[o.PauseBreak=7]="PauseBreak",o[o.CapsLock=8]="CapsLock",o[o.Escape=9]="Escape",o[o.Space=10]="Space",o[o.PageUp=11]="PageUp",o[o.PageDown=12]="PageDown",o[o.End=13]="End",o[o.Home=14]="Home",o[o.LeftArrow=15]="LeftArrow",o[o.UpArrow=16]="UpArrow",o[o.RightArrow=17]="RightArrow",o[o.DownArrow=18]="DownArrow",o[o.Insert=19]="Insert",o[o.Delete=20]="Delete",o[o.KEY_0=21]="KEY_0",o[o.KEY_1=22]="KEY_1",o[o.KEY_2=23]="KEY_2",o[o.KEY_3=24]="KEY_3",o[o.KEY_4=25]="KEY_4",o[o.KEY_5=26]="KEY_5",o[o.KEY_6=27]="KEY_6",o[o.KEY_7=28]="KEY_7",o[o.KEY_8=29]="KEY_8",o[o.KEY_9=30]="KEY_9",o[o.KEY_A=31]="KEY_A",o[o.KEY_B=32]="KEY_B",o[o.KEY_C=33]="KEY_C",o[o.KEY_D=34]="KEY_D",o[o.KEY_E=35]="KEY_E",o[o.KEY_F=36]="KEY_F",o[o.KEY_G=37]="KEY_G",o[o.KEY_H=38]="KEY_H",o[o.KEY_I=39]="KEY_I",o[o.KEY_J=40]="KEY_J",o[o.KEY_K=41]="KEY_K",o[o.KEY_L=42]="KEY_L",o[o.KEY_M=43]="KEY_M",o[o.KEY_N=44]="KEY_N",o[o.KEY_O=45]="KEY_O",o[o.KEY_P=46]="KEY_P",o[o.KEY_Q=47]="KEY_Q",o[o.KEY_R=48]="KEY_R",o[o.KEY_S=49]="KEY_S",o[o.KEY_T=50]="KEY_T",o[o.KEY_U=51]="KEY_U",o[o.KEY_V=52]="KEY_V",o[o.KEY_W=53]="KEY_W",o[o.KEY_X=54]="KEY_X",o[o.KEY_Y=55]="KEY_Y",o[o.KEY_Z=56]="KEY_Z",o[o.Meta=57]="Meta",o[o.ContextMenu=58]="ContextMenu",o[o.F1=59]="F1",o[o.F2=60]="F2",o[o.F3=61]="F3",o[o.F4=62]="F4",o[o.F5=63]="F5",o[o.F6=64]="F6",o[o.F7=65]="F7",o[o.F8=66]="F8",o[o.F9=67]="F9",o[o.F10=68]="F10",o[o.F11=69]="F11",o[o.F12=70]="F12",o[o.F13=71]="F13",o[o.F14=72]="F14",o[o.F15=73]="F15",o[o.F16=74]="F16",o[o.F17=75]="F17",o[o.F18=76]="F18",o[o.F19=77]="F19",o[o.NumLock=78]="NumLock",o[o.ScrollLock=79]="ScrollLock",o[o.US_SEMICOLON=80]="US_SEMICOLON",o[o.US_EQUAL=81]="US_EQUAL",o[o.US_COMMA=82]="US_COMMA",o[o.US_MINUS=83]="US_MINUS",o[o.US_DOT=84]="US_DOT",o[o.US_SLASH=85]="US_SLASH",o[o.US_BACKTICK=86]="US_BACKTICK",o[o.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",o[o.US_BACKSLASH=88]="US_BACKSLASH",o[o.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",o[o.US_QUOTE=90]="US_QUOTE",o[o.OEM_8=91]="OEM_8",o[o.OEM_102=92]="OEM_102",o[o.NUMPAD_0=93]="NUMPAD_0",o[o.NUMPAD_1=94]="NUMPAD_1",o[o.NUMPAD_2=95]="NUMPAD_2",o[o.NUMPAD_3=96]="NUMPAD_3",o[o.NUMPAD_4=97]="NUMPAD_4",o[o.NUMPAD_5=98]="NUMPAD_5",o[o.NUMPAD_6=99]="NUMPAD_6",o[o.NUMPAD_7=100]="NUMPAD_7",o[o.NUMPAD_8=101]="NUMPAD_8",o[o.NUMPAD_9=102]="NUMPAD_9",o[o.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",o[o.NUMPAD_ADD=104]="NUMPAD_ADD",o[o.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",o[o.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",o[o.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",o[o.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",o[o.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",o[o.ABNT_C1=110]="ABNT_C1",o[o.ABNT_C2=111]="ABNT_C2",o[o.MAX_VALUE=112]="MAX_VALUE"})(A=e.KeyCode||(e.KeyCode={}));class R{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(c,a){this._keyCodeToStr[c]=a,this._strToKeyCode[a.toLowerCase()]=c}keyCodeToStr(c){return this._keyCodeToStr[c]}strToKeyCode(c){return this._strToKeyCode[c.toLowerCase()]||0}}const S=new R,M=new R,i=new R;(function(){function o(c,a,l=a,t=l){S.define(c,a),M.define(c,l),i.define(c,t)}o(0,"unknown"),o(1,"Backspace"),o(2,"Tab"),o(3,"Enter"),o(4,"Shift"),o(5,"Ctrl"),o(6,"Alt"),o(7,"PauseBreak"),o(8,"CapsLock"),o(9,"Escape"),o(10,"Space"),o(11,"PageUp"),o(12,"PageDown"),o(13,"End"),o(14,"Home"),o(15,"LeftArrow","Left"),o(16,"UpArrow","Up"),o(17,"RightArrow","Right"),o(18,"DownArrow","Down"),o(19,"Insert"),o(20,"Delete"),o(21,"0"),o(22,"1"),o(23,"2"),o(24,"3"),o(25,"4"),o(26,"5"),o(27,"6"),o(28,"7"),o(29,"8"),o(30,"9"),o(31,"A"),o(32,"B"),o(33,"C"),o(34,"D"),o(35,"E"),o(36,"F"),o(37,"G"),o(38,"H"),o(39,"I"),o(40,"J"),o(41,"K"),o(42,"L"),o(43,"M"),o(44,"N"),o(45,"O"),o(46,"P"),o(47,"Q"),o(48,"R"),o(49,"S"),o(50,"T"),o(51,"U"),o(52,"V"),o(53,"W"),o(54,"X"),o(55,"Y"),o(56,"Z"),o(57,"Meta"),o(58,"ContextMenu"),o(59,"F1"),o(60,"F2"),o(61,"F3"),o(62,"F4"),o(63,"F5"),o(64,"F6"),o(65,"F7"),o(66,"F8"),o(67,"F9"),o(68,"F10"),o(69,"F11"),o(70,"F12"),o(71,"F13"),o(72,"F14"),o(73,"F15"),o(74,"F16"),o(75,"F17"),o(76,"F18"),o(77,"F19"),o(78,"NumLock"),o(79,"ScrollLock"),o(80,";",";","OEM_1"),o(81,"=","=","OEM_PLUS"),o(82,",",",","OEM_COMMA"),o(83,"-","-","OEM_MINUS"),o(84,".",".","OEM_PERIOD"),o(85,"/","/","OEM_2"),o(86,"`","`","OEM_3"),o(110,"ABNT_C1"),o(111,"ABNT_C2"),o(87,"[","[","OEM_4"),o(88,"\\","\\","OEM_5"),o(89,"]","]","OEM_6"),o(90,"'","'","OEM_7"),o(91,"OEM_8"),o(92,"OEM_102"),o(93,"NumPad0"),o(94,"NumPad1"),o(95,"NumPad2"),o(96,"NumPad3"),o(97,"NumPad4"),o(98,"NumPad5"),o(99,"NumPad6"),o(100,"NumPad7"),o(101,"NumPad8"),o(102,"NumPad9"),o(103,"NumPad_Multiply"),o(104,"NumPad_Add"),o(105,"NumPad_Separator"),o(106,"NumPad_Subtract"),o(107,"NumPad_Decimal"),o(108,"NumPad_Divide")})();var w;(function(o){function c(s){return S.keyCodeToStr(s)}o.toString=c;function a(s){return S.strToKeyCode(s)}o.fromString=a;function l(s){return M.keyCodeToStr(s)}o.toUserSettingsUS=l;function t(s){return i.keyCodeToStr(s)}o.toUserSettingsGeneral=t;function r(s){return M.strToKeyCode(s)||i.strToKeyCode(s)}o.fromUserSettings=r})(w=e.KeyCodeUtils||(e.KeyCodeUtils={}));var p;(function(o){o[o.CtrlCmd=2048]="CtrlCmd",o[o.Shift=1024]="Shift",o[o.Alt=512]="Alt",o[o.WinCtrl=256]="WinCtrl",o[o.KeyCode=255]="KeyCode"})(p||(p={}));var n;(function(o){o[o.CtrlCmd=2048]="CtrlCmd",o[o.Shift=1024]="Shift",o[o.Alt=512]="Alt",o[o.WinCtrl=256]="WinCtrl"})(n=e.KeyMod||(e.KeyMod={}));function E(o,c){const a=(c&65535)<<16>>>0;return(o|a)>>>0}e.KeyChord=E;function P(o,c){if(o===0)return null;const a=(o&65535)>>>0,l=(o&4294901760)>>>16;return l!==0?new m([b(a,c),b(l,c)]):new m([b(a,c)])}e.createKeybinding=P;function b(o,c){const a=!!(o&2048),l=!!(o&256),t=c===2?l:a,r=!!(o&1024),s=!!(o&512),u=c===2?a:l,h=o&255;return new f(t,r,s,u,h)}e.createSimpleKeybinding=b;class f{constructor(c,a,l,t,r){this.ctrlKey=c,this.shiftKey=a,this.altKey=l,this.metaKey=t,this.keyCode=r}equals(c){return this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",l=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${c}${a}${l}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=f;class m{constructor(c){if(c.length===0)throw(0,v.illegalArgument)("parts");this.parts=c}getHashCode(){let c="";for(let a=0,l=this.parts.length;a<l;a++)a!==0&&(c+=";"),c+=this.parts[a].getHashCode();return c}equals(c){if(c===null||this.parts.length!==c.parts.length)return!1;for(let a=0;a<this.parts.length;a++)if(!this.parts[a].equals(c.parts[a]))return!1;return!0}}e.ChordKeybinding=m;class D{constructor(c,a,l,t,r,s){this.ctrlKey=c,this.shiftKey=a,this.altKey=l,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=D;class I{}e.ResolvedKeybinding=I}),define(J[2],Z([0,1,42,63]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const R=!1;let S=null;function M(c){S=c}if(e.setDisposableTracker=M,R){const c="__is_disposable_tracked__";S=new class{trackDisposable(a){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[c]||console.log(l)},3e3)}markTracked(a){if(a&&a!==m.None)try{a[c]=!0}catch(l){}}}}function i(c){!S||S.markTracked(c)}function w(c){return S&&S.trackDisposable(c),c}e.trackDisposable=w;class p extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=p;function n(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=n;function E(c){if(A.Iterable.is(c)){let a=[];for(const l of c)if(l){i(l);try{l.dispose()}catch(t){a.push(t)}}if(a.length===1)throw a[0];if(a.length>1)throw new p(a);return Array.isArray(c)?[]:c}else if(c)return i(c),c.dispose(),c}e.dispose=E;function P(...c){return c.forEach(i),b(()=>E(c))}e.combinedDisposable=P;function b(c){const a=w({dispose:()=>{i(a),c()}});return a}e.toDisposable=b;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(i(this),this._isDisposed=!0,this.clear())}clear(){try{E(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return i(a),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new f,w(this)}dispose(){i(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class D{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var l;this._isDisposed||a===this._value||((l=this._value)===null||l===void 0||l.dispose(),a&&i(a),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,i(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}e.MutableDisposable=D;class I{constructor(){this.references=new Map}acquire(a,...l){let t=this.references.get(a);t||(t={counter:0,object:this.createReferencedObject(a,...l)},this.references.set(a,t));const{object:r}=t,s=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(a,t.object),this.references.delete(a))});return t.counter++,{object:r,dispose:s}}}e.ReferenceCollection=I;class o{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=o}),define(J[78],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(S){this.element=S,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class A{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let S=this._first;for(;S!==v.Undefined;){const M=S.next;S.prev=v.Undefined,S.next=v.Undefined,S=M}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,M){const i=new v(S);if(this._first===v.Undefined)this._first=i,this._last=i;else if(M){const p=this._last;this._last=i,i.prev=p,p.next=i}else{const p=this._first;this._first=i,i.next=p,p.prev=i}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(i))}}shift(){if(this._first!==v.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==v.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==v.Undefined&&S.next!==v.Undefined){const M=S.prev;M.next=S.next,S.next.prev=M}else S.prev===v.Undefined&&S.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):S.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):S.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==v.Undefined;)yield S.element,S=S.next}}e.LinkedList=A});"use strict";(function(){function j(R){const S=[];typeof R=="number"&&S.push("code/timeOrigin",R);function M(w){S.push(w,Date.now())}function i(){const w=[];for(let p=0;p<S.length;p+=2)w.push({name:S[p],startTime:S[p+1]});return w}return{mark:M,getMarks:i}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const M of performance.getEntriesByType("mark"))S.push({name:M.name,startTime:Math.round(R+M.startTime)});return S}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function v(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=v(A))})(),define(J[3],Z([0,1]),function(j,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const A="en";let R=!1,S=!1,M=!1,i=!1,w=!1,p=!1,n=!1,E,P=A,b,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const D=typeof((v=m==null?void 0:m.versions)===null||v===void 0?void 0:v.electron)=="string"&&m.type==="renderer";if(e.isElectronSandboxed=D&&(m==null?void 0:m.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const u=m==null?void 0:m.env.VSCODE_BROWSER_CODE_LOADING;if(typeof u=="string")return u==="none"||u==="code"||u==="bypassHeatCheck"||u==="bypassHeatCheckAndEagerCompile"?u:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!D)f=navigator.userAgent,R=f.indexOf("Windows")>=0,S=f.indexOf("Macintosh")>=0,n=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=f.indexOf("Linux")>=0,p=!0,E=navigator.language,P=E;else if(typeof m=="object"){R=m.platform==="win32",S=m.platform==="darwin",M=m.platform==="linux",i=M&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,E=A,P=A;const u=m.env.VSCODE_NLS_CONFIG;if(u)try{const h=JSON.parse(u),g=h.availableLanguages["*"];E=h.locale,P=g||A,b=h._translationsConfigFile}catch(h){}w=!0}else console.error("Unable to resolve platform.");var I;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function o(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let c=0;S?c=1:R?c=3:M&&(c=2),e.isWindows=R,e.isMacintosh=S,e.isLinux=M,e.isLinuxSnap=i,e.isNative=w,e.isWeb=p,e.isIOS=n,e.platform=c,e.userAgent=f,e.language=P;var a;(function(u){function h(){return e.language}u.value=h;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=g;function d(){return e.language==="en"}u.isDefault=d})(a=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let g=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeSetImmediateId)for(let L=0,O=g.length;L<O;L++){const z=g[L];if(z.id===y.data.vscodeSetImmediateId){g.splice(L,1),z.callback();return}}});let d=0;return y=>{const L=++d;g.push({id:L,callback:y}),e.globals.postMessage({vscodeSetImmediateId:L},"*")}}if(typeof(m==null?void 0:m.nextTick)=="function")return m.nextTick.bind(m);const h=Promise.resolve();return g=>h.then(g)}();var l;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||n?2:R?1:3;let t=!0,r=!1;function s(){if(!r){r=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,t=new Uint16Array(u.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(J[32],Z([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let A;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const R=v.globals.vscode.process;A={get platform(){return R.platform},get env(){return R.env},cwd(){return R.cwd()},nextTick(S){return(0,v.setImmediate)(S)}}}else typeof process!="undefined"?A={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:A={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(R){return(0,v.setImmediate)(R)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.nextTick=A.nextTick}),define(J[8],Z([0,1,32]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,R=97,S=90,M=122,i=46,w=47,p=92,n=58,E=63;class P extends Error{constructor(a,l,t){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const s=a.indexOf(".")!==-1?"property":"argument";let u=`The "${a}" ${s} ${r} of type ${l}`;u+=`. Received type ${typeof t}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function b(c,a){if(typeof c!="string")throw new P(a,"string",c)}function f(c){return c===w||c===p}function m(c){return c===w}function D(c){return c>=A&&c<=S||c>=R&&c<=M}function I(c,a,l,t){let r="",s=0,u=-1,h=0,g=0;for(let d=0;d<=c.length;++d){if(d<c.length)g=c.charCodeAt(d);else{if(t(g))break;g=w}if(t(g)){if(!(u===d-1||h===1))if(h===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==i||r.charCodeAt(r.length-2)!==i){if(r.length>2){const y=r.lastIndexOf(l);y===-1?(r="",s=0):(r=r.slice(0,y),s=r.length-1-r.lastIndexOf(l)),u=d,h=0;continue}else if(r.length!==0){r="",s=0,u=d,h=0;continue}}a&&(r+=r.length>0?`${l}..`:"..",s=2)}else r.length>0?r+=`${l}${c.slice(u+1,d)}`:r=c.slice(u+1,d),s=d-u-1;u=d,h=0}else g===i&&h!==-1?++h:h=-1}return r}function o(c,a){if(a===null||typeof a!="object")throw new P("pathObject","Object",a);const l=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${t}`:`${l}${c}${t}`:t}e.win32={resolve(...c){let a="",l="",t=!1;for(let r=c.length-1;r>=-1;r--){let s;if(r>=0){if(s=c[r],b(s,"path"),s.length===0)continue}else a.length===0?s=v.cwd():(s=v.env[`=${a}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==a.toLowerCase()&&s.charCodeAt(2)===p)&&(s=`${a}\\`));const u=s.length;let h=0,g="",d=!1;const y=s.charCodeAt(0);if(u===1)f(y)&&(h=1,d=!0);else if(f(y))if(d=!0,f(s.charCodeAt(1))){let L=2,O=L;for(;L<u&&!f(s.charCodeAt(L));)L++;if(L<u&&L!==O){const z=s.slice(O,L);for(O=L;L<u&&f(s.charCodeAt(L));)L++;if(L<u&&L!==O){for(O=L;L<u&&!f(s.charCodeAt(L));)L++;(L===u||L!==O)&&(g=`\\\\${z}\\${s.slice(O,L)}`,h=L)}}}else h=1;else D(y)&&s.charCodeAt(1)===n&&(g=s.slice(0,2),h=2,u>2&&f(s.charCodeAt(2))&&(d=!0,h=3));if(g.length>0)if(a.length>0){if(g.toLowerCase()!==a.toLowerCase())continue}else a=g;if(t){if(a.length>0)break}else if(l=`${s.slice(h)}\\${l}`,t=d,d&&a.length>0)break}return l=I(l,!t,"\\",f),t?`${a}\\${l}`:`${a}${l}`||"."},normalize(c){b(c,"path");const a=c.length;if(a===0)return".";let l=0,t,r=!1;const s=c.charCodeAt(0);if(a===1)return m(s)?"\\":c;if(f(s))if(r=!0,f(c.charCodeAt(1))){let h=2,g=h;for(;h<a&&!f(c.charCodeAt(h));)h++;if(h<a&&h!==g){const d=c.slice(g,h);for(g=h;h<a&&f(c.charCodeAt(h));)h++;if(h<a&&h!==g){for(g=h;h<a&&!f(c.charCodeAt(h));)h++;if(h===a)return`\\\\${d}\\${c.slice(g)}\\`;h!==g&&(t=`\\\\${d}\\${c.slice(g,h)}`,l=h)}}}else l=1;else D(s)&&c.charCodeAt(1)===n&&(t=c.slice(0,2),l=2,a>2&&f(c.charCodeAt(2))&&(r=!0,l=3));let u=l<a?I(c.slice(l),!r,"\\",f):"";return u.length===0&&!r&&(u="."),u.length>0&&f(c.charCodeAt(a-1))&&(u+="\\"),t===void 0?r?`\\${u}`:u:r?`${t}\\${u}`:`${t}${u}`},isAbsolute(c){b(c,"path");const a=c.length;if(a===0)return!1;const l=c.charCodeAt(0);return f(l)||a>2&&D(l)&&c.charCodeAt(1)===n&&f(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let a,l;for(let s=0;s<c.length;++s){const u=c[s];b(u,"path"),u.length>0&&(a===void 0?a=l=u:a+=`\\${u}`)}if(a===void 0)return".";let t=!0,r=0;if(typeof l=="string"&&f(l.charCodeAt(0))){++r;const s=l.length;s>1&&f(l.charCodeAt(1))&&(++r,s>2&&(f(l.charCodeAt(2))?++r:t=!1))}if(t){for(;r<a.length&&f(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(c,a){if(b(c,"from"),b(a,"to"),c===a)return"";const l=e.win32.resolve(c),t=e.win32.resolve(a);if(l===t||(c=l.toLowerCase(),a=t.toLowerCase(),c===a))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===p;)r++;let s=c.length;for(;s-1>r&&c.charCodeAt(s-1)===p;)s--;const u=s-r;let h=0;for(;h<a.length&&a.charCodeAt(h)===p;)h++;let g=a.length;for(;g-1>h&&a.charCodeAt(g-1)===p;)g--;const d=g-h,y=u<d?u:d;let L=-1,O=0;for(;O<y;O++){const X=c.charCodeAt(r+O);if(X!==a.charCodeAt(h+O))break;X===p&&(L=O)}if(O!==y){if(L===-1)return t}else{if(d>y){if(a.charCodeAt(h+O)===p)return t.slice(h+O+1);if(O===2)return t.slice(h+O)}u>y&&(c.charCodeAt(r+O)===p?L=O:O===2&&(L=3)),L===-1&&(L=0)}let z="";for(O=r+L+1;O<=s;++O)(O===s||c.charCodeAt(O)===p)&&(z+=z.length===0?"..":"\\..");return h+=L,z.length>0?`${z}${t.slice(h,g)}`:(t.charCodeAt(h)===p&&++h,t.slice(h,g))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const a=e.win32.resolve(c);if(a.length<=2)return c;if(a.charCodeAt(0)===p){if(a.charCodeAt(1)===p){const l=a.charCodeAt(2);if(l!==E&&l!==i)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(D(a.charCodeAt(0))&&a.charCodeAt(1)===n&&a.charCodeAt(2)===p)return`\\\\?\\${a}`;return c},dirname(c){b(c,"path");const a=c.length;if(a===0)return".";let l=-1,t=0;const r=c.charCodeAt(0);if(a===1)return f(r)?c:".";if(f(r)){if(l=t=1,f(c.charCodeAt(1))){let h=2,g=h;for(;h<a&&!f(c.charCodeAt(h));)h++;if(h<a&&h!==g){for(g=h;h<a&&f(c.charCodeAt(h));)h++;if(h<a&&h!==g){for(g=h;h<a&&!f(c.charCodeAt(h));)h++;if(h===a)return c;h!==g&&(l=t=h+1)}}}}else D(r)&&c.charCodeAt(1)===n&&(l=a>2&&f(c.charCodeAt(2))?3:2,t=l);let s=-1,u=!0;for(let h=a-1;h>=t;--h)if(f(c.charCodeAt(h))){if(!u){s=h;break}}else u=!1;if(s===-1){if(l===-1)return".";s=l}return c.slice(0,s)},basename(c,a){a!==void 0&&b(a,"ext"),b(c,"path");let l=0,t=-1,r=!0,s;if(c.length>=2&&D(c.charCodeAt(0))&&c.charCodeAt(1)===n&&(l=2),a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let u=a.length-1,h=-1;for(s=c.length-1;s>=l;--s){const g=c.charCodeAt(s);if(f(g)){if(!r){l=s+1;break}}else h===-1&&(r=!1,h=s+1),u>=0&&(g===a.charCodeAt(u)?--u==-1&&(t=s):(u=-1,t=h))}return l===t?t=h:t===-1&&(t=c.length),c.slice(l,t)}for(s=c.length-1;s>=l;--s)if(f(c.charCodeAt(s))){if(!r){l=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":c.slice(l,t)},extname(c){b(c,"path");let a=0,l=-1,t=0,r=-1,s=!0,u=0;c.length>=2&&c.charCodeAt(1)===n&&D(c.charCodeAt(0))&&(a=t=2);for(let h=c.length-1;h>=a;--h){const g=c.charCodeAt(h);if(f(g)){if(!s){t=h+1;break}continue}r===-1&&(s=!1,r=h+1),g===i?l===-1?l=h:u!==1&&(u=1):l!==-1&&(u=-1)}return l===-1||r===-1||u===0||u===1&&l===r-1&&l===t+1?"":c.slice(l,r)},format:o.bind(null,"\\"),parse(c){b(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.length;let t=0,r=c.charCodeAt(0);if(l===1)return f(r)?(a.root=a.dir=c,a):(a.base=a.name=c,a);if(f(r)){if(t=1,f(c.charCodeAt(1))){let L=2,O=L;for(;L<l&&!f(c.charCodeAt(L));)L++;if(L<l&&L!==O){for(O=L;L<l&&f(c.charCodeAt(L));)L++;if(L<l&&L!==O){for(O=L;L<l&&!f(c.charCodeAt(L));)L++;L===l?t=L:L!==O&&(t=L+1)}}}}else if(D(r)&&c.charCodeAt(1)===n){if(l<=2)return a.root=a.dir=c,a;if(t=2,f(c.charCodeAt(2))){if(l===3)return a.root=a.dir=c,a;t=3}}t>0&&(a.root=c.slice(0,t));let s=-1,u=t,h=-1,g=!0,d=c.length-1,y=0;for(;d>=t;--d){if(r=c.charCodeAt(d),f(r)){if(!g){u=d+1;break}continue}h===-1&&(g=!1,h=d+1),r===i?s===-1?s=d:y!==1&&(y=1):s!==-1&&(y=-1)}return h!==-1&&(s===-1||y===0||y===1&&s===h-1&&s===u+1?a.base=a.name=c.slice(u,h):(a.name=c.slice(u,s),a.base=c.slice(u,h),a.ext=c.slice(s,h))),u>0&&u!==t?a.dir=c.slice(0,u-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let a="",l=!1;for(let t=c.length-1;t>=-1&&!l;t--){const r=t>=0?c[t]:v.cwd();b(r,"path"),r.length!==0&&(a=`${r}/${a}`,l=r.charCodeAt(0)===w)}return a=I(a,!l,"/",m),l?`/${a}`:a.length>0?a:"."},normalize(c){if(b(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===w,l=c.charCodeAt(c.length-1)===w;return c=I(c,!a,"/",m),c.length===0?a?"/":l?"./":".":(l&&(c+="/"),a?`/${c}`:c)},isAbsolute(c){return b(c,"path"),c.length>0&&c.charCodeAt(0)===w},join(...c){if(c.length===0)return".";let a;for(let l=0;l<c.length;++l){const t=c[l];b(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(c,a){if(b(c,"from"),b(a,"to"),c===a||(c=e.posix.resolve(c),a=e.posix.resolve(a),c===a))return"";const l=1,t=c.length,r=t-l,s=1,u=a.length-s,h=r<u?r:u;let g=-1,d=0;for(;d<h;d++){const L=c.charCodeAt(l+d);if(L!==a.charCodeAt(s+d))break;L===w&&(g=d)}if(d===h)if(u>h){if(a.charCodeAt(s+d)===w)return a.slice(s+d+1);if(d===0)return a.slice(s+d)}else r>h&&(c.charCodeAt(l+d)===w?g=d:d===0&&(g=0));let y="";for(d=l+g+1;d<=t;++d)(d===t||c.charCodeAt(d)===w)&&(y+=y.length===0?"..":"/..");return`${y}${a.slice(s+g)}`},toNamespacedPath(c){return c},dirname(c){if(b(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===w;let l=-1,t=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===w){if(!t){l=r;break}}else t=!1;return l===-1?a?"/":".":a&&l===1?"//":c.slice(0,l)},basename(c,a){a!==void 0&&b(a,"ext"),b(c,"path");let l=0,t=-1,r=!0,s;if(a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let u=a.length-1,h=-1;for(s=c.length-1;s>=0;--s){const g=c.charCodeAt(s);if(g===w){if(!r){l=s+1;break}}else h===-1&&(r=!1,h=s+1),u>=0&&(g===a.charCodeAt(u)?--u==-1&&(t=s):(u=-1,t=h))}return l===t?t=h:t===-1&&(t=c.length),c.slice(l,t)}for(s=c.length-1;s>=0;--s)if(c.charCodeAt(s)===w){if(!r){l=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":c.slice(l,t)},extname(c){b(c,"path");let a=-1,l=0,t=-1,r=!0,s=0;for(let u=c.length-1;u>=0;--u){const h=c.charCodeAt(u);if(h===w){if(!r){l=u+1;break}continue}t===-1&&(r=!1,t=u+1),h===i?a===-1?a=u:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||t===-1||s===0||s===1&&a===t-1&&a===l+1?"":c.slice(a,t)},format:o.bind(null,"/"),parse(c){b(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.charCodeAt(0)===w;let t;l?(a.root="/",t=1):t=0;let r=-1,s=0,u=-1,h=!0,g=c.length-1,d=0;for(;g>=t;--g){const y=c.charCodeAt(g);if(y===w){if(!h){s=g+1;break}continue}u===-1&&(h=!1,u=g+1),y===i?r===-1?r=g:d!==1&&(d=1):r!==-1&&(d=-1)}if(u!==-1){const y=s===0&&l?1:s;r===-1||d===0||d===1&&r===u-1&&r===s+1?a.base=a.name=c.slice(y,u):(a.name=c.slice(y,r),a.base=c.slice(y,u),a.ext=c.slice(r,u))}return s>0?a.dir=c.slice(0,s-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[106],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var A;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(A=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(S,...M){const i=M.reduce((n,E)=>(n[E]=!0,n),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(n=>!i[n]).forEach(n=>{for(let E=0;E<w.length;E++)if(n.search(w[E])!==-1){delete S[n];break}})}e.sanitizeProcessEnvironment=R}),define(J[79],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var v;(function(i){i[i.DependsOnKbLayout=-1]="DependsOnKbLayout",i[i.None=0]="None",i[i.Hyper=1]="Hyper",i[i.Super=2]="Super",i[i.Fn=3]="Fn",i[i.FnLock=4]="FnLock",i[i.Suspend=5]="Suspend",i[i.Resume=6]="Resume",i[i.Turbo=7]="Turbo",i[i.Sleep=8]="Sleep",i[i.WakeUp=9]="WakeUp",i[i.KeyA=10]="KeyA",i[i.KeyB=11]="KeyB",i[i.KeyC=12]="KeyC",i[i.KeyD=13]="KeyD",i[i.KeyE=14]="KeyE",i[i.KeyF=15]="KeyF",i[i.KeyG=16]="KeyG",i[i.KeyH=17]="KeyH",i[i.KeyI=18]="KeyI",i[i.KeyJ=19]="KeyJ",i[i.KeyK=20]="KeyK",i[i.KeyL=21]="KeyL",i[i.KeyM=22]="KeyM",i[i.KeyN=23]="KeyN",i[i.KeyO=24]="KeyO",i[i.KeyP=25]="KeyP",i[i.KeyQ=26]="KeyQ",i[i.KeyR=27]="KeyR",i[i.KeyS=28]="KeyS",i[i.KeyT=29]="KeyT",i[i.KeyU=30]="KeyU",i[i.KeyV=31]="KeyV",i[i.KeyW=32]="KeyW",i[i.KeyX=33]="KeyX",i[i.KeyY=34]="KeyY",i[i.KeyZ=35]="KeyZ",i[i.Digit1=36]="Digit1",i[i.Digit2=37]="Digit2",i[i.Digit3=38]="Digit3",i[i.Digit4=39]="Digit4",i[i.Digit5=40]="Digit5",i[i.Digit6=41]="Digit6",i[i.Digit7=42]="Digit7",i[i.Digit8=43]="Digit8",i[i.Digit9=44]="Digit9",i[i.Digit0=45]="Digit0",i[i.Enter=46]="Enter",i[i.Escape=47]="Escape",i[i.Backspace=48]="Backspace",i[i.Tab=49]="Tab",i[i.Space=50]="Space",i[i.Minus=51]="Minus",i[i.Equal=52]="Equal",i[i.BracketLeft=53]="BracketLeft",i[i.BracketRight=54]="BracketRight",i[i.Backslash=55]="Backslash",i[i.IntlHash=56]="IntlHash",i[i.Semicolon=57]="Semicolon",i[i.Quote=58]="Quote",i[i.Backquote=59]="Backquote",i[i.Comma=60]="Comma",i[i.Period=61]="Period",i[i.Slash=62]="Slash",i[i.CapsLock=63]="CapsLock",i[i.F1=64]="F1",i[i.F2=65]="F2",i[i.F3=66]="F3",i[i.F4=67]="F4",i[i.F5=68]="F5",i[i.F6=69]="F6",i[i.F7=70]="F7",i[i.F8=71]="F8",i[i.F9=72]="F9",i[i.F10=73]="F10",i[i.F11=74]="F11",i[i.F12=75]="F12",i[i.PrintScreen=76]="PrintScreen",i[i.ScrollLock=77]="ScrollLock",i[i.Pause=78]="Pause",i[i.Insert=79]="Insert",i[i.Home=80]="Home",i[i.PageUp=81]="PageUp",i[i.Delete=82]="Delete",i[i.End=83]="End",i[i.PageDown=84]="PageDown",i[i.ArrowRight=85]="ArrowRight",i[i.ArrowLeft=86]="ArrowLeft",i[i.ArrowDown=87]="ArrowDown",i[i.ArrowUp=88]="ArrowUp",i[i.NumLock=89]="NumLock",i[i.NumpadDivide=90]="NumpadDivide",i[i.NumpadMultiply=91]="NumpadMultiply",i[i.NumpadSubtract=92]="NumpadSubtract",i[i.NumpadAdd=93]="NumpadAdd",i[i.NumpadEnter=94]="NumpadEnter",i[i.Numpad1=95]="Numpad1",i[i.Numpad2=96]="Numpad2",i[i.Numpad3=97]="Numpad3",i[i.Numpad4=98]="Numpad4",i[i.Numpad5=99]="Numpad5",i[i.Numpad6=100]="Numpad6",i[i.Numpad7=101]="Numpad7",i[i.Numpad8=102]="Numpad8",i[i.Numpad9=103]="Numpad9",i[i.Numpad0=104]="Numpad0",i[i.NumpadDecimal=105]="NumpadDecimal",i[i.IntlBackslash=106]="IntlBackslash",i[i.ContextMenu=107]="ContextMenu",i[i.Power=108]="Power",i[i.NumpadEqual=109]="NumpadEqual",i[i.F13=110]="F13",i[i.F14=111]="F14",i[i.F15=112]="F15",i[i.F16=113]="F16",i[i.F17=114]="F17",i[i.F18=115]="F18",i[i.F19=116]="F19",i[i.F20=117]="F20",i[i.F21=118]="F21",i[i.F22=119]="F22",i[i.F23=120]="F23",i[i.F24=121]="F24",i[i.Open=122]="Open",i[i.Help=123]="Help",i[i.Select=124]="Select",i[i.Again=125]="Again",i[i.Undo=126]="Undo",i[i.Cut=127]="Cut",i[i.Copy=128]="Copy",i[i.Paste=129]="Paste",i[i.Find=130]="Find",i[i.AudioVolumeMute=131]="AudioVolumeMute",i[i.AudioVolumeUp=132]="AudioVolumeUp",i[i.AudioVolumeDown=133]="AudioVolumeDown",i[i.NumpadComma=134]="NumpadComma",i[i.IntlRo=135]="IntlRo",i[i.KanaMode=136]="KanaMode",i[i.IntlYen=137]="IntlYen",i[i.Convert=138]="Convert",i[i.NonConvert=139]="NonConvert",i[i.Lang1=140]="Lang1",i[i.Lang2=141]="Lang2",i[i.Lang3=142]="Lang3",i[i.Lang4=143]="Lang4",i[i.Lang5=144]="Lang5",i[i.Abort=145]="Abort",i[i.Props=146]="Props",i[i.NumpadParenLeft=147]="NumpadParenLeft",i[i.NumpadParenRight=148]="NumpadParenRight",i[i.NumpadBackspace=149]="NumpadBackspace",i[i.NumpadMemoryStore=150]="NumpadMemoryStore",i[i.NumpadMemoryRecall=151]="NumpadMemoryRecall",i[i.NumpadMemoryClear=152]="NumpadMemoryClear",i[i.NumpadMemoryAdd=153]="NumpadMemoryAdd",i[i.NumpadMemorySubtract=154]="NumpadMemorySubtract",i[i.NumpadClear=155]="NumpadClear",i[i.NumpadClearEntry=156]="NumpadClearEntry",i[i.ControlLeft=157]="ControlLeft",i[i.ShiftLeft=158]="ShiftLeft",i[i.AltLeft=159]="AltLeft",i[i.MetaLeft=160]="MetaLeft",i[i.ControlRight=161]="ControlRight",i[i.ShiftRight=162]="ShiftRight",i[i.AltRight=163]="AltRight",i[i.MetaRight=164]="MetaRight",i[i.BrightnessUp=165]="BrightnessUp",i[i.BrightnessDown=166]="BrightnessDown",i[i.MediaPlay=167]="MediaPlay",i[i.MediaRecord=168]="MediaRecord",i[i.MediaFastForward=169]="MediaFastForward",i[i.MediaRewind=170]="MediaRewind",i[i.MediaTrackNext=171]="MediaTrackNext",i[i.MediaTrackPrevious=172]="MediaTrackPrevious",i[i.MediaStop=173]="MediaStop",i[i.Eject=174]="Eject",i[i.MediaPlayPause=175]="MediaPlayPause",i[i.MediaSelect=176]="MediaSelect",i[i.LaunchMail=177]="LaunchMail",i[i.LaunchApp2=178]="LaunchApp2",i[i.LaunchApp1=179]="LaunchApp1",i[i.SelectTask=180]="SelectTask",i[i.LaunchScreenSaver=181]="LaunchScreenSaver",i[i.BrowserSearch=182]="BrowserSearch",i[i.BrowserHome=183]="BrowserHome",i[i.BrowserBack=184]="BrowserBack",i[i.BrowserForward=185]="BrowserForward",i[i.BrowserStop=186]="BrowserStop",i[i.BrowserRefresh=187]="BrowserRefresh",i[i.BrowserFavorites=188]="BrowserFavorites",i[i.ZoomToggle=189]="ZoomToggle",i[i.MailReply=190]="MailReply",i[i.MailForward=191]="MailForward",i[i.MailSend=192]="MailSend",i[i.MAX_VALUE=193]="MAX_VALUE"})(v=e.ScanCode||(e.ScanCode={}));const A=[],R=Object.create(null),S=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:i=>S[i]||0,toEnum:i=>R[i]||0,toString:i=>A[i]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class M{constructor(w,p,n,E,P){this.ctrlKey=w,this.shiftKey=p,this.altKey=n,this.metaKey=E,this.scanCode=P}equals(w){return this.ctrlKey===w.ctrlKey&&this.shiftKey===w.shiftKey&&this.altKey===w.altKey&&this.metaKey===w.metaKey&&this.scanCode===w.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=M,function(){function i(w,p){A[w]=p,R[p]=w,S[p.toLowerCase()]=w}i(0,"None"),i(1,"Hyper"),i(2,"Super"),i(3,"Fn"),i(4,"FnLock"),i(5,"Suspend"),i(6,"Resume"),i(7,"Turbo"),i(8,"Sleep"),i(9,"WakeUp"),i(10,"KeyA"),i(11,"KeyB"),i(12,"KeyC"),i(13,"KeyD"),i(14,"KeyE"),i(15,"KeyF"),i(16,"KeyG"),i(17,"KeyH"),i(18,"KeyI"),i(19,"KeyJ"),i(20,"KeyK"),i(21,"KeyL"),i(22,"KeyM"),i(23,"KeyN"),i(24,"KeyO"),i(25,"KeyP"),i(26,"KeyQ"),i(27,"KeyR"),i(28,"KeyS"),i(29,"KeyT"),i(30,"KeyU"),i(31,"KeyV"),i(32,"KeyW"),i(33,"KeyX"),i(34,"KeyY"),i(35,"KeyZ"),i(36,"Digit1"),i(37,"Digit2"),i(38,"Digit3"),i(39,"Digit4"),i(40,"Digit5"),i(41,"Digit6"),i(42,"Digit7"),i(43,"Digit8"),i(44,"Digit9"),i(45,"Digit0"),i(46,"Enter"),i(47,"Escape"),i(48,"Backspace"),i(49,"Tab"),i(50,"Space"),i(51,"Minus"),i(52,"Equal"),i(53,"BracketLeft"),i(54,"BracketRight"),i(55,"Backslash"),i(56,"IntlHash"),i(57,"Semicolon"),i(58,"Quote"),i(59,"Backquote"),i(60,"Comma"),i(61,"Period"),i(62,"Slash"),i(63,"CapsLock"),i(64,"F1"),i(65,"F2"),i(66,"F3"),i(67,"F4"),i(68,"F5"),i(69,"F6"),i(70,"F7"),i(71,"F8"),i(72,"F9"),i(73,"F10"),i(74,"F11"),i(75,"F12"),i(76,"PrintScreen"),i(77,"ScrollLock"),i(78,"Pause"),i(79,"Insert"),i(80,"Home"),i(81,"PageUp"),i(82,"Delete"),i(83,"End"),i(84,"PageDown"),i(85,"ArrowRight"),i(86,"ArrowLeft"),i(87,"ArrowDown"),i(88,"ArrowUp"),i(89,"NumLock"),i(90,"NumpadDivide"),i(91,"NumpadMultiply"),i(92,"NumpadSubtract"),i(93,"NumpadAdd"),i(94,"NumpadEnter"),i(95,"Numpad1"),i(96,"Numpad2"),i(97,"Numpad3"),i(98,"Numpad4"),i(99,"Numpad5"),i(100,"Numpad6"),i(101,"Numpad7"),i(102,"Numpad8"),i(103,"Numpad9"),i(104,"Numpad0"),i(105,"NumpadDecimal"),i(106,"IntlBackslash"),i(107,"ContextMenu"),i(108,"Power"),i(109,"NumpadEqual"),i(110,"F13"),i(111,"F14"),i(112,"F15"),i(113,"F16"),i(114,"F17"),i(115,"F18"),i(116,"F19"),i(117,"F20"),i(118,"F21"),i(119,"F22"),i(120,"F23"),i(121,"F24"),i(122,"Open"),i(123,"Help"),i(124,"Select"),i(125,"Again"),i(126,"Undo"),i(127,"Cut"),i(128,"Copy"),i(129,"Paste"),i(130,"Find"),i(131,"AudioVolumeMute"),i(132,"AudioVolumeUp"),i(133,"AudioVolumeDown"),i(134,"NumpadComma"),i(135,"IntlRo"),i(136,"KanaMode"),i(137,"IntlYen"),i(138,"Convert"),i(139,"NonConvert"),i(140,"Lang1"),i(141,"Lang2"),i(142,"Lang3"),i(143,"Lang4"),i(144,"Lang5"),i(145,"Abort"),i(146,"Props"),i(147,"NumpadParenLeft"),i(148,"NumpadParenRight"),i(149,"NumpadBackspace"),i(150,"NumpadMemoryStore"),i(151,"NumpadMemoryRecall"),i(152,"NumpadMemoryClear"),i(153,"NumpadMemoryAdd"),i(154,"NumpadMemorySubtract"),i(155,"NumpadClear"),i(156,"NumpadClearEntry"),i(157,"ControlLeft"),i(158,"ShiftLeft"),i(159,"AltLeft"),i(160,"MetaLeft"),i(161,"ControlRight"),i(162,"ShiftRight"),i(163,"AltRight"),i(164,"MetaRight"),i(165,"BrightnessUp"),i(166,"BrightnessDown"),i(167,"MediaPlay"),i(168,"MediaRecord"),i(169,"MediaFastForward"),i(170,"MediaRewind"),i(171,"MediaTrackNext"),i(172,"MediaTrackPrevious"),i(173,"MediaStop"),i(174,"Eject"),i(175,"MediaPlayPause"),i(176,"MediaSelect"),i(177,"LaunchMail"),i(178,"LaunchApp2"),i(179,"LaunchApp1"),i(180,"SelectTask"),i(181,"LaunchScreenSaver"),i(182,"BrowserSearch"),i(183,"BrowserHome"),i(184,"BrowserBack"),i(185,"BrowserForward"),i(186,"BrowserStop"),i(187,"BrowserRefresh"),i(188,"BrowserFavorites"),i(189,"ZoomToggle"),i(190,"MailReply"),i(191,"MailForward"),i(192,"MailSend")}(),function(){for(let w=0;w<=193;w++)e.IMMUTABLE_CODE_TO_KEY_CODE[w]=-1;for(let w=0;w<=112;w++)e.IMMUTABLE_KEY_CODE_TO_CODE[w]=-1;function i(w,p){e.IMMUTABLE_CODE_TO_KEY_CODE[w]=p,p!==0&&p!==3&&p!==5&&p!==4&&p!==6&&p!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[p]=w)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,i(0,0),i(1,0),i(2,0),i(3,0),i(4,0),i(5,0),i(6,0),i(7,0),i(8,0),i(9,0),i(46,3),i(47,9),i(48,1),i(49,2),i(50,10),i(63,8),i(64,59),i(65,60),i(66,61),i(67,62),i(68,63),i(69,64),i(70,65),i(71,66),i(72,67),i(73,68),i(74,69),i(75,70),i(76,0),i(77,79),i(78,7),i(79,19),i(80,14),i(81,11),i(82,20),i(83,13),i(84,12),i(85,17),i(86,15),i(87,18),i(88,16),i(89,78),i(90,108),i(91,103),i(92,106),i(93,104),i(94,3),i(95,94),i(96,95),i(97,96),i(98,97),i(99,98),i(100,99),i(101,100),i(102,101),i(103,102),i(104,93),i(105,107),i(107,58),i(108,0),i(109,0),i(110,71),i(111,72),i(112,73),i(113,74),i(114,75),i(115,76),i(116,77),i(117,0),i(118,0),i(119,0),i(120,0),i(121,0),i(122,0),i(123,0),i(124,0),i(125,0),i(126,0),i(127,0),i(128,0),i(129,0),i(130,0),i(131,0),i(132,0),i(133,0),i(134,105),i(136,0),i(138,0),i(139,0),i(140,0),i(141,0),i(142,0),i(143,0),i(144,0),i(145,0),i(146,0),i(147,0),i(148,0),i(149,0),i(150,0),i(151,0),i(152,0),i(153,0),i(154,0),i(155,0),i(156,0),i(157,5),i(158,4),i(159,6),i(160,57),i(161,5),i(162,4),i(163,6),i(164,57),i(165,0),i(166,0),i(167,0),i(168,0),i(169,0),i(170,0),i(171,0),i(172,0),i(173,0),i(174,0),i(175,0),i(176,0),i(177,0),i(178,0),i(179,0),i(180,0),i(181,0),i(182,0),i(183,0),i(184,0),i(185,0),i(186,0),i(187,0),i(188,0),i(189,0),i(190,0),i(191,0),i(192,0)}()}),define(J[107],Z([0,1,57,79]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class R{static _readModifiers(M){M=M.toLowerCase().trim();let i=!1,w=!1,p=!1,n=!1,E;do E=!1,/^ctrl(\+|\-)/.test(M)&&(i=!0,M=M.substr("ctrl-".length),E=!0),/^shift(\+|\-)/.test(M)&&(w=!0,M=M.substr("shift-".length),E=!0),/^alt(\+|\-)/.test(M)&&(p=!0,M=M.substr("alt-".length),E=!0),/^meta(\+|\-)/.test(M)&&(n=!0,M=M.substr("meta-".length),E=!0),/^win(\+|\-)/.test(M)&&(n=!0,M=M.substr("win-".length),E=!0),/^cmd(\+|\-)/.test(M)&&(n=!0,M=M.substr("cmd-".length),E=!0);while(E);let P;const b=M.indexOf(" ");return b>0?(P=M.substring(0,b),M=M.substring(b)):(P=M,M=""),{remains:M,ctrl:i,shift:w,alt:p,meta:n,key:P}}static parseSimpleKeybinding(M){const i=this._readModifiers(M),w=v.KeyCodeUtils.fromUserSettings(i.key);return[new v.SimpleKeybinding(i.ctrl,i.shift,i.alt,i.meta,w),i.remains]}static parseKeybinding(M,i){if(!M)return null;const w=[];let p;do[p,M]=this.parseSimpleKeybinding(M),w.push(p);while(M.length>0);return new v.ChordKeybinding(w)}static parseSimpleUserBinding(M){const i=this._readModifiers(M),w=i.key.match(/^\[([^\]]+)\]$/);if(w){const n=w[1],E=A.ScanCodeUtils.lowerCaseToEnum(n);return[new A.ScanCodeBinding(i.ctrl,i.shift,i.alt,i.meta,E),i.remains]}const p=v.KeyCodeUtils.fromUserSettings(i.key);return[new v.SimpleKeybinding(i.ctrl,i.shift,i.alt,i.meta,p),i.remains]}static parseUserBinding(M){if(!M)return[];const i=[];let w;for(;M.length>0;)[w,M]=this.parseSimpleUserBinding(M),i.push(w);return i}}e.KeybindingParser=R}),define(J[108],Z([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=v.globals.performance&&typeof v.globals.performance.now=="function";class R{constructor(M){this._highResolution=A&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new R(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=R}),define(J[5],Z([0,1,18,42,2,78,108]),function(j,e,v,A,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var i;(function(I){I.None=()=>R.Disposable.None;function o(B){return(N,C=null,$)=>{let V=!1,_;return _=B(T=>{if(!V)return _?_.dispose():V=!0,N.call(C,T)},null,$),V&&_.dispose(),_}}I.once=o;function c(B,N){return u((C,$=null,V)=>B(_=>C.call($,N(_)),null,V))}I.map=c;function a(B,N){return u((C,$=null,V)=>B(_=>{N(_),C.call($,_)},null,V))}I.forEach=a;function l(B,N){return u((C,$=null,V)=>B(_=>N(_)&&C.call($,_),null,V))}I.filter=l;function t(B){return B}I.signal=t;function r(...B){return(N,C=null,$)=>(0,R.combinedDisposable)(...B.map(V=>V(_=>N.call(C,_),null,$)))}I.any=r;function s(B,N,C){let $=C;return c(B,V=>($=N($,V),$))}I.reduce=s;function u(B){let N;const C=new P({onFirstListenerAdd(){N=B(C.fire,C)},onLastListenerRemove(){N.dispose()}});return C.event}I.snapshot=u;function h(B,N,C=100,$=!1,V){let _,T,W,k=0;const F=new P({leakWarningThreshold:V,onFirstListenerAdd(){_=B(U=>{k++,T=N(T,U),$&&!W&&(F.fire(T),T=void 0),clearTimeout(W),W=setTimeout(()=>{const K=T;T=void 0,W=void 0,(!$||k>1)&&F.fire(K),k=0},C)})},onLastListenerRemove(){_.dispose()}});return F.event}I.debounce=h;function g(B){const N=new Date().getTime();return c(o(B),C=>new Date().getTime()-N)}I.stopwatch=g;function d(B,N=(C,$)=>C===$){let C=!0,$;return l(B,V=>{const _=C||!N(V,$);return C=!1,$=V,_})}I.latch=d;function y(B,N){return[I.filter(B,N),I.filter(B,C=>!N(C))]}I.split=y;function L(B,N=!1,C=[]){let $=C.slice(),V=B(W=>{$?$.push(W):T.fire(W)});const _=()=>{$&&$.forEach(W=>T.fire(W)),$=null},T=new P({onFirstListenerAdd(){V||(V=B(W=>T.fire(W)))},onFirstListenerDidAdd(){$&&(N?setTimeout(_):_())},onLastListenerRemove(){V&&V.dispose(),V=null}});return T.event}I.buffer=L;class O{constructor(N){this.event=N}map(N){return new O(c(this.event,N))}forEach(N){return new O(a(this.event,N))}filter(N){return new O(l(this.event,N))}reduce(N,C){return new O(s(this.event,N,C))}latch(){return new O(d(this.event))}debounce(N,C=100,$=!1,V){return new O(h(this.event,N,C,$,V))}on(N,C,$){return this.event(N,C,$)}once(N,C,$){return o(this.event)(N,C,$)}}function z(B){return new O(B)}I.chain=z;function X(B,N,C=$=>$){const $=(...W)=>T.fire(C(...W)),V=()=>B.on(N,$),_=()=>B.removeListener(N,$),T=new P({onFirstListenerAdd:V,onLastListenerRemove:_});return T.event}I.fromNodeEventEmitter=X;function x(B,N,C=$=>$){const $=(...W)=>T.fire(C(...W)),V=()=>B.addEventListener(N,$),_=()=>B.removeEventListener(N,$),T=new P({onFirstListenerAdd:V,onLastListenerRemove:_});return T.event}I.fromDOMEventEmitter=x;function H(B){const N=new P;let C=!1;return B.then(void 0,()=>null).then(()=>{C?N.fire(void 0):setTimeout(()=>N.fire(void 0),0)}),C=!0,N.event}I.fromPromise=H;function Q(B){return new Promise(N=>o(B)(N))}I.toPromise=Q})(i=e.Event||(e.Event={}));class w{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${w._idPool++}`}start(o){this._stopWatch=new M.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let p=-1;function n(I){const o=p;return p=I,{dispose(){p=o}}}e.setGlobalLeakWarningThreshold=n;class E{constructor(o,c=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let c=p;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),!(c<=0||o<c)){this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),l=this._stacks.get(a)||0;if(this._stacks.set(a,l+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,r=0;for(const[s,u]of this._stacks)(!t||r<u)&&(t=s,r=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}}class P{constructor(o){var c;this._disposed=!1,this._options=o,this._leakageMon=p>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(o,c,a)=>{var l;this._listeners||(this._listeners=new S.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(c?[o,c]:o);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,c);const s=(l=this._leakageMon)===null||l===void 0?void 0:l.check(this._listeners.size);let u;return u={dispose:()=>{s&&s(),u.dispose=P._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},a instanceof R.DisposableStore?a.add(u):Array.isArray(a)&&a.push(u),u}),this._event}fire(o){var c,a;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let l of this._listeners)this._deliveryQueue.push([l,o]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[l,t]=this._deliveryQueue.shift();try{typeof l=="function"?l.call(void 0,t):l[0].call(l[1],t)}catch(r){(0,v.onUnexpectedError)(r)}}(a=this._perfMon)===null||a===void 0||a.stop()}}dispose(){var o,c,a,l;(o=this._listeners)===null||o===void 0||o.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),((a=this._options)===null||a===void 0?void 0:a.onLastListenerRemove)&&this._options.onLastListenerRemove(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=P,P._noop=function(){};class b extends P{constructor(o){super(o);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=o==null?void 0:o.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=b;class f{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new P({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const c={event:o,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const a=()=>{this.hasListeners&&this.unhook(c);const l=this.events.indexOf(c);this.events.splice(l,1)};return(0,R.toDisposable)((0,A.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(c=>this.emitter.fire(c))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=f;class m{constructor(){this.buffers=[]}wrapEvent(o){return(c,a,l)=>o(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>c.call(a,t)):c.call(a,t)},void 0,l)}bufferEvents(o){const c=[];this.buffers.push(c);const a=o();return this.buffers.pop(),c.forEach(l=>l()),a}}e.EventBufferer=m;class D{constructor(){this.listening=!1,this.inputEvent=i.None,this.inputEventListener=R.Disposable.None,this.emitter=new P({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(J[26],Z([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(i,w){const p=setTimeout(i.bind(w),0);return{dispose(){clearTimeout(p)}}});var R;(function(i){function w(p){return p===i.None||p===i.Cancelled||p instanceof S?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}i.isCancellationToken=w,i.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),i.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(R=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=R.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=M}),define(J[109],Z([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class A{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(E){const P=this._icons.get(E.id);P?E.description?P.description=E.description:console.error(`Duplicate registration of codicon ${E.id}`):(this._icons.set(E.id,E),this._onDidRegister.fire(E))}get(E){return this._icons.get(E)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new A;e.iconRegistry=R;function S(n,E){return new i(n,E)}e.registerCodicon=S;function M(n){return n?n.replace(/\$\((.*?)\)/g,(E,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=M;class i{constructor(E,P,b){this.id=E,this.definition=P,this.description=b,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i;function w(n,E){const P=["codicon","codicon-"+n];return E&&P.push("codicon-modifier-"+E),P}e.getClassNamesArray=w;var p;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const E=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function P(m){if(m instanceof i)return["codicon","codicon-"+m.id];const D=E.exec(m.id);if(!D)return P(i.error);let[,I,o]=D;const c=["codicon","codicon-"+I];return o&&c.push("codicon-modifier-"+o.substr(1)),c}n.asClassNameArray=P;function b(m){return P(m).join(" ")}n.asClassName=b;function f(m){return"."+P(m).join(".")}n.asCSSSelector=f})(p=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(i=e.Codicon||(e.Codicon={}))}),define(J[64],Z([0,1,18,2]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(c){const a=c;return a?[a.on,a.pause,a.resume,a.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=R;function S(c){const a=c;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=S;function M(c,a){return new i(c,a)}e.newWriteableStream=M;class i{constructor(a,l){this.reducer=a,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){var l;if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof((l=this.options)===null||l===void 0?void 0:l.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(l=>l(a))}emitError(a){this.listeners.error.length===0?(0,v.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(l=>l(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,l){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(a,l){if(!this.state.destroyed){let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(l);r>=0&&t.splice(r,1)}}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(c,a){const l=[];let t;for(;(t=c.read())!==null;)l.push(t);return a(l)}e.consumeReadable=w;function p(c,a,l){const t=[];let r;for(;(r=c.read())!==null&&t.length<l;)t.push(r);return r===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return c.read()}}}e.peekReadable=p;function n(c,a){return new Promise((l,t)=>{const r=[];E(c,{onData:s=>{a&&r.push(s)},onError:s=>{a?t(s):l(void 0)},onEnd:()=>{l(a?a(r):void 0)}})})}e.consumeStream=n;function E(c,a){c.on("error",l=>a.onError(l)),c.on("end",()=>a.onEnd()),c.on("data",l=>a.onData(l))}e.listenStream=E;function P(c,a){return new Promise((l,t)=>{const r=new A.DisposableStore,s=[],u=d=>{if(s.push(d),s.length>a)return r.dispose(),c.pause(),l({stream:c,buffer:s,ended:!1})},h=d=>t(d),g=()=>l({stream:c,buffer:s,ended:!0});r.add((0,A.toDisposable)(()=>c.removeListener("error",h))),c.on("error",h),r.add((0,A.toDisposable)(()=>c.removeListener("end",g))),c.on("end",g),r.add((0,A.toDisposable)(()=>c.removeListener("data",u))),c.on("data",u)})}e.peekStream=P;function b(c,a){const l=M(a);return l.end(c),l}e.toStream=b;function f(){const c=M(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=f;function m(c){let a=!1;return{read:()=>a?null:(a=!0,c)}}e.toReadable=m;function D(c,a,l){const t=M(l);return E(c,{onData:r=>t.write(a.data(r)),onError:r=>t.error(a.error?a.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function I(c,a,l){let t=!1;return{read:()=>{const r=a.read();return t?r:(t=!0,r!==null?l([c,r]):c)}}}e.prefixedReadable=I;function o(c,a,l){let t=!1;const r=M(l);return E(a,{onData:s=>t?r.write(s):(t=!0,r.write(l([c,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(c)),r.end()}}),r}e.prefixedStream=o}),define(J[24],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=v;const A=/{(\d+)}/g;function R(q,...ie){return ie.length===0?q:q.replace(A,function(ae,ce){const de=parseInt(ce,10);return isNaN(de)||de<0||de>=ie.length?ae:ie[de]})}e.format=R;function S(q){return q.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=S;function M(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=M;function i(q,ie){let ae=0;const ce=ie.charCodeAt(0);for(let de=q.length-1;de>=0;de--)q.charCodeAt(de)===ce&&ae++;return ae}e.count=i;function w(q,ie,ae="\u2026"){return q.length<=ie?q:`${q.substr(0,ie)}${ae}`}e.truncate=w;function p(q,ie=" "){const ae=n(q,ie);return E(ae,ie)}e.trim=p;function n(q,ie){if(!q||!ie)return q;const ae=ie.length;if(ae===0||q.length===0)return q;let ce=0;for(;q.indexOf(ie,ce)===ce;)ce=ce+ae;return q.substring(ce)}e.ltrim=n;function E(q,ie){if(!q||!ie)return q;const ae=ie.length,ce=q.length;if(ae===0||ce===0)return q;let de=ce,be=-1;for(;be=q.lastIndexOf(ie,de-1),!(be===-1||be+ae!==de);){if(be===0)return"";de=be}return q.substring(0,de)}e.rtrim=E;function P(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=P;function b(q){return q.replace(/\*/g,"")}e.stripWildcards=b;function f(q,ie,ae={}){if(!q)throw new Error("Cannot create regex from empty string");ie||(q=M(q)),ae.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(q,ce)}e.createRegExp=f;function m(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function D(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function I(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=I;function o(q){return q.split(/\r\n|\r|\n/)}e.splitLines=o;function c(q){for(let ie=0,ae=q.length;ie<ae;ie++){const ce=q.charCodeAt(ie);if(ce!==32&&ce!==9)return ie}return-1}e.firstNonWhitespaceIndex=c;function a(q,ie=0,ae=q.length){for(let ce=ie;ce<ae;ce++){const de=q.charCodeAt(ce);if(de!==32&&de!==9)return q.substring(ie,ce)}return q.substring(ie,ae)}e.getLeadingWhitespace=a;function l(q,ie=q.length-1){for(let ae=ie;ae>=0;ae--){const ce=q.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=l;function t(q,ie){return q<ie?-1:q>ie?1:0}e.compare=t;function r(q,ie,ae=0,ce=q.length,de=0,be=ie.length){for(;ae<ce&&de<be;ae++,de++){let We=q.charCodeAt(ae),Be=ie.charCodeAt(de);if(We<Be)return-1;if(We>Be)return 1}const Me=ce-ae,Te=be-de;return Me<Te?-1:Me>Te?1:0}e.compareSubstring=r;function s(q,ie){return u(q,ie,0,q.length,0,ie.length)}e.compareIgnoreCase=s;function u(q,ie,ae=0,ce=q.length,de=0,be=ie.length){for(;ae<ce&&de<be;ae++,de++){let We=q.charCodeAt(ae),Be=ie.charCodeAt(de);if(We!==Be){const he=We-Be;if(!(he===32&&g(Be))&&!(he===-32&&g(We)))return h(We)&&h(Be)?he:r(q.toLowerCase(),ie.toLowerCase(),ae,ce,de,be)}}const Me=ce-ae,Te=be-de;return Me<Te?-1:Me>Te?1:0}e.compareSubstringIgnoreCase=u;function h(q){return q>=97&&q<=122}e.isLowerAsciiLetter=h;function g(q){return q>=65&&q<=90}e.isUpperAsciiLetter=g;function d(q){return h(q)||g(q)}function y(q,ie){return q.length===ie.length&&L(q,ie)}e.equalsIgnoreCase=y;function L(q,ie,ae=q.length){for(let ce=0;ce<ae;ce++){const de=q.charCodeAt(ce),be=ie.charCodeAt(ce);if(de!==be){if(d(de)&&d(be)){const Me=Math.abs(de-be);if(Me!==0&&Me!==32)return!1}else if(String.fromCharCode(de).toLowerCase()!==String.fromCharCode(be).toLowerCase())return!1}}return!0}function O(q,ie){const ae=ie.length;return ie.length>q.length?!1:L(q,ie,ae)}e.startsWithIgnoreCase=O;function z(q,ie){let ae,ce=Math.min(q.length,ie.length);for(ae=0;ae<ce;ae++)if(q.charCodeAt(ae)!==ie.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=z;function X(q,ie){let ae,ce=Math.min(q.length,ie.length);const de=q.length-1,be=ie.length-1;for(ae=0;ae<ce;ae++)if(q.charCodeAt(de-ae)!==ie.charCodeAt(be-ae))return ae;return ce}e.commonSuffixLength=X;function x(q){return 55296<=q&&q<=56319}e.isHighSurrogate=x;function H(q){return 56320<=q&&q<=57343}e.isLowSurrogate=H;function Q(q,ie){return(q-55296<<10)+(ie-56320)+65536}e.computeCodePoint=Q;function B(q,ie,ae){const ce=q.charCodeAt(ae);if(x(ce)&&ae+1<ie){const de=q.charCodeAt(ae+1);if(H(de))return Q(ce,de)}return ce}e.getNextCodePoint=B;function N(q,ie){const ae=q.charCodeAt(ie-1);if(H(ae)&&ie>1){const ce=q.charCodeAt(ie-2);if(x(ce))return Q(ce,ae)}return ae}function C(q,ie){const ae=ze.getInstance(),ce=ie,de=q.length,be=B(q,de,ie);ie+=be>=65536?2:1;let Me=ae.getGraphemeBreakType(be);for(;ie<de;){const Te=B(q,de,ie),We=ae.getGraphemeBreakType(Te);if(Ve(Me,We))break;ie+=Te>=65536?2:1,Me=We}return ie-ce}e.nextCharLength=C;function $(q,ie){const ae=ze.getInstance(),ce=ie,de=N(q,ie);ie-=de>=65536?2:1;let be=ae.getGraphemeBreakType(de);for(;ie>0;){const Me=N(q,ie),Te=ae.getGraphemeBreakType(Me);if(Ve(Te,be))break;ie-=Me>=65536?2:1,be=Te}return ce-ie}e.prevCharLength=$;function V(q,ie){const ae=ze.getInstance(),ce=q.length,de=ie,be=B(q,ce,ie),Me=ae.getGraphemeBreakType(be);ie+=be>=65536?2:1;let Te=Me;for(;ie<ce;){const Be=B(q,ce,ie),he=ae.getGraphemeBreakType(Be);if(Ve(Te,he))break;ie+=Be>=65536?2:1,Te=he}const We=ie;for(ie=de,Te=Me;ie>0;){const Be=N(q,ie),he=ae.getGraphemeBreakType(Be);if(Ve(he,Te))break;ie-=Be>=65536?2:1,Te=he}return[ie,We]}function _(q,ie){return ie>0&&H(q.charCodeAt(ie))?V(q,ie-1):V(q,ie)}e.getCharContainingOffset=_;function T(q){const ie=q.length;let ae=0,ce=0;for(;ce<ie;){const Me=B(q,ie,ce);ce+=Me>=65536?2:1,Me<128?ae+=1:Me<2048?ae+=2:Me<65536?ae+=3:ae+=4}const de=new Uint8Array(ae);ce=0;let be=0;for(;ce<ie;){const Me=B(q,ie,ce);ce+=Me>=65536?2:1,Me<128?de[be++]=Me:Me<2048?(de[be++]=192|(Me&1984)>>>6,de[be++]=128|(Me&63)>>>0):Me<65536?(de[be++]=224|(Me&61440)>>>12,de[be++]=128|(Me&4032)>>>6,de[be++]=128|(Me&63)>>>0):(de[be++]=240|(Me&1835008)>>>18,de[be++]=128|(Me&258048)>>>12,de[be++]=128|(Me&4032)>>>6,de[be++]=128|(Me&63)>>>0)}return de}e.encodeUTF8=T;function W(q){const ie=q.byteLength,ae=[];let ce=0;for(;ce<ie;){const de=q[ce];let be;if(de>=240&&ce+3<ie?be=(q[ce++]&7)<<18>>>0|(q[ce++]&63)<<12>>>0|(q[ce++]&63)<<6>>>0|(q[ce++]&63)<<0>>>0:de>=224&&ce+2<ie?be=(q[ce++]&15)<<12>>>0|(q[ce++]&63)<<6>>>0|(q[ce++]&63)<<0>>>0:de>=192&&ce+1<ie?be=(q[ce++]&31)<<6>>>0|(q[ce++]&63)<<0>>>0:be=q[ce++],be>=0&&be<=55295||be>=57344&&be<=65535)ae.push(String.fromCharCode(be));else if(be>=65536&&be<=1114111){const Me=be-65536,Te=55296+((Me&1047552)>>>10),We=56320+((Me&1023)>>>0);ae.push(String.fromCharCode(Te)),ae.push(String.fromCharCode(We))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=W;const k=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(q){return k.test(q)}e.containsRTL=F;const U=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function K(q){return U.test(q)}e.containsEmoji=K;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(q){return G.test(q)}e.isBasicASCII=Y,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ee(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=ee;function re(q){for(let ie=0,ae=q.length;ie<ae;ie++)if(se(q.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=re;function se(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=se;function oe(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=oe;function ne(q,ie){if(q.length<ie)return q;const ae=/\b/g;let ce=0;for(;ae.test(q)&&!(q.length-ae.lastIndex<ie);)ce=ae.lastIndex,ae.lastIndex+=1;return q.substring(ce).replace(/^\s/,"")}e.lcut=ne;const le=/\x1B\x5B[12]?K/g,ve=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function Se(q){return q&&(q=q.replace(le,""),q=q.replace(ve,""),q=q.replace(we,"")),q}e.removeAnsiEscapeCodes=Se,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function ye(q){return Ae(q)?q.substr(1):q}e.stripUTF8BOM=ye;function me(q,ie){if(!q||!ie||q.length<ie.length)return!1;const ae=ie.length,ce=q.toLowerCase();let de=0,be=-1;for(;de<ae;){const Me=ce.indexOf(ie[de],be+1);if(Me<0)return!1;be=Me,de++}return!0}e.fuzzyContains=me;function Ie(q,ie=!1){return q?(ie&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=Ie;function Re(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=Re;function Fe(q,ie=1){if(ie===0)return"";let ae=-1;do ae=q.indexOf(`
`,ae+1),ie--;while(ie>0&&ae>=0);return ae===-1?q:(q[ae-1]==="\r"&&ae--,q.substr(0,ae))}e.getNLines=Fe;function Ne(q){const ie=90-65+1;return q=q%(2*ie),q<ie?String.fromCharCode(97+q):String.fromCharCode(65+q-ie)}e.singleLetterHash=Ne;function qe(q){return ze.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=qe;function Ve(q,ie){return q===0?ie!==5&&ie!==7:q===2&&ie===3?!1:q===4||q===2||q===3||ie===4||ie===2||ie===3?!0:!(q===8&&(ie===8||ie===9||ie===11||ie===12)||(q===11||q===9)&&(ie===9||ie===10)||(q===12||q===10)&&ie===10||ie===5||ie===13||ie===7||q===1||q===13&&ie===14||q===6&&ie===6)}e.breakBetweenGraphemeBreakType=Ve;var tt;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(tt=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=at()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ae=this._data,ce=ae.length/3;let de=1;for(;de<=ce;)if(ie<ae[3*de])de=2*de;else if(ie>ae[3*de+1])de=2*de+1;else return ae[3*de+2];return 0}}ze._INSTANCE=null;function at(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function it(q,ie){if(q===0)return 0;const ae=dt(q,ie);if(ae!==void 0)return ae;const ce=N(ie,q);return q-=Ge(ce),q}e.getLeftDeleteOffset=it;function dt(q,ie){let ae=N(ie,q);for(q-=Ge(ae);ft(ae)||ae===65039||ae===8419;){if(q===0)return;ae=N(ie,q),q-=Ge(ae)}if(!!oe(ae)){if(q>=0){const ce=N(ie,q);ce===8205&&(q-=Ge(ce))}return q}}function Ge(q){return q>=65536?2:1}function ft(q){return 127995<=q&&q<=127999}var lt;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(lt||(lt={}))}),define(J[19],Z([0,1,24,64]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",M=typeof TextDecoder!="undefined";let i,w;class p{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return R?new p(Buffer.allocUnsafe(d)):new p(new Uint8Array(d))}static wrap(d){return R&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new p(d)}static fromString(d,y){return!((y==null?void 0:y.dontUseNodeBuffer)||!1)&&R?new p(Buffer.from(d)):S?(i||(i=new TextEncoder),new p(i.encode(d))):new p(v.encodeUTF8(d))}static concat(d,y){if(typeof y=="undefined"){y=0;for(let z=0,X=d.length;z<X;z++)y+=d[z].byteLength}const L=p.alloc(y);let O=0;for(let z=0,X=d.length;z<X;z++){const x=d[z];L.set(x,O),O+=x.byteLength}return L}toString(){return R?this.buffer.toString():M?(w||(w=new TextDecoder),w.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(d,y){return new p(this.buffer.subarray(d,y))}set(d,y){d instanceof p?this.buffer.set(d.buffer,y):this.buffer.set(d,y)}readUInt32BE(d){return P(this.buffer,d)}writeUInt32BE(d,y){b(this.buffer,d,y)}readUInt32LE(d){return f(this.buffer,d)}writeUInt32LE(d,y){m(this.buffer,d,y)}readUInt8(d){return D(this.buffer,d)}writeUInt8(d,y){I(this.buffer,d,y)}}e.VSBuffer=p;function n(g,d){return g[d+0]<<0>>>0|g[d+1]<<8>>>0}e.readUInt16LE=n;function E(g,d,y){g[y+0]=d&255,d=d>>>8,g[y+1]=d&255}e.writeUInt16LE=E;function P(g,d){return g[d]*2**24+g[d+1]*2**16+g[d+2]*2**8+g[d+3]}e.readUInt32BE=P;function b(g,d,y){g[y+3]=d,d=d>>>8,g[y+2]=d,d=d>>>8,g[y+1]=d,d=d>>>8,g[y]=d}e.writeUInt32BE=b;function f(g,d){return g[d+0]<<0>>>0|g[d+1]<<8>>>0|g[d+2]<<16>>>0|g[d+3]<<24>>>0}e.readUInt32LE=f;function m(g,d,y){g[y+0]=d&255,d=d>>>8,g[y+1]=d&255,d=d>>>8,g[y+2]=d&255,d=d>>>8,g[y+3]=d&255}e.writeUInt32LE=m;function D(g,d){return g[d]}e.readUInt8=D;function I(g,d,y){g[y]=d}e.writeUInt8=I;function o(g){return A.consumeReadable(g,d=>p.concat(d))}e.readableToBuffer=o;function c(g){return A.toReadable(g)}e.bufferToReadable=c;function a(g){return A.consumeStream(g,d=>p.concat(d))}e.streamToBuffer=a;async function l(g){return g.ended?p.concat(g.buffer):p.concat([...g.buffer,await a(g.stream)])}e.bufferedStreamToBuffer=l;function t(g){return A.toStream(g,d=>p.concat(d))}e.bufferToStream=t;function r(g){return A.transform(g,{data:d=>typeof d=="string"?p.fromString(d):p.wrap(d)},d=>p.concat(d))}e.streamToBufferReadableStream=r;function s(g){return A.newWriteableStream(d=>p.concat(d),g)}e.newWriteableBufferStream=s;function u(g,d){return A.prefixedReadable(g,d,y=>p.concat(y))}e.prefixedBufferReadable=u;function h(g,d){return A.prefixedStream(g,d,y=>p.concat(y))}e.prefixedBufferStream=h}),define(J[80],Z([0,1,24]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function A(I){return R(I,0)}e.hash=A;function R(I,o){switch(typeof I){case"object":return I===null?S(349,o):Array.isArray(I)?w(I,o):p(I,o);case"string":return i(I,o);case"boolean":return M(I,o);case"number":return S(I,o);case"undefined":return S(937,o);default:return S(617,o)}}e.doHash=R;function S(I,o){return(o<<5)-o+I|0}function M(I,o){return S(I?433:863,o)}function i(I,o){o=S(149417,o);for(let c=0,a=I.length;c<a;c++)o=S(I.charCodeAt(c),o);return o}e.stringHash=i;function w(I,o){return o=S(104579,o),I.reduce((c,a)=>R(a,c),o)}function p(I,o){return o=S(181387,o),Object.keys(I).sort().reduce((c,a)=>(c=i(a,c),R(I[a],c)),o)}class n{constructor(){this._value=0}get value(){return this._value}hash(o){return this._value=R(o,this._value),this._value}}e.Hasher=n;var E;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function P(I,o,c=32){const a=c-o,l=~((1<<a)-1);return(I<<o|(l&I)>>>a)>>>0}function b(I,o=0,c=I.byteLength,a=0){for(let l=0;l<c;l++)I[o+l]=a}function f(I,o,c="0"){for(;I.length<o;)I=c+I;return I}function m(I,o=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(c=>c.toString(16).padStart(2,"0")).join(""):f((I>>>0).toString(16),o/4)}e.toHexString=m;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(o){const c=o.length;if(c!==0){const a=this._buff;let l=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=o.charCodeAt(0),s=0);;){let u=r;if(v.isHighSurrogate(r))if(s+1<c){const h=o.charCodeAt(s+1);v.isLowSurrogate(h)?(s++,u=v.computeCodePoint(r,h)):u=65533}else{t=r;break}else v.isLowSurrogate(r)&&(u=65533);if(l=this._push(a,l,u),s++,s<c)r=o.charCodeAt(s);else break}this._buffLen=l,this._leftoverHighSurrogate=t}}_push(o,c,a){return a<128?o[c++]=a:a<2048?(o[c++]=192|(a&1984)>>>6,o[c++]=128|(a&63)>>>0):a<65536?(o[c++]=224|(a&61440)>>>12,o[c++]=128|(a&4032)>>>6,o[c++]=128|(a&63)>>>0):(o[c++]=240|(a&1835008)>>>18,o[c++]=128|(a&258048)>>>12,o[c++]=128|(a&4032)>>>6,o[c++]=128|(a&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const o=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(o/4294967296),!1),this._buffDV.setUint32(60,o%4294967296,!1),this._step()}_step(){const o=D._bigBlock32,c=this._buffDV;for(let d=0;d<64;d+=4)o.setUint32(d,c.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)o.setUint32(d,P(o.getUint32(d-12,!1)^o.getUint32(d-32,!1)^o.getUint32(d-56,!1)^o.getUint32(d-64,!1),1),!1);let a=this._h0,l=this._h1,t=this._h2,r=this._h3,s=this._h4,u,h,g;for(let d=0;d<80;d++)d<20?(u=l&t|~l&r,h=1518500249):d<40?(u=l^t^r,h=1859775393):d<60?(u=l&t|l&r|t&r,h=2400959708):(u=l^t^r,h=3395469782),g=P(a,5)+u+s+h+o.getUint32(d*4,!1)&4294967295,s=r,r=t,t=P(l,30),l=a,a=g;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(d){return Array.isArray(d)}e.isArray=v;function A(d){return typeof d=="string"}e.isString=A;function R(d){return Array.isArray(d)&&d.every(y=>A(y))}e.isStringArray=R;function S(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=S;function M(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=M;function i(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=i;function w(d){return d===!0||d===!1}e.isBoolean=w;function p(d){return typeof d=="undefined"}e.isUndefined=p;function n(d){return!E(d)}e.isDefined=n;function E(d){return p(d)||d===null}e.isUndefinedOrNull=E;function P(d,y){if(!d)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}e.assertType=P;function b(d){if(E(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=b;function f(...d){const y=[];for(let L=0;L<d.length;L++){const O=d[L];if(E(O))throw new Error(`Assertion Failed: argument at index ${L} is undefined or null`);y.push(O)}return y}e.assertAllDefined=f;const m=Object.prototype.hasOwnProperty;function D(d){if(!S(d))return!1;for(let y in d)if(m.call(d,y))return!1;return!0}e.isEmptyObject=D;function I(d){return typeof d=="function"}e.isFunction=I;function o(...d){return d.length>0&&d.every(I)}e.areFunctions=o;function c(d,y){const L=Math.min(d.length,y.length);for(let O=0;O<L;O++)a(d[O],y[O])}e.validateConstraints=c;function a(d,y){if(A(y)){if(typeof d!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(I(y)){try{if(d instanceof y)return}catch(L){}if(!E(d)&&d.constructor===y||y.length===1&&y.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function l(d){let y=[],L=Object.getPrototypeOf(d);for(;Object.prototype!==L;)y=y.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return y}e.getAllPropertyNames=l;function t(d){const y=[];for(const L of l(d))typeof d[L]=="function"&&y.push(L);return y}e.getAllMethodNames=t;function r(d,y){const L=z=>function(){const X=Array.prototype.slice.call(arguments,0);return y(z,X)};let O={};for(const z of d)O[z]=L(z);return O}e.createProxyObject=r;function s(d){return d===null?void 0:d}e.withNullAsUndefined=s;function u(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=u;function h(d){return class{constructor(){return new Proxy({},{get(y,L){if(y[L])return y[L];throw new Error(`Not Implemented: ${d}->${String(L)}`)}})}}}e.NotImplementedProxy=h;function g(d){throw new Error("Unreachable")}e.assertNever=g}),define(J[30],Z([0,1,3,24,8,13]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(s){return s===47||s===92}e.isPathSeparator=M;function i(s){return s.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=i;function w(s){return s.indexOf("/")===-1&&(s=i(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=w;function p(s,u=R.posix.sep){if(!s)return"";const h=s.length,g=s.charCodeAt(0);if(M(g)){if(M(s.charCodeAt(1))&&!M(s.charCodeAt(2))){let y=3;const L=y;for(;y<h&&!M(s.charCodeAt(y));y++);if(L!==y&&!M(s.charCodeAt(y+1))){for(y+=1;y<h;y++)if(M(s.charCodeAt(y)))return s.slice(0,y+1).replace(/[\\/]/g,u)}}return u}else if(I(g)&&s.charCodeAt(1)===58)return M(s.charCodeAt(2))?s.slice(0,2)+u:s.slice(0,2);let d=s.indexOf("://");if(d!==-1){for(d+=3;d<h;d++)if(M(s.charCodeAt(d)))return s.slice(0,d+1)}return""}e.getRoot=p;function n(s){if(!v.isWindows||!s||s.length<5)return!1;let u=s.charCodeAt(0);if(u!==92||(u=s.charCodeAt(1),u!==92))return!1;let h=2;const g=h;for(;h<s.length&&(u=s.charCodeAt(h),u!==92);h++);return!(g===h||(u=s.charCodeAt(h+1),isNaN(u)||u===92))}e.isUNC=n;const E=/[\\/:\*\?"<>\|]/g,P=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,u=v.isWindows){const h=u?E:P;return!(!s||s.length===0||/^\s+$/.test(s)||(h.lastIndex=0,h.test(s))||u&&b.test(s)||s==="."||s===".."||u&&s[s.length-1]==="."||u&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function m(s,u,h){const g=s===u;return!h||g?g:!s||!u?!1:(0,A.equalsIgnoreCase)(s,u)}e.isEqual=m;function D(s,u,h,g=R.sep){if(s===u)return!0;if(!s||!u||u.length>s.length)return!1;if(h){if(!(0,A.startsWithIgnoreCase)(s,u))return!1;if(u.length===s.length)return!0;let y=u.length;return u.charAt(u.length-1)===g&&y--,s.charAt(y)===g}return u.charAt(u.length-1)!==g&&(u+=g),s.indexOf(u)===0}e.isEqualOrParent=D;function I(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=I;function o(s,u){return v.isWindows&&s.endsWith(":")&&(s+=R.sep),(0,R.isAbsolute)(s)||(s=(0,R.join)(u,s)),s=(0,R.normalize)(s),v.isWindows?(s=(0,A.rtrim)(s,R.sep),s.endsWith(":")&&(s+=R.sep)):(s=(0,A.rtrim)(s,R.sep),s||(s=R.sep)),s}e.sanitizeFilePath=o;function c(s){const u=(0,R.normalize)(s);return v.isWindows?s.length>3?!1:a(u)&&(s.length===2||u.charCodeAt(2)===92):u===R.posix.sep}e.isRootOrDriveLetter=c;function a(s){return v.isWindows?I(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function l(s){return a(s)?s[0]:void 0}e.getDriveLetter=l;function t(s,u,h){return u.length>s.length?-1:s===u?0:(h&&(s=s.toLowerCase(),u=u.toLowerCase()),s.indexOf(u))}e.indexOfPath=t;function r(s){const u=s.split(":");let h,g,d;if(u.forEach(y=>{const L=Number(y);(0,S.isNumber)(L)?g===void 0?g=L:d===void 0&&(d=L):h=h?[h,y].join(":"):y}),!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:g!==void 0?g:void 0,column:d!==void 0?d:g!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(J[44],Z([0,1,13]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const D=Array.isArray(m)?[]:{};return Object.keys(m).forEach(I=>{m[I]&&typeof m[I]=="object"?D[I]=A(m[I]):D[I]=m[I]}),D}e.deepClone=A;function R(m){if(!m||typeof m!="object")return m;const D=[m];for(;D.length>0;){const I=D.shift();Object.freeze(I);for(const o in I)if(S.call(I,o)){const c=I[o];typeof c=="object"&&!Object.isFrozen(c)&&D.push(c)}}return m}e.deepFreeze=R;const S=Object.prototype.hasOwnProperty;function M(m,D){return i(m,D,new Set)}e.cloneAndChange=M;function i(m,D,I){if((0,v.isUndefinedOrNull)(m))return m;const o=D(m);if(typeof o!="undefined")return o;if((0,v.isArray)(m)){const c=[];for(const a of m)c.push(i(a,D,I));return c}if((0,v.isObject)(m)){if(I.has(m))throw new Error("Cannot clone recursive data-structure");I.add(m);const c={};for(let a in m)S.call(m,a)&&(c[a]=i(m[a],D,I));return I.delete(m),c}return m}function w(m,D,I=!0){return(0,v.isObject)(m)?((0,v.isObject)(D)&&Object.keys(D).forEach(o=>{o in m?I&&((0,v.isObject)(m[o])&&(0,v.isObject)(D[o])?w(m[o],D[o],I):m[o]=D[o]):m[o]=D[o]}),m):D}e.mixin=w;function p(m,D){if(m===D)return!0;if(m==null||D===null||D===void 0||typeof m!=typeof D||typeof m!="object"||Array.isArray(m)!==Array.isArray(D))return!1;let I,o;if(Array.isArray(m)){if(m.length!==D.length)return!1;for(I=0;I<m.length;I++)if(!p(m[I],D[I]))return!1}else{const c=[];for(o in m)c.push(o);c.sort();const a=[];for(o in D)a.push(o);if(a.sort(),!p(c,a))return!1;for(I=0;I<c.length;I++)if(!p(m[c[I]],D[c[I]]))return!1}return!0}e.equals=p;function n(m){const D=new Set;return JSON.stringify(m,(I,o)=>{if((0,v.isObject)(o)||Array.isArray(o)){if(D.has(o))return"[Circular]";D.add(o)}return o})}e.safeStringify=n;function E(m,D,I){const o=D(m);return typeof o=="undefined"?I:o}e.getOrDefault=E;function P(m,D){const I=Object.create(null);return!m||!D||Object.keys(D).forEach(c=>{const a=m[c],l=D[c];p(a,l)||(I[c]=l)}),I}e.distinct=P;function b(m,D){const I=D.toLowerCase(),o=Object.keys(m).find(c=>c.toLowerCase()===I);return o?m[o]:m[D]}e.getCaseInsensitive=b;function f(m,D){const I=Object.create(null);for(const o of Object.keys(m))D(o,m[o])&&(I[o]=m[o]);return I}e.filter=f}),define(J[7],Z([0,1,3,8]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,S=/^\//,M=/^\/\//;function i(s,u){if(!s.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!R.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!S.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(s,u){return!s&&!u?"file":s}function p(s,u){switch(s){case"https":case"http":case"file":u?u[0]!==E&&(u=E+u):u=E;break}return u}const n="",E="/",P=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(u,h,g,d,y,L=!1){typeof u=="object"?(this.scheme=u.scheme||n,this.authority=u.authority||n,this.path=u.path||n,this.query=u.query||n,this.fragment=u.fragment||n):(this.scheme=w(u,L),this.authority=h||n,this.path=p(this.scheme,g||n),this.query=d||n,this.fragment=y||n,i(this,L))}static isUri(u){return u instanceof b?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}get fsPath(){return c(this,!1)}with(u){if(!u)return this;let{scheme:h,authority:g,path:d,query:y,fragment:L}=u;return h===void 0?h=this.scheme:h===null&&(h=n),g===void 0?g=this.authority:g===null&&(g=n),d===void 0?d=this.path:d===null&&(d=n),y===void 0?y=this.query:y===null&&(y=n),L===void 0?L=this.fragment:L===null&&(L=n),h===this.scheme&&g===this.authority&&d===this.path&&y===this.query&&L===this.fragment?this:new m(h,g,d,y,L)}static parse(u,h=!1){const g=P.exec(u);return g?new m(g[2]||n,r(g[4]||n),r(g[5]||n),r(g[7]||n),r(g[9]||n),h):new m(n,n,n,n,n)}static file(u){let h=n;if(v.isWindows&&(u=u.replace(/\\/g,E)),u[0]===E&&u[1]===E){const g=u.indexOf(E,2);g===-1?(h=u.substring(2),u=E):(h=u.substring(2,g),u=u.substring(g)||E)}return new m("file",h,u,n,n)}static from(u){const h=new m(u.scheme,u.authority,u.path,u.query,u.fragment);return i(h,!0),h}static joinPath(u,...h){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return v.isWindows&&u.scheme==="file"?g=b.file(A.win32.join(c(u,!0),...h)).path:g=A.posix.join(u.path,...h),u.with({path:g})}toString(u=!1){return a(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof b)return u;{const h=new m(u);return h._formatted=u.external,h._fsPath=u._sep===f?u.fsPath:null,h}}else return u}}e.URI=b;const f=v.isWindows?1:void 0;class m extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(u=!1){return u?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=f),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(s,u){let h,g=-1;for(let d=0;d<s.length;d++){const y=s.charCodeAt(d);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||u&&y===47)g!==-1&&(h+=encodeURIComponent(s.substring(g,d)),g=-1),h!==void 0&&(h+=s.charAt(d));else{h===void 0&&(h=s.substr(0,d));const L=D[y];L!==void 0?(g!==-1&&(h+=encodeURIComponent(s.substring(g,d)),g=-1),h+=L):g===-1&&(g=d)}}return g!==-1&&(h+=encodeURIComponent(s.substring(g))),h!==void 0?h:s}function o(s){let u;for(let h=0;h<s.length;h++){const g=s.charCodeAt(h);g===35||g===63?(u===void 0&&(u=s.substr(0,h)),u+=D[g]):u!==void 0&&(u+=s[h])}return u!==void 0?u:s}function c(s,u){let h;return s.authority&&s.path.length>1&&s.scheme==="file"?h=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?u?h=s.path.substr(1):h=s.path[1].toLowerCase()+s.path.substr(2):h=s.path,v.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=c;function a(s,u){const h=u?o:I;let g="",{scheme:d,authority:y,path:L,query:O,fragment:z}=s;if(d&&(g+=d,g+=":"),(y||d==="file")&&(g+=E,g+=E),y){let X=y.indexOf("@");if(X!==-1){const x=y.substr(0,X);y=y.substr(X+1),X=x.indexOf(":"),X===-1?g+=h(x,!1):(g+=h(x.substr(0,X),!1),g+=":",g+=h(x.substr(X+1),!1)),g+="@"}y=y.toLowerCase(),X=y.indexOf(":"),X===-1?g+=h(y,!1):(g+=h(y.substr(0,X),!1),g+=y.substr(X))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const X=L.charCodeAt(1);X>=65&&X<=90&&(L=`/${String.fromCharCode(X+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const X=L.charCodeAt(0);X>=65&&X<=90&&(L=`${String.fromCharCode(X+32)}:${L.substr(2)}`)}g+=h(L,!0)}return O&&(g+="?",g+=h(O,!1)),z&&(g+="#",g+=u?z:I(z,!1)),g}function l(s){try{return decodeURIComponent(s)}catch(u){return s.length>3?s.substr(0,3)+l(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,u=>l(u)):s}}),define(J[110],Z([0,1,7]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(p){const n=p;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=A;function R(p){const n=[];let E;try{const P=JSON.parse(p.arguments),b=P[P.length-1];b&&b.__$stack&&(P.pop(),E=b.__$stack),n.push(...P)}catch(P){n.push("Unable to log remote console arguments",p.arguments)}return{args:n,stack:E}}e.parse=R;function S(p){if(typeof p!="string")return S(R(p).stack);const n=p;if(n){const E=M(n),P=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(P&&P.length===4)return{uri:v.URI.file(P[1]),line:Number(P[2]),column:Number(P[3])}}}e.getFirstFrame=S;function M(p){if(!p)return p;const n=p.indexOf(`
`);return n===-1?p:p.substring(0,n)}function i(p,n){const{args:E,stack:P}=R(p),b=typeof E[0]=="string"&&E.length===1;let f=M(P);f&&(f=`(${f.trim()})`);let m=[];if(typeof E[0]=="string"?f&&b?m=[`%c[${n}] %c${E[0]} %c${f}`,w("blue"),w(""),w("grey")]:m=[`%c[${n}] %c${E[0]}`,w("blue"),w(""),...E.slice(1)]:m=[`%c[${n}]%`,w("blue"),...E],f&&!b&&m.push(f),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,m)}e.log=i;function w(p){return`color: ${p}`}});var Mt=this&&this.__classPrivateFieldSet||function(j,e,v,A,R){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!R:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?R.call(j,v):R?R.value=v:e.set(j,v),v},Ke=this&&this.__classPrivateFieldGet||function(j,e,v,A){if(v==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!A:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?A:v==="a"?A.call(j):A?A.value:e.get(j)};define(J[36],Z([0,1,7,24]),function(j,e,v,A){"use strict";var R,S,M;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function i(t,r,s){let u=t.get(r);return u===void 0&&(u=s,t.set(r,u)),u}e.getOrSet=i;function w(t){const r=[];return t.forEach((s,u)=>{r.push(`${u} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=w;function p(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=p;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=n;class E{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,A.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class P{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,A.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=P;var b;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(b||(b={}));class f{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new P(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,A.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class m{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new f(r))}static forPaths(){return new D(new P)}static forStrings(){return new D(new n)}static forConfigKeys(){return new D(new E)}clear(){this._root=void 0}set(r,s){const u=this._iter.reset(r);let h;for(this._root||(this._root=new m,this._root.segment=u.value()),h=this._root;;){const d=u.cmp(h.segment);if(d>0)h.left||(h.left=new m,h.left.segment=u.value()),h=h.left;else if(d<0)h.right||(h.right=new m,h.right.segment=u.value()),h=h.right;else if(u.hasNext())u.next(),h.mid||(h.mid=new m,h.mid.segment=u.value()),h=h.mid;else break}const g=h.value;return h.value=s,h.key=r,g}get(r){var s;return(s=this._getNode(r))===null||s===void 0?void 0:s.value}_getNode(r){const s=this._iter.reset(r);let u=this._root;for(;u;){const h=s.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(r){const s=this._getNode(r);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const u=this._iter.reset(r),h=[];let g=this._root;for(;g;){const d=u.cmp(g.segment);if(d>0)h.push([1,g]),g=g.left;else if(d<0)h.push([-1,g]),g=g.right;else if(u.hasNext())u.next(),h.push([0,g]),g=g.mid;else{for(s?(g.left=void 0,g.mid=void 0,g.right=void 0):g.value=void 0;h.length>0&&g.isEmpty();){let[y,L]=h.pop();switch(y){case 1:L.left=void 0;break;case 0:L.mid=void 0;break;case-1:L.right=void 0;break}g=L}break}}}findSubstr(r){const s=this._iter.reset(r);let u=this._root,h;for(;u;){const g=s.cmp(u.segment);if(g>0)u=u.left;else if(g<0)u=u.right;else if(s.hasNext())s.next(),h=u.value||h,u=u.mid;else break}return u&&u.value||h}findSuperstr(r){const s=this._iter.reset(r);let u=this._root;for(;u;){const h=s.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(r){for(const[s,u]of this)r(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){r&&(yield*this._entries(r.left),r.value&&(yield[r.key,r.value]),yield*this._entries(r.mid),yield*this._entries(r.right))}}e.TernarySearchTree=D;class I{constructor(r,s){this[R]="ResourceMap",r instanceof I?(this.map=new Map(r.map),this.toKey=s!=null?s:I.defaultToKey):(this.map=new Map,this.toKey=r!=null?r:I.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[u,h]of this.map)r(h,v.URI.parse(u),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield v.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[v.URI.parse(r[0]),r[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[v.URI.parse(r[0]),r[1]]}}e.ResourceMap=I,I.defaultToKey=t=>t.toString();var o;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class c{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,s=0){const u=this._map.get(r);if(!!u)return s!==0&&this.touch(u,s),u.value}set(r,s,u=0){let h=this._map.get(r);if(h)h.value=s,u!==0&&this.touch(h,u);else{switch(h={key:r,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}}forEach(r,s){const u=this._state;let h=this._head;for(;h;){if(s?r.bind(s)(h.value,h.key,this):r(h.value,h.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,s=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.key,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return h}values(){const r=this,s=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.value,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return h}entries(){const r=this,s=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:[u.key,u.value],done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return h}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(!(r>=this.size)){if(r===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>r;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,u=r.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const u=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(u.previous=h,h.next=u),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const u=r.next,h=r.previous;r===this._head?(u.previous=void 0,this._head=u):(u.previous=h,h.next=u),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,u)=>{r.push([u,s])}),r}fromJSON(r){this.clear();for(const[s,u]of r)this.set(s,u)}}e.LinkedMap=c;class a extends c{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class l{constructor(r){M.set(this,void 0),Mt(this,M,r,"f")}get size(){return Ke(this,M,"f").size}forEach(r,s){Ke(this,M,"f").forEach(r,s)}get(r){return Ke(this,M,"f").get(r)}has(r){return Ke(this,M,"f").has(r)}entries(){return Ke(this,M,"f").entries()}keys(){return Ke(this,M,"f").keys()}values(){return Ke(this,M,"f").values()}[(M=new WeakMap,Symbol.iterator)](){return Ke(this,M,"f").entries()}}e.ReadonlyMapView=l}),define(J[111],Z([0,1,19,24,7]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(p){return JSON.stringify(p,i)}e.stringify=S;function M(p){let n=JSON.parse(p);return n=w(n),n}e.parse=M;function i(p,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:(0,A.regExpFlags)(n)}:n}function w(p,n=0){if(!p||n>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return R.URI.revive(p);case 2:return new RegExp(p.source,p.flags)}if(p instanceof v.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let E=0;E<p.length;++E)p[E]=w(p[E],n+1);else for(const E in p)Object.hasOwnProperty.call(p,E)&&(p[E]=w(p[E],n+1))}return p}e.revive=w}),define(J[10],Z([0,1,7,3]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(i){i.inMemory="inmemory",i.vscode="vscode",i.internal="private",i.walkThrough="walkThrough",i.walkThroughSnippet="walkThroughSnippet",i.http="http",i.https="https",i.file="file",i.mailto="mailto",i.untitled="untitled",i.data="data",i.command="command",i.vscodeRemote="vscode-remote",i.vscodeRemoteResource="vscode-remote-resource",i.userData="vscode-userdata",i.vscodeCustomEditor="vscode-custom-editor",i.vscodeNotebook="vscode-notebook",i.vscodeNotebookCell="vscode-notebook-cell",i.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",i.vscodeNotebookCellOutput="vscode-notebook-cell-output",i.vscodeSettings="vscode-settings",i.vscodeWorkspaceTrust="vscode-workspace-trust",i.vscodeTerminal="vscode-terminal",i.webviewPanel="webview-panel",i.vscodeWebview="vscode-webview",i.extension="extension",i.vscodeFileResource="vscode-file",i.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,p,n){this._hosts[w]=p,this._ports[w]=n}setConnectionToken(w,p){this._connectionTokens[w]=p}rewrite(w){if(this._delegate)return this._delegate(w);const p=w.authority;let n=this._hosts[p];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const E=this._ports[p],P=this._connectionTokens[p];let b=`path=${encodeURIComponent(w.path)}`;return typeof P=="string"&&(b+=`&tkn=${encodeURIComponent(P)}`),v.URI.from({scheme:A.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${n}:${E}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new S;class M{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(w,p,n){const E=this.toUri(w,p);return E.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(E):A.isNative&&(n||A.isPreferringBrowserCodeLoad)&&E.scheme===R.file?E.with({scheme:R.vscodeFileResource,authority:E.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(w,p){const n=this.toUri(w,p);return n.scheme===R.vscodeFileResource?n.with({scheme:R.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(w,p){return v.URI.isUri(w)?w:v.URI.parse(p.toUrl(w))}}e.FileAccess=new M}),define(J[65],Z([0,1,36]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const A=new v.LRUCache(1e4);function R(p){return w(p,"NFC",A)}e.normalizeNFC=R;const S=new v.LRUCache(1e4);function M(p){return w(p,"NFD",S)}e.normalizeNFD=M;const i=/[^\u0000-\u0080]/;function w(p,n,E){if(!e.canNormalize||!p)return p;const P=E.get(p);if(P)return P;let b;return i.test(p)?b=p.normalize(n):b=p,E.set(p,b),b}e.removeAccents=function(){if(e.canNormalize){const p=/[\u0300-\u036f]/g;return function(n){return M(n).replace(p,"")}}else return function(p){return p}}()}),define(J[15],Z([0,1,30,8,7,24,10,3]),function(j,e,v,A,R,S,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(b){return(0,R.uriToFsPath)(b,!0)}e.originalFSPath=w;class p{constructor(f){this._ignorePathCasing=f}compare(f,m,D=!1){return f===m?0:(0,S.compare)(this.getComparisonKey(f,D),this.getComparisonKey(m,D))}isEqual(f,m,D=!1){return f===m?!0:!f||!m?!1:this.getComparisonKey(f,D)===this.getComparisonKey(m,D)}getComparisonKey(f,m=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,m,D=!1){if(f.scheme===m.scheme){if(f.scheme===M.Schemas.file)return v.isEqualOrParent(w(f),w(m),this._ignorePathCasing(f))&&f.query===m.query&&(D||f.fragment===m.fragment);if((0,e.isEqualAuthority)(f.authority,m.authority))return v.isEqualOrParent(f.path,m.path,this._ignorePathCasing(f),"/")&&f.query===m.query&&(D||f.fragment===m.fragment)}return!1}joinPath(f,...m){return R.URI.joinPath(f,...m)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return A.posix.basename(f.path)}extname(f){return A.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let m;return f.scheme===M.Schemas.file?m=R.URI.file(A.dirname(w(f))).path:(m=A.posix.dirname(f.path),f.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),m="/")),f.with({path:m})}normalizePath(f){if(!f.path.length)return f;let m;return f.scheme===M.Schemas.file?m=R.URI.file(A.normalize(w(f))).path:m=A.posix.normalize(f.path),f.with({path:m})}relativePath(f,m){if(!(f.scheme!==m.scheme||!(0,e.isEqualAuthority)(f.authority,m.authority))){if(f.scheme===M.Schemas.file){const o=A.relative(w(f),w(m));return i.isWindows?v.toSlashes(o):o}let D=f.path||"/",I=m.path||"/";if(this._ignorePathCasing(f)){let o=0;for(const c=Math.min(D.length,I.length);o<c&&!(D.charCodeAt(o)!==I.charCodeAt(o)&&D.charAt(o).toLowerCase()!==I.charAt(o).toLowerCase());o++);D=I.substr(0,o)+D.substr(o)}return A.posix.relative(D,I)}}resolvePath(f,m){if(f.scheme===M.Schemas.file){const D=R.URI.file(A.resolve(w(f),m));return f.with({authority:D.authority,path:D.path})}return m=v.toPosixPath(m),f.with({path:A.posix.resolve(f.path,m)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,m){return f===m||(0,S.equalsIgnoreCase)(f,m)}hasTrailingPathSeparator(f,m=A.sep){if(f.scheme===M.Schemas.file){const D=w(f);return D.length>v.getRoot(D).length&&D[D.length-1]===m}else{const D=f.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,m=A.sep){return(0,e.hasTrailingPathSeparator)(f,m)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,m=A.sep){let D=!1;if(f.scheme===M.Schemas.file){const I=w(f);D=I!==void 0&&I.length===v.getRoot(I).length&&I[I.length-1]===m}else{m="/";const I=f.path;D=I.length===1&&I.charCodeAt(I.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(f,m)?f.with({path:f.path+"/"}):f}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(b=>b.scheme===M.Schemas.file?!i.isLinux:!0),e.extUriIgnorePathCase=new p(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(b,f){const m=[];for(let D=0;D<b.length;D++){const I=f(b[D]);b.some((o,c)=>c===D?!1:(0,e.isEqualOrParent)(I,f(o)))||m.push(b[D])}return m}e.distinctParents=n;var E;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(m){const D=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(c=>{const[a,l]=c.split(":");a&&l&&D.set(a,l)});const o=m.path.substring(0,m.path.indexOf(";"));return o&&D.set(b.META_DATA_MIME,o),D}b.parseMetaData=f})(E=e.DataUri||(e.DataUri={}));function P(b,f,m){if(f){let D=b.path;return D&&D[0]!==A.posix.sep&&(D=A.posix.sep+D),b.with({scheme:m,authority:f,path:D})}return b.with({scheme:m})}e.toLocalResource=P}),define(J[9],Z([0,1,26,18,5,2,78,15]),function(j,e,v,A,R,S,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(V){return!!V&&typeof V.then=="function"}e.isThenable=w;function p(V){const _=new v.CancellationTokenSource,T=V(_.token),W=new Promise((k,F)=>{_.token.onCancellationRequested(()=>{F((0,A.canceled)())}),Promise.resolve(T).then(U=>{_.dispose(),k(U)},U=>{_.dispose(),F(U)})});return new class{cancel(){_.cancel()}then(k,F){return W.then(k,F)}catch(k){return this.then(void 0,k)}finally(k){return W.finally(k)}}}e.createCancelablePromise=p;function n(V,_,T){return Promise.race([V,new Promise(W=>_.onCancellationRequested(()=>W(T)))])}e.raceCancellation=n;async function E(V){let _=-1;const T=V.map((k,F)=>k.then(U=>(_=F,U))),W=await Promise.race(T);return V.forEach((k,F)=>{F!==_&&k.cancel()}),W}e.raceCancellablePromises=E;function P(V,_,T){let W;const k=setTimeout(()=>{W==null||W(void 0),T==null||T()},_);return Promise.race([V.finally(()=>clearTimeout(k)),new Promise(F=>W=F)])}e.raceTimeout=P;function b(V){return new Promise((_,T)=>{const W=V();w(W)?W.then(_,T):_(W)})}e.asPromise=b;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(T,T).then(W)})}return new Promise((T,W)=>{this.queuedPromise.then(T,W)})}return this.activePromise=_(),new Promise((T,W)=>{this.activePromise.then(k=>{this.activePromise=null,T(k)},k=>{this.activePromise=null,W(k)})})}}e.Throttler=f;class m{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=m;class D{constructor(){this.promiseMap=new Map}queue(_,T){var W;const F=((W=this.promiseMap.get(_))!==null&&W!==void 0?W:Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(_)===F&&this.promiseMap.delete(_)});return this.promiseMap.set(_,F),F}}e.SequencerByKey=D;class I{constructor(_){this.defaultDelay=_,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,T=this.defaultDelay){return this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,k)=>{this.doResolve=W,this.doReject=k}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},T),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,A.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=I;class o{constructor(_){this.delayer=new I(_),this.throttler=new f}trigger(_,T){return this.delayer.trigger(()=>this.throttler.queue(_),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=o;class c{constructor(){this._isOpen=!1,this._promise=new Promise((_,T)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class a extends c{constructor(_){super();this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function l(V,_){return _?new Promise((T,W)=>{const k=setTimeout(T,V);_.onCancellationRequested(()=>{clearTimeout(k),W((0,A.canceled)())})}):p(T=>l(V,T))}e.timeout=l;function t(V,_=0){const T=setTimeout(V,_);return(0,S.toDisposable)(()=>clearTimeout(T))}e.disposableTimeout=t;function r(V){return V.then(void 0,_=>{})}e.ignoreErrors=r;function s(V){const _=[];let T=0;const W=V.length;function k(){return T<W?V[T++]():null}function F(U){U!=null&&_.push(U);const K=k();return K?K.then(F):Promise.resolve(_)}return Promise.resolve(null).then(F)}e.sequence=s;function u(V,_=W=>!!W,T=null){let W=0;const k=V.length,F=()=>{if(W>=k)return Promise.resolve(T);const U=V[W++];return Promise.resolve(U()).then(G=>_(G)?Promise.resolve(G):F())};return F()}e.first=u;function h(V,_=W=>!!W,T=null){if(V.length===0)return Promise.resolve(T);let W=V.length;const k=()=>{var F,U;W=-1;for(const K of V)(U=(F=K).cancel)===null||U===void 0||U.call(F)};return new Promise((F,U)=>{for(const K of V)K.then(G=>{--W>=0&&_(G)?(k(),F(G)):W===0&&F(T)}).catch(G=>{--W>=0&&(k(),U(G))})})}e.firstParallel=h;class g{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(_){return this._size++,new Promise((T,W)=>{this.outstandingPromises.push({factory:_,c:T,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const T=_.factory();T.then(_.c,_.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=g;class d extends g{constructor(){super(1)}}e.Queue=d;class y{constructor(){this.queues=new Map}queueFor(_,T=i.extUri){const W=T.getComparisonKey(_);let k=this.queues.get(W);return k||(k=new d,R.Event.once(k.onFinished)(()=>{k==null||k.dispose(),this.queues.delete(W)}),this.queues.set(W,k)),k}dispose(){this.queues.forEach(_=>_.dispose()),this.queues.clear()}}e.ResourceQueue=y;class L{constructor(_,T){this._token=-1,typeof _=="function"&&typeof T=="number"&&this.setIfNotSet(_,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},T)}setIfNotSet(_,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},T))}}e.TimeoutTimer=L;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,T){this.cancel(),this._token=setInterval(()=>{_()},T)}}e.IntervalTimer=O;class z{constructor(_,T){this.timeoutToken=-1,this.runner=_,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=z;class X extends z{constructor(_,T){super(_,T);this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner&&this.runner(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const V=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=_=>{const T=setTimeout(()=>_(V));let W=!1;return{dispose(){W||(W=!0,clearTimeout(T))}}}}else e.runWhenIdle=(V,_)=>{const T=requestIdleCallback(V,typeof _=="number"?{timeout:_}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(T))}}}}();class x{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=x;async function H(V,_,T){let W;for(let k=0;k<T;k++)try{return await V()}catch(F){W=F,await l(_)}throw W}e.retry=H;class Q{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var _;(_=this._pending)===null||_===void 0||_.cancel()}setPending(_,T,W){return this._pending={taskId:_,cancel:()=>W==null?void 0:W(),promise:T},T.then(()=>this.donePending(_),()=>this.donePending(_)),T}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let T,W;const k=new Promise((F,U)=>{T=F,W=U});this._next={run:_,promise:k,promiseResolve:T,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=Q;class B{constructor(_){this.interval=_,this.lastIncrementTime=0,this.value=0}increment(){const _=Date.now();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,T)=>{this.completeCallback=_,this.errorCallback=T})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(_){return new Promise(T=>{this.completeCallback(_),this.resolved=!0,T()})}error(_){return new Promise(T=>{this.errorCallback(_),this.rejected=!0,T()})}cancel(){new Promise(_=>{this.errorCallback((0,A.canceled)()),this.rejected=!0,_()})}}e.DeferredPromise=N;class C extends R.Emitter{async fireAsync(_,T,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const k of this._listeners)this._asyncDeliveryQueue.push([k,_]);for(;this._asyncDeliveryQueue.size>0&&!T.isCancellationRequested;){const[k,F]=this._asyncDeliveryQueue.shift(),U=[],K=Object.assign(Object.assign({},F),{waitUntil:G=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");W&&(G=W(G,typeof k=="function"?k:k[0])),U.push(G)}});try{typeof k=="function"?k.call(void 0,K):k[0].call(k[1],K)}catch(G){(0,A.onUnexpectedError)(G);continue}Object.freeze(U),await $.settled(U).catch(G=>(0,A.onUnexpectedError)(G))}}}}e.AsyncEmitter=C;var $;(function(V){async function _(F){return typeof Promise.allSettled=="function"?T(F):W(F)}V.allSettled=_;async function T(F){return Promise.allSettled(F)}async function W(F){return Promise.all(F.map(U=>U.then(K=>({status:"fulfilled",value:K}),K=>({status:"rejected",reason:K}))))}async function k(F){let U;const K=await Promise.all(F.map(G=>G.then(Y=>Y,Y=>{U||(U=Y)})));if(typeof U!="undefined")throw U;return K}V.settled=k})($=e.Promises||(e.Promises={}))}),define(J[112],Z([0,1,24,30,8,36,9]),function(j,e,v,A,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function i(){return Object.create(null)}e.getEmptyExpression=i;const w="**",p="/",n="[/\\\\]",E="[^/\\\\]",P=/\//g;function b(T){switch(T){case 0:return"";case 1:return`${E}*?`;default:return`(?:${n}|${E}+${n}|${n}${E}+)*?`}}function f(T,W){if(!T)return[];const k=[];let F=!1,U=!1,K="";for(const G of T){switch(G){case W:if(!F&&!U){k.push(K),K="";continue}break;case"{":F=!0;break;case"}":F=!1;break;case"[":U=!0;break;case"]":U=!1;break}K+=G}return K&&k.push(K),k}e.splitGlobAware=f;function m(T){if(!T)return"";let W="";const k=f(T,p);if(k.every(F=>F===w))W=".*";else{let F=!1;k.forEach((U,K)=>{if(U===w){F||(W+=b(2),F=!0);return}let G=!1,Y="",ee=!1,re="";for(const se of U){if(se!=="}"&&G){Y+=se;continue}if(ee&&(se!=="]"||!re)){let oe;se==="-"?oe=se:(se==="^"||se==="!")&&!re?oe="^":se===p?oe="":oe=v.escapeRegExpCharacters(se),re+=oe;continue}switch(se){case"{":G=!0;continue;case"[":ee=!0;continue;case"}":W+=`(?:${f(Y,",").map(le=>m(le)).join("|")})`,G=!1,Y="";break;case"]":W+="["+re+"]",ee=!1,re="";break;case"?":W+=E;continue;case"*":W+=b(1);continue;default:W+=v.escapeRegExpCharacters(se)}}K<k.length-1&&(k[K+1]!==w||K+2<k.length)&&(W+=n),F=!1})}return W}const D=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,o=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),r=function(){return!1},s=function(){return null};function u(T,W){if(!T)return s;let k;typeof T!="string"?k=T.pattern:k=T,k=k.trim();const F=`${k}_${!!W.trimForExclusions}`;let U=t.get(F);if(U)return h(U,T);let K;if(D.test(k)){const G=k.substr(4);U=function(Y,ee){return typeof Y=="string"&&Y.endsWith(G)?k:null}}else(K=I.exec(g(k,W)))?U=d(K[1],k):(W.trimForExclusions?c:o).test(k)?U=y(k,W):(K=a.exec(g(k,W)))?U=L(K[1].substr(1),k,!0):(K=l.exec(g(k,W)))?U=L(K[1],k,!1):U=O(k);return t.set(F,U),h(U,T)}function h(T,W){return typeof W=="string"?T:function(k,F){return A.isEqualOrParent(k,W.base)?T(R.relative(W.base,k),F):null}}function g(T,W){return W.trimForExclusions&&T.endsWith("/**")?T.substr(0,T.length-2):T}function d(T,W){const k=`/${T}`,F=`\\${T}`,U=function(G,Y){return typeof G!="string"?null:Y?Y===T?W:null:G===T||G.endsWith(k)||G.endsWith(F)?W:null},K=[T];return U.basenames=K,U.patterns=[W],U.allBasenames=K,U}function y(T,W){const k=_(T.slice(1,-1).split(",").map(Y=>u(Y,W)).filter(Y=>Y!==s),T),F=k.length;if(!F)return s;if(F===1)return k[0];const U=function(Y,ee){for(let re=0,se=k.length;re<se;re++)if(k[re](Y,ee))return T;return null},K=k.find(Y=>!!Y.allBasenames);K&&(U.allBasenames=K.allBasenames);const G=k.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return G.length&&(U.allPaths=G),U}function L(T,W,k){const F=R.sep===R.posix.sep,U=F?T:T.replace(P,R.sep),K=R.sep+U,G=R.posix.sep+T,Y=k?function(ee,re){return typeof ee=="string"&&(ee===U||ee.endsWith(K)||!F&&(ee===T||ee.endsWith(G)))?W:null}:function(ee,re){return typeof ee=="string"&&(ee===U||!F&&ee===T)?W:null};return Y.allPaths=[(k?"*/":"./")+T],Y}function O(T){try{const W=new RegExp(`^${m(T)}$`);return function(k){return W.lastIndex=0,typeof k=="string"&&W.test(k)?T:null}}catch(W){return s}}function z(T,W,k){return!T||typeof W!="string"?!1:X(T)(W,void 0,k)}e.match=z;function X(T,W={}){if(!T)return r;if(typeof T=="string"||B(T)){const k=u(T,W);if(k===s)return r;const F=function(U,K){return!!k(U,K)};return k.allBasenames&&(F.allBasenames=k.allBasenames),k.allPaths&&(F.allPaths=k.allPaths),F}return $(T,W)}e.parse=X;function x(T){if(!!T){let W;return k=>(W||(W=(T()||Promise.resolve([])).then(F=>F?Q(F):{})),W.then(F=>!!F[k]))}}e.hasSiblingPromiseFn=x;function H(T){if(!!T){let W;return k=>{if(!W){const F=T();W=F?Q(F):{}}return!!W[k]}}}e.hasSiblingFn=H;function Q(T){const W={};for(const k of T)W[k]=!0;return W}function B(T){const W=T;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=B;function N(T){return T.allBasenames||[]}e.getBasenameTerms=N;function C(T){return T.allPaths||[]}e.getPathTerms=C;function $(T,W){const k=_(Object.getOwnPropertyNames(T).map(Y=>V(Y,T[Y],W)).filter(Y=>Y!==s)),F=k.length;if(!F)return s;if(!k.some(Y=>!!Y.requiresSiblings)){if(F===1)return k[0];const Y=function(se,oe){for(let ne=0,le=k.length;ne<le;ne++){const ve=k[ne](se,oe);if(ve)return ve}return null},ee=k.find(se=>!!se.allBasenames);ee&&(Y.allBasenames=ee.allBasenames);const re=k.reduce((se,oe)=>oe.allPaths?se.concat(oe.allPaths):se,[]);return re.length&&(Y.allPaths=re),Y}const U=function(Y,ee,re){let se;for(let oe=0,ne=k.length;oe<ne;oe++){const le=k[oe];le.requiresSiblings&&re&&(ee||(ee=R.basename(Y)),se||(se=ee.substr(0,ee.length-R.extname(Y).length)));const ve=le(Y,ee,se,re);if(ve)return ve}return null},K=k.find(Y=>!!Y.allBasenames);K&&(U.allBasenames=K.allBasenames);const G=k.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return G.length&&(U.allPaths=G),U}function V(T,W,k){if(W===!1)return s;const F=u(T,k);if(F===s)return s;if(typeof W=="boolean")return F;if(W){const U=W.when;if(typeof U=="string"){const K=(G,Y,ee,re)=>{if(!re||!F(G,Y))return null;const se=U.replace("$(basename)",ee),oe=re(se);return(0,M.isThenable)(oe)?oe.then(ne=>ne?T:null):oe?T:null};return K.requiresSiblings=!0,K}}return F}function _(T,W){const k=T.filter(Y=>!!Y.basenames);if(k.length<2)return T;const F=k.reduce((Y,ee)=>{const re=ee.basenames;return re?Y.concat(re):Y},[]);let U;if(W){U=[];for(let Y=0,ee=F.length;Y<ee;Y++)U.push(W)}else U=k.reduce((Y,ee)=>{const re=ee.patterns;return re?Y.concat(re):Y},[]);const K=function(Y,ee){if(typeof Y!="string")return null;if(!ee){let se;for(se=Y.length;se>0;se--){const oe=Y.charCodeAt(se-1);if(oe===47||oe===92)break}ee=Y.substr(se)}const re=F.indexOf(ee);return re!==-1?U[re]:null};K.basenames=F,K.patterns=U,K.allBasenames=F;const G=T.filter(Y=>!Y.basenames);return G.push(K),G}}),define(J[39],Z([0,1,7,8,24,10,3,15,30]),function(j,e,v,A,R,S,M,i,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function p(u,h,g){if(typeof u=="string"&&(u=v.URI.file(u)),g){const y=g.getWorkspaceFolder(u);if(y){const L=g.getWorkspace().folders.length>1;let O;if((0,i.isEqual)(y.uri,u)?O="":O=(0,i.relativePath)(y.uri,u),L){const z=y.name?y.name:(0,i.basename)(y.uri);O=O?z+" \u2022 "+O:z}return O}}if(u.scheme!==S.Schemas.file&&u.scheme!==S.Schemas.untitled)return u.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(u.fsPath))return(0,A.normalize)(E(u.fsPath));let d=(0,A.normalize)(u.fsPath);return!M.isWindows&&(h==null?void 0:h.userHome)&&(d=b(d,h.userHome.fsPath)),d}e.getPathLabel=p;function n(u){if(!!u){typeof u=="string"&&(u=v.URI.file(u));const h=(0,i.basename)(u)||(u.scheme===S.Schemas.file?u.fsPath:u.path);return M.isWindows&&(0,w.isRootOrDriveLetter)(h)?E(h):h}}e.getBaseLabel=n;function E(u){return(0,w.hasDriveLetter)(u)?u.charAt(0).toUpperCase()+u.slice(1):u}e.normalizeDriveLetter=E;let P=Object.create(null);function b(u,h){if(M.isWindows||!u||!h)return u;let g=P.original===h?P.normalized:void 0;return g||(g=`${(0,R.rtrim)(h,A.posix.sep)}${A.posix.sep}`,P={original:h,normalized:g}),(M.isLinux?u.startsWith(g):(0,R.startsWithIgnoreCase)(u,g))&&(u=`~/${u.substr(g.length)}`),u}e.tildify=b;function f(u,h){return u.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=f;const m="\u2026",D="\\\\",I="~";function o(u,h=A.sep){const g=new Array(u.length);let d=!1;for(let y=0;y<u.length;y++){let L=u[y];if(L===""){g[y]=`.${h}`;continue}if(!L){g[y]=L;continue}d=!0;let O="";L.indexOf(D)===0?(O=L.substr(0,L.indexOf(D)+D.length),L=L.substr(L.indexOf(D)+D.length)):L.indexOf(h)===0?(O=L.substr(0,L.indexOf(h)+h.length),L=L.substr(L.indexOf(h)+h.length)):L.indexOf(I)===0&&(O=L.substr(0,L.indexOf(I)+I.length),L=L.substr(L.indexOf(I)+I.length));const z=L.split(h);for(let X=1;d&&X<=z.length;X++)for(let x=z.length-X;d&&x>=0;x--){d=!1;let H=z.slice(x,x+X).join(h);for(let Q=0;!d&&Q<u.length;Q++)if(Q!==y&&u[Q]&&u[Q].indexOf(H)>-1){const B=x+X===z.length,N=x>0&&u[Q].indexOf(h)>-1?h+H:H,C=u[Q].endsWith(N);d=!B||C}if(!d){let Q="";(z[0].endsWith(":")||O!=="")&&(x===1&&(x=0,X++,H=z[0]+h+H),x>0&&(Q=z[0]+h),Q=O+Q),x>0&&(Q=Q+m+h),Q=Q+H,x+X<z.length&&(Q=Q+h+m),g[y]=Q}}d&&(g[y]=L)}return g}e.shorten=o;var c;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function a(u,h=Object.create(null)){const g=[];let d=!1,y="";for(const L of u)if(L==="$"||d&&L==="{")y&&g.push({value:y,type:c.TEXT}),y="",d=!0;else if(L==="}"&&d){const O=h[y];if(typeof O=="string")O.length&&g.push({value:O,type:c.VARIABLE});else if(O){const z=g[g.length-1];(!z||z.type!==c.SEPARATOR)&&g.push({value:O.label,type:c.SEPARATOR})}y="",d=!1}else y+=L;return y&&!d&&g.push({value:y,type:c.TEXT}),g.filter((L,O)=>{if(L.type===c.SEPARATOR){const z=g[O-1],X=g[O+1];return[z,X].every(x=>x&&(x.type===c.VARIABLE||x.type===c.TEXT)&&x.value.length>0)}return!0}).map(L=>L.value).join("")}e.template=a;function l(u,h){return M.isMacintosh||h?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):u.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function t(u,h){return M.isMacintosh||h?u.replace(/\(&&\w\)|&&/g,""):M.isWindows?u.replace(/&&|&/g,g=>g==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(u){return u.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(u){const h=u.indexOf("/")!==-1?A.posix:A.win32,g=h.basename(u),d=h.dirname(u);return g.length?{name:g,parentPath:d}:{name:d,parentPath:""}}e.splitName=s}),define(J[28],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(w){return v.test(w)}e.isUUID=A;const R=new Uint8Array(16),S=[];for(let w=0;w<256;w++)S.push(w.toString(16).padStart(2,"0"));let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(w){for(let p=0;p<w.length;p++)w[p]=Math.floor(Math.random()*256);return w};function i(){M(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let w=0,p="";return p+=S[R[w++]],p+=S[R[w++]],p+=S[R[w++]],p+=S[R[w++]],p+="-",p+=S[R[w++]],p+=S[R[w++]],p+="-",p+=S[R[w++]],p+=S[R[w++]],p+="-",p+=S[R[w++]],p+=S[R[w++]],p+="-",p+=S[R[w++]],p+=S[R[w++]],p+=S[R[w++]],p+=S[R[w++]],p+=S[R[w++]],p+=S[R[w++]],p}e.generateUuid=i}),define(J[113],Z([0,1,20,58,42]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function S(M,i){if(await new Promise((n,E)=>{const P=v.createReadStream(M),b=A.createHash("sha1");P.pipe(b);const f=(0,R.once)((m,D)=>{P.removeAllListeners(),b.removeAllListeners(),m?E(m):n(D)});P.once("error",f),P.once("end",f),b.once("error",f),b.once("data",m=>f(void 0,m.toString("hex")))})!==i)throw new Error("Hash mismatch")}e.checksum=S}),define(J[81],Z([0,1,237]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class A{constructor(S="utf8"){this.stringDecoder=new v.StringDecoder(S),this.remaining=null}write(S){const M=[],i=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(i.length<1)return M;let w=0,p,n=w;for(;n<i.length;)if(p=i.charCodeAt(n),p===13||p===10){if(M.push(i.substring(w,n)),n++,n<i.length){const E=p;p=i.charCodeAt(n),(E===13&&p===10||E===10&&p===13)&&n++}w=n}else n++;return this.remaining=w<i.length?i.substr(w):null,M}end(){return this.remaining}}e.LineDecoder=A}),define(J[114],Z([0,1,27]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(i){const w=i.replace(/\-/g,":").toLowerCase();return!A.has(w)}function S(){return new Promise(async(i,w)=>{const p=setTimeout(()=>w("Unable to retrieve mac address (timeout after 10s)"),1e4);try{i(await M())}catch(n){w(n)}finally{clearTimeout(p)}})}e.getMac=S;function M(){return new Promise((i,w)=>{try{const p=(0,v.networkInterfaces)();for(let n in p){const E=p[n];if(E){for(const{mac:P}of E)if(R(P))return i(P)}}w("Unable to retrieve mac address (unexpected format)")}catch(p){w(p)}})}}),define(J[66],Z([0,1,18,28,27,36,114]),function(j,e,v,A,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=S.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,E=0;const P=(0,R.networkInterfaces)();for(let b in P){const f=P[b];if(f)for(const{mac:m,internal:D}of f)D||(E+=1,this._isVirtualMachineMacAdress(m.toUpperCase())&&(n+=1))}this._value=E>0?n/E:0}return this._value}};let i;async function w(){return i||(i=(async()=>await p()||A.generateUuid())()),i}e.getMachineId=w;async function p(){try{const n=await new Promise((P,b)=>{j(["crypto"],P,b)}),E=await(0,M.getMac)();return n.createHash("sha256").update(E,"utf8").digest("hex")}catch(n){v.onUnexpectedError(n);return}}}),define(J[21],Z([0,1,20,27,8,9,3,30,28,65,15,7]),function(j,e,v,A,R,S,M,i,w,p,n,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var P;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(P=e.RimRafMode||(e.RimRafMode={}));async function b(N,C=P.UNLINK){if((0,i.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return C===P.UNLINK?m(N):f(N)}e.rimraf=b;async function f(N){try{const C=(0,R.join)((0,A.tmpdir)(),(0,w.generateUuid)());try{await v.promises.rename(N,C)}catch($){return m(N)}m(C).catch($=>{})}catch(C){if(C.code!=="ENOENT")throw C}}async function m(N){return v.promises.rmdir(N,{recursive:!0,maxRetries:3})}function D(N){if((0,i.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(N,{recursive:!0})}e.rimrafSync=D;async function I(N,C){return a(await(C?o(N):v.promises.readdir(N)))}e.readdir=I;async function o(N){try{return await v.promises.readdir(N,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const C=[],$=await I(N);for(const V of $){let _=!1,T=!1,W=!1;try{const k=await v.promises.lstat((0,R.join)(N,V));_=k.isFile(),T=k.isDirectory(),W=k.isSymbolicLink()}catch(k){console.warn("[node.js fs] unexpected error from lstat after readdir: ",k)}C.push({name:V,isFile:()=>_,isDirectory:()=>T,isSymbolicLink:()=>W})}return C}function c(N){return a(v.readdirSync(N))}e.readdirSync=c;function a(N){return N.map(C=>typeof C=="string"?M.isMacintosh?(0,p.normalizeNFC)(C):C:(C.name=M.isMacintosh?(0,p.normalizeNFC)(C.name):C.name,C))}async function l(N){const C=await I(N),$=[];for(const V of C)await r.existsDirectory((0,R.join)(N,V))&&$.push(V);return $}e.readDirsInDir=l;function t(N,C=1e3){return new Promise($=>{let V=!1;const _=setInterval(()=>{V||(V=!0,v.access(N,T=>{V=!1,T&&(clearInterval(_),$(void 0))}))},C)})}e.whenDeleted=t;var r;(function(N){async function C(_){let T;try{if(T=await v.promises.lstat(_),!T.isSymbolicLink())return{stat:T}}catch(W){}try{return{stat:await v.promises.stat(_),symbolicLink:(T==null?void 0:T.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(M.isWindows&&W.code==="EACCES")try{return{stat:await v.promises.stat(await v.promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(k){if(k.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw k}throw W}}N.stat=C;async function $(_){try{const{stat:T,symbolicLink:W}=await N.stat(_);return T.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(T){}return!1}N.existsFile=$;async function V(_){try{const{stat:T,symbolicLink:W}=await N.stat(_);return T.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(T){}return!1}N.existsDirectory=V})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new S.ResourceQueue;function u(N,C,$){return s.queueFor(E.URI.file(N),n.extUriBiasedIgnorePathCase).queue(()=>{const V=y($);return new Promise((_,T)=>g(N,C,V,W=>W?T(W):_()))})}e.writeFile=u;let h=!0;function g(N,C,$,V){if(!h)return v.writeFile(N,C,{mode:$.mode,flag:$.flag},V);v.open(N,$.flag,$.mode,(_,T)=>{if(_)return V(_);v.writeFile(T,C,W=>{if(W)return v.close(T,()=>V(W));v.fdatasync(T,k=>(k&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",k),h=!1),v.close(T,F=>V(F))))})})}function d(N,C,$){const V=y($);if(!h)return v.writeFileSync(N,C,{mode:V.mode,flag:V.flag});const _=v.openSync(N,V.flag,V.mode);try{v.writeFileSync(_,C);try{v.fdatasyncSync(_)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),h=!1}}finally{v.closeSync(_)}}e.writeFileSync=d;function y(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function L(N,C){if(N!==C){async function $(V){try{const _=await v.promises.lstat(V);if(_.isDirectory()||_.isSymbolicLink())return;const T=await v.promises.open(V,"a");try{await T.utimes(_.atime,new Date)}finally{await T.close()}}catch(_){}}try{await v.promises.rename(N,C),await $(C)}catch(V){if(N.toLowerCase()!==C.toLowerCase()&&V.code==="EXDEV"||N.endsWith("."))await O(N,C,{preserveSymlinks:!1}),await b(N,P.MOVE),await $(C);else throw V}}}e.move=L;async function O(N,C,$){return X(N,C,{root:{source:N,target:C},options:$,handledSourcePaths:new Set})}e.copy=O;const z=511;async function X(N,C,$){if(!$.handledSourcePaths.has(N)){$.handledSourcePaths.add(N);const{stat:V,symbolicLink:_}=await r.stat(N);if(_){if($.options.preserveSymlinks)try{return await Q(N,C,$)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(_.dangling)return}return V.isDirectory()?x(N,C,V.mode&z,$):H(N,C,V.mode&z)}}async function x(N,C,$,V){await v.promises.mkdir(C,{recursive:!0,mode:$});const _=await I(N);for(const T of _)await X((0,R.join)(N,T),(0,R.join)(C,T),V)}async function H(N,C,$){await v.promises.copyFile(N,C),await v.promises.chmod(C,$)}async function Q(N,C,$){let V=await v.promises.readlink(N);(0,i.isEqualOrParent)(V,$.root.source,!M.isLinux)&&(V=(0,R.join)($.root.target,V.substr($.root.source.length+1))),await v.promises.symlink(V,C)}async function B(N){try{return await v.promises.access(N),!0}catch(C){return!1}}e.exists=B}),define(J[82],Z([0,1,20,83,24,8,21]),function(j,e,v,A,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(E){const P=(0,S.dirname)(E);if(E===P)return E;const b=((0,S.basename)(E)||E).toLowerCase();try{const m=(0,M.readdirSync)(P).filter(D=>D.toLowerCase()===b);if(m.length===1){const D=i(P);if(D)return(0,S.join)(D,m[0])}else if(m.length>1){const D=m.indexOf(b);if(D>=0){const I=i(P);if(I)return(0,S.join)(I,m[D])}}}catch(f){}return null}e.realcaseSync=i;async function w(E){try{return await(0,A.promisify)(v.realpath)(E)}catch(P){const b=n(E);return await v.promises.access(b,v.constants.R_OK),b}}e.realpath=w;function p(E){try{return v.realpathSync(E)}catch(P){const b=n(E);return v.accessSync(b,v.constants.R_OK),b}}e.realpathSync=p;function n(E){return(0,R.rtrim)((0,S.normalize)(E),S.sep)}}),define(J[115],Z([0,1,59]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function A(i,w,p){let n=!1;return new Promise(E=>{const P=setTimeout(()=>{if(!n)return n=!0,E(0)},p);R(i,w,b=>{if(!n)return n=!0,clearTimeout(P),E(b)})})}e.findFreePort=A;function R(i,w,p){if(w===0)return p(0);const n=new v.Socket;n.once("connect",()=>(M(n),R(i+1,w-1,p))),n.once("data",()=>{}),n.once("error",E=>(M(n),E.code!=="ECONNREFUSED"?R(i+1,w-1,p):p(i))),n.connect(i,"127.0.0.1")}function S(i,w,p){let n=!1,E,P=1;const b=v.createServer({pauseOnConnect:!0});function f(m,D){n||(n=!0,b.removeAllListeners(),b.close(),E&&clearTimeout(E),D(m))}return new Promise(m=>{E=setTimeout(()=>{f(0,m)},p),b.on("listening",()=>{f(i,m)}),b.on("error",D=>{D&&(D.code==="EADDRINUSE"||D.code==="EACCES")&&P<w?(i++,P++,b.listen(i,"127.0.0.1")):f(0,m)}),b.on("close",()=>{f(0,m)}),b.listen(i,"127.0.0.1")})}e.findFreePortFaster=S;function M(i){try{i.removeAllListeners("connect"),i.removeAllListeners("error"),i.end(),i.destroy(),i.unref()}catch(w){console.error(w)}}});var _e=this&&this.__await||function(j){return this instanceof _e?(this.v=j,this):new _e(j)},pt=this&&this.__asyncGenerator||function(j,e,v){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var A=v.apply(j,e||[]),R,S=[];return R={},M("next"),M("throw"),M("return"),R[Symbol.asyncIterator]=function(){return this},R;function M(P){A[P]&&(R[P]=function(b){return new Promise(function(f,m){S.push([P,b,f,m])>1||i(P,b)})})}function i(P,b){try{w(A[P](b))}catch(f){E(S[0][3],f)}}function w(P){P.value instanceof _e?Promise.resolve(P.value.v).then(p,n):E(S[0][2],P)}function p(P){i("next",P)}function n(P){i("throw",P)}function E(P,b){P(b),S.shift(),S.length&&i(S[0][0],S[0][1])}},yt=this&&this.__asyncValues||function(j){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=j[Symbol.asyncIterator],v;return e?e.call(j):(j=typeof __values=="function"?__values(j):j[Symbol.iterator](),v={},A("next"),A("throw"),A("return"),v[Symbol.asyncIterator]=function(){return this},v);function A(S){v[S]=j[S]&&function(M){return new Promise(function(i,w){M=j[S](M),R(i,w,M.done,M.value)})}}function R(S,M,i,w){Promise.resolve(w).then(function(p){S({value:p,done:i})},M)}};define(J[116],Z([0,1,21,27,8]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,M=/^Microsoft.PowerShell_.*/,i=/^Microsoft.PowerShellPreview_.*/;var w;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(w||(w={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class E{constructor(l,t,r){this.exePath=l,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function P({useAlternateBitness:a=!1}={}){return a?p===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:a=!1,findPreview:l=!1}={}){const t=P({useAlternateBitness:a});if(!t)return null;const r=R.join(t,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(r))return null;let s=-1,u=null;for(const d of await v.readdir(r)){let y=-1;if(l){const O=d.indexOf("-");if(O<0)continue;const z=d.substring(0,O);if(!S.test(z)||d.substring(O+1)!=="preview")continue;y=parseInt(z,10)}else{if(!S.test(d))continue;y=parseInt(d,10)}if(!(y<=s)){const L=R.join(r,d,"pwsh.exe");!await v.SymlinkSupport.existsFile(L)||(u=L,s=y)}}if(!u)return null;const h=t.includes("x86")?" (x86)":"",g=l?" Preview":"";return new E(u,`PowerShell${g}${h}`,!0)}async function f({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const l=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=a?{pwshMsixDirRegex:i,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const s of await v.readdir(l))if(t.test(s)){const u=R.join(l,s,"pwsh.exe");return new E(u,r)}return null}function m(){const a=R.join(A.homedir(),".dotnet","tools","pwsh.exe");return new E(a,".NET Core PowerShell Global Tool")}function D(){const a=R.join(process.env.windir,p===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(a,"Windows PowerShell",!0)}function I(){return pt(this,arguments,function*(){let l=yield _e(b());l&&(yield yield _e(l)),l=yield _e(b({useAlternateBitness:!0})),l&&(yield yield _e(l)),l=yield _e(f()),l&&(yield yield _e(l)),l=m(),l&&(yield yield _e(l)),l=yield _e(b({findPreview:!0})),l&&(yield yield _e(l)),l=yield _e(f({findPreview:!0})),l&&(yield yield _e(l)),l=yield _e(b({useAlternateBitness:!0,findPreview:!0})),l&&(yield yield _e(l)),l=D(),l&&(yield yield _e(l))})}function o(){return pt(this,arguments,function*(){var l,t;try{for(var r=yt(I()),s;s=yield _e(r.next()),!s.done;){const u=s.value;(yield _e(u.exists()))&&(yield yield _e(u))}}catch(u){l={error:u}}finally{try{s&&!s.done&&(t=r.return)&&(yield _e(t.call(r)))}finally{if(l)throw l.error}}})}e.enumeratePowerShellInstallations=o;async function c(){var a,l;try{for(var t=yt(o()),r;r=await t.next(),!r.done;)return r.value}catch(s){a={error:s}}finally{try{r&&!r.done&&(l=t.return)&&await l.call(t)}finally{if(a)throw a.error}}return null}e.getFirstAvailablePowerShellInstallation=c}),define(J[84],Z([0,1,40,10]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(M){return new Promise((i,w)=>{let p;const n=new Map;function E(f,m,D,I,o){const c=n.get(m);if(f===M||c){const a={name:P(D),cmd:D,pid:f,ppid:m,load:I,mem:o};n.set(f,a),f===M&&(p=a),c&&(c.children||(c.children=[]),c.children.push(a),c.children.length>1&&(c.children=c.children.sort((l,t)=>l.pid-t.pid)))}}function P(f){const m=/--disable-blink-features=Auxclick/,D=/\\watcher\\win32\\CodeHelper\.exe/,I=/--crashes-directory/,o=/\\pipe\\winpty-control/,c=/conhost\.exe/,a=/--type=([a-zA-Z-]+)/;if(D.exec(f))return"watcherService ";if(I.exec(f))return"electron-crash-reporter";if(o.exec(f))return"winpty-process";if(c.exec(f))return"console-window-host (Windows internal process)";let l=a.exec(f);if(l&&l.length===2)return l[1]==="renderer"?m.exec(f)?"shared-process":"window":l[1];const t=/[a-zA-Z-]+\.js/g;let r="";do l=t.exec(f),l&&(r+=l+" ");while(l);return r&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron_node ${r}`:f}if(process.platform==="win32"){const f=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,D)=>{j(["windows-process-tree"],m,D)}).then(m=>{m.getProcessList(M,D=>{m.getProcessCpuUsage(D,I=>{const o=new Map;I.forEach(c=>{const a=f(c.commandLine||"");o.set(c.pid,{name:P(a),cmd:a,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),p=o.get(M),p?(o.forEach(c=>{const a=o.get(c.ppid);a&&(a.children||(a.children=[]),a.children.push(c))}),o.forEach(c=>{c.children&&(c.children=c.children.sort((a,l)=>a.pid-l.pid))}),i(p)):w(new Error(`Root process ${M} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{function b(){let f=[p];const m=[];for(;f.length;){const I=f.shift();I&&(m.push(I.pid),I.children&&(f=f.concat(I.children)))}let D=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);D+=" "+m.join(" "),(0,v.exec)(D,{},(I,o,c)=>{if(I||c)w(I||new Error(c.toString()));else{const a=o.toString().split(`
`);for(let l=0;l<m.length;l++){const t=n.get(m[l]);t.load=parseFloat(a[l])}if(!p){w(new Error(`Root process ${M} not found`));return}i(p)}})}(0,v.exec)("which ps",{},(f,m,D)=>{if(f||D)if(process.platform!=="linux")w(f||new Error(D.toString()));else{const I=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,v.exec)(I,{},(o,c,a)=>{o||a?w(o||new Error(a.toString())):(S(c,E),b())})}else{const I=m.toString().trim(),o="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${I} ${o}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,a,l)=>{c||l&&!l.includes("screen size is bogus")?w(c||new Error(l.toString())):(S(a,E),process.platform==="linux"?b():p?i(p):w(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=R;function S(M,i){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=M.toString().split(`
`);for(const n of p){const E=w.exec(n.trim());E&&E.length===6&&i(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(J[117],Z([0,1,8,20,3,65,2,21]),function(j,e,v,A,R,S,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function w(E,P,b){return n({path:E,isDirectory:!1},P,b)}e.watchFile=w;function p(E,P,b){return n({path:E,isDirectory:!0},P,b)}e.watchFolder=p,e.CHANGE_BUFFER_DELAY=100;function n(E,P,b){const f=(0,v.basename)(E.path),m=new Map;let D=!1,I=[(0,M.toDisposable)(()=>{m.forEach(o=>(0,M.dispose)(o)),m.clear()})];try{const o=(0,A.watch)(E.path);I.push((0,M.toDisposable)(()=>{o.removeAllListeners(),o.close()}));const c=new Set;E.isDirectory&&(0,i.readdir)(E.path).then(a=>a.forEach(l=>c.add(l))),o.on("error",(a,l)=>{D||b(`Failed to watch ${E.path} for changes using fs.watch() (${a}, ${l})`)}),o.on("change",(a,l)=>{if(!D){let t="";if(l&&(t=l.toString(),R.isMacintosh&&(t=(0,S.normalizeNFC)(t))),!(!t||a!=="change"&&a!=="rename")){const r=E.isDirectory?(0,v.join)(E.path,t):E.path;if(E.isDirectory)if(a==="rename"){const s=m.get(r);s&&(0,M.dispose)(s);const u=setTimeout(async()=>{m.delete(r);const h=await(0,i.exists)(r);if(!D){let g;h?c.has(t)?g="changed":(g="added",c.add(t)):(c.delete(t),g="deleted"),P(g,r)}},e.CHANGE_BUFFER_DELAY);m.set(r,(0,M.toDisposable)(()=>clearTimeout(u)))}else{let s;c.has(t)?s="changed":(s="added",c.add(t)),P(s,r)}else if(a==="rename"||t!==f){const s=setTimeout(async()=>{const u=await(0,i.exists)(r);D||(u?(P("changed",r),I=[n(E,P,b)]):P("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(I),I=[(0,M.toDisposable)(()=>clearTimeout(s))]}else P("changed",r)}}})}catch(o){(0,i.exists)(E.path).then(c=>{c&&!D&&b(`Failed to watch ${E.path} for changes using fs.watch() (${o.toString()})`)})}return(0,M.toDisposable)(()=>{D=!0,I=(0,M.dispose)(I)})}}),define(J[118],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[119],Z([0,1,14,118,13]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function S(){v.ipcMain.on(A.CONTEXT_MENU_CHANNEL,(i,w,p,n,E)=>{const P=M(i,n,p);P.popup({window:(0,R.withNullAsUndefined)(v.BrowserWindow.fromWebContents(i.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{P&&i.sender.send(A.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=S;function M(i,w,p){const n=new v.Menu;return p.forEach(E=>{let P;E.type==="separator"?P=new v.MenuItem({type:E.type}):Array.isArray(E.submenu)?P=new v.MenuItem({submenu:M(i,w,E.submenu),label:E.label}):P=new v.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(b,f,m)=>i.sender.send(w,E.id,m)}),n.append(P)}),n}});var ue=this&&this.__decorate||function(j,e,v,A){var R=arguments.length,S=R<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,v):A,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(j,e,v,A);else for(var i=j.length-1;i>=0;i--)(M=j[i])&&(S=(R<3?M(S):R>3?M(e,v,S):M(e,v))||S);return R>3&&S&&Object.defineProperty(e,v,S),S};define(J[33],Z([0,1,5,2,9,26,18,19,35,13,111,24,46]),function(j,e,v,A,R,S,M,i,w,p,n,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function f(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function D(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(I||(I={}));class o{constructor(T){this.buffer=T,this.pos=0}read(T){const W=this.buffer.slice(this.pos,this.pos+T);return this.pos+=W.byteLength,W}}class c{constructor(){this.buffers=[]}get buffer(){return i.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}var a;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(a||(a={}));function l(_){const T=i.VSBuffer.alloc(4);return T.writeUInt32BE(_,0),T}function t(_){return _.read(4).readUInt32BE(0)}function r(_){const T=i.VSBuffer.alloc(1);return T.writeUInt8(_,0),T}const s={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object)},u=typeof Buffer!="undefined";function h(_,T){if(typeof T=="undefined")_.write(s.Undefined);else if(typeof T=="string"){const W=i.VSBuffer.fromString(T);_.write(s.String),_.write(l(W.byteLength)),_.write(W)}else if(u&&Buffer.isBuffer(T)){const W=i.VSBuffer.wrap(T);_.write(s.Buffer),_.write(l(W.byteLength)),_.write(W)}else if(T instanceof i.VSBuffer)_.write(s.VSBuffer),_.write(l(T.byteLength)),_.write(T);else if(Array.isArray(T)){_.write(s.Array),_.write(l(T.length));for(const W of T)h(_,W)}else{const W=i.VSBuffer.fromString(JSON.stringify(T));_.write(s.Object),_.write(l(W.byteLength)),_.write(W)}}function g(_){switch(_.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return _.read(t(_)).toString();case a.Buffer:return _.read(t(_)).buffer;case a.VSBuffer:return _.read(t(_));case a.Array:{const W=t(_),k=[];for(let F=0;F<W;F++)k.push(g(_));return k}case a.Object:return JSON.parse(_.read(t(_)).toString())}}class d{constructor(T,W,k=null,F=1e3){this.protocol=T,this.ctx=W,this.logger=k,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(U=>this.onRawMessage(U)),this.sendResponse({type:200})}registerChannel(T,W){this.channels.set(T,W),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const W=this.send([T.type]);this.logger&&this.logger.logOutgoing(W,0,1,D(T.type));return}case 201:case 202:case 204:case 203:{const W=this.send([T.type,T.id],T.data);this.logger&&this.logger.logOutgoing(W,T.id,1,D(T.type),T.data);return}}}send(T,W=void 0){const k=new c;return h(k,T),h(k,W),this.sendBuffer(k.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(W){return 0}}onRawMessage(T){const W=new o(T),k=g(W),F=g(W),U=k[0];switch(U){case 100:return this.logger&&this.logger.logIncoming(T.byteLength,k[1],1,`${f(U)}: ${k[2]}.${k[3]}`,F),this.onPromise({type:U,id:k[1],channelName:k[2],name:k[3],arg:F});case 102:return this.logger&&this.logger.logIncoming(T.byteLength,k[1],1,`${f(U)}: ${k[2]}.${k[3]}`,F),this.onEventListen({type:U,id:k[1],channelName:k[2],name:k[3],arg:F});case 101:return this.logger&&this.logger.logIncoming(T.byteLength,k[1],1,`${f(U)}`),this.disposeActiveRequest({type:U,id:k[1]});case 103:return this.logger&&this.logger.logIncoming(T.byteLength,k[1],1,`${f(U)}`),this.disposeActiveRequest({type:U,id:k[1]})}}onPromise(T){const W=this.channels.get(T.channelName);if(!W){this.collectPendingRequest(T);return}const k=new S.CancellationTokenSource;let F;try{F=W.call(this.ctx,T.name,T.arg,k.token)}catch(G){F=Promise.reject(G)}const U=T.id;F.then(G=>{this.sendResponse({id:U,data:G,type:201}),this.activeRequests.delete(T.id)},G=>{G instanceof Error?this.sendResponse({id:U,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:U,data:G,type:203}),this.activeRequests.delete(T.id)});const K=(0,A.toDisposable)(()=>k.cancel());this.activeRequests.set(T.id,K)}onEventListen(T){const W=this.channels.get(T.channelName);if(!W){this.collectPendingRequest(T);return}const k=T.id,U=W.listen(this.ctx,T.name,T.arg)(K=>this.sendResponse({id:k,data:K,type:204}));this.activeRequests.set(T.id,U)}disposeActiveRequest(T){const W=this.activeRequests.get(T.id);W&&(W.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let W=this.pendingRequests.get(T.channelName);W||(W=[],this.pendingRequests.set(T.channelName,W));const k=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:T,timeoutTimer:k})}flushPendingRequests(T){const W=this.pendingRequests.get(T);if(W){for(const k of W)switch(clearTimeout(k.timeoutTimer),k.request.type){case 100:this.onPromise(k.request);break;case 102:this.onEventListen(k.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var y;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(T,W=null){this.protocol=T,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(k=>this.onBuffer(k)),this.logger=W}getChannel(T){const W=this;return{call(k,F,U){return W.isDisposed?Promise.reject(M.canceled()):W.requestPromise(T,k,F,U)},listen(k,F){return W.isDisposed?Promise.reject(M.canceled()):W.requestEvent(T,k,F)}}}requestPromise(T,W,k,F=S.CancellationToken.None){const U=this.lastRequestId++,G={id:U,type:100,channelName:T,name:W,arg:k};if(F.isCancellationRequested)return Promise.reject(M.canceled());let Y;return new Promise((re,se)=>{if(F.isCancellationRequested)return se(M.canceled());const oe=()=>{const we=Se=>{switch(Se.type){case 201:this.handlers.delete(U),re(Se.data);break;case 202:this.handlers.delete(U);const Ae=new Error(Se.data.message);Ae.stack=Se.data.stack,Ae.name=Se.data.name,se(Ae);break;case 203:this.handlers.delete(U),se(Se.data);break}};this.handlers.set(U,we),this.sendRequest(G)};let ne=null;this.state===I.Idle?oe():(ne=(0,R.createCancelablePromise)(we=>this.whenInitialized()),ne.then(()=>{ne=null,oe()}));const le=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:U,type:101}),se(M.canceled())},ve=F.onCancellationRequested(le);Y=(0,A.combinedDisposable)((0,A.toDisposable)(le),ve),this.activeRequests.add(Y)}).finally(()=>{this.activeRequests.delete(Y)})}requestEvent(T,W,k){const F=this.lastRequestId++,K={id:F,type:102,channelName:T,name:W,arg:k};let G=null;const Y=new v.Emitter({onFirstListenerAdd:()=>{G=(0,R.createCancelablePromise)(re=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(Y),this.sendRequest(K)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(Y),this.sendRequest({id:F,type:103}))}}),ee=re=>Y.fire(re.data);return this.handlers.set(F,ee),Y.event}sendRequest(T){switch(T.type){case 100:case 102:{const W=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger&&this.logger.logOutgoing(W,T.id,0,`${f(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const W=this.send([T.type,T.id]);this.logger&&this.logger.logOutgoing(W,T.id,0,f(T.type));return}}}send(T,W=void 0){const k=new c;return h(k,T),h(k,W),this.sendBuffer(k.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(W){return 0}}onBuffer(T){const W=new o(T),k=g(W),F=g(W),U=k[0];switch(U){case 200:return this.logger&&this.logger.logIncoming(T.byteLength,0,0,D(U)),this.onResponse({type:k[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(T.byteLength,k[1],0,D(U),F),this.onResponse({type:k[0],id:k[1],data:F})}}onResponse(T){if(T.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(T.id);W&&W(T)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===I.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}ue([P.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class O{constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:W,onDidClientDisconnect:k})=>{v.Event.once(W.onMessage)(U=>{const K=new o(U),G=g(K),Y=new d(W,G),ee=new L(W);this.channels.forEach((se,oe)=>Y.registerChannel(oe,se));const re={channelServer:Y,channelClient:ee,ctx:G};this._connections.add(re),this._onDidAddConnection.fire(re),k(()=>{Y.dispose(),ee.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const T=[];return this._connections.forEach(W=>T.push(W)),T}getChannel(T,W){const k=this;return{call(F,U,K){let G;if((0,p.isFunction)(W)){let ee=(0,w.getRandomElement)(k.connections.filter(W));G=ee?Promise.resolve(ee):v.Event.toPromise(v.Event.filter(k.onDidAddConnection,W))}else G=W.routeCall(k,F,U);const Y=G.then(ee=>ee.channelClient.getChannel(T));return X(Y).call(F,U,K)},listen(F,U){if((0,p.isFunction)(W))return k.getMulticastEvent(T,W,F,U);const K=W.routeEvent(k,F,U).then(G=>G.channelClient.getChannel(T));return X(K).listen(F,U)}}}getMulticastEvent(T,W,k,F){const U=this;let K=new A.DisposableStore;const G=new v.Emitter({onFirstListenerAdd:()=>{K=new A.DisposableStore;const Y=new v.EventMultiplexer,ee=new Map,re=oe=>{const le=oe.channelClient.getChannel(T).listen(k,F),ve=Y.add(le);ee.set(oe,ve)},se=oe=>{const ne=ee.get(oe);!ne||(ne.dispose(),ee.delete(oe))};U.connections.filter(W).forEach(re),v.Event.filter(U.onDidAddConnection,W)(re,void 0,K),U.onDidRemoveConnection(se,void 0,K),Y.event(G.fire,G,K),K.add(Y)},onLastListenerRemove:()=>{K.dispose()}});return G.event}registerChannel(T,W){this.channels.set(T,W),this._connections.forEach(k=>{k.channelServer.registerChannel(T,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=O;class z{constructor(T,W,k=null){const F=new c;h(F,W),T.send(F.buffer),this.channelClient=new L(T,k),this.channelServer=new d(T,W,k)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,W){this.channelServer.registerChannel(T,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=z;function X(_){return{call(T,W,k){return _.then(F=>F.call(T,W,k))},listen(T,W){const k=new v.Relay;return _.then(F=>k.input=F.listen(T,W)),k.event}}}e.getDelayedChannel=X;function x(_){let T=!1;return{call(W,k,F){return T?_.call(W,k,F):(0,R.timeout)(0).then(()=>T=!0).then(()=>_.call(W,k,F))},listen(W,k){if(T)return _.listen(W,k);const F=new v.Relay;return(0,R.timeout)(0).then(()=>T=!0).then(()=>F.input=_.listen(W,k)),F.event}}}e.getNextTickChannel=x;class H{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const W of T.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await v.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=H;var Q;(function(_){function T(F,U){const K=F,G=U&&U.disableMarshalling,Y=new Map;for(const ee in K)k(ee)&&Y.set(ee,v.Event.buffer(K[ee],!0));return new class{listen(ee,re){const se=Y.get(re);if(se)return se;throw new Error(`Event not found: ${re}`)}call(ee,re,se){const oe=K[re];if(typeof oe=="function"){if(!G&&Array.isArray(se))for(let ne=0;ne<se.length;ne++)se[ne]=(0,n.revive)(se[ne]);return oe.apply(K,se)}throw new Error(`Method not found: ${re}`)}}}_.fromService=T;function W(F,U){const K=U&&U.disableMarshalling;return new Proxy({},{get(G,Y){var ee;if(typeof Y=="string")return((ee=U==null?void 0:U.properties)===null||ee===void 0?void 0:ee.has(Y))?U.properties.get(Y):k(Y)?F.listen(Y):async function(...re){let se;U&&!(0,p.isUndefinedOrNull)(U.context)?se=[U.context,...re]:se=re;const oe=await F.call(Y,se);return K?oe:(0,n.revive)(oe)};throw new Error(`Property not found: ${String(Y)}`)}})}_.toService=W;function k(F){return F[0]==="o"&&F[1]==="n"&&E.isUpperAsciiLetter(F.charCodeAt(2))}})(Q=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){let T=_.toString();if(T!=="[object Object]")return T}return _}function C(_){return Array.isArray(_)?_.map(N):N(_)}function $(_,T,W,k,F,U,K){K=C(K);const G=B[F],Y=G[k%G.length];let ee=[`%c[${_}]%c[${String(T).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(k).padStart(5," ")} - ${U}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(U)?(ee=ee.concat(K),ee.push(")")):ee.push(K),console.log.apply(console,ee)}e.logWithColors=$;class V{constructor(T,W){this._outgoingPrefix=T,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,W,k,F,U){this._totalOutgoing+=T,$(this._outgoingPrefix,this._totalOutgoing,T,W,k,F,U)}logIncoming(T,W,k,F,U){this._totalIncoming+=T,$(this._incomingPrefix,this._totalIncoming,T,W,k,F,U)}}e.IPCLogger=V}),define(J[120],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(R,S){this.sender=R,this.onMessage=S}send(R){try{this.sender.send("vscode:message",R.buffer)}catch(S){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(J[121],Z([0,1,5,33,19]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class S{constructor(w){this.port=w,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",p=>R.VSBuffer.wrap(p.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=S;class M extends A.IPCClient{constructor(w,p){const n=new S(w);super(n,p);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=M}),define(J[85],Z([0,1,5,33,2,19,3,32]),function(j,e,v,A,R,S,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let w=null;function p(){return w||(w=S.VSBuffer.alloc(0)),w}class n{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,u){if(s===0)return p();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const y=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=s),y}if(this._chunks[0].byteLength>s){const y=this._chunks[0].slice(0,s);return u&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),y}let h=S.VSBuffer.alloc(s),g=0,d=0;for(;s>0;){const y=this._chunks[d];if(y.byteLength>s){const L=y.slice(0,s);h.set(L,g),g+=s,u&&(this._chunks[d]=y.slice(s),this._totalLength-=s),s-=s}else h.set(y,g),g+=y.byteLength,u?(this._chunks.shift(),this._totalLength-=y.byteLength):d++,s-=y.byteLength}return h}}e.ChunkStream=n;var E;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(E||(E={}));var P;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(P=e.ProtocolConstants||(e.ProtocolConstants={}));class b{constructor(s,u,h,g){this.type=s,this.id=u,this.ack=h,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends R.Disposable{constructor(s){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new n,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5);else{const h=this._state.messageType,g=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new b(h,g,d,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=S.VSBuffer.alloc(13);u.writeUInt8(s.type,0),u.writeUInt32BE(s.id,1),u.writeUInt32BE(s.ack,5),u.writeUInt32BE(s.data.byteLength,9),this._writeSoon(u,s.data)}}_bufferAdd(s,u){const h=this._totalLength===0;return this._data.push(s,u),this._totalLength+=s.byteLength+u.byteLength,h}_bufferTake(){const s=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,u){this._bufferAdd(s,u)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class D extends R.Disposable{constructor(s){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new b(1,0,0,s))}}e.Protocol=D;class I extends A.IPCClient{constructor(s,u,h=null){super(s,u,h);this.protocol=s}static fromSocket(s,u){return new I(new D(s),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=I;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,i.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class c{constructor(s){this.data=s,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],u=0,h=this._first;for(;h;)s[u++]=h.data,h=h.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const u=new c(s);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class l{constructor(){this.lastRuns=[];const s=Date.now();for(let u=0;u<l._HISTORY_LENGTH;u++)this.lastRuns[u]=s-1e3*u;setInterval(()=>{for(let u=l._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const s=Date.now(),u=(1+l._HISTORY_LENGTH)*1e3;let h=0;for(let g=0;g<l._HISTORY_LENGTH;g++)s-this.lastRuns[g]<=u&&h++;return 1-h/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class t{constructor(s,u=null){this._loadEstimator=l.getInstance(),this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),u&&this._socketReader.acceptChunk(u),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new b(5,0,0,p());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const u=new b(4,0,0,p());this._socketWriter.write(u),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,u){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let u=0,h=s.length;u<h;u++)this._socketWriter.write(s[u]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new b(6,0,0,p())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const u=this._outgoingUnackMsg.toArray();for(let h=0,g=u.length;h<g;h++)this._socketWriter.write(u[h]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new b(1,u,this._incomingAckId,s);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(s){const u=new b(2,0,0,s);this._socketWriter.write(u)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),u=Date.now()-s.writtenTime;if(u>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-u,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new b(3,0,this._incomingAckId,p());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(J[122],Z([0,1,14,5,33,120,2,19]),function(j,e,v,A,R,S,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(n,E){const P=A.Event.fromNodeEventEmitter(v.ipcMain,E,(f,m)=>({event:f,message:m})),b=A.Event.filter(P,({event:f})=>f.sender.id===n);return A.Event.map(b,({message:f})=>f&&i.VSBuffer.wrap(f))}class p extends R.IPCServer{constructor(){super(p.getOnDidClientConnect())}static getOnDidClientConnect(){const E=A.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:P})=>P);return A.Event.map(E,P=>{const b=P.id,f=p.Clients.get(b);f&&f.dispose();const m=new A.Emitter;p.Clients.set(b,(0,M.toDisposable)(()=>m.fire()));const D=w(b,"vscode:message"),I=A.Event.any(A.Event.signal(w(b,"vscode:disconnect")),m.event);return{protocol:new S.Protocol(P,D),onDidClientDisconnect:I}})}}e.Server=p,p.Clients=new Map}),define(J[86],Z([0,1,14,5,28,121]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends S.Client{constructor(p,n){super({addEventListener:(E,P)=>p.addListener(E,P),removeEventListener:(E,P)=>p.removeListener(E,P),postMessage:E=>p.postMessage(E),start:()=>p.start(),close:()=>p.close()},n)}}e.Client=M;async function i(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const p=(0,R.generateUuid)();w.webContents.send("vscode:createMessageChannel",p);const n=A.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(P,b)=>({nonce:b,port:P.ports[0]})),{port:E}=await A.Event.toPromise(A.Event.once(A.Event.filter(n,P=>P.nonce===p)));return E}e.connect=i}),define(J[87],Z([0,1,2,5,9,13]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var M;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));var i;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(i||(i={}));class w extends v.Disposable{constructor(E,P=Object.create(null)){super();this.database=E,this.options=P,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=i.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){var P,b;(P=E.changed)===null||P===void 0||P.forEach((f,m)=>this.accept(m,f)),(b=E.deleted)===null||b===void 0||b.forEach(f=>this.accept(f,void 0))}accept(E,P){if(this.state!==i.Closed){let b=!1;(0,S.isUndefinedOrNull)(P)?b=this.cache.delete(E):this.cache.get(E)!==P&&(this.cache.set(E,P),b=!0),b&&this._onDidChangeStorage.fire(E)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===i.None&&(this.state=i.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,P){const b=this.cache.get(E);return(0,S.isUndefinedOrNull)(b)?P:b}getBoolean(E,P){const b=this.get(E);return(0,S.isUndefinedOrNull)(b)?P:b==="true"}getNumber(E,P){const b=this.get(E);return(0,S.isUndefinedOrNull)(b)?P:parseInt(b,10)}async set(E,P){if(this.state!==i.Closed){if((0,S.isUndefinedOrNull)(P))return this.delete(E);const b=String(P);if(this.cache.get(E)!==b)return this.cache.set(E,b),this.pendingInserts.set(E,b),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(E){if(this.state!==i.Closed&&!!this.cache.delete(E))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=i.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(E){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{var P;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(P=this.whenFlushedCallbacks.pop())===null||P===void 0||P()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert&&E.insert.forEach((P,b)=>this.items.set(b,P)),E.delete&&E.delete.forEach(P=>this.items.delete(P))}async close(){}}e.InMemoryStorageDatabase=p}),define(J[123],Z([0,1,20,5,9,36,8,21]),function(j,e,v,A,R,S,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class w{constructor(E,P=Object.create(null)){this.path=E,this.options=P,this.name=(0,M.basename)(this.path),this.logger=new p(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return A.Event.None}async getItems(){const E=await this.whenConnected,P=new Map;return(await this.all(E,"SELECT * FROM ItemTable")).forEach(f=>P.set(f.key,f.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${P.size} rows`),P}async updateItems(E){const P=await this.whenConnected;return this.doUpdateItems(P,E)}doUpdateItems(E,P){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${P.insert?(0,S.mapToString)(P.insert):"0"}), delete(${P.delete?(0,S.setToString)(P.delete):"0"})`),this.transaction(E,()=>{const b=P.insert,f=P.delete;if(b&&b.size>0){const m=[];m.push([]);let D=0;b.forEach((I,o)=>{let c=m[D];c.length>w.MAX_HOST_PARAMETERS&&(D++,c=[],m.push(c)),c.push(o,I)}),m.forEach(I=>{this.prepare(E,`INSERT INTO ItemTable VALUES ${new Array(I.length/2).fill("(?,?)").join(",")}`,o=>o.run(I),()=>{const o=[];let c=0;return b.forEach((a,l)=>{o.push(l),c+=a.length}),`Keys: ${o.join(", ")} Length: ${c}`})})}if(f&&f.size){const m=[];m.push([]);let D=0;f.forEach(I=>{let o=m[D];o.length>w.MAX_HOST_PARAMETERS&&(D++,o=[],m.push(o)),o.push(I)}),m.forEach(I=>{this.prepare(E,`DELETE FROM ItemTable WHERE key IN (${new Array(I.length).fill("?").join(",")})`,o=>o.run(I),()=>{const o=[];return f.forEach(c=>{o.push(c)}),`Keys: ${o.join(", ")}`})})}})}async close(E){this.logger.trace(`[storage ${this.name}] close()`);const P=await this.whenConnected;return this.doClose(P,E)}doClose(E,P){return new Promise((b,f)=>{E.db.close(m=>(m&&this.handleSQLiteError(E,`[storage ${this.name}] close(): ${m}`),this.path===w.IN_MEMORY_PATH?b():!E.isErroneous&&!E.isInMemory?this.backup().then(b,D=>(this.logger.error(`[storage ${this.name}] backup(): ${D}`),b())):typeof P=="function"?v.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(D=>{const I=()=>this.doClose(D,void 0);return this.doUpdateItems(D,{insert:P()}).then(()=>I(),o=>(I(),Promise.reject(o)))})).then(b,f):f(m||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const E=this.toBackupPath(this.path);return(0,i.copy)(this.path,E,{preserveSymlinks:!1})}toBackupPath(E){return`${E}.backup`}async checkIntegrity(E){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${E})`);const P=await this.whenConnected,b=await this.get(P,E?"PRAGMA integrity_check":"PRAGMA quick_check"),f=E?b.integrity_check:b.quick_check;return P.isErroneous?`${f} (last error: ${P.lastError})`:P.isInMemory?`${f} (in-memory!)`:f}async connect(E,P=!0){this.logger.trace(`[storage ${this.name}] open(${E}, retryOnBusy: ${P})`);try{return await this.doConnect(E)}catch(b){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&P)return await(0,R.timeout)(w.BUSY_OPEN_TIMEOUT),this.connect(E,!1);try{await v.promises.unlink(E);try{await v.promises.rename(this.toBackupPath(E),E)}catch(f){}return await this.doConnect(E)}catch(f){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${f}`),this.doConnect(w.IN_MEMORY_PATH)}}}handleSQLiteError(E,P){E.isErroneous=!0,E.lastError=P,this.logger.error(P)}doConnect(E){return new Promise((P,b)=>{new Promise((f,m)=>{j(["vscode-sqlite3"],f,m)}).then(f=>{const m={db:new(this.logger.isTracing?f.verbose().Database:f.Database)(E,D=>D?m.db?m.db.close(()=>b(D)):b(D):this.exec(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(m),I=>m.db.close(()=>b(I)))),isInMemory:E===w.IN_MEMORY_PATH};m.db.on("error",D=>this.handleSQLiteError(m,`[storage ${this.name}] Error (event): ${D}`)),this.logger.isTracing&&m.db.on("trace",D=>this.logger.trace(`[storage ${this.name}] Trace (event): ${D}`))},b)})}exec(E,P){return new Promise((b,f)=>{E.db.exec(P,m=>m?(this.handleSQLiteError(E,`[storage ${this.name}] exec(): ${m}`),f(m)):b())})}get(E,P){return new Promise((b,f)=>{E.db.get(P,(m,D)=>m?(this.handleSQLiteError(E,`[storage ${this.name}] get(): ${m}`),f(m)):b(D))})}all(E,P){return new Promise((b,f)=>{E.db.all(P,(m,D)=>m?(this.handleSQLiteError(E,`[storage ${this.name}] all(): ${m}`),f(m)):b(D))})}transaction(E,P){return new Promise((b,f)=>{E.db.serialize(()=>{E.db.run("BEGIN TRANSACTION"),P(),E.db.run("END TRANSACTION",m=>m?(this.handleSQLiteError(E,`[storage ${this.name}] transaction(): ${m}`),f(m)):b())})})}prepare(E,P,b,f){const m=E.db.prepare(P),D=I=>{this.handleSQLiteError(E,`[storage ${this.name}] prepare(): ${I} (${P}). Details: ${f()}`)};m.on("error",D),b(m),m.finalize(I=>{I&&D(I),m.removeListener("error",D)})}}e.SQLiteStorageDatabase=w,w.IN_MEMORY_PATH=":memory:",w.BUSY_OPEN_TIMEOUT=2e3,w.MAX_HOST_PARAMETERS=256;class p{constructor(E){E&&typeof E.logTrace=="function"&&process.env[p.VSCODE_TRACE_STORAGE]&&(this.logTrace=E.logTrace),E&&typeof E.logError=="function"&&(this.logError=E.logError)}get isTracing(){return!!this.logTrace}trace(E){this.logTrace&&this.logTrace(E)}error(E){this.logError&&this.logError(E)}}p.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[124],Z([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(J[125],Z([0,1,124]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,R=A*60,S=R*24,M=S*7,i=S*30,w=S*365;function p(E,P){typeof E!="number"&&(E=E.getTime());const b=Math.round((new Date().getTime()-E)/1e3);if(b<-30)return(0,v.localize)(0,null,p(new Date().getTime()+b*1e3,!1));if(b<30)return(0,v.localize)(1,null);let f;return b<A?(f=b,P?f===1?(0,v.localize)(2,null,f):(0,v.localize)(3,null,f):f===1?(0,v.localize)(4,null,f):(0,v.localize)(5,null,f)):b<R?(f=Math.floor(b/A),P?f===1?(0,v.localize)(6,null,f):(0,v.localize)(7,null,f):f===1?(0,v.localize)(8,null,f):(0,v.localize)(9,null,f)):b<S?(f=Math.floor(b/R),P?f===1?(0,v.localize)(10,null,f):(0,v.localize)(11,null,f):f===1?(0,v.localize)(12,null,f):(0,v.localize)(13,null,f)):b<M?(f=Math.floor(b/S),P?f===1?(0,v.localize)(14,null,f):(0,v.localize)(15,null,f):f===1?(0,v.localize)(16,null,f):(0,v.localize)(17,null,f)):b<i?(f=Math.floor(b/M),P?f===1?(0,v.localize)(18,null,f):(0,v.localize)(19,null,f):f===1?(0,v.localize)(20,null,f):(0,v.localize)(21,null,f)):b<w?(f=Math.floor(b/i),P?f===1?(0,v.localize)(22,null,f):(0,v.localize)(23,null,f):f===1?(0,v.localize)(24,null,f):(0,v.localize)(25,null,f)):(f=Math.floor(b/w),P?f===1?(0,v.localize)(26,null,f):(0,v.localize)(27,null,f):f===1?(0,v.localize)(28,null,f):(0,v.localize)(29,null,f))}e.fromNow=p;function n(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(J[126],Z([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(J[67],Z([0,1,126,13,35]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(p,n){return n&&(p.stack||p.stacktrace)?v.localize(0,null,i(p),M(p.stack)||M(p.stacktrace)):i(p)}function M(p){return Array.isArray(p)?p.join(`
`):p}function i(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?v.localize(1,null,p.message):p.message||v.localize(2,null)}function w(p=null,n=!1){if(!p)return v.localize(3,null);if(Array.isArray(p)){const E=R.coalesce(p),P=w(E[0],n);return E.length>1?v.localize(4,null,P,E.length):P}if(A.isString(p))return p;if(p.detail){const E=p.detail;if(E.error)return S(E.error,n);if(E.exception)return S(E.exception,n)}return p.stack?S(p,n):p.message?p.message:v.localize(5,null)}e.toErrorMessage=w}),define(J[127],Z([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(J[128],Z([0,1,127]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class A{constructor(M,i,w=i){this.modifierLabels=[null],this.modifierLabels[2]=M,this.modifierLabels[1]=i,this.modifierLabels[3]=w}toLabel(M,i,w){if(i.length===0)return null;const p=[];for(let n=0,E=i.length;n<E;n++){const P=i[n],b=w(P);if(b===null)return null;p[n]=R(P,b,this.modifierLabels[M])}return p.join(" ")}}e.ModifierLabelProvider=A,e.UILabelProvider=new A({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new A({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new A({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new A({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function R(S,M,i){if(M===null)return"";const w=[];return S.ctrlKey&&w.push(i.ctrlKey),S.shiftKey&&w.push(i.shiftKey),S.altKey&&w.push(i.altKey),S.metaKey&&w.push(i.metaKey),M!==""&&w.push(M),w.join(i.separator)}}),define(J[129],Z([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(J[68],Z([0,1,8,20,21,40,129,32,13,44,30,3,81,10]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function f(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(l,t){if(E.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};t&&(r.cwd=t);const s=S.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],r);return new Promise(u=>{s.once("error",h=>{u({success:!1,error:h})}),s.once("exit",(h,g)=>{u(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?f(r.status):1})}else if(E.isLinux||E.isMacintosh)try{const r=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(s=>{S.execFile(r,[l.pid.toString()],{encoding:"utf8",shell:!0},(u,h,g)=>{s(u?{success:!1,error:u}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function D(l=i.env){return l.comspec||"cmd.exe"}e.getWindowsShell=D;class I{constructor(t,r,s,u){if(r!==void 0&&s!==void 0&&u!==void 0)this.cmd=t,this.args=r,this.shell=s,this.options=u;else{const h=t;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(i.env).forEach(g=>{h[g]=i.env[g]}),Object.keys(this.options.env).forEach(g=>{h[g]=this.options.env[g]}),this.options.env=h}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const r=t.lastIndexOf(v.sep);return r!==-1&&(t=t.substring(r+1)),I.WellKnowCommands[t]?t:"other"}start(t){return E.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(i.cwd()))?Promise.reject(new Error(M.localize(0,null))):this.useExec().then(r=>{let s,u;const h=new Promise((g,d)=>{s=g,u=d});if(r){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=S.exec(g,this.options,(d,y,L)=>{this.childProcess=null;const O=d;O&&O.killed?u({killed:this.terminateRequested,stdout:y.toString(),stderr:L.toString()}):this.handleExec(s,t,d,y,L)})}else{let g=null;const d=y=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(y,s,t,u);const L={terminated:this.terminateRequested};w.isNumber(y)&&(L.cmdCode=y),s(L)};if(this.shell&&E.isWindows){const y=p.deepClone(this.options);y.windowsVerbatimArguments=!0,y.detached=!1;let L=!1,O=!1;const z=[];let X=this.ensureQuotes(this.cmd);z.push(X.value),L=X.quoted,this.args&&this.args.forEach(H=>{X=this.ensureQuotes(H),z.push(X.value),O=O&&X.quoted});const x=["/s","/c"];L?O?x.push('"'+z.join(" ")+'"'):z.length>1?x.push('"'+z[0]+'" '+z.slice(1).join(" ")):x.push('"'+z[0]+'"'):x.push(z.join(" ")),g=S.spawn(D(),x,y)}else this.cmd&&(g=S.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(w.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",y=>{this.childProcess=null,u({terminated:this.terminateRequested,error:y})}),g.pid&&(this.childProcess.on("close",d),this.handleSpawn(g,s,t,u,!0)))}return h})}handleClose(t,r,s,u){}ensureQuotes(t){return I.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,m(t,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!E.isWindows)return t(!1);const r=S.spawn(D(),["/s","/c"]);r.on("error",s=>t(!0)),r.on("exit",s=>t(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class o extends I{constructor(t,r,s,u){super(t,r,s,u);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,r,s,u,h){[u,h].forEach((g,d)=>{const y=new P.LineDecoder;y.write(g).forEach(z=>{r({line:z,source:d===0?0:1})});const O=y.end();O&&r({line:O,source:d===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,r,s,u,h){const g=new P.LineDecoder,d=new P.LineDecoder;t.stdout.on("data",y=>{g.write(y).forEach(O=>s({line:O,source:0}))}),t.stderr.on("data",y=>{d.write(y).forEach(O=>s({line:O,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=d}handleClose(t,r,s,u){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&s({line:h,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&s({line:g,source:1})}}e.LineProcess=o;function c(l){let t=[],r=!1;const s=function(u){if(r){t.push(u);return}(!l.send(u,g=>{if(g&&console.error(g),r=!1,t.length>0){const d=t.slice(0);t=[],d.forEach(y=>s(y))}})||E.isWindows)&&(r=!0)};return{send:s}}e.createQueuedSender=c;var a;(function(l){async function t(r,s,u){if(v.isAbsolute(r))return r;if(s===void 0&&(s=i.cwd()),v.dirname(r)!=="."||(u===void 0&&w.isString(i.env.PATH)&&(u=i.env.PATH.split(v.delimiter)),u===void 0||u.length===0))return v.join(s,r);async function g(d){return await R.exists(d)?!(await A.promises.stat(d)).isDirectory():!1}for(let d of u){let y;if(v.isAbsolute(d)?y=v.join(d,r):y=v.join(s,d,r),await g(y))return y;let L=y+".com";if(await g(L)||(L=y+".exe",await g(L)))return L}return v.join(s,r)}l.findExecutable=t})(a=e.win32||(e.win32={}))}),define(J[130],Z([0,1,27,3,116,68]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(b,f){return b===1?A.isWindows?E():S.getWindowsShell(f):p(b,f)}e.getSystemShell=M;function i(b,f){return b===1?A.isWindows?P(f):S.getWindowsShell(f):p(b,f)}e.getSystemShellSync=i;let w=null;function p(b,f){if(A.isLinux&&b===2||A.isMacintosh&&b===3)return"/bin/bash";if(!w){let m;if(A.isWindows)m="/bin/bash";else{if(m=f.SHELL,!m)try{m=(0,v.userInfo)().shell}catch(D){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}w=m}return w}let n=null;async function E(){return n||(n=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),n}function P(b){if(n)return n;const f=A.isWindows&&parseFloat((0,v.release)())>=10,m=b.hasOwnProperty("PROCESSOR_ARCHITEW6432"),D=`${b.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?D:S.getWindowsShell(b)}}),define(J[88],Z([0,1,40,2,9,44,5,68,33,110,26,18,19,3]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends w.ChannelServer{constructor(I){super({send:o=>{try{process.send&&process.send(o.buffer.toString("base64"))}catch(c){}},onMessage:M.Event.fromNodeEventEmitter(process,"message",o=>P.VSBuffer.wrap(Buffer.from(o,"base64")))},I);process.once("disconnect",()=>this.dispose())}}e.Server=f;class m{constructor(I,o){this.modulePath=I,this.options=o,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new M.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=o&&o.timeout?o.timeout:6e4;this.disposeDelayer=new R.Delayer(c),this.child=null,this._client=null}getChannel(I){const o=this;return{call(c,a,l){return o.requestPromise(I,c,a,l)},listen(c,a){return o.requestEvent(I,c,a)}}}requestPromise(I,o,c,a=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(I),t=(0,R.createCancelablePromise)(u=>l.call(o,c,u)),r=a.onCancellationRequested(()=>t.cancel()),s=(0,A.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{r.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(I,o,c){if(!this.disposeDelayer)return M.Event.None;this.disposeDelayer.cancel();let a;const l=new M.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(I).listen(o,c)(l.fire,l),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const I=this.options&&this.options.args?this.options.args:[],o=Object.create(null);o.env=Object.assign(Object.assign({},(0,S.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(o.env=Object.assign(Object.assign({},o.env),this.options.env)),this.options&&this.options.freshExecArgv&&(o.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),b.isMacintosh&&o.env&&delete o.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,I,o);const c=new M.Emitter;M.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if((0,p.isRemoteConsoleLog)(h)){(0,p.log)(h,`IPC Library: ${this.options.serverName}`);return}c.fire(P.VSBuffer.wrap(Buffer.from(h,"base64")))});const l=this.options.useQueue?(0,i.createQueuedSender)(this.child):this.child,t=h=>this.child&&this.child.connected&&l.send(h.buffer.toString("base64")),r=c.event,s={send:t,onMessage:r};this._client=new w.ChannelClient(s);const u=()=>this.disposeClient();process.once("exit",u),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,g)=>{process.removeListener("exit",u),this.activeRequests.forEach(d=>(0,A.dispose)(d)),this.activeRequests.clear(),h!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:g})})}return this._client}getCachedChannel(I){let o=this.channels.get(I);return o||(o=this.client.getChannel(I),this.channels.set(I,o)),o}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(J[131],Z([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(J[132],Z([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[133],Z([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[134],Z([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(J[135],Z([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(J[136],Z([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[137],Z([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[138],Z([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[139],Z([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(J[140],Z([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(J[141],Z([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(J[142],Z([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[143],Z([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[144],Z([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[145],Z([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[146],Z([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(J[147],Z([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[148],Z([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(J[149],Z([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(J[150],Z([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[151],Z([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(J[152],Z([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[153],Z([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[154],Z([0,1,5,2]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class R{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(i,w,p){switch(w){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:p[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:p[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:p[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:p[0],port:p[1],subId:p[2]}))}throw new Error("Method not implemented.")}listen(i,w,p){switch(w){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=R,R.ChannelName="extensionhostdebugservice";class S extends A.Disposable{constructor(i){super();this.channel=i}reload(i){this.channel.call("reload",[i])}get onReload(){return this.channel.listen("reload")}close(i){this.channel.call("close",[i])}get onClose(){return this.channel.listen("close")}attachSession(i,w,p){this.channel.call("attach",[i,w,p])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(i,w){this.channel.call("terminate",[i,w])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(i,w,p){return this.channel.call("openExtensionDevelopmentHostWindow",[i,w||{},p])}}e.ExtensionHostDebugChannelClient=S}),define(J[155],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(M){this.driver=M}listen(M,i){throw new Error(`No event found: ${i}`)}call(M,i,w){switch(i){case"click":return this.driver.click(w[0],w[1],w[2]);case"doubleClick":return this.driver.doubleClick(w);case"setValue":return this.driver.setValue(w[0],w[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(w);case"getElements":return this.driver.getElements(w[0],w[1]);case"getElementXY":return this.driver.getElementXY(w[0],w[1],w[2]);case"typeInEditor":return this.driver.typeInEditor(w[0],w[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(w);case"writeInTerminal":return this.driver.writeInTerminal(w[0],w[1])}throw new Error(`Call not found: ${i}`)}}e.WindowDriverChannel=v;class A{constructor(M){this.channel=M}click(M,i,w){return this.channel.call("click",[M,i,w])}doubleClick(M){return this.channel.call("doubleClick",M)}setValue(M,i){return this.channel.call("setValue",[M,i])}getTitle(){return this.channel.call("getTitle")}isActiveElement(M){return this.channel.call("isActiveElement",M)}getElements(M,i){return this.channel.call("getElements",[M,i])}getElementXY(M,i,w){return this.channel.call("getElementXY",[M,i,w])}typeInEditor(M,i){return this.channel.call("typeInEditor",[M,i])}getTerminalBuffer(M){return this.channel.call("getTerminalBuffer",M)}writeInTerminal(M,i){return this.channel.call("writeInTerminal",[M,i])}}e.WindowDriverChannelClient=A;class R{constructor(M){this.channel=M}registerWindowDriver(M){return this.channel.call("registerWindowDriver",M)}reloadWindowDriver(M){return this.channel.call("reloadWindowDriver",M)}}e.WindowDriverRegistryChannelClient=R}),define(J[156],Z([0,1,8,15,46,125,10,7,32]),function(j,e,v,A,R,S,M,i,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class p{constructor(f,m,D){this._args=f,this.paths=m,this.productService=D}get appRoot(){return(0,v.dirname)(M.FileAccess.asFileUri("",j).fsPath)}get userHome(){return i.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return i.URI.file((0,v.join)(this.userDataPath,"User"))}get tmpDir(){return i.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,A.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,A.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,v.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return i.URI.file((0,v.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.joinPath)(i.URI.file((0,v.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return i.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return i.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=w.env.VSCODE_PORTABLE;return f?i.URI.file((0,v.join)(f,"argv.json")):(0,A.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,A.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return i.URI.file((0,v.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,v.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,v.resolve)(f):(0,v.normalize)((0,v.join)(M.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const f=this.args["extensions-download-dir"];return f?(0,v.resolve)(f):(0,v.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,v.resolve)(f);const m=w.env.VSCODE_EXTENSIONS;if(m)return m;const D=w.env.VSCODE_PORTABLE;return D?(0,v.join)(D,"extensions"):(0,A.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(m=>/^[^:/?#]+?:\/\//.test(m)?i.URI.parse(m):i.URI.file((0,v.normalize)(m)))}get extensionDevelopmentKind(){var f;return(f=this.args.extensionDevelopmentKind)===null||f===void 0?void 0:f.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?i.URI.parse(f):i.URI.file((0,v.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!w.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,A.joinPath)(i.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return i.URI.file((0,v.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ue([R.memoize],p.prototype,"appRoot",null),ue([R.memoize],p.prototype,"userHome",null),ue([R.memoize],p.prototype,"userDataPath",null),ue([R.memoize],p.prototype,"appSettingsHome",null),ue([R.memoize],p.prototype,"tmpDir",null),ue([R.memoize],p.prototype,"userRoamingDataHome",null),ue([R.memoize],p.prototype,"settingsResource",null),ue([R.memoize],p.prototype,"userDataSyncHome",null),ue([R.memoize],p.prototype,"userDataSyncLogResource",null),ue([R.memoize],p.prototype,"sync",null),ue([R.memoize],p.prototype,"machineSettingsResource",null),ue([R.memoize],p.prototype,"globalStorageHome",null),ue([R.memoize],p.prototype,"workspaceStorageHome",null),ue([R.memoize],p.prototype,"keybindingsResource",null),ue([R.memoize],p.prototype,"keyboardLayoutResource",null),ue([R.memoize],p.prototype,"argvResource",null),ue([R.memoize],p.prototype,"snippetsHome",null),ue([R.memoize],p.prototype,"isExtensionDevelopment",null),ue([R.memoize],p.prototype,"untitledWorkspacesHome",null),ue([R.memoize],p.prototype,"installSourcePath",null),ue([R.memoize],p.prototype,"builtinExtensionsPath",null),ue([R.memoize],p.prototype,"extensionsPath",null),ue([R.memoize],p.prototype,"extensionDevelopmentLocationURI",null),ue([R.memoize],p.prototype,"extensionDevelopmentKind",null),ue([R.memoize],p.prototype,"extensionTestsLocationURI",null),ue([R.memoize],p.prototype,"debugExtensionHost",null),ue([R.memoize],p.prototype,"serviceMachineIdResource",null),ue([R.memoize],p.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=p;function n(b,f){return P(b["inspect-extensions"],b["inspect-brk-extensions"],5870,f,b.debugId)}e.parseExtensionHostPort=n;function E(b,f){return P(b["inspect-search"],b["inspect-brk-search"],5876,f)}e.parseSearchPort=E;function P(b,f,m,D,I){const c=Number(f||b)||(D?null:m),a=c?Boolean(!!f):!1;return{port:c,break:a,debugId:I}}}),define(J[89],Z([0,1,238,134,3]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:(0,A.localize)(0,null),e:(0,A.localize)(1,null),t:(0,A.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,A.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,A.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,A.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,A.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,A.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,A.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,A.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,A.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,A.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,A.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,A.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,A.localize)(14,null)},category:{type:"string",cat:"e",description:(0,A.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,A.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,A.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,A.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,A.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,A.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,A.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,A.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,A.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,A.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,A.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,A.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,A.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,A.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,A.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,A.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,A.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{}};function i(f,m,D=M){const I={},o=[],c=[];for(let r in m){const s=m[r];s.alias&&(I[r]=s.alias),s.type==="string"||s.type==="string[]"?(o.push(r),s.deprecates&&o.push(s.deprecates)):s.type==="boolean"&&(c.push(r),s.deprecates&&c.push(s.deprecates))}const a=v(f,{string:o,boolean:c,alias:I}),l={},t=a;l._=a._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in m){const s=m[r];s.alias&&delete t[s.alias];let u=t[r];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(u||(u=t[s.deprecates]),delete t[s.deprecates]),typeof u!="undefined"&&(s.type==="string[]"?u&&!Array.isArray(u)&&(u=[u]):s.type==="string"&&Array.isArray(u)&&(u=u.pop(),D.onMultipleValues(r,u)),l[r]=u),delete t[r]}for(let r in t)D.onUnknownOption(r);return l}e.parseArgs=i;function w(f,m){let D="";return m.args&&(Array.isArray(m.args)?D=` <${m.args.join("> <")}>`:D=` <${m.args}>`),m.alias?`-${m.alias} --${f}${D}`:`--${f}${D}`}function p(f,m){let D=0,I=[];for(const l in f){const t=f[l],r=w(l,t);D=Math.max(D,r.length),I.push([r,t.description])}let o=D+2+1;if(m-o<25)return I.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let c=m-o-1,a=[];for(const l of I){let t=l[0],r=E(l[1],c),s=n(o-t.length-2);a.push("  "+t+s+r[0]);for(let u=1;u<r.length;u++)a.push(n(o)+r[u])}return a}e.formatOptions=p;function n(f){return" ".repeat(f)}function E(f,m){let D=[];for(;f.length;){let I=f.length<m?f.length:f.lastIndexOf(" ",m),o=f.slice(0,I).trim();f=f.slice(I),D.push(o)}return D}function P(f,m,D,I,o=!0){const c=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${f} ${D}`];a.push(""),a.push(`${(0,A.localize)(32,null)}: ${m} [${(0,A.localize)(33,null)}][${(0,A.localize)(34,null)}...]`),a.push(""),o&&(R.isWindows?a.push((0,A.localize)(35,null,m)):a.push((0,A.localize)(36,null,m)),a.push(""));const l={};for(const t in I){const r=I[t];if(r.description&&r.cat){let s=l[r.cat];s||(l[r.cat]=s={}),s[t]=r}}for(let t in l){const r=t;let s=l[r];s&&(a.push(S[r]),a.push(...p(s,c)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=P;function b(f,m){return`${f||(0,A.localize)(37,null)}
${m||(0,A.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=b}),define(J[157],Z([0,1,89,59,154]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class S extends R.ExtensionHostDebugBroadcastChannel{constructor(i){super();this.windowsMainService=i}call(i,w,p){return w==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(p[0],p[1],p[2]):super.call(i,w,p)}async openExtensionDevelopmentHostWindow(i,w,p){const n=(0,v.parseArgs)(i,v.OPTIONS);n.debugRenderer=p;const E=n.extensionDevelopmentPath;if(!E)return{success:!1};let P;const b=Object.keys(w);for(let c of b){let a=w[c];a===null||(P||(P=Object.create(null)),P[c]=a)}const[f]=this.windowsMainService.openExtensionDevelopmentHostWindow(E,{context:5,cli:n,userEnv:P});if(!p)return{success:!0};const m=f.win;if(!m)return{success:!0};const D=m.webContents.debugger;let I=D.isAttached()?Infinity:0;const o=(0,A.createServer)(c=>{I++==0&&D.attach();let a=!1;const l=s=>{a||c.write(JSON.stringify(s)+"\0")},t=(s,u,h,g)=>l({method:u,params:h,sessionId:g});m.on("close",()=>{D.removeListener("message",t),c.end(),a=!0}),D.addListener("message",t);let r=Buffer.alloc(0);c.on("data",s=>{r=Buffer.concat([r,s]);for(let u=r.indexOf(0);u!==-1;u=r.indexOf(0)){let h;try{const g=r.slice(0,u).toString("utf8");r=r.slice(u+1),h=JSON.parse(g)}catch(g){console.error("error reading cdp line",g)}D.sendCommand(h.method,h.params,h.sessionId).then(g=>l({id:h.id,sessionId:h.sessionId,result:g})).catch(g=>l({id:h.id,sessionId:h.sessionId,error:{code:0,message:g.message}}))}}),c.on("error",s=>{console.error("error on cdp pipe:",s)}),c.on("close",()=>{a=!0,--I==0&&D.detach()})});return await new Promise(c=>o.listen(0,c)),m.on("close",()=>o.close()),{rendererDebugPort:o.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=S}),function(){"use strict";function j(e,v,A,R){function S(i){const w=M(i),p=[w];return e.isAbsolute(w)||p.unshift(R),e.resolve(...p)}function M(i){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");const p=i["user-data-dir"];if(p)return p;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(E,"AppData","Roaming")}break;case"darwin":n=e.join(v.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,A)}return{getUserDataPath:S}}if(typeof define=="function")define(J[158],Z([0,159,27,10,15,32]),function(e,v,A,R,S,M){const i=S.dirname(R.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(S.joinPath(i,"package.json").fsPath);return j(v,A,w.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),A=require("os");module.exports=j(v,A,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[160],Z([0,1,27,158,156]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends R.AbstractNativeEnvironmentService{constructor(i,w){super(i,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,A.getUserDataPath)(i)},w)}}e.NativeEnvironmentService=S}),define(J[161],Z([0,1,20,27,8]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function S(M){const i=(0,R.join)((0,A.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(i,""),M&&console.log(`Marker file for --wait created: ${i}`),i}catch(w){M&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFile=S}),define(J[162],Z([0,1,137]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(P){return P=P.trim(),P==="*"||A.test(P)}e.isValidVersionStr=S;function M(P){if(!S(P))return null;if(P=P.trim(),P==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=P.match(A);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=M;function i(P){if(!P)return null;let b=P.majorBase,f=P.majorMustEqual,m=P.minorBase,D=P.minorMustEqual,I=P.patchBase,o=P.patchMustEqual;P.hasCaret&&(b===0||(D=!1),o=!1);let c=0;if(P.preRelease){const a=R.exec(P.preRelease);if(a){const[,l,t,r]=a;c=Date.UTC(Number(l),Number(t)-1,Number(r))}}return{majorBase:b,majorMustEqual:f,minorBase:m,minorMustEqual:D,patchBase:I,patchMustEqual:o,isMinimum:P.hasGreaterEquals,notBefore:c}}e.normalizeVersion=i;function w(P,b,f){let m;typeof P=="string"?m=i(M(P)):m=P;let D;b instanceof Date?D=b.getTime():typeof b=="string"&&(D=new Date(b).getTime());let I;if(typeof f=="string"?I=i(M(f)):I=f,!m||!I)return!1;let o=m.majorBase,c=m.minorBase,a=m.patchBase,l=I.majorBase,t=I.minorBase,r=I.patchBase,s=I.notBefore,u=I.majorMustEqual,h=I.minorMustEqual,g=I.patchMustEqual;return I.isMinimum?o>l?!0:o<l?!1:c>t?!0:c<t||D&&D<s?!1:a>=r:(o===1&&l===0&&(!u||!h||!g)&&(l=1,t=0,r=0,u=!0,h=!1,g=!1),o<l?!1:o>l?!u:c<t?!1:c>t?!h:a<r?!1:a>r?!g:!(D&&D<s))}e.isValidVersion=w;function p(P,b,f,m){return f.isBuiltin||typeof f.main=="undefined"?!0:E(P,b,f.engines.vscode,m)}e.isValidExtensionVersion=p;function n(P,b,f){return P==="*"||E(b,f,P)}e.isEngineValid=n;function E(P,b,f,m=[]){let D=i(M(f));if(!D)return m.push(v.localize(0,null,f)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return m.push(v.localize(1,null,f)),!1}else if(!D.majorMustEqual)return m.push(v.localize(2,null,f)),!1;return w(P,b,D)?!0:(m.push(v.localize(3,null,P,f)),!1)}}),define(J[163],Z([0,1,33,88,2,10]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M extends R.Disposable{constructor(w,p,n,E){super();this.folders=w,this.onDidFilesChange=p,this.onLogMessage=n,this.verboseLogging=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new A.Client(S.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=M.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.setFolders(this.folders)}setVerboseLogging(w){this.verboseLogging=w,!this.isDisposed&&this.service&&this.service.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=M,M.MAX_RESTARTS=5}),define(J[164],Z([0,1,33,88,2,10]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M extends R.Disposable{constructor(w,p,n,E,P={}){super();this.folders=w,this.onDidFilesChange=p,this.onLogMessage=n,this.verboseLogging=E,this.watcherOptions=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new A.Client(S.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=M.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(w.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.service.setRoots(this.folders)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${w}`})}setVerboseLogging(w){this.verboseLogging=w,this.service&&this.service.setVerboseLogging(w)}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=M,M.MAX_RESTARTS=5}),define(J[165],Z([0,1,40,81,112,10]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class M{constructor(w,p,n,E,P){this.watchedFolder=w,this.eventCallback=n,this.logCallback=E,this.verboseLogging=P,this.restartCounter=0,Array.isArray(p)?this.ignored=p.map(b=>R.parse(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${w}`),this.startWatcher()}startWatcher(){const w=[this.watchedFolder];this.verboseLogging&&w.push("-verbose"),this.handle=v.spawn(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",j).fsPath,w);const p=new A.LineDecoder;this.handle.stdout.on("data",n=>{const E=[];p.write(n).forEach(P=>{const b=P.split("|");if(b.length===2){const f=Number(b[0]),m=b[1];if(f>=0&&f<3){if(this.ignored&&this.ignored.some(D=>D(m))){this.verboseLogging&&this.log(m);return}E.push({type:M.changeTypeMap[f],path:m})}else this.log(b[1])}}),E.length>0&&this.eventCallback(E)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,E)=>this.onExit(n,E))}onError(w){this.error("process error: "+w.toString())}onExit(w,p){this.handle&&(this.error(`terminated unexpectedly (code: ${w}, signal: ${p})`),this.restartCounter<=M.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(w){this.logCallback({type:"error",message:`[File Watcher (C#)] ${w}`})}log(w){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${w}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=M,M.MAX_RESTARTS=5,M.changeTypeMap=[0,1,2]}),define(J[166],Z([0,1,165,8,24]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S{constructor(i,w,p,n){this.onDidFilesChange=w,this.onLogMessage=p,this.verboseLogging=n,this.service=void 0,this.folder=i[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=(0,R.rtrim)(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,i=>this.onFileEvents(i),i=>this.onLogMessage(i),this.verboseLogging)}setVerboseLogging(i){this.verboseLogging=i,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(i){this.isDisposed||i.length>0&&this.onDidFilesChange(i)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=S}),define(J[69],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(S,M=[],i=!1){this.ctor=S,this.staticArguments=M,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=v;const A=(R,...S)=>new v(R,S);e.createSyncDescriptor=A}),define(J[167],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=v;class A{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let M of this._nodes.values())M.outgoing.size===0&&S.push(M);return S}insertEdge(S,M){const i=this.lookupOrInsertNode(S),w=this.lookupOrInsertNode(M);i.outgoing.set(this._hashFn(M),w),w.incoming.set(this._hashFn(S),i)}removeNode(S){const M=this._hashFn(S);this._nodes.delete(M);for(let i of this._nodes.values())i.outgoing.delete(M),i.incoming.delete(M)}lookupOrInsertNode(S){const M=this._hashFn(S);let i=this._nodes.get(M);return i||(i=new v(S),this._nodes.set(M,i)),i}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[M,i]of this._nodes)S.push(`${M}, (incoming)[${[...i.incoming.keys()].join(", ")}], (outgoing)[${[...i.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,M]of this._nodes){const i=new Set([S]),w=this._findCycle(M,i);if(w)return w}}_findCycle(S,M){for(let[i,w]of S.outgoing){if(M.has(i))return[...M,i].join(" -> ");M.add(i);const p=this._findCycle(w,M);if(p)return p;M.delete(i)}}}e.Graph=A}),define(J[4],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function w(p){return p[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=w})(v=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function A(i,w,p,n){w[v.DI_TARGET]===w?w[v.DI_DEPENDENCIES].push({id:i,index:p,optional:n}):(w[v.DI_DEPENDENCIES]=[{id:i,index:p,optional:n}],w[v.DI_TARGET]=w)}function R(i){if(v.serviceIds.has(i))return v.serviceIds.get(i);const w=function(p,n,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(w,p,E,!1)};return w.toString=()=>i,v.serviceIds.set(i,w),w}e.createDecorator=R;function S(i){return i}e.refineServiceDecorator=S;function M(i){return function(w,p,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");A(i,w,n,!0)}}e.optional=M}),define(J[70],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function A(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=A}),define(J[90],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class A{constructor(S){this.machineId=S}encryption(){return new Promise((S,M)=>j(["vscode-encrypt"],S,M))}async encrypt(S){try{return(await this.encryption()).encrypt(this.machineId,S)}catch(M){return S}}async decrypt(S){try{return(await this.encryption()).decrypt(this.machineId,S)}catch(M){return S}}}e.EncryptionMainService=A}),define(J[53],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(J[168],Z([0,1,136,4,10]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function S(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=S;var M;(function(E){E[E.NoneOrRelevance=0]="NoneOrRelevance",E[E.LastUpdatedDate=1]="LastUpdatedDate",E[E.Title=2]="Title",E[E.PublisherName=3]="PublisherName",E[E.InstallCount=4]="InstallCount",E[E.PublishedDate=5]="PublishedDate",E[E.AverageRating=6]="AverageRating",E[E.WeightedRating=12]="WeightedRating"})(M=e.SortBy||(e.SortBy={}));var i;(function(E){E[E.Default=0]="Default",E[E.Ascending=1]="Ascending",E[E.Descending=2]="Descending"})(i=e.SortOrder||(e.SortOrder={}));var w;(function(E){E.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var p;(function(E){E[E.None=0]="None",E[E.Install=1]="Install",E[E.Update=2]="Update"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(P,b){super(P);this.code=b}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,A.createDecorator)("IExtensionManagementCLIService")}),define(J[169],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(J[170],Z([0,1,24,4]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function R(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));class M{constructor(n){this.value=n,this._lower=n.toLowerCase()}static equals(n,E){if(typeof n=="undefined"||n===null)return typeof E=="undefined"||E===null;if(typeof E=="undefined"||E===null)return!1;if(typeof n=="string"||typeof E=="string"){let P=typeof n=="string"?n:n.value,b=typeof E=="string"?E:E.value;return v.equalsIgnoreCase(P,b)}return n._lower===E._lower}static toKey(n){return typeof n=="string"?n.toLowerCase():n._lower}}e.ExtensionIdentifier=M;function i(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=i;function w(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[171],Z([0,1,24,170]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(b,f){return b.uuid&&f.uuid?b.uuid===f.uuid:b.id===f.id?!0:(0,v.compareIgnoreCase)(b.id,f.id)===0}e.areSameExtensions=R;class S{constructor(f,m){this.version=m,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof S?R(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=S;function M(b,f){return`${b}.${f}`}e.getExtensionId=M;function i(b){return b.toLocaleLowerCase()}e.adoptToGalleryExtensionId=i;function w(b,f){return i(M(b,f))}e.getGalleryExtensionId=w;function p(b,f){const m=[],D=I=>{for(const o of m)if(o.some(c=>R(f(c),f(I))))return o;return null};for(const I of b){const o=D(I);o?o.push(I):m.push([I])}return m}e.groupByExtension=p;function n(b){return{id:b.identifier.id,name:b.manifest.name,galleryId:null,publisherId:b.publisherId,publisherName:b.manifest.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:b.manifest.extensionDependencies&&b.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function E(b){return Object.assign({id:b.identifier.id,name:b.name,galleryId:b.identifier.uuid,publisherId:b.publisherId,publisherName:b.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:!!(b.properties.dependencies&&b.properties.dependencies.length>0)},b.telemetryData)}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function P(b){const f=new Set;for(const m of b)m.malicious&&f.add(m.id.id);return f}e.getMaliciousExtensionsSet=P}),define(J[91],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(J[22],Z([0,1,140,8,7,4,24,13,36]),function(j,e,v,A,R,S,M,i,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function p(B){return B.create===!0}e.isFileOpenForWriteOptions=p;var n;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var E;(function(B){B[B.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var P;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock"})(P=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=b;function f(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=f;function m(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function D(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=D;var I;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class o extends Error{constructor(N,C){super(N);this.code=C}}e.FileSystemProviderError=o;function c(B,N){const C=new o(B.toString(),N);return l(C,N),C}e.createFileSystemProviderError=c;function a(B){return B||c((0,v.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=a;function l(B,N){return B.name=N?`${N} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=l;function t(B){if(!B)return I.Unknown;if(B instanceof o)return B.code;const N=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!N)return I.Unknown;switch(N[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=t;function r(B){if(B instanceof y)return B.fileOperationResult;switch(t(B)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class u{constructor(N,C,$){this.resource=N,this.operation=C,this.target=$}isOperation(N){return this.operation===N}}e.FileOperationEvent=u;var h;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class g{constructor(N,C){this.ignorePathCasing=C,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=N;for(const $ of N)switch($.type){case 1:this.added||(this.added=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set($.resource,$);break}}contains(N,...C){return this.doContains(N,{includeChildren:!1},...C)}affects(N,...C){return this.doContains(N,{includeChildren:!0},...C)}doContains(N,C,...$){var V,_,T,W,k,F;if(!N)return!1;const U=$.length>0;return!!((!U||$.includes(1))&&(((V=this.added)===null||V===void 0?void 0:V.get(N))||C.includeChildren&&((_=this.added)===null||_===void 0?void 0:_.findSuperstr(N)))||(!U||$.includes(0))&&(((T=this.updated)===null||T===void 0?void 0:T.get(N))||C.includeChildren&&((W=this.updated)===null||W===void 0?void 0:W.findSuperstr(N)))||(!U||$.includes(2))&&(((k=this.deleted)===null||k===void 0?void 0:k.findSubstr(N))||C.includeChildren&&((F=this.deleted)===null||F===void 0?void 0:F.findSuperstr(N))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(N){const C=[],$=N===1?this.added:N===0?this.updated:this.deleted;if($)for(const[,V]of $)C.push(V);return C}filter(N){return new g(this.changes.filter(C=>N(C)),this.ignorePathCasing)}}e.FileChangesEvent=g;function d(B,N,C){return!B||!N||B===N||N.length>B.length?!1:(N.charAt(N.length-1)!==A.sep&&(N+=A.sep),C?(0,M.startsWithIgnoreCase)(B,N):B.indexOf(N)===0)}e.isParent=d;class y extends Error{constructor(N,C,$){super(N);this.fileOperationResult=C,this.options=$}static isFileOperationError(N){return N instanceof Error&&!(0,i.isUndefinedOrNull)(N.fileOperationResult)}}e.FileOperationError=y;var L;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(L=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function z(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=z;async function X(B,N){if(!N.canHandleResource(R.URI.from({scheme:B.scheme})))return new Promise(C=>{const $=N.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===B.scheme&&V.added&&($.dispose(),C())})})}e.whenProviderRegistered=X,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(N){return(0,i.isNumber)(N)||(N=0),N<x.KB?(0,v.localize)(1,null,N.toFixed(0)):N<x.MB?(0,v.localize)(2,null,(N/x.KB).toFixed(2)):N<x.GB?(0,v.localize)(3,null,(N/x.MB).toFixed(2)):N<x.TB?(0,v.localize)(4,null,(N/x.GB).toFixed(2)):(0,v.localize)(5,null,(N/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var H;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function Q(B){return{maxFileSize:B===0?300*x.MB:16*x.GB,maxHeapSize:B===0?700*x.MB:2*700*x.MB}}e.getPlatformLimits=Q}),define(J[54],Z([0,1,239,135,22,89]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function M(P,b){const f={onUnknownOption:D=>{console.warn((0,A.localize)(0,null,D))},onMultipleValues:(D,I)=>{console.warn((0,A.localize)(1,null,D,I))}},m=(0,S.parseArgs)(P,S.OPTIONS,b?f:void 0);return m.goto&&m._.forEach(D=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(D),(0,A.localize)(2,null))),m["max-memory"]&&v(parseInt(m["max-memory"])>=R.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${R.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function i(P){const b=P.findIndex(f=>!/^-/.test(f));if(b>-1)return[...P.slice(0,b),...P.slice(b+1)]}function w(P){let[,...b]=P;process.env.VSCODE_DEV&&(b=i(b)||[]);const f=!E(process.env);return M(b,f)}e.parseMainProcessArgv=w;function p(P){const[,,...b]=P;return M(b,!0)}e.parseCLIProcessArgv=p;function n(P,...b){const f=P.indexOf("--");return f===-1?P.push(...b):P.splice(f,0,...b),P}e.addArg=n;function E(P){return P.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(J[92],Z([0,1,159,40,28,3,54,67,130]),function(j,e,v,A,R,S,M,i,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function p(P,b,f){return b["force-disable-user-env"]?(P.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(P.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,M.isLaunchedFromCli)(f)&&!b["force-user-env"]?(P.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,M.isLaunchedFromCli)(f)?P.trace("resolveShellEnv(): running (--force-user-env)"):P.trace("resolveShellEnv(): running (macOS/Linux)"),n||(n=E(P)),n)}e.resolveShellEnv=p;let n;async function E(P){const b=new Promise(async(f,m)=>{const D=process.env.ELECTRON_RUN_AS_NODE;P.trace("getUnixShellEnvironment#runAsNode",D);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;P.trace("getUnixShellEnvironment#noAttach",I);const o=(0,R.generateUuid)().replace(/-/g,"").substr(0,12),c=new RegExp(o+"(.*)"+o),a=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});P.trace("getUnixShellEnvironment#env",a);const l=await(0,w.getSystemShell)(S.OS,a);P.trace("getUnixShellEnvironment#shell",l);const t=v.basename(l);let r,s;/^pwsh(-preview)?$/.test(t)?(r=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,s=["-Login","-Command"]):(r=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,s=["-ilc"]),P.trace("getUnixShellEnvironment#spawn",JSON.stringify(s),r);const u=(0,A.spawn)(l,[...s,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});u.on("error",d=>{P.error("getUnixShellEnvironment#errorChildProcess",(0,i.toErrorMessage)(d)),f({})});const h=[];u.stdout.on("data",d=>h.push(d));const g=[];u.stderr.on("data",d=>g.push(d)),u.on("close",(d,y)=>{const L=Buffer.concat(h).toString("utf8");P.trace("getUnixShellEnvironment#raw",L);const O=Buffer.concat(g).toString("utf8");if(O.trim()&&P.trace("getUnixShellEnvironment#stderr",O),d||y)return m(new Error(`Failed to get environment (code ${d}, signal ${y})`));const z=c.exec(L),X=z?z[1]:"{}";try{const x=JSON.parse(X);D?x.ELECTRON_RUN_AS_NODE=D:delete x.ELECTRON_RUN_AS_NODE,I?x.ELECTRON_NO_ATTACH_CONSOLE=I:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,P.trace("getUnixShellEnvironment#result",x),f(x)}catch(x){P.error("getUnixShellEnvironment#errorCaught",(0,i.toErrorMessage)(x)),m(x)}})});try{return await b}catch(f){return P.error("getUnixShellEnvironment#error",(0,i.toErrorMessage)(f)),{}}}}),define(J[93],Z([0,1,7,22,3]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function S(w){return w.map(p=>({type:p.type,resource:v.URI.file(p.path)}))}e.toFileChanges=S;function M(w){const p=new i;for(const n of w)p.processEvent(n);return p.normalize()}e.normalizeFileChanges=M;class i{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(p){const n=this.mapPathToChange.get(p.path);if(n){const E=n.type,P=p.type;E===1&&P===2?(this.mapPathToChange.delete(p.path),this.normalized.splice(this.normalized.indexOf(n),1)):E===2&&P===1?n.type=0:E===1&&P===0||(n.type=P)}else this.normalized.push(p),this.mapPathToChange.set(p.path,p)}normalize(){const p=[],n=[];return this.normalized.filter(E=>E.type!==2?(p.push(E),!1):!0).sort((E,P)=>E.path.length-P.path.length).filter(E=>n.some(P=>(0,A.isParent)(E.path,P,!R.isLinux))?!1:(n.push(E.path),!0)).concat(p)}}}),define(J[172],Z([0,1,93,2,21,82,117,9,8]),function(j,e,v,A,R,S,M,i,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class p extends A.Disposable{constructor(E,P,b,f){super();this.path=E,this.onDidFilesChange=P,this.onLogMessage=b,this.verboseLogging=f,this.fileChangesDelayer=this._register(new i.ThrottledDelayer(M.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:P}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(P)try{b=await(0,S.realpath)(b)}catch(f){if(this.onError(f),P.dangling)return}E.isDirectory()?this._register((0,M.watchFolder)(b,(f,m)=>{this.onFileChange({type:f==="changed"?0:f==="added"?1:2,path:(0,w.join)(this.path,(0,w.basename)(m))})},f=>this.onError(f))):this._register((0,M.watchFile)(b,f=>{this.onFileChange({type:f==="changed"?0:2,path:this.path})},f=>this.onError(f)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const P=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,v.normalizeFileChanges)(P);this.verboseLogging&&b.forEach(f=>{this.onVerbose(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`)}),b.length>0&&this.onDidFilesChange(b)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=p}),define(J[71],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...R){this._entries=new Map;for(let[S,M]of R)this.set(S,M)}set(R,S){const M=this._entries.get(R);return this._entries.set(R,S),M}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=v}),define(J[173],Z([0,1,18,167,69,4,71,9]),function(j,e,v,A,R,S,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class p extends Error{constructor(f){var m;super("cyclic dependency between services");this.message=(m=f.findCycleSlow())!==null&&m!==void 0?m:`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class n{constructor(f=new M.ServiceCollection,m=!1,D){this._activeInstantiations=new Set,this._services=f,this._strict=m,this._parent=D,this._services.set(S.IInstantiationService,this)}createChild(f){return new n(f,this._strict,this)}invokeFunction(f,...m){let D=P.traceInvocation(f),I=!1;try{return f({get:(c,a)=>{if(I)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(c,D);if(!l&&a!==S.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return l}},...m)}finally{I=!0,D.stop()}}createInstance(f,...m){let D,I;return f instanceof R.SyncDescriptor?(D=P.traceCreation(f.ctor),I=this._createInstance(f.ctor,f.staticArguments.concat(m),D)):(D=P.traceCreation(f),I=this._createInstance(f,m,D)),D.stop(),I}_createInstance(f,m=[],D){let I=S._util.getServiceDependencies(f).sort((a,l)=>a.index-l.index),o=[];for(const a of I){let l=this._getOrCreateServiceInstance(a.id,D);if(!l&&this._strict&&!a.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${a.id}.`);o.push(l)}let c=I.length>0?I[0].index:m.length;if(m.length!==c){console.warn(`[createInstance] First service dependency of ${f.name} at position ${c+1} conflicts with ${m.length} static arguments`);let a=c-m.length;a>0?m=m.concat(new Array(a)):m=m.slice(0,c)}return new f(...[...m,...o])}_setServiceInstance(f,m){if(this._services.get(f)instanceof R.SyncDescriptor)this._services.set(f,m);else if(this._parent)this._parent._setServiceInstance(f,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let m=this._services.get(f);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):m}_getOrCreateServiceInstance(f,m){let D=this._getServiceInstanceOrDescriptor(f);return D instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,D,m.branch(f,!0)):(m.branch(f,!1),D)}_safeCreateAndCacheServiceInstance(f,m,D){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,m,D)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,m,D){const I=new A.Graph(a=>a.id.toString());let o=0;const c=[{id:f,desc:m,_trace:D}];for(;c.length;){const a=c.pop();if(I.lookupOrInsertNode(a),o++>1e3)throw new p(I);for(let l of S._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(l.id);if(!t&&!l.optional&&console.warn(`[createInstance] ${f} depends on ${l.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:l.id,desc:t,_trace:a._trace.branch(l.id,!0)};I.insertEdge(a,r),c.push(r)}}}for(;;){const a=I.roots();if(a.length===0){if(!I.isEmpty())throw new p(I);break}for(const{data:l}of a){if(this._getServiceInstanceOrDescriptor(l.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,r)}I.removeNode(l)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,m,D=[],I,o){if(this._services.get(f)instanceof R.SyncDescriptor)return this._createServiceInstance(m,D,I,o);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,m,D,I,o);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(f,m=[],D,I){if(D){const o=new i.IdleValue(()=>this._createInstance(f,m,I));return new Proxy(Object.create(null),{get(c,a){if(a in c)return c[a];let l=o.value,t=l[a];return typeof t!="function"||(t=t.bind(l),c[a]=t),t},set(c,a,l){return o.value[a]=l,!0}})}else return this._createInstance(f,m,I)}}e.InstantiationService=n;var E;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(E||(E={}));class P{constructor(f,m){this.type=f,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return w?new P(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):P._None}static traceCreation(f){return w?new P(0,f.name):P._None}branch(f,m){let D=new P(2,f.toString());return this._dep.push([f,m,D]),D}stop(){let f=Date.now()-this._start;P._totals+=f;let m=!1;function D(o,c){let a=[],l=new Array(o+1).join("	");for(const[t,r,s]of c._dep)if(r&&s){m=!0,a.push(`${l}CREATES -> ${t}`);let u=D(o+1,s);u&&a.push(u)}else a.push(`${l}uses -> ${t}`);return a.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${P._totals.toFixed(2)}ms)`];(f>2||m)&&console.log(I.join(`
`))}}P._None=new class extends P{constructor(){super(-1,null)}stop(){}branch(){return this}},P._totals=0}),define(J[174],Z([0,1,18,128,57]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class S extends R.ResolvedKeybinding{constructor(i,w){super();if(w.length===0)throw(0,v.illegalArgument)("parts");this._os=i,this._parts=w}getLabel(){return A.UILabelProvider.toLabel(this._os,this._parts,i=>this._getLabel(i))}getAriaLabel(){return A.AriaLabelProvider.toLabel(this._os,this._parts,i=>this._getAriaLabel(i))}getElectronAccelerator(){return this._parts.length>1?null:A.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,i=>this._getElectronAccelerator(i))}getUserSettingsLabel(){return A.UserSettingsLabelProvider.toLabel(this._os,this._parts,i=>this._getUserSettingsLabel(i))}isWYSIWYG(){return this._parts.every(i=>this._isWYSIWYG(i))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(i=>this._getPart(i))}_getPart(i){return new R.ResolvedKeybindingPart(i.ctrlKey,i.shiftKey,i.altKey,i.metaKey,this._getLabel(i),this._getAriaLabel(i))}getDispatchParts(){return this._parts.map(i=>this._getDispatchPart(i))}getSingleModifierDispatchParts(){return this._parts.map(i=>this._getSingleModifierDispatchPart(i))}}e.BaseResolvedKeybinding=S}),define(J[175],Z([0,1,57,174]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class R extends A.BaseResolvedKeybinding{constructor(M,i){super(i,M.parts)}_keyCodeToUILabel(M){if(this._os===2)switch(M){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(M)}_getLabel(M){return M.isDuplicateModifierCase()?"":this._keyCodeToUILabel(M.keyCode)}_getAriaLabel(M){return M.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(M.keyCode)}_keyCodeToElectronAccelerator(M){if(M>=93&&M<=108)return null;switch(M){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return v.KeyCodeUtils.toString(M)}_getElectronAccelerator(M){return M.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(M.keyCode)}_getUserSettingsLabel(M){if(M.isDuplicateModifierCase())return"";const i=v.KeyCodeUtils.toUserSettingsUS(M.keyCode);return i&&i.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(M){return R.getDispatchStr(M)}static getDispatchStr(M){if(M.isModifierKey())return null;let i="";return M.ctrlKey&&(i+="ctrl+"),M.shiftKey&&(i+="shift+"),M.altKey&&(i+="alt+"),M.metaKey&&(i+="meta+"),i+=v.KeyCodeUtils.toString(M.keyCode),i}_getSingleModifierDispatchPart(M){return M.keyCode===5&&!M.shiftKey&&!M.altKey&&!M.metaKey?"ctrl":M.keyCode===4&&!M.ctrlKey&&!M.altKey&&!M.metaKey?"shift":M.keyCode===6&&!M.ctrlKey&&!M.shiftKey&&!M.metaKey?"alt":M.keyCode===57&&!M.ctrlKey&&!M.shiftKey&&!M.altKey?"meta":null}}e.USLayoutResolvedKeybinding=R}),define(J[176],Z([0,1,9]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function A(R,S){if(R.length===0)return Promise.resolve(!1);const M=[];let i=!1;for(let w of R){if(w===!0)return Promise.resolve(!0);(0,v.isThenable)(w)&&M.push(w.then(p=>{p&&(i=!0)},p=>{S(p),i=!0}))}return v.Promises.settled(M).then(()=>i)}e.handleVetos=A}),define(J[6],Z([0,1,4,2,3,5,67]),function(j,e,v,A,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function i(){return new Date().toISOString()}var w;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class p extends A.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=p;class n extends p{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(w.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(w.Error,this.format(s))}else this.log(w.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let u=t[s];if(typeof u=="object")try{u=JSON.stringify(u)}catch(h){}r+=(s>0?" ":"")+u}return r}}e.AbstractMessageLogger=n;class E extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!R.isWindows}trace(t,...r){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${i()}][0m`,t,...r):console.log(`[main ${i()}]`,t,...r))}debug(t,...r){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${i()}][0m`,t,...r):console.log(`[main ${i()}]`,t,...r))}info(t,...r){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${i()}][0m`,t,...r):console.log(`[main ${i()}]`,t,...r))}warn(t,...r){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${i()}][0m`,t,...r):console.warn(`[main ${i()}]`,t,...r))}error(t,...r){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${i()}][0m`,t,...r):console.error(`[main ${i()}]`,t,...r))}critical(t,...r){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${i()}][0m`,t,...r):console.error(`[main ${i()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class P extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=P;class b extends p{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,M.toErrorMessage)(t,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class f extends p{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=f;class m extends A.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=m;class D extends A.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(s))}))}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(r==null?void 0:r.always)?w.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class I{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return w.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=I;function o(l){if(l.verbose)return w.Trace;if(typeof l.logLevel=="string"){const t=c(l.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function c(l){switch(l){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=c;function a(l){switch(l){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=a}),define(J[94],Z([0,1,6]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function A(S,M){switch(M){case v.LogLevel.Trace:return S.trace;case v.LogLevel.Debug:return S.debug;case v.LogLevel.Info:return S.info;case v.LogLevel.Warning:return S.warn;case v.LogLevel.Error:return S.error;case v.LogLevel.Critical:return S.critical;default:throw new Error("Invalid log level")}}class R extends v.AbstractLogger{constructor(M=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(i=>{this._logger&&this._logger.setLevel(i)}))}set logger(M){this._logger=M;for(const{level:i,args:w}of this.buffer)A(M,i).apply(M,w);this.buffer=[]}_log(M,...i){this._logger?A(this._logger,M).apply(this._logger,i):this.getLevel()<=M&&this.buffer.push({level:M,args:i})}trace(M,...i){this._log(v.LogLevel.Trace,M,...i)}debug(M,...i){this._log(v.LogLevel.Debug,M,...i)}info(M,...i){this._log(v.LogLevel.Info,M,...i)}warn(M,...i){this._log(v.LogLevel.Warning,M,...i)}error(M,...i){this._log(v.LogLevel.Error,M,...i)}critical(M,...i){this._log(v.LogLevel.Critical,M,...i)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=R});var te=this&&this.__param||function(j,e){return function(v,A){e(v,A,j)}};define(J[177],Z([0,1,6,22,9,19,15,4,94]),function(j,e,v,A,R,S,M,i,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const p=5*A.ByteSize.MB;let n=class extends v.AbstractLogger{constructor(b,f,m,D){super();this.name=b,this.resource=f,this.fileService=D,this.backupIndex=1,this.setLevel(m),this.queue=this._register(new R.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=v.LogLevel.Trace&&this._log(v.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=v.LogLevel.Debug&&this._log(v.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=v.LogLevel.Info&&this._log(v.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=v.LogLevel.Warning&&this._log(v.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=v.LogLevel.Error){const b=arguments[0];if(b instanceof Error){const f=Array.prototype.slice.call(arguments);f[0]=b.stack,this._log(v.LogLevel.Error,this.format(f))}else this._log(v.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=v.LogLevel.Critical&&this._log(v.LogLevel.Critical,this.format(arguments))}flush(){}log(b,f){this._log(b,this.format(f))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(b){if(b.fileOperationResult!==3)throw b}}_log(b,f){this.queue.queue(async()=>{await this.initializePromise;let m=await this.loadContent();m.length>p&&(await this.fileService.writeFile(this.getBackupResource(),S.VSBuffer.fromString(m)),m=""),m+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(b)}] ${f}
`,await this.fileService.writeFile(this.resource,S.VSBuffer.fromString(m))})}getCurrentTimestamp(){const b=D=>D<10?`0${D}`:D,f=D=>D<10?`00${D}`:D<100?`0${D}`:D,m=new Date;return`${m.getFullYear()}-${b(m.getMonth()+1)}-${b(m.getDate())} ${b(m.getHours())}:${b(m.getMinutes())}:${b(m.getSeconds())}.${f(m.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,M.joinPath)((0,M.dirname)(this.resource),`${(0,M.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(b){return""}}stringifyLogLevel(b){switch(b){case v.LogLevel.Critical:return"critical";case v.LogLevel.Debug:return"debug";case v.LogLevel.Error:return"error";case v.LogLevel.Info:return"info";case v.LogLevel.Trace:return"trace";case v.LogLevel.Warning:return"warning"}return""}format(b){let f="";for(let m=0;m<b.length;m++){let D=b[m];if(typeof D=="object")try{D=JSON.stringify(D)}catch(I){}f+=(m>0?" ":"")+D}return f}};n=ue([te(3,A.IFileService)],n),e.FileLogger=n;let E=class extends v.AbstractLoggerService{constructor(b,f,m){super(b.getLevel(),b.onDidChangeLogLevel);this.instantiationService=f,this.fileService=m}doCreateLogger(b,f){const m=new w.BufferLogService(f);return(0,A.whenProviderRegistered)(b,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(n,(0,M.basename)(b),b,m.getLevel())),m}};E=ue([te(0,v.ILogService),te(1,i.IInstantiationService),te(2,A.IFileService)],E),e.FileLoggerService=E}),define(J[178],Z([0,1,6,5,7]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(P){this.service=P,this.onDidChangeLogLevel=A.Event.buffer(P.onDidChangeLogLevel,!0)}listen(P,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(P,b,f){switch(b){case"setLevel":return this.service.setLevel(f)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=S;class M{constructor(P){this.channel=P}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(P){M.setLevel(this.channel,P)}static setLevel(P,b){return P.call("setLevel",b)}}e.LogLevelChannelClient=M;class i{constructor(P){this.loggerService=P,this.loggers=new Map}listen(P,b){throw new Error(`Event not found: ${b}`)}async call(P,b,f){switch(b){case"createLogger":this.createLogger(R.URI.revive(f[0]),f[1]);return;case"log":return this.log(R.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${b}`)}createLogger(P,b){this.loggers.set(P.toString(),this.loggerService.createLogger(P,b))}consoleLog(P,b){let f=console.log;switch(P){case v.LogLevel.Error:f=console.error;break;case v.LogLevel.Warning:f=console.warn;break;case v.LogLevel.Info:f=console.info;break}f.call(console,...b)}log(P,b){const f=this.loggers.get(P.toString());if(!f)throw new Error("Create the logger before logging");for(const[m,D]of b)switch(m){case v.LogLevel.Trace:f.trace(D);break;case v.LogLevel.Debug:f.debug(D);break;case v.LogLevel.Info:f.info(D);break;case v.LogLevel.Warning:f.warn(D);break;case v.LogLevel.Error:f.error(D);break;case v.LogLevel.Critical:f.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=i;class w extends v.AbstractLoggerService{constructor(P,b,f){super(P,b);this.channel=f}createConsoleMainLogger(){return new v.AdapterLogger({log:(P,b)=>{this.channel.call("consoleLog",[P,b])}})}doCreateLogger(P,b,f){return new p(this.channel,P,b,f)}}e.LoggerChannelClient=w;class p extends v.AbstractMessageLogger{constructor(P,b,f,m){super(m==null?void 0:m.always);this.channel=P,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[b,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(P,b){const f=[[P,b]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(P){this.channel.call("log",[this.file,P])}}class n extends v.LogService{constructor(P,b){super(b);this.parent=P,this._register(P.onDidChangeLogLevel(f=>b.setLevel(f)))}setLevel(P){super.setLevel(P),this.parent.setLevel(P)}}e.FollowerLogService=n}),define(J[95],Z([0,1,6,22]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function R(w,p,n,E){try{return(await new Promise((b,f)=>{j(["spdlog"],b,f)})).createAsyncRotatingLogger(w,p,n,E)}catch(P){console.error(P)}return null}function S(w,p,n,E){return j.__$__nodeRequire("spdlog").createRotatingLogger(w,p,n,E)}e.createRotatingLogger=S;function M(w,p,n){switch(p){case v.LogLevel.Trace:w.trace(n);break;case v.LogLevel.Debug:w.debug(n);break;case v.LogLevel.Info:w.info(n);break;case v.LogLevel.Warning:w.warn(n);break;case v.LogLevel.Error:w.error(n);break;case v.LogLevel.Critical:w.critical(n);break;default:throw new Error("Invalid log level")}w.flush()}class i extends v.AbstractMessageLogger{constructor(p,n,E,P){super();this.name=p,this.filepath=n,this.rotating=E,this.buffer=[],this.setLevel(P),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}_createSpdLogLogger(){const p=this.rotating?6:1,n=30/p*A.ByteSize.MB;return R(this.name,this.filepath,n,p).then(E=>{if(E){this._logger=E,this._logger.setLevel(this.getLevel());for(const{level:P,message:b}of this.buffer)M(this._logger,P,b);this.buffer=[]}})}log(p,n){this._logger?M(this._logger,p,n):this.getLevel()<=p&&this.buffer.push({level:p,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=i}),define(J[179],Z([0,1,6,15,10,177,95,22,28]),function(j,e,v,A,R,S,M,i,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let p=class extends v.AbstractLoggerService{constructor(E,P){super(E.getLevel(),E.onDidChangeLogLevel);this.fileService=P}doCreateLogger(E,P,b){var f;if(E.scheme===R.Schemas.file){const m=new M.SpdLogLogger((b==null?void 0:b.name)||(0,w.generateUuid)(),E.fsPath,!(b==null?void 0:b.donotRotate),P);return(b==null?void 0:b.donotUseFormatters)&&m.clearFormatters(),m}else return new S.FileLogger((f=b==null?void 0:b.name)!==null&&f!==void 0?f:(0,A.basename)(E),E,P,this.fileService)}};p=ue([te(0,v.ILogService),te(1,i.IFileService)],p),e.LoggerService=p}),define(J[180],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function A(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=A;function R(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=R;function S(M){return!v(M)&&!A(M)&&!R(M)}e.isMenubarMenuItemAction=S}),define(J[47],Z([0,1,10,3,32,15]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof A.globals.vscode!="undefined"&&typeof A.globals.vscode.context!="undefined"){const i=A.globals.vscode.context.configuration();if(i)M=i.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(j==null?void 0:j.__$__nodeRequire)=="function"){const i=(0,S.dirname)(v.FileAccess.asFileUri("",j));M=j.__$__nodeRequire((0,S.joinPath)(i,"product.json").fsPath);const w=j.__$__nodeRequire((0,S.joinPath)(i,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`}),Object.assign(M,{version:w.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.57.0-dev",nameShort:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=M}),define(J[96],Z([0,1,141,19,22,18,47]),function(j,e,v,A,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function i(E,P,b,f,m,D){let I;try{await w(E,P,b,f,m,D)}catch(o){I=o}finally{I&&m.errorTransformer&&(I=m.errorTransformer(I)),typeof I!="undefined"&&b.error(I),b.end()}}e.readFileIntoStream=i;async function w(E,P,b,f,m,D){p(D);const I=await E.open(P,{create:!1});try{p(D);let o=0,c=0,a=m&&typeof m.length=="number"?m.length:void 0,l=A.VSBuffer.alloc(Math.min(m.bufferSize,typeof a=="number"?a:m.bufferSize)),t=m&&typeof m.position=="number"?m.position:0,r=0;do c=await E.read(I,t,l.buffer,r,l.byteLength-r),t+=c,r+=c,o+=c,typeof a=="number"&&(a-=c),r===l.byteLength&&(await b.write(f(l)),l=A.VSBuffer.alloc(Math.min(m.bufferSize,typeof a=="number"?a:m.bufferSize)),r=0);while(c>0&&(typeof a!="number"||a>0)&&p(D)&&n(o,m));if(r>0){let s=r;typeof a=="number"&&(s=Math.min(r,a)),b.write(f(l.slice(0,s)))}}catch(o){throw(0,R.ensureFileSystemProviderError)(o)}finally{await E.close(I)}}function p(E){if(E.isCancellationRequested)throw(0,S.canceled)();return!0}function n(E,P){if(P==null?void 0:P.limits){if(typeof P.limits.memory=="number"&&E>P.limits.memory)throw(0,R.createFileSystemProviderError)((0,v.localize)(0,null,M.default.nameShort),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&E>P.limits.size)throw(0,R.createFileSystemProviderError)((0,v.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[181],Z([0,1,139,72,2,22,5,15,36,35,6,19,64,9,26,10,96,63]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let o=class extends R.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new M.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(a,l){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,A.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:l});const t=new R.DisposableStore;return t.add(l.onDidChangeFile(r=>this._onDidFilesChange.fire(new S.FileChangesEvent(r,!this.isPathCaseSensitive(l))))),t.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:a}))),typeof l.onDidErrorOccur=="function"&&t.add(l.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,R.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:l}),this.provider.delete(a),(0,R.dispose)(t)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(t){l.push(t)}}),!this.provider.has(a)&&await b.Promises.settled(l)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,l){const t=this.provider.get(a.scheme);return!!(t&&t.capabilities&l)}listCapabilities(){return I.Iterable.map(this.provider,([a,l])=>({scheme:a,capabilities:l.capabilities}))}async withProvider(a){if(!(0,i.isAbsolutePath)(a))throw new S.FileOperationError((0,v.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const l=this.provider.get(a.scheme);if(!l){const t=new Error;throw t.name="ENOPRO",t.message=(0,v.localize)(1,null,a.toString()),t}return l}async withReadProvider(a){const l=await this.withProvider(a);if((0,S.hasOpenReadWriteCloseCapability)(l)||(0,S.hasReadWriteCapability)(l)||(0,S.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const l=await this.withProvider(a);if((0,S.hasOpenReadWriteCloseCapability)(l)||(0,S.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,l){try{return await this.doResolveFile(a,l)}catch(t){throw(0,S.toFileSystemProviderErrorCode)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,v.localize)(2,null,this.resourceForError(a)),1):(0,S.ensureFileSystemProviderError)(t)}}async doResolveFile(a,l){const t=await this.withProvider(a),r=this.isPathCaseSensitive(t),s=l==null?void 0:l.resolveTo,u=l==null?void 0:l.resolveSingleChildDescendants,h=l==null?void 0:l.resolveMetadata,g=await t.stat(a);let d;return this.toFileStat(t,a,g,void 0,!!h,(y,L)=>(d||(d=w.TernarySearchTree.forUris(()=>!r),d.set(a,!0),(0,p.isNonEmptyArray)(s)&&s.forEach(O=>d.set(O,!0))),Boolean(d.findSuperstr(y.resource)||d.get(y.resource))?!0:y.isDirectory&&u?L===1:!1))}async toFileStat(a,l,t,r,s,u){var h;const{providerExtUri:g}=this.getExtUri(a),d={resource:l,name:g.basename(l),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((h=t.permissions)!==null&&h!==void 0?h:0)&S.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,S.etag)({mtime:t.mtime,size:t.size})};if(d.isDirectory&&u(d,r)){try{const y=await a.readdir(l),L=await b.Promises.settled(y.map(async([O,z])=>{try{const X=g.joinPath(l,O),x=s?await a.stat(X):{type:z};return await this.toFileStat(a,X,x,y.length,s,u)}catch(X){return this.logService.trace(X),null}}));d.children=(0,p.coalesce)(L)}catch(y){this.logService.trace(y),d.children=[]}return d}return d}async resolveAll(a){return b.Promises.settled(a.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(a){const l=await this.withProvider(a);try{return!!await l.stat(a)}catch(t){return!1}}async canCreateFile(a,l){try{await this.doValidateCreateFile(a,l)}catch(t){return t}return!0}async doValidateCreateFile(a,l){if(!(l==null?void 0:l.overwrite)&&await this.exists(a))throw new S.FileOperationError((0,v.localize)(3,null,this.resourceForError(a)),3,l)}async createFile(a,l=E.VSBuffer.fromString(""),t){await this.doValidateCreateFile(a,t);const r=await this.writeFile(a,l);return this._onDidRunOperation.fire(new S.FileOperationEvent(a,0,r)),r}async writeFile(a,l,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:s}=this.getExtUri(r);try{await this.validateWriteFile(r,a,t)||await this.mkdirp(r,s.dirname(a));let h;if((0,S.hasReadWriteCapability)(r)&&!(l instanceof E.VSBuffer))if((0,P.isReadableStream)(l)){const g=await(0,P.peekStream)(l,3);g.ended?h=E.VSBuffer.concat(g.buffer):h=g}else h=(0,P.peekReadable)(l,g=>E.VSBuffer.concat(g),3);else h=l;!(0,S.hasOpenReadWriteCloseCapability)(r)||(0,S.hasReadWriteCapability)(r)&&h instanceof E.VSBuffer?await this.doWriteUnbuffered(r,a,t,h):await this.doWriteBuffered(r,a,t,h instanceof E.VSBuffer?(0,E.bufferToReadable)(h):h)}catch(u){throw new S.FileOperationError((0,v.localize)(4,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(u).toString()),(0,S.toFileOperationResult)(u),t)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,l,t){if(!!(t==null?void 0:t.unlock)&&!(a.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(l)));let s;try{s=await a.stat(l)}catch(u){return}if((s.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,v.localize)(6,null,this.resourceForError(l)),0,t);if(this.throwIfFileIsReadonly(l,s),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,S.etag)({mtime:t.mtime,size:s.size}))throw new S.FileOperationError((0,v.localize)(7,null),3,t);return s}async readFile(a,l){const t=await this.withReadProvider(a);return(l==null?void 0:l.atomic)?this.doReadFileAtomic(t,a,l):this.doReadFile(t,a,l)}async doReadFileAtomic(a,l,t){return new Promise((r,s)=>{this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(a,l,t);r(u)}catch(u){s(u)}})})}async doReadFile(a,l,t){const r=await this.doReadFileStream(a,l,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await(0,E.streamToBuffer)(r.value)})}async readFileStream(a,l){const t=await this.withReadProvider(a);return this.doReadFileStream(t,a,l)}async doReadFileStream(a,l,t){const r=new f.CancellationTokenSource,s=this.validateReadFile(l,t).then(h=>h,h=>{throw r.cancel(),h});let u;try{t&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await s,!((0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasFileReadStreamCapability)(a))||(0,S.hasReadWriteCapability)(a)&&(t==null?void 0:t.preferUnbuffered)?u=this.readFileUnbuffered(a,l,t):(0,S.hasFileReadStreamCapability)(a)?u=this.readFileStreamed(a,l,r.token,t):u=this.readFileBuffered(a,l,r.token,t);const h=await s;return Object.assign(Object.assign({},h),{value:u})}catch(h){throw u&&await(0,P.consumeStream)(u),new S.FileOperationError((0,v.localize)(8,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(h).toString()),(0,S.toFileOperationResult)(h),t)}}readFileStreamed(a,l,t,r=Object.create(null)){const s=a.readFileStream(l,r,t);return(0,P.transform)(s,{data:u=>u instanceof E.VSBuffer?u:E.VSBuffer.wrap(u),error:u=>new S.FileOperationError((0,v.localize)(9,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(u).toString()),(0,S.toFileOperationResult)(u),r)},u=>E.VSBuffer.concat(u))}readFileBuffered(a,l,t,r=Object.create(null)){const s=(0,E.newWriteableBufferStream)();return(0,D.readFileIntoStream)(a,l,s,u=>u,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:u=>new S.FileOperationError((0,v.localize)(10,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(u).toString()),(0,S.toFileOperationResult)(u),r)}),t),s}readFileUnbuffered(a,l,t){const r=(0,P.newWriteableStream)(s=>E.VSBuffer.concat(s));return(async()=>{try{let s=await a.readFile(l);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(l,s.byteLength,t),r.end(E.VSBuffer.wrap(s))}catch(s){r.error(s),r.end()}})(),r}async validateReadFile(a,l){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError((0,v.localize)(11,null,this.resourceForError(a)),0,l);if(l&&typeof l.etag=="string"&&l.etag!==S.ETAG_DISABLED&&l.etag===t.etag)throw new S.FileOperationError((0,v.localize)(12,null),2,l);return this.validateReadFileLimits(a,t.size,l),t}validateReadFileLimits(a,l,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&l>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&l>t.limits.size&&(r=7),typeof r=="number")throw new S.FileOperationError((0,v.localize)(13,null,this.resourceForError(a)),r)}}async canMove(a,l,t){return this.doCanMoveCopy(a,l,"move",t)}async canCopy(a,l,t){return this.doCanMoveCopy(a,l,"copy",t)}async doCanMoveCopy(a,l,t,r){if(a.toString()!==l.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(s,a,u,l,t,r)}catch(s){return s}return!0}async move(a,l,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),u=await this.doMoveCopy(r,a,s,l,"move",!!t),h=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(a,u==="move"?2:3,h)),h}async copy(a,l,t){const r=await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),u=await this.doMoveCopy(r,a,s,l,"copy",!!t),h=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(a,u==="copy"?3:2,h)),h}async doMoveCopy(a,l,t,r,s,u){if(l.toString()===r.toString())return s;const{exists:h,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(a,l,t,r,s,u);if(h&&!g&&u&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),s==="copy"){if(a===t&&(0,S.hasFileFolderCopyCapability)(a))await a.copy(l,r,{overwrite:u});else{const d=await this.resolve(l);d.isDirectory?await this.doCopyFolder(a,d,t,r):await this.doCopyFile(a,l,t,r)}return s}else return a===t?(await a.rename(l,r,{overwrite:u}),s):(await this.doMoveCopy(a,l,t,r,"copy",u),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(a,l,t,r){if((0,S.hasOpenReadWriteCloseCapability)(a)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(a,l,t,r);if((0,S.hasOpenReadWriteCloseCapability)(a)&&(0,S.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(a,l,t,r);if((0,S.hasReadWriteCapability)(a)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(a,l,t,r);if((0,S.hasReadWriteCapability)(a)&&(0,S.hasReadWriteCapability)(t))return this.doPipeUnbuffered(a,l,t,r)}async doCopyFolder(a,l,t,r){await t.mkdir(r),Array.isArray(l.children)&&await b.Promises.settled(l.children.map(async s=>{const u=this.getExtUri(t).providerExtUri.joinPath(r,s.name);return s.isDirectory?this.doCopyFolder(a,await this.resolve(s.resource),t,u):this.doCopyFile(a,s.resource,t,u)}))}async doValidateMoveCopy(a,l,t,r,s,u){let h=!1;if(a===t){const{providerExtUri:d,isPathCaseSensitive:y}=this.getExtUri(a);if(y||(h=d.isEqual(l,r)),h&&s==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(l),this.resourceForError(r)));if(!h&&d.isEqualOrParent(r,l))throw new Error((0,v.localize)(15,null,this.resourceForError(l),this.resourceForError(r)))}const g=await this.exists(r);if(g&&!h){if(!u)throw new S.FileOperationError((0,v.localize)(16,null,this.resourceForError(l),this.resourceForError(r)),4);if(a===t){const{providerExtUri:d}=this.getExtUri(a);if(d.isEqualOrParent(l,r))throw new Error((0,v.localize)(17,null,this.resourceForError(l),this.resourceForError(r)))}}return{exists:g,isSameResourceWithDifferentPathCase:h}}getExtUri(a){const l=this.isPathCaseSensitive(a);return{providerExtUri:l?i.extUri:i.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(l,a);const t=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(a,0,t)),t}async mkdirp(a,l){const t=[],{providerExtUri:r}=this.getExtUri(a);for(;!r.isEqual(l,r.dirname(l));)try{if(((await a.stat(l)).type&S.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(l)));break}catch(s){if((0,S.toFileSystemProviderErrorCode)(s)!==S.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(r.basename(l)),l=r.dirname(l)}for(let s=t.length-1;s>=0;s--){l=r.joinPath(l,t[s]);try{await a.mkdir(l)}catch(u){if((0,S.toFileSystemProviderErrorCode)(u)!==S.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(a,l){try{await this.doValidateDelete(a,l)}catch(t){return t}return!0}async doValidateDelete(a,l){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!(l==null?void 0:l.useTrash)&&!(t.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(a)));let s;try{s=await t.stat(a)}catch(h){}if(s)this.throwIfFileIsReadonly(a,s);else throw new S.FileOperationError((0,v.localize)(20,null,this.resourceForError(a)),1);if(!!!(l==null?void 0:l.recursive)){const h=await this.resolve(a);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(a)))}return t}async del(a,l){const t=await this.doValidateDelete(a,l),r=!!(l==null?void 0:l.useTrash),s=!!(l==null?void 0:l.recursive);await t.delete(a,{recursive:s,useTrash:r}),this._onDidRunOperation.fire(new S.FileOperationEvent(a,1))}watch(a,l={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(a,l).then(s=>{t?(0,R.dispose)(s):r=()=>(0,R.dispose)(s)},s=>this.logService.error(s)),(0,R.toDisposable)(()=>r())}async doWatch(a,l){const t=await this.withProvider(a),r=this.toWatchKey(t,a,l),s=this.activeWatchers.get(r)||{count:0,disposable:t.watch(a,l)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,s),s.count+=1,(0,R.toDisposable)(()=>{s.count--,s.count===0&&((0,R.dispose)(s.disposable),this.activeWatchers.delete(r))})}toWatchKey(a,l,t){const{providerExtUri:r}=this.getExtUri(a);return[r.getComparisonKey(l),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(a=>(0,R.dispose)(a.disposable)),this.activeWatchers.clear()}async doWriteBuffered(a,l,t,r){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{var s;const u=await a.open(l,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{(0,P.isReadableStream)(r)||(0,P.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(a,u,r):await this.doWriteReadableBufferedQueued(a,u,r)}catch(h){throw(0,S.ensureFileSystemProviderError)(h)}finally{await a.close(u)}})}async doWriteStreamBufferedQueued(a,l,t){let r=0,s;if((0,P.isReadableBufferedStream)(t)){if(t.buffer.length>0){const u=E.VSBuffer.concat(t.buffer);await this.doWriteBuffer(a,l,u,u.byteLength,r,0),r+=u.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(u,h)=>{(0,P.listenStream)(s,{onData:async g=>{s.pause();try{await this.doWriteBuffer(a,l,g,g.byteLength,r,0)}catch(d){return h(d)}r+=g.byteLength,setTimeout(()=>s.resume())},onError:g=>h(g),onEnd:()=>u()})})}async doWriteReadableBufferedQueued(a,l,t){let r=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(a,l,s,s.byteLength,r,0),r+=s.byteLength}async doWriteBuffer(a,l,t,r,s,u){let h=0;for(;h<r;)h+=await a.write(l,s+h,t.buffer,u+h,r-h)}async doWriteUnbuffered(a,l,t,r){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,l,t,r))}async doWriteUnbufferedQueued(a,l,t,r){var s;let u;r instanceof E.VSBuffer?u=r:(0,P.isReadableStream)(r)?u=await(0,E.streamToBuffer)(r):(0,P.isReadableBufferedStream)(r)?u=await(0,E.bufferedStreamToBuffer)(r):u=(0,E.readableToBuffer)(r),await a.writeFile(l,u.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(a,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,l,t,r))}async doPipeBufferedQueued(a,l,t,r){let s,u;try{s=await a.open(l,{create:!1}),u=await t.open(r,{create:!0,unlock:!1});const h=E.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,d=0,y=0;do y=await a.read(s,g,h.buffer,d,h.byteLength-d),await this.doWriteBuffer(t,u,h,y,g,d),g+=y,d+=y,d===h.byteLength&&(d=0);while(y>0)}catch(h){throw(0,S.ensureFileSystemProviderError)(h)}finally{await b.Promises.settled([typeof s=="number"?a.close(s):Promise.resolve(),typeof u=="number"?t.close(u):Promise.resolve()])}}async doPipeUnbuffered(a,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,l,t,r))}async doPipeUnbufferedQueued(a,l,t,r){return t.writeFile(r,await a.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,l,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,l,t,r))}async doPipeUnbufferedToBufferedQueued(a,l,t,r){const s=await t.open(r,{create:!0,unlock:!1});try{const u=await a.readFile(l);await this.doWriteBuffer(t,s,E.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,S.ensureFileSystemProviderError)(u)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(a,l,t,r){const s=await(0,E.streamToBuffer)(this.readFileBuffered(a,l,f.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,s)}throwIfFileSystemIsReadonly(a,l){if(a.capabilities&2048)throw new S.FileOperationError((0,v.localize)(22,null,this.resourceForError(l)),6);return a}throwIfFileIsReadonly(a,l){var t;if(((t=l.permissions)!==null&&t!==void 0?t:0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,v.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===m.Schemas.file?a.fsPath:a.toString(!0)}};o=ue([te(0,n.ILogService)],o),e.FileService=o}),define(J[182],Z([0,1,20,83,2,22,5,3,21,8,15,30,9,6,142,93,164,166,163,172,64,96,35,19]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D,I,o,c,a,l,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends R.Disposable{constructor(h,g){var d;super();this.logService=h,this.options=g,this.BUFFER_SIZE=((d=this.options)===null||d===void 0?void 0:d.bufferSize)||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new P.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,i.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(h){try{const{stat:g,symbolicLink:d}=await w.SymlinkSupport.stat(this.toFilePath(h));return{type:this.toType(g,d),ctime:g.birthtime.getTime(),mtime:g.mtime.getTime(),size:g.size}}catch(g){throw this.toFileSystemProviderError(g)}}async readdir(h){try{const g=await(0,w.readdir)(this.toFilePath(h),{withFileTypes:!0}),d=[];return await Promise.all(g.map(async y=>{try{let L;y.isSymbolicLink()?L=(await this.stat((0,n.joinPath)(h,y.name))).type:L=this.toType(y),d.push([y.name,L])}catch(L){this.logService.trace(L)}})),d}catch(g){throw this.toFileSystemProviderError(g)}}toType(h,g){let d;return(g==null?void 0:g.dangling)?d=S.FileType.Unknown:h.isFile()?d=S.FileType.File:h.isDirectory()?d=S.FileType.Directory:d=S.FileType.Unknown,g&&(d|=S.FileType.SymbolicLink),d}async readFile(h){try{const g=this.toFilePath(h);return await v.promises.readFile(g)}catch(g){throw this.toFileSystemProviderError(g)}}readFileStream(h,g,d){const y=(0,a.newWriteableStream)(L=>r.VSBuffer.concat(L.map(O=>r.VSBuffer.wrap(O))).buffer);return(0,l.readFileIntoStream)(this,h,y,L=>L.buffer,Object.assign(Object.assign({},g),{bufferSize:this.BUFFER_SIZE}),d),y}async writeFile(h,g,d){let y;try{const L=this.toFilePath(h);if(!d.create||!d.overwrite){if(await(0,w.exists)(L)){if(!d.overwrite)throw(0,S.createFileSystemProviderError)((0,f.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw(0,S.createFileSystemProviderError)((0,f.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}y=await this.open(h,{create:!0,unlock:d.unlock}),await this.write(y,0,g,0,g.byteLength)}catch(L){throw await this.toFileSystemProviderWriteError(h,L)}finally{typeof y=="number"&&await this.close(y)}}async open(h,g){try{const d=this.toFilePath(h);if((0,S.isFileOpenForWriteOptions)(g)&&g.unlock)try{const{stat:O}=await w.SymlinkSupport.stat(d);O.mode&128||await v.promises.chmod(d,O.mode|128)}catch(O){this.logService.trace(O)}let y;if((0,S.isFileOpenForWriteOptions)(g)){if(i.isWindows)try{await v.promises.truncate(d,0),y="r+"}catch(O){O.code!=="ENOENT"&&this.logService.trace(O)}y||(y="w")}else y="r";const L=await(0,A.promisify)(v.open)(d,y);return this.mapHandleToPos.set(L,0),(0,S.isFileOpenForWriteOptions)(g)&&this.writeHandles.set(L,h),L}catch(d){throw(0,S.isFileOpenForWriteOptions)(g)?await this.toFileSystemProviderWriteError(h,d):this.toFileSystemProviderError(d)}}async close(h){try{if(this.mapHandleToPos.delete(h),this.writeHandles.delete(h)&&this.canFlush)try{await(0,A.promisify)(v.fdatasync)(h)}catch(g){this.canFlush=!1,this.logService.error(g)}return await(0,A.promisify)(v.close)(h)}catch(g){throw this.toFileSystemProviderError(g)}}async read(h,g,d,y,L){const O=this.normalizePos(h,g);let z=null;try{const X=await(0,A.promisify)(v.read)(h,d,y,L,O);return typeof X=="number"?z=X:z=X.bytesRead,z}catch(X){throw this.toFileSystemProviderError(X)}finally{this.updatePos(h,O,z)}}normalizePos(h,g){return g===this.mapHandleToPos.get(h)?null:g}updatePos(h,g,d){const y=this.mapHandleToPos.get(h);typeof y=="number"&&(typeof g=="number"||(typeof d=="number"?this.mapHandleToPos.set(h,y+d):this.mapHandleToPos.delete(h)))}async write(h,g,d,y,L){return(0,P.retry)(()=>this.doWrite(h,g,d,y,L),100,3)}async doWrite(h,g,d,y,L){const O=this.normalizePos(h,g);let z=null;try{const X=await(0,A.promisify)(v.write)(h,d,y,L,O);return typeof X=="number"?z=X:z=X.bytesWritten,z}catch(X){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(h),X)}finally{this.updatePos(h,O,z)}}async mkdir(h){try{await v.promises.mkdir(this.toFilePath(h))}catch(g){throw this.toFileSystemProviderError(g)}}async delete(h,g){try{const d=this.toFilePath(h);await this.doDelete(d,g)}catch(d){throw this.toFileSystemProviderError(d)}}async doDelete(h,g){g.recursive?await(0,w.rimraf)(h,w.RimRafMode.MOVE):await v.promises.unlink(h)}async rename(h,g,d){const y=this.toFilePath(h),L=this.toFilePath(g);if(y!==L)try{await this.validateTargetDeleted(h,g,"move",d.overwrite),await(0,w.move)(y,L)}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,f.localize)(2,null,(0,p.basename)(y),(0,p.basename)((0,p.dirname)(L)),O.toString()))),this.toFileSystemProviderError(O)}}async copy(h,g,d){const y=this.toFilePath(h),L=this.toFilePath(g);if(y!==L)try{await this.validateTargetDeleted(h,g,"copy",d.overwrite),await(0,w.copy)(y,L,{preserveSymlinks:!0})}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,f.localize)(3,null,(0,p.basename)(y),(0,p.basename)((0,p.dirname)(L)),O.toString()))),this.toFileSystemProviderError(O)}}async validateTargetDeleted(h,g,d,y){const L=this.toFilePath(h),O=this.toFilePath(g);let z=!1;if(!!(this.capabilities&1024)||(z=(0,E.isEqual)(L,O,!0)),z&&d==="copy")throw(0,S.createFileSystemProviderError)((0,f.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!z&&await(0,w.exists)(O)){if(!y)throw(0,S.createFileSystemProviderError)((0,f.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(g,{recursive:!0,useTrash:!1})}}watch(h,g){return g.recursive?this.watchRecursive(h,g.excludes):this.watchNonRecursive(h)}watchRecursive(h,g){const d={path:this.toFilePath(h),excludes:g},y=(0,t.insert)(this.recursiveFoldersToWatch,d);return this.refreshRecursiveWatchers(),(0,R.toDisposable)(()=>{y(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var h,g,d;if(this.recursiveWatcher instanceof o.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,R.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let y,L;((g=(h=this.options)===null||h===void 0?void 0:h.watcher)===null||g===void 0?void 0:g.usePolling)?(y=D.FileWatcher,L=(d=this.options)===null||d===void 0?void 0:d.watcher):this.recursiveFoldersToWatch.length===1?i.isWindows?y=I.FileWatcher:y=D.FileWatcher:y=o.FileWatcher,this.recursiveWatcher=new y(this.recursiveFoldersToWatch,O=>this._onDidChangeFile.fire((0,m.toFileChanges)(O)),O=>{O.type==="error"&&this._onDidWatchErrorOccur.fire(O.message),this.logService[O.type](O.message)},this.logService.getLevel()===b.LogLevel.Trace,L),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))}}watchNonRecursive(h){const g=new c.FileWatcher(this.toFilePath(h),y=>this._onDidChangeFile.fire((0,m.toFileChanges)(y)),y=>{y.type==="error"&&this._onDidWatchErrorOccur.fire(y.message),this.logService[y.type](y.message)},this.logService.getLevel()===b.LogLevel.Trace),d=this.logService.onDidChangeLogLevel(()=>{g.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,R.combinedDisposable)(g,d)}toFilePath(h){return(0,p.normalize)(h.fsPath)}toFileSystemProviderError(h){if(h instanceof S.FileSystemProviderError)return h;let g;switch(h.code){case"ENOENT":g=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":g=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":g=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":g=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":g=S.FileSystemProviderErrorCode.NoPermissions;break;default:g=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(h,g)}async toFileSystemProviderWriteError(h,g){let d=this.toFileSystemProviderError(g);if(h&&d.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:y}=await w.SymlinkSupport.stat(this.toFilePath(h));y.mode&128||(d=(0,S.createFileSystemProviderError)(g,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(y){this.logService.trace(y)}return d}dispose(){super.dispose(),(0,R.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,R.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(J[23],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(J[183],Z([0,1,58,6,23]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let S=class{constructor(i,w){this.productService=i,this.logService=w,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(i,w){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const p=/^(.*)#([^#]+)$/.exec(w);if(!p)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,n,E]=p;let P=this.trustedExtensionUrlPublicKeys.get(i);if(!P){if(P=this.productService.trustedExtensionUrlPublicKeys[i],!P||P.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",i),!1;this.trustedExtensionUrlPublicKeys.set(i,[...P])}const b=Buffer.from(decodeURIComponent(E),"base64");if(b.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const f=b.slice(0,6),m=b.readUIntBE(0,6),D=Date.now()-m;if(D<0||D>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const I=b.slice(6),o=v.createVerify("SHA256");o.write(f),o.write(Buffer.from(n)),o.end();for(let c=0;c<P.length;c++){let a=P[c];if(a!==null){if(typeof a=="string")try{a=v.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),P[c]=a}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${i}:`,l),P[c]=null;continue}if(o.verify(a,I))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};S=ue([te(0,R.IProductService),te(1,A.ILogService)],S),e.ExtensionUrlTrustService=S}),define(J[55],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(J[184],Z([0,1,2,10,7,53,14,6,36,3,15,28]),function(j,e,v,A,R,S,M,i,w,p,n,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let P=class extends v.Disposable{constructor(f,m){super();this.logService=m,this.validRoots=w.TernarySearchTree.forUris(()=>!p.isLinux),this.validExtensions=new Set([".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(R.URI.file(f.appRoot)),this.addValidFileRoot(R.URI.file(f.extensionsPath)),this.addValidFileRoot(f.globalStorageHome),this.addValidFileRoot(f.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:f}=M.session;f.protocol.registerFileProtocol(A.Schemas.vscodeFileResource,(m,D)=>this.handleResourceRequest(m,D)),f.protocol.interceptFileProtocol(A.Schemas.file,(m,D)=>this.handleFileRequest(m,D)),this._register((0,v.toDisposable)(()=>{f.protocol.unregisterProtocol(A.Schemas.vscodeFileResource),f.protocol.uninterceptProtocol(A.Schemas.file)}))}addValidFileRoot(f){return this.validRoots.get(f)?v.Disposable.None:(this.validRoots.set(f,!0),(0,v.toDisposable)(()=>this.validRoots.delete(f)))}handleFileRequest(f,m){const D=R.URI.parse(f.url);return p.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${D.fsPath} from ${A.Schemas.file}: protocol (original URL: ${f.url})`),m({error:-3})):this.validRoots.findSubstr(D)?m({path:D.fsPath}):this.validExtensions.has((0,n.extname)(D))?m({path:D.fsPath}):(this.logService.error(`${A.Schemas.file}: Refused to load resource ${D.fsPath} from ${A.Schemas.file}: protocol (original URL: ${f.url})`),m({error:-3}))}handleResourceRequest(f,m){const D=R.URI.parse(f.url),I=A.FileAccess.asFileUri(D);return this.validRoots.findSubstr(I)?m({path:I.fsPath}):this.validExtensions.has((0,n.extname)(I))?m({path:I.fsPath}):(this.logService.error(`${A.Schemas.vscodeFileResource}: Refused to load resource ${I.fsPath} from ${A.Schemas.vscodeFileResource}: protocol (original URL: ${f.url})`),m({error:-3}))}createIPCObjectUrl(){let f;const m=R.URI.from({scheme:"vscode",path:(0,E.generateUuid)()}),D=m.toString(),I=async()=>f;return M.ipcMain.handle(D,I),this.logService.trace(`IPC Object URL: Registered new channel ${D}.`),{resource:m,update:o=>f=o,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${D}.`),M.ipcMain.removeHandler(D)}}}};P=ue([te(0,S.INativeEnvironmentService),te(1,i.ILogService)],P),e.ProtocolMainService=P}),define(J[37],Z([0,1,13,103]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(M,i){A.ok(v.isString(M)),A.ok(v.isObject(i)),A.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,i)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new R}),define(J[185],Z([0,1,37,5]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(i){return i.length>0&&i.charAt(i.length-1)==="#"?i.substring(0,i.length-1):i}class S{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,p){this.schemasById[R(w)]=p,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new S;v.Registry.add(e.Extensions.JSONContribution,M)}),define(J[48],Z([0,1,132,5,37,13,185]),function(j,e,v,A,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var i;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(i=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=R.Registry.as(M.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(I,o=!0){this.registerConfigurations([I],o)}registerConfigurations(I,o=!0){const c=[];I.forEach(a=>{c.push(...this.validateAndRegisterProperties(a,o,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(I){const o=[],c=a=>{if(a.properties)for(const l in a.properties)o.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,a.properties[l]);a.allOf&&a.allOf.forEach(l=>c(l))};for(const a of I){c(a);const l=this.configurationContributors.indexOf(a);l!==-1&&this.configurationContributors.splice(l,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(I){const o=[],c=[];for(const a of I)for(const l in a)if(o.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]=Object.assign(Object.assign({},this.defaultValues[l]||{}),a[l]);const t={type:"object",default:this.defaultValues[l],description:v.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};c.push(E(l)),this.configurationProperties[l]=t,this.defaultLanguageConfigurationOverridesNode.properties[l]=t}else{this.defaultValues[l]=a[l];const t=this.configurationProperties[l];t&&(this.updatePropertyDefaultValue(l,t),this.updateSchema(l,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(I){const o=[];for(const c of I)for(const a in c)if(o.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const l=this.configurationProperties[a];l&&(this.updatePropertyDefaultValue(a,l),this.updateSchema(a,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...I){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(I){for(const o of I)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(I,o=!0,c,a=3){var l;a=S.isUndefinedOrNull(I.scope)?a:I.scope;let t=[],r=I.properties;if(r)for(let u in r){if(o&&f(u)){delete r[u];continue}const h=r[u];if(this.updatePropertyDefaultValue(u,h),e.OVERRIDE_PROPERTY_PATTERN.test(u)?h.scope=void 0:(h.scope=S.isUndefinedOrNull(h.scope)?a:h.scope,h.restricted=S.isUndefinedOrNull(h.restricted)?!!((l=c==null?void 0:c.restrictedConfigurations)===null||l===void 0?void 0:l.includes(u)):h.restricted),r[u].hasOwnProperty("included")&&!r[u].included){this.excludedConfigurationProperties[u]=r[u],delete r[u];continue}else this.configurationProperties[u]=r[u];!r[u].deprecationMessage&&r[u].markdownDeprecationMessage&&(r[u].deprecationMessage=r[u].markdownDeprecationMessage),t.push(u)}let s=I.allOf;if(s)for(let u of s)t.push(...this.validateAndRegisterProperties(u,o,c,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(I){const o=c=>{let a=c.properties;if(a)for(const t in a)this.updateSchema(t,a[t]);let l=c.allOf;l&&l.forEach(o)};o(I)}updateSchema(I,o){switch(e.allSettings.properties[I]=o,o.scope){case 1:e.applicationSettings.properties[I]=o;break;case 2:e.machineSettings.properties[I]=o;break;case 6:e.machineOverridableSettings.properties[I]=o;break;case 3:e.windowSettings.properties[I]=o;break;case 4:e.resourceSettings.properties[I]=o;break;case 5:e.resourceSettings.properties[I]=o,this.resourceLanguageSettingsSchema.properties[I]=o;break}}removeFromSchema(I,o){switch(delete e.allSettings.properties[I],o.scope){case 1:delete e.applicationSettings.properties[I];break;case 2:delete e.machineSettings.properties[I];break;case 6:delete e.machineOverridableSettings.properties[I];break;case 3:delete e.windowSettings.properties[I];break;case 4:case 5:delete e.resourceSettings.properties[I];break}}updateOverridePropertyPatternKey(){for(const I of this.overrideIdentifiers.values()){const o=`[${I}]`,c={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,c),e.allSettings.properties[o]=c,e.applicationSettings.properties[o]=c,e.machineSettings.properties[o]=c,e.machineOverridableSettings.properties[o]=c,e.windowSettings.properties[o]=c,e.resourceSettings.properties[o]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(I,o){let c=this.defaultValues[I];S.isUndefined(c)&&(c=o.default),S.isUndefined(c)&&(c=P(o.type)),o.default=c}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function E(D){return D.substring(1,D.length-1)}e.overrideIdentifierFromKey=E;function P(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=P;const b=new p;R.Registry.add(e.Extensions.Configuration,b);function f(D){return D.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(D)?v.localize(5,null,D):b.getConfigurationProperties()[D]!==void 0?v.localize(6,null,D):null:v.localize(4,null)}e.validateProperty=f;function m(){const D=[],I=b.getConfigurationProperties();for(const o of Object.keys(I))D.push([o,I[o].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=m}),define(J[16],Z([0,1,44,13,7,37,4,48]),function(j,e,v,A,R,S,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,M.createDecorator)("configurationService");function w(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=w;var p;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(p=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function E(r,s){const u=s?r?s.keys.filter(z=>r.keys.indexOf(z)===-1):[...s.keys]:[],h=r?s?r.keys.filter(z=>s.keys.indexOf(z)===-1):[...r.keys]:[],g=[];if(s&&r){for(const z of r.keys)if(s.keys.indexOf(z)!==-1){const X=I(r.contents,z),x=I(s.contents,z);v.equals(X,x)||g.push(z)}}const d=[],y=z=>{const X={};for(const x of z)for(const H of x.identifiers)X[l(H)]=x;return X},L=s?y(s.overrides):{},O=r?y(r.overrides):{};if(Object.keys(L).length)for(const z of u){const X=L[z];X&&d.push([(0,i.overrideIdentifierFromKey)(z),X.keys])}if(Object.keys(O).length)for(const z of h){const X=O[z];X&&d.push([(0,i.overrideIdentifierFromKey)(z),X.keys])}if(Object.keys(L).length&&Object.keys(O).length)for(const z of g){const X=O[z],x=L[z];if(X&&x){const H=E({contents:X.contents,keys:X.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});d.push([(0,i.overrideIdentifierFromKey)(z),[...H.added,...H.removed,...H.updated]])}}return{added:u,removed:h,updated:g,overrides:d}}e.compare=E;function P(r,s){const u=[];for(const h of Object.keys(r))if(i.OVERRIDE_PROPERTY_PATTERN.test(h)){const g={};for(const d in r[h])g[d]=r[h][d];u.push({identifiers:[(0,i.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(g),contents:b(g,s)})}return u}e.toOverrides=P;function b(r,s){const u=Object.create(null);for(let h in r)f(u,h,r[h],s);return u}e.toValuesTree=b;function f(r,s,u,h){const g=s.split("."),d=g.pop();let y=r;for(let L=0;L<g.length;L++){let O=g[L],z=y[O];switch(typeof z){case"undefined":z=y[O]=Object.create(null);break;case"object":break;default:h(`Ignoring ${s} as ${g.slice(0,L+1).join(".")} is ${JSON.stringify(z)}`);return}y=z}if(typeof y=="object"&&y!==null)try{y[d]=u}catch(L){h(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(y)}`)}else h(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(y)}`)}e.addToValueTree=f;function m(r,s){const u=s.split(".");D(r,u)}e.removeFromValueTree=m;function D(r,s){const u=s.shift();if(s.length===0){delete r[u];return}if(Object.keys(r).indexOf(u)!==-1){const h=r[u];typeof h=="object"&&!Array.isArray(h)&&(D(h,s),Object.keys(h).length===0&&delete r[u])}}function I(r,s,u){function h(y,L){let O=y;for(const z of L){if(typeof O!="object"||O===null)return;O=O[z]}return O}const g=s.split("."),d=h(r,g);return typeof d=="undefined"?u:d}e.getConfigurationValue=I;function o(r,s,u){Object.keys(s).forEach(h=>{h!=="__proto__"&&(h in r?A.isObject(r[h])&&A.isObject(s[h])?o(r[h],s[h],u):u&&(r[h]=s[h]):r[h]=s[h])})}e.merge=o;function c(){const r=S.Registry.as(i.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=c;function a(){const r=Object.create(null),s=S.Registry.as(i.Extensions.Configuration).getConfigurationProperties();for(let u in s){let h=s[u].default;f(r,u,h,g=>console.error(`Conflict in default settings: ${g}`))}return r}e.getDefaultValues=a;function l(r){return`[${r}]`}e.keyFromOverrideIdentifier=l;function t(r,s,u){const h=r.inspect(s),g=r.inspect(u);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:h.defaultValue}e.getMigratedSettingValue=t}),define(J[186],Z([0,1,43,36,35,13,44,7,48,16,37,2,5]),function(j,e,v,A,R,S,M,i,w,p,n,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,p.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,p.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const u of R.distinct([...Object.keys(this.contents),...Object.keys(r)])){let h=this.contents[u],g=r[u];g&&(typeof h=="object"&&typeof g=="object"?(h=M.deepClone(h),this.mergeContents(h,g)):h=g),s[u]=h}return new b(s,this.keys,this.overrides)}merge(...t){const r=M.deepClone(this.contents),s=M.deepClone(this.overrides),u=[...this.keys];for(const h of t){this.mergeContents(r,h.contents);for(const g of h.overrides){const[d]=s.filter(y=>R.equals(y.identifiers,g.identifiers));d?this.mergeContents(d.contents,g.contents):s.push(M.deepClone(g))}for(const g of h.keys)u.indexOf(g)===-1&&u.push(g)}return new b(r,u,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&S.isObject(t[s])&&S.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=M.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?M.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,p.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,p.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=b;class f extends b{constructor(){const t=(0,p.getDefaultValues)(),r=(0,p.getConfigurationKeys)(),s=[];for(const u of Object.keys(t))w.OVERRIDE_PROPERTY_PATTERN.test(u)&&s.push({identifiers:[(0,w.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(t[u]),contents:(0,p.toValuesTree)(t[u],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,r,s)}}e.DefaultConfigurationModel=f;class m{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!S.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:u,overrides:h,restricted:g}=this.doParseRaw(t,r);this._configurationModel=new b(s,u,h),this._restrictedConfigurations=g||[]}doParseContent(t){let r={},s=null,u=[],h=[],g=[];function d(L){Array.isArray(u)?u.push(L):s&&(u[s]=L)}let y={onObjectBegin:()=>{let L={};d(L),h.push(u),u=L,s=null},onObjectProperty:L=>{s=L},onObjectEnd:()=>{u=h.pop()},onArrayBegin:()=>{let L=[];d(L),h.push(u),u=L,s=null},onArrayEnd:()=>{u=h.pop()},onLiteralValue:d,onError:(L,O,z)=>{g.push({error:L,offset:O,length:z})}};if(t)try{v.visit(t,y),r=u[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return r}doParseRaw(t,r){const s=n.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),u=this.filter(t,s,!0,r);t=u.raw;const h=(0,p.toValuesTree)(t,y=>console.error(`Conflict in settings file ${this._name}: ${y}`)),g=Object.keys(t),d=(0,p.toOverrides)(t,y=>console.error(`Conflict in settings file ${this._name}: ${y}`));return{contents:h,keys:g,overrides:d,restricted:u.restricted}}filter(t,r,s,u){if(!(u==null?void 0:u.scopes)&&!(u==null?void 0:u.skipRestricted))return{raw:t,restricted:[]};const h={},g=[];for(let d in t)if(w.OVERRIDE_PROPERTY_PATTERN.test(d)&&s){const y=this.filter(t[d],r,!1,u);h[d]=y.raw,g.push(...y.restricted)}else{const y=r[d],L=y?typeof y.scope!="undefined"?y.scope:3:void 0;(y==null?void 0:y.restricted)&&g.push(d),(L===void 0||u.scopes===void 0||u.scopes.includes(L))&&(u.skipRestricted&&(y==null?void 0:y.restricted)||(h[d]=t[d]))}return{raw:h,restricted:g}}}e.ConfigurationModelParser=m;class D extends E.Disposable{constructor(t,r,s,u){super();this.userSettingsResource=t,this.scopes=r,this.fileService=u,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class I{constructor(t,r,s=new b,u=new b,h=new A.ResourceMap,g=new b,d=new A.ResourceMap,y=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=u,this._folderConfigurations=h,this._memoryConfiguration=g,this._memoryConfigurationByResource=d,this._freeze=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let u;s.resource?(u=this._memoryConfigurationByResource.get(s.resource),u||(u=new b,this._memoryConfigurationByResource.set(s.resource,u))):u=this._memoryConfiguration,r===void 0?u.removeValue(t):u.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const u=this.getConsolidateConfigurationModel(r,s),h=this.getFolderConfigurationModelForResource(r.resource,s),g=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,d=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),y=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),L=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),O=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),z=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,X=h?r.overrideIdentifier?h.freeze().override(r.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,x=r.overrideIdentifier?g.override(r.overrideIdentifier).getValue(t):g.getValue(t),H=u.getValue(t),Q=R.distinct(R.flatten(u.overrides.map(B=>B.identifiers))).filter(B=>u.getOverrideValue(t,B)!==void 0);return{defaultValue:d,userValue:y,userLocalValue:L,userRemoteValue:O,workspaceValue:z,workspaceFolderValue:X,memoryValue:x,value:H,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:y!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:L!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:z!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:X!==void 0?{value:h==null?void 0:h.freeze().getValue(t),override:r.overrideIdentifier?h==null?void 0:h.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:g.getValue(t),override:r.overrideIdentifier?g.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Q.length?Q:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(u=>w.OVERRIDE_PROPERTY_PATTERN.test(u)).map(u=>{const h=(0,w.overrideIdentifierFromKey)(u),g=this._defaultConfiguration.getKeysForOverrideIdentifier(h),d=t.getKeysForOverrideIdentifier(h),y=[...d.filter(L=>g.indexOf(L)===-1),...g.filter(L=>d.indexOf(L)===-1),...g.filter(L=>!M.equals(this._defaultConfiguration.override(h).getValue(L),t.override(h).getValue(L)))];return[h,y]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:u,overrides:h}=(0,p.compare)(this.localUserConfiguration,t),g=[...r,...s,...u];return g.length&&this.updateLocalUserConfiguration(t),{keys:g,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:u,overrides:h}=(0,p.compare)(this.remoteUserConfiguration,t);let g=[...r,...s,...u];return g.length&&this.updateRemoteUserConfiguration(t),{keys:g,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:u,overrides:h}=(0,p.compare)(this.workspaceConfiguration,t);let g=[...r,...s,...u];return g.length&&this.updateWorkspaceConfiguration(t),{keys:g,overrides:h}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:u,updated:h,removed:g,overrides:d}=(0,p.compare)(s,r);let y=[...u,...h,...g];return(y.length||!s)&&this.updateFolderConfiguration(t,r),{keys:y,overrides:d}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:u,removed:h,overrides:g}=(0,p.compare)(r,void 0);return{keys:[...s,...u,...h],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const u=r.getFolder(t);u&&(s=this.getFolderConsolidatedConfiguration(u.uri)||s);const h=this._memoryConfigurationByResource.get(t);h&&(s=s.merge(h))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(t);u?(r=s.merge(u),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:u,keys:h}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:u,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(u=>r.add(u))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),u=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((g,d)=>(g.set(i.URI.revive(d[0]),this.parseConfigurationModel(d[1])),g),new A.ResourceMap);return new I(r,s,new b,u,h,new b,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=I;function o(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const t=new Set,r=new Map;for(const u of l)u.keys.forEach(h=>t.add(h)),u.overrides.forEach(([h,g])=>{const d=(0,A.getOrSet)(r,h,new Set);g.forEach(y=>d.add(y))});const s=[];return r.forEach((u,h)=>s.push([h,[...u.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=o;class c{constructor(t,r,s,u){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=u,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(d=>h.add(d)),t.overrides.forEach(([,d])=>d.forEach(y=>h.add(y))),this.affectedKeys=[...h.values()];const g=new b;this.affectedKeys.forEach(d=>g.setValue(d,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const u=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,h=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!M.equals(u,h)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,p.toValuesTree)({[r]:!0},()=>{}),u;for(;typeof s=="object"&&(u=Object.keys(s)[0]);){if(t=t[u],!t)return!1;s=s[u]}return!0}}e.ConfigurationChangeEvent=c;class a extends c{constructor(t,r,s,u){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=a}),define(J[187],Z([0,1,37,48,2,16,186,5,9,15]),function(j,e,v,A,R,S,M,i,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends R.Disposable{constructor(P,b){super();this.settingsResource=P,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new M.UserSettings(this.settingsResource,void 0,p.extUriBiasedIgnorePathCase,b)),this.configuration=new M.Configuration(new M.DefaultConfigurationModel,new M.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(A.Extensions.Configuration).onDidUpdateConfiguration(f=>this.onDidDefaultConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const P=await this.userConfiguration.loadConfiguration();this.configuration=new M.Configuration(new M.DefaultConfigurationModel,P)}getConfigurationData(){return this.configuration.toData()}getValue(P,b){const f=typeof P=="string"?P:void 0,m=(0,S.isConfigurationOverrides)(P)?P:(0,S.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(f,m,void 0)}updateValue(P,b,f,m){return Promise.reject(new Error("not supported"))}inspect(P){return this.configuration.inspect(P,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const P=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(P)}onDidChangeUserConfiguration(P){const b=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(P);this.trigger(f,b,1)}onDidDefaultConfigurationChange(P){const b=this.configuration.toData(),f=this.configuration.compareAndUpdateDefaultConfiguration(new M.DefaultConfigurationModel,P);this.trigger(f,b,6)}trigger(P,b,f){const m=new M.ConfigurationChangeEvent(P,{data:b},this.configuration);m.source=f,m.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(P){switch(P){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(J[188],Z([0,1,40,8,68,138,21,3,91,16,4,10,106]),function(j,e,v,A,R,S,M,i,w,p,n,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=S.localize(0,null);class f{async getDefaultTerminalForPlatforms(){const t=await I.getDefaultTerminalLinuxReady();return{windows:m.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let m=class Je extends f{constructor(t){super();this._configurationService=t}openTerminal(t){const r=this._configurationService.getValue();return this.spawnTerminal(v,r,R.getWindowsShell(),t)}spawnTerminal(t,r,s,u){const h=r.terminal.external,g=(h==null?void 0:h.windowsExec)||Je.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const d=A.basename(g).toLowerCase();if(d==="cmder"||d==="cmder.exe")return t.spawn(g,u?[u]:void 0),Promise.resolve(void 0);const y=["/c","start","/wait"];return g.indexOf(" ")>=0&&y.push('""'),y.push(g),(d==="wt"||d==="wt.exe")&&y.push("-d ."),new Promise((L,O)=>{const z=o(process),X=t.spawn(s,y,{cwd:u,env:z});X.on("error",O),X.on("exit",()=>L())})}runInTerminal(t,r,s,u,h){const g="windowsExec"in h&&h.windowsExec?h.windowsExec:Je.getDefaultTerminalWindows();return new Promise((d,y)=>{const L=`"${r} - ${b}"`,O=`""${s.join('" "')}" & pause"`,z=["/c","start",L,"/wait",g,"/c",O],X=Object.assign({},o(process),u);Object.keys(X).filter(Q=>X[Q]===null).forEach(Q=>delete X[Q]);const x={cwd:r,env:X,windowsVerbatimArguments:!0};v.spawn(Je.CMD,z,x).on("error",Q=>{y(c(Q))}),d(void 0)})}static getDefaultTerminalWindows(){if(!Je._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Je._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return Je._DEFAULT_TERMINAL_WINDOWS}};m.CMD="cmd.exe",m=ue([te(0,(0,n.optional)(p.IConfigurationService))],m),e.WindowsExternalTerminalService=m;let D=class Et extends f{constructor(t){super();this._configurationService=t}openTerminal(t){const r=this._configurationService.getValue();return this.spawnTerminal(v,r,t)}runInTerminal(t,r,s,u,h){const g=h.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((d,y)=>{if(g===w.DEFAULT_TERMINAL_OSX||g==="iTerm.app"){const L=g===w.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",z=[E.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${L}.scpt`,j).fsPath,"-t",t||b,"-w",r];for(let H of s)z.push("-a"),z.push(H);if(u)for(let H in u){const Q=u[H];Q===null?(z.push("-u"),z.push(H)):(z.push("-e"),z.push(`${H}=${Q}`))}let X="";const x=v.spawn(Et.OSASCRIPT,z);x.on("error",H=>{y(c(H))}),x.stderr.on("data",H=>{X+=H.toString()}),x.on("exit",H=>{if(H===0)d(void 0);else if(X){const Q=X.split(`
`,1);y(new Error(Q[0]))}else y(new Error(S.localize(1,null,L,H)))})}else y(new Error(S.localize(2,null,g)))})}spawnTerminal(t,r,s){const u=r.terminal.external,h=(u==null?void 0:u.osxExec)||w.DEFAULT_TERMINAL_OSX;return new Promise((g,d)=>{const y=["-a",h];s&&y.push(s);const L=t.spawn("/usr/bin/open",y);L.on("error",d),L.on("exit",()=>g())})}};D.OSASCRIPT="/usr/bin/osascript",D=ue([te(0,(0,n.optional)(p.IConfigurationService))],D),e.MacExternalTerminalService=D;let I=class Ze extends f{constructor(t){super();this._configurationService=t}openTerminal(t){const r=this._configurationService.getValue();return this.spawnTerminal(v,r,t)}runInTerminal(t,r,s,u,h){const g=h.linuxExec?Promise.resolve(h.linuxExec):Ze.getDefaultTerminalLinuxReady();return new Promise((d,y)=>{let L=[];g.then(O=>{O.indexOf("gnome-terminal")>=0?L.push("-x"):L.push("-e"),L.push("bash"),L.push("-c");const z=`${a(s)}; echo; read -p "${Ze.WAIT_MESSAGE}" -n1;`;L.push(`''${z}''`);const X=Object.assign({},process.env,u);Object.keys(X).filter(B=>X[B]===null).forEach(B=>delete X[B]);const x={cwd:r,env:X};let H="";const Q=v.spawn(O,L,x);Q.on("error",B=>{y(c(B))}),Q.stderr.on("data",B=>{H+=B.toString()}),Q.on("exit",B=>{if(B===0)d(void 0);else if(H){const N=H.split(`
`,1);y(new Error(N[0]))}else y(new Error(S.localize(4,null,O,B)))})})})}static async getDefaultTerminalLinuxReady(){return Ze._DEFAULT_TERMINAL_LINUX_READY||(Ze._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{i.isLinux?await M.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),Ze._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,r,s){const u=r.terminal.external,h=(u==null?void 0:u.linuxExec)?Promise.resolve(u.linuxExec):Ze.getDefaultTerminalLinuxReady();return new Promise((g,d)=>{h.then(y=>{const L=o(process),O=t.spawn(y,[],{cwd:s,env:L});O.on("error",d),O.on("exit",()=>g())})})}};I.WAIT_MESSAGE=S.localize(3,null),I=ue([te(0,(0,n.optional)(p.IConfigurationService))],I),e.LinuxExternalTerminalService=I;function o(l){const t=l.env;return(0,P.sanitizeProcessEnvironment)(t),t}function c(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(S.localize(5,null,l.path)):l}function a(l){let t="";for(let r of l)r.indexOf(" ")>=0?t+='"'+r+'"':t+=r,t+=" ";return t}}),define(J[189],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var A;(function(M){M[M.Unknown=0]="Unknown",M[M.DisableTrust=1]="DisableTrust",M[M.MachineTrusted=2]="MachineTrusted"})(A=e.RemoteTrustOption||(e.RemoteTrustOption={}));var R;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(i,w=R.Unknown,p){super(i);this._message=i,this._code=w,this._detail=p,this.isHandled=w===R.NotAvailable&&p===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(i){return i instanceof S&&i._code===R.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof S&&i._code===R.NoResolverFound}static isHandled(i){return i instanceof S&&i.isHandled}}e.RemoteAuthorityResolverError=S}),define(J[190],Z([0,1,85,28,2,19,5,189,18,9,26]),function(j,e,v,A,R,S,M,i,w,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var P;(function(k){k[k.Management=1]="Management",k[k.ExtensionHost=2]="ExtensionHost",k[k.Tunnel=3]="Tunnel"})(P=e.ConnectionType||(e.ConnectionType={}));function b(k){switch(k){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(k){const F=new n.CancellationTokenSource;return setTimeout(()=>F.cancel(),k),F.token}function m(k,F){if(k.isCancellationRequested||F.isCancellationRequested)return n.CancellationToken.Cancelled;const U=new n.CancellationTokenSource;return k.onCancellationRequested(()=>U.cancel()),F.onCancellationRequested(()=>U.cancel()),U.token}class D{constructor(F){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((U,K)=>{this._resolvePromise=U,this._rejectPromise=K}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function I(k,F){const U=new D(F);return U.registerDisposable(k.onControlMessage(K=>{const G=JSON.parse(K.toString()),Y=$(G);Y?U.reject(Y):U.resolve(G)})),U.promise}function o(k,F,U,K,G,Y){const ee=new D(Y);return F.connect(U,K,G,(re,se)=>{ee.didTimeout?(re&&k.error(re),se==null||se.dispose()):re||!se?ee.reject(re):ee.resolve(se)}),ee.promise}function c(k,F){const U=new D(F);return k.then(K=>{U.didTimeout||U.resolve(K)},K=>{U.didTimeout||U.reject(K)}),U.promise}async function a(k,F,U,K){const G=T(k,F);k.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await o(k.logService,k.socketFactory,k.host,k.port,`reconnectionToken=${k.reconnectionToken}&reconnection=${k.reconnectionProtocol?"true":"false"}`,K)}catch(oe){throw k.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),k.logService.error(oe),oe}k.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let ee,re;k.reconnectionProtocol?(k.reconnectionProtocol.beginAcceptReconnection(Y,null),ee=k.reconnectionProtocol,re=!1):(ee=new v.PersistentProtocol(Y,null),re=!0),k.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const se={type:"auth",auth:k.connectionToken||"00000000000000000000"};ee.sendControl(S.VSBuffer.fromString(JSON.stringify(se)));try{const oe=await I(ee,m(K,f(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}k.logService.trace(`${G} 4/6. received SignRequest control message.`);const ne=await c(k.signService.sign(oe.data),K),le={type:"connectionType",commit:k.commit,signedData:ne,desiredConnectionType:F};return U&&(le.args=U),k.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(S.VSBuffer.fromString(JSON.stringify(le))),{protocol:ee,ownsProtocol:re}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(k.logService.error(`${G} the handshake timed out. Error:`),k.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(k.logService.error(`${G} received error control message when negotiating connection. Error:`),k.logService.error(oe)),re&&C(ee),oe}}async function l(k,F,U,K){const G=Date.now(),Y=T(k,F),{protocol:ee,ownsProtocol:re}=await a(k,F,U,K),se=new D(K);return se.registerDisposable(ee.onControlMessage(oe=>{const ne=JSON.parse(oe.toString()),le=$(ne);le?(k.logService.error(`${Y} received error control message when negotiating connection. Error:`),k.logService.error(le),re&&C(ee),se.reject(le)):(k.reconnectionProtocol&&k.reconnectionProtocol.endAcceptReconnection(),k.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${W(G)}!`),se.resolve({protocol:ee,firstMessage:ne}))})),se.promise}async function t(k,F){const{protocol:U}=await l(k,1,void 0,F);return{protocol:U}}async function r(k,F,U){const{protocol:K,firstMessage:G}=await l(k,2,F,U),Y=G&&G.debugPort;return{protocol:K,debugPort:Y}}async function s(k,F,U){const K=Date.now(),G=T(k,3),{protocol:Y}=await a(k,3,F,U);return k.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${W(K)}!`),Y}async function u(k,F,U){const{host:K,port:G,connectionToken:Y}=await k.addressProvider.getAddress();return{commit:k.commit,host:K,port:G,connectionToken:Y,reconnectionToken:F,reconnectionProtocol:U,socketFactory:k.socketFactory,signService:k.signService,logService:k.logService}}async function h(k,F,U){try{const K=(0,A.generateUuid)(),G=await u(k,K,null),{protocol:Y}=await t(G,n.CancellationToken.None);return new B(k,F,U,K,Y)}catch(K){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(K),Q.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentManagement=h;async function g(k,F){try{const U=(0,A.generateUuid)(),K=await u(k,U,null),{protocol:G,debugPort:Y}=await r(K,F,n.CancellationToken.None);return new N(k,F,U,G,Y)}catch(U){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(U),Q.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(U)),U}}e.connectRemoteAgentExtensionHost=g;async function d(k,F){const U=await u(k,(0,A.generateUuid)(),null);return await s(U,{port:F},n.CancellationToken.None)}e.connectRemoteAgentTunnel=d;function y(k){return(0,p.createCancelablePromise)(F=>new Promise((U,K)=>{const G=setTimeout(U,k*1e3);F.onCancellationRequested(()=>{clearTimeout(G),U()})}))}var L;(function(k){k[k.ConnectionLost=0]="ConnectionLost",k[k.ReconnectionWait=1]="ReconnectionWait",k[k.ReconnectionRunning=2]="ReconnectionRunning",k[k.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",k[k.ConnectionGain=4]="ConnectionGain"})(L=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class O{constructor(F,U){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=O;class z{constructor(F,U,K,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.durationSeconds=K,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=z;class X{constructor(F,U,K){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.attempt=K,this.type=2}}e.ReconnectionRunningEvent=X;class x{constructor(F,U,K){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.attempt=K,this.type=4}}e.ConnectionGainEvent=x;class H{constructor(F,U,K,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.attempt=K,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=H;class Q extends R.Disposable{constructor(F,U,K,G){super();this._connectionType=F,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=U,this.reconnectionToken=K,this.protocol=G,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(G.onSocketClose(()=>this._beginReconnecting())),this._register(G.onSocketTimeout(()=>this._beginReconnecting())),Q._instances.push(this),Q._permanentFailure&&this._gotoPermanentFailure(Q._permanentFailureMillisSinceLastIncomingData,Q._permanentFailureAttempt,Q._permanentFailureHandled)}static triggerPermanentFailure(F,U,K){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=U,this._permanentFailureHandled=K,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(!Q._permanentFailure){const F=_(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30],K=Date.now();let G=-1;do{G++;const Y=G<U.length?U[G]:U[U.length-1];try{if(Y>0){const re=y(Y);this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,re)),this._options.logService.info(`${F} waiting for ${Y} seconds before reconnecting...`);try{await re}catch(se){}}if(Q._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this._options.logService.info(`${F} resolving connection...`);const ee=await u(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${ee.host}:${ee.port}...`),await this._reconnect(ee,f(E)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ee),Q.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(Date.now()-K>108e5){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ee),Q.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ee)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((0,w.isPromiseCanceledError)(ee)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if(ee instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ee),Q.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,i.RemoteAuthorityResolverError.isHandled(ee));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ee),Q.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!Q._permanentFailure)}}_gotoPermanentFailure(F,U,K){this._onDidStateChange.fire(new H(this.reconnectionToken,F,U,K)),C(this.protocol)}}Q._permanentFailure=!1,Q._permanentFailureMillisSinceLastIncomingData=0,Q._permanentFailureAttempt=0,Q._permanentFailureHandled=!1,Q._instances=[];class B extends Q{constructor(F,U,K,G,Y){super(1,F,G,Y);this.client=this._register(new v.Client(Y,{remoteAuthority:U,clientId:K},F.ipcLogger))}async _reconnect(F,U){await t(F,U)}}e.ManagementPersistentConnection=B;class N extends Q{constructor(F,U,K,G,Y){super(2,F,K,G);this._startArguments=U,this.debugPort=Y}async _reconnect(F,U){await r(F,this._startArguments,U)}}e.ExtensionHostPersistentConnection=N;function C(k){try{k.acceptDisconnect();const F=k.getSocket();k.dispose(),F.dispose()}catch(F){(0,w.onUnexpectedError)(F)}}function $(k){if(k&&k.type==="error"){const F=new Error(`Connection error: ${k.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function V(k,F){for(;k.length<F;)k+=" ";return k}function _(k,F,U){return`[remote-connection][${V(b(k),13)}][${F.substr(0,5)}\u2026][${U?"reconnect":"initial"}]`}function T(k,F){return`${_(F,k.reconnectionToken,!!k.reconnectionProtocol)}[${k.host}:${k.port}]`}function W(k){return`${Date.now()-k} ms`}}),define(J[73],Z([0,1,10]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function A(w){return w.scheme===v.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=A;function R(w){if(!!w){const p=w.indexOf("+");return p<0?w:w.substr(0,p)}}e.getRemoteName=R;function S(w){return w.scheme!==v.Schemas.file&&w.scheme!==v.Schemas.vscodeRemote}function M(w){if(w.folders.length)return w.folders.every(p=>S(p.uri))?w.folders[0].uri:void 0;if(w.configuration&&S(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=M;function i(w){var p;return(p=M(w))===null||p===void 0?void 0:p.scheme}e.getVirtualWorkspaceScheme=i}),define(J[74],Z([0,1,5,3,4,6]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService");var M;(function(P){P[P.Notify=1]="Notify",P[P.OpenBrowser=2]="OpenBrowser",P[P.OpenPreview=3]="OpenPreview",P[P.Silent=4]="Silent",P[P.Ignore=5]="Ignore"})(M=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function i(P){if(!(P.scheme!=="http"&&P.scheme!=="https")){const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(P.authority);if(!!b)return{address:b[1],port:+b[2]}}}e.extractLocalHostUriMetaDataForPortMapping=i,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(P){return e.LOCALHOST_ADDRESSES.indexOf(P)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(P){return e.ALL_INTERFACES_ADDRESSES.indexOf(P)>=0}e.isAllInterfaces=p;function n(P,b){return b?b!==1&&P<1024:!A.isWindows&&P<1024}e.isPortPrivileged=n;let E=class{constructor(b){this.logService=b,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(b,f){return this._tunnelProvider=b,b?(this._canElevate=f.elevation,this._canMakePublic=f.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async b=>{const f=[],m=Array.from(this._tunnels.values());for(let D of m){const I=Array.from(D.values());for(let o of I){const c=await o.value;c&&f.push(c)}}b(f)})}async dispose(){for(const b of this._tunnels.values()){for(const{value:f}of b.values())await f.then(m=>m==null?void 0:m.dispose());b.clear()}this._tunnels.clear()}openTunnel(b,f,m,D,I=!1,o=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${m} on local port ${D}.`),!!b){f||(f="localhost");const c=this.retainOrCreateTunnel(b,f,m,D,I,o);return c?c.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.makeTunnel(a);return(a.tunnelRemoteHost!==f||a.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(l),l}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,public:b.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const f=this._tunnels.get(b.tunnelRemoteHost);if(f){const m=f.get(b.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,m))}}}}async tryDisposeTunnel(b,f,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${f}.`);const D=m.value.then(async I=>{I&&(await I.dispose(!0),this._onTunnelClosed.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(f),D}}async closeTunnel(b,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${f} `);const m=this._tunnels.get(b);if(m&&m.has(f)){const D=m.get(f);D.refcount=0,await this.tryDisposeTunnel(b,f,D)}}addTunnelToMap(b,f,m){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(f,{refcount:1,value:m})}async removeEmptyTunnelFromMap(b,f){const m=this._tunnels.get(b);m&&(await m.get(f)||m.delete(f),m.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,f){let m=[b];w(b)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):p(b)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const D=m.map(I=>this._tunnels.get(I));for(const I of D){const o=I==null?void 0:I.get(f);if(o)return o}}canTunnel(b){return!!i(b)}createWithProvider(b,f,m,D,I,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${m} on local port ${D}.`);const a={elevationRequired:I?n(D===void 0?m:D):!1},l={remoteAddress:{host:f,port:m},localAddressPort:D,public:o},t=b.forwardPort(l,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(f,m,t),t}};E=ue([te(0,S.ILogService)],E),e.AbstractTunnelService=E}),define(J[49],Z([0,1,146,4,48,37,19]),function(j,e,v,A,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function i(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=i;function w(f){return f.res.statusCode===204}async function p(f){if(!i(f))throw new Error("Server returned "+f.res.statusCode);return w(f)?null:(await(0,M.streamToBuffer)(f.stream)).toString()}e.asText=p;async function n(f){if(!i(f))throw new Error("Server returned "+f.res.statusCode);if(w(f))return null;const D=(await(0,M.streamToBuffer)(f.stream)).toString();try{return JSON.parse(D)}catch(I){throw I.message+=`:
`+D,I}}e.asJson=n;function E(f){b(f)}e.updateProxyConfigurationsScope=E;let P;function b(f){const m=S.Registry.as(R.Extensions.Configuration);P&&m.deregisterConfigurations([P]),P={id:"http",order:15,title:(0,v.localize)(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,v.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,v.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,v.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,v.localize)(4,null),(0,v.localize)(5,null),(0,v.localize)(6,null),(0,v.localize)(7,null)],default:"override",description:(0,v.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,v.localize)(9,null),restricted:!0}}},m.registerConfiguration(P)}b(2)}),define(J[191],Z([0,1,192,13]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function R(M,i){return M.protocol==="http:"?i.HTTP_PROXY||i.http_proxy||null:M.protocol==="https:"&&(i.HTTPS_PROXY||i.https_proxy||i.HTTP_PROXY||i.http_proxy)||null}async function S(M,i,w={}){const p=(0,v.parse)(M),n=w.proxyUrl||R(p,i);if(!n)return null;const E=(0,v.parse)(n);if(!/^https?:$/.test(E.protocol||""))return null;const P={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,A.isBoolean)(w.strictSSL)?w.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((b,f)=>{j(["http-proxy-agent"],b,f)}))(P):new(await new Promise((b,f)=>{j(["https-proxy-agent"],b,f)}))(P)}e.getProxyAgent=S}),define(J[193],Z([0,1,28,19]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(S,M,i){let w=i&&i.get("storage.serviceMachineId",0)||null;if(w)return w;try{const n=(await M.readFile(S.serviceMachineIdResource)).value.toString();w=(0,v.isUUID)(n)?n:null}catch(p){w=null}if(!w){w=(0,v.generateUuid)();try{await M.writeFile(S.serviceMachineIdResource,A.VSBuffer.fromString(w))}catch(p){}}return i&&i.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=R}),define(J[75],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[194],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((R,S)=>j(["vsda"],R,S))}async sign(R){try{const S=await this.vsda(),M=new S.signer;if(M)return M.sign(R)}catch(S){}return R}}e.SignService=v}),define(J[38],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(J[17],Z([0,1,14,6,38,5,4,176,3,2,9,13,32]),function(j,e,v,A,R,S,M,i,w,p,n,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,M.createDecorator)("lifecycleMainService");var b;(function(D){D[D.CLOSE=1]="CLOSE",D[D.QUIT=2]="QUIT",D[D.RELOAD=3]="RELOAD",D[D.LOAD=4]="LOAD"})(b=e.UnloadReason||(e.UnloadReason={}));var f;(function(D){D[D.Starting=1]="Starting",D[D.Ready=2]="Ready",D[D.AfterWindowOpen=3]="AfterWindowOpen"})(f=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let m=class ut extends p.Disposable{constructor(I,o){super();this.logService=I,this.stateMainService=o,this._onBeforeShutdown=this._register(new S.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new S.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new S.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new S.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new S.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ut.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ut.QUIT_AND_RESTART_KEY)}registerListeners(){const I=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),w.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",I);const o=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!w.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",o),v.app.once("will-quit",c=>{this.logService.trace("Lifecycle#app.on(will-quit)"),c.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",I),v.app.removeListener("window-all-closed",o),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const I=[];return this._onWillShutdown.fire({join(o){I.push(o)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(I)}catch(o){this.logService.error(o)}try{await this.stateMainService.close()}catch(o){this.logService.error(o)}})(),this.pendingWillShutdownPromise}set phase(I){if(I<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase!==I){this.logService.trace(`lifecycle (main): phase changed (value: ${I})`),this._phase=I;const o=this.phaseWhen.get(this._phase);o&&(o.open(),this.phaseWhen.delete(this._phase))}}async when(I){if(!(I<=this._phase)){let o=this.phaseWhen.get(I);o||(o=new n.Barrier,this.phaseWhen.set(I,o)),await o.wait()}}registerWindow(I){const o=new p.DisposableStore;this.windowCounter++,o.add(I.onWillLoad(a=>this._onWillLoadWindow.fire({window:I,workspace:a.workspace})));const c=(0,E.assertIsDefined)(I.win);c.on("close",a=>{const l=I.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${I.id}`),a.preventDefault(),this.unload(I,1).then(t=>{if(t){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(I),I.close()})}),c.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${I.id}`),this.windowCounter--,o.dispose(),this.windowCounter===0&&(!w.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(I,o){await this.unload(I,3)||I.reload(o)}async unload(I,o){if(!I.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${I.id}`);const c=this._quitRequested?2:o;let a=await this.onBeforeUnloadWindowInRenderer(I,c);return a?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${I.id})`),this.handleWindowUnloadVeto(a)):(a=await this.onBeforeUnloadWindowInMain(I,c),a?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${I.id})`),this.handleWindowUnloadVeto(a)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${I.id})`),await this.onWillUnloadWindowInRenderer(I,c),!1))}handleWindowUnloadVeto(I){return I?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(I){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(I),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(I,o){return new Promise(c=>{const a=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${a}`,t=`vscode:cancel${a}`;v.ipcMain.once(l,()=>{c(!1)}),v.ipcMain.once(t,()=>{c(!0)}),I.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:t,reason:o})})}onBeforeUnloadWindowInMain(I,o){const c=[];return this._onBeforeUnloadWindow.fire({reason:o,window:I,veto(a){c.push(a)}}),(0,i.handleVetos)(c,a=>this.logService.error(a))}onWillUnloadWindowInRenderer(I,o){return new Promise(c=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(l,()=>c()),I.send("vscode:onWillUnload",{replyChannel:l,reason:o})})}quit(I){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${I}`),I&&this.stateMainService.setItem(ut.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(o=>{this.pendingQuitPromiseResolve=o,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(I){this.logService.trace("Lifecycle#relaunch()");const o=process.argv.slice(1);if((I==null?void 0:I.addArgs)&&o.push(...I.addArgs),I==null?void 0:I.removeArgs)for(const l of I.removeArgs){const t=o.indexOf(l);t>=0&&o.splice(t,1)}const c=()=>{try{if(w.isWindows){const l=(0,P.cwd)();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:o})};v.app.once("quit",c),await this.quit(!0)&&v.app.removeListener("quit",c)}async kill(I){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const o of v.BrowserWindow.getAllWindows())if(o&&!o.isDestroyed()){let c;o.webContents&&!o.webContents.isDestroyed()?c=new Promise(a=>o.once("closed",a)):c=Promise.resolve(),o.destroy(),await c}})()]),v.app.exit(I)}};m.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",m=ue([te(0,A.ILogService),te(1,R.IStateMainService)],m),e.LifecycleMainService=m}),define(J[195],Z([0,1,4,5,2,17]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,v.createDecorator)("keyboardLayoutMainService");let M=class extends R.Disposable{constructor(p){super();this._onDidChangeKeyboardLayout=this._register(new A.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,p.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const p=await new Promise((n,E)=>{j(["native-keymap"],n,E)});this._keyboardLayoutData=i(p),p.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=i(p),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};M=ue([te(0,S.ILifecycleMainService)],M),e.KeyboardLayoutMainService=M;function i(w){const p=w.getKeyMap(),n=w.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:n}}}),define(J[97],Z([0,1,4,5,2,13,87,9]),function(j,e,v,A,R,S,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var p;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var E;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));class P extends R.Disposable{constructor(D={flushInterval:P.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new i.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,i.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,I){I===w?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:I,target:this.getKeyTargets(D)[I]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,I,o){var c;return(c=this.getStorage(I))===null||c===void 0?void 0:c.get(D,o)}getBoolean(D,I,o){var c;return(c=this.getStorage(I))===null||c===void 0?void 0:c.getBoolean(D,o)}getNumber(D,I,o){var c;return(c=this.getStorage(I))===null||c===void 0?void 0:c.getNumber(D,o)}store(D,I,o,c){if((0,S.isUndefinedOrNull)(I)){this.remove(D,o);return}this.withPausedEmitters(()=>{var a;this.updateKeyTarget(D,o,c),(a=this.getStorage(o))===null||a===void 0||a.set(D,I)})}remove(D,I){this.withPausedEmitters(()=>{var o;this.updateKeyTarget(D,I,void 0),(o=this.getStorage(I))===null||o===void 0||o.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,I){const o=[],c=this.getKeyTargets(D);for(const a of Object.keys(c))c[a]===I&&o.push(a);return o}updateKeyTarget(D,I,o){var c,a;const l=this.getKeyTargets(I);typeof o=="number"?l[D]!==o&&(l[D]=o,(c=this.getStorage(I))===null||c===void 0||c.set(w,JSON.stringify(l))):typeof l[D]=="number"&&(delete l[D],(a=this.getStorage(I))===null||a===void 0||a.set(w,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const I=this.get(w,D);if(I)try{return JSON.parse(I)}catch(o){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){var D,I,o,c;this._onWillSaveState.fire({reason:p.NONE}),await i.Promises.settled([(I=(D=this.getStorage(0))===null||D===void 0?void 0:D.whenFlushed())!==null&&I!==void 0?I:Promise.resolve(),(c=(o=this.getStorage(1))===null||o===void 0?void 0:o.whenFlushed())!==null&&c!==void 0?c:Promise.resolve()])}async logStorage(){var D,I,o,c,a,l;const t=(I=(D=this.getStorage(0))===null||D===void 0?void 0:D.items)!==null&&I!==void 0?I:new Map,r=(c=(o=this.getStorage(1))===null||o===void 0?void 0:o.items)!==null&&c!==void 0?c:new Map;return f(t,r,(a=this.getLogDetails(0))!==null&&a!==void 0?a:"",(l=this.getLogDetails(1))!==null&&l!==void 0?l:"")}}e.AbstractStorageService=P,P.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends P{constructor(){super();this.globalStorage=new M.Storage(new M.InMemoryStorageDatabase),this.workspaceStorage=new M.Storage(new M.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=b;async function f(m,D,I,o){const c=h=>{try{return JSON.parse(h)}catch(g){return h}},a=new Map,l=new Map;m.forEach((h,g)=>{a.set(g,h),l.set(g,c(h))});const t=new Map,r=new Map;D.forEach((h,g)=>{t.set(g,h),r.set(g,c(h))}),console.group(`Storage: Global (path: ${I})`);let s=[];a.forEach((h,g)=>{s.push({key:g,value:h})}),console.table(s),console.groupEnd(),console.log(l),console.group(`Storage: Workspace (path: ${o})`);let u=[];t.forEach((h,g)=>{u.push({key:g,value:h})}),console.table(u),console.groupEnd(),console.log(r)}e.logStorage=f}),define(J[196],Z([0,1,3,32,28,7]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(p){if(v.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function i(p,n,E,P,b,f,m,D,I,o){const c=Object.create(null);c["common.machineId"]=m,c.sessionID=(0,R.generateUuid)()+Date.now(),c.commitHash=b,c.version=f,c["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,v.PlatformToString)(v.platform),c["common.nodePlatform"]=A.platform,c["common.nodeArch"]=P,c["common.product"]=o||"desktop";const a=w(D||[]);a&&(c["common.msftInternal"]=a);let l=0;const t=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),v.isLinuxSnap&&(c["common.snap"]="true");const r=M(E);r&&(c["common.platformDetail"]=r);try{const s=await p.readFile(S.URI.file(I));c["common.source"]=s.value.toString().slice(0,30)}catch(s){}return c}e.resolveCommonProperties=i;function w(p){const n=A.env.USERDNSDOMAIN;if(!n)return!1;const E=n.toLowerCase();return p.some(P=>E===P)}e.verifyMicrosoftInternalDomain=w}),define(J[31],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[197],Z([0,1,27,66,70,20,8,43,84,23,3,7,31,63,10,22,21]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function I(t,r){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],u=new Map,h=new Map,g=2e4;function d(O,z,X,x){const H=z.substring(O.length+1);return new Promise(async Q=>{var B,N,C;let $;try{$=await(0,D.readdir)(z,{withFileTypes:!0})}catch(T){Q();return}if(x.count>=g){x.count+=$.length,x.maxReached=!0,Q();return}let V=$.length;if(V===0){Q();return}let _=$;x.count+$.length>g&&(x.maxReached=!0,V=g-x.count,_=$.slice(0,V)),x.count+=$.length;for(const T of _)if(T.isDirectory()){if(X.includes(T.name)||await d(O,(0,M.join)(z,T.name),X,x),--V==0){Q();return}}else{const W=T.name.lastIndexOf(".");if(W>=0){const k=T.name.substring(W+1);k&&u.set(k,((B=u.get(k))!==null&&B!==void 0?B:0)+1)}for(const k of s)((N=k.relativePathPattern)===null||N===void 0?void 0:N.test(H))!==!1&&k.filePattern.test(T.name)&&h.set(k.tag,((C=h.get(k.tag))!==null&&C!==void 0?C:0)+1);if(--V==0){Q();return}}})}const y={count:0,maxReached:!1};await d(t,t,r,y);const L=await a(t);return{configFiles:o(h),fileTypes:o(u),fileCount:y.count,maxFilesReached:y.maxReached,launchConfigFiles:L}}e.collectWorkspaceStats=I;function o(t){return[...b.Iterable.map(t.entries(),([r,s])=>({name:r,count:s}))].sort((r,s)=>s.count-r.count)}function c(){const t={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(A.virtualMachineHint.value()*100)}%`},r=v.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=c;function a(t){let r=new Map,s=(0,M.join)(t,".vscode","launch.json");return new Promise((u,h)=>{(0,S.exists)(s,g=>{if(g)(0,S.readFile)(s,(d,y)=>{if(d)return u([]);const L=[],O=(0,i.parse)(y.toString(),L);if(L.length)return console.log(`Unable to parse ${s}`),u([]);if((0,i.getNodeType)(O)==="object"&&O.configurations)for(const z of O.configurations){const X=z.type;X&&(r.has(X)?r.set(X,r.get(X)+1):r.set(X,1))}return u(o(r))});else return u([])})})}e.collectLaunchConfigs=a;let l=class{constructor(r,s){this.telemetryService=r,this.productService=s}formatMachineInfo(r){const s=[];return s.push(`OS Version:       ${r.os}`),s.push(`CPUs:             ${r.cpus}`),s.push(`Memory (System):  ${r.memory}`),s.push(`VM:               ${r.vmHint}`),s.join(`
`)}formatEnvironment(r){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const u=v.cpus();return u&&u.length>0&&s.push(`CPUs:             ${u[0].model} (${u.length} x ${u[0].speed})`),s.push(`Memory (System):  ${(v.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||s.push(`Load (avg):       ${v.loadavg().map(h=>Math.round(h)).join(", ")}`),s.push(`VM:               ${Math.round(A.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${r.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(r,s){return Promise.all([(0,w.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async u=>{let[h,g]=u,d=this.formatProcessList(r,h);return s.forEach(y=>{if((0,R.isRemoteDiagnosticError)(y))d+=`
${y.errorMessage}`,g+=`
${y.errorMessage}`;else if(d+=`

Remote: ${y.hostName}`,y.processes&&(d+=`
${this.formatProcessList(r,y.processes)}`),y.workspaceMetadata){g+=`
|  Remote: ${y.hostName}`;for(const L of Object.keys(y.workspaceMetadata)){const O=y.workspaceMetadata[L];let z=`${O.fileCount} files`;O.maxFilesReached&&(z=`more than ${z}`),g+=`|    Folder (${L}): ${z}`,g+=this.formatWorkspaceStats(O)}}}),{processInfo:d,workspaceInfo:g}})}async getSystemInfo(r,s){const{memory:u,vmHint:h,os:g,cpus:d}=c(),y={os:g,memory:u,cpus:d,vmHint:h,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:s};return n.isWindows||(y.load=`${v.loadavg().map(L=>Math.round(L)).join(", ")}`),n.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(r,s){const u=[];return(0,w.listProcesses)(r.mainPID).then(async h=>(u.push(""),u.push(this.formatEnvironment(r)),u.push(""),u.push(this.formatProcessList(r,h)),r.windows.some(g=>g.folderURIs&&g.folderURIs.length>0&&!g.remoteAuthority)&&(u.push(""),u.push("Workspace Stats: "),u.push(await this.formatWorkspaceMetadata(r))),s.forEach(g=>{if((0,R.isRemoteDiagnosticError)(g))u.push(`
${g.errorMessage}`);else if(u.push(`

`),u.push(`Remote:           ${g.hostName}`),u.push(this.formatMachineInfo(g.machineInfo)),g.processes&&u.push(this.formatProcessList(r,g.processes)),g.workspaceMetadata)for(const d of Object.keys(g.workspaceMetadata)){const y=g.workspaceMetadata[d];let L=`${y.fileCount} files`;y.maxFilesReached&&(L=`more than ${L}`),u.push(`Folder (${d}): ${L}`),u.push(this.formatWorkspaceStats(y))}}),u.push(""),u.push(""),u.join(`
`)))}formatWorkspaceStats(r){const s=[],u=60;let h=0;const g=(O,z)=>{const X=` ${O}(${z})`;h+X.length>u?(s.push(d),d="|                 ",h=d.length):h+=X.length,d+=X};let d="|      File types:";const y=10;let L=r.fileTypes.length>y?y:r.fileTypes.length;for(let O=0;O<L;O++){const z=r.fileTypes[O];g(z.name,z.count)}if(s.push(d),r.configFiles.length>=0&&(d="|      Conf files:",h=0,r.configFiles.forEach(O=>{g(O.name,O.count)}),s.push(d)),r.launchConfigFiles.length>0){let O="|      Launch Configs:";r.launchConfigFiles.forEach(z=>{O+=z.count>1?` ${z.name}(${z.count})`:` ${z.name}`}),s.push(O)}return s.join(`
`)}expandGPUFeatures(r){const s=Math.max(...Object.keys(r).map(u=>u.length));return Object.keys(r).map(u=>`${u}:  ${" ".repeat(s-u.length)}  ${r[u]}`).join(`
                  `)}formatWorkspaceMetadata(r){const s=[],u=[];return r.windows.forEach(h=>{h.folderURIs.length===0||!!h.remoteAuthority||(s.push(`|  Window (${h.title})`),h.folderURIs.forEach(g=>{const d=E.URI.revive(g);if(d.scheme===f.Schemas.file){const y=d.fsPath;u.push(I(y,["node_modules",".git"]).then(L=>{let O=`${L.fileCount} files`;L.maxFilesReached&&(O=`more than ${O}`),s.push(`|    Folder (${(0,M.basename)(y)}): ${O}`),s.push(this.formatWorkspaceStats(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${y} (${L.toString()})`)}))}else s.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(u).then(h=>s.join(`
`)).catch(h=>`Unable to collect workspace stats: ${h}`)}formatProcessList(r,s){const u=new Map;r.windows.forEach(g=>u.set(g.pid,g.title));const h=[];return h.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(r.mainPID,u,h,s,0),h.join(`
`)}formatProcessItem(r,s,u,h,g){const d=g===0;let y;d?y=h.pid===r?`${this.productService.applicationName} main`:"remote agent":(y=`${"  ".repeat(g)} ${h.name}`,h.name==="window"&&(y=`${y} (${s.get(h.pid)})`));const L=process.platform==="win32"?h.mem:v.totalmem()*(h.mem/100);u.push(`${h.load.toFixed(0).padStart(5," ")}	${(L/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${h.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(h.children)&&h.children.forEach(O=>this.formatProcessItem(r,s,u,O,g+1))}async reportWorkspaceStats(r){for(const{uri:s}of r.folders){const u=E.URI.revive(s);if(u.scheme===f.Schemas.file){const h=u.fsPath;try{const g=await I(h,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),g.fileTypes.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:d.name,count:d.count})}),g.launchConfigFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:d.name,count:d.count})}),g.configFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:d.name,count:d.count})})}catch(g){}}}}};l=ue([te(0,P.ITelemetryService),te(1,p.IProductService)],l),e.DiagnosticsService=l}),define(J[198],Z([0,1,18,168,171,44,31,49,162,53,26,6,22,7,23,97,193,4,15]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var c;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished"})(c||(c={}));function a(..._){return String(_.reduce((T,W)=>T|W,0))}var l;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(l||(l={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class h{constructor(T=u){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(T,W=this.state.pageSize){return new h(Object.assign(Object.assign({},this.state),{pageNumber:T,pageSize:W}))}withFilter(T,...W){const k=[...this.state.criteria,...W.length?W.map(F=>({filterType:T,value:F})):[{filterType:T}]];return new h(Object.assign(Object.assign({},this.state),{criteria:k}))}withSortBy(T){return new h(Object.assign(Object.assign({},this.state),{sortBy:T}))}withSortOrder(T){return new h(Object.assign(Object.assign({},this.state),{sortOrder:T}))}withFlags(...T){return new h(Object.assign(Object.assign({},this.state),{flags:T.reduce((W,k)=>W|k,0)}))}withAssetTypes(...T){return new h(Object.assign(Object.assign({},this.state),{assetTypes:T}))}get raw(){const{criteria:T,pageNumber:W,pageSize:k,sortBy:F,sortOrder:U,flags:K,assetTypes:G}=this.state;return{filters:[{criteria:T,pageNumber:W,pageSize:k,sortBy:F,sortOrder:U}],assetTypes:G,flags:K}}get searchText(){const T=this.state.criteria.filter(W=>W.filterType===l.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function g(_,T){const W=(_||[]).filter(k=>k.statisticName===T)[0];return W?W.value:0}function d(_){const T="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(k=>k.assetType.indexOf(T)===0).reduce((k,F)=>{const U=z(_,F.assetType);return U&&k.push([F.assetType.substring(T.length),U]),k},[])}function y(_){if(_.properties){const T=_.properties.filter(F=>F.key===t.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),k=T.filter(F=>W.test(F.value))[0];return k?{uri:k.value,fallbackUri:k.value}:null}return z(_,t.Repository)}function L(_){return{uri:`${_.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${_.fallbackAssetUri}/${t.VSIX}`}}function O(_){const T=z(_,t.Icon);if(T)return T;const W=A.DefaultIconPath;return{uri:W,fallbackUri:W}}function z(_,T){return _.files.filter(k=>k.assetType===T)[0]?{uri:`${_.assetUri}/${T}`,fallbackUri:`${_.fallbackAssetUri}/${T}`}:null}function X(_,T){const W=_.properties?_.properties.filter(F=>F.key===T):[],k=W.length>0&&W[0].value;return k?k.split(",").map(F=>(0,R.adoptToGalleryExtensionId)(F)):[]}function x(_){const T=_.properties?_.properties.filter(W=>W.key===r.Engine):[];return T.length>0&&T[0].value||""}function H(_){const T=_.properties?_.properties.filter(k=>k.key===r.LocalizedLanguages):[],W=T.length>0&&T[0].value||"";return W?W.split(","):[]}function Q(_){return _.indexOf("preview")!==-1}function B(_){const T=_.properties?_.properties.find(W=>W.key===r.WebExtension):void 0;return!!T&&T.value==="true"}function N(_){return _.files.some(T=>T.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,o.joinPath)(b.URI.parse(_.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function C(_,T,W,k,F){const U={manifest:z(T,t.Manifest),readme:z(T,t.Details),changelog:z(T,t.Changelog),license:z(T,t.License),repository:y(T),download:L(T),icon:O(T),coreTranslations:d(T)};return{identifier:{id:(0,R.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:T.version,date:T.lastUpdated,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,description:_.shortDescription||"",installCount:g(_.statistics,"install"),rating:g(_.statistics,"averagerating"),ratingCount:g(_.statistics,"ratingcount"),assetUri:b.URI.parse(T.assetUri),webResource:N(T),assetTypes:T.files.map(({assetType:K})=>K),assets:U,properties:{dependencies:X(T,r.Dependency),extensionPack:X(T,r.ExtensionPack),engine:x(T),localizedLanguages:H(T),webExtension:B(T)},telemetryData:{index:(k.pageNumber-1)*k.pageSize+W,querySource:F},preview:Q(_.flags)}}let $=class{constructor(T,W,k,F,U,K,G){this.requestService=T,this.logService=W,this.environmentService=k,this.telemetryService=F,this.fileService=U,this.productService=K;const Y=K.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=V(K.version,this.environmentService,this.fileService,G)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,W){const k=[];let{total:F,firstPage:U,getPage:K}=await this.query({names:T,pageSize:T.length},W);k.push(...U);for(let G=1;k.length<F&&(U=await K(G,W),U.length);G++)k.push(...U);return k}async getCompatibleExtension(T,W){const k=await this.getCompatibleExtensionByEngine(T,W);return(k==null?void 0:k.properties.webExtension)?k.webResource?k:null:k}async getCompatibleExtensionByEngine(T,W){const k=(0,A.isIExtensionIdentifier)(T)?null:T;if(k&&k.properties.engine&&(0,w.isEngineValid)(k.properties.engine,this.productService.version,this.productService.date))return k;const{id:F,uuid:U}=k?k.identifier:T;let K=new h().withFlags(c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");U?K=K.withFilter(l.ExtensionId,U):K=K.withFilter(l.ExtensionName,F);const{galleryExtensions:G}=await this.queryGallery(K,n.CancellationToken.None),[Y]=G;if(!Y||!Y.versions.length)return null;if(W){const re=Y.versions.filter(se=>se.version===W)[0];if(re){const se=C(Y,re,0,K);if(se.properties.engine&&(0,w.isEngineValid)(se.properties.engine,this.productService.version,this.productService.date))return se}return null}const ee=await this.getLastValidExtensionVersion(Y,Y.versions);return ee?C(Y,ee,0,K):null}async query(T,W){const k=n.CancellationToken.isCancellationToken(T)?{}:T,F=n.CancellationToken.isCancellationToken(T)?T:W;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let U=k.text||"";const K=(0,S.getOrDefault)(k,oe=>oe.pageSize,50);let G=new h().withFlags(c.IncludeLatestVersionOnly,c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,K).withFilter(l.Target,"Microsoft.VisualStudio.Code");U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,ne,le)=>(G=G.withFilter(l.Category,le||ne),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,ne,le)=>(G=G.withFilter(l.Tag,le||ne),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(l.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),G=G.withFilter(l.SearchText,U)),G=G.withSortBy(0)):k.ids?G=G.withFilter(l.ExtensionId,...k.ids):k.names?G=G.withFilter(l.ExtensionName,...k.names):G=G.withSortBy(4),typeof k.sortBy=="number"&&(G=G.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(G=G.withSortOrder(k.sortOrder));const{galleryExtensions:Y,total:ee}=await this.queryGallery(G,F),re=Y.map((oe,ne)=>C(oe,oe.versions[0],ne,G,k.source)),se=async(oe,ne)=>{if(ne.isCancellationRequested)throw(0,v.canceled)();const le=G.withPage(oe+1),{galleryExtensions:ve}=await this.queryGallery(le,ne);return ve.map((we,Se)=>C(we,we.versions[0],Se,le,k.source))};return{firstPage:re,total:ee,pageSize:G.pageSize,getPage:se}}async queryGallery(T,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,c.ExcludeNonValidated).withFilter(l.ExcludeWithFlags,a(c.Unpublished));const k=await this.commonHeadersPromise,F=JSON.stringify(T.raw),U=Object.assign(Object.assign({},k),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(F.length)}),K=new Date().getTime();let G,Y,ee=0;try{if(G=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:F,headers:U},W),G.res.statusCode&&G.res.statusCode>=400&&G.res.statusCode<500)return{galleryExtensions:[],total:ee};const re=await(0,i.asJson)(G);if(re){const se=re.results[0],oe=se.extensions,ne=se.resultMetadata&&se.resultMetadata.filter(le=>le.metadataType==="ResultCount")[0];return ee=ne&&ne.metadataItems.filter(le=>le.name==="TotalCount")[0].count||0,{galleryExtensions:oe,total:ee}}return{galleryExtensions:[],total:ee}}catch(re){throw Y=re,re}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},T.telemetryData),{requestBodySize:String(F.length),duration:new Date().getTime()-K,success:!!G&&(0,i.isSuccess)(G),responseBodySize:G==null?void 0:G.res.headers["Content-Length"],statusCode:G?String(G.res.statusCode):void 0,errorCode:Y?(0,v.isPromiseCanceledError)(Y)?"canceled":(0,v.getErrorMessage)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ee)}))}}async reportStatistic(T,W,k,F){if(!!this.isEnabled()){const U=await this.commonHeadersPromise,K=Object.assign(Object.assign({},U),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${T}/extensions/${W}/${k}/stats?statType=${F}`),headers:K},n.CancellationToken.None)}catch(G){}}}async download(T,W,k){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const F=(0,R.getGalleryExtensionTelemetryData)(T),U=new Date().getTime(),K=re=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},F),{duration:re})),G=k===1?"install":k===2?"update":"",Y=G?{uri:`${T.assets.download.uri}&${G}=true`,fallbackUri:`${T.assets.download.fallbackUri}?${G}=true`}:T.assets.download,ee=await this.getAsset(Y);await this.fileService.writeFile(W,ee.stream),K(new Date().getTime()-U)}async getReadme(T,W){if(T.assets.readme){const k=await this.getAsset(T.assets.readme,{},W);return await(0,i.asText)(k)||""}return""}async getManifest(T,W){if(T.assets.manifest){const k=await this.getAsset(T.assets.manifest,{},W),F=await(0,i.asText)(k);return F?JSON.parse(F):null}return null}async getCoreTranslation(T,W){const k=T.assets.coreTranslations.filter(F=>F[0]===W.toUpperCase())[0];if(k){const F=await this.getAsset(k[1]),U=await(0,i.asText)(F);return U?JSON.parse(U):null}return null}async getChangelog(T,W){if(T.assets.changelog){const k=await this.getAsset(T.assets.changelog,{},W);return await(0,i.asText)(k)||""}return""}async getAllVersions(T,W){let k=new h().withFlags(c.IncludeVersions,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");T.identifier.uuid?k=k.withFilter(l.ExtensionId,T.identifier.uuid):k=k.withFilter(l.ExtensionName,T.identifier.id);const F=[],{galleryExtensions:U}=await this.queryGallery(k,n.CancellationToken.None);return U.length&&(W?await Promise.all(U[0].versions.map(async K=>{let G;try{G=await this.getEngine(K)}catch(Y){}G&&(0,w.isEngineValid)(G,this.productService.version,this.productService.date)&&F.push({version:K.version,date:K.lastUpdated})})):F.push(...U[0].versions.map(K=>({version:K.version,date:K.lastUpdated})))),F}async getAsset(T,W={},k=n.CancellationToken.None){const F=await this.commonHeadersPromise,U={type:"GET"},K=Object.assign(Object.assign({},F),W.headers||{});W=Object.assign(Object.assign(Object.assign({},W),U),{headers:K});const G=T.uri,Y=T.fallbackUri,ee=Object.assign(Object.assign({},W),{url:G});try{const re=await this.requestService.request(ee,k);if(re.res.statusCode===200)return re;const se=await(0,i.asText)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${se}`)}catch(re){if((0,v.isPromiseCanceledError)(re))throw re;const se=(0,v.getErrorMessage)(re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:G,message:se});const oe=Object.assign(Object.assign({},W),{url:Y});return this.requestService.request(oe,k)}}async getLastValidExtensionVersion(T,W){const k=this.getLastValidExtensionVersionFromProperties(T,W);return k||this.getLastValidExtensionVersionRecursively(T,W)}getLastValidExtensionVersionFromProperties(T,W){for(const k of W){const F=x(k);if(!F)return null;if((0,w.isEngineValid)(F,this.productService.version,this.productService.date))return k}return null}async getEngine(T){const W=x(T);if(W)return W;const k=z(T,t.Manifest);if(!k)throw new Error("Manifest was not found");const F={"Accept-Encoding":"gzip"},U=await this.getAsset(k,{headers:F}),K=await(0,i.asJson)(U);if(K)return K.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(T,W){if(!W.length)return null;const k=W[0],F=await this.getEngine(k);return(0,w.isEngineValid)(F,this.productService.version,this.productService.date)?(k.properties=k.properties||[],k.properties.push({key:r.Engine,value:F}),k):this.getLastValidExtensionVersionRecursively(T,W.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,i.asJson)(T),k=new Map;if(W)for(const F of W.malicious){const U=k.get(F)||{id:{id:F},malicious:!0,slow:!1};U.malicious=!0,k.set(F,U)}return[...k.values()]}};$=ue([te(0,i.IRequestService),te(1,E.ILogService),te(2,p.IEnvironmentService),te(3,M.ITelemetryService),te(4,P.IFileService),te(5,f.IProductService),te(6,(0,I.optional)(m.IStorageService))],$),e.ExtensionGalleryService=$;async function V(_,T,W,k){const F={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_}`},U=await(0,D.getServiceMachineId)(T,W,k);return F["X-Market-User-Id"]=U,F}e.resolveMarketplaceHeaders=V}),define(J[199],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(S){this.appender=S}listen(S,M){throw new Error(`Event not found: ${M}`)}call(S,M,{eventName:i,data:w}){return this.appender.log(i,w),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class A{constructor(S){this.channel=S}log(S,M){return this.channel.call("log",{eventName:S,data:M}).then(void 0,i=>`Failed to log telemetry: ${console.warn(i)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(J[200],Z([0,1,47,147,24,4,16,48,2,44,37]),function(j,e,v,A,R,S,M,i,w,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(f,m){this._configurationService=m,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appender=f.appender,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const I=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!I})}))}setExperimentProperty(f,m){this._experimentProperties[f]=m}setEnabled(f){this._enabled=f}_updateUserOptIn(){var f;const m=(f=this._configurationService)===null||f===void 0?void 0:f.getValue(P);this._userOptIn=m?m.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const f=await this._commonProperties;let m=f.sessionID,D=f["common.instanceId"],I=f["common.machineId"],o=f["common.firstSessionDate"],c=f["common.msftInternal"];return{sessionId:m,instanceId:D,machineId:I,firstSessionDate:o,msftInternal:c}}dispose(){this._disposables.dispose()}publicLog(f,m,D){return this.isOptedIn?this._commonProperties.then(I=>{m=(0,p.mixin)(m,I),m=(0,p.mixin)(m,this._experimentProperties),m=(0,p.cloneAndChange)(m,o=>{if(typeof o=="string")return this._cleanupInfo(o,D)}),this._appender.log(f,m)},I=>{console.error(I)}):Promise.resolve(void 0)}publicLog2(f,m,D){return this.publicLog(f,m,D)}publicLogError(f,m){return this.sendErrorTelemetry?this.publicLog(f,m,!0):Promise.resolve(void 0)}publicLogError2(f,m){return this.publicLogError(f,m)}_cleanupInfo(f,m){let D=f;if(m){const I=[];for(let l of this._cleanupPatterns)for(;;){const t=l.exec(f);if(!t)break;I.push([t.index,l.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(D="";;){const l=c.exec(f);if(!l)break;!o.test(l[0])&&I.every(([t,r])=>l.index<t||l.index>=r)&&(D+=f.substring(a,l.index)+"<REDACTED: user-file-path>",a=c.lastIndex)}a<f.length&&(D+=f.substr(a))}for(let I of this._cleanupPatterns)D=D.replace(I,"");return D}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=ue([te(1,(0,S.optional)(M.IConfigurationService))],E),e.TelemetryService=E;const P="telemetry";n.Registry.as(i.Extensions.Configuration).registerConfiguration({id:P,order:110,type:"object",title:(0,A.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,A.localize)(2,null,v.default.privacyStatementUrl):(0,A.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(J[98],Z([0,1,16,44,13,9]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(f,m){return Promise.resolve(void 0)}publicLog2(f,m){return this.publicLog(f,m)}publicLogError(f,m){return Promise.resolve(void 0)}publicLogError2(f,m){return this.publicLogError(f,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class M{async publicLog(m,D,I){}async publicLogError(m,D,I){}}e.NullEndpointTelemetryService=M;function i(...f){return{log:(m,D)=>f.forEach(I=>I.log(m,D)),flush:()=>S.Promises.settled(f.map(m=>m.flush()))}}e.combinedAppender=i,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(f,m){return m.onDidChangeConfiguration(D=>{D.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:(0,v.ConfigurationTargetToString)(D.source),configurationKeys:P(D.sourceConfig)})})}e.configurationTelemetry=w;function p(f){const m=Object.create(null),D=Object.create(null),I=Object.create(null);E(f,I);for(let o in I){o=o.length>150?o.substr(o.length-149):o;const c=I[o];typeof c=="number"?D[o]=c:typeof c=="boolean"?D[o]=c?1:0:typeof c=="string"?m[o]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(m[o]=c)}return{properties:m,measurements:D}}e.validateTelemetryData=p;function n(f){if(!f)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(I=>{f.indexOf(`${I}+`)===0&&(m=I)}),m}e.cleanRemoteAuthority=n;function E(f,m,D=0,I){if(!!f)for(let o of Object.getOwnPropertyNames(f)){const c=f[o],a=I?I+o:o;Array.isArray(c)?m[a]=(0,A.safeStringify)(c):c instanceof Date?m[a]=c.toISOString():(0,R.isObject)(c)?D<2?E(c,m,D+1,a+"."):m[a]=(0,A.safeStringify)(c):m[a]=c}}function P(f){if(!f)return[];const m=[];return b(m,"",f),m}function b(f,m,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(I=>b(f,m?`${m}.${I}`:I,D[I])):f.push(m)}}),define(J[201],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(J[202],Z([0,1,4,2,37,5,201,109]),function(j,e,v,A,R,S,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,v.createDecorator)("themeService");var w;(function(D){function I(o){return o&&typeof o=="object"&&typeof o.id=="string"}D.isThemeColor=I})(w=e.ThemeColor||(e.ThemeColor={}));function p(D){return{id:D}}e.themeColorFromId=p;var n;(function(D){function I(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||w.isThemeColor(t.color))}D.isThemeIcon=I;const o=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function c(t){const r=o.exec(t);if(!!r){let[,s]=r;return{id:s}}}D.fromString=c;function a(t,r){let s=t.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),r&&(s=`${s}~${r}`),{id:s}}D.modify=a;function l(t,r){var s,u;return t.id===r.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((u=r.color)===null||u===void 0?void 0:u.id)}D.isEqual=l,D.asClassNameArray=i.CSSIcon.asClassNameArray,D.asClassName=i.CSSIcon.asClassName,D.asCSSSelector=i.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function E(D){switch(D){case M.ColorScheme.DARK:return"vs-dark";case M.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class P{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,A.toDisposable)(()=>{const o=this.themingParticipants.indexOf(I);this.themingParticipants.splice(o,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new P;R.Registry.add(e.Extensions.ThemingContribution,b);function f(D){return b.onColorThemeChange(D)}e.registerThemingParticipant=f;class m extends A.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(o=>this.onThemeChange(o)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,o){let c=this.theme.getColor(I);return c&&o&&(c=o(c,this.theme)),c?c.toString():null}}e.Themable=m}),define(J[60],Z([0,1,14,3,38,4]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const M="#FFFFFF",i="#1E1E1E",w="#000000",p="theme",n="themeBackground",E="windowSplash";e.IThemeMainService=(0,S.createDecorator)("themeMainService");let P=class{constructor(f){this.stateMainService=f}getBackgroundColor(){if((A.isWindows||A.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return w;let f=this.stateMainService.getItem(n,null);if(!f){let m;(A.isWindows||A.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?m="hc-black":m=this.stateMainService.getItem(p,"vs-dark").split(" ")[0],f=m==="hc-black"?w:m==="vs"?M:i}return A.isMacintosh&&f.toUpperCase()===i&&(f="#171717"),f}saveWindowSplash(f,m){this.stateMainService.setItems([{key:p,data:m.baseTheme},{key:n,data:m.colorInfo.background},{key:E,data:m}]),typeof f=="number"&&this.updateBackgroundColor(f,m)}updateBackgroundColor(f,m){for(const D of v.BrowserWindow.getAllWindows())if(D.id===f){D.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};P=ue([te(0,R.IStateMainService)],P),e.ThemeMainService=P}),define(J[41],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var A;(function(S){S.Uninitialized="uninitialized",S.Idle="idle",S.CheckingForUpdates="checking for updates",S.AvailableForDownload="available for download",S.Downloading="downloading",S.Downloaded="downloaded",S.Updating="updating",S.Ready="ready"})(A=e.StateType||(e.StateType={}));var R;(function(S){S[S.Setup=0]="Setup",S[S.Archive=1]="Archive",S[S.Snap=2]="Snap"})(R=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(S,M)=>({type:"idle",updateType:S,error:M}),CheckingForUpdates:S=>({type:"checking for updates",explicit:S}),AvailableForDownload:S=>({type:"available for download",update:S}),Downloading:S=>({type:"downloading",update:S}),Downloaded:S=>({type:"downloaded",update:S}),Updating:S=>({type:"updating",update:S}),Ready:S=>({type:"ready",update:S})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(J[203],Z([0,1,37,48,148,3]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.Registry.as(A.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[204],Z([0,1,5,41]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class R{constructor(i){this.service=i}listen(i,w){switch(w){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${w}`)}call(i,w,p){switch(w){case"checkForUpdates":return this.service.checkForUpdates(p);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=R;class S{constructor(i){this.channel=i,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=A.State.Uninitialized,this.channel.listen("onStateChange")(w=>this.state=w),this.channel.call("_getInitialState").then(w=>this.state=w)}get state(){return this._state}set state(i){this._state=i,this._onStateChange.fire(i)}checkForUpdates(i){return this.channel.call("checkForUpdates",i)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=S}),define(J[99],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(J[205],Z([0,1,7]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class A{constructor(i){this.handler=i}listen(i,w){throw new Error(`Event not found: ${w}`)}call(i,w,p){switch(w){case"handleURL":return this.handler.handleURL(v.URI.revive(p[0]),p[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=A;class R{constructor(i){this.channel=i}handleURL(i,w){return this.channel.call("handleURL",[i.toJSON(),w])}}e.URLHandlerChannelClient=R;class S{constructor(i){this.next=i}async routeCall(i,w,p,n){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(p){const E=v.URI.revive(p);if(E&&E.query){const P=/\bwindowId=(\d+)/.exec(E.query);if(P){const b=P[1],f=new RegExp(`window:${b}`),m=i.connections.find(D=>f.test(D.ctx));if(m)return m}}}return this.next.routeCall(i,w,p,n)}routeEvent(i,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=S}),define(J[206],Z([0,1,7,9,2,23]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends R.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(p,n){const E=[...this.handlers.values()];return(0,A.first)(E.map(P=>()=>P.handleURL(p,n)),void 0,!1).then(P=>P||!1)}registerHandler(p){return this.handlers.add(p),(0,R.toDisposable)(()=>this.handlers.delete(p))}}e.AbstractURLService=M;let i=class extends M{constructor(p){super();this.productService=p}create(p){let{authority:n,path:E,query:P,fragment:b}=p||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return n&&E&&E.indexOf("/")!==0&&(E=`/${E}`),v.URI.from({scheme:this.productService.urlProtocol,authority:n,path:E,query:P,fragment:b})}};i=ue([te(0,S.IProductService)],i),e.NativeURLService=i}),define(J[207],Z([0,1,5,14,7,2,3,9]),function(j,e,v,A,R,S,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(n){try{return R.URI.parse(n)}catch(E){return null}}class p{constructor(E,P,b,f,m){if(this.urlService=P,this.uris=[],this.retryCount=0,this.flushDisposable=S.Disposable.None,this.disposables=new S.DisposableStore,this.uris=E,M.isWindows){const o=f.isBuilt?[]:[`"${f.appRoot}"`];o.push("--open-url","--"),A.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,o)}const D=v.Event.map(v.Event.fromNodeEventEmitter(A.app,"open-url",(o,c)=>({event:o,url:c})),({event:o,url:c})=>(o.preventDefault(),c));this.disposables.add(D(o=>{const c=w(o);!c||this.urlService.open(c,{originalUrl:o})})),b.getWindows().filter(o=>o.isReady).length>0?this.flush():v.Event.once(b.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(!(this.retryCount++>10)){const E=[];for(const P of this.uris)await this.urlService.open(P.uri,{originalUrl:P.url})||E.push(P);E.length!==0&&(this.uris=E,this.flushDisposable=(0,i.disposableTimeout)(()=>this.flush(),500))}}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=p}),define(J[76],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService"),e.webviewPartitionId="webview"}),define(J[208],Z([0,1,14,2,10,7,76]),function(j,e,v,A,R,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class i extends A.Disposable{constructor(){super();const p=v.session.fromPartition(M.webviewPartitionId),n=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(R.Schemas.vscodeWebview,n),p.protocol.registerFileProtocol(R.Schemas.vscodeWebview,n)}async handleWebviewRequest(p,n){try{const E=S.URI.parse(p.url),P=i.validWebviewFilePaths.get(E.path);if(typeof P=="string"){const b=E.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${P}`:`vs/workbench/contrib/webview/browser/pre/${P}`,f=R.FileAccess.asFileUri(b,j);return n(decodeURIComponent(f.fsPath))}}catch(E){}n({error:-10})}}e.WebviewProtocolProvider=i,i.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],Z([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(p){return!!p.workspaceUri}e.isWorkspaceToOpen=A;function R(p){return!!p.folderUri}e.isFolderToOpen=R;function S(p){return!!p.fileUri}e.isFileToOpen=S;function M(p){const n=i(p),E=p.getValue("window.menuBarVisibility");return E==="default"||n==="native"&&E==="compact"||v.isMacintosh&&v.isNative?"classic":E}e.getMenuBarVisibility=M;function i(p){if(v.isWeb)return"custom";const n=p.getValue("window");if(n){if(v.isMacintosh&&n.nativeTabs===!0||v.isMacintosh&&n.nativeFullScreen===!1)return"native";const b=n.titleBarStyle;if(b==="native"||b==="custom")return b}return v.isLinux?"native":"custom"}e.getTitleBarStyle=i;function w(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=w}),define(J[34],Z([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var A;(function(i){i[i.CLI=0]="CLI",i[i.DOCK=1]="DOCK",i[i.MENU=2]="MENU",i[i.DIALOG=3]="DIALOG",i[i.DESKTOP=4]="DESKTOP",i[i.API=5]="API"})(A=e.OpenContext||(e.OpenContext={}));const R=function(i=1){return{width:1024,height:768,mode:i}};e.defaultWindowState=R;var S;(function(i){i[i.Maximized=0]="Maximized",i[i.Normal=1]="Normal",i[i.Minimized=2]="Minimized",i[i.Fullscreen=3]="Fullscreen"})(S=e.WindowMode||(e.WindowMode={}));var M;(function(i){i[i.UNRESPONSIVE=1]="UNRESPONSIVE",i[i.CRASHED=2]="CRASHED",i[i.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(J[209],Z([0,1,14,2,74,76,208,34]),function(j,e,v,A,R,S,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let w=class extends A.Disposable{constructor(n,E){super();this.windowsMainService=E,this._register(new M.WebviewProtocolProvider);const P=v.session.fromPartition(S.webviewPartitionId);P.setPermissionRequestHandler((b,f,m)=>m(f==="clipboard-read")),P.setPermissionCheckHandler((b,f)=>f==="clipboard-read")}async setIgnoreMenuShortcuts(n,E){let P;if(typeof n.windowId=="number"){const{windowId:b}=n,f=this.windowsMainService.getWindowById(b);if(!(f==null?void 0:f.win))throw new Error(`Invalid windowId: ${b}`);P=f.win.webContents}else{const{webContentsId:b}=n;if(P=v.webContents.fromId(b),!P)throw new Error(`Invalid webContentsId: ${b}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(E)}};w=ue([te(0,R.ITunnelService),te(1,i.IWindowsMainService)],w),e.WebviewMainService=w}),define(J[210],Z([0,1,5,2,9]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class S extends A.Disposable{constructor({onDidOpenWindow:i,onDidFocusWindow:w,getActiveWindowId:p}){super();this.disposables=this._register(new A.DisposableStore),v.Event.latch(v.Event.any(i,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>p()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(i){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=i}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=S}),define(J[211],Z([0,1,7,15,4,36]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");var M;(function(P){P[P.EMPTY=1]="EMPTY",P[P.FOLDER=2]="FOLDER",P[P.WORKSPACE=3]="WORKSPACE"})(M=e.WorkbenchState||(e.WorkbenchState={}));function i(P){const b=P;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=i;function w(P){const b=P;return!!(b&&typeof b=="object"&&v.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=w;class p{constructor(b,f,m,D){this._id=b,this._configuration=m,this._ignorePathCasing=D,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=f}update(b){this._id=b.id,this._configuration=b.configuration,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b.with({scheme:b.scheme,authority:b.authority,path:b.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=p;class n{constructor(b,f){this.raw=f,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,A.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function E(P){return new n({uri:P,index:0,name:(0,A.basenameOrAuthority)(P)},{uri:P.toString()})}e.toWorkspaceFolder=E}),define(J[29],Z([0,1,4,151,211,7,3,8,15,105,43,10,39,30,73]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(N){return(typeof N=="string"?(0,i.extname)(N):(0,w.extname)(N))===m}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function I(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function o(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=o;function c(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=c;function a(N){const C=N;return typeof(C==null?void 0:C.id)=="string"&&S.URI.isUri(C.uri)}e.isSingleFolderWorkspaceIdentifier=a;function l(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=l;function t(N){const C=N;return typeof(C==null?void 0:C.id)=="string"&&S.URI.isUri(C.configPath)}e.isWorkspaceIdentifier=t;function r(N){const C=N;if(C==null?void 0:C.uri)return{id:C.id,uri:S.URI.revive(C.uri)};const $=N;if($==null?void 0:$.configPath)return{id:$.id,configPath:S.URI.revive($.configPath)};if(N==null?void 0:N.id)return{id:N.id}}e.reviveIdentifier=r;function s(N,C){return w.extUriBiasedIgnorePathCase.isEqualOrParent(N,C.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function u(N){return h(N)||g(N)}e.isStoredWorkspaceFolder=u;function h(N){const C=N;return typeof(C==null?void 0:C.path)=="string"&&(!C.name||typeof C.name=="string")}e.isRawFileWorkspaceFolder=h;function g(N){const C=N;return typeof(C==null?void 0:C.uri)=="string"&&(!C.name||typeof C.name=="string")}e.isRawUriWorkspaceFolder=g;function d(N,C,$,V,_=!M.isWindows,T){if(N.scheme!==V.scheme)return{name:$,uri:N.toString(!0)};let W=C?void 0:T.relativePath(V,N);if(W!==void 0)W.length===0?W=".":M.isWindows&&N.scheme===E.Schemas.file&&!_&&(W=W.replace(/\//g,"\\"));else if(N.scheme===E.Schemas.file)W=N.fsPath,M.isWindows&&(W=(0,P.normalizeDriveLetter)(W),_&&(W=(0,b.toSlashes)(W)));else{if(!T.isEqualAuthority(N.authority,V.authority))return{name:$,uri:N.toString(!0)};W=N.path}return{name:$,path:W}}e.getStoredWorkspaceFolder=d;function y(N,C,$){let V=[],_=new Set;const T=$.dirname(C);for(let W of N){let k;if(h(W))W.path&&(k=$.resolvePath(T,W.path));else if(g(W))try{k=S.URI.parse(W.uri),k.path[0]!=="/"&&(k=k.with({path:"/"+k.path}))}catch(F){console.warn(F)}if(k){let F=$.getComparisonKey(k);if(!_.has(F)){_.add(F);const U=W.name||$.basenameOrAuthority(k);V.push(new R.WorkspaceFolder({uri:k,name:U,index:V.length},W))}}}return V}e.toWorkspaceFolders=y;function L(N,C,$,V,_){let T=O(C,N);const W=_.dirname(C),k=_.dirname(V),F=[],U=z(T.folders);for(const ee of T.folders){const re=h(ee)?_.resolvePath(W,ee.path):S.URI.parse(ee.uri);let se;$?se=!1:se=!h(ee)||(0,i.isAbsolute)(ee.path),F.push(d(re,se,ee.name,k,U,_))}const K={insertSpaces:!1,tabSize:4,eol:M.isLinux||M.isMacintosh?`
`:`\r
`},G=p.setProperty(N,["folders"],F,K);let Y=p.applyEdits(N,G);return T.remoteAuthority===(0,f.getRemoteAuthority)(V)&&(Y=p.applyEdits(Y,p.removeProperty(Y,["remoteAuthority"],K))),Y}e.rewriteWorkspaceFileForNewLocation=L;function O(N,C){let $=n.parse(C);if($&&Array.isArray($.folders))$.folders=$.folders.filter(V=>u(V));else throw new Error(`${N} looks like an invalid workspace file.`);return $}function z(N){return M.isWindows?N.some(C=>h(C)&&C.path.indexOf("/")>=0):!0}e.useSlashForPath=z;function X(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function x(N){return typeof N.folderUri=="string"}function H(N){return typeof N.fileUri=="string"}function Q(N,C){const $={workspaces:[],files:[]};if(N){const V=function(T,W){for(let k=0;k<T.length;k++)try{W(T[k],k)}catch(F){C.warn(`Error restoring recent entry ${JSON.stringify(T[k])}: ${F.toString()}. Skip entry.`)}},_=N;if(Array.isArray(_.entries))V(_.entries,T=>{const W=T.label,k=T.remoteAuthority;X(T)?$.workspaces.push({label:W,remoteAuthority:k,workspace:{id:T.workspace.id,configPath:S.URI.parse(T.workspace.configPath)}}):x(T)?$.workspaces.push({label:W,remoteAuthority:k,folderUri:S.URI.parse(T.folderUri)}):H(T)&&$.files.push({label:W,remoteAuthority:k,fileUri:S.URI.parse(T.fileUri)})});else{const T=N;Array.isArray(T.workspaces3)&&V(T.workspaces3,(W,k)=>{const F=Array.isArray(T.workspaceLabels)&&T.workspaceLabels[k]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?$.workspaces.push({label:F,workspace:{id:W.id,configPath:S.URI.parse(W.configURIPath)}}):typeof W=="string"&&$.workspaces.push({label:F,folderUri:S.URI.parse(W)})}),Array.isArray(T.files2)&&V(T.files2,(W,k)=>{const F=Array.isArray(T.fileLabels)&&T.fileLabels[k]||void 0;typeof W=="string"&&$.files.push({label:F,fileUri:S.URI.parse(W)})})}}return $}e.restoreRecentlyOpened=Q;function B(N){const C={entries:[]};for(const $ of N.workspaces)o($)?C.entries.push({folderUri:$.folderUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority}):C.entries.push({workspace:{id:$.workspace.id,configPath:$.workspace.configPath.toString()},label:$.label,remoteAuthority:$.remoteAuthority});for(const $ of N.files)C.entries.push({fileUri:$.fileUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority});return C}e.toStoreData=B}),define(J[50],Z([0,1,4,29]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function R(S){const M=S;return M&&(0,A.isWorkspaceIdentifier)(M.workspace)}e.isWorkspaceBackupInfo=R}),define(J[51],Z([0,1,4,14,9,38,3,8,65,21,13,133,29,39,2,80]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,v.createDecorator)("dialogMainService");let D=class mt{constructor(o){this.stateMainService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new R.Queue}pickFileFolder(o,c){return this.doPick(Object.assign(Object.assign({},o),{pickFolders:!0,pickFiles:!0,title:(0,E.localize)(0,null)}),c)}pickFolder(o,c){return this.doPick(Object.assign(Object.assign({},o),{pickFolders:!0,title:(0,E.localize)(1,null)}),c)}pickFile(o,c){return this.doPick(Object.assign(Object.assign({},o),{pickFiles:!0,title:(0,E.localize)(2,null)}),c)}pickWorkspace(o,c){const a=(0,E.localize)(3,null),l=(0,b.mnemonicButtonLabel)((0,E.localize)(4,null)),t=P.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},o),{pickFiles:!0,title:a,filters:t,buttonLabel:l}),c)}async doPick(o,c){const a={title:o.title,buttonLabel:o.buttonLabel,filters:o.filters};a.defaultPath=o.defaultPath||this.stateMainService.getItem(mt.workingDirPickerStorageKey),(typeof o.pickFiles=="boolean"||typeof o.pickFolders=="boolean")&&(a.properties=void 0,o.pickFiles&&o.pickFolders&&(a.properties=["multiSelections","openDirectory","openFile","createDirectory"])),a.properties||(a.properties=["multiSelections",o.pickFolders?"openDirectory":"openFile","createDirectory"]),M.isMacintosh&&a.properties.push("treatPackageAsDirectory");const l=c||A.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(a,(0,n.withNullAsUndefined)(l));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(mt.workingDirPickerStorageKey,(0,i.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(o){if(o){let c=this.windowDialogQueues.get(o.id);return c||(c=new R.Queue,this.windowDialogQueues.set(o.id,c)),c}else return this.noWindowDialogueQueue}showMessageBox(o,c){return this.getWindowDialogQueue(c).queue(async()=>c?A.dialog.showMessageBox(c,o):A.dialog.showMessageBox(o))}async showSaveDialog(o,c){const a=this.acquireFileDialogLock(o,c);if(!a)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let l;return c?l=await A.dialog.showSaveDialog(c,o):l=await A.dialog.showSaveDialog(o),l.filePath=this.normalizePath(l.filePath),l})}finally{(0,f.dispose)(a)}}normalizePath(o){return o&&M.isMacintosh&&(o=(0,w.normalizeNFC)(o)),o}normalizePaths(o){return o.map(c=>this.normalizePath(c))}async showOpenDialog(o,c){o.defaultPath&&(await(0,p.exists)(o.defaultPath)||(o.defaultPath=void 0));const a=this.acquireFileDialogLock(o,c);if(!a)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let l;return c?l=await A.dialog.showOpenDialog(c,o):l=await A.dialog.showOpenDialog(o),l.filePaths=this.normalizePaths(l.filePaths),l})}finally{(0,f.dispose)(a)}}acquireFileDialogLock(o,c){if(!c)return f.Disposable.None;let a=this.windowFileDialogLocks.get(c.id);a||(a=new Set,this.windowFileDialogLocks.set(c.id,a));const l=(0,m.hash)(o);if(!a.has(l))return a.add(l),(0,f.toDisposable)(()=>{a==null||a.delete(l),(a==null?void 0:a.size)===0&&this.windowFileDialogLocks.delete(c.id)})}};D.workingDirPickerStorageKey="pickerWorkingDir",D=ue([te(0,S.IStateMainService)],D),e.DialogMainService=D}),define(J[212],Z([0,1,5,2,29]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class S extends A.Disposable{constructor(i,w){super();this.logService=i,this.storageMainService=w,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(i,w)=>(i?i.push(w):i=[w],i),S.STORAGE_CHANGE_DEBOUNCE_TIME)(i=>{i.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(i))}))}serializeGlobalStorageEvents(i){const w=new Map,p=new Set;return i.forEach(n=>{const E=this.storageMainService.globalStorage.get(n.key);typeof E=="string"?w.set(n.key,E):p.add(n.key)}),{changed:Array.from(w.entries()),deleted:Array.from(p.values())}}listen(i,w){switch(w){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${w}`)}async call(i,w,p){const n=(0,R.reviveIdentifier)(p.workspace),E=await this.withStorageInitialized(n);switch(w){case"getItems":return Array.from(E.items.entries());case"updateItems":{const P=p;if(P.insert)for(const[b,f]of P.insert)E.set(b,f);P.delete&&P.delete.forEach(b=>E.delete(b));break}case"close":{if(n)return E.close();break}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(i){const w=i?this.storageMainService.workspaceStorage(i):this.storageMainService.globalStorage;try{await w.init()}catch(p){this.logService.error(`StorageIPC#init: Unable to init ${i?"workspace":"global"} storage due to ${p}`)}return w}}e.StorageDatabaseChannel=S,S.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[213],Z([0,1,20,21,5,2,6,123,87,8,97,31,28,29]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class f extends S.Disposable{constructor(o){super();this.logService=o,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new R.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new w.Storage(new w.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const o=await this.doCreate();this.storage.dispose(),this.storage=o,this._register(o.onDidChangeStorage(a=>this._onDidChangeStorage.fire({key:a}))),await this.doInit(o);const c=o.getBoolean(n.IS_NEW_KEY);c===void 0?o.set(n.IS_NEW_KEY,!0):c&&o.set(n.IS_NEW_KEY,!1)}catch(o){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${o}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===M.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this.storage.items}get(o,c){return this.storage.get(o,c)}set(o,c){return this.storage.set(o,c)}delete(o){return this.storage.delete(o)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class m extends f{constructor(o,c,a){super(c);this.options=o,this.environmentService=a}async doCreate(){let o;return this.options.useInMemoryStorage?o=i.SQLiteStorageDatabase.IN_MEMORY_PATH:o=(0,p.join)(this.environmentService.globalStorageHome.fsPath,m.STORAGE_NAME),new w.Storage(new i.SQLiteStorageDatabase(o,{logging:this.createLogginOptions()}))}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(E.instanceStorageKey,void 0)===void 0&&o.set(E.instanceStorageKey,(0,P.generateUuid)()),o.get(E.firstSessionDateStorageKey,void 0)===void 0&&o.set(E.firstSessionDateStorageKey,new Date().toUTCString());const l=o.get(E.currentSessionDateStorageKey,void 0),t=new Date().toUTCString();o.set(E.lastSessionDateStorageKey,typeof l=="undefined"?null:l),o.set(E.currentSessionDateStorageKey,t)}}e.GlobalStorageMain=m,m.STORAGE_NAME="state.vscdb";class D extends f{constructor(o,c,a,l){super(a);this.workspace=o,this.options=c,this.environmentService=l}async doCreate(){const{storageFilePath:o,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new w.Storage(new i.SQLiteStorageDatabase(o,{logging:this.createLogginOptions()}),{hint:c?w.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:i.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,p.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,p.join)(o,D.WORKSPACE_STORAGE_NAME);return await(0,A.exists)(o)?{storageFilePath:c,wasCreated:!1}:(await v.promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let c;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const a=(0,p.join)(o,D.WORKSPACE_META_NAME);await(0,A.exists)(a)||await(0,A.writeFile)(a,JSON.stringify(c,void 0,2))}catch(a){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${a}`)}}}e.WorkspaceStorageMain=D,D.WORKSPACE_STORAGE_NAME="state.vscdb",D.WORKSPACE_META_NAME="workspace.json"}),define(J[100],Z([0,1,42,2,53,4,17,6,213]),function(j,e,v,A,R,S,M,i,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,S.createDecorator)("storageMainService");let p=class extends A.Disposable{constructor(E,P,b){super();this.logService=E,this.environmentService=P,this.lifecycleMainService=b,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async E=>{E.workspace&&this.workspaceStorage(E.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(E=>{E.join(this.globalStorage.close());for(const[,P]of this.mapWorkspaceToStorage)E.join(P.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const E=new w.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(E.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),E}createWorkspaceStorage(E){return new w.WorkspaceStorageMain(E,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(E){let P=this.mapWorkspaceToStorage.get(E.id);return P||(this.logService.trace(`StorageMainService: creating workspace storage (${E.id})`),P=this.createWorkspaceStorage(E),this.mapWorkspaceToStorage.set(E.id,P),(0,v.once)(P.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${E.id})`),this.mapWorkspaceToStorage.delete(E.id)})),P}};p=ue([te(0,i.ILogService),te(1,R.IEnvironmentService),te(2,M.ILifecycleMainService)],p),e.StorageMainService=p}),define(J[101],Z([0,1,7,29,15]),function(j,e,v,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function S(w,p,n){for(const P of w){const b=P.openedWorkspace;if((0,A.isWorkspaceIdentifier)(b)){const f=n(b);if(f){if(f.folders.some(m=>R.extUriBiasedIgnorePathCase.isEqualOrParent(p,m.uri)))return P}else if(R.extUriBiasedIgnorePathCase.isEqualOrParent(p,b.configPath))return P}}const E=w.filter(P=>(0,A.isSingleFolderWorkspaceIdentifier)(P.openedWorkspace)&&R.extUriBiasedIgnorePathCase.isEqualOrParent(p,P.openedWorkspace.uri));if(E.length)return E.sort((P,b)=>-(P.openedWorkspace.uri.path.length-b.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=S;function M(w,p){for(const n of w)if((0,A.isWorkspaceIdentifier)(n.openedWorkspace)&&R.extUriBiasedIgnorePathCase.isEqual(n.openedWorkspace.configPath,p)||(0,A.isSingleFolderWorkspaceIdentifier)(n.openedWorkspace)&&R.extUriBiasedIgnorePathCase.isEqual(n.openedWorkspace.uri,p))return n}e.findWindowOnWorkspaceOrFolder=M;function i(w,p){var n,E;const P=b=>p.some(f=>R.extUriBiasedIgnorePathCase.isEqual(v.URI.file(f),v.URI.file(b)));for(const b of w)if((E=(n=b.config)===null||n===void 0?void 0:n.extensionDevelopmentPath)===null||E===void 0?void 0:E.some(f=>P(f)))return b}e.findWindowOnExtensionDevelopmentPath=i}),define(J[214],Z([0,1,14,2,3,15,7,16,17,6,38,34,29]),function(j,e,v,A,R,S,M,i,w,p,n,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let b=class vt extends A.Disposable{constructor(c,a,l,t,r){super();this.windowsMainService=c,this.stateMainService=a,this.lifecycleMainService=l,this.logService=t,this.configurationService=r,this._state=f(this.stateMainService.getItem(vt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),t&&(c.lastActiveWindow=this.toWindowState(t))}const a=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);a&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const l=D(c);this.stateMainService.setItem(vt.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(c){if(!this.lifecycleMainService.quitRequested){const a=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(l=>{var t;const r=(0,P.isWorkspaceIdentifier)(c.openedWorkspace)&&((t=l.workspace)===null||t===void 0?void 0:t.id)===c.openedWorkspace.id,s=(0,P.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&l.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(l.folderUri,c.openedWorkspace.uri);(r||s)&&(l.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}}toWindowState(c){return{workspace:(0,P.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,P.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const a=this.doGetNewWindowState(c),l=this.configurationService.getValue("window");let t;return a.hasDefaultState?t=!!((l==null?void 0:l.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(l==null?void 0:l.restoreFullscreen)),t&&R.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(t=!1)),a.mode===3&&!t&&(a.mode=1),a}doGetNewWindowState(c){const a=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=c.workspace;if((0,P.isWorkspaceIdentifier)(h)){const d=this.state.openedWindows.filter(y=>y.workspace&&y.workspace.id===h.id).map(y=>y.uiState);if(d.length)return d[0]}if((0,P.isSingleFolderWorkspaceIdentifier)(h)){const d=this.state.openedWindows.filter(y=>y.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(y.folderUri,h.uri)).map(y=>y.uiState);if(d.length)return d[0]}else if(c.backupPath){const d=this.state.openedWindows.filter(y=>y.backupPath===c.backupPath).map(y=>y.uiState);if(d.length)return d[0]}const g=this.lastClosedState||this.state.lastActiveWindow;if(!a&&g)return g.uiState}let l;const t=v.screen.getAllDisplays();if(t.length===1)l=t[0];else{if(R.isMacintosh){const h=v.screen.getCursorScreenPoint();l=v.screen.getDisplayNearestPoint(h)}!l&&a&&(l=v.screen.getDisplayMatching(a.getBounds())),l||(l=v.screen.getPrimaryDisplay()||t[0])}let r=(0,E.defaultWindowState)();r.x=Math.round(l.bounds.x+l.bounds.width/2-r.width/2),r.y=Math.round(l.bounds.y+l.bounds.height/2-r.height/2);const s=this.configurationService.getValue("window");let u=!0;if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")r.mode=0,u=!1;else if(s.newWindowDimensions==="fullscreen")r.mode=3,u=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&a){const h=a.serializeWindowState();h.mode===3?r.mode=3:r=h,u=r.mode!==3&&s.newWindowDimensions==="offset"}}return u&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const a=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;a.some(l=>l.x===c.x||l.y===c.y);)c.x+=30,c.y+=30;return c}};b.windowsStateStorageKey="windowsState",b=ue([te(0,E.IWindowsMainService),te(1,n.IStateMainService),te(2,w.ILifecycleMainService),te(3,p.ILogService),te(4,i.IConfigurationService)],b),e.WindowsStateHandler=b;function f(o){const c={openedWindows:[]},a=o||{openedWindows:[]};return a.lastActiveWindow&&(c.lastActiveWindow=m(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=m(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(c.openedWindows=a.openedWindows.map(l=>m(l))),c}e.restoreWindowsState=f;function m(o){const c={uiState:o.uiState};return o.backupPath&&(c.backupPath=o.backupPath),o.remoteAuthority&&(c.remoteAuthority=o.remoteAuthority),o.folder&&(c.folderUri=M.URI.parse(o.folder)),o.workspaceIdentifier&&(c.workspace={id:o.workspaceIdentifier.id,configPath:M.URI.parse(o.workspaceIdentifier.configURIPath)}),c}function D(o){return{lastActiveWindow:o.lastActiveWindow&&I(o.lastActiveWindow),lastPluginDevelopmentHostWindow:o.lastPluginDevelopmentHostWindow&&I(o.lastPluginDevelopmentHostWindow),openedWindows:o.openedWindows.map(c=>I(c))}}e.getWindowsStateStoreData=D;function I(o){return{workspaceIdentifier:o.workspace&&{id:o.workspace.id,configURIPath:o.workspace.configPath.toString()},folder:o.folderUri&&o.folderUri.toString(),backupPath:o.backupPath,remoteAuthority:o.remoteAuthority,uiState:o.uiState}}}),define(J[56],Z([0,1,58,59,215,5,33,8,27,28,2,19,85,18,3]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(d){this.socket=d,this._errorListener=y=>{if(y){if(y.code==="EPIPE")return;(0,b.onUnexpectedError)(y)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const y=L=>d(E.VSBuffer.wrap(L));return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(d){return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(d){return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(d){if(!this.socket.destroyed)try{this.socket.write(d.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,b.onUnexpectedError)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,b.onUnexpectedError)(y)}}end(){this.socket.end()}drain(){return new Promise((d,y)=>{if(this.socket.bufferSize===0){d();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),d()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=m;var D;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var I;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(I||(I={}));class o extends n.Disposable{constructor(d,y,L,O){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=d,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=y,this._recordInflateBytes=O,y?(this._zlibInflate=R.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",z=>{console.error(z),(0,b.onUnexpectedError)(z),this._onClose.fire()}),this._zlibInflate.on("data",z=>{this._pendingInflateData.push(z)}),L&&(this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=R.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",z=>{console.error(z),(0,b.onUnexpectedError)(z),this._onClose.fire()}),this._zlibDeflate.on("data",z=>{this._pendingDeflateData.push(z)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new P.ChunkStream,this._register(this.socket.onData(z=>this._acceptChunk(z))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?E.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):E.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._totalOutgoingDataBytes+=d.byteLength,this._zlibDeflate?(this._zlibDeflate.write(d.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let y=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,y=y.slice(0,y.length-4),this._isEnded||this._write(E.VSBuffer.wrap(y),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(d,!1)}_write(d,y){let L=2;d.byteLength<126?L+=0:d.byteLength<2**16?L+=2:L+=8;const O=E.VSBuffer.alloc(L);if(y?O.writeUInt8(194,0):O.writeUInt8(130,0),d.byteLength<126)O.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){O.writeUInt8(126,1);let z=1;O.writeUInt8(d.byteLength>>>8&255,++z),O.writeUInt8(d.byteLength>>>0&255,++z)}else{O.writeUInt8(127,1);let z=1;O.writeUInt8(0,++z),O.writeUInt8(0,++z),O.writeUInt8(0,++z),O.writeUInt8(0,++z),O.writeUInt8(d.byteLength>>>24&255,++z),O.writeUInt8(d.byteLength>>>16&255,++z),O.writeUInt8(d.byteLength>>>8&255,++z),O.writeUInt8(d.byteLength>>>0&255,++z)}this._totalOutgoingWireBytes+=O.byteLength+d.byteLength,this.socket.write(E.VSBuffer.concat([O,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._totalIncomingWireBytes+=d.byteLength,this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const y=this._incomingData.peek(this._state.readLen),O=(y.readUInt8(0)&128)>>>7,z=y.readUInt8(1),X=(z&128)>>>7,x=z&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=O,this._state.mask=0}else if(this._state.state===2){const y=this._incomingData.read(this._state.readLen),L=y.readUInt8(1),O=(L&128)>>>7;let z=L&127,X=1;z===126?z=y.readUInt8(++X)*2**8+y.readUInt8(++X):z===127&&(z=y.readUInt8(++X)*0+y.readUInt8(++X)*0+y.readUInt8(++X)*0+y.readUInt8(++X)*0+y.readUInt8(++X)*2**24+y.readUInt8(++X)*2**16+y.readUInt8(++X)*2**8+y.readUInt8(++X));let x=0;O&&(x=y.readUInt8(++X)*2**24+y.readUInt8(++X)*2**16+y.readUInt8(++X)*2**8+y.readUInt8(++X)),this._state.state=3,this._state.readLen=z,this._state.mask=x}else if(this._state.state===3){const y=this._incomingData.read(this._state.readLen);c(y,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(y.buffer)),this._zlibInflate.write(y.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const L=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=L.length,this._onData.fire(E.VSBuffer.wrap(L))})):(this._totalIncomingDataBytes+=y.byteLength,this._onData.fire(y))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=o;function c(g,d){if(d!==0){let y=g.byteLength>>>2;for(let H=0;H<y;H++){const Q=g.readUInt32BE(H*4);g.writeUInt32BE(Q^d,H*4)}let L=y*4,O=g.byteLength-L;const z=d>>>24&255,X=d>>>16&255,x=d>>>8&255;O>=1&&g.writeUInt8(g.readUInt8(L)^z,L),O>=2&&g.writeUInt8(g.readUInt8(L+1)^X,L+1),O>=3&&g.writeUInt8(g.readUInt8(L+2)^x,L+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function l(){const g=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let d;return e.XDG_RUNTIME_DIR?d=(0,i.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):d=(0,i.join)((0,w.tmpdir)(),`vscode-ipc-${g}.sock`),r(d),d}e.createRandomIPCHandle=l;function t(g,d,y){const L=(0,v.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${y}-${d}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,i.join)(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${y}-${d}.sock`):O=(0,i.join)(g,`${y}-${d}.sock`),r(O),O}e.createStaticIPCHandle=t;function r(g){const d=a[f.platform];typeof d=="number"&&g.length>=d&&console.warn(`WARNING: IPC handle "${g}" is longer than ${d} chars, try a shorter --user-data-dir`)}class s extends M.IPCServer{constructor(d){super(s.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const y=S.Event.fromNodeEventEmitter(d,"connection");return S.Event.map(y,L=>({protocol:new P.Protocol(new m(L)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function u(g){return new Promise((d,y)=>{const L=(0,A.createServer)();L.on("error",y),L.listen(g,()=>{L.removeListener("error",y),d(new s(L))})})}e.serve=u;function h(g,d){return new Promise((y,L)=>{const O=(0,A.createConnection)(g,()=>{O.removeListener("error",L),y(P.Client.fromSocket(new m(O),d))});O.once("error",L)})}e.connect=h}),define(J[216],Z([0,1,56]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class A{constructor(w){this.driver=w}listen(w,p){throw new Error("No event found")}call(w,p,n){switch(p){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(n);case"reloadWindow":return this.driver.reloadWindow(n);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(n[0],n[1]);case"click":return this.driver.click(n[0],n[1],n[2],n[3]);case"doubleClick":return this.driver.doubleClick(n[0],n[1]);case"setValue":return this.driver.setValue(n[0],n[1],n[2]);case"getTitle":return this.driver.getTitle(n[0]);case"isActiveElement":return this.driver.isActiveElement(n[0],n[1]);case"getElements":return this.driver.getElements(n[0],n[1],n[2]);case"getElementXY":return this.driver.getElementXY(n[0],n[1],n[2]);case"typeInEditor":return this.driver.typeInEditor(n[0],n[1],n[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(n[0],n[1]);case"writeInTerminal":return this.driver.writeInTerminal(n[0],n[1],n[2])}throw new Error(`Call not found: ${p}`)}}e.DriverChannel=A;class R{constructor(w){this.channel=w}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(w){return this.channel.call("capturePage",w)}reloadWindow(w){return this.channel.call("reloadWindow",w)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(w,p){return this.channel.call("dispatchKeybinding",[w,p])}click(w,p,n,E){return this.channel.call("click",[w,p,n,E])}doubleClick(w,p){return this.channel.call("doubleClick",[w,p])}setValue(w,p,n){return this.channel.call("setValue",[w,p,n])}getTitle(w){return this.channel.call("getTitle",[w])}isActiveElement(w,p){return this.channel.call("isActiveElement",[w,p])}getElements(w,p,n){return this.channel.call("getElements",[w,p,n])}getElementXY(w,p,n,E){return this.channel.call("getElementXY",[w,p,n,E])}typeInEditor(w,p,n){return this.channel.call("typeInEditor",[w,p,n])}getTerminalBuffer(w,p){return this.channel.call("getTerminalBuffer",[w,p])}writeInTerminal(w,p,n){return this.channel.call("writeInTerminal",[w,p,n])}}e.DriverChannelClient=R;class S{constructor(w){this.registry=w}listen(w,p){throw new Error(`Event not found: ${p}`)}call(w,p,n){switch(p){case"registerWindowDriver":return this.registry.registerWindowDriver(n);case"reloadWindowDriver":return this.registry.reloadWindowDriver(n)}throw new Error(`Call not found: ${p}`)}}e.WindowDriverRegistryChannel=S;async function M(i){const w=await(0,v.connect)(i,"driverClient"),p=w.getChannel("driver"),n=new R(p);return{client:w,driver:n}}e.connect=M}),define(J[25],Z([0,1,8,46,4,53,160,56]),function(j,e,v,A,R,S,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,R.refineServiceDecorator)(S.IEnvironmentService);class w extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,v.join)(this.userDataPath,"clp")}get backupHome(){return(0,v.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,v.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,i.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}get chromeCachedDataDir(){return(0,v.join)(this.userDataPath,"Code Cache")}}ue([A.memoize],w.prototype,"cachedLanguagesPath",null),ue([A.memoize],w.prototype,"backupHome",null),ue([A.memoize],w.prototype,"backupWorkspacesPath",null),ue([A.memoize],w.prototype,"mainIPCHandle",null),ue([A.memoize],w.prototype,"sandbox",null),ue([A.memoize],w.prototype,"driverVerbose",null),ue([A.memoize],w.prototype,"disableUpdates",null),ue([A.memoize],w.prototype,"disableKeytar",null),ue([A.memoize],w.prototype,"nodeCachedDataDir",null),ue([A.memoize],w.prototype,"chromeCachedDataDir",null),e.EnvironmentMainService=w}),define(J[217],Z([0,1,20,58,8,3,21,50,25,16,22,6,29,7,30,10,15]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let I=class{constructor(c,a,l){this.configurationService=a,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=D.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>(0,f.isEqual)(t,r,!S.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await v.promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){c=Object.create(null)}c.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos));let a=[];try{Array.isArray(c.rootURIWorkspaces)&&(a=c.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:b.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(a);let l=[];try{Array.isArray(c.folderURIWorkspaces)&&(l=c.folderURIWorkspaces.map(t=>b.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==n.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===n.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var c;const a=this.configurationService.getValue();return((c=a==null?void 0:a.files)===null||c===void 0?void 0:c.hotExit)||n.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,a){this.workspaces.some(t=>c.workspace.id===t.workspace.id)||(this.workspaces.push(c),this.saveSync());const l=this.getBackupPath(c.workspace.id);return a&&this.moveBackupFolderSync(l,a),l}moveBackupFolderSync(c,a){if(v.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),v.existsSync(a))try{v.renameSync(a,c)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(c){const a=c.id,l=this.workspaces.findIndex(t=>t.workspace.id===a);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(a=>this.backupUriComparer.isEqual(c,a))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const a=this.folders.findIndex(l=>this.backupUriComparer.isEqual(c,l));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(c,a){const l=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:a}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(c){const a=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,c));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(c){return(0,R.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const a=new Set,l=[];for(let t of c){const r=t.workspace;if(!(0,P.isWorkspaceIdentifier)(r))return[];if(!a.has(r.id)){a.add(r.id);const s=this.getBackupPath(r.id);await this.doHasBackups(s)?r.configPath.scheme!==m.Schemas.file||await(0,M.exists)(r.configPath.fsPath)?l.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateFolders(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let t of c){const r=this.backupUriComparer.getComparisonKey(t);if(!l.has(r)){l.add(r);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==m.Schemas.file||await(0,M.exists)(t.fsPath)?a.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return a}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let t of c){const r=t.backupFolder;if(typeof r!="string")return[];if(!l.has(r)){l.add(r);const s=this.getBackupPath(r);await this.doHasBackups(s)?a.push(t):await this.deleteStaleBackup(s)}}return a}async deleteStaleBackup(c){try{await(0,M.exists)(c)&&await(0,M.rimraf)(c,M.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{await v.promises.rename(c,l)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{v.renameSync(c,l)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const c=[];for(const a of this.workspaces)await this.hasBackups(a)&&c.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&c.push(a);return c}hasBackups(c){let a;return b.URI.isUri(c)?a=this.getBackupPath(this.getFolderHash(c)):(0,i.isWorkspaceBackupInfo)(c)?a=this.getBackupPath(c.workspace.id):a=c.backupFolder,this.doHasBackups(a)}async doHasBackups(c){try{const a=await(0,M.readdir)(c);for(const l of a)try{if((await(0,M.readdir)((0,R.join)(c,l))).length>0)return!0}catch(t){}}catch(a){}return!1}saveSync(){try{(0,M.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await(0,M.writeFile)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderURIWorkspaces:this.folders.map(c=>c.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){let a;return c.scheme===m.Schemas.file?a=S.isLinux?c.fsPath:c.fsPath.toLowerCase():a=c.toString().toLowerCase(),(0,A.createHash)("md5").update(a).digest("hex")}};I=ue([te(0,w.IEnvironmentMainService),te(1,p.IConfigurationService),te(2,E.ILogService)],I),e.BackupMainService=I}),define(J[45],Z([0,1,20,40,83,145,82,5,34,14,17,3,25,51,21,7,31,4,27,66,6,8,23,46,2,60]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D,I,o,c,a,l,t,r,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,I.createDecorator)("nativeHostMainService");let h=class ht extends s.Disposable{constructor(d,y,L,O,z,X,x,H,Q){super();this.sharedProcess=d,this.windowsMainService=y,this.dialogMainService=L,this.lifecycleMainService=O,this.environmentMainService=z,this.telemetryService=X,this.logService=x,this.productService=H,this.themeMainService=Q,this.onDidOpenWindow=i.Event.map(this.windowsMainService.onDidOpenWindow,B=>B.id),this.onDidMaximizeWindow=i.Event.filter(i.Event.fromNodeEventEmitter(p.app,"browser-window-maximize",(B,N)=>N.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidUnmaximizeWindow=i.Event.filter(i.Event.fromNodeEventEmitter(p.app,"browser-window-unmaximize",(B,N)=>N.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidBlurWindow=i.Event.filter(i.Event.fromNodeEventEmitter(p.app,"browser-window-blur",(B,N)=>N.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidFocusWindow=i.Event.any(i.Event.map(i.Event.filter(i.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),B=>!!B),B=>B.id),i.Event.filter(i.Event.fromNodeEventEmitter(p.app,"browser-window-focus",(B,N)=>N.id),B=>!!this.windowsMainService.getWindowById(B))),this.onDidResumeOS=i.Event.fromNodeEventEmitter(p.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new i.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new i.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=i.Event.debounce(i.Event.any(i.Event.filter(i.Event.fromNodeEventEmitter(p.screen,"display-metrics-changed",(B,N,C)=>C),B=>!(Array.isArray(B)&&B.length===1&&B[0]==="workArea")),i.Event.fromNodeEventEmitter(p.screen,"display-added"),i.Event.fromNodeEventEmitter(p.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){p.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors,dark:p.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(y=>{var L,O;return{id:y.id,workspace:y.openedWorkspace,title:(O=(L=y.win)===null||L===void 0?void 0:L.getTitle())!==null&&O!==void 0?O:"",filename:y.getRepresentedFilename(),dirty:y.isDocumentEdited()}})}async getWindowCount(d){return this.windowsMainService.getWindowCount()}async getActiveWindowId(d){const y=p.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(y)return y.id}openWindow(d,y,L){return Array.isArray(y)?this.doOpenWindow(d,y,L):this.doOpenEmptyWindow(d,y)}async doOpenWindow(d,y,L=Object.create(null)){y.length>0&&this.windowsMainService.open({context:5,contextWindowId:d,urisToOpen:y,cli:this.environmentMainService.args,forceNewWindow:L.forceNewWindow,forceReuseWindow:L.forceReuseWindow,preferNewWindow:L.preferNewWindow,diffMode:L.diffMode,addMode:L.addMode,gotoLineMode:L.gotoLineMode,noRecentEntry:L.noRecentEntry,waitMarkerFileURI:L.waitMarkerFileURI,remoteAuthority:L.remoteAuthority||void 0})}async doOpenEmptyWindow(d,y){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:d},y)}async toggleFullScreen(d){const y=this.windowById(d);y&&y.toggleFullScreen()}async handleTitleDoubleClick(d){const y=this.windowById(d);y&&y.handleTitleDoubleClick()}async isMaximized(d){const y=this.windowById(d);return(y==null?void 0:y.win)?y.win.isMaximized():!1}async maximizeWindow(d){const y=this.windowById(d);(y==null?void 0:y.win)&&y.win.maximize()}async unmaximizeWindow(d){const y=this.windowById(d);(y==null?void 0:y.win)&&y.win.unmaximize()}async minimizeWindow(d){const y=this.windowById(d);(y==null?void 0:y.win)&&y.win.minimize()}async focusWindow(d,y){var L;y&&typeof y.windowId=="number"&&(d=y.windowId);const O=this.windowById(d);O&&O.focus({force:(L=y==null?void 0:y.force)!==null&&L!==void 0?L:!1})}async setMinimumSize(d,y,L){const O=this.windowById(d);if(O==null?void 0:O.win){const[z,X]=O.win.getSize(),[x,H]=O.win.getMinimumSize(),[Q,B]=[y!=null?y:x,L!=null?L:H],[N,C]=[Math.max(z,Q),Math.max(X,B)];(x!==Q||H!==B)&&O.win.setMinimumSize(Q,B),(z!==N||X!==C)&&O.win.setSize(N,C)}}async saveWindowSplash(d,y){this.themeMainService.saveWindowSplash(d,y)}async installShellCommand(d){const{source:y,target:L}=await this.getShellCommandLink();try{const{symbolicLink:O}=await f.SymlinkSupport.stat(y);if(O&&!O.dangling){const z=await(0,M.realpath)(y);if(L===z)return}await v.promises.unlink(y)}catch(O){if(O.code!=="ENOENT")throw O}try{await v.promises.symlink(L,y)}catch(O){if(O.code!=="EACCES"&&O.code!=="ENOENT")throw O;const{response:z}=await this.showMessageBox(d,{type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,S.localize)(1,null),(0,S.localize)(2,null)],cancelId:1});if(z===0)try{const X=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${L}' '${y}'\\" with administrator privileges"`;await(0,R.promisify)(A.exec)(X)}catch(X){throw new Error((0,S.localize)(3,null,y))}}}async uninstallShellCommand(d){const{source:y}=await this.getShellCommandLink();try{await v.promises.unlink(y)}catch(L){switch(L.code){case"EACCES":const{response:O}=await this.showMessageBox(d,{type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,S.localize)(5,null),(0,S.localize)(6,null)],cancelId:1});if(O===0)try{const z=`osascript -e "do shell script \\"rm '${y}'\\" with administrator privileges"`;await(0,R.promisify)(A.exec)(z)}catch(z){throw new Error((0,S.localize)(7,null,y))}break;case"ENOENT":break;default:throw L}}}async getShellCommandLink(){const d=(0,l.resolve)(this.environmentMainService.appRoot,"bin","code"),y=`/usr/local/bin/${this.productService.applicationName}`;if(!await(0,f.exists)(d))throw new Error((0,S.localize)(8,null,d));return{source:y,target:d}}async showMessageBox(d,y){return this.dialogMainService.showMessageBox(y,this.toBrowserWindow(d))}async showSaveDialog(d,y){return this.dialogMainService.showSaveDialog(y,this.toBrowserWindow(d))}async showOpenDialog(d,y){return this.dialogMainService.showOpenDialog(y,this.toBrowserWindow(d))}toBrowserWindow(d){const y=this.windowById(d);if(y==null?void 0:y.win)return y.win}async pickFileFolderAndOpen(d,y){const L=await this.dialogMainService.pickFileFolder(y);L&&(this.sendPickerTelemetry(L,y.telemetryEventName||"openFileFolder",y.telemetryExtraData),this.doOpenPicked(await Promise.all(L.map(async O=>await f.SymlinkSupport.existsDirectory(O)?{folderUri:m.URI.file(O)}:{fileUri:m.URI.file(O)})),y,d))}async pickFolderAndOpen(d,y){const L=await this.dialogMainService.pickFolder(y);L&&(this.sendPickerTelemetry(L,y.telemetryEventName||"openFolder",y.telemetryExtraData),this.doOpenPicked(L.map(O=>({folderUri:m.URI.file(O)})),y,d))}async pickFileAndOpen(d,y){const L=await this.dialogMainService.pickFile(y);L&&(this.sendPickerTelemetry(L,y.telemetryEventName||"openFile",y.telemetryExtraData),this.doOpenPicked(L.map(O=>({fileUri:m.URI.file(O)})),y,d))}async pickWorkspaceAndOpen(d,y){const L=await this.dialogMainService.pickWorkspace(y);L&&(this.sendPickerTelemetry(L,y.telemetryEventName||"openWorkspace",y.telemetryExtraData),this.doOpenPicked(L.map(O=>({workspaceUri:m.URI.file(O)})),y,d))}doOpenPicked(d,y,L){this.windowsMainService.open({context:3,contextWindowId:L,cli:this.environmentMainService.args,urisToOpen:d,forceNewWindow:y.forceNewWindow})}sendPickerTelemetry(d,y,L){const O=d?d.length:0;this.telemetryService.publicLog(y,Object.assign(Object.assign({},L),{outcome:O?"success":"canceled",numberOfPaths:O}))}async showItemInFolder(d,y){p.shell.showItemInFolder(y)}async setRepresentedFilename(d,y){const L=this.windowById(d);L&&L.setRepresentedFilename(y)}async setDocumentEdited(d,y){const L=this.windowById(d);L&&L.setDocumentEdited(y)}async openExternal(d,y){return E.isLinuxSnap?this.safeSnapOpenExternal(y):p.shell.openExternal(y),!0}safeSnapOpenExternal(d){const y=process.env.GDK_PIXBUF_MODULE_FILE,L=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,p.shell.openExternal(d),process.env.GDK_PIXBUF_MODULE_FILE=y,process.env.GDK_PIXBUF_MODULEDIR=L}moveItemToTrash(d,y){return p.shell.trashItem(y)}async isAdmin(){let d;return E.isWindows?d=(await new Promise((y,L)=>{j(["native-is-elevated"],y,L)}))():d=process.getuid()===0,d}async writeElevated(d,y,L,O){const z=await new Promise((X,x)=>{j(["sudo-prompt"],X,x)});return new Promise((X,x)=>{const H=[`"${this.cliPath}"`];(O==null?void 0:O.unlock)&&H.push("--file-chmod"),H.push("--file-write",`"${y.fsPath}"`,`"${L.fsPath}"`);const Q={name:this.productService.nameLong.replace("-",""),icns:E.isMacintosh&&this.environmentMainService.isBuilt?(0,l.join)((0,l.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};z.exec(H.join(" "),Q,(B,N,C)=>{N&&this.logService.trace(`[sudo-prompt] received stdout: ${N}`),C&&this.logService.trace(`[sudo-prompt] received stderr: ${C}`),B?x(B):X(void 0)})})}get cliPath(){return E.isWindows?this.environmentMainService.isBuilt?(0,l.join)((0,l.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,l.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):E.isLinux?this.environmentMainService.isBuilt?(0,l.join)((0,l.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,l.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,l.join)(this.environmentMainService.appRoot,"bin","code"):(0,l.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,o.totalmem)(),freemem:(0,o.freemem)(),loadavg:(0,o.loadavg)()}}async getOSProperties(){return{arch:(0,o.arch)(),platform:(0,o.platform)(),release:(0,o.release)(),type:(0,o.type)(),cpus:(0,o.cpus)()}}async getOSVirtualMachineHint(){return c.virtualMachineHint.value()}async killProcess(d,y,L){process.kill(y,L)}async readClipboardText(d,y){return p.clipboard.readText(y)}async writeClipboardText(d,y,L){return p.clipboard.writeText(y,L)}async readClipboardFindText(d){return p.clipboard.readFindText()}async writeClipboardFindText(d,y){return p.clipboard.writeFindText(y)}async writeClipboardBuffer(d,y,L,O){return p.clipboard.writeBuffer(y,Buffer.from(L),O)}async readClipboardBuffer(d,y){return p.clipboard.readBuffer(y)}async hasClipboard(d,y,L){return p.clipboard.has(y,L)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){p.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){p.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){p.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){p.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){p.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(d,y){const L=this.windowById(d);L&&L.updateTouchBar(y)}async notifyReady(d){const y=this.windowById(d);y&&y.setReady()}async relaunch(d,y){return this.lifecycleMainService.relaunch(y)}async reload(d,y){const L=this.windowById(d);if(L)return this.lifecycleMainService.reload(L,(y==null?void 0:y.disableExtensions)!==void 0?{_:[],"disable-extensions":y==null?void 0:y.disableExtensions}:void 0)}async closeWindow(d){this.closeWindowById(d,d)}async closeWindowById(d,y){const L=this.windowById(y);if(L==null?void 0:L.win)return L.win.close()}async quit(d){const y=this.windowsMainService.getLastActiveWindow();(y==null?void 0:y.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&y.win?y.win.close():this.lifecycleMainService.quit()}async exit(d,y){await this.lifecycleMainService.kill(y)}async resolveProxy(d,y){var L,O;const z=this.windowById(d),X=(O=(L=z==null?void 0:z.win)===null||L===void 0?void 0:L.webContents)===null||O===void 0?void 0:O.session;if(X)return X.resolveProxy(y)}async openDevTools(d,y){const L=this.windowById(d);(L==null?void 0:L.win)&&L.win.webContents.openDevTools(y)}async toggleDevTools(d){const y=this.windowById(d);(y==null?void 0:y.win)&&y.win.webContents.toggleDevTools()}async sendInputEvent(d,y){const L=this.windowById(d);(L==null?void 0:L.win)&&(y.type==="mouseDown"||y.type==="mouseUp")&&L.win.webContents.sendInputEvent(y)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(d,y,L,O){if(!!E.isWindows){const z=await new Promise((X,x)=>{j(["vscode-windows-registry"],X,x)});try{return z.GetStringRegKey(y,L,O)}catch(X){return}}}async getPassword(d,y,L){const O=await this.withKeytar(),z=await O.getPassword(y,L);if(z)try{let{content:X,hasNextChunk:x}=JSON.parse(z);if(!X||!x)return z;let H=1;for(;x;){const Q=await O.getPassword(y,`${L}-${H}`),B=JSON.parse(Q);X+=B.content,x=B.hasNextChunk}return X}catch(X){return z}return z}async setPassword(d,y,L,O){const z=await this.withKeytar();if(E.isWindows&&O.length>ht.MAX_PASSWORD_LENGTH){let X=0,x=0,H=!0;for(;H;){const Q=O.substring(X,X+ht.PASSWORD_CHUNK_SIZE);X+=ht.PASSWORD_CHUNK_SIZE,H=O.length-X>0;const B={content:Q,hasNextChunk:H};await z.setPassword(y,x?`${L}-${x}`:L,JSON.stringify(B)),x++}}else await z.setPassword(y,L,O);this._onDidChangePassword.fire({service:y,account:L})}async deletePassword(d,y,L){const z=await(await this.withKeytar()).deletePassword(y,L);return z&&this._onDidChangePassword.fire({service:y,account:L}),z}async findPassword(d,y){return(await this.withKeytar()).findPassword(y)}async findCredentials(d,y){return(await this.withKeytar()).findCredentials(y)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((d,y)=>{j(["keytar"],d,y)})}windowById(d){if(typeof d=="number")return this.windowsMainService.getWindowById(d)}};h.MAX_PASSWORD_LENGTH=2500,h.PASSWORD_CHUNK_SIZE=h.MAX_PASSWORD_LENGTH-100,ue([r.memoize],h.prototype,"cliPath",null),h=ue([te(1,w.IWindowsMainService),te(2,b.IDialogMainService),te(3,n.ILifecycleMainService),te(4,P.IEnvironmentMainService),te(5,D.ITelemetryService),te(6,a.ILogService),te(7,t.IProductService),te(8,u.IThemeMainService)],h),e.NativeHostMainService=h}),define(J[218],Z([0,1,2,5,80,14,6,34,45,90,28,23,26]),function(j,e,v,A,R,S,M,i,w,p,n,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var b;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(b||(b={}));let f=class extends v.Disposable{constructor(D,I,o,c,a){super();this.logService=D,this.windowsMainService=I,this.nativeHostMainService=o,this.encryptionMainService=c,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=b.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const D=A.Event.fromNodeEventEmitter(S.app,"login",(I,o,c,a,l)=>({event:I,webContents:o,req:c,authInfo:a,callback:l}));this._register(D(this.onLogin,this))}async onLogin({event:D,authInfo:I,req:o,callback:c}){if(!!I.isProxy){if(!this.pendingProxyResolve&&this.state===b.LoginDialogShown&&o.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}D.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(I);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(a==null?void 0:a.username,a==null?void 0:a.password)}}async resolveProxyCredentials(D){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const I=await this.doResolveProxyCredentials(D);if(I)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),I;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(D){var I,o,c,a;this.logService.trace("auth#doResolveProxyCredentials - enter",D);const l=String((0,R.hash)({scheme:D.scheme,host:D.host,port:D.port}));let t,r;try{const g=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l);if(g){const d=JSON.parse(await this.encryptionMainService.decrypt(g));t=d.username,r=d.password}}catch(g){this.logService.error(g)}if(this.state!==b.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=b.StoredCredentialsUsed,{username:t,password:r};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const u={authInfo:D,username:(o=(I=this.sessionCredentials)===null||I===void 0?void 0:I.username)!==null&&o!==void 0?o:t,password:(a=(c=this.sessionCredentials)===null||c===void 0?void 0:c.password)!==null&&a!==void 0?a:r,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",P.CancellationToken.None,u),this.state=b.LoginDialogShown;const h=await new Promise(g=>{var d;const y=async(L,O,z)=>{var X;if(O===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(X=s.win)===null||X===void 0||X.webContents.off("ipc-message",y),z){const x={username:z.username,password:z.password};try{if(z.remember){const H=await this.encryptionMainService.encrypt(JSON.stringify(x));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l,H)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,l)}catch(H){this.logService.error(H)}g({username:x.username,password:x.password})}else g(void 0)};(d=s.win)===null||d===void 0||d.webContents.on("ipc-message",y)});return this.sessionCredentials=h,h}};f=ue([te(0,M.ILogService),te(1,i.IWindowsMainService),te(2,w.INativeHostMainService),te(3,p.IEncryptionMainService),te(4,E.IProductService)],f),e.ProxyAuthHandler=f}),define(J[219],Z([0,1,216,155,34,56,2,33,57,175,3,5,79,107,9,17,45]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function I(a){return a<21}let o=class{constructor(l,t,r,s,u){this.windowServer=l,this.options=t,this.windowsMainService=r,this.lifecycleMainService=s,this.nativeHostMainService=u,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new E.Emitter}async registerWindowDriver(l){return this.registeredWindowIds.add(l),this.reloadingWindowIds.delete(l),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(l){this.reloadingWindowIds.add(l)}async getWindowIds(){return this.windowsMainService.getWindows().map(l=>l.id).filter(l=>this.registeredWindowIds.has(l)&&!this.reloadingWindowIds.has(l))}async capturePage(l){await this.whenUnfrozen(l);const t=this.windowsMainService.getWindowById(l);if(!(t==null?void 0:t.win))throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(l){await this.whenUnfrozen(l);const t=this.windowsMainService.getWindowById(l);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(l),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(l,t){await this.whenUnfrozen(l);const r=b.KeybindingParser.parseUserBinding(t);for(let s of r)await this._dispatchKeybinding(l,s)}async _dispatchKeybinding(l,t){if(t instanceof P.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const r=this.windowsMainService.getWindowById(l);if(!(r==null?void 0:r.win))throw new Error("Invalid window");const s=r.win.webContents,u=new w.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),g=new p.USLayoutResolvedKeybinding(u.toChord(),n.OS).getElectronAccelerator(),d=[];t.ctrlKey&&d.push("ctrl"),t.metaKey&&d.push("meta"),t.shiftKey&&d.push("shift"),t.altKey&&d.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:g,modifiers:d}),I(t.keyCode)||s.sendInputEvent({type:"char",keyCode:g,modifiers:d}),s.sendInputEvent({type:"keyUp",keyCode:g,modifiers:d}),await(0,f.timeout)(100)}async click(l,t,r,s){await(await this.getWindowDriver(l)).click(t,r,s)}async doubleClick(l,t){await(await this.getWindowDriver(l)).doubleClick(t)}async setValue(l,t,r){await(await this.getWindowDriver(l)).setValue(t,r)}async getTitle(l){return await(await this.getWindowDriver(l)).getTitle()}async isActiveElement(l,t){return await(await this.getWindowDriver(l)).isActiveElement(t)}async getElements(l,t,r){return await(await this.getWindowDriver(l)).getElements(t,r)}async getElementXY(l,t,r,s){return await(await this.getWindowDriver(l)).getElementXY(t,r,s)}async typeInEditor(l,t,r){await(await this.getWindowDriver(l)).typeInEditor(t,r)}async getTerminalBuffer(l,t){return await(await this.getWindowDriver(l)).getTerminalBuffer(t)}async writeInTerminal(l,t,r){await(await this.getWindowDriver(l)).writeInTerminal(t,r)}async getWindowDriver(l){await this.whenUnfrozen(l);const t=`window:${l}`,r=new i.StaticRouter(u=>u===t),s=this.windowServer.getChannel("windowDriver",r);return new A.WindowDriverChannelClient(s)}async whenUnfrozen(l){for(;this.reloadingWindowIds.has(l);)await E.Event.toPromise(this.onDidReloadingChange.event)}};o=ue([te(2,R.IWindowsMainService),te(3,m.ILifecycleMainService),te(4,D.INativeHostMainService)],o),e.Driver=o;async function c(a,l,t,r){const s=t.driverVerbose,u=r.createInstance(o,a,{verbose:s}),h=new v.WindowDriverRegistryChannel(u);a.registerChannel("windowDriverRegistry",h);const g=await(0,S.serve)(l),d=new v.DriverChannel(u);return g.registerChannel("driver",d),(0,M.combinedDisposable)(g,a)}e.serve=c}),define(J[220],Z([0,1,59,56]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,S,M,i){const w=n=>i(n,void 0),p=v.createConnection({host:R,port:S},()=>{p.removeListener("error",w);const n=Buffer.alloc(16);for(let f=0;f<16;f++)n[f]=Math.round(Math.random()*256);const E=n.toString("base64");let P=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${S}/?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`];p.write(P.join(`\r
`)+`\r
\r
`);const b=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(p.off("data",b),i(void 0,new A.NodeSocket(p)))};p.on("data",b)});p.once("error",w)}}}),define(J[221],Z([0,1,59,9,2,115,6,23,190,74,220,75]),function(j,e,v,A,R,S,M,i,w,p,n,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function P(D,I,o,c){return new b(D,I,o,c).waitForReady()}class b extends R.Disposable{constructor(I,o,c,a){super();this.suggestedLocalPort=a,this.public=!1,this._socketsDispose=new Map,this._options=I,this._server=v.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=l=>this._onConnection(l),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(o=>{o()})}async waitForReady(){var I;let o=await(0,S.findFreePortFaster)((I=this.suggestedLocalPort)!==null&&I!==void 0?I:this.tunnelRemotePort,2,1e3),c=null;return c=this._server.listen(o).address(),c||(o=0,c=this._server.listen(o).address()),this.tunnelLocalPort=c.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(I){I.pause();const o=await(0,w.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),c=o.getSocket().socket,a=o.readEntireBuffer();o.dispose(),a.byteLength>0&&I.write(a.buffer),I.on("end",()=>{this._socketsDispose.delete(I.localAddress),c.end()}),I.on("close",()=>c.end()),I.on("error",()=>{this._socketsDispose.delete(I.localAddress),c.destroy()}),c.on("end",()=>I.end()),c.on("close",()=>I.end()),c.on("error",()=>{I.destroy()}),I.pipe(c),c.pipe(I),this._socketsDispose.set(I.localAddress,()=>{I.end(),c.end()})}}let f=class extends p.AbstractTunnelService{constructor(I,o,c,a){super(o);this.socketFactory=I,this.signService=c,this.productService=a}retainOrCreateTunnel(I,o,c,a,l,t){const r=this.getTunnelFromMap(o,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,o,c,a,l,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${c} on local port ${a}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:I,signService:this.signService,logService:this.logService,ipcLogger:null},u=P(s,o,c,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(o,c,u),u}}};f=ue([te(1,M.ILogService),te(2,E.ISignService),te(3,i.IProductService)],f),e.BaseTunnelService=f;let m=class extends f{constructor(I,o,c){super(n.nodeSocketFactory,I,o,c)}};m=ue([te(0,M.ILogService),te(1,E.ISignService),te(2,i.IProductService)],m),e.TunnelService=m}),define(J[222],Z([0,1,215,192,2,13,18,191,16,6,19,53,92]),function(j,e,v,A,R,S,M,i,w,p,n,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let b=class extends R.Disposable{constructor(m,D,I){super();this.environmentService=D,this.logService=I,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,D){this.logService.trace("RequestService#request",m.url);const{proxyUrl:I,strictSSL:o}=this,c=Object.assign(Object.assign({},process.env),await(0,P.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),a=m.agent?m.agent:await(0,i.getProxyAgent)(m.url||"",c,{proxyUrl:I,strictSSL:o});return m.agent=a,m.strictSSL=o,this.authorization&&(m.headers=Object.assign(Object.assign({},m.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(m,D)}async getNodeRequest(m){return((0,A.parse)(m.url).protocol==="https:"?await new Promise((o,c)=>{j(["https"],o,c)}):await new Promise((o,c)=>{j(["http"],o,c)})).request}_request(m,D){return new Promise(async(I,o)=>{let c;const a=(0,A.parse)(m.url),l=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),t={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,S.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(t.auth=m.user+":"+m.password),c=l(t,r=>{const s=(0,S.isNumber)(m.followRedirects)?m.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&s>0&&r.headers.location)this._request(Object.assign(Object.assign({},m),{url:r.headers.location,followRedirects:s-1}),D).then(I,o);else{let u=r;r.headers["content-encoding"]==="gzip"&&(u=r.pipe((0,v.createGunzip)())),I({res:r,stream:(0,n.streamToBufferReadableStream)(u)})}}),c.on("error",o),m.timeout&&c.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&c.write(m.data),c.end(),D.onCancellationRequested(()=>{c.abort(),o((0,M.canceled)())})})}async resolveProxy(m){}};b=ue([te(0,w.IConfigurationService),te(1,E.INativeEnvironmentService),te(2,p.ILogService)],b),e.RequestService=b}),define(J[223],Z([0,1,222,14]),function(j,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function R(M){return A.net.request}class S extends v.RequestService{request(i,w){return super.request(Object.assign(Object.assign({},i||{}),{getRawRequest:R}),w)}}e.RequestMainService=S}),define(J[224],Z([0,1,47,14,25,9,6,17,60,10,3,2,86,13,5,55]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let D=class extends E.Disposable{constructor(o,c,a,l,t,r,s){super();this.machineId=o,this.userEnv=c,this.environmentMainService=a,this.lifecycleMainService=l,this.logService=t,this.themeMainService=r,this.protocolMainService=s,this.firstWindowConnectionBarrier=new S.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new f.Emitter),this.onDidError=f.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),A.ipcMain.on("vscode:createSharedProcessMessageChannel",async(o,c)=>this.onWindowConnection(o,c))}async onWindowConnection(o,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(o.sender.isDestroyed())return a.close();o.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[a])}onWillShutdown(){const o=this.window;!o||(!o.isDestroyed()&&!o.webContents.isDestroyed()&&o.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(o.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{o.close()}catch(c){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(o=>A.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),o()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(o=>A.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),o()}))})()),this._whenIpcReady}createWindow(){const o=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new A.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:p.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`],v8CacheOptions:n.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),o.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:v.default}),this.window.loadURL(p.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=o=>{var c;this.logService.trace("SharedProcess#close prevented"),o.preventDefault(),((c=this.window)===null||c===void 0?void 0:c.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(o,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(o,c,a)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${a}`})))}async connect(){await this.whenIpcReady;const o=(0,b.assertIsDefined)(this.window);return(0,P.connect)(o)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var o,c;return(c=(o=this.window)===null||o===void 0?void 0:o.isVisible())!==null&&c!==void 0?c:!1}};D=ue([te(2,R.IEnvironmentMainService),te(3,i.ILifecycleMainService),te(4,M.ILogService),te(5,w.IThemeMainService),te(6,m.IProtocolMainService)],D),e.SharedProcess=D}),define(J[225],Z([0,1,7,8,13,6,25,9,22,19]),function(j,e,v,A,R,S,M,i,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class n{constructor(b,f,m){this.storagePath=b,this.logService=f,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new i.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}}getItem(b,f){const m=this.storage[b];return(0,R.isUndefinedOrNull)(m)?f:m}setItem(b,f){this.setItems([{key:b,data:f}])}setItems(b){let f=!1;for(const{key:m,data:D}of b)this.storage[m]!==D&&((0,R.isUndefinedOrNull)(D)?(0,R.isUndefined)(this.storage[m])||(this.storage[m]=void 0,f=!0):(this.storage[m]=D,f=!0));f&&this.save()}removeItem(b){(0,R.isUndefined)(this.storage[b])||(this.storage[b]=void 0,this.save())}async save(b){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),b)}async doSave(){if(!!this.initializing){await this.initializing;const b=JSON.stringify(this.storage,null,4);if(b!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,p.VSBuffer.fromString(b)),this.lastSavedStorageContents=b}catch(f){this.logService.error(f)}}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=n;let E=class It{constructor(b,f,m){this.fileStorage=new n(v.URI.file((0,A.join)(b.userDataPath,It.STATE_FILE)),f,m)}async init(){return this.fileStorage.init()}getItem(b,f){return this.fileStorage.getItem(b,f)}setItem(b,f){this.fileStorage.setItem(b,f)}setItems(b){this.fileStorage.setItems(b)}removeItem(b){this.fileStorage.removeItem(b)}close(){return this.fileStorage.close()}};E.STATE_FILE="storage.json",E=ue([te(0,M.IEnvironmentMainService),te(1,S.ILogService),te(2,w.IFileService)],E),e.StateMainService=E}),define(J[77],Z([0,1,5,9,16,17,23,41,25,6,49,26]),function(j,e,v,A,R,S,M,i,w,p,n,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function P(f,m,D){return`${D.updateUrl}/api/update/${f}/${m}/${D.commit}`}e.createUpdateURL=P;let b=class{constructor(m,D,I,o,c,a){this.lifecycleMainService=m,this.configurationService=D,this.environmentMainService=I,this.requestService=o,this.logService=c,this.productService=a,this._state=i.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!!this.environmentMainService.isBuilt){if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),D=this.getProductQuality(m);if(!D){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(D),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(i.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,I=>this.logService.error(I))}}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return(0,A.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},E.CancellationToken.None).then(m=>m.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};b=ue([te(0,S.ILifecycleMainService),te(1,R.IConfigurationService),te(2,w.IEnvironmentMainService),te(3,n.IRequestService),te(4,p.ILogService),te(5,M.IProductService)],b),e.AbstractUpdateService=b}),define(J[226],Z([0,1,14,2,5,46,16,17,41,31,25,6,77,49,23]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends P.AbstractUpdateService{constructor(I,o,c,a,l,t,r){super(I,o,a,l,t,r);this.telemetryService=c,this.disposables=new A.DisposableStore}get onRawError(){return R.Event.fromNodeEventEmitter(v.autoUpdater,"error",(I,o)=>o)}get onRawUpdateNotAvailable(){return R.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return R.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(I,o,c)=>({url:o,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return R.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(I,o,c,a)=>({releaseNotes:o,version:c,productVersion:c,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(I){this.logService.error("UpdateService error:",I);const c=(this.state.type==="checking for updates"?this.state.explicit:!0)?I:void 0;this.setState(w.State.Idle(1,c))}buildUpdateFeedUrl(I){let o;this.productService.darwinUniversalAssetId?o=this.productService.darwinUniversalAssetId:o=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,P.createUpdateURL)(o,I,this.productService);try{v.autoUpdater.setFeedURL({url:c})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return c}doCheckForUpdates(I){this.setState(w.State.CheckingForUpdates(I)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(I){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(I))}onUpdateDownloaded(I){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:I.version}),this.setState(w.State.Ready(I)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([S.memoize],m.prototype,"onRawError",null),ue([S.memoize],m.prototype,"onRawUpdateNotAvailable",null),ue([S.memoize],m.prototype,"onRawUpdateAvailable",null),ue([S.memoize],m.prototype,"onRawUpdateDownloaded",null),m=ue([te(0,i.ILifecycleMainService),te(1,M.IConfigurationService),te(2,p.ITelemetryService),te(3,n.IEnvironmentMainService),te(4,b.IRequestService),te(5,E.ILogService),te(6,f.IProductService)],m),e.DarwinUpdateService=m}),define(J[227],Z([0,1,23,16,17,41,31,25,6,77,49,26,45]),function(j,e,v,A,R,S,M,i,w,p,n,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let b=class extends p.AbstractUpdateService{constructor(m,D,I,o,c,a,l,t){super(m,D,o,c,a,t);this.telemetryService=I,this.nativeHostMainService=l}buildUpdateFeedUrl(m){return(0,p.createUpdateURL)(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(S.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},E.CancellationToken.None).then(n.asJson).then(D=>{!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(D))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const I=m?D.message||D:void 0;this.setState(S.State.Idle(1,I))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(S.State.Idle(1))}};b=ue([te(0,R.ILifecycleMainService),te(1,A.IConfigurationService),te(2,M.ITelemetryService),te(3,i.IEnvironmentMainService),te(4,n.IRequestService),te(5,w.ILogService),te(6,P.INativeHostMainService),te(7,v.IProductService)],b),e.LinuxUpdateService=b}),define(J[228],Z([0,1,5,9,17,41,25,6,8,20,40,31]),function(j,e,v,A,R,S,M,i,w,p,n,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let P=class{constructor(m,D,I){if(this.lifecycleMainService=m,this.logService=I,this._state=S.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,D.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,o=>this.logService.error(o))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return(0,A.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};P=ue([te(0,R.ILifecycleMainService),te(1,M.IEnvironmentMainService),te(2,i.ILogService)],P);let b=class extends P{constructor(m,D,I,o,c,a){super(I,o,c);this.snap=m,this.snapRevision=D,this.telemetryService=a;const l=(0,p.watch)(w.dirname(this.snap)),t=v.Event.fromNodeEventEmitter(l,"change",(h,g)=>g),r=v.Event.filter(t,h=>h==="current"),u=v.Event.debounce(r,(h,g)=>g,2e3)(()=>this.checkForUpdates(!1));I.onWillShutdown(()=>{u.dispose(),l.close()})}doCheckForUpdates(){this.setState(S.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(m=>{m?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2)))},m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2,m.message||m))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+w.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((I,o)=>(0,p.realpath)(`${w.dirname(this.snap)}/current`,(c,a)=>c?o(c):I(a))),D=w.basename(m);return this.snapRevision!==D}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};b=ue([te(2,R.ILifecycleMainService),te(3,M.IEnvironmentMainService),te(4,i.ILogService),te(5,E.ITelemetryService)],b),e.SnapUpdateService=b}),define(J[229],Z([0,1,20,8,21,46,16,17,23,41,31,25,6,77,49,113,27,40,26,9,22,7,45]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D,I,o,c,a,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(g,d=1e3){for(;!g();)await(0,c.timeout)(d)}let s;function u(){return typeof s=="undefined"&&(s=v.existsSync(A.join(A.dirname(process.execPath),"unins000.exe"))?0:1),s}let h=class extends b.AbstractUpdateService{constructor(d,y,L,O,z,X,x,H,Q){super(d,y,O,z,X,Q);this.telemetryService=L,this.fileService=x,this.nativeHostMainService=H}get cachePath(){const d=A.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return v.promises.mkdir(d,{recursive:!0}).then(()=>d)}initialize(){super.initialize(),u()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(d){let y="win32";return process.arch!=="ia32"&&(y+=`-${process.arch}`),u()===1?y+="-archive":this.productService.target==="user"&&(y+="-user"),(0,b.createUpdateURL)(y,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(p.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},o.CancellationToken.None).then(f.asJson).then(y=>{const L=u();return!y||!y.url||!y.version||!y.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(p.State.Idle(L)),Promise.resolve(null)):L===1?(this.setState(p.State.AvailableForDownload(y)),Promise.resolve(null)):(this.setState(p.State.Downloading(y)),this.cleanup(y.version).then(()=>this.getUpdatePackagePath(y.version).then(O=>R.exists(O).then(z=>{if(z)return Promise.resolve(O);const X=y.url,x=y.hash,H=`${O}.tmp`;return this.requestService.request({url:X},o.CancellationToken.None).then(Q=>this.fileService.writeFile(l.URI.file(H),Q.stream)).then(x?()=>(0,m.checksum)(H,y.hash):()=>{}).then(()=>v.promises.rename(H,O)).then(()=>O)})).then(O=>{const z=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:O},z&&y.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(p.State.Downloaded(y)):this.setState(p.State.Ready(y))})))}).then(void 0,y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const L=d?y.message||y:void 0;this.setState(p.State.Idle(u(),L))}))}async doDownloadUpdate(d){d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(p.State.Idle(u()))}async getUpdatePackagePath(d){const y=await this.cachePath;return A.join(y,`CodeSetup-${this.productService.quality}-${d}.exe`)}async cleanup(d=null){const y=d?X=>!new RegExp(`${this.productService.quality}-${d}\\.exe$`).test(X):()=>!0,L=await this.cachePath,z=(await R.readdir(L)).filter(y).map(async X=>{try{await v.promises.unlink(A.join(L,X))}catch(x){}});await Promise.all(z)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const d=this.state.update;this.setState(p.State.Updating(d));const y=await this.cachePath;this.availableUpdate.updateFilePath=A.join(y,`CodeSetup-${this.productService.quality}-${d.version}.flag`),await R.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,I.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(p.State.Idle(u()))});const O=`${this.productService.win32MutexName}-ready`,z=await new Promise((X,x)=>{j(["windows-mutex"],X,x)});r(()=>z.isActive(O)).then(()=>this.setState(p.State.Ready(d)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?v.unlinkSync(this.availableUpdate.updateFilePath):(0,I.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return u()}};ue([S.memoize],h.prototype,"cachePath",null),h=ue([te(0,i.ILifecycleMainService),te(1,M.IConfigurationService),te(2,n.ITelemetryService),te(3,E.IEnvironmentMainService),te(4,f.IRequestService),te(5,P.ILogService),te(6,a.IFileService),te(7,t.INativeHostMainService),te(8,w.IProductService)],h),e.Win32UpdateService=h}),define(J[52],Z([0,1,29,25,8,21,20,3,5,6,58,43,10,2,15,4,153,23,14,13,50,51,101]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D,I,o,c,a,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,m.createDecorator)("workspacesManagementMainService");let r=class extends b.Disposable{constructor(g,d,y,L,O){super();this.environmentMainService=g,this.logService=d,this.backupMainService=y,this.dialogMainService=L,this.productService=O,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new w.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new w.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(g){if(!!this.isWorkspacePath(g)&&g.scheme===P.Schemas.file){let d;try{d=(0,M.readFileSync)(g.fsPath,"utf8")}catch(y){return}return this.doResolveWorkspace(g,d)}}isWorkspacePath(g){return(0,v.isUntitledWorkspace)(g,this.environmentMainService)||(0,v.hasWorkspaceFileExtension)(g)}doResolveWorkspace(g,d){try{const y=this.doParseStoredWorkspace(g,d),L=s(g);return{id:L.id,configPath:L.configPath,folders:(0,v.toWorkspaceFolders)(y.folders,L.configPath,f.extUriBiasedIgnorePathCase),remoteAuthority:y.remoteAuthority}}catch(y){this.logService.warn(y.toString())}}doParseStoredWorkspace(g,d){const y=(0,E.parse)(d);if(y&&Array.isArray(y.folders))y.folders=y.folders.filter(L=>(0,v.isStoredWorkspaceFolder)(L));else throw new Error(`${g.toString(!0)} looks like an invalid workspace file.`);return y}async createUntitledWorkspace(g,d){const{workspace:y,storedWorkspace:L}=this.newUntitledWorkspace(g,d),O=y.configPath.fsPath;return await M.promises.mkdir((0,R.dirname)(O),{recursive:!0}),await(0,S.writeFile)(O,JSON.stringify(L,null,"	")),y}createUntitledWorkspaceSync(g,d){const{workspace:y,storedWorkspace:L}=this.newUntitledWorkspace(g,d),O=y.configPath.fsPath;return(0,M.mkdirSync)((0,R.dirname)(O),{recursive:!0}),(0,S.writeFileSync)(O,JSON.stringify(L,null,"	")),y}newUntitledWorkspace(g=[],d){const y=(Date.now()+Math.round(Math.random()*1e3)).toString(),L=(0,f.joinPath)(this.untitledWorkspacesHome,y),O=(0,f.joinPath)(L,v.UNTITLED_WORKSPACE_NAME),z=[];for(const X of g)z.push((0,v.getStoredWorkspaceFolder)(X.uri,!0,X.name,L,!i.isWindows,f.extUriBiasedIgnorePathCase));return{workspace:s(O),storedWorkspace:{folders:z,remoteAuthority:d}}}async getWorkspaceIdentifier(g){return s(g)}isUntitledWorkspace(g){return(0,v.isUntitledWorkspace)(g.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(g){!this.isUntitledWorkspace(g)||(this.doDeleteUntitledWorkspaceSync(g),this._onDidDeleteUntitledWorkspace.fire(g))}async deleteUntitledWorkspace(g){this.deleteUntitledWorkspaceSync(g)}doDeleteUntitledWorkspaceSync(g){const d=(0,f.originalFSPath)(g.configPath);try{(0,S.rimrafSync)((0,R.dirname)(d));const y=(0,R.join)(this.environmentMainService.workspaceStorageHome.fsPath,g.id);(0,M.existsSync)(y)&&(0,S.writeFileSync)((0,R.join)(y,"obsolete"),"")}catch(y){this.logService.warn(`Unable to delete untitled workspace ${d} (${y}).`)}}getUntitledWorkspacesSync(){const g=[];try{const d=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(y=>(0,f.joinPath)(this.untitledWorkspacesHome,y,v.UNTITLED_WORKSPACE_NAME));for(const y of d){const L=s(y),O=this.resolveLocalWorkspaceSync(y);O?g.push({workspace:L,remoteAuthority:O.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(L)}}catch(d){d.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${d}).`)}return g}async enterWorkspace(g,d,y){if(!(!g||!g.win||!g.isReady)&&!!await this.isValidTargetWorkspacePath(g,d,y)){const O=this.doEnterWorkspace(g,s(y));if(!!O)return this._onDidEnterWorkspace.fire({window:g,workspace:O.workspace}),O}}async isValidTargetWorkspacePath(g,d,y){if(!y)return!0;if((0,v.isWorkspaceIdentifier)(g.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(g.openedWorkspace.configPath,y))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(d,y)){const L={title:this.productService.nameLong,type:"info",buttons:[(0,D.localize)(0,null)],message:(0,D.localize)(1,null,(0,f.basename)(y)),detail:(0,D.localize)(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(L,(0,c.withNullAsUndefined)(o.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(g,d){if(!!g.config){g.focus();let y;return g.config.extensionDevelopmentPath||(y=this.backupMainService.registerWorkspaceBackupSync({workspace:d,remoteAuthority:g.remoteAuthority},g.config.backupPath)),(0,v.isWorkspaceIdentifier)(g.openedWorkspace)&&this.isUntitledWorkspace(g.openedWorkspace)&&this.deleteUntitledWorkspaceSync(g.openedWorkspace),g.config.workspace=d,g.config.backupPath=y,{workspace:d,backupPath:y}}}};r=ue([te(0,A.IEnvironmentMainService),te(1,p.ILogService),te(2,a.IBackupMainService),te(3,l.IDialogMainService),te(4,I.IProductService)],r),e.WorkspacesManagementMainService=r;function s(h){function g(){let d=h.scheme===P.Schemas.file?(0,f.originalFSPath)(h):h.toString();return i.isLinux||(d=d.toLowerCase()),(0,n.createHash)("md5").update(d).digest("hex")}return{id:g(),configPath:h}}e.getWorkspaceIdentifier=s;function u(h,g){function d(){if(h.scheme!==P.Schemas.file)return(0,n.createHash)("md5").update(h.toString()).digest("hex");if(!g)try{g=(0,M.statSync)(h.fsPath)}catch(O){return}let L;return i.isLinux?L=g.ino:i.isMacintosh?L=g.birthtime.getTime():i.isWindows&&(typeof g.birthtimeMs=="number"?L=Math.floor(g.birthtimeMs):L=g.birthtime.getTime()),(0,n.createHash)("md5").update(h.fsPath).update(L?String(L):"").digest("hex")}const y=d();if(typeof y=="string")return{id:y,uri:h}}e.getSingleFolderWorkspaceIdentifier=u}),define(J[102],Z([0,1,6,99,3,4,34,21,52,16,7,14,35,54,26,29,13]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,S.createDecorator)(e.ID);let I=class{constructor(c,a,l,t,r){this.logService=c,this.windowsMainService=a,this.urlService=l,this.workspacesManagementMainService=t,this.configurationService=r}async start(c,a){this.logService.trace("Received data from other instance: ",c,a),R.isMacintosh&&E.app.focus({steal:!0});const l=this.parseOpenUrl(c);if(l.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:r,url:s}of l)this.urlService.open(r,{originalUrl:s})})}else return this.startOpenWindow(c,a)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,P.coalesce)(c._urls.map(a=>{try{return{uri:n.URI.parse(a),url:a}}catch(l){return null}})):[]}async startOpenWindow(c,a){const l=(0,b.isLaunchedFromCli)(a)?0:4;let t=[];const r=c.wait&&c.waitMarkerFilePath?n.URI.file(c.waitMarkerFilePath):void 0,s=c.remote||void 0;if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,{context:l,cli:c,userEnv:a,waitMarkerFileURI:r,remoteAuthority:s});else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let u=!1;if(c["new-window"]||c["unity-launch"])u=!0;else if(c["reuse-window"])u=!1;else{const h=this.configurationService.getValue("window");switch((h==null?void 0:h.openWithoutArgumentsInNewWindow)||"default"){case"on":u=!0;break;case"off":u=!1;break;default:u=!R.isMacintosh}}if(u)t=this.windowsMainService.open({context:l,cli:c,userEnv:a,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:r,remoteAuthority:s});else{const h=this.windowsMainService.getLastActiveWindow();h?(h.focus(),t=[h]):t=this.windowsMainService.open({context:l,cli:c,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:l,cli:c,userEnv:a,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],waitMarkerFileURI:r,gotoLineMode:c.goto,remoteAuthority:s});if(r&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,i.whenDeleted)(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return E.BrowserWindow.getAllWindows().forEach(a=>{const l=this.windowsMainService.getWindowById(a.id);l?c.push(this.codeWindowToInfo(l)):c.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(t=>new Promise(r=>{const s=t.remoteAuthority;if(s){const u=`vscode:getDiagnosticInfoResponse${t.id}`,h={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",f.CancellationToken.None,{replyChannel:u,args:h}),E.ipcMain.once(u,(g,d)=>{d||r({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),r(d)}),setTimeout(()=>{r({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else r(void 0)})))).filter(t=>!!t)}getFolderURIs(c){const a=[],l=c.openedWorkspace;if((0,m.isSingleFolderWorkspaceIdentifier)(l))a.push(l.uri);else if((0,m.isWorkspaceIdentifier)(l)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);t&&t.folders.forEach(s=>{a.push(s.uri)})}return a}codeWindowToInfo(c){const a=this.getFolderURIs(c),l=(0,D.assertIsDefined)(c.win);return this.browserWindowToInfo(l,a,c.remoteAuthority)}browserWindowToInfo(c,a=[],l){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:a,remoteAuthority:l}}};I=ue([te(0,v.ILogService),te(1,M.IWindowsMainService),te(2,A.IURLService),te(3,w.IWorkspacesManagementMainService),te(4,p.IConfigurationService)],I),e.LaunchMainService=I}),define(J[230],Z([0,1,143,27,47,14,102,70,25,3,6,84,51,4,61,10,45,55,2]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,b.createDecorator)("issueMainService");let c=class Pt{constructor(l,t,r,s,u,h,g,d){this.userEnv=l,this.environmentMainService=t,this.launchMainService=r,this.logService=s,this.diagnosticsService=u,this.dialogMainService=h,this.nativeHostMainService=g,this.protocolMainService=d,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){S.ipcMain.on("vscode:issueSystemInfoRequest",async l=>{const[t,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(t,r);this.safeSend(l,"vscode:issueSystemInfoResponse",s)}),S.ipcMain.on("vscode:listProcesses",async l=>{const t=[];try{const r=await this.launchMainService.getMainProcessId();t.push({name:(0,v.localize)(0,null),rootProcess:await(0,E.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(u=>{(0,i.isRemoteDiagnosticError)(u)?t.push({name:u.hostName,rootProcess:u}):u.processes&&t.push({name:u.hostName,rootProcess:u.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(l,"vscode:listProcessesResponse",t)}),S.ipcMain.on("vscode:issueReporterClipboard",async l=>{const t={message:(0,v.localize)(1,null),type:"warning",buttons:[(0,v.localize)(2,null),(0,v.localize)(3,null)]};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(l,"vscode:issueReporterClipboardResponse",r.response===0)}}),S.ipcMain.on("vscode:issuePerformanceInfoRequest",async l=>{const t=await this.getPerformanceInfo();this.safeSend(l,"vscode:issuePerformanceInfoResponse",t)}),S.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const l={message:(0,v.localize)(4,null),type:"warning",buttons:[(0,v.localize)(5,null),(0,v.localize)(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(l,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),S.ipcMain.on("vscode:workbenchCommand",(l,t)=>{const{id:r,from:s,args:u}=t;let h;switch(s){case"issueReporter":h=this.issueReporterParentWindow;break;case"processExplorer":h=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}h&&h.webContents.send("vscode:runAction",{id:r,from:s,args:u})}),S.ipcMain.on("vscode:openExternal",(l,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),S.ipcMain.on("vscode:closeIssueReporter",l=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),S.ipcMain.on("vscode:closeProcessExplorer",l=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),S.ipcMain.on("vscode:windowsInfoRequest",async l=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(l,"vscode:windowsInfoResponse",t.windows)})}safeSend(l,t,...r){l.sender.isDestroyed()||l.sender.send(t,...r)}async openReporter(l){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new o.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(u,s,{backgroundColor:l.styles.backgroundColor,title:(0,v.localize)(7,null),zoomLevel:l.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:l,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,A.type)(),arch:(0,A.arch)(),release:(0,A.release)()},product:R.default}),this.issueReporterWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(l){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new o.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(u,s,{backgroundColor:l.styles.backgroundColor,title:(0,v.localize)(8,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:l,product:R.default}),this.processExplorerWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(l,t,r){const s=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:r.title,backgroundColor:r.backgroundColor||Pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--context-isolation"],v8CacheOptions:p.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,f.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return s.setMenuBarVisibility(!1),s}async getSystemStatus(){const[l,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(l,t)}getWindowPosition(l,t,r){let s;const u=S.screen.getAllDisplays();if(u.length===1)s=u[0];else{if(p.isMacintosh){const d=S.screen.getCursorScreenPoint();s=S.screen.getDisplayNearestPoint(d)}!s&&l&&(s=S.screen.getDisplayMatching(l.getBounds())),s||(s=S.screen.getPrimaryDisplay()||u[0])}const h={width:t,height:r},g=s.bounds;return h.x=g.x+g.width/2-h.width/2,h.y=g.y+g.height/2-h.height/2,g.width>0&&g.height>0&&(h.x<g.x&&(h.x=g.x),h.y<g.y&&(h.y=g.y),h.x>g.x+g.width&&(h.x=g.x),h.y>g.y+g.height&&(h.y=g.y),h.width>g.width&&(h.width=g.width),h.height>g.height&&(h.height=g.height)),h}async getPerformanceInfo(){try{const[l,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(l,t)}catch(l){throw this.logService.warn("issueService#getPerformanceInfo ",l.message),l}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=ue([te(1,w.IEnvironmentMainService),te(2,M.ILaunchMainService),te(3,n.ILogService),te(4,i.IDiagnosticsService),te(5,P.IDialogMainService),te(6,D.INativeHostMainService),te(7,I.IProtocolMainService)],c),e.IssueMainService=c}),define(J[231],Z([0,1,8,149,72,5,7,14,25,6,16,23,61,2,3,34,29,52,50,198,60,31,51,39,202,17,100,22,10,54,26,55]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D,I,o,c,a,l,t,r,s,u,h,g,d,y,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var z;(function(x){x[x.NONE=0]="NONE",x[x.LOADING=1]="LOADING",x[x.NAVIGATING=2]="NAVIGATING",x[x.READY=3]="READY"})(z||(z={}));let X=class extends b.Disposable{constructor(H,Q,B,N,C,$,V,_,T,W,k,F,U,K){super();this.logService=Q,this.environmentMainService=B,this.fileService=N,this.configurationService=$,this.themeMainService=V,this.workspacesManagementMainService=_,this.backupMainService=T,this.telemetryService=W,this.dialogMainService=k,this.lifecycleMainService=F,this.productService=U,this.protocolMainService=K,this._onWillLoad=this._register(new S.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new S.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new S.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new S.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[G,Y]=this.restoreWindowState(H.state);this.windowState=G,this.logService.trace("window#ctor: using window state",G);const ee=this.windowState.mode===0||this.windowState.mode===3,re=this.configurationService.getValue("window"),se={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:P.WindowMinimumSize.WIDTH,minHeight:P.WindowMinimumSize.HEIGHT,show:!ee,title:this.productService.nameLong,webPreferences:Object.assign({preload:d.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:f.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:(0,P.zoomLevelToZoomFactor)(re==null?void 0:re.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};f.browserCodeLoadingCacheStrategy?this.logService.info(`window#ctor: using vscode-file:// protocol and V8 cache options: ${f.browserCodeLoadingCacheStrategy}`):this.logService.trace("window#ctor: vscode-file:// protocol is explicitly disabled"),f.isLinux?se.icon=(0,v.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):f.isWindows&&!this.environmentMainService.isBuilt&&(se.icon=(0,v.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),f.isMacintosh&&!this.useNativeFullScreen()&&(se.fullscreenable=!1),f.isMacintosh&&(se.acceptFirstMouse=!0,(re==null?void 0:re.clickThroughInactive)===!1&&(se.acceptFirstMouse=!1));const oe=f.isMacintosh&&(re==null?void 0:re.nativeTabs)===!0;oe&&(se.tabbingIdentifier=this.productService.nameShort);const ne=(0,P.getTitleBarStyle)(this.configurationService)==="custom";if(ne&&(se.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,f.isMacintosh||(se.frame=!1)),(0,R.mark)("code/willCreateCodeBrowserWindow"),this._win=new i.BrowserWindow(se),(0,R.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),f.isMacintosh&&ne&&this._win.setSheetOffset(22),f.isMacintosh&&Y&&(!oe||i.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(le=>typeof le=="number")){const le=this.windowState;this._win.setBounds({width:le.width,height:le.height,x:le.x,y:le.y})}ee&&((0,R.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,R.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,c.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:G=>C.globalStorage.get(G),store:(G,Y)=>C.globalStorage.set(G,Y)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var H;return(H=this.currentConfig)===null||H===void 0?void 0:H.backupPath}get openedWorkspace(){var H;return(H=this.currentConfig)===null||H===void 0?void 0:H.workspace}get remoteAuthority(){var H;return(H=this.currentConfig)===null||H===void 0?void 0:H.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var H;return!!((H=this.currentConfig)===null||H===void 0?void 0:H.extensionDevelopmentPath)}get isExtensionTestHost(){var H;return!!((H=this.currentConfig)===null||H===void 0?void 0:H.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var H;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((H=this.currentConfig)===null||H===void 0?void 0:H.debugId)}setRepresentedFilename(H){f.isMacintosh?this._win.setRepresentedFilename(H):this.representedFilename=H}getRepresentedFilename(){return f.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(H){f.isMacintosh&&this._win.setDocumentEdited(H),this.documentEdited=H}isDocumentEdited(){return f.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(H){f.isMacintosh&&(H==null?void 0:H.force)&&i.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(H=>{if(this.isReady)return H(this);this.whenReadyCallbacks.push(H)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(H=>{function Q(){B.dispose(),N.dispose(),H()}const B=this.onDidClose(()=>Q()),N=this.onWillLoad(()=>Q())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(N,C)=>this.onWindowError(2,C)),this._win.webContents.on("did-fail-load",(N,C,$)=>this.onWindowError(3,$)),this._win.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const H=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Q=N=>{for(let C=N;C;C=C.parent)if(C.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1};this._win.webContents.session.webRequest.onBeforeRequest((N,C)=>{const $=M.URI.parse(N.url);if($.path.endsWith(".svg")&&!(H.has($.scheme)||$.path.includes(d.Schemas.vscodeRemoteResource))){const _=Q(N.frame);return C({cancel:!_})}return C({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((N,C)=>{const $=N.responseHeaders,V=$["content-type"]||$["Content-Type"];if(V&&Array.isArray(V)){const _=M.URI.parse(N.url);if(_.path.endsWith(".svg")&&H.has(_.scheme))return $["Content-Type"]=["image/svg+xml"],C({cancel:!1,responseHeaders:$});if(!_.path.includes(d.Schemas.vscodeRemoteResource)&&V.some(T=>T.toLowerCase().includes("image/svg"))){const T=Q(N.frame);return C({cancel:!T})}}return C({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",N=>{this.currentConfig&&(this.currentConfig.maximized=!0),i.app.emit("browser-window-maximize",N,this._win)}),this._win.on("unmaximize",N=>{this.currentConfig&&(this.currentConfig.maximized=!1),i.app.emit("browser-window-unmaximize",N,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",L.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",L.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(N=>this.onDidDeleteUntitledWorkspace(N)));const B=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:B},async(N,C)=>{const $=await this.marketplaceHeadersPromise;C({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,$)})})}async onWindowError(H,Q){var B;switch(H){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof Q=="string"?Q:Q==null?void 0:Q.reason}, code: ${typeof Q=="string"?"<unknown>":(B=Q==null?void 0:Q.exitCode)!==null&&B!==void 0?B:"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof Q=="string"?Q:Q==null?void 0:Q.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:H,reason:typeof Q!="string"?Q==null?void 0:Q.reason:void 0}),H===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const N=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,r.mnemonicButtonLabel)((0,A.localize)(0,null)),(0,r.mnemonicButtonLabel)((0,A.localize)(1,null)),(0,r.mnemonicButtonLabel)((0,A.localize)(2,null))],message:(0,A.localize)(3,null),detail:(0,A.localize)(4,null),noLink:!0},this._win);if(!this._win)return;N.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):N.response===2&&this.destroyWindow()}else if(H===2){let N;typeof Q=="string"||!Q?N=(0,A.localize)(5,null):N=(0,A.localize)(6,null,Q.reason);const C=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,r.mnemonicButtonLabel)((0,A.localize)(7,null)),(0,r.mnemonicButtonLabel)((0,A.localize)(8,null))],message:N,detail:(0,A.localize)(9,null),noLink:!0},this._win);if(!this._win)return;C.response===0?this.reload():C.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(H){var Q;((Q=this.openedWorkspace)===null||Q===void 0?void 0:Q.id)===H.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const H=this.getMenuBarVisibility();H!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=H,this.setMenuBarVisibility(H));let Q=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(Q==null?void 0:Q.endsWith("/"))&&(Q=Q.substr(0,Q.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Q||"").indexOf("@")===-1&&(Q!==this.currentHttpProxy||B!==this.currentNoProxy)){this.currentHttpProxy=Q,this.currentNoProxy=B;const N=Q||"",C=B?`${B},<local>`:"<local>";this.logService.trace(`Setting proxy to '${N}', bypassing '${C}'`),this._win.webContents.session.setProxy({proxyRules:N,proxyBypassRules:C,pacScript:""})}}addTabbedWindow(H){f.isMacintosh&&H.win&&this._win.addTabbedWindow(H.win)}load(H,Q=Object.create(null)){this.isDocumentEdited()&&(!Q.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Q.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(H,Q),this.readyState===0?this.currentConfig=H:(this.pendingLoadConfig=H,this.readyState=2),this._win.loadURL(d.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:H.workspace})}updateConfiguration(H,Q){var B,N;const C=(N=(B=this.currentConfig)!==null&&B!==void 0?B:this.pendingLoadConfig)===null||N===void 0?void 0:N.userEnv;C&&(0,y.isLaunchedFromCli)(C)&&!(0,y.isLaunchedFromCli)(H.userEnv)&&(H.userEnv=Object.assign(Object.assign({},C),H.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(H.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Q.disableExtensions!==void 0&&(H["disable-extensions"]=Q.disableExtensions),H.fullscreen=this.isFullScreen,H.maximized=this._win.isMaximized(),H.partsSplash=this.themeMainService.getWindowSplash(),(0,R.mark)("code/willOpenNewWindow"),H.perfMarks=(0,R.getMarks)(),this.configObjectUrl.update(H)}async reload(H){const Q=Object.assign({},this.currentConfig);Q.workspace=await this.validateWorkspace(Q),delete Q.filesToOpenOrCreate,delete Q.filesToDiff,delete Q.filesToWait,this.isExtensionDevelopmentHost&&H&&(Q.verbose=H.verbose,Q.debugId=H.debugId,Q["inspect-extensions"]=H["inspect-extensions"],Q["inspect-brk-extensions"]=H["inspect-brk-extensions"],Q["extensions-dir"]=H["extensions-dir"]),Q.isInitialStartup=!1,this.load(Q,{isReload:!0,disableExtensions:H==null?void 0:H["disable-extensions"]})}async validateWorkspace(H){if((0,D.isWorkspaceIdentifier)(H.workspace)){const Q=H.workspace.configPath;if(Q.scheme===d.Schemas.file&&!await this.fileService.exists(Q))return}else if((0,D.isSingleFolderWorkspaceIdentifier)(H.workspace)){const Q=H.workspace.uri;if(Q.scheme===d.Schemas.file&&!await this.fileService.exists(Q))return}return H.workspace}serializeWindowState(){if(!this._win)return(0,m.defaultWindowState)();if(this.isFullScreen){let B;try{B=i.screen.getDisplayMatching(this.getBounds())}catch($){}const N=(0,m.defaultWindowState)();return{mode:3,display:B?B.id:void 0,width:this.windowState.width||N.width,height:this.windowState.height||N.height,x:this.windowState.x||0,y:this.windowState.y||0}}const H=Object.create(null);let Q;if(!f.isMacintosh&&this._win.isMaximized()?Q=0:Q=1,Q===0?H.mode=0:H.mode=1,Q===1||Q===0){let B;Q===1?B=this.getBounds():B=this._win.getNormalBounds(),H.x=B.x,H.y=B.y,H.width=B.width,H.height=B.height}return H}restoreWindowState(H){(0,R.mark)("code/willRestoreCodeWindowState");let Q=!1;if(H)try{const B=i.screen.getAllDisplays();Q=B.length>1,H=this.validateWindowState(H,B)}catch(B){this.logService.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,R.mark)("code/didRestoreCodeWindowState"),[H||(0,m.defaultWindowState)(),Q]}validateWindowState(H,Q){var B,N;if(this.logService.trace(`window#validateWindowState: validating window state on ${Q.length} display(s)`,H),typeof H.x!="number"||typeof H.y!="number"||typeof H.width!="number"||typeof H.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(H.width<=0||H.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Q.length===1){const _=this.getWorkingArea(Q[0]);if(_){this.logService.trace("window#validateWindowState: 1 monitor working area",_);function C(){!H||typeof H.x!="number"||typeof H.y!="number"||!_||(H.x<_.x&&(H.x=_.x),H.y<_.y&&(H.y=_.y))}C(),H.width>_.width&&(H.width=_.width),H.height>_.height&&(H.height=_.height),H.x>_.x+_.width-128&&(H.x=_.x+_.width-H.width),H.y>_.y+_.height-128&&(H.y=_.y+_.height-H.height),C()}return H}if(H.display&&H.mode===3){const _=Q.find(T=>T.id===H.display);if(_&&typeof((B=_.bounds)===null||B===void 0?void 0:B.x)=="number"&&typeof((N=_.bounds)===null||N===void 0?void 0:N.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const T=(0,m.defaultWindowState)(3);return T.x=_.bounds.x,T.y=_.bounds.y,T}}let $,V;try{$=i.screen.getDisplayMatching({x:H.x,y:H.y,width:H.width,height:H.height}),V=this.getWorkingArea($)}catch(_){}if($&&V&&H.x+H.width>V.x&&H.y+H.height>V.y&&H.x<V.x+V.width&&H.y<V.y+V.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",V),H}getWorkingArea(H){if(H.workArea.width>0&&H.workArea.height>0)return H.workArea;if(H.bounds.width>0&&H.bounds.height>0)return H.bounds}getBounds(){const[H,Q]=this._win.getPosition(),[B,N]=this._win.getSize();return{x:H,y:Q,width:B,height:N}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(H){this.useNativeFullScreen()?this.setNativeFullScreen(H):this.setSimpleFullScreen(H),this.sendWhenReady(H?"vscode:enterFullScreen":"vscode:leaveFullScreen",L.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(H){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(H)}setSimpleFullScreen(H){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(H),this._win.webContents.focus()}useNativeFullScreen(){const H=this.configurationService.getValue("window");return!H||typeof H.nativeFullScreen!="boolean"||H.nativeTabs?!0:H.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let H=(0,P.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(H)<0&&(H="classic"),H}setMenuBarVisibility(H,Q=!0){f.isMacintosh||(H==="toggle"&&Q&&this.send("vscode:showInfoMessage",(0,A.localize)(10,null)),H==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(H)}):this.doSetMenuBarVisibility(H))}doSetMenuBarVisibility(H){const Q=this.isFullScreen;switch(H){case"classic":this._win.setMenuBarVisibility(!Q),this._win.autoHideMenuBar=Q;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(f.isMacintosh)switch(i.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(H,Q,...B){this.isReady?this.send(H,...B):this.ready().then(()=>{Q.isCancellationRequested||this.send(H,...B)})}send(H,...Q){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${H} for window that is destroyed`);return}this._win.webContents.send(H,...Q)}}updateTouchBar(H){!f.isMacintosh||this.touchBarGroups.forEach((Q,B)=>{const N=H[B];Q.segments=this.createTouchBarGroupSegments(N)})}createTouchBar(){if(!!f.isMacintosh){for(let H=0;H<10;H++){const Q=this.createTouchBarGroup();this.touchBarGroups.push(Q)}this._win.setTouchBar(new i.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(H=[]){const Q=this.createTouchBarGroupSegments(H),B=new i.TouchBar.TouchBarSegmentedControl({segments:Q,mode:"buttons",segmentStyle:"automatic",change:N=>{this.sendWhenReady("vscode:runAction",L.CancellationToken.None,{id:B.segments[N].id,from:"touchbar"})}});return B}createTouchBarGroupSegments(H=[]){return H.map(B=>{var N,C;let $;B.icon&&!s.ThemeIcon.isThemeIcon(B.icon)&&((C=(N=B.icon)===null||N===void 0?void 0:N.dark)===null||C===void 0?void 0:C.scheme)===d.Schemas.file&&($=i.nativeImage.createFromPath(M.URI.revive(B.icon.dark).fsPath),$.isEmpty()&&($=void 0));let V;return typeof B.title=="string"?V=B.title:V=B.title.value,{id:B.id,label:$?void 0:V,icon:$}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};X=ue([te(1,p.ILogService),te(2,w.IEnvironmentMainService),te(3,g.IFileService),te(4,h.IStorageMainService),te(5,n.IConfigurationService),te(6,a.IThemeMainService),te(7,I.IWorkspacesManagementMainService),te(8,o.IBackupMainService),te(9,l.ITelemetryService),te(10,t.IDialogMainService),te(11,u.ILifecycleMainService),te(12,E.IProductService),te(13,O.IProtocolMainService)],X),e.CodeWindow=X}),define(J[62],Z([0,1,152,35,38,14,6,39,5,3,29,52,9,15,7,10,21,17,4,2]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D,I,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,o.createDecorator)("workspacesHistoryMainService");let a=class He extends c.Disposable{constructor(g,d,y,L){super();this.stateMainService=g,this.logService=d,this.workspacesManagementMainService=y,this.lifecycleMainService=L,this._onDidChangeRecentlyOpened=this._register(new w.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new P.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(g=>this.addRecentlyOpened([{workspace:g.workspace}])))}handleWindowsJumpList(){!p.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(g){const d=[],y=[];for(let L of g)if((0,n.isRecentWorkspace)(L))!this.workspacesManagementMainService.isUntitledWorkspace(L.workspace)&&r(d,L.workspace)===-1&&d.push(L);else if((0,n.isRecentFolder)(L))s(d,L.folderUri)===-1&&d.push(L);else{const O=u(y,L.fileUri)>=0,z=L.fileUri.scheme===m.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,b.basename)(L.fileUri))>=0;!O&&!z&&(y.push(L),p.isWindows&&L.fileUri.scheme===m.Schemas.file&&S.app.addRecentDocument(L.fileUri.fsPath))}this.addEntriesFromStorage(d,y),d.length>He.MAX_TOTAL_RECENT_ENTRIES&&(d.length=He.MAX_TOTAL_RECENT_ENTRIES),y.length>He.MAX_TOTAL_RECENT_ENTRIES&&(y.length=He.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:d,files:y}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(g){const d=z=>{const X=t(z);for(const x of g)if(b.extUriBiasedIgnorePathCase.isEqual(x,X))return!1;return!0},y=this.getRecentlyOpened(),L=y.workspaces.filter(d),O=y.files.filter(d);(L.length!==y.workspaces.length||O.length!==y.files.length)&&(this.saveRecentlyOpened({files:O,workspaces:L}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!!p.isMacintosh){S.app.clearRecentDocuments();const g=this.getRecentlyOpened(),d=[];let y=0;for(let O=0;O<g.workspaces.length&&y<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;O++){const z=t(g.workspaces[O]);if(z.scheme===m.Schemas.file){const X=(0,b.originalFSPath)(z);await(0,D.exists)(X)&&(d.push(X),y++)}}const L=[];for(let O=0;O<g.files.length&&y<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;O++){const z=t(g.files[O]);if(z.scheme===m.Schemas.file){const X=(0,b.originalFSPath)(z);if(He.COMMON_FILES_FILTER.includes((0,b.basename)(z))||d.includes(X))continue;await(0,D.exists)(X)&&(L.push(X),y++)}}L.reverse().forEach(O=>S.app.addRecentDocument(O)),d.reverse().forEach(O=>S.app.addRecentDocument(O))}}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(g){var d,y;const L=[],O=[],z=(d=g==null?void 0:g.config)===null||d===void 0?void 0:d.workspace;(0,n.isWorkspaceIdentifier)(z)&&!this.workspacesManagementMainService.isUntitledWorkspace(z)?L.push({workspace:z}):(0,n.isSingleFolderWorkspaceIdentifier)(z)&&L.push({folderUri:z.uri});const X=(y=g==null?void 0:g.config)===null||y===void 0?void 0:y.filesToOpenOrCreate;if(X)for(let x of X){const H=x.fileUri;H&&u(O,H)===-1&&O.push({fileUri:H})}return this.addEntriesFromStorage(L,O),{workspaces:L,files:O}}addEntriesFromStorage(g,d){let y=this.getRecentlyOpenedFromStorage();for(let L of y.workspaces){let O=(0,n.isRecentFolder)(L)?s(g,L.folderUri):r(g,L.workspace);O>=0?g[O].label=g[O].label||L.label:g.push(L)}for(let L of y.files){let O=u(d,L.fileUri);O>=0?d[O].label=d[O].label||L.label:d.push(L)}}getRecentlyOpenedFromStorage(){const g=this.stateMainService.getItem(He.recentlyOpenedStorageKey);return(0,n.restoreRecentlyOpened)(g,this.logService)}saveRecentlyOpened(g){const d=(0,n.toStoreData)(g);this.stateMainService.setItem(He.recentlyOpenedStorageKey,d)}updateWindowsJumpList(){if(!!p.isWindows){const g=[];if(g.push({type:"tasks",items:[{type:"task",title:(0,v.localize)(0,null),description:(0,v.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let d=[];for(let O of S.app.getJumpListSettings().removedItems){const z=O.args;if(z){const X=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(z);X&&d.push(f.URI.parse(X[2]))}}this.removeRecentlyOpened(d);let y=!1;const L=(0,A.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(O=>{const z=(0,n.isRecentWorkspace)(O)?O.workspace:O.folderUri,{title:X,description:x}=this.getWindowsJumpListLabel(z,O.label);let H;return f.URI.isUri(z)?H=`--folder-uri "${z.toString()}"`:(y=!0,H=`--file-uri "${z.configPath.toString()}"`),{type:"task",title:X.substr(0,255),description:x.substr(0,255),program:process.execPath,args:H,iconPath:"explorer.exe",iconIndex:0}}));L.length>0&&g.push({type:"custom",name:y?(0,v.localize)(2,null):(0,v.localize)(3,null),items:L})}g.push({type:"recent"});try{S.app.setJumpList(g)}catch(d){this.logService.warn("updateWindowsJumpList#setJumpList",d)}}}getWindowsJumpListLabel(g,d){if(d)return{title:(0,i.splitName)(d).name,description:d};if(f.URI.isUri(g))return{title:(0,b.basename)(g),description:l(g)};if(this.workspacesManagementMainService.isUntitledWorkspace(g))return{title:(0,v.localize)(4,null),description:""};let y=(0,b.basename)(g.configPath);return y.endsWith(n.WORKSPACE_EXTENSION)&&(y=y.substr(0,y.length-n.WORKSPACE_EXTENSION.length-1)),{title:(0,v.localize)(5,null,y),description:l(g.configPath)}}};a.MAX_TOTAL_RECENT_ENTRIES=100,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=ue([te(0,R.IStateMainService),te(1,M.ILogService),te(2,E.IWorkspacesManagementMainService),te(3,I.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a;function l(h){return h.scheme==="file"?(0,i.normalizeDriveLetter)(h.fsPath):h.toString()}function t(h){return(0,n.isRecentFolder)(h)?h.folderUri:(0,n.isRecentFile)(h)?h.fileUri:h.workspace.configPath}function r(h,g){return h.findIndex(d=>(0,n.isRecentWorkspace)(d)&&d.workspace.id===g.id)}function s(h,g){return h.findIndex(d=>(0,n.isRecentFolder)(d)&&b.extUriBiasedIgnorePathCase.isEqual(d.folderUri,g))}function u(h,g){return h.findIndex(d=>b.extUriBiasedIgnorePathCase.isEqual(d.fileUri,g))}}),define(J[232],Z([0,1,144,3,25,14,61,16,31,41,23,9,6,39,34,62,180,7,38,17,45,26]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D,I,o,c,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class wt{constructor(h,g,d,y,L,O,z,X,x,H,Q){this.updateService=h,this.configurationService=g,this.windowsMainService=d,this.environmentMainService=y,this.telemetryService=L,this.workspacesHistoryMainService=O,this.stateMainService=z,this.lifecycleMainService=X,this.logService=x,this.nativeHostMainService=H,this.productService=Q,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new E.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new E.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(A.isMacintosh||(0,M.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const h=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);h&&(h.menus&&(this.menubarMenus=h.menus),h.keybindings&&(this.keybindings=h.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(O,z,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:z==null?void 0:z.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(O,z,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:z==null?void 0:z.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(O,z,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(O,z,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const h=this.productService.twitterUrl;h&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(h,"openTwitterUrl"));const g=this.productService.requestFeatureUrl;g&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(g,"openUserVoiceUrl"));const d=this.productService.reportIssueUrl;d&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(d,"openReportIssues"));const y=this.productService.licenseUrl;y&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(A.language){const O=y.indexOf("?")>0?"&":"?";this.openUrl(`${y}${O}lang=${A.language}`,"openLicenseUrl")}else this.openUrl(y,"openLicenseUrl")});const L=this.productService.privacyStatementUrl;L&&y&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(A.language){const O=y.indexOf("?")>0?"&":"?";this.openUrl(`${L}${O}lang=${A.language}`,"openPrivacyStatement")}else this.openUrl(L,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(h=>this.onDidChangeWindowsCount(h)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let h=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof h!="boolean"&&(h=!0),h}get currentEnableNativeTabs(){if(!A.isMacintosh)return!1;let h=this.configurationService.getValue("window.nativeTabs");return typeof h!="boolean"&&(h=!1),h}updateMenu(h,g){this.menubarMenus=h.menus,this.keybindings=h.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,h),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(h){!A.isMacintosh||(h.oldCount===0&&h.newCount>0||h.oldCount>0&&h.newCount===0)&&(this.closedLastWindow=h.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!A.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const h=S.Menu.getApplicationMenu();if(h&&this.oldMenus.push(h),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(A.isMacintosh?new S.Menu:null);return}const g=new S.Menu;let d;if(A.isMacintosh){const F=new S.Menu;d=new S.MenuItem({label:this.productService.nameShort,submenu:F}),this.setMacApplicationMenu(F),g.append(d)}if(A.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const F=new S.Menu;F.append(new S.MenuItem({label:this.mnemonicLabel(v.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(F)}const y=new S.Menu,L=new S.MenuItem({label:this.mnemonicLabel(v.localize(1,null)),submenu:y});this.setMenuById(y,"File"),g.append(L);const O=new S.Menu,z=new S.MenuItem({label:this.mnemonicLabel(v.localize(2,null)),submenu:O});this.setMenuById(O,"Edit"),g.append(z);const X=new S.Menu,x=new S.MenuItem({label:this.mnemonicLabel(v.localize(3,null)),submenu:X});this.setMenuById(X,"Selection"),g.append(x);const H=new S.Menu,Q=new S.MenuItem({label:this.mnemonicLabel(v.localize(4,null)),submenu:H});this.setMenuById(H,"View"),g.append(Q);const B=new S.Menu,N=new S.MenuItem({label:this.mnemonicLabel(v.localize(5,null)),submenu:B});this.setMenuById(B,"Go"),g.append(N);const C=new S.Menu,$=new S.MenuItem({label:this.mnemonicLabel(v.localize(6,null)),submenu:C});this.setMenuById(C,"Run"),g.append($);const V=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(v.localize(7,null)),submenu:V});this.setMenuById(V,"Terminal"),g.append(_);let T;if(this.shouldDrawMenu("Window")){const F=new S.Menu;T=new S.MenuItem({label:this.mnemonicLabel(v.localize(8,null)),submenu:F,role:"window"}),this.setMacWindowMenu(F)}T&&g.append(T);const W=new S.Menu,k=new S.MenuItem({label:this.mnemonicLabel(v.localize(9,null)),submenu:W,role:"help"});this.setMenuById(W,"Help"),g.append(k),g.items&&g.items.length>0?S.Menu.setApplicationMenu(g):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(h){const g=this.createMenuItem(v.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),d=this.getUpdateMenuItems();let y;if(this.shouldDrawMenu("Preferences")){const B=new S.Menu;this.setMenuById(B,"Preferences"),y=new S.MenuItem({label:this.mnemonicLabel(v.localize(11,null)),submenu:B})}const L=new S.Menu,O=new S.MenuItem({label:v.localize(12,null),role:"services",submenu:L}),z=new S.MenuItem({label:v.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new S.MenuItem({label:v.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new S.MenuItem({label:v.localize(15,null),role:"unhide"}),H=new S.MenuItem(this.likeAction("workbench.action.quit",{label:v.localize(16,null,this.productService.nameLong),click:()=>{const B=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||(B==null?void 0:B.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),Q=[g];Q.push(...d),y&&Q.push(s(),y),Q.push(s(),O,s(),z,X,x,s(),H),Q.forEach(B=>h.append(B))}shouldDrawMenu(h){if(!A.isMacintosh&&(0,M.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(h){case"File":case"Help":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[h];case"Window":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[h]}}setMenu(h,g){g.forEach(d=>{if((0,D.isMenubarMenuItemSeparator)(d))h.append(s());else if((0,D.isMenubarMenuItemSubmenu)(d)){const y=new S.Menu,L=new S.MenuItem({label:this.mnemonicLabel(d.label),submenu:y});this.setMenu(y,d.submenu.items),h.append(L)}else(0,D.isMenubarMenuItemRecentAction)(d)?h.append(this.createOpenRecentMenuItem(d)):(0,D.isMenubarMenuItemAction)(d)&&(d.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(h),A.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[d.id]?h.append(new S.MenuItem(this.likeAction(d.id,{label:this.mnemonicLabel(d.label),click:this.fallbackMenuHandlers[d.id]}))):h.append(this.createMenuItem(d.label,d.id,!1,d.checked)):h.append(this.createMenuItem(d.label,d.id,d.enabled!==!1,!!d.checked)):h.append(this.createMenuItem(d.label,d.id,d.enabled!==!1,!!d.checked)))})}setMenuById(h,g){this.menubarMenus&&this.menubarMenus[g]&&this.setMenu(h,this.menubarMenus[g].items)}insertCheckForUpdatesItems(h){const g=this.getUpdateMenuItems();g.length&&(g.forEach(d=>h.append(d)),h.append(s()))}createOpenRecentMenuItem(h){const g=I.URI.revive(h.uri),d=h.id,y=d==="openRecentFile"?{fileUri:g}:d==="openRecentWorkspace"?{workspaceUri:g}:{folderUri:g};return new S.MenuItem(this.likeAction(d,{label:h.label,click:(L,O,z)=>{const X=this.isOptionClick(z);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[y],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:h.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([g])}},!1))}isOptionClick(h){return!!(h&&(!A.isMacintosh&&(h.ctrlKey||h.shiftKey)||A.isMacintosh&&(h.metaKey||h.altKey)))}createRoleMenuItem(h,g,d){const y={label:this.mnemonicLabel(h),role:d,enabled:!0};return new S.MenuItem(this.withKeybinding(g,y))}setMacWindowMenu(h){const g=new S.MenuItem({label:v.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),d=new S.MenuItem({label:v.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),y=new S.MenuItem({label:v.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),L=this.createMenuItem(v.localize(20,null),"workbench.action.switchWindow"),O=[];this.currentEnableNativeTabs&&(O.push(s()),O.push(this.createMenuItem(v.localize(21,null),"workbench.action.newWindowTab")),O.push(this.createRoleMenuItem(v.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),O.push(this.createRoleMenuItem(v.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),O.push(this.createRoleMenuItem(v.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),O.push(this.createRoleMenuItem(v.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[g,d,s(),L,...O,s(),y].forEach(z=>h.append(z))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:v.localize(27,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:v.localize(29,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:v.localize(31,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(h,g,d,y){const L=this.mnemonicLabel(h),O=typeof g=="function"?g:(Q,B,N)=>{const C=Q?Q.userSettingsLabel:null;let $=g;Array.isArray(g)&&($=this.isOptionClick(N)?g[1]:g[0]),C&&N.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:C}):this.runActionInRenderer({type:"commandId",commandId:$})},z=typeof d=="boolean"?d:this.windowsMainService.getWindowCount()>0,X=typeof y=="boolean"?y:!1,x={label:L,click:O,enabled:z};X&&(x.type="checkbox",x.checked=X);let H;return typeof g=="string"?H=g:Array.isArray(g)&&(H=g[0]),A.isMacintosh&&(H==="editor.action.clipboardCutAction"?x.role="cut":H==="editor.action.clipboardCopyAction"?x.role="copy":H==="editor.action.clipboardPasteAction"&&(x.role="paste"),H==="undo"?x.click=this.makeContextAwareClickHandler(O,{inDevTools:Q=>Q.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):H==="redo"?x.click=this.makeContextAwareClickHandler(O,{inDevTools:Q=>Q.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):H==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(O,{inDevTools:Q=>Q.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(H,x))}makeContextAwareClickHandler(h,g){return(d,y,L)=>{const O=S.BrowserWindow.getFocusedWindow();if(!O)return g.inNoWindow();if(O.webContents.isDevToolsFocused()&&O.webContents.devToolsWebContents)return g.inDevTools(O.webContents.devToolsWebContents);h(d,y||O,L)}}runActionInRenderer(h){let g=S.BrowserWindow.getFocusedWindow();if(!g){const y=this.windowsMainService.getLastActiveWindow();(y==null?void 0:y.isMinimized())&&(g=y.win)}const d=g?this.windowsMainService.getWindowById(g.id):void 0;if(d){if(this.logService.trace("menubar#runActionInRenderer",h),A.isMacintosh&&!this.environmentMainService.isBuilt&&!d.isReady&&(h.type==="commandId"&&h.commandId==="workbench.action.toggleDevTools"||h.type!=="commandId"&&h.userSettingsLabel==="alt+cmd+i"))return;if(h.type==="commandId"){const y={id:h.commandId,from:"menu"};d.sendWhenReady("vscode:runAction",l.CancellationToken.None,y)}else{const y={userSettingsLabel:h.userSettingsLabel};d.sendWhenReady("vscode:runKeybinding",l.CancellationToken.None,y)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",h)}withKeybinding(h,g){const d=typeof h=="string"?this.keybindings[h]:void 0;if(d==null?void 0:d.label){if(d.isNative!==!1)g.accelerator=d.label,g.userSettingsLabel=d.userSettingsLabel;else if(typeof g.label=="string"){const y=g.label.indexOf("[");y>=0?g.label=`${g.label.substr(0,y)} [${d.label}]`:g.label=`${g.label} [${d.label}]`}}else g.accelerator=void 0;return g}likeAction(h,g,d=!g.accelerator){d&&(g=this.withKeybinding(h,g));const y=g.click;return g.click=(L,O,z)=>{this.reportMenuActionTelemetry(h),y&&y(L,O,z)},g}openUrl(h,g){this.nativeHostMainService.openExternal(void 0,h),this.reportMenuActionTelemetry(g)}reportMenuActionTelemetry(h){this.telemetryService.publicLog2("workbenchActionExecuted",{id:h,from:t})}mnemonicLabel(h){return(0,b.mnemonicMenuLabel)(h,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=ue([te(0,p.IUpdateService),te(1,i.IConfigurationService),te(2,f.IWindowsMainService),te(3,R.IEnvironmentMainService),te(4,w.ITelemetryService),te(5,m.IWorkspacesHistoryMainService),te(6,o.IStateMainService),te(7,c.ILifecycleMainService),te(8,P.ILogService),te(9,a.INativeHostMainService),te(10,n.IProductService)],r),e.Menubar=r;function s(){return new S.MenuItem({type:"separator"})}}),define(J[233],Z([0,1,232,6,4,17]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,R.createDecorator)("menubarMainService");let M=class{constructor(w,p,n){this.instantiationService=w,this.lifecycleMainService=p,this.logService=n,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(v.Menubar)}async updateMenubar(w,p){this.logService.trace("menubarService#updateMenubar",w),(await this.menubar).updateMenu(p,w)}};M=ue([te(0,R.IInstantiationService),te(1,S.ILifecycleMainService),te(2,A.ILogService)],M),e.MenubarMainService=M}),define(J[234],Z([0,1,20,27,47,72,8,150,35,50,25,38,231,14,17,16,6,61,101,5,23,62,3,29,4,10,7,15,73,214,52,42,2,51,13,30,39,26,22,32,55]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D,I,o,c,a,l,t,r,s,u,h,g,d,y,L,O,z,X,x,H,Q,B,N,C,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function V(W){return(0,r.isWorkspaceIdentifier)(W==null?void 0:W.workspace)}function _(W){return(0,r.isSingleFolderWorkspaceIdentifier)(W==null?void 0:W.workspace)}let T=class et extends z.Disposable{constructor(k,F,U,K,G,Y,ee,re,se,oe,ne,le,ve,we,Se){super();this.machineId=k,this.initialUserEnv=F,this.logService=U,this.stateMainService=K,this.environmentMainService=G,this.lifecycleMainService=Y,this.backupMainService=ee,this.configurationService=re,this.workspacesHistoryMainService=se,this.workspacesManagementMainService=oe,this.instantiationService=ne,this.dialogMainService=le,this.fileService=ve,this.productService=we,this.protocolMainService=Se,this._onDidOpenWindow=this._register(new c.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new c.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new c.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new c.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new y.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(k=>this._onDidSignalReadyWindow.fire(k.window))),this._register(this.onDidSignalReadyWindow(k=>{var F,U;if(((F=k.config)===null||F===void 0?void 0:F.extensionDevelopmentPath)||((U=k.config)===null||U===void 0?void 0:U.extensionTestsPath)){const K=new z.DisposableStore;if(K.add(c.Event.any(k.onDidClose,k.onDidDestroy)(()=>K.dispose())),k.config.extensionDevelopmentPath)for(const G of k.config.extensionDevelopmentPath)K.add(this.protocolMainService.addValidFileRoot(h.URI.file(G)));k.config.extensionTestsPath&&K.add(this.protocolMainService.addValidFileRoot(h.URI.file(k.config.extensionTestsPath)))}}))}openEmptyWindow(k,F){let U=this.environmentMainService.args;const K=(F==null?void 0:F.remoteAuthority)||void 0,G=!0,Y=F==null?void 0:F.forceReuseWindow,ee=!Y;return this.open(Object.assign(Object.assign({},k),{cli:U,forceEmpty:G,forceNewWindow:ee,forceReuseWindow:Y,remoteAuthority:K}))}open(k){this.logService.trace("windowsManager#open"),k.addMode&&(k.initialStartup||!this.getLastActiveWindow())&&(k.addMode=!1);const F=[],U=[],K=[],G=[],Y=[];let ee,re=0;const se=this.getPathsToOpen(k);this.logService.trace("windowsManager#open pathsToOpen",se);for(const we of se)_(we)?k.addMode?F.push(we):U.push(we):V(we)?K.push(we):we.fileUri?(ee||(ee={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:we.remoteAuthority}),ee.filesToOpenOrCreate.push(we)):we.backupPath?Y.push({backupFolder:(0,M.basename)(we.backupPath),remoteAuthority:we.remoteAuthority}):re++;k.diffMode&&(ee==null?void 0:ee.filesToOpenOrCreate.length)===2&&(ee.filesToDiff=ee.filesToOpenOrCreate,ee.filesToOpenOrCreate=[]),ee&&k.waitMarkerFileURI&&(ee.filesToWait={paths:[...ee.filesToDiff,...ee.filesToOpenOrCreate],waitMarkerFileUri:k.waitMarkerFileURI}),k.initialStartup?(G.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),K.push(...G),Y.push(...this.backupMainService.getEmptyWindowBackupPaths())):Y.length=0;const{windows:oe,filesOpenedInWindow:ne}=this.doOpen(k,K,U,Y,re,ee,F);if(this.logService.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${K.length}, foldersToOpen: ${U.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${re})`),oe.length>1)if(ne)ne.focus();else{const we=this.windowsStateHandler.state.lastActiveWindow&&!k.forceEmpty&&!k.cli._.length&&!k.cli["file-uri"]&&!k.cli["folder-uri"]&&!(k.urisToOpen&&k.urisToOpen.length);let Se=!0,Ae=!0;if(we){const ye=oe.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),Se=!1,Ae=!1)}if(Se)for(let ye=oe.length-1;ye>=0;ye--){const me=oe[ye];if(!(me.openedWorkspace&&G.some(Ie=>me.openedWorkspace&&Ie.workspace.id===me.openedWorkspace.id)||me.backupPath&&Y.some(Ie=>me.backupPath&&Ie.backupFolder===(0,M.basename)(me.backupPath)))){me.focus(),Ae=!1;break}}Ae&&oe[oe.length-1].focus()}const le=ee&&ee.filesToDiff.length>0;if(!oe.some(we=>we.isExtensionDevelopmentHost)&&!le&&!k.noRecentEntry){const we=[];for(const Se of se)V(Se)?we.push({label:Se.label,workspace:Se.workspace,remoteAuthority:Se.remoteAuthority}):_(Se)?we.push({label:Se.label,folderUri:Se.workspace.uri,remoteAuthority:Se.remoteAuthority}):Se.fileUri&&we.push({label:Se.label,fileUri:Se.fileUri,remoteAuthority:Se.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(we)}const ve=k.waitMarkerFileURI;return k.context===0&&ve&&oe.length===1&&oe[0]&&(async()=>{await oe[0].whenClosedOrLoaded;try{await this.fileService.del(ve)}catch(we){}})(),oe}doOpen(k,F,U,K,G,Y,ee){const re=[];let se;function oe(ye,me){re.push(ye),me&&(se=ye,Y=void 0)}let{openFolderInNewWindow:ne,openFilesInNewWindow:le}=this.shouldOpenNewWindow(k);if(!k.initialStartup&&ee.length>0){const ye=ee[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(ye);me&&oe(this.doAddFoldersToExistingWindow(me,ee.map(Ie=>Ie.workspace.uri)))}const ve=U.length+F.length+K.length;if(Y&&ve===0){const ye=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0],me=this.getWindows().filter(Re=>Y&&Re.remoteAuthority===Y.remoteAuthority);let Ie;(ye==null?void 0:ye.fileUri)&&!le&&((k.context===4||k.context===0||k.context===1)&&(Ie=(0,o.findWindowOnFile)(me,ye.fileUri,Re=>Re.configPath.scheme===u.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Re.configPath):void 0)),Ie||(Ie=this.doGetLastActiveWindow(me))),Ie?(0,r.isWorkspaceIdentifier)(Ie.openedWorkspace)?F.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):(0,r.isSingleFolderWorkspaceIdentifier)(Ie.openedWorkspace)?U.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):oe(this.doOpenFilesInExistingWindow(k,Ie,Y),!0):oe(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:k.forceNewTabbedWindow}),!0)}const we=(0,w.distinct)(F,ye=>ye.workspace.id);if(we.length>0){const ye=(0,w.coalesce)(we.map(me=>(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(ye.length>0){const me=ye[0],Ie=(Y==null?void 0:Y.remoteAuthority)===me.remoteAuthority?Y:void 0;oe(this.doOpenFilesInExistingWindow(k,me,Ie),!!Ie),ne=!0}we.forEach(me=>{if(!ye.some(Fe=>Fe.openedWorkspace&&Fe.openedWorkspace.id===me.workspace.id)){const Ie=me.remoteAuthority,Re=(Y==null?void 0:Y.remoteAuthority)===Ie?Y:void 0;oe(this.doOpenFolderOrWorkspace(k,me,ne,Re),!!Re),ne=!0}})}const Se=(0,w.distinct)(U,ye=>g.extUriBiasedIgnorePathCase.getComparisonKey(ye.workspace.uri));if(Se.length>0){const ye=(0,w.coalesce)(Se.map(me=>(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(ye.length>0){const me=ye[0],Ie=(Y==null?void 0:Y.remoteAuthority)===me.remoteAuthority?Y:void 0;oe(this.doOpenFilesInExistingWindow(k,me,Ie),!!Ie),ne=!0}Se.forEach(me=>{if(!ye.some(Fe=>(0,r.isSingleFolderWorkspaceIdentifier)(Fe.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(Fe.openedWorkspace.uri,me.workspace.uri))){const Ie=me.remoteAuthority,Re=(Y==null?void 0:Y.remoteAuthority)===Ie?Y:void 0;oe(this.doOpenFolderOrWorkspace(k,me,ne,Re),!!Re),ne=!0}})}const Ae=(0,w.distinct)(K,ye=>ye.backupFolder);if(Ae.length>0&&Ae.forEach(ye=>{const me=ye.remoteAuthority,Ie=(Y==null?void 0:Y.remoteAuthority)===me?Y:void 0;oe(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:Ie,remoteAuthority:me,forceNewWindow:!0,forceNewTabbedWindow:k.forceNewTabbedWindow,emptyWindowBackupInfo:ye}),!!Ie),ne=!0}),re.length===0||Y){Y&&!G&&G++;const ye=Y?Y.remoteAuthority:k.remoteAuthority;for(let me=0;me<G;me++)oe(this.doOpenEmpty(k,ne,ye,Y),!!Y),ne=!0}return{windows:(0,w.distinct)(re),filesOpenedInWindow:se}}doOpenFilesInExistingWindow(k,F,U){var K;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),F.focus();const G={filesToOpenOrCreate:U==null?void 0:U.filesToOpenOrCreate,filesToDiff:U==null?void 0:U.filesToDiff,filesToWait:U==null?void 0:U.filesToWait,termProgram:(K=k==null?void 0:k.userEnv)===null||K===void 0?void 0:K.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",B.CancellationToken.None,G),F}doAddFoldersToExistingWindow(k,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),k.focus();const U={foldersToAdd:F};return k.sendWhenReady("vscode:addFolders",B.CancellationToken.None,U),k}doOpenEmpty(k,F,U,K,G){return!F&&!G&&typeof k.contextWindowId=="number"&&(G=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:U,forceNewWindow:F,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:K,windowToUse:G})}doOpenFolderOrWorkspace(k,F,U,K,G){return!U&&!G&&typeof k.contextWindowId=="number"&&(G=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:K,windowToUse:G})}getPathsToOpen(k){var F;let U,K=!1,G=!1;if(k.urisToOpen&&k.urisToOpen.length>0?(U=this.doExtractPathsFromAPI(k),K=!0):k.forceEmpty?U=[Object.create(null)]:k.cli._.length||k.cli["folder-uri"]||k.cli["file-uri"]?(U=this.doExtractPathsFromCLI(k.cli),U.length===0&&U.push(Object.create(null)),K=!0):(U=this.doGetPathsFromLastSession(),U.length===0&&U.push(Object.create(null)),G=!0),!k.addMode&&K){const Y=U.filter(ee=>_(ee));if(Y.length>1){const ee=Y[0].remoteAuthority;if(Y.every(re=>re.remoteAuthority===ee)){const re=this.workspacesManagementMainService.createUntitledWorkspaceSync(Y.map(se=>({uri:se.workspace.uri})));U.push({workspace:re,remoteAuthority:ee}),U=U.filter(se=>!_(se))}}}return k.initialStartup&&!G&&((F=this.configurationService.getValue("window"))===null||F===void 0?void 0:F.restoreWindows)==="preserve"&&U.unshift(...this.doGetPathsFromLastSession().filter(Y=>V(Y)||_(Y)||Y.backupPath)),U}doExtractPathsFromAPI(k){const F=[],U={gotoLineMode:k.gotoLineMode,remoteAuthority:k.remoteAuthority};for(const K of(0,w.coalesce)(k.urisToOpen||[])){const G=this.resolveOpenable(K,U);if(G)G.label=K.label,F.push(G);else{const Y=this.resourceFromOpenable(K),ee={title:this.productService.nameLong,type:"info",buttons:[(0,i.localize)(0,null)],message:Y.scheme===u.Schemas.file?(0,i.localize)(1,null):(0,i.localize)(2,null),detail:Y.scheme===u.Schemas.file?(0,i.localize)(3,null,(0,Q.getPathLabel)(Y.fsPath,this.environmentMainService)):(0,i.localize)(4,null,Y.toString()),noLink:!0};this.dialogMainService.showMessageBox(ee,(0,x.withNullAsUndefined)(b.BrowserWindow.getFocusedWindow()))}}return F}doExtractPathsFromCLI(k){const F=[],U={ignoreFileNotFound:!0,gotoLineMode:k.goto,remoteAuthority:k.remote||void 0,forceOpenWorkspaceAsFile:!1},K=k["folder-uri"];if(K)for(const ee of K){const re=this.cliArgToUri(ee);if(re){const se=this.resolveOpenable({folderUri:re},U);se&&F.push(se)}}const G=k["file-uri"];if(G)for(const ee of G){const re=this.cliArgToUri(ee);if(re){const se=this.resolveOpenable((0,r.hasWorkspaceFileExtension)(ee)?{workspaceUri:re}:{fileUri:re},U);se&&F.push(se)}}const Y=k._;for(const ee of Y){const re=U.remoteAuthority?this.doResolvePathRemote(ee,U):this.doResolveFilePath(ee,U);re&&F.push(re)}return F}cliArgToUri(k){try{const F=h.URI.parse(k);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${k}`);return}return F}catch(F){this.logService.error(`Invalid URI input string: ${k}, ${F.message}`)}}doGetPathsFromLastSession(){const k=this.getRestoreWindowsSetting();switch(k){case"none":return[];case"one":case"all":case"preserve":case"folders":const F=[];k!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const U=[];for(const K of F)if(K.workspace){const G=this.resolveOpenable({workspaceUri:K.workspace.configPath},{remoteAuthority:K.remoteAuthority});V(G)&&U.push(G)}else if(K.folderUri){const G=this.resolveOpenable({folderUri:K.folderUri},{remoteAuthority:K.remoteAuthority});_(G)&&U.push(G)}else k!=="folders"&&K.backupPath&&U.push({backupPath:K.backupPath,remoteAuthority:K.remoteAuthority});return U}}getRestoreWindowsSetting(){let k;if(this.lifecycleMainService.wasRestarted)k="all";else{const F=this.configurationService.getValue("window");k=(F==null?void 0:F.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(k)||(k="all")}return k}resolveOpenable(k,F={}){let U=this.resourceFromOpenable(k);return U.scheme===u.Schemas.file?((0,I.isFileToOpen)(k)&&(F=Object.assign(Object.assign({},F),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(U.fsPath,F)):this.doResolveRemoteOpenable(k,F)}doResolveRemoteOpenable(k,F){let U=this.resourceFromOpenable(k);const K=(0,d.getRemoteAuthority)(U)||F.remoteAuthority;if(U=(0,g.removeTrailingPathSeparator)((0,g.normalizePath)(U)),(0,I.isFileToOpen)(k)){if(F.gotoLineMode){const{path:G,line:Y,column:ee}=(0,H.parseLineAndColumnAware)(U.path);return{fileUri:U.with({path:G}),lineNumber:Y,columnNumber:ee,remoteAuthority:K}}return{fileUri:U,remoteAuthority:K}}else if((0,I.isWorkspaceToOpen)(k))return{workspace:(0,L.getWorkspaceIdentifier)(U),remoteAuthority:K};return{workspace:(0,L.getSingleFolderWorkspaceIdentifier)(U),remoteAuthority:K}}resourceFromOpenable(k){return(0,I.isWorkspaceToOpen)(k)?k.workspaceUri:(0,I.isFolderToOpen)(k)?k.folderUri:k.fileUri}doResolveFilePath(k,F){let U,K;F.gotoLineMode&&({path:k,line:U,column:K}=(0,H.parseLineAndColumnAware)(k)),k=(0,H.sanitizeFilePath)((0,M.normalize)(k),(0,C.cwd)());try{const G=(0,v.statSync)(k);if(G.isFile()){if(!F.forceOpenWorkspaceAsFile){const Y=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(k));if(Y)return{workspace:{id:Y.id,configPath:Y.configPath},remoteAuthority:Y.remoteAuthority,exists:!0}}return{fileUri:h.URI.file(k),lineNumber:U,columnNumber:K,exists:!0}}else if(G.isDirectory())return{workspace:(0,L.getSingleFolderWorkspaceIdentifier)(h.URI.file(k),G),exists:!0}}catch(G){const Y=h.URI.file(k);if(this.workspacesHistoryMainService.removeRecentlyOpened([Y]),F.ignoreFileNotFound)return{fileUri:Y,exists:!1}}}doResolvePathRemote(k,F){const U=k.charCodeAt(0),K=F.remoteAuthority;let G,Y;F.gotoLineMode&&({path:k,line:G,column:Y}=(0,H.parseLineAndColumnAware)(k)),U!==47&&((0,H.isWindowsDriveLetter)(U)&&k.charCodeAt(k.charCodeAt(1))===58&&(k=(0,H.toSlashes)(k)),k=`/${k}`);const ee=h.URI.from({scheme:u.Schemas.vscodeRemote,authority:K,path:k});if(k.charCodeAt(k.length-1)!==47){if((0,r.hasWorkspaceFileExtension)(k))return F.forceOpenWorkspaceAsFile?{fileUri:ee,lineNumber:G,columnNumber:Y,remoteAuthority:F.remoteAuthority}:{workspace:(0,L.getWorkspaceIdentifier)(ee),remoteAuthority:K};if(F.gotoLineMode||M.posix.basename(k).indexOf(".")!==-1)return{fileUri:ee,lineNumber:G,columnNumber:Y,remoteAuthority:K}}return{workspace:(0,L.getSingleFolderWorkspaceIdentifier)(ee),remoteAuthority:K}}shouldOpenNewWindow(k){const F=this.configurationService.getValue("window"),U=(F==null?void 0:F.openFoldersInNewWindow)||"default",K=(F==null?void 0:F.openFilesInNewWindow)||"off";let G=(k.preferNewWindow||k.forceNewWindow)&&!k.forceReuseWindow;!k.forceNewWindow&&!k.forceReuseWindow&&(U==="on"||U==="off")&&(G=U==="on");let Y=!1;return k.forceNewWindow||k.forceReuseWindow?Y=!!k.forceNewWindow&&!k.forceReuseWindow:(t.isMacintosh?k.context===1&&(Y=!0):k.context!==3&&k.context!==2&&!(k.userEnv&&k.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!k.cli.extensionDevelopmentPath&&(K==="on"||K==="off")&&(Y=K==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:Y}}openExtensionDevelopmentHostWindow(k,F){const U=(0,o.findWindowOnExtensionDevelopmentPath)(this.getWindows(),k);if(U)return this.lifecycleMainService.reload(U,F.cli),U.focus(),[U];let K=F.cli["folder-uri"]||[],G=F.cli["file-uri"]||[],Y=F.cli._;if(!Y.length&&!K.length&&!G.length&&!F.cli.extensionTestsPath){const oe=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ne=oe&&(oe.workspace||oe.folderUri);ne&&(h.URI.isUri(ne)?ne.scheme===u.Schemas.file?Y=[ne.fsPath]:K=[ne.toString()]:ne.configPath.scheme===u.Schemas.file?Y=[(0,g.originalFSPath)(ne.configPath)]:G=[ne.configPath.toString()])}let ee=F.remoteAuthority;for(const oe of k)if(oe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=h.URI.parse(oe),le=(0,d.getRemoteAuthority)(ne);le&&(ee?le!==ee&&this.logService.error("more than one extension development path authority"):ee=le)}Y=Y.filter(oe=>{const ne=h.URI.file(oe);return(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:(0,d.getRemoteAuthority)(ne)===ee}),K=K.filter(oe=>{const ne=this.cliArgToUri(oe);return ne&&!!(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,d.getRemoteAuthority)(ne)===ee:!1}),G=G.filter(oe=>{const ne=this.cliArgToUri(oe);return ne&&!!(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,d.getRemoteAuthority)(ne)===ee:!1}),F.cli._=Y,F.cli["folder-uri"]=K,F.cli["file-uri"]=G;const re=!Y.length&&!K.length&&!G.length,se={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:re,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:ee};return this.open(se)}openInBrowserWindow(k){var F,U,K,G,Y;const ee=this.configurationService.getValue("window"),re=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),k.cli),{machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupPath:k.emptyWindowBackupInfo?(0,M.join)(this.environmentMainService.backupHome,k.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:k.remoteAuthority,workspace:k.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),k.userEnv),filesToOpenOrCreate:(F=k.filesToOpen)===null||F===void 0?void 0:F.filesToOpenOrCreate,filesToDiff:(U=k.filesToOpen)===null||U===void 0?void 0:U.filesToDiff,filesToWait:(K=k.filesToOpen)===null||K===void 0?void 0:K.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:R.default,isInitialStartup:k.initialStartup,perfMarks:(0,S.getMarks)(),os:{release:(0,A.release)(),hostname:(0,A.hostname)()},zoomLevel:typeof(ee==null?void 0:ee.zoomLevel)=="number"?ee.zoomLevel:void 0,autoDetectHighContrast:(G=ee==null?void 0:ee.autoDetectHighContrast)!==null&&G!==void 0?G:!0,accessibilitySupport:b.app.accessibilitySupportEnabled,colorScheme:{dark:b.nativeTheme.shouldUseDarkColors,highContrast:b.nativeTheme.shouldUseInvertedColorScheme||b.nativeTheme.shouldUseHighContrastColors}});let se;if(!k.forceNewWindow&&!k.forceNewTabbedWindow&&(se=k.windowToUse||this.getLastActiveWindow(),se&&se.focus()),se){const oe=se.config;!re.extensionDevelopmentPath&&oe&&!!oe.extensionDevelopmentPath&&(re.extensionDevelopmentPath=oe.extensionDevelopmentPath,re.verbose=oe.verbose,re["inspect-brk-extensions"]=oe["inspect-brk-extensions"],re.debugId=oe.debugId,re["inspect-extensions"]=oe["inspect-extensions"],re["extensions-dir"]=oe["extensions-dir"])}else{const oe=this.windowsStateHandler.getNewWindowState(re);(0,S.mark)("code/willCreateCodeWindow");const ne=se=this.instantiationService.createInstance(P.CodeWindow,{state:oe,extensionDevelopmentPath:re.extensionDevelopmentPath,isExtensionTestHost:!!re.extensionTestsPath});if((0,S.mark)("code/didCreateCodeWindow"),k.forceNewTabbedWindow){const ve=this.getLastActiveWindow();ve&&ve.addTabbedWindow(ne)}et.WINDOWS.push(ne),this._onDidOpenWindow.fire(ne),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,O.once)(ne.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ne)),(0,O.once)(ne.onDidClose)(()=>this.onWindowClosed(ne)),(0,O.once)(ne.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ne));const le=(0,x.assertIsDefined)((Y=ne.win)===null||Y===void 0?void 0:Y.webContents);le.removeAllListeners("devtools-reload-page"),le.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ne)),this.lifecycleMainService.registerWindow(ne)}return re.windowId=se.id,se.isReady?this.lifecycleMainService.unload(se,4).then(oe=>{oe||this.doOpenInBrowserWindow(se,re,k)}):this.doOpenInBrowserWindow(se,re,k),se}doOpenInBrowserWindow(k,F,U){if(!F.extensionDevelopmentPath)if((0,r.isWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:F.workspace,remoteAuthority:F.remoteAuthority});else if((0,r.isSingleFolderWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerFolderBackupSync(F.workspace.uri);else{const K=U.emptyWindowBackupInfo&&U.emptyWindowBackupInfo.backupFolder;F.backupPath=this.backupMainService.registerEmptyWindowBackupSync(K,F.remoteAuthority)}k.load(F)}onWindowClosed(k){const F=et.WINDOWS.indexOf(k);et.WINDOWS.splice(F,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const k=b.BrowserWindow.getFocusedWindow();if(k)return this.getWindowById(k.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(k){return this.doGetLastActiveWindow(this.getWindows().filter(F=>F.remoteAuthority===k))}doGetLastActiveWindow(k){const F=Math.max.apply(Math,k.map(U=>U.lastFocusTime));return k.find(U=>U.lastFocusTime===F)}sendToFocused(k,...F){const U=this.getFocusedWindow()||this.getLastActiveWindow();U&&U.sendWhenReady(k,B.CancellationToken.None,...F)}sendToAll(k,F,U){for(const K of this.getWindows())U&&U.indexOf(K.id)>=0||K.sendWhenReady(k,B.CancellationToken.None,F)}getWindows(){return et.WINDOWS}getWindowCount(){return et.WINDOWS.length}getWindowById(k){const F=this.getWindows().filter(U=>U.id===k);return(0,w.firstOrDefault)(F)}getWindowByWebContents(k){const F=b.BrowserWindow.fromWebContents(k);if(!!F)return this.getWindowById(F.id)}};T.WINDOWS=[],T=ue([te(2,D.ILogService),te(3,E.IStateMainService),te(4,n.IEnvironmentMainService),te(5,f.ILifecycleMainService),te(6,p.IBackupMainService),te(7,m.IConfigurationService),te(8,l.IWorkspacesHistoryMainService),te(9,L.IWorkspacesManagementMainService),te(10,s.IInstantiationService),te(11,X.IDialogMainService),te(12,N.IFileService),te(13,a.IProductService),te(14,$.IProtocolMainService)],T),e.WindowsMainService=T}),define(J[235],Z([0,1,52,34,62,50]),function(j,e,v,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(w,p,n,E){this.workspacesManagementMainService=w,this.windowsMainService=p,this.workspacesHistoryMainService=n,this.backupMainService=E,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(w,p){const n=this.windowsMainService.getWindowById(w);if(n)return this.workspacesManagementMainService.enterWorkspace(n,this.windowsMainService.getWindows(),p)}createUntitledWorkspace(w,p,n){return this.workspacesManagementMainService.createUntitledWorkspace(p,n)}deleteUntitledWorkspace(w,p){return this.workspacesManagementMainService.deleteUntitledWorkspace(p)}getWorkspaceIdentifier(w,p){return this.workspacesManagementMainService.getWorkspaceIdentifier(p)}async getRecentlyOpened(w){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(w))}async addRecentlyOpened(w,p){return this.workspacesHistoryMainService.addRecentlyOpened(p)}async removeRecentlyOpened(w,p){return this.workspacesHistoryMainService.removeRecentlyOpened(p)}async clearRecentlyOpened(w){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=ue([te(0,v.IWorkspacesManagementMainService),te(1,A.IWindowsMainService),te(2,R.IWorkspacesHistoryMainService),te(3,S.IBackupMainService)],M),e.WorkspacesMainService=M}),define(J[236],Z([0,1,27,20,14,3,234,17,92,41,204,33,122,86,224,102,4,71,69,6,38,25,16,99,205,31,98,199,200,196,23,218,2,34,7,29,235,66,229,227,226,230,178,18,207,219,233,119,8,15,131,10,228,100,212,217,50,62,206,52,70,157,45,51,13,39,209,76,22,43,28,19,90,210,195,54,30,9,169,183,42,73,75,91,188]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D,I,o,c,a,l,t,r,s,u,h,g,d,y,L,O,z,X,x,H,Q,B,N,C,$,V,_,T,W,k,F,U,K,G,Y,ee,re,se,oe,ne,le,ve,we,Se,Ae,ye,me,Ie,Re,Fe,Ne,qe,Ve,tt,ze,at,it,dt,Ge,ft,lt,q,ie,ae,ce,de,be,Me,Te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let We=class extends z.Disposable{constructor(he,pe,fe,ge,Ee,Le,ke,De,Pe,Ue){super();this.mainProcessNodeIpcServer=he,this.userEnv=pe,this.mainInstantiationService=fe,this.logService=ge,this.environmentMainService=Ee,this.lifecycleMainService=Le,this.configurationService=ke,this.stateMainService=De,this.fileService=Pe,this.productService=Ue,this.registerListeners()}registerListeners(){(0,T.setUnexpectedErrorHandler)(fe=>this.onUnexpectedError(fe)),process.on("uncaughtException",fe=>this.onUnexpectedError(fe)),process.on("unhandledRejection",fe=>(0,T.onUnexpectedError)(fe)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,U.registerContextMenuListener)(),R.app.on("accessibility-support-changed",(fe,ge)=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.sendToAll("vscode:accessibilitySupportChanged",ge)}),R.app.on("activate",(fe,ge)=>{var Ee;this.logService.trace("app#activate"),ge||(Ee=this.windowsMainService)===null||Ee===void 0||Ee.openEmptyWindow({context:1})}),R.app.on("remote-require",(fe,ge,Ee)=>{this.logService.trace("app#on(remote-require): prevented"),fe.preventDefault()}),R.app.on("remote-get-global",(fe,ge,Ee)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${Ee}`),fe.preventDefault()}),R.app.on("remote-get-builtin",(fe,ge,Ee)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${Ee}`),Ee!=="clipboard"&&fe.preventDefault()}),R.app.on("remote-get-current-window",fe=>{this.logService.trace("app#on(remote-get-current-window): prevented"),fe.preventDefault()}),R.app.on("remote-get-current-web-contents",fe=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),fe.preventDefault())}),R.app.on("web-contents-created",(fe,ge)=>{ge.on("will-attach-webview",(Le,ke,De)=>{const Pe=Ue=>{if(!Ue)return!1;const $e=x.URI.parse(Ue);if($e.scheme===ee.Schemas.vscodeWebview)return $e.path==="/index.html"||$e.path==="/electron-browser-index.html";const Ye=$e.fsPath.toLowerCase(),Xe=x.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return Ye.startsWith(Xe+K.sep)};delete ke.preload,ke.nodeIntegration=!1,!(Pe(De.src)&&Pe(ke.preloadURL))&&(delete ke.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Le.preventDefault())}),ge.on("will-navigate",Le=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Le.preventDefault()}),ge.on("new-window",(Le,ke)=>{var De;Le.preventDefault(),(De=this.nativeHostMainService)===null||De===void 0||De.openExternal(void 0,ke)});const Ee=Le=>Le.startsWith(`${ee.Schemas.vscodeWebview}://`);R.session.defaultSession.setPermissionRequestHandler((Le,ke,De,Pe)=>Ee(Pe.requestingUrl)?De(ke==="clipboard-read"):De(!1)),R.session.defaultSession.setPermissionCheckHandler((Le,ke,De,Pe)=>Ee(Pe.requestingUrl)?ke==="clipboard-read":!1)});let he=[],pe;R.app.on("open-file",(fe,ge)=>{this.logService.trace("app#open-file: ",ge),fe.preventDefault(),he.push(this.getWindowOpenableFromPathSync(ge)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.open({context:1,cli:this.environmentMainService.args,urisToOpen:he,gotoLineMode:!1,preferNewWindow:!0}),he=[],pe=void 0},100)}),R.app.on("new-window-for-tab",()=>{var fe;(fe=this.windowsMainService)===null||fe===void 0||fe.openEmptyWindow({context:4})}),R.ipcMain.handle("vscode:fetchShellEnv",fe=>{var ge;const Ee=(ge=this.windowsMainService)===null||ge===void 0?void 0:ge.getWindowByWebContents(fe.sender);let Le,ke;return(Ee==null?void 0:Ee.config)?(Le=Ee.config,ke=Object.assign(Object.assign({},process.env),Ee.config.userEnv)):(Le=this.environmentMainService.args,ke=process.env),(0,w.resolveShellEnv)(this.logService,Le,ke)}),R.ipcMain.handle("vscode:writeNlsFile",(fe,ge,Ee)=>{const Le=this.validateNlsPath([ge]);if(!Le||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,at.VSBuffer.fromString(Ee))}),R.ipcMain.handle("vscode:readNlsFile",async(fe,...ge)=>{const Ee=this.validateNlsPath(ge);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ee)).value.toString()}),R.ipcMain.on("vscode:toggleDevTools",fe=>fe.sender.toggleDevTools()),R.ipcMain.on("vscode:openDevTools",fe=>fe.sender.openDevTools()),R.ipcMain.on("vscode:reloadWindow",fe=>fe.sender.reload())}validateNlsPath(he){let pe;for(const fe of he)typeof fe=="string"&&(typeof pe!="string"?pe=fe:pe=(0,K.join)(pe,fe));if(!(typeof pe!="string"||!(0,K.isAbsolute)(pe)||!(0,lt.isEqualOrParent)(pe,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return x.URI.file(pe)}onUnexpectedError(he){var pe;if(he){const fe={message:`[uncaught exception in main]: ${he.message}`,stack:he.stack};(pe=this.windowsMainService)===null||pe===void 0||pe.sendToFocused("vscode:reportError",JSON.stringify(fe))}this.logService.error(`[uncaught exception in main]: ${he}`),he.stack&&this.logService.error(he.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);try{const Pe=x.URI.file(this.environmentMainService.chromeCachedDataDir);this.logService.trace(`Deleting Chrome cached data path: ${Pe.fsPath}`),await this.fileService.del(Pe,{recursive:!0})}catch(Pe){Pe.fileOperationResult!==1&&this.logService.error(Pe)}const he=this.productService.win32AppUserModelId;S.isWindows&&he&&R.app.setAppUserModelId(he);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!R.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&R.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Pe){this.logService.error(Pe)}const pe=new P.Server;this.logService.trace("Resolving machine identifier...");const fe=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${fe}`);const{sharedProcess:ge,sharedProcessReady:Ee,sharedProcessClient:Le}=this.setupSharedProcess(fe),ke=await this.initServices(fe,ge,Ee);if(this.environmentMainService.driverHandle){const Pe=await(0,k.serve)(pe,this.environmentMainService.driverHandle,this.environmentMainService,ke);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Pe)}this._register(ke.createInstance(O.ProxyAuthHandler)),ke.invokeFunction(Pe=>this.initChannels(Pe,pe,Le));const De=ke.invokeFunction(Pe=>this.openFirstWindow(Pe,pe));ke.invokeFunction(Pe=>this.afterWindowOpen(Pe,ge)),this.environmentMainService.args.trace&&ke.invokeFunction(Pe=>this.stopTracingEventually(Pe,De))}async resolveMachineId(){let he=this.stateMainService.getItem(u.machineIdKey);return(!he||S.isMacintosh&&he==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(he=await(0,B.getMachineId)(),this.stateMainService.setItem(u.machineIdKey,he)),he}setupSharedProcess(he){const pe=this._register(this.mainInstantiationService.createInstance(f.SharedProcess,he,this.userEnv)),fe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ee=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new b.Client(Ee,"main")})(),ge=(async()=>(await pe.whenReady(),fe))();return{sharedProcess:pe,sharedProcessReady:ge,sharedProcessClient:fe}}async initServices(he,pe,fe){const ge=new I.ServiceCollection;switch(process.platform){case"win32":ge.set(p.IUpdateService,new o.SyncDescriptor(N.Win32UpdateService));break;case"linux":S.isLinuxSnap?ge.set(p.IUpdateService,new o.SyncDescriptor(re.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(p.IUpdateService,new o.SyncDescriptor(C.LinuxUpdateService));break;case"darwin":ge.set(p.IUpdateService,new o.SyncDescriptor($.DarwinUpdateService));break}ge.set(X.IWindowsMainService,new o.SyncDescriptor(M.WindowsMainService,[he,this.userEnv])),ge.set(Ie.IDialogMainService,new o.SyncDescriptor(Ie.DialogMainService)),ge.set(m.ILaunchMainService,new o.SyncDescriptor(m.LaunchMainService)),ge.set(Ae.IDiagnosticsService,E.ProxyChannel.toService((0,E.getDelayedChannel)(fe.then(Le=>Le.getChannel("diagnostics"))))),ge.set(V.IIssueMainService,new o.SyncDescriptor(V.IssueMainService,[this.userEnv])),ge.set(it.IEncryptionMainService,new o.SyncDescriptor(it.EncryptionMainService,[he])),ge.set(Ge.IKeyboardLayoutMainService,new o.SyncDescriptor(Ge.KeyboardLayoutMainService)),ge.set(me.INativeHostMainService,new o.SyncDescriptor(me.NativeHostMainService,[pe])),ge.set(qe.IWebviewManagerService,new o.SyncDescriptor(Ne.WebviewMainService)),ge.set(H.IWorkspacesService,new o.SyncDescriptor(Q.WorkspacesMainService)),ge.set(Se.IWorkspacesManagementMainService,new o.SyncDescriptor(Se.WorkspacesManagementMainService)),ge.set(ve.IWorkspacesHistoryMainService,new o.SyncDescriptor(ve.WorkspacesHistoryMainService)),ge.set(F.IMenubarMainService,new o.SyncDescriptor(F.MenubarMainService)),ge.set(ie.IExtensionUrlTrustService,new o.SyncDescriptor(ae.ExtensionUrlTrustService)),ge.set(se.IStorageMainService,new o.SyncDescriptor(se.StorageMainService)),S.isWindows?ge.set(Me.IExternalTerminalMainService,new o.SyncDescriptor(Te.WindowsExternalTerminalService)):S.isMacintosh?ge.set(Me.IExternalTerminalMainService,new o.SyncDescriptor(Te.MacExternalTerminalService)):S.isLinux&&ge.set(Me.IExternalTerminalMainService,new o.SyncDescriptor(Te.LinuxExternalTerminalService));const Ee=new ne.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(le.IBackupMainService,Ee),ge.set(r.IURLService,new o.SyncDescriptor(we.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Le=(0,E.getDelayedChannel)(fe.then($e=>$e.getChannel("telemetryAppender"))),ke=new g.TelemetryAppenderClient(Le),De=(0,y.resolveCommonProperties)(this.fileService,(0,v.release)(),(0,v.hostname)(),process.arch,this.productService.commit,this.productService.version,he,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Pe=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ue={appender:ke,commonProperties:De,piiPaths:Pe,sendErrorTelemetry:!0};ge.set(u.ITelemetryService,new o.SyncDescriptor(d.TelemetryService,[Ue]))}else ge.set(u.ITelemetryService,h.NullTelemetryService);return await Ee.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(he,pe,fe){const ge=E.ProxyChannel.fromService(he.get(m.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge);const Ee=new n.UpdateChannel(he.get(p.IUpdateService));pe.registerChannel("update",Ee);const Le=E.ProxyChannel.fromService(he.get(V.IIssueMainService));pe.registerChannel("issue",Le);const ke=E.ProxyChannel.fromService(he.get(it.IEncryptionMainService));pe.registerChannel("encryption",ke);const De=E.ProxyChannel.fromService(he.get(be.ISignService));pe.registerChannel("sign",De);const Pe=E.ProxyChannel.fromService(he.get(Ge.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Pe),this.nativeHostMainService=he.get(me.INativeHostMainService);const Ue=E.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Ue),fe.then(je=>je.registerChannel("nativeHost",Ue));const $e=E.ProxyChannel.fromService(he.get(H.IWorkspacesService));pe.registerChannel("workspaces",$e);const Ye=E.ProxyChannel.fromService(he.get(F.IMenubarMainService));pe.registerChannel("menubar",Ye);const Xe=E.ProxyChannel.fromService(he.get(r.IURLService));pe.registerChannel("url",Xe);const Oe=E.ProxyChannel.fromService(he.get(ie.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",Oe);const ct=E.ProxyChannel.fromService(he.get(qe.IWebviewManagerService));pe.registerChannel("webview",ct);const xe=this._register(new oe.StorageDatabaseChannel(this.logService,he.get(se.IStorageMainService)));pe.registerChannel("storage",xe),fe.then(je=>je.registerChannel("storage",xe));const nt=E.ProxyChannel.fromService(he.get(Me.IExternalTerminalMainService));pe.registerChannel("externalTerminal",nt);const rt=new _.LogLevelChannel(he.get(c.ILogService));pe.registerChannel("logLevel",rt),fe.then(je=>je.registerChannel("logLevel",rt));const st=new _.LoggerChannel(he.get(c.ILoggerService));pe.registerChannel("logger",st),fe.then(je=>je.registerChannel("logger",st));const ot=new ye.ElectronExtensionHostDebugBroadcastChannel(he.get(X.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",ot)}openFirstWindow(he,pe){const fe=this.windowsMainService=he.get(X.IWindowsMainService),ge=he.get(r.IURLService),Ee=he.get(me.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],ke=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ce=>{try{return{uri:x.URI.parse(Ce),url:Ce}}catch(Qe){return null}}).filter(Ce=>{if(!Ce||this.shouldBlockURI(Ce.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Ce.uri);return Qe?(Le.push(Qe),!1):!0}),De=this,Pe=this.environmentMainService;ge.registerHandler({async handleURL(Ce,Qe){if(De.shouldBlockURI(Ce))return!0;const bt=De.getWindowOpenableFromProtocolLink(Ce);if(bt){const[gt]=fe.open({context:5,cli:Object.assign({},Pe.args),urisToOpen:[bt],gotoLineMode:!0});return gt.focus(),!0}if(S.isMacintosh&&fe.getWindowCount()===0){const[gt]=fe.open({context:5,cli:Object.assign({},Pe.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.getRemoteAuthority)(Ce)});return await gt.ready(),ge.open(Ce,Qe)}return!1}});const Ue=this._register(new dt.ActiveWindowManager({onDidOpenWindow:Ee.onDidOpenWindow,onDidFocusWindow:Ee.onDidFocusWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),$e=new E.StaticRouter(Ce=>Ue.getActiveClientId().then(Qe=>Ce===Qe)),Ye=new s.URLHandlerRouter($e),Xe=pe.getChannel("urlHandler",Ye);ge.registerHandler(new s.URLHandlerChannelClient(Xe)),this._register(new W.ElectronURLListener(ke,ge,fe,this.environmentMainService,this.productService));const Oe=this.environmentMainService.args,ct=global.macOpenFiles,xe=(0,ft.isLaunchedFromCli)(process.env)?0:4,nt=Oe._.length,rt=!!Oe["folder-uri"],st=!!Oe["file-uri"],ot=Oe["skip-add-to-recently-opened"]===!0,je=Oe.wait&&Oe.waitMarkerFilePath?x.URI.file(Oe.waitMarkerFilePath):void 0,St=Oe.remote||void 0;return Le.length>0?fe.open({context:xe,cli:Oe,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):Oe["new-window"]&&!nt&&!rt&&!st?fe.open({context:xe,cli:Oe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:ot,waitMarkerFileURI:je,initialStartup:!0,remoteAuthority:St}):ct.length&&!nt&&!rt&&!st?fe.open({context:1,cli:Oe,urisToOpen:ct.map(Ce=>this.getWindowOpenableFromPathSync(Ce)),noRecentEntry:ot,waitMarkerFileURI:je,initialStartup:!0}):fe.open({context:xe,cli:Oe,forceNewWindow:Oe["new-window"]||!nt&&Oe["unity-launch"],diffMode:Oe.diff,noRecentEntry:ot,waitMarkerFileURI:je,gotoLineMode:Oe.goto,initialStartup:!0,remoteAuthority:St})}shouldBlockURI(he){return!!(he.authority===ee.Schemas.file&&S.isWindows&&R.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,Fe.mnemonicButtonLabel)((0,Y.localize)(0,null)),(0,Fe.mnemonicButtonLabel)((0,Y.localize)(1,null))],cancelId:1,message:(0,Y.localize)(2,null,(0,Fe.getPathLabel)(he.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,Y.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(he){if(!!he.path){if(he.authority===ee.Schemas.file)return{fileUri:x.URI.file(he.fsPath)};if(he.authority===ee.Schemas.vscodeRemote){const pe=he.path.indexOf(K.posix.sep,1);if(pe!==-1){const fe=he.path.substring(1,pe),ge=he.path.substring(pe),Ee=x.URI.from({scheme:ee.Schemas.vscodeRemote,authority:fe,path:ge,query:he.query,fragment:he.fragment});return(0,H.hasWorkspaceFileExtension)(ge)?{workspaceUri:Ee}:/:[\d]+$/.test(ge)?{fileUri:Ee}:{folderUri:Ee}}}}}getWindowOpenableFromPathSync(he){try{if((0,A.statSync)(he).isDirectory())return{folderUri:x.URI.file(he)};if((0,H.hasWorkspaceFileExtension)(he))return{workspaceUri:x.URI.file(he)}}catch(pe){}return{fileUri:x.URI.file(he)}}async afterWindowOpen(he,pe){var fe;this.lifecycleMainService.phase=3;let ge=!1;(0,ce.once)(this.lifecycleMainService.onWillShutdown)(()=>ge=!0);const Ee=he.get(u.ITelemetryService);this._register(pe.onDidError(({type:De,details:Pe})=>{let Ue;typeof Pe=="string"?Ue=Pe:Ue=`SharedProcess: crashed (detail: ${Pe.reason}, code: ${Pe.exitCode})`,(0,T.onUnexpectedError)(new Error(Ue)),Ee.publicLog2("sharedprocesserror",{type:De,reason:typeof Pe!="string"?Pe==null?void 0:Pe.reason:void 0,visible:pe.isVisible(),shuttingdown:ge})}));const Le=this.productService.win32MutexName;if(S.isWindows&&Le)try{const De=j.__$__nodeRequire("windows-mutex").Mutex,Pe=new De(Le);(0,ce.once)(this.lifecycleMainService.onWillShutdown)(()=>Pe.release())}catch(De){this.logService.error(De)}R.protocol.registerHttpProtocol(ee.Schemas.vscodeRemoteResource,(De,Pe)=>{Pe({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})});const ke=he.get(p.IUpdateService);(ke instanceof N.Win32UpdateService||ke instanceof C.LinuxUpdateService||ke instanceof $.DarwinUpdateService)&&ke.initialize(),(async()=>{const De=this._register(new q.RunOnceScheduler(()=>this.logService.warn("Resolving your shell environment is taking more than 10s. Please review your shell configuration. Learn more at https://go.microsoft.com/fwlink/?linkid=2149667."),1e4));De.schedule(),await(0,w.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env),De.dispose()})();try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,tt.stripComments)(Pe))["enable-crash-reporter"]===void 0){const $e=(fe=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&fe!==void 0?fe:!0,Ye=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${$e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,ze.generateUuid)()}"`,"}"],Xe=Pe.substring(0,Pe.length-2).concat(`,
`,Ye.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,at.VSBuffer.fromString(Xe))}}catch(De){this.logService.error(De)}}stopTracingEventually(he,pe){this.logService.info("Tracing: waiting for windows to get ready...");const fe=he.get(Ie.IDialogMainService);let ge=!1;const Ee=async ke=>{if(!ge){ge=!0;const De=await R.contentTracing.stopRecording((0,G.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);ke?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${De}`):fe.showMessageBox({type:"info",message:(0,Y.localize)(4,null),detail:(0,Y.localize)(5,null,De),buttons:[(0,Y.localize)(6,null)]},(0,Re.withNullAsUndefined)(R.BrowserWindow.getFocusedWindow()))}},Le=setTimeout(()=>Ee(!0),3e4);Promise.all(pe.map(ke=>ke.ready())).then(()=>{clearTimeout(Le),Ee(!1)})}};We=ue([te(2,D.IInstantiationService),te(3,c.ILogService),te(4,l.IEnvironmentMainService),te(5,i.ILifecycleMainService),te(6,t.IConfigurationService),te(7,a.IStateMainService),te(8,Ve.IFileService),te(9,L.IProductService)],We),e.CodeApplication=We}),define(J[240],Z([0,1,14,20,11,3,72,47,54,161,17,33,56,173,71,69,6,225,38,16,187,49,223,236,39,95,94,18,60,42,75,194,197,181,182,10,22,74,221,23,30,24,8,35,25,67,98,179,32,55,184,9,203]),function(j,e,v,A,R,S,M,i,w,p,n,E,P,b,f,m,D,I,o,c,a,l,t,r,s,u,h,g,d,y,L,O,z,X,x,H,Q,B,N,C,$,V,_,T,W,k,F,U,K,G,Y,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class re{main(){try{this.startup()}catch(ne){console.error(ne.message),v.app.exit(1)}}async startup(){(0,g.setUnexpectedErrorHandler)(me=>console.error(me));const[ne,le,ve,we,Se,Ae,ye]=this.createServices();try{try{await this.initServices(ve,we,Se)}catch(me){throw this.handleStartupDataDirError(ve,ye.nameLong,me),me}await ne.invokeFunction(async me=>{const Ie=me.get(D.ILogService),Re=me.get(n.ILifecycleMainService),Fe=me.get(Q.IFileService),Ne=await this.claimInstance(Ie,ve,Re,ne,ye,!0);return Ae.logger=new u.SpdLogLogger("main",(0,_.join)(ve.logsPath,"main.log"),!0,Ae.getLevel()),(0,y.once)(Re.onWillShutdown)(()=>{Fe.dispose(),we.dispose()}),ne.createInstance(r.CodeApplication,Ne,le).startup()})}catch(me){ne.invokeFunction(this.quit,me)}}createServices(){const ne=new f.ServiceCollection,le=Object.assign({_serviceBrand:void 0},i.default);ne.set(C.IProductService,le);const ve=new W.EnvironmentMainService(this.resolveArgs(),le),we=this.patchEnvironment(ve);ne.set(W.IEnvironmentMainService,ve);const Se=new h.BufferLogService,Ae=new D.MultiplexLogService([new D.ConsoleMainLogger((0,D.getLogLevel)(ve)),Se]);process.once("exit",()=>Ae.dispose()),ne.set(D.ILogService,Ae);const ye=new X.FileService(Ae);ne.set(Q.IFileService,ye);const me=new x.DiskFileSystemProvider(Ae);ye.registerProvider(H.Schemas.file,me),ne.set(D.ILoggerService,new U.LoggerService(Ae,ye));const Ie=new a.ConfigurationService(ve.settingsResource,ye);ne.set(c.IConfigurationService,Ie),ne.set(n.ILifecycleMainService,new m.SyncDescriptor(n.LifecycleMainService));const Re=new I.StateMainService(ve,Ae,ye);return ne.set(o.IStateMainService,Re),ne.set(l.IRequestService,new m.SyncDescriptor(t.RequestMainService)),ne.set(d.IThemeMainService,new m.SyncDescriptor(d.ThemeMainService)),ne.set(L.ISignService,new m.SyncDescriptor(O.SignService)),ne.set(B.ITunnelService,new m.SyncDescriptor(N.TunnelService)),ne.set(G.IProtocolMainService,new m.SyncDescriptor(Y.ProtocolMainService)),[new b.InstantiationService(ne,!0),we,ve,Ie,Re,Se,le]}patchEnvironment(ne){const le={VSCODE_IPC_HOOK:ne.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ve=>{const we=process.env[ve];typeof we=="string"&&(le[ve]=we)}),Object.assign(process.env,le),le}initServices(ne,le,ve){return ee.Promises.settled([Promise.all([ne.extensionsPath,ne.nodeCachedDataDir,ne.logsPath,ne.globalStorageHome.fsPath,ne.workspaceStorageHome.fsPath,ne.backupHome].map(we=>we?A.promises.mkdir(we,{recursive:!0}):void 0)),le.initialize(),ve.init()])}async claimInstance(ne,le,ve,we,Se,Ae){let ye;try{(0,M.mark)("code/willStartMainServer"),ye=await(0,P.serve)(le.mainIPCHandle),(0,M.mark)("code/didStartMainServer"),(0,y.once)(ve.onWillShutdown)(()=>ye.dispose())}catch(me){if(me.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,Se.nameLong,me),me;let Ie;try{Ie=await(0,P.connect)(le.mainIPCHandle,"main")}catch(Ne){if(!Ae||S.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,R.localize)(0,null,Se.nameShort),(0,R.localize)(1,null),Se.nameLong),Ne;try{(0,A.unlinkSync)(le.mainIPCHandle)}catch(qe){throw ne.warn("Could not delete obsolete instance handle",qe),qe}return this.claimInstance(ne,le,ve,we,Se,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ne.error(Ne),Ie.dispose(),new Error(Ne)}let Re;!le.args.wait&&!le.args.status&&(Re=setTimeout(()=>{this.showStartupWarningDialog((0,R.localize)(2,null,Se.nameShort),(0,R.localize)(3,null),Se.nameLong)},1e4));const Fe=E.ProxyChannel.toService(Ie.getChannel("launch"),{disableMarshalling:!0});if(le.args.status)return we.invokeFunction(async()=>{const Ne=new z.DiagnosticsService(F.NullTelemetryService,Se),qe=await Fe.getMainProcessInfo(),Ve=await Fe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),tt=await Ne.getDiagnostics(qe,Ve);throw console.log(tt),new g.ExpectedError});throw S.isWindows&&await this.windowsAllowSetForegroundWindow(Fe,ne),ne.trace("Sending env to running instance..."),await Fe.start(le.args,process.env),Ie.dispose(),Re&&clearTimeout(Re),new g.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw ne.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new g.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(ne,le,ve){if(ve.code==="EACCES"||ve.code==="EPERM"){const we=(0,T.coalesce)([ne.userDataPath,ne.extensionsPath,P.XDG_RUNTIME_DIR]).map(Se=>(0,s.getPathLabel)(Se,ne));this.showStartupWarningDialog((0,R.localize)(4,null),(0,R.localize)(5,null,(0,k.toErrorMessage)(ve),we.join(`
`)),le)}}showStartupWarningDialog(ne,le,ve){v.dialog.showMessageBoxSync({title:ve,type:"warning",buttons:[(0,s.mnemonicButtonLabel)((0,R.localize)(6,null))],message:ne,detail:le,noLink:!0})}async windowsAllowSetForegroundWindow(ne,le){if(S.isWindows){const ve=await ne.getMainProcessId();le.trace("Sending some foreground love to the running instance:",ve);try{(await new Promise((we,Se)=>{j(["windows-foreground-love"],we,Se)})).allowSetForegroundWindow(ve)}catch(we){le.error(we)}}}quit(ne,le){const ve=ne.get(D.ILogService),we=ne.get(n.ILifecycleMainService);let Se=0;le&&(le.isExpected?le.message&&ve.trace(le.message):(Se=1,le.stack?ve.error(le.stack):ve.error(`Startup error: ${le.toString()}`))),we.kill(Se)}resolveArgs(){const ne=this.validatePaths((0,w.parseMainProcessArgv)(process.argv));if(ne.wait&&!ne.waitMarkerFilePath){const le=(0,p.createWaitMarkerFile)(ne.verbose);le&&((0,w.addArg)(process.argv,"--waitMarkerFilePath",le),ne.waitMarkerFilePath=le)}return ne}validatePaths(ne){if(ne["open-url"]&&(ne._urls=ne._,ne._=[]),!ne.remote){const le=this.doValidatePaths(ne._,ne.goto);ne._=le}return ne}doValidatePaths(ne,le){const ve=(0,K.cwd)(),we=ne.map(ye=>{let me=String(ye),Ie;le&&(Ie=(0,$.parseLineAndColumnAware)(me),me=Ie.path),me&&(me=this.preparePath(ve,me));const Re=(0,$.sanitizeFilePath)(me,ve),Fe=(0,_.basename)(Re);return Fe&&!(0,$.isValidBasename)(Fe)?null:le&&Ie?(Ie.path=Re,this.toPath(Ie)):Re}),Se=S.isWindows||S.isMacintosh,Ae=(0,T.distinct)(we,ye=>ye&&Se?ye.toLowerCase():ye||"");return(0,T.coalesce)(Ae)}preparePath(ne,le){return S.isWindows&&(le=(0,V.rtrim)(le,'"')),le=(0,V.trim)((0,V.trim)(le," "),"	"),S.isWindows&&(le=(0,_.resolve)(ne,le),le=(0,V.rtrim)(le,".")),le}toPath(ne){const le=[ne.path];return typeof ne.line=="number"&&le.push(String(ne.line)),typeof ne.column=="number"&&le.push(String(ne.column)),le.join(":")}}new re().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/53b58c89d44deb230dc526605561a1d42f6d1c50/core/vs/code/electron-main/main.js.map
