/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/platform","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/base/common/stopwatch","vs/base/common/codicons","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(G){for(var e=[],b=0,L=G.length;b<L;b++)e[b]=me[G[b]];return e};define(me[52],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(L,I){if(!L)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=b}),define(me[53],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const b=Object.prototype.hasOwnProperty;function L(P){const h=[];for(let p in P)b.call(P,p)&&h.push(P[p]);return h}e.values=L;function I(P,h){for(let p in P)if(b.call(P,p)&&h({key:p,value:P[p]},function(){delete P[p]})===!1)return}e.forEach=I;function T(P,h){const p=Object.create(null);for(const o of P){const d=h(o);let E=p[d];E||(E=p[d]=[]),E.push(o)}return p}e.groupBy=T;function y(P,h){const p=new Map;for(const o of P){const d=h(o);let E=p.get(d);E||(E=[],p.set(d,E)),E.push(o)}return p}e.groupByNumber=y;function C(P){const h=Object.create(null);return P&&P.forEach((p,o)=>{h[o]=p}),h}e.fromMap=C;function D(P,h){const p=[],o=[];for(let d of P)h.has(d)||p.push(d);for(let d of h)P.has(d)||o.push(d);return{removed:p,added:o}}e.diffSets=D;function k(P,h){const p=[],o=[];for(let[d,E]of P)h.has(d)||p.push(E);for(let[d,E]of h)P.has(d)||o.push(E);return{removed:p,added:o}}e.diffMaps=k;class i{constructor(){this.map=new Map}add(h,p){let o=this.map.get(h);o||(o=new Set,this.map.set(h,o)),o.add(p)}delete(h,p){const o=this.map.get(h);!o||(o.delete(p),o.size===0&&this.map.delete(h))}forEach(h,p){const o=this.map.get(h);!o||o.forEach(p)}}e.SetMap=i}),define(me[54],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function b(y){return(C,D,k)=>{let i=null,P=null;if(typeof k.value=="function"?(i="value",P=k.value):typeof k.get=="function"&&(i="get",P=k.get),!P)throw new Error("not supported");k[i]=y(P,D)}}e.createDecorator=b;function L(y,C,D){let k=null,i=null;if(typeof D.value=="function"?(k="value",i=D.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(k="get",i=D.get),!i)throw new Error("not supported");const P=`$memoize$${C}`;D[k]=function(...h){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,h)}),this[P]}}e.memoize=L;function I(y,C,D){return b((k,i)=>{const P=`$debounce$${i}`,h=`$debounce$result$${i}`;return function(...p){this[h]||(this[h]=D?D():void 0),clearTimeout(this[P]),C&&(this[h]=C(this[h],...p),p=[this[h]]),this[P]=setTimeout(()=>{k.apply(this,p),this[h]=D?D():void 0},y)}})}e.debounce=I;function T(y,C,D){return b((k,i)=>{const P=`$throttle$timer$${i}`,h=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,o=`$throttle$pending$${i}`;return function(...d){if(this[h]||(this[h]=D?D():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),C&&(this[h]=C(this[h],...d)),!this[o]){const E=this[p]+y;E<=Date.now()?(this[p]=Date.now(),k.apply(this,[this[h]]),this[h]=D?D():void 0):(this[o]=!0,this[P]=setTimeout(()=>{this[o]=!1,this[p]=Date.now(),k.apply(this,[this[h]]),this[h]=D?D():void 0},E-Date.now()))}}})}e.throttle=T}),define(me[17],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=b,e.errorHandler=new b;function L(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=L;function I(f){D(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=I;function T(f){D(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=T;function y(f){if(f instanceof Error){let{name:t,message:n}=f;const s=f.stacktrace||f.stack;return{$isError:!0,name:t,message:n,stack:s}}return f}e.transformErrorForSerialization=y;const C="Canceled";function D(f){return f instanceof Error&&f.name===C&&f.message===C}e.isPromiseCanceledError=D;class k extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=k;function i(){const f=new Error(C);return f.name=f.message,f}e.canceled=i;function P(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=P;function h(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=h;function p(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function o(f){const t=new Error(`${f} has been disposed`);return t.name="DISPOSED",t}e.disposed=o;function d(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=d;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function u(f){const t=f;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function c(f,t=Object.create(null)){const n=new Error(f);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=c}),define(me[16],ge([0,1,17]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(U,A=0){return U[U.length-(1+A)]}e.tail=L;function I(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=I;function T(U,A,x=(F,M)=>F===M){if(U===A)return!0;if(!U||!A||U.length!==A.length)return!1;for(let F=0,M=U.length;F<M;F++)if(!x(U[F],A[F]))return!1;return!0}e.equals=T;function y(U,A,x){let F=0,M=U.length-1;for(;F<=M;){const W=(F+M)/2|0,z=x(U[W],A);if(z<0)F=W+1;else if(z>0)M=W-1;else return W}return-(F+1)}e.binarySearch=y;function C(U,A){let x=0,F=U.length;if(F===0)return 0;for(;x<F;){const M=Math.floor((x+F)/2);A(U[M])?F=M:x=M+1}return x}e.findFirstInSorted=C;function D(U,A,x){if(U=U|0,U>=A.length)throw new TypeError("invalid index");let F=A[Math.floor(A.length*Math.random())],M=[],W=[],z=[];for(let Y of A){const le=x(Y,F);le<0?M.push(Y):le>0?W.push(Y):z.push(Y)}return U<M.length?D(U,M,x):U<M.length+z.length?z[0]:D(U-(M.length+z.length),W,x)}e.quickSelect=D;function k(U,A){const x=[];let F;for(const M of U.slice(0).sort(A))!F||A(F[0],M)!==0?(F=[M],x.push(F)):F.push(M);return x}e.groupBy=k;function i(U,A,x){const F=[];function M(Y,le,ve){if(!(le===0&&ve.length===0)){const Te=F[F.length-1];Te&&Te.start+Te.deleteCount===Y?(Te.deleteCount+=le,Te.toInsert.push(...ve)):F.push({start:Y,deleteCount:le,toInsert:ve})}}let W=0,z=0;for(;;){if(W===U.length){M(W,0,A.slice(z));break}if(z===A.length){M(W,U.length-W,[]);break}const Y=U[W],le=A[z],ve=x(Y,le);ve===0?(W+=1,z+=1):ve<0?(M(W,1,[]),W+=1):ve>0&&(M(W,0,[le]),z+=1)}return F}e.sortedDiff=i;function P(U,A,x){const F=i(U,A,x),M=[],W=[];for(const z of F)M.push(...U.slice(z.start,z.start+z.deleteCount)),W.push(...z.toInsert);return{removed:M,added:W}}e.delta=P;function h(U,A,x){if(x===0)return[];const F=U.slice(0,x).sort(A);return o(U,A,F,x,U.length),F}e.top=h;function p(U,A,x,F,M){return x===0?Promise.resolve([]):new Promise((W,z)=>{(async()=>{const Y=U.length,le=U.slice(0,x).sort(A);for(let ve=x,Te=Math.min(x+F,Y);ve<Y;ve=Te,Te=Math.min(Te+F,Y)){if(ve>x&&await new Promise(ye=>setTimeout(ye)),M&&M.isCancellationRequested)throw(0,b.canceled)();o(U,A,le,ve,Te)}return le})().then(W,z)})}e.topAsync=p;function o(U,A,x,F,M){for(const W=x.length;F<M;F++){const z=U[F];if(A(z,x[W-1])<0){x.pop();const Y=C(x,le=>A(z,le)<0);x.splice(Y,0,z)}}}function d(U){return U.filter(A=>!!A)}e.coalesce=d;function E(U){let A=0;for(let x=0;x<U.length;x++)U[x]&&(U[A]=U[x],A+=1);U.length=A}e.coalesceInPlace=E;function w(U,A,x){U.splice(x,0,U.splice(A,1)[0])}e.move=w;function S(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=S;function u(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=u;function c(U,A){if(!A)return U.filter((F,M)=>U.indexOf(F)===M);const x=Object.create(null);return U.filter(F=>{const M=A(F);return x[M]?!1:(x[M]=!0,!0)})}e.distinct=c;function f(U){const A=new Set;return U.filter(x=>A.has(x)?!1:(A.add(x),!0))}e.distinctES6=f;function t(U){const A=Object.create(null);return x=>{const F=U(x);return A[F]?!1:(A[F]=!0,!0)}}e.uniqueFilter=t;function n(U,A){for(let x=U.length-1;x>=0;x--){const F=U[x];if(A(F))return x}return-1}e.lastIndex=n;function s(U,A){return U.length>0?U[0]:A}e.firstOrDefault=s;function r(U,A,x=(F,M)=>F===M){let F=0;for(let M=0,W=Math.min(U.length,A.length);M<W&&x(U[M],A[M]);M++)F++;return F}e.commonPrefixLength=r;function a(U){return[].concat(...U)}e.flatten=a;function g(U,A){let x=typeof A=="number"?U:0;typeof A=="number"?x=U:(x=0,A=U);const F=[];if(x<=A)for(let M=x;M<A;M++)F.push(M);else for(let M=x;M>A;M--)F.push(M);return F}e.range=g;function m(U,A,x){return U.reduce((F,M)=>(F[A(M)]=x?x(M):M,F),Object.create(null))}e.index=m;function _(U,A){return U.push(A),()=>l(U,A)}e.insert=_;function l(U,A){const x=U.indexOf(A);if(x>-1)return U.splice(x,1),A}e.remove=l;function v(U,A,x){const F=U.slice(0,A),M=U.slice(A);return F.concat(x,M)}e.arrayInsert=v;function R(U,A){let x;if(typeof A=="number"){let F=A;x=()=>{const M=Math.sin(F++)*179426549;return M-Math.floor(M)}}else x=Math.random;for(let F=U.length-1;F>0;F-=1){const M=Math.floor(x()*(F+1)),W=U[F];U[F]=U[M],U[M]=W}}e.shuffle=R;function O(U,A){const x=U.indexOf(A);x>-1&&(U.splice(x,1),U.unshift(A))}e.pushToStart=O;function H(U,A){const x=U.indexOf(A);x>-1&&(U.splice(x,1),U.push(A))}e.pushToEnd=H;function ne(U,A){return Array.isArray(U)?U.map(A):A(U)}e.mapArrayOrNot=ne;function ie(U){return Array.isArray(U)?U:[U]}e.asArray=ie;function N(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=N;function B(U,A){for(const x of U){const F=A(x);if(F!==void 0)return F}}e.mapFind=B}),define(me[72],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(L){const I=this;let T=!1,y;return function(){return T||(T=!0,y=L.apply(I,arguments)),y}}e.once=b}),define(me[73],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class b{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=b,e.defaultGenerator=new b("id#")}),define(me[55],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(L){function I(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}L.is=I;const T=Object.freeze([]);function y(){return T}L.empty=y;function*C(f){yield f}L.single=C;function D(f){return f||T}L.from=D;function k(f){return!f||f[Symbol.iterator]().next().done===!0}L.isEmpty=k;function i(f){return f[Symbol.iterator]().next().value}L.first=i;function P(f,t){for(const n of f)if(t(n))return!0;return!1}L.some=P;function h(f,t){for(const n of f)if(t(n))return n}L.find=h;function*p(f,t){for(const n of f)t(n)&&(yield n)}L.filter=p;function*o(f,t){for(const n of f)yield t(n)}L.map=o;function*d(...f){for(const t of f)for(const n of t)yield n}L.concat=d;function*E(f){for(const t of f)for(const n of t)yield n}L.concatNested=E;function w(f,t,n){let s=n;for(const r of f)s=t(s,r);return s}L.reduce=w;function*S(f,t,n=f.length){for(t<0&&(t+=f.length),n<0?n+=f.length:n>f.length&&(n=f.length);t<n;t++)yield f[t]}L.slice=S;function u(f,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,f];const s=f[Symbol.iterator]();for(let r=0;r<t;r++){const a=s.next();if(a.done)return[n,L.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return s}}]}L.consume=u;function c(f,t,n=(s,r)=>s===r){const s=f[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const a=s.next(),g=r.next();if(a.done!==g.done)return!1;if(a.done)return!0;if(!n(a.value,g.value))return!1}}L.equals=c})(b=e.Iterable||(e.Iterable={}))}),define(me[56],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let s=0,r=t.length,a="",g=0,m=16,_=0;function l(N){let B=0,U=0;for(;B<N;){const A=t.charCodeAt(s);if(A>=48&&A<=57)U=U*16+A-48;else if(A>=65&&A<=70)U=U*16+A-65+10;else if(A>=97&&A<=102)U=U*16+A-97+10;else break;s++,B++}return B<N&&(U=-1),U}function v(N){s=N,a="",g=0,m=16,_=0}function R(){const N=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return _=3,t.substring(N,s);let B=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;B=s}else _=3;return t.substring(N,B)}function O(){let N="",B=s;for(;;){if(s>=r){N+=t.substring(B,s),_=2;break}const U=t.charCodeAt(s);if(U===34){N+=t.substring(B,s),s++;break}if(U===92){if(N+=t.substring(B,s),s++,s>=r){_=2;break}switch(t.charCodeAt(s++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:const x=l(4);x>=0?N+=String.fromCharCode(x):_=4;break;default:_=5}B=s;continue}if(U>=0&&U<=31)if(D(U)){N+=t.substring(B,s),_=2;break}else _=6;s++}return N}function H(){if(a="",_=0,g=s,s>=r)return g=r,m=17;let N=t.charCodeAt(s);if(C(N)){do s++,a+=String.fromCharCode(N),N=t.charCodeAt(s);while(C(N));return m=15}if(D(N))return s++,a+=String.fromCharCode(N),N===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),m=14;switch(N){case 123:return s++,m=1;case 125:return s++,m=2;case 91:return s++,m=3;case 93:return s++,m=4;case 58:return s++,m=6;case 44:return s++,m=5;case 34:return s++,a=O(),m=10;case 47:const B=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!D(t.charCodeAt(s));)s++;return a=t.substring(B,s),m=12}if(t.charCodeAt(s+1)===42){s+=2;const U=r-1;let A=!1;for(;s<U;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,A=!0;break}s++}return A||(s++,_=1),a=t.substring(B,s),m=13}return a+=String.fromCharCode(N),s++,m=16;case 45:if(a+=String.fromCharCode(N),s++,s===r||!k(t.charCodeAt(s)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=R(),m=11;default:for(;s<r&&ne(N);)s++,N=t.charCodeAt(s);if(g!==s){switch(a=t.substring(g,s),a){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return a+=String.fromCharCode(N),s++,m=16}}function ne(N){if(C(N)||D(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let N;do N=H();while(N>=12&&N<=15);return N}return{setPosition:v,getPosition:()=>s,scan:n?ie:H,getToken:()=>m,getTokenValue:()=>a,getTokenOffset:()=>g,getTokenLength:()=>s-g,getTokenError:()=>_}}e.createScanner=y;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function P(t,n){const s=[],r=new Object;let a;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function _(l,v,R,O){g.value=l,g.offset=v,g.length=R,g.type=O,g.colonOffset=void 0,a=g}try{u(t,{onObjectBegin:(l,v)=>{if(n<=l)throw r;a=void 0,m=n>l,s.push("")},onObjectProperty:(l,v,R)=>{if(n<v||(_(l,v,R,"property"),s[s.length-1]=l,n<=v+R))throw r},onObjectEnd:(l,v)=>{if(n<=l)throw r;a=void 0,s.pop()},onArrayBegin:(l,v)=>{if(n<=l)throw r;a=void 0,s.push(0)},onArrayEnd:(l,v)=>{if(n<=l)throw r;a=void 0,s.pop()},onLiteralValue:(l,v,R)=>{if(n<v||(_(l,v,R,f(l)),n<=v+R))throw r},onSeparator:(l,v,R)=>{if(n<=v)throw r;if(l===":"&&a&&a.type==="property")a.colonOffset=v,m=!1,a=void 0;else if(l===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(m=!0,s[s.length-1]=""),a=void 0}}})}catch(l){if(l!==r)throw l}return{path:s,previousNode:a,isAtPropertyKey:m,matches:l=>{let v=0;for(let R=0;v<l.length&&R<s.length;R++)if(l[v]===s[R]||l[v]==="*")v++;else if(l[v]!=="**")return!1;return v===l.length}}}e.getLocation=P;function h(t,n=[],s=T.DEFAULT){let r=null,a=[];const g=[];function m(l){Array.isArray(a)?a.push(l):r!==null&&(a[r]=l)}return u(t,{onObjectBegin:()=>{const l={};m(l),g.push(a),a=l,r=null},onObjectProperty:l=>{r=l},onObjectEnd:()=>{a=g.pop()},onArrayBegin:()=>{const l=[];m(l),g.push(a),a=l,r=null},onArrayEnd:()=>{a=g.pop()},onLiteralValue:m,onError:(l,v,R)=>{n.push({error:l,offset:v,length:R})}},s),a[0]}e.parse=h;function p(t,n=[],s=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(l){r.type==="property"&&(r.length=l-r.offset,r=r.parent)}function g(l){return r.children.push(l),l}u(t,{onObjectBegin:l=>{r=g({type:"object",offset:l,length:-1,parent:r,children:[]})},onObjectProperty:(l,v,R)=>{r=g({type:"property",offset:v,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:l,offset:v,length:R,parent:r})},onObjectEnd:(l,v)=>{r.length=l+v-r.offset,r=r.parent,a(l+v)},onArrayBegin:(l,v)=>{r=g({type:"array",offset:l,length:-1,parent:r,children:[]})},onArrayEnd:(l,v)=>{r.length=l+v-r.offset,r=r.parent,a(l+v)},onLiteralValue:(l,v,R)=>{g({type:f(l),offset:v,length:R,parent:r,value:l}),a(v+R)},onSeparator:(l,v,R)=>{r.type==="property"&&(l===":"?r.colonOffset=v:l===","&&a(v))},onError:(l,v,R)=>{n.push({error:l,offset:v,length:R})}},s);const _=r.children[0];return _&&delete _.parent,_}e.parseTree=p;function o(t,n){if(!!t){let s=t;for(let r of n)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const g of s.children)if(Array.isArray(g.children)&&g.children[0].value===r){s=g.children[1],a=!0;break}if(!a)return}else{const a=r;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}}e.findNodeAtLocation=o;function d(t){if(!t.parent||!t.parent.children)return[];const n=d(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=d;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const n=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(n[s.children[0].value]=E(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function w(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=w;function S(t,n,s=!1){if(w(t,n,s)){const r=t.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=n;a++){const g=S(r[a],n,s);if(g)return g}return t}}e.findNodeAtOffset=S;function u(t,n,s=T.DEFAULT){const r=y(t,!1);function a(le){return le?()=>le(r.getTokenOffset(),r.getTokenLength()):()=>!0}function g(le){return le?ve=>le(ve,r.getTokenOffset(),r.getTokenLength()):()=>!0}const m=a(n.onObjectBegin),_=g(n.onObjectProperty),l=a(n.onObjectEnd),v=a(n.onArrayBegin),R=a(n.onArrayEnd),O=g(n.onLiteralValue),H=g(n.onSeparator),ne=a(n.onComment),ie=g(n.onError),N=s&&s.disallowComments,B=s&&s.allowTrailingComma;function U(){for(;;){const le=r.scan();switch(r.getTokenError()){case 4:A(14);break;case 5:A(15);break;case 3:A(13);break;case 1:N||A(11);break;case 2:A(12);break;case 6:A(16);break}switch(le){case 12:case 13:N?A(10):ne();break;case 16:A(1);break;case 15:case 14:break;default:return le}}}function A(le,ve=[],Te=[]){if(ie(le),ve.length+Te.length>0){let ye=r.getToken();for(;ye!==17;){if(ve.indexOf(ye)!==-1){U();break}else if(Te.indexOf(ye)!==-1)break;ye=U()}}}function x(le){const ve=r.getTokenValue();return le?O(ve):_(ve),U(),!0}function F(){switch(r.getToken()){case 11:let le=0;try{le=JSON.parse(r.getTokenValue()),typeof le!="number"&&(A(2),le=0)}catch(ve){A(2)}O(le);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return U(),!0}function M(){return r.getToken()!==10?(A(3,[],[2,5]),!1):(x(!1),r.getToken()===6?(H(":"),U(),Y()||A(4,[],[2,5])):A(5,[],[2,5]),!0)}function W(){m(),U();let le=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(le||A(4,[],[]),H(","),U(),r.getToken()===2&&B)break}else le&&A(6,[],[]);M()||A(4,[],[2,5]),le=!0}return l(),r.getToken()!==2?A(7,[2],[]):U(),!0}function z(){v(),U();let le=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(le||A(4,[],[]),H(","),U(),r.getToken()===4&&B)break}else le&&A(6,[],[]);Y()||A(4,[],[4,5]),le=!0}return R(),r.getToken()!==4?A(8,[4],[]):U(),!0}function Y(){switch(r.getToken()){case 3:return z();case 1:return W();case 10:return x(!0);default:return F()}}return U(),r.getToken()===17?s.allowEmptyContent?!0:(A(4,[],[]),!1):Y()?(r.getToken()!==17&&A(9,[],[]),!0):(A(4,[],[]),!1)}e.visit=u;function c(t,n){let s=y(t),r=[],a,g=0,m;do switch(m=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:g!==m&&r.push(t.substring(g,m)),n!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,n)),g=s.getPosition();break}while(a!==17);return r.join("")}e.stripComments=c;function f(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(me[132],ge([0,1,56]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(D,k,i){let P,h,p,o,d;if(k){for(o=k.offset,d=o+k.length,p=o;p>0&&!C(D,p-1);)p--;let g=d;for(;g<D.length&&!C(D,g);)g++;h=D.substring(p,g),P=T(h,i)}else h=D,P=0,p=0,o=0,d=D.length;const E=y(i,D);let w=!1,S=0,u;i.insertSpaces?u=I(" ",i.tabSize||4):u="	";const c=(0,b.createScanner)(h,!1);let f=!1;function t(){return E+I(u,P+S)}function n(){let g=c.scan();for(w=!1;g===15||g===14;)w=w||g===14,g=c.scan();return f=g===16||c.getTokenError()!==0,g}const s=[];function r(g,m,_){!f&&m<d&&_>o&&D.substring(m,_)!==g&&s.push({offset:m,length:_-m,content:g})}let a=n();if(a!==17){const g=c.getTokenOffset()+p,m=I(u,P);r(m,p,g)}for(;a!==17;){let g=c.getTokenOffset()+c.getTokenLength()+p,m=n(),_="";for(;!w&&(m===12||m===13);){const v=c.getTokenOffset()+p;r(" ",g,v),g=c.getTokenOffset()+c.getTokenLength()+p,_=m===12?t():"",m=n()}if(m===2)a!==1&&(S--,_=t());else if(m===4)a!==3&&(S--,_=t());else{switch(a){case 3:case 1:S++,_=t();break;case 5:case 12:_=t();break;case 13:w?_=t():_=" ";break;case 6:_=" ";break;case 10:if(m===6){_="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?_=" ":m!==5&&m!==17&&(f=!0);break;case 16:f=!0;break}w&&(m===12||m===13)&&(_=t())}const l=c.getTokenOffset()+p;r(_,g,l),a=m}return s}e.format=L;function I(D,k){let i="";for(let P=0;P<k;P++)i+=D;return i}function T(D,k){let i=0,P=0;const h=k.tabSize||4;for(;i<D.length;){const p=D.charAt(i);if(p===" ")P++;else if(p==="	")P+=h;else break;i++}return Math.floor(P/h)}function y(D,k){for(let i=0;i<k.length;i++){const P=k.charAt(i);if(P==="\r")return i+1<k.length&&k.charAt(i+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function C(D,k){return`\r
`.indexOf(D.charAt(k))!==-1}e.isEOL=C}),define(me[133],ge([0,1,56,132]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(k,i,P){return T(k,i,void 0,P)}e.removeProperty=I;function T(k,i,P,h,p){const o=i.slice(),d=[],E=(0,b.parseTree)(k,d);let w,S;for(;o.length>0&&(S=o.pop(),w=(0,b.findNodeAtLocation)(E,o),w===void 0&&P!==void 0);)typeof S=="string"?P={[S]:P}:P=[P];if(w)if(w.type==="object"&&typeof S=="string"&&Array.isArray(w.children)){const u=(0,b.findNodeAtLocation)(w,[S]);if(u!==void 0)if(P===void 0){if(!u.parent)throw new Error("Malformed AST");const c=w.children.indexOf(u.parent);let f,t=u.parent.offset+u.parent.length;if(c>0){const n=w.children[c-1];f=n.offset+n.length}else f=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return y(k,{offset:f,length:t-f,content:""},h)}else return y(k,{offset:u.offset,length:u.length,content:JSON.stringify(P)},h);else{if(P===void 0)return[];const c=`${JSON.stringify(S)}: ${JSON.stringify(P)}`,f=p?p(w.children.map(n=>n.children[0].value)):w.children.length;let t;if(f>0){const n=w.children[f-1];t={offset:n.offset+n.length,length:0,content:","+c}}else w.children.length===0?t={offset:w.offset+1,length:0,content:c}:t={offset:w.offset+1,length:0,content:c+","};return y(k,t,h)}}else if(w.type==="array"&&typeof S=="number"&&Array.isArray(w.children))if(P!==void 0){const u=`${JSON.stringify(P)}`;let c;if(w.children.length===0||S===0)c={offset:w.offset+1,length:0,content:w.children.length===0?u:u+","};else{const f=S===-1||S>w.children.length?w.children.length:S,t=w.children[f-1];c={offset:t.offset+t.length,length:0,content:","+u}}return y(k,c,h)}else{const u=S,c=w.children[u];let f;if(w.children.length===1)f={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===u){const t=w.children[u-1],n=t.offset+t.length,s=w.offset+w.length;f={offset:n,length:s-2-n,content:""}}else f={offset:c.offset,length:w.children[u+1].offset-c.offset,content:""};return y(k,f,h)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${w.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return y(k,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(P)},h)}}e.setProperty=T;function y(k,i,P){let h=C(k,i),p=i.offset,o=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,L.isEOL)(h,p-1);)p--;for(;o<h.length&&!(0,L.isEOL)(h,o);)o++}const d=(0,L.format)(h,{offset:p,length:o-p},P);for(let w=d.length-1;w>=0;w--){const S=d[w];h=C(h,S),p=Math.min(p,S.offset),o=Math.max(o,S.offset+S.length),o+=S.content.length-S.length}const E=k.length-(h.length-o)-p;return[{offset:p,length:E,content:h.substring(p,o)}]}e.withFormatting=y;function C(k,i){return k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)}e.applyEdit=C;function D(k,i){let P=i.slice(0).sort((p,o)=>{const d=p.offset-o.offset;return d===0?p.length-o.length:d}),h=k.length;for(let p=P.length-1;p>=0;p--){let o=P[p];if(o.offset+o.length<=h)k=C(k,o);else throw new Error("Overlapping edit");h=o.offset}return k}e.applyEdits=D}),define(me[134],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new b(()=>I(this.getValue()))}}e.Lazy=b}),define(me[6],ge([0,1,72,55]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const I=!1;let T=null;function y(u){T=u}if(e.setDisposableTracker=y,I){const u="__is_disposable_tracked__";T=new class{trackDisposable(c){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[u]||console.log(f)},3e3)}markTracked(c){if(c&&c!==d.None)try{c[u]=!0}catch(f){}}}}function C(u){!T||T.markTracked(u)}function D(u){return T&&T.trackDisposable(u),u}e.trackDisposable=D;class k extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=k;function i(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=i;function P(u){if(L.Iterable.is(u)){let c=[];for(const f of u)if(f){C(f);try{f.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new k(c);return Array.isArray(u)?[]:u}else if(u)return C(u),u.dispose(),u}e.dispose=P;function h(...u){return u.forEach(C),p(()=>P(u))}e.combinedDisposable=h;function p(u){const c=D({dispose:()=>{C(c),u()}});return c}e.toDisposable=p;class o{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return C(c),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=o,o.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new o,D(this)}dispose(){C(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var f;this._isDisposed||c===this._value||((f=this._value)===null||f===void 0||f.dispose(),c&&C(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,C(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=E;class w{constructor(){this.references=new Map}acquire(c,...f){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...f)},this.references.set(c,t));const{object:n}=t,s=(0,b.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=w;class S{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=S}),define(me[57],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(T){this.element=T,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class L{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){let T=this._first;for(;T!==b.Undefined;){const y=T.next;T.prev=b.Undefined,T.next=b.Undefined,T=y}this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,y){const C=new b(T);if(this._first===b.Undefined)this._first=C,this._last=C;else if(y){const k=this._last;this._last=C,C.prev=k,k.next=C}else{const k=this._first;this._first=C,C.next=k,k.prev=C}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(C))}}shift(){if(this._first!==b.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==b.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==b.Undefined&&T.next!==b.Undefined){const y=T.prev;y.next=T.next,T.next.prev=y}else T.prev===b.Undefined&&T.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):T.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):T.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==b.Undefined;)yield T.element,T=T.next}}e.LinkedList=L}),function(G,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(G=typeof globalThis!="undefined"?globalThis:G||self,G.marked=e())}(this,function(){"use strict";function G(Ce,De){for(var Pe=0;Pe<De.length;Pe++){var oe=De[Pe];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Ce,oe.key,oe)}}function e(Ce,De,Pe){return De&&G(Ce.prototype,De),Pe&&G(Ce,Pe),Ce}function b(Ce,De){if(!!Ce){if(typeof Ce=="string")return L(Ce,De);var Pe=Object.prototype.toString.call(Ce).slice(8,-1);if(Pe==="Object"&&Ce.constructor&&(Pe=Ce.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(Ce);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return L(Ce,De)}}function L(Ce,De){(De==null||De>Ce.length)&&(De=Ce.length);for(var Pe=0,oe=new Array(De);Pe<De;Pe++)oe[Pe]=Ce[Pe];return oe}function I(Ce,De){var Pe;if(typeof Symbol=="undefined"||Ce[Symbol.iterator]==null){if(Array.isArray(Ce)||(Pe=b(Ce))||De&&Ce&&typeof Ce.length=="number"){Pe&&(Ce=Pe);var oe=0;return function(){return oe>=Ce.length?{done:!0}:{done:!1,value:Ce[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=Ce[Symbol.iterator](),Pe.next.bind(Pe)}function T(Ce){var De={exports:{}};return Ce(De,De.exports),De.exports}var y=T(function(Ce){function De(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(oe){Ce.exports.defaults=oe}Ce.exports={defaults:De(),getDefaults:De,changeDefaults:Pe}}),C=/[&<>"']/,D=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(De){return P[De]};function p(Ce,De){if(De){if(C.test(Ce))return Ce.replace(D,h)}else if(k.test(Ce))return Ce.replace(i,h);return Ce}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Ce){return Ce.replace(o,function(De,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var E=/(^|[^\[])\^/g;function w(Ce,De){Ce=Ce.source||Ce,De=De||"";var Pe={replace:function(ue,V){return V=V.source||V,V=V.replace(E,"$1"),Ce=Ce.replace(ue,V),Pe},getRegex:function(){return new RegExp(Ce,De)}};return Pe}var S=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(Ce,De,Pe){if(Ce){var oe;try{oe=decodeURIComponent(d(Pe)).replace(S,"").toLowerCase()}catch(ue){return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}De&&!u.test(Pe)&&(Pe=r(De,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(ue){return null}return Pe}var f={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Ce,De){f[" "+Ce]||(t.test(Ce)?f[" "+Ce]=Ce+"/":f[" "+Ce]=_(Ce,"/",!0)),Ce=f[" "+Ce];var Pe=Ce.indexOf(":")===-1;return De.substring(0,2)==="//"?Pe?De:Ce.replace(n,"$1")+De:De.charAt(0)==="/"?Pe?De:Ce.replace(s,"$1")+De:Ce+De}var a={exec:function(){}};function g(Ce){for(var De=1,Pe,oe;De<arguments.length;De++){Pe=arguments[De];for(oe in Pe)Object.prototype.hasOwnProperty.call(Pe,oe)&&(Ce[oe]=Pe[oe])}return Ce}function m(Ce,De){var Pe=Ce.replace(/\|/g,function(V,J,ce){for(var Ae=!1,Ee=J;--Ee>=0&&ce[Ee]==="\\";)Ae=!Ae;return Ae?"|":" |"}),oe=Pe.split(/ \|/),ue=0;if(oe.length>De)oe.splice(De);else for(;oe.length<De;)oe.push("");for(;ue<oe.length;ue++)oe[ue]=oe[ue].trim().replace(/\\\|/g,"|");return oe}function _(Ce,De,Pe){var oe=Ce.length;if(oe===0)return"";for(var ue=0;ue<oe;){var V=Ce.charAt(oe-ue-1);if(V===De&&!Pe)ue++;else if(V!==De&&Pe)ue++;else break}return Ce.substr(0,oe-ue)}function l(Ce,De){if(Ce.indexOf(De[1])===-1)return-1;for(var Pe=Ce.length,oe=0,ue=0;ue<Pe;ue++)if(Ce[ue]==="\\")ue++;else if(Ce[ue]===De[0])oe++;else if(Ce[ue]===De[1]&&(oe--,oe<0))return ue;return-1}function v(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Ce,De){if(De<1)return"";for(var Pe="";De>1;)De&1&&(Pe+=Ce),De>>=1,Ce+=Ce;return Pe+Ce}var O={escape:p,unescape:d,edit:w,cleanUrl:c,resolveUrl:r,noopTest:a,merge:g,splitCells:m,rtrim:_,findClosingBracket:l,checkSanitizeDeprecation:v,repeatString:R},H=y.defaults,ne=O.rtrim,ie=O.splitCells,N=O.escape,B=O.findClosingBracket;function U(Ce,De,Pe){var oe=De.href,ue=De.title?N(De.title):null,V=Ce[1].replace(/\\([\[\]])/g,"$1");return Ce[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:oe,title:ue,text:V}:{type:"image",raw:Pe,href:oe,title:ue,text:N(V)}}function A(Ce,De){var Pe=Ce.match(/^(\s+)(?:```)/);if(Pe===null)return De;var oe=Pe[1];return De.split(`
`).map(function(ue){var V=ue.match(/^\s+/);if(V===null)return ue;var J=V[0];return J.length>=oe.length?ue.slice(oe.length):ue}).join(`
`)}var x=function(){function Ce(Pe){this.options=Pe||H}var De=Ce.prototype;return De.space=function(oe){var ue=this.rules.block.newline.exec(oe);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},De.code=function(oe){var ue=this.rules.block.code.exec(oe);if(ue){var V=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?V:ne(V,`
`)}}},De.fences=function(oe){var ue=this.rules.block.fences.exec(oe);if(ue){var V=ue[0],J=A(V,ue[3]||"");return{type:"code",raw:V,lang:ue[2]?ue[2].trim():ue[2],text:J}}},De.heading=function(oe){var ue=this.rules.block.heading.exec(oe);if(ue){var V=ue[2].trim();if(/#$/.test(V)){var J=ne(V,"#");(this.options.pedantic||!J||/ $/.test(J))&&(V=J.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:V}}},De.nptable=function(oe){var ue=this.rules.block.nptable.exec(oe);if(ue){var V={type:"table",header:ie(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[],raw:ue[0]};if(V.header.length===V.align.length){var J=V.align.length,ce;for(ce=0;ce<J;ce++)/^ *-+: *$/.test(V.align[ce])?V.align[ce]="right":/^ *:-+: *$/.test(V.align[ce])?V.align[ce]="center":/^ *:-+ *$/.test(V.align[ce])?V.align[ce]="left":V.align[ce]=null;for(J=V.cells.length,ce=0;ce<J;ce++)V.cells[ce]=ie(V.cells[ce],V.header.length);return V}}},De.hr=function(oe){var ue=this.rules.block.hr.exec(oe);if(ue)return{type:"hr",raw:ue[0]}},De.blockquote=function(oe){var ue=this.rules.block.blockquote.exec(oe);if(ue){var V=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],text:V}}},De.list=function(oe){var ue=this.rules.block.list.exec(oe);if(ue){var V=ue[0],J=ue[2],ce=J.length>1,Ae={type:"list",raw:V,ordered:ce,start:ce?+J.slice(0,-1):"",loose:!1,items:[]},Ee=ue[0].match(this.rules.block.item),Me=!1,Ve,Xe,rt,Qe,et,pt,bt,de,Se=Ee.length;rt=this.rules.block.listItemStart.exec(Ee[0]);for(var ae=0;ae<Se;ae++){if(Ve=Ee[ae],V=Ve,ae!==Se-1){if(Qe=this.rules.block.listItemStart.exec(Ee[ae+1]),this.options.pedantic?Qe[1].length>rt[1].length:Qe[1].length>rt[0].length||Qe[1].length>3){Ee.splice(ae,2,Ee[ae]+`
`+Ee[ae+1]),ae--,Se--;continue}else(!this.options.pedantic||this.options.smartLists?Qe[2][Qe[2].length-1]!==J[J.length-1]:ce===(Qe[2].length===1))&&(et=Ee.slice(ae+1).join(`
`),Ae.raw=Ae.raw.substring(0,Ae.raw.length-et.length),ae=Se-1);rt=Qe}Xe=Ve.length,Ve=Ve.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ve.indexOf(`
 `)&&(Xe-=Ve.length,Ve=this.options.pedantic?Ve.replace(/^ {1,4}/gm,""):Ve.replace(new RegExp("^ {1,"+Xe+"}","gm"),"")),pt=Me||/\n\n(?!\s*$)/.test(Ve),ae!==Se-1&&(Me=Ve.charAt(Ve.length-1)===`
`,pt||(pt=Me)),pt&&(Ae.loose=!0),this.options.gfm&&(bt=/^\[[ xX]\] /.test(Ve),de=void 0,bt&&(de=Ve[1]!==" ",Ve=Ve.replace(/^\[[ xX]\] +/,""))),Ae.items.push({type:"list_item",raw:V,task:bt,checked:de,loose:pt,text:Ve})}return Ae}},De.html=function(oe){var ue=this.rules.block.html.exec(oe);if(ue)return{type:this.options.sanitize?"paragraph":"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):N(ue[0]):ue[0]}},De.def=function(oe){var ue=this.rules.block.def.exec(oe);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var V=ue[1].toLowerCase().replace(/\s+/g," ");return{tag:V,raw:ue[0],href:ue[2],title:ue[3]}}},De.table=function(oe){var ue=this.rules.block.table.exec(oe);if(ue){var V={type:"table",header:ie(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(V.header.length===V.align.length){V.raw=ue[0];var J=V.align.length,ce;for(ce=0;ce<J;ce++)/^ *-+: *$/.test(V.align[ce])?V.align[ce]="right":/^ *:-+: *$/.test(V.align[ce])?V.align[ce]="center":/^ *:-+ *$/.test(V.align[ce])?V.align[ce]="left":V.align[ce]=null;for(J=V.cells.length,ce=0;ce<J;ce++)V.cells[ce]=ie(V.cells[ce].replace(/^ *\| *| *\| *$/g,""),V.header.length);return V}}},De.lheading=function(oe){var ue=this.rules.block.lheading.exec(oe);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1]}},De.paragraph=function(oe){var ue=this.rules.block.paragraph.exec(oe);if(ue)return{type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1]}},De.text=function(oe){var ue=this.rules.block.text.exec(oe);if(ue)return{type:"text",raw:ue[0],text:ue[0]}},De.escape=function(oe){var ue=this.rules.inline.escape.exec(oe);if(ue)return{type:"escape",raw:ue[0],text:N(ue[1])}},De.tag=function(oe,ue,V){var J=this.rules.inline.tag.exec(oe);if(J)return!ue&&/^<a /i.test(J[0])?ue=!0:ue&&/^<\/a>/i.test(J[0])&&(ue=!1),!V&&/^<(pre|code|kbd|script)(\s|>)/i.test(J[0])?V=!0:V&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(J[0])&&(V=!1),{type:this.options.sanitize?"text":"html",raw:J[0],inLink:ue,inRawBlock:V,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):N(J[0]):J[0]}},De.link=function(oe){var ue=this.rules.inline.link.exec(oe);if(ue){var V=ue[2].trim();if(!this.options.pedantic&&/^</.test(V)){if(!/>$/.test(V))return;var J=ne(V.slice(0,-1),"\\");if((V.length-J.length)%2==0)return}else{var ce=B(ue[2],"()");if(ce>-1){var Ae=ue[0].indexOf("!")===0?5:4,Ee=Ae+ue[1].length+ce;ue[2]=ue[2].substring(0,ce),ue[0]=ue[0].substring(0,Ee).trim(),ue[3]=""}}var Me=ue[2],Ve="";if(this.options.pedantic){var Xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);Xe&&(Me=Xe[1],Ve=Xe[3])}else Ve=ue[3]?ue[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(V)?Me=Me.slice(1):Me=Me.slice(1,-1)),U(ue,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:Ve&&Ve.replace(this.rules.inline._escapes,"$1")},ue[0])}},De.reflink=function(oe,ue){var V;if((V=this.rules.inline.reflink.exec(oe))||(V=this.rules.inline.nolink.exec(oe))){var J=(V[2]||V[1]).replace(/\s+/g," ");if(J=ue[J.toLowerCase()],!J||!J.href){var ce=V[0].charAt(0);return{type:"text",raw:ce,text:ce}}return U(V,J,V[0])}},De.emStrong=function(oe,ue,V){V===void 0&&(V="");var J=this.rules.inline.emStrong.lDelim.exec(oe);if(!!J&&!(J[3]&&V.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=J[1]||J[2]||"";if(!ce||ce&&(V===""||this.rules.inline.punctuation.exec(V))){var Ae=J[0].length-1,Ee,Me,Ve=Ae,Xe=0,rt=J[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,ue=ue.slice(-1*oe.length+Ae);(J=rt.exec(ue))!=null;)if(Ee=J[1]||J[2]||J[3]||J[4]||J[5]||J[6],!!Ee){if(Me=Ee.length,J[3]||J[4]){Ve+=Me;continue}else if((J[5]||J[6])&&Ae%3&&!((Ae+Me)%3)){Xe+=Me;continue}if(Ve-=Me,!(Ve>0)){if(Ve+Xe-Me<=0&&!ue.slice(rt.lastIndex).match(rt)&&(Me=Math.min(Me,Me+Ve+Xe)),Math.min(Ae,Me)%2)return{type:"em",raw:oe.slice(0,Ae+J.index+Me+1),text:oe.slice(1,Ae+J.index+Me)};if(Math.min(Ae,Me)%2==0)return{type:"strong",raw:oe.slice(0,Ae+J.index+Me+1),text:oe.slice(2,Ae+J.index+Me-1)}}}}}},De.codespan=function(oe){var ue=this.rules.inline.code.exec(oe);if(ue){var V=ue[2].replace(/\n/g," "),J=/[^ ]/.test(V),ce=/^ /.test(V)&&/ $/.test(V);return J&&ce&&(V=V.substring(1,V.length-1)),V=N(V,!0),{type:"codespan",raw:ue[0],text:V}}},De.br=function(oe){var ue=this.rules.inline.br.exec(oe);if(ue)return{type:"br",raw:ue[0]}},De.del=function(oe){var ue=this.rules.inline.del.exec(oe);if(ue)return{type:"del",raw:ue[0],text:ue[2]}},De.autolink=function(oe,ue){var V=this.rules.inline.autolink.exec(oe);if(V){var J,ce;return V[2]==="@"?(J=N(this.options.mangle?ue(V[1]):V[1]),ce="mailto:"+J):(J=N(V[1]),ce=J),{type:"link",raw:V[0],text:J,href:ce,tokens:[{type:"text",raw:J,text:J}]}}},De.url=function(oe,ue){var V;if(V=this.rules.inline.url.exec(oe)){var J,ce;if(V[2]==="@")J=N(this.options.mangle?ue(V[0]):V[0]),ce="mailto:"+J;else{var Ae;do Ae=V[0],V[0]=this.rules.inline._backpedal.exec(V[0])[0];while(Ae!==V[0]);J=N(V[0]),V[1]==="www."?ce="http://"+J:ce=J}return{type:"link",raw:V[0],text:J,href:ce,tokens:[{type:"text",raw:J,text:J}]}}},De.inlineText=function(oe,ue,V){var J=this.rules.inline.text.exec(oe);if(J){var ce;return ue?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):N(J[0]):J[0]:ce=N(this.options.smartypants?V(J[0]):J[0]),{type:"text",raw:J[0],text:ce}}},Ce}(),F=O.noopTest,M=O.edit,W=O.merge,z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=M(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,z.item=M(z.item,"gm").replace(/bull/g,z.bullet).getRegex(),z.listItemStart=M(/^( *)(bull)/).replace("bull",z.bullet).getRegex(),z.list=M(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=M(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=M(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.blockquote=M(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=W({},z),z.gfm=W({},z.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.nptable=M(z.gfm.nptable).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.gfm.table=M(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.pedantic=W({},z.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:M(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Y={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Y._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Y.punctuation=M(Y.punctuation).replace(/punctuation/g,Y._punctuation).getRegex(),Y.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Y.escapedEmSt=/\\\*|\\_/g,Y._comment=M(z._comment).replace("(?:-->|$)","-->").getRegex(),Y.emStrong.lDelim=M(Y.emStrong.lDelim).replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimAst=M(Y.emStrong.rDelimAst,"g").replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimUnd=M(Y.emStrong.rDelimUnd,"g").replace(/punct/g,Y._punctuation).getRegex(),Y._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Y._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Y._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Y.autolink=M(Y.autolink).replace("scheme",Y._scheme).replace("email",Y._email).getRegex(),Y._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Y.tag=M(Y.tag).replace("comment",Y._comment).replace("attribute",Y._attribute).getRegex(),Y._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Y._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Y._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Y.link=M(Y.link).replace("label",Y._label).replace("href",Y._href).replace("title",Y._title).getRegex(),Y.reflink=M(Y.reflink).replace("label",Y._label).getRegex(),Y.reflinkSearch=M(Y.reflinkSearch,"g").replace("reflink",Y.reflink).replace("nolink",Y.nolink).getRegex(),Y.normal=W({},Y),Y.pedantic=W({},Y.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",Y._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Y._label).getRegex()}),Y.gfm=W({},Y.normal,{escape:M(Y.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Y.gfm.url=M(Y.gfm.url,"i").replace("email",Y.gfm._extended_email).getRegex(),Y.breaks=W({},Y.gfm,{br:M(Y.br).replace("{2,}","*").getRegex(),text:M(Y.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var le={block:z,inline:Y},ve=y.defaults,Te=le.block,ye=le.inline,Oe=O.repeatString;function j(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Q(Ce){var De="",Pe,oe,ue=Ce.length;for(Pe=0;Pe<ue;Pe++)oe=Ce.charCodeAt(Pe),Math.random()>.5&&(oe="x"+oe.toString(16)),De+="&#"+oe+";";return De}var Z=function(){function Ce(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||ve,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var oe={block:Te.normal,inline:ye.normal};this.options.pedantic?(oe.block=Te.pedantic,oe.inline=ye.pedantic):this.options.gfm&&(oe.block=Te.gfm,this.options.breaks?oe.inline=ye.breaks:oe.inline=ye.gfm),this.tokenizer.rules=oe}Ce.lex=function(oe,ue){var V=new Ce(ue);return V.lex(oe)},Ce.lexInline=function(oe,ue){var V=new Ce(ue);return V.inlineTokens(oe)};var De=Ce.prototype;return De.lex=function(oe){return oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens,!0),this.inline(this.tokens),this.tokens},De.blockTokens=function(oe,ue,V){ue===void 0&&(ue=[]),V===void 0&&(V=!0),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var J,ce,Ae,Ee;oe;){if(J=this.tokenizer.space(oe)){oe=oe.substring(J.raw.length),J.type&&ue.push(J);continue}if(J=this.tokenizer.code(oe)){oe=oe.substring(J.raw.length),Ee=ue[ue.length-1],Ee&&Ee.type==="paragraph"?(Ee.raw+=`
`+J.raw,Ee.text+=`
`+J.text):ue.push(J);continue}if(J=this.tokenizer.fences(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.heading(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.nptable(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.hr(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.blockquote(oe)){oe=oe.substring(J.raw.length),J.tokens=this.blockTokens(J.text,[],V),ue.push(J);continue}if(J=this.tokenizer.list(oe)){for(oe=oe.substring(J.raw.length),Ae=J.items.length,ce=0;ce<Ae;ce++)J.items[ce].tokens=this.blockTokens(J.items[ce].text,[],!1);ue.push(J);continue}if(J=this.tokenizer.html(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(V&&(J=this.tokenizer.def(oe))){oe=oe.substring(J.raw.length),this.tokens.links[J.tag]||(this.tokens.links[J.tag]={href:J.href,title:J.title});continue}if(J=this.tokenizer.table(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.lheading(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(V&&(J=this.tokenizer.paragraph(oe))){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.text(oe)){oe=oe.substring(J.raw.length),Ee=ue[ue.length-1],Ee&&Ee.type==="text"?(Ee.raw+=`
`+J.raw,Ee.text+=`
`+J.text):ue.push(J);continue}if(oe){var Me="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return ue},De.inline=function(oe){var ue,V,J,ce,Ae,Ee,Me=oe.length;for(ue=0;ue<Me;ue++)switch(Ee=oe[ue],Ee.type){case"paragraph":case"text":case"heading":{Ee.tokens=[],this.inlineTokens(Ee.text,Ee.tokens);break}case"table":{for(Ee.tokens={header:[],cells:[]},ce=Ee.header.length,V=0;V<ce;V++)Ee.tokens.header[V]=[],this.inlineTokens(Ee.header[V],Ee.tokens.header[V]);for(ce=Ee.cells.length,V=0;V<ce;V++)for(Ae=Ee.cells[V],Ee.tokens.cells[V]=[],J=0;J<Ae.length;J++)Ee.tokens.cells[V][J]=[],this.inlineTokens(Ae[J],Ee.tokens.cells[V][J]);break}case"blockquote":{this.inline(Ee.tokens);break}case"list":{for(ce=Ee.items.length,V=0;V<ce;V++)this.inline(Ee.items[V].tokens);break}}return oe},De.inlineTokens=function(oe,ue,V,J){ue===void 0&&(ue=[]),V===void 0&&(V=!1),J===void 0&&(J=!1);var ce,Ae,Ee=oe,Me,Ve,Xe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Ee))!=null;)rt.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Ee=Ee.slice(0,Me.index)+"["+Oe("a",Me[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Ee))!=null;)Ee=Ee.slice(0,Me.index)+"["+Oe("a",Me[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Ee))!=null;)Ee=Ee.slice(0,Me.index)+"++"+Ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;){if(Ve||(Xe=""),Ve=!1,ce=this.tokenizer.escape(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.tag(oe,V,J)){oe=oe.substring(ce.raw.length),V=ce.inLink,J=ce.inRawBlock;var Qe=ue[ue.length-1];Qe&&ce.type==="text"&&Qe.type==="text"?(Qe.raw+=ce.raw,Qe.text+=ce.text):ue.push(ce);continue}if(ce=this.tokenizer.link(oe)){oe=oe.substring(ce.raw.length),ce.type==="link"&&(ce.tokens=this.inlineTokens(ce.text,[],!0,J)),ue.push(ce);continue}if(ce=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ce.raw.length);var et=ue[ue.length-1];ce.type==="link"?(ce.tokens=this.inlineTokens(ce.text,[],!0,J),ue.push(ce)):et&&ce.type==="text"&&et.type==="text"?(et.raw+=ce.raw,et.text+=ce.text):ue.push(ce);continue}if(ce=this.tokenizer.emStrong(oe,Ee,Xe)){oe=oe.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],V,J),ue.push(ce);continue}if(ce=this.tokenizer.codespan(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.br(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.del(oe)){oe=oe.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],V,J),ue.push(ce);continue}if(ce=this.tokenizer.autolink(oe,Q)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(!V&&(ce=this.tokenizer.url(oe,Q))){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.inlineText(oe,J,j)){oe=oe.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(Xe=ce.raw.slice(-1)),Ve=!0,Ae=ue[ue.length-1],Ae&&Ae.type==="text"?(Ae.raw+=ce.raw,Ae.text+=ce.text):ue.push(ce);continue}if(oe){var pt="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(pt);break}else throw new Error(pt)}}return ue},e(Ce,null,[{key:"rules",get:function(){return{block:Te,inline:ye}}}]),Ce}(),se=y.defaults,fe=O.cleanUrl,_e=O.escape,xe=function(){function Ce(Pe){this.options=Pe||se}var De=Ce.prototype;return De.code=function(oe,ue,V){var J=(ue||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(oe,J);ce!=null&&ce!==oe&&(V=!0,oe=ce)}return oe=oe.replace(/\n$/,"")+`
`,J?'<pre><code class="'+this.options.langPrefix+_e(J,!0)+'">'+(V?oe:_e(oe,!0))+`</code></pre>
`:"<pre><code>"+(V?oe:_e(oe,!0))+`</code></pre>
`},De.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},De.html=function(oe){return oe},De.heading=function(oe,ue,V,J){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+J.slug(V)+'">'+oe+"</h"+ue+`>
`:"<h"+ue+">"+oe+"</h"+ue+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(oe,ue,V){var J=ue?"ol":"ul",ce=ue&&V!==1?' start="'+V+'"':"";return"<"+J+ce+`>
`+oe+"</"+J+`>
`},De.listitem=function(oe){return"<li>"+oe+`</li>
`},De.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(oe){return"<p>"+oe+`</p>
`},De.table=function(oe,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ue+`</table>
`},De.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},De.tablecell=function(oe,ue){var V=ue.header?"th":"td",J=ue.align?"<"+V+' align="'+ue.align+'">':"<"+V+">";return J+oe+"</"+V+`>
`},De.strong=function(oe){return"<strong>"+oe+"</strong>"},De.em=function(oe){return"<em>"+oe+"</em>"},De.codespan=function(oe){return"<code>"+oe+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(oe){return"<del>"+oe+"</del>"},De.link=function(oe,ue,V){if(oe=fe(this.options.sanitize,this.options.baseUrl,oe),oe===null)return V;var J='<a href="'+_e(oe)+'"';return ue&&(J+=' title="'+ue+'"'),J+=">"+V+"</a>",J},De.image=function(oe,ue,V){if(oe=fe(this.options.sanitize,this.options.baseUrl,oe),oe===null)return V;var J='<img src="'+oe+'" alt="'+V+'"';return ue&&(J+=' title="'+ue+'"'),J+=this.options.xhtml?"/>":">",J},De.text=function(oe){return oe},Ce}(),pe=function(){function Ce(){}var De=Ce.prototype;return De.strong=function(oe){return oe},De.em=function(oe){return oe},De.codespan=function(oe){return oe},De.del=function(oe){return oe},De.html=function(oe){return oe},De.text=function(oe){return oe},De.link=function(oe,ue,V){return""+V},De.image=function(oe,ue,V){return""+V},De.br=function(){return""},Ce}(),ke=function(){function Ce(){this.seen={}}var De=Ce.prototype;return De.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(oe,ue){var V=oe,J=0;if(this.seen.hasOwnProperty(V)){J=this.seen[oe];do J++,V=oe+"-"+J;while(this.seen.hasOwnProperty(V))}return ue||(this.seen[oe]=J,this.seen[V]=0),V},De.slug=function(oe,ue){ue===void 0&&(ue={});var V=this.serialize(oe);return this.getNextSafeSlug(V,ue.dryrun)},Ce}(),Fe=y.defaults,He=O.unescape,be=function(){function Ce(Pe){this.options=Pe||Fe,this.options.renderer=this.options.renderer||new xe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new ke}Ce.parse=function(oe,ue){var V=new Ce(ue);return V.parse(oe)},Ce.parseInline=function(oe,ue){var V=new Ce(ue);return V.parseInline(oe)};var De=Ce.prototype;return De.parse=function(oe,ue){ue===void 0&&(ue=!0);var V="",J,ce,Ae,Ee,Me,Ve,Xe,rt,Qe,et,pt,bt,de,Se,ae,X,Be,Le,Je=oe.length;for(J=0;J<Je;J++)switch(et=oe[J],et.type){case"space":continue;case"hr":{V+=this.renderer.hr();continue}case"heading":{V+=this.renderer.heading(this.parseInline(et.tokens),et.depth,He(this.parseInline(et.tokens,this.textRenderer)),this.slugger);continue}case"code":{V+=this.renderer.code(et.text,et.lang,et.escaped);continue}case"table":{for(rt="",Xe="",Ee=et.header.length,ce=0;ce<Ee;ce++)Xe+=this.renderer.tablecell(this.parseInline(et.tokens.header[ce]),{header:!0,align:et.align[ce]});for(rt+=this.renderer.tablerow(Xe),Qe="",Ee=et.cells.length,ce=0;ce<Ee;ce++){for(Ve=et.tokens.cells[ce],Xe="",Me=Ve.length,Ae=0;Ae<Me;Ae++)Xe+=this.renderer.tablecell(this.parseInline(Ve[Ae]),{header:!1,align:et.align[Ae]});Qe+=this.renderer.tablerow(Xe)}V+=this.renderer.table(rt,Qe);continue}case"blockquote":{Qe=this.parse(et.tokens),V+=this.renderer.blockquote(Qe);continue}case"list":{for(pt=et.ordered,bt=et.start,de=et.loose,Ee=et.items.length,Qe="",ce=0;ce<Ee;ce++)ae=et.items[ce],X=ae.checked,Be=ae.task,Se="",ae.task&&(Le=this.renderer.checkbox(X),de?ae.tokens.length>0&&ae.tokens[0].type==="text"?(ae.tokens[0].text=Le+" "+ae.tokens[0].text,ae.tokens[0].tokens&&ae.tokens[0].tokens.length>0&&ae.tokens[0].tokens[0].type==="text"&&(ae.tokens[0].tokens[0].text=Le+" "+ae.tokens[0].tokens[0].text)):ae.tokens.unshift({type:"text",text:Le}):Se+=Le),Se+=this.parse(ae.tokens,de),Qe+=this.renderer.listitem(Se,Be,X);V+=this.renderer.list(Qe,pt,bt);continue}case"html":{V+=this.renderer.html(et.text);continue}case"paragraph":{V+=this.renderer.paragraph(this.parseInline(et.tokens));continue}case"text":{for(Qe=et.tokens?this.parseInline(et.tokens):et.text;J+1<Je&&oe[J+1].type==="text";)et=oe[++J],Qe+=`
`+(et.tokens?this.parseInline(et.tokens):et.text);V+=ue?this.renderer.paragraph(Qe):Qe;continue}default:{var it='Token with "'+et.type+'" type was not found.';if(this.options.silent){console.error(it);return}else throw new Error(it)}}return V},De.parseInline=function(oe,ue){ue=ue||this.renderer;var V="",J,ce,Ae=oe.length;for(J=0;J<Ae;J++)switch(ce=oe[J],ce.type){case"escape":{V+=ue.text(ce.text);break}case"html":{V+=ue.html(ce.text);break}case"link":{V+=ue.link(ce.href,ce.title,this.parseInline(ce.tokens,ue));break}case"image":{V+=ue.image(ce.href,ce.title,ce.text);break}case"strong":{V+=ue.strong(this.parseInline(ce.tokens,ue));break}case"em":{V+=ue.em(this.parseInline(ce.tokens,ue));break}case"codespan":{V+=ue.codespan(ce.text);break}case"br":{V+=ue.br();break}case"del":{V+=ue.del(this.parseInline(ce.tokens,ue));break}case"text":{V+=ue.text(ce.text);break}default:{var Ee='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(Ee);return}else throw new Error(Ee)}}return V},Ce}(),Ke=O.merge,K=O.checkSanitizeDeprecation,te=O.escape,we=y.getDefaults,Ue=y.changeDefaults,je=y.defaults;function ze(Ce,De,Pe){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof De=="function"&&(Pe=De,De=null),De=Ke({},ze.defaults,De||{}),K(De),Pe){var oe=De.highlight,ue;try{ue=Z.lex(Ce,De)}catch(Ae){return Pe(Ae)}var V=function(Ee){var Me;if(!Ee)try{Me=be.parse(ue,De)}catch(Ve){Ee=Ve}return De.highlight=oe,Ee?Pe(Ee):Pe(null,Me)};if(!oe||oe.length<3||(delete De.highlight,!ue.length))return V();var J=0;ze.walkTokens(ue,function(Ae){Ae.type==="code"&&(J++,setTimeout(function(){oe(Ae.text,Ae.lang,function(Ee,Me){if(Ee)return V(Ee);Me!=null&&Me!==Ae.text&&(Ae.text=Me,Ae.escaped=!0),J--,J===0&&V()})},0))}),J===0&&V();return}try{var ce=Z.lex(Ce,De);return De.walkTokens&&ze.walkTokens(ce,De.walkTokens),be.parse(ce,De)}catch(Ae){if(Ae.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+te(Ae.message+"",!0)+"</pre>";throw Ae}}ze.options=ze.setOptions=function(Ce){return Ke(ze.defaults,Ce),Ue(ze.defaults),ze},ze.getDefaults=we,ze.defaults=je,ze.use=function(Ce){var De=Ke({},Ce);if(Ce.renderer&&function(){var oe=ze.defaults.renderer||new xe,ue=function(ce){var Ae=oe[ce];oe[ce]=function(){for(var Ee=arguments.length,Me=new Array(Ee),Ve=0;Ve<Ee;Ve++)Me[Ve]=arguments[Ve];var Xe=Ce.renderer[ce].apply(oe,Me);return Xe===!1&&(Xe=Ae.apply(oe,Me)),Xe}};for(var V in Ce.renderer)ue(V);De.renderer=oe}(),Ce.tokenizer&&function(){var oe=ze.defaults.tokenizer||new x,ue=function(ce){var Ae=oe[ce];oe[ce]=function(){for(var Ee=arguments.length,Me=new Array(Ee),Ve=0;Ve<Ee;Ve++)Me[Ve]=arguments[Ve];var Xe=Ce.tokenizer[ce].apply(oe,Me);return Xe===!1&&(Xe=Ae.apply(oe,Me)),Xe}};for(var V in Ce.tokenizer)ue(V);De.tokenizer=oe}(),Ce.walkTokens){var Pe=ze.defaults.walkTokens;De.walkTokens=function(oe){Ce.walkTokens(oe),Pe&&Pe(oe)}}ze.setOptions(De)},ze.walkTokens=function(Ce,De){for(var Pe=I(Ce),oe;!(oe=Pe()).done;){var ue=oe.value;switch(De(ue),ue.type){case"table":{for(var V=I(ue.tokens.header),J;!(J=V()).done;){var ce=J.value;ze.walkTokens(ce,De)}for(var Ae=I(ue.tokens.cells),Ee;!(Ee=Ae()).done;)for(var Me=Ee.value,Ve=I(Me),Xe;!(Xe=Ve()).done;){var rt=Xe.value;ze.walkTokens(rt,De)}break}case"list":{ze.walkTokens(ue.items,De);break}default:ue.tokens&&ze.walkTokens(ue.tokens,De)}}},ze.parseInline=function(Ce,De){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");De=Ke({},ze.defaults,De||{}),K(De);try{var Pe=Z.lexInline(Ce,De);return De.walkTokens&&ze.walkTokens(Pe,De.walkTokens),be.parseInline(Pe,De)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+te(oe.message+"",!0)+"</pre>";throw oe}},ze.Parser=be,ze.parser=be.parse,ze.Renderer=xe,ze.TextRenderer=pe,ze.Lexer=Z,ze.lexer=Z.lex,ze.Tokenizer=x,ze.Slugger=ke,ze.parse=ze;var Ze=ze;return Ze}),define(me[74],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function b(y,C,D){return Math.min(Math.max(y,C),D)}e.clamp=b;function L(y,C){return(C+y%C)%C}e.rot=L;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class T{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function G(I){const T=[];typeof I=="number"&&T.push("code/timeOrigin",I);function y(D){T.push(D,Date.now())}function C(){const D=[];for(let k=0;k<T.length;k+=2)D.push({name:T[k],startTime:T[k+1]});return D}return{mark:y,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const y of performance.getEntriesByType("mark"))T.push({name:y.name,startTime:Math.round(I+y.startTime)});return T}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function b(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=b(L))})(),define(me[10],ge([0,1]),function(G,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const L="en";let I=!1,T=!1,y=!1,C=!1,D=!1,k=!1,i=!1,P,h=L,p,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const E=typeof((b=d==null?void 0:d.versions)===null||b===void 0?void 0:b.electron)=="string"&&d.type==="renderer";if(e.isElectronSandboxed=E&&(d==null?void 0:d.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=d==null?void 0:d.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)o=navigator.userAgent,I=o.indexOf("Windows")>=0,T=o.indexOf("Macintosh")>=0,i=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=o.indexOf("Linux")>=0,k=!0,P=navigator.language,h=P;else if(typeof d=="object"){I=d.platform==="win32",T=d.platform==="darwin",y=d.platform==="linux",C=y&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,P=L,h=L;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const a=JSON.parse(r),g=a.availableLanguages["*"];P=a.locale,h=g||L,p=a._translationsConfigFile}catch(a){}D=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function S(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let u=0;T?u=1:I?u=3:y&&(u=2),e.isWindows=I,e.isMacintosh=T,e.isLinux=y,e.isLinuxSnap=C,e.isNative=D,e.isWeb=k,e.isIOS=i,e.platform=u,e.userAgent=o,e.language=h;var c;(function(r){function a(){return e.language}r.value=a;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=g;function m(){return e.language==="en"}r.isDefault=m})(c=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let g=[];e.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeSetImmediateId)for(let l=0,v=g.length;l<v;l++){const R=g[l];if(R.id===_.data.vscodeSetImmediateId){g.splice(l,1),R.callback();return}}});let m=0;return _=>{const l=++m;g.push({id:l,callback:_}),e.globals.postMessage({vscodeSetImmediateId:l},"*")}}if(typeof(d==null?void 0:d.nextTick)=="function")return d.nextTick.bind(d);const a=Promise.resolve();return g=>a.then(g)}();var f;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||i?2:I?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(me[36],ge([0,1,10]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof b.globals.vscode!="undefined"&&typeof b.globals.vscode.process!="undefined"){const I=b.globals.vscode.process;L={get platform(){return I.platform},get env(){return I.env},cwd(){return I.cwd()},nextTick(T){return(0,b.setImmediate)(T)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(I){return process.nextTick(I)}}:L={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},nextTick(I){return(0,b.setImmediate)(I)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(me[9],ge([0,1,36]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,I=97,T=90,y=122,C=46,D=47,k=92,i=58,P=63;class h extends Error{constructor(c,f,t){let n;typeof f=="string"&&f.indexOf("not ")===0?(n="must not be",f=f.replace(/^not /,"")):n="must be";const s=c.indexOf(".")!==-1?"property":"argument";let r=`The "${c}" ${s} ${n} of type ${f}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function p(u,c){if(typeof u!="string")throw new h(c,"string",u)}function o(u){return u===D||u===k}function d(u){return u===D}function E(u){return u>=L&&u<=T||u>=I&&u<=y}function w(u,c,f,t){let n="",s=0,r=-1,a=0,g=0;for(let m=0;m<=u.length;++m){if(m<u.length)g=u.charCodeAt(m);else{if(t(g))break;g=D}if(t(g)){if(!(r===m-1||a===1))if(a===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==C||n.charCodeAt(n.length-2)!==C){if(n.length>2){const _=n.lastIndexOf(f);_===-1?(n="",s=0):(n=n.slice(0,_),s=n.length-1-n.lastIndexOf(f)),r=m,a=0;continue}else if(n.length!==0){n="",s=0,r=m,a=0;continue}}c&&(n+=n.length>0?`${f}..`:"..",s=2)}else n.length>0?n+=`${f}${u.slice(r+1,m)}`:n=u.slice(r+1,m),s=m-r-1;r=m,a=0}else g===C&&a!==-1?++a:a=-1}return n}function S(u,c){if(c===null||typeof c!="object")throw new h("pathObject","Object",c);const f=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return f?f===c.root?`${f}${t}`:`${f}${u}${t}`:t}e.win32={resolve(...u){let c="",f="",t=!1;for(let n=u.length-1;n>=-1;n--){let s;if(n>=0){if(s=u[n],p(s,"path"),s.length===0)continue}else c.length===0?s=b.cwd():(s=b.env[`=${c}`]||b.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==c.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${c}\\`));const r=s.length;let a=0,g="",m=!1;const _=s.charCodeAt(0);if(r===1)o(_)&&(a=1,m=!0);else if(o(_))if(m=!0,o(s.charCodeAt(1))){let l=2,v=l;for(;l<r&&!o(s.charCodeAt(l));)l++;if(l<r&&l!==v){const R=s.slice(v,l);for(v=l;l<r&&o(s.charCodeAt(l));)l++;if(l<r&&l!==v){for(v=l;l<r&&!o(s.charCodeAt(l));)l++;(l===r||l!==v)&&(g=`\\\\${R}\\${s.slice(v,l)}`,a=l)}}}else a=1;else E(_)&&s.charCodeAt(1)===i&&(g=s.slice(0,2),a=2,r>2&&o(s.charCodeAt(2))&&(m=!0,a=3));if(g.length>0)if(c.length>0){if(g.toLowerCase()!==c.toLowerCase())continue}else c=g;if(t){if(c.length>0)break}else if(f=`${s.slice(a)}\\${f}`,t=m,m&&c.length>0)break}return f=w(f,!t,"\\",o),t?`${c}\\${f}`:`${c}${f}`||"."},normalize(u){p(u,"path");const c=u.length;if(c===0)return".";let f=0,t,n=!1;const s=u.charCodeAt(0);if(c===1)return d(s)?"\\":u;if(o(s))if(n=!0,o(u.charCodeAt(1))){let a=2,g=a;for(;a<c&&!o(u.charCodeAt(a));)a++;if(a<c&&a!==g){const m=u.slice(g,a);for(g=a;a<c&&o(u.charCodeAt(a));)a++;if(a<c&&a!==g){for(g=a;a<c&&!o(u.charCodeAt(a));)a++;if(a===c)return`\\\\${m}\\${u.slice(g)}\\`;a!==g&&(t=`\\\\${m}\\${u.slice(g,a)}`,f=a)}}}else f=1;else E(s)&&u.charCodeAt(1)===i&&(t=u.slice(0,2),f=2,c>2&&o(u.charCodeAt(2))&&(n=!0,f=3));let r=f<c?w(u.slice(f),!n,"\\",o):"";return r.length===0&&!n&&(r="."),r.length>0&&o(u.charCodeAt(c-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(u){p(u,"path");const c=u.length;if(c===0)return!1;const f=u.charCodeAt(0);return o(f)||c>2&&E(f)&&u.charCodeAt(1)===i&&o(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let c,f;for(let s=0;s<u.length;++s){const r=u[s];p(r,"path"),r.length>0&&(c===void 0?c=f=r:c+=`\\${r}`)}if(c===void 0)return".";let t=!0,n=0;if(typeof f=="string"&&o(f.charCodeAt(0))){++n;const s=f.length;s>1&&o(f.charCodeAt(1))&&(++n,s>2&&(o(f.charCodeAt(2))?++n:t=!1))}if(t){for(;n<c.length&&o(c.charCodeAt(n));)n++;n>=2&&(c=`\\${c.slice(n)}`)}return e.win32.normalize(c)},relative(u,c){if(p(u,"from"),p(c,"to"),u===c)return"";const f=e.win32.resolve(u),t=e.win32.resolve(c);if(f===t||(u=f.toLowerCase(),c=t.toLowerCase(),u===c))return"";let n=0;for(;n<u.length&&u.charCodeAt(n)===k;)n++;let s=u.length;for(;s-1>n&&u.charCodeAt(s-1)===k;)s--;const r=s-n;let a=0;for(;a<c.length&&c.charCodeAt(a)===k;)a++;let g=c.length;for(;g-1>a&&c.charCodeAt(g-1)===k;)g--;const m=g-a,_=r<m?r:m;let l=-1,v=0;for(;v<_;v++){const O=u.charCodeAt(n+v);if(O!==c.charCodeAt(a+v))break;O===k&&(l=v)}if(v!==_){if(l===-1)return t}else{if(m>_){if(c.charCodeAt(a+v)===k)return t.slice(a+v+1);if(v===2)return t.slice(a+v)}r>_&&(u.charCodeAt(n+v)===k?l=v:v===2&&(l=3)),l===-1&&(l=0)}let R="";for(v=n+l+1;v<=s;++v)(v===s||u.charCodeAt(v)===k)&&(R+=R.length===0?"..":"\\..");return a+=l,R.length>0?`${R}${t.slice(a,g)}`:(t.charCodeAt(a)===k&&++a,t.slice(a,g))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const c=e.win32.resolve(u);if(c.length<=2)return u;if(c.charCodeAt(0)===k){if(c.charCodeAt(1)===k){const f=c.charCodeAt(2);if(f!==P&&f!==C)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(E(c.charCodeAt(0))&&c.charCodeAt(1)===i&&c.charCodeAt(2)===k)return`\\\\?\\${c}`;return u},dirname(u){p(u,"path");const c=u.length;if(c===0)return".";let f=-1,t=0;const n=u.charCodeAt(0);if(c===1)return o(n)?u:".";if(o(n)){if(f=t=1,o(u.charCodeAt(1))){let a=2,g=a;for(;a<c&&!o(u.charCodeAt(a));)a++;if(a<c&&a!==g){for(g=a;a<c&&o(u.charCodeAt(a));)a++;if(a<c&&a!==g){for(g=a;a<c&&!o(u.charCodeAt(a));)a++;if(a===c)return u;a!==g&&(f=t=a+1)}}}}else E(n)&&u.charCodeAt(1)===i&&(f=c>2&&o(u.charCodeAt(2))?3:2,t=f);let s=-1,r=!0;for(let a=c-1;a>=t;--a)if(o(u.charCodeAt(a))){if(!r){s=a;break}}else r=!1;if(s===-1){if(f===-1)return".";s=f}return u.slice(0,s)},basename(u,c){c!==void 0&&p(c,"ext"),p(u,"path");let f=0,t=-1,n=!0,s;if(u.length>=2&&E(u.charCodeAt(0))&&u.charCodeAt(1)===i&&(f=2),c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let r=c.length-1,a=-1;for(s=u.length-1;s>=f;--s){const g=u.charCodeAt(s);if(o(g)){if(!n){f=s+1;break}}else a===-1&&(n=!1,a=s+1),r>=0&&(g===c.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=a))}return f===t?t=a:t===-1&&(t=u.length),u.slice(f,t)}for(s=u.length-1;s>=f;--s)if(o(u.charCodeAt(s))){if(!n){f=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":u.slice(f,t)},extname(u){p(u,"path");let c=0,f=-1,t=0,n=-1,s=!0,r=0;u.length>=2&&u.charCodeAt(1)===i&&E(u.charCodeAt(0))&&(c=t=2);for(let a=u.length-1;a>=c;--a){const g=u.charCodeAt(a);if(o(g)){if(!s){t=a+1;break}continue}n===-1&&(s=!1,n=a+1),g===C?f===-1?f=a:r!==1&&(r=1):f!==-1&&(r=-1)}return f===-1||n===-1||r===0||r===1&&f===n-1&&f===t+1?"":u.slice(f,n)},format:S.bind(null,"\\"),parse(u){p(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const f=u.length;let t=0,n=u.charCodeAt(0);if(f===1)return o(n)?(c.root=c.dir=u,c):(c.base=c.name=u,c);if(o(n)){if(t=1,o(u.charCodeAt(1))){let l=2,v=l;for(;l<f&&!o(u.charCodeAt(l));)l++;if(l<f&&l!==v){for(v=l;l<f&&o(u.charCodeAt(l));)l++;if(l<f&&l!==v){for(v=l;l<f&&!o(u.charCodeAt(l));)l++;l===f?t=l:l!==v&&(t=l+1)}}}}else if(E(n)&&u.charCodeAt(1)===i){if(f<=2)return c.root=c.dir=u,c;if(t=2,o(u.charCodeAt(2))){if(f===3)return c.root=c.dir=u,c;t=3}}t>0&&(c.root=u.slice(0,t));let s=-1,r=t,a=-1,g=!0,m=u.length-1,_=0;for(;m>=t;--m){if(n=u.charCodeAt(m),o(n)){if(!g){r=m+1;break}continue}a===-1&&(g=!1,a=m+1),n===C?s===-1?s=m:_!==1&&(_=1):s!==-1&&(_=-1)}return a!==-1&&(s===-1||_===0||_===1&&s===a-1&&s===r+1?c.base=c.name=u.slice(r,a):(c.name=u.slice(r,s),c.base=u.slice(r,a),c.ext=u.slice(s,a))),r>0&&r!==t?c.dir=u.slice(0,r-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let c="",f=!1;for(let t=u.length-1;t>=-1&&!f;t--){const n=t>=0?u[t]:b.cwd();p(n,"path"),n.length!==0&&(c=`${n}/${c}`,f=n.charCodeAt(0)===D)}return c=w(c,!f,"/",d),f?`/${c}`:c.length>0?c:"."},normalize(u){if(p(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===D,f=u.charCodeAt(u.length-1)===D;return u=w(u,!c,"/",d),u.length===0?c?"/":f?"./":".":(f&&(u+="/"),c?`/${u}`:u)},isAbsolute(u){return p(u,"path"),u.length>0&&u.charCodeAt(0)===D},join(...u){if(u.length===0)return".";let c;for(let f=0;f<u.length;++f){const t=u[f];p(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(u,c){if(p(u,"from"),p(c,"to"),u===c||(u=e.posix.resolve(u),c=e.posix.resolve(c),u===c))return"";const f=1,t=u.length,n=t-f,s=1,r=c.length-s,a=n<r?n:r;let g=-1,m=0;for(;m<a;m++){const l=u.charCodeAt(f+m);if(l!==c.charCodeAt(s+m))break;l===D&&(g=m)}if(m===a)if(r>a){if(c.charCodeAt(s+m)===D)return c.slice(s+m+1);if(m===0)return c.slice(s+m)}else n>a&&(u.charCodeAt(f+m)===D?g=m:m===0&&(g=0));let _="";for(m=f+g+1;m<=t;++m)(m===t||u.charCodeAt(m)===D)&&(_+=_.length===0?"..":"/..");return`${_}${c.slice(s+g)}`},toNamespacedPath(u){return u},dirname(u){if(p(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===D;let f=-1,t=!0;for(let n=u.length-1;n>=1;--n)if(u.charCodeAt(n)===D){if(!t){f=n;break}}else t=!1;return f===-1?c?"/":".":c&&f===1?"//":u.slice(0,f)},basename(u,c){c!==void 0&&p(c,"ext"),p(u,"path");let f=0,t=-1,n=!0,s;if(c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let r=c.length-1,a=-1;for(s=u.length-1;s>=0;--s){const g=u.charCodeAt(s);if(g===D){if(!n){f=s+1;break}}else a===-1&&(n=!1,a=s+1),r>=0&&(g===c.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=a))}return f===t?t=a:t===-1&&(t=u.length),u.slice(f,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===D){if(!n){f=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":u.slice(f,t)},extname(u){p(u,"path");let c=-1,f=0,t=-1,n=!0,s=0;for(let r=u.length-1;r>=0;--r){const a=u.charCodeAt(r);if(a===D){if(!n){f=r+1;break}continue}t===-1&&(n=!1,t=r+1),a===C?c===-1?c=r:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||t===-1||s===0||s===1&&c===t-1&&c===f+1?"":u.slice(c,t)},format:S.bind(null,"/"),parse(u){p(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const f=u.charCodeAt(0)===D;let t;f?(c.root="/",t=1):t=0;let n=-1,s=0,r=-1,a=!0,g=u.length-1,m=0;for(;g>=t;--g){const _=u.charCodeAt(g);if(_===D){if(!a){s=g+1;break}continue}r===-1&&(a=!1,r=g+1),_===C?n===-1?n=g:m!==1&&(m=1):n!==-1&&(m=-1)}if(r!==-1){const _=s===0&&f?1:s;n===-1||m===0||m===1&&n===r-1&&n===s+1?c.base=c.name=u.slice(_,r):(c.name=u.slice(_,n),c.base=u.slice(_,r),c.ext=u.slice(n,r))}return s>0?c.dir=u.slice(0,s-1):f&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[135],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var b;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(b=e.Source||(e.Source={}));var L;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(T,...y){const C=y.reduce((i,P)=>(i[P]=!0,i),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(i=>!C[i]).forEach(i=>{for(let P=0;P<D.length;P++)if(i.search(D[P])!==-1){delete T[i];break}})}e.sanitizeProcessEnvironment=I}),define(me[45],ge([0,1,10]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=b.globals.performance&&typeof b.globals.performance.now=="function";class I{constructor(y){this._highResolution=L&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new I(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=I}),define(me[3],ge([0,1,17,72,6,57,45]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(w){w.None=()=>I.Disposable.None;function S(N){return(B,U=null,A)=>{let x=!1,F;return F=N(M=>{if(!x)return F?F.dispose():x=!0,B.call(U,M)},null,A),x&&F.dispose(),F}}w.once=S;function u(N,B){return r((U,A=null,x)=>N(F=>U.call(A,B(F)),null,x))}w.map=u;function c(N,B){return r((U,A=null,x)=>N(F=>{B(F),U.call(A,F)},null,x))}w.forEach=c;function f(N,B){return r((U,A=null,x)=>N(F=>B(F)&&U.call(A,F),null,x))}w.filter=f;function t(N){return N}w.signal=t;function n(...N){return(B,U=null,A)=>(0,I.combinedDisposable)(...N.map(x=>x(F=>B.call(U,F),null,A)))}w.any=n;function s(N,B,U){let A=U;return u(N,x=>(A=B(A,x),A))}w.reduce=s;function r(N){let B;const U=new h({onFirstListenerAdd(){B=N(U.fire,U)},onLastListenerRemove(){B.dispose()}});return U.event}w.snapshot=r;function a(N,B,U=100,A=!1,x){let F,M,W,z=0;const Y=new h({leakWarningThreshold:x,onFirstListenerAdd(){F=N(le=>{z++,M=B(M,le),A&&!W&&(Y.fire(M),M=void 0),clearTimeout(W),W=setTimeout(()=>{const ve=M;M=void 0,W=void 0,(!A||z>1)&&Y.fire(ve),z=0},U)})},onLastListenerRemove(){F.dispose()}});return Y.event}w.debounce=a;function g(N){const B=new Date().getTime();return u(S(N),U=>new Date().getTime()-B)}w.stopwatch=g;function m(N,B=(U,A)=>U===A){let U=!0,A;return f(N,x=>{const F=U||!B(x,A);return U=!1,A=x,F})}w.latch=m;function _(N,B){return[w.filter(N,B),w.filter(N,U=>!B(U))]}w.split=_;function l(N,B=!1,U=[]){let A=U.slice(),x=N(W=>{A?A.push(W):M.fire(W)});const F=()=>{A&&A.forEach(W=>M.fire(W)),A=null},M=new h({onFirstListenerAdd(){x||(x=N(W=>M.fire(W)))},onFirstListenerDidAdd(){A&&(B?setTimeout(F):F())},onLastListenerRemove(){x&&x.dispose(),x=null}});return M.event}w.buffer=l;class v{constructor(B){this.event=B}map(B){return new v(u(this.event,B))}forEach(B){return new v(c(this.event,B))}filter(B){return new v(f(this.event,B))}reduce(B,U){return new v(s(this.event,B,U))}latch(){return new v(m(this.event))}debounce(B,U=100,A=!1,x){return new v(a(this.event,B,U,A,x))}on(B,U,A){return this.event(B,U,A)}once(B,U,A){return S(this.event)(B,U,A)}}function R(N){return new v(N)}w.chain=R;function O(N,B,U=A=>A){const A=(...W)=>M.fire(U(...W)),x=()=>N.on(B,A),F=()=>N.removeListener(B,A),M=new h({onFirstListenerAdd:x,onLastListenerRemove:F});return M.event}w.fromNodeEventEmitter=O;function H(N,B,U=A=>A){const A=(...W)=>M.fire(U(...W)),x=()=>N.addEventListener(B,A),F=()=>N.removeEventListener(B,A),M=new h({onFirstListenerAdd:x,onLastListenerRemove:F});return M.event}w.fromDOMEventEmitter=H;function ne(N){const B=new h;let U=!1;return N.then(void 0,()=>null).then(()=>{U?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),U=!0,B.event}w.fromPromise=ne;function ie(N){return new Promise(B=>S(N)(B))}w.toPromise=ie})(C=e.Event||(e.Event={}));class D{constructor(S){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${S}_${D._idPool++}`}start(S){this._stopWatch=new y.StopWatch(!0),this._listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this._elapsedOverall+=S,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${S.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let k=-1;function i(w){const S=k;return k=w,{dispose(){k=S}}}e.setGlobalLeakWarningThreshold=i;class P{constructor(S,u=Math.random().toString(18).slice(2,5)){this.customThreshold=S,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(S){let u=k;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),!(u<=0||S<u)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),f=this._stacks.get(c)||0;if(this._stacks.set(c,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,n=0;for(const[s,r]of this._stacks)(!t||n<r)&&(t=s,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class h{constructor(S){var u;this._disposed=!1,this._options=S,this._leakageMon=k>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(S,u,c)=>{var f;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(u?[S,u]:S);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,S,u);const s=(f=this._leakageMon)===null||f===void 0?void 0:f.check(this._listeners.size);let r;return r={dispose:()=>{s&&s(),r.dispose=h._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof I.DisposableStore?c.add(r):Array.isArray(c)&&c.push(r),r}),this._event}fire(S){var u,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,S]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,t]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,t):f[0].call(f[1],t)}catch(n){(0,b.onUnexpectedError)(n)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var S,u,c,f;(S=this._listeners)===null||S===void 0||S.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),((c=this._options)===null||c===void 0?void 0:c.onLastListenerRemove)&&this._options.onLastListenerRemove(),(f=this._leakageMon)===null||f===void 0||f.dispose(),this._disposed=!0}}e.Emitter=h,h._noop=function(){};class p extends h{constructor(S){super(S);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=S==null?void 0:S.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._listeners&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=p;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const u={event:S,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const c=()=>{this.hasListeners&&this.unhook(u);const f=this.events.indexOf(u);this.events.splice(f,1)};return(0,I.toDisposable)((0,L.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(u=>this.emitter.fire(u))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class d{constructor(){this.buffers=[]}wrapEvent(S){return(u,c,f)=>S(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>u.call(c,t)):u.call(c,t)},void 0,f)}bufferEvents(S){const u=[];this.buffers.push(u);const c=S();return this.buffers.pop(),u.forEach(f=>f()),c}}e.EventBufferer=d;class E{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=I.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,D){const k=setTimeout(C.bind(D),0);return{dispose(){clearTimeout(k)}}});var I;(function(C){function D(k){return k===C.None||k===C.Cancelled||k instanceof T?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}C.isCancellationToken=D,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(I=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=I.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=y}),define(me[46],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new b.Emitter}add(P){const h=this._icons.get(P.id);h?P.description?h.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const I=new L;e.iconRegistry=I;function T(i,P){return new C(i,P)}e.registerCodicon=T;function y(i){return i?i.replace(/\$\((.*?)\)/g,(P,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=y;class C{constructor(P,h,p){this.id=P,this.definition=h,this.description=p,I.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function D(i,P){const h=["codicon","codicon-"+i];return P&&h.push("codicon-modifier-"+P),h}e.getClassNamesArray=D;var k;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function h(d){if(d instanceof C)return["codicon","codicon-"+d.id];const E=P.exec(d.id);if(!E)return h(C.error);let[,w,S]=E;const u=["codicon","codicon-"+w];return S&&u.push("codicon-modifier-"+S.substr(1)),u}i.asClassNameArray=h;function p(d){return h(d).join(" ")}i.asClassName=p;function o(d){return"."+h(d).join(".")}i.asCSSSelector=o})(k=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(me[94],ge([0,1,17,6]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=I;function T(u){const c=u;return c?I(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=T;function y(u,c){return new C(u,c)}e.newWriteableStream=y;class C{constructor(c,f){this.reducer=c,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){var f;if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof((f=this.options)===null||f===void 0?void 0:f.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(f=>f(c))}emitError(c){this.listeners.error.length===0?(0,b.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(f=>f(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,f){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(c,f){if(!this.state.destroyed){let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(f);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(u,c){const f=[];let t;for(;(t=u.read())!==null;)f.push(t);return c(f)}e.consumeReadable=D;function k(u,c,f){const t=[];let n;for(;(n=u.read())!==null&&t.length<f;)t.push(n);return n===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const s=n;return n=void 0,s}return u.read()}}}e.peekReadable=k;function i(u,c){return new Promise((f,t)=>{const n=[];P(u,{onData:s=>{c&&n.push(s)},onError:s=>{c?t(s):f(void 0)},onEnd:()=>{f(c?c(n):void 0)}})})}e.consumeStream=i;function P(u,c){u.on("error",f=>c.onError(f)),u.on("end",()=>c.onEnd()),u.on("data",f=>c.onData(f))}e.listenStream=P;function h(u,c){return new Promise((f,t)=>{const n=new L.DisposableStore,s=[],r=m=>{if(s.push(m),s.length>c)return n.dispose(),u.pause(),f({stream:u,buffer:s,ended:!1})},a=m=>t(m),g=()=>f({stream:u,buffer:s,ended:!0});n.add((0,L.toDisposable)(()=>u.removeListener("error",a))),u.on("error",a),n.add((0,L.toDisposable)(()=>u.removeListener("end",g))),u.on("end",g),n.add((0,L.toDisposable)(()=>u.removeListener("data",r))),u.on("data",r)})}e.peekStream=h;function p(u,c){const f=y(c);return f.end(u),f}e.toStream=p;function o(){const u=y(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=o;function d(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=d;function E(u,c,f){const t=y(f);return P(u,{onData:n=>t.write(c.data(n)),onError:n=>t.error(c.error?c.error(n):n),onEnd:()=>t.end()}),t}e.transform=E;function w(u,c,f){let t=!1;return{read:()=>{const n=c.read();return t?n:(t=!0,n!==null?f([u,n]):u)}}}e.prefixedReadable=w;function S(u,c,f){let t=!1;const n=y(f);return P(c,{onData:s=>t?n.write(s):(t=!0,n.write(f([u,s]))),onError:s=>n.error(s),onEnd:()=>{t||(t=!0,n.write(u)),n.end()}}),n}e.prefixedStream=S}),define(me[8],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function b(V){return!V||typeof V!="string"?!0:V.trim().length===0}e.isFalsyOrWhitespace=b;const L=/{(\d+)}/g;function I(V,...J){return J.length===0?V:V.replace(L,function(ce,Ae){const Ee=parseInt(Ae,10);return isNaN(Ee)||Ee<0||Ee>=J.length?ce:J[Ee]})}e.format=I;function T(V){return V.replace(/[<>&]/g,function(J){switch(J){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return J}})}e.escape=T;function y(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function C(V,J){let ce=0;const Ae=J.charCodeAt(0);for(let Ee=V.length-1;Ee>=0;Ee--)V.charCodeAt(Ee)===Ae&&ce++;return ce}e.count=C;function D(V,J,ce="\u2026"){return V.length<=J?V:`${V.substr(0,J)}${ce}`}e.truncate=D;function k(V,J=" "){const ce=i(V,J);return P(ce,J)}e.trim=k;function i(V,J){if(!V||!J)return V;const ce=J.length;if(ce===0||V.length===0)return V;let Ae=0;for(;V.indexOf(J,Ae)===Ae;)Ae=Ae+ce;return V.substring(Ae)}e.ltrim=i;function P(V,J){if(!V||!J)return V;const ce=J.length,Ae=V.length;if(ce===0||Ae===0)return V;let Ee=Ae,Me=-1;for(;Me=V.lastIndexOf(J,Ee-1),!(Me===-1||Me+ce!==Ee);){if(Me===0)return"";Ee=Me}return V.substring(0,Ee)}e.rtrim=P;function h(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function p(V){return V.replace(/\*/g,"")}e.stripWildcards=p;function o(V,J,ce={}){if(!V)throw new Error("Cannot create regex from empty string");J||(V=y(V)),ce.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let Ae="";return ce.global&&(Ae+="g"),ce.matchCase||(Ae+="i"),ce.multiline&&(Ae+="m"),ce.unicode&&(Ae+="u"),new RegExp(V,Ae)}e.createRegExp=o;function d(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function E(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function w(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}e.regExpFlags=w;function S(V){return V.split(/\r\n|\r|\n/)}e.splitLines=S;function u(V){for(let J=0,ce=V.length;J<ce;J++){const Ae=V.charCodeAt(J);if(Ae!==32&&Ae!==9)return J}return-1}e.firstNonWhitespaceIndex=u;function c(V,J=0,ce=V.length){for(let Ae=J;Ae<ce;Ae++){const Ee=V.charCodeAt(Ae);if(Ee!==32&&Ee!==9)return V.substring(J,Ae)}return V.substring(J,ce)}e.getLeadingWhitespace=c;function f(V,J=V.length-1){for(let ce=J;ce>=0;ce--){const Ae=V.charCodeAt(ce);if(Ae!==32&&Ae!==9)return ce}return-1}e.lastNonWhitespaceIndex=f;function t(V,J){return V<J?-1:V>J?1:0}e.compare=t;function n(V,J,ce=0,Ae=V.length,Ee=0,Me=J.length){for(;ce<Ae&&Ee<Me;ce++,Ee++){let rt=V.charCodeAt(ce),Qe=J.charCodeAt(Ee);if(rt<Qe)return-1;if(rt>Qe)return 1}const Ve=Ae-ce,Xe=Me-Ee;return Ve<Xe?-1:Ve>Xe?1:0}e.compareSubstring=n;function s(V,J){return r(V,J,0,V.length,0,J.length)}e.compareIgnoreCase=s;function r(V,J,ce=0,Ae=V.length,Ee=0,Me=J.length){for(;ce<Ae&&Ee<Me;ce++,Ee++){let rt=V.charCodeAt(ce),Qe=J.charCodeAt(Ee);if(rt!==Qe){const et=rt-Qe;if(!(et===32&&g(Qe))&&!(et===-32&&g(rt)))return a(rt)&&a(Qe)?et:n(V.toLowerCase(),J.toLowerCase(),ce,Ae,Ee,Me)}}const Ve=Ae-ce,Xe=Me-Ee;return Ve<Xe?-1:Ve>Xe?1:0}e.compareSubstringIgnoreCase=r;function a(V){return V>=97&&V<=122}e.isLowerAsciiLetter=a;function g(V){return V>=65&&V<=90}e.isUpperAsciiLetter=g;function m(V){return a(V)||g(V)}function _(V,J){return V.length===J.length&&l(V,J)}e.equalsIgnoreCase=_;function l(V,J,ce=V.length){for(let Ae=0;Ae<ce;Ae++){const Ee=V.charCodeAt(Ae),Me=J.charCodeAt(Ae);if(Ee!==Me){if(m(Ee)&&m(Me)){const Ve=Math.abs(Ee-Me);if(Ve!==0&&Ve!==32)return!1}else if(String.fromCharCode(Ee).toLowerCase()!==String.fromCharCode(Me).toLowerCase())return!1}}return!0}function v(V,J){const ce=J.length;return J.length>V.length?!1:l(V,J,ce)}e.startsWithIgnoreCase=v;function R(V,J){let ce,Ae=Math.min(V.length,J.length);for(ce=0;ce<Ae;ce++)if(V.charCodeAt(ce)!==J.charCodeAt(ce))return ce;return Ae}e.commonPrefixLength=R;function O(V,J){let ce,Ae=Math.min(V.length,J.length);const Ee=V.length-1,Me=J.length-1;for(ce=0;ce<Ae;ce++)if(V.charCodeAt(Ee-ce)!==J.charCodeAt(Me-ce))return ce;return Ae}e.commonSuffixLength=O;function H(V){return 55296<=V&&V<=56319}e.isHighSurrogate=H;function ne(V){return 56320<=V&&V<=57343}e.isLowSurrogate=ne;function ie(V,J){return(V-55296<<10)+(J-56320)+65536}e.computeCodePoint=ie;function N(V,J,ce){const Ae=V.charCodeAt(ce);if(H(Ae)&&ce+1<J){const Ee=V.charCodeAt(ce+1);if(ne(Ee))return ie(Ae,Ee)}return Ae}e.getNextCodePoint=N;function B(V,J){const ce=V.charCodeAt(J-1);if(ne(ce)&&J>1){const Ae=V.charCodeAt(J-2);if(H(Ae))return ie(Ae,ce)}return ce}function U(V,J){const ce=ze.getInstance(),Ae=J,Ee=V.length,Me=N(V,Ee,J);J+=Me>=65536?2:1;let Ve=ce.getGraphemeBreakType(Me);for(;J<Ee;){const Xe=N(V,Ee,J),rt=ce.getGraphemeBreakType(Xe);if(Ue(Ve,rt))break;J+=Xe>=65536?2:1,Ve=rt}return J-Ae}e.nextCharLength=U;function A(V,J){const ce=ze.getInstance(),Ae=J,Ee=B(V,J);J-=Ee>=65536?2:1;let Me=ce.getGraphemeBreakType(Ee);for(;J>0;){const Ve=B(V,J),Xe=ce.getGraphemeBreakType(Ve);if(Ue(Xe,Me))break;J-=Ve>=65536?2:1,Me=Xe}return Ae-J}e.prevCharLength=A;function x(V,J){const ce=ze.getInstance(),Ae=V.length,Ee=J,Me=N(V,Ae,J),Ve=ce.getGraphemeBreakType(Me);J+=Me>=65536?2:1;let Xe=Ve;for(;J<Ae;){const Qe=N(V,Ae,J),et=ce.getGraphemeBreakType(Qe);if(Ue(Xe,et))break;J+=Qe>=65536?2:1,Xe=et}const rt=J;for(J=Ee,Xe=Ve;J>0;){const Qe=B(V,J),et=ce.getGraphemeBreakType(Qe);if(Ue(et,Xe))break;J-=Qe>=65536?2:1,Xe=et}return[J,rt]}function F(V,J){return J>0&&ne(V.charCodeAt(J))?x(V,J-1):x(V,J)}e.getCharContainingOffset=F;function M(V){const J=V.length;let ce=0,Ae=0;for(;Ae<J;){const Ve=N(V,J,Ae);Ae+=Ve>=65536?2:1,Ve<128?ce+=1:Ve<2048?ce+=2:Ve<65536?ce+=3:ce+=4}const Ee=new Uint8Array(ce);Ae=0;let Me=0;for(;Ae<J;){const Ve=N(V,J,Ae);Ae+=Ve>=65536?2:1,Ve<128?Ee[Me++]=Ve:Ve<2048?(Ee[Me++]=192|(Ve&1984)>>>6,Ee[Me++]=128|(Ve&63)>>>0):Ve<65536?(Ee[Me++]=224|(Ve&61440)>>>12,Ee[Me++]=128|(Ve&4032)>>>6,Ee[Me++]=128|(Ve&63)>>>0):(Ee[Me++]=240|(Ve&1835008)>>>18,Ee[Me++]=128|(Ve&258048)>>>12,Ee[Me++]=128|(Ve&4032)>>>6,Ee[Me++]=128|(Ve&63)>>>0)}return Ee}e.encodeUTF8=M;function W(V){const J=V.byteLength,ce=[];let Ae=0;for(;Ae<J;){const Ee=V[Ae];let Me;if(Ee>=240&&Ae+3<J?Me=(V[Ae++]&7)<<18>>>0|(V[Ae++]&63)<<12>>>0|(V[Ae++]&63)<<6>>>0|(V[Ae++]&63)<<0>>>0:Ee>=224&&Ae+2<J?Me=(V[Ae++]&15)<<12>>>0|(V[Ae++]&63)<<6>>>0|(V[Ae++]&63)<<0>>>0:Ee>=192&&Ae+1<J?Me=(V[Ae++]&31)<<6>>>0|(V[Ae++]&63)<<0>>>0:Me=V[Ae++],Me>=0&&Me<=55295||Me>=57344&&Me<=65535)ce.push(String.fromCharCode(Me));else if(Me>=65536&&Me<=1114111){const Ve=Me-65536,Xe=55296+((Ve&1047552)>>>10),rt=56320+((Ve&1023)>>>0);ce.push(String.fromCharCode(Xe)),ce.push(String.fromCharCode(rt))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=W;const z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(V){return z.test(V)}e.containsRTL=Y;const le=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ve(V){return le.test(V)}e.containsEmoji=ve;const Te=/^[\t\n\r\x20-\x7E]*$/;function ye(V){return Te.test(V)}e.isBasicASCII=ye,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Oe(V){return e.UNUSUAL_LINE_TERMINATORS.test(V)}e.containsUnusualLineTerminators=Oe;function j(V){for(let J=0,ce=V.length;J<ce;J++)if(Q(V.charCodeAt(J)))return!0;return!1}e.containsFullWidthCharacter=j;function Q(V){return V=+V,V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}e.isFullWidthCharacter=Q;function Z(V){return V>=127462&&V<=127487||V===8986||V===8987||V===9200||V===9203||V>=9728&&V<=10175||V===11088||V===11093||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129003||V>=129280&&V<=129535||V>=129648&&V<=129750}e.isEmojiImprecise=Z;function se(V,J){if(V.length<J)return V;const ce=/\b/g;let Ae=0;for(;ce.test(V)&&!(V.length-ce.lastIndex<J);)Ae=ce.lastIndex,ce.lastIndex+=1;return V.substring(Ae).replace(/^\s/,"")}e.lcut=se;const fe=/\x1B\x5B[12]?K/g,_e=/\x1b\[\d+m/g,xe=/\x1b\[0?m/g;function pe(V){return V&&(V=V.replace(fe,""),V=V.replace(_e,""),V=V.replace(xe,"")),V}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Fe(V){return ke(V)?V.substr(1):V}e.stripUTF8BOM=Fe;function He(V,J){if(!V||!J||V.length<J.length)return!1;const ce=J.length,Ae=V.toLowerCase();let Ee=0,Me=-1;for(;Ee<ce;){const Ve=Ae.indexOf(J[Ee],Me+1);if(Ve<0)return!1;Me=Ve,Ee++}return!0}e.fuzzyContains=He;function be(V,J=!1){return V?(J&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}e.containsUppercaseCharacter=be;function Ke(V){return V.charAt(0).toUpperCase()+V.slice(1)}e.uppercaseFirstLetter=Ke;function K(V,J=1){if(J===0)return"";let ce=-1;do ce=V.indexOf(`
`,ce+1),J--;while(J>0&&ce>=0);return ce===-1?V:(V[ce-1]==="\r"&&ce--,V.substr(0,ce))}e.getNLines=K;function te(V){const J=90-65+1;return V=V%(2*J),V<J?String.fromCharCode(97+V):String.fromCharCode(65+V-J)}e.singleLetterHash=te;function we(V){return ze.getInstance().getGraphemeBreakType(V)}e.getGraphemeBreakType=we;function Ue(V,J){return V===0?J!==5&&J!==7:V===2&&J===3?!1:V===4||V===2||V===3||J===4||J===2||J===3?!0:!(V===8&&(J===8||J===9||J===11||J===12)||(V===11||V===9)&&(J===9||J===10)||(V===12||V===10)&&J===10||J===5||J===13||J===7||V===1||V===13&&J===14||V===6&&J===6)}e.breakBetweenGraphemeBreakType=Ue;var je;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Ze()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(J){if(J<32)return J===10?3:J===13?2:4;if(J<127)return 0;const ce=this._data,Ae=ce.length/3;let Ee=1;for(;Ee<=Ae;)if(J<ce[3*Ee])Ee=2*Ee;else if(J>ce[3*Ee+1])Ee=2*Ee+1;else return ce[3*Ee+2];return 0}}ze._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ce(V,J){if(V===0)return 0;const ce=De(V,J);if(ce!==void 0)return ce;const Ae=B(J,V);return V-=Pe(Ae),V}e.getLeftDeleteOffset=Ce;function De(V,J){let ce=B(J,V);for(V-=Pe(ce);oe(ce)||ce===65039||ce===8419;){if(V===0)return;ce=B(J,V),V-=Pe(ce)}if(!!Z(ce)){if(V>=0){const Ae=B(J,V);Ae===8205&&(V-=Pe(Ae))}return V}}function Pe(V){return V>=65536?2:1}function oe(V){return 127995<=V&&V<=127999}var ue;(function(V){V[V.zwj=8205]="zwj",V[V.emojiVariantSelector=65039]="emojiVariantSelector",V[V.enclosingKeyCap=8419]="enclosingKeyCap"})(ue||(ue={}))}),define(me[23],ge([0,1,8,94]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const I=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let C,D;class k{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return I?new k(Buffer.allocUnsafe(m)):new k(new Uint8Array(m))}static wrap(m){return I&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new k(m)}static fromString(m,_){return!((_==null?void 0:_.dontUseNodeBuffer)||!1)&&I?new k(Buffer.from(m)):T?(C||(C=new TextEncoder),new k(C.encode(m))):new k(b.encodeUTF8(m))}static concat(m,_){if(typeof _=="undefined"){_=0;for(let R=0,O=m.length;R<O;R++)_+=m[R].byteLength}const l=k.alloc(_);let v=0;for(let R=0,O=m.length;R<O;R++){const H=m[R];l.set(H,v),v+=H.byteLength}return l}toString(){return I?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):b.decodeUTF8(this.buffer)}slice(m,_){return new k(this.buffer.subarray(m,_))}set(m,_){m instanceof k?this.buffer.set(m.buffer,_):this.buffer.set(m,_)}readUInt32BE(m){return h(this.buffer,m)}writeUInt32BE(m,_){p(this.buffer,m,_)}readUInt32LE(m){return o(this.buffer,m)}writeUInt32LE(m,_){d(this.buffer,m,_)}readUInt8(m){return E(this.buffer,m)}writeUInt8(m,_){w(this.buffer,m,_)}}e.VSBuffer=k;function i(g,m){return g[m+0]<<0>>>0|g[m+1]<<8>>>0}e.readUInt16LE=i;function P(g,m,_){g[_+0]=m&255,m=m>>>8,g[_+1]=m&255}e.writeUInt16LE=P;function h(g,m){return g[m]*2**24+g[m+1]*2**16+g[m+2]*2**8+g[m+3]}e.readUInt32BE=h;function p(g,m,_){g[_+3]=m,m=m>>>8,g[_+2]=m,m=m>>>8,g[_+1]=m,m=m>>>8,g[_]=m}e.writeUInt32BE=p;function o(g,m){return g[m+0]<<0>>>0|g[m+1]<<8>>>0|g[m+2]<<16>>>0|g[m+3]<<24>>>0}e.readUInt32LE=o;function d(g,m,_){g[_+0]=m&255,m=m>>>8,g[_+1]=m&255,m=m>>>8,g[_+2]=m&255,m=m>>>8,g[_+3]=m&255}e.writeUInt32LE=d;function E(g,m){return g[m]}e.readUInt8=E;function w(g,m,_){g[_]=m}e.writeUInt8=w;function S(g){return L.consumeReadable(g,m=>k.concat(m))}e.readableToBuffer=S;function u(g){return L.toReadable(g)}e.bufferToReadable=u;function c(g){return L.consumeStream(g,m=>k.concat(m))}e.streamToBuffer=c;async function f(g){return g.ended?k.concat(g.buffer):k.concat([...g.buffer,await c(g.stream)])}e.bufferedStreamToBuffer=f;function t(g){return L.toStream(g,m=>k.concat(m))}e.bufferToStream=t;function n(g){return L.transform(g,{data:m=>typeof m=="string"?k.fromString(m):k.wrap(m)},m=>k.concat(m))}e.streamToBufferReadableStream=n;function s(g){return L.newWriteableStream(m=>k.concat(m),g)}e.newWriteableBufferStream=s;function r(g,m){return L.prefixedReadable(g,m,_=>k.concat(_))}e.prefixedBufferReadable=r;function a(g,m){return L.prefixedStream(g,m,_=>k.concat(_))}e.prefixedBufferStream=a}),define(me[75],ge([0,1,8]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(w){return I(w,0)}e.hash=L;function I(w,S){switch(typeof w){case"object":return w===null?T(349,S):Array.isArray(w)?D(w,S):k(w,S);case"string":return C(w,S);case"boolean":return y(w,S);case"number":return T(w,S);case"undefined":return T(937,S);default:return T(617,S)}}e.doHash=I;function T(w,S){return(S<<5)-S+w|0}function y(w,S){return T(w?433:863,S)}function C(w,S){S=T(149417,S);for(let u=0,c=w.length;u<c;u++)S=T(w.charCodeAt(u),S);return S}e.stringHash=C;function D(w,S){return S=T(104579,S),w.reduce((u,c)=>I(c,u),S)}function k(w,S){return S=T(181387,S),Object.keys(w).sort().reduce((u,c)=>(u=C(c,u),I(w[c],u)),S)}class i{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=I(S,this._value),this._value}}e.Hasher=i;var P;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function h(w,S,u=32){const c=u-S,f=~((1<<c)-1);return(w<<S|(f&w)>>>c)>>>0}function p(w,S=0,u=w.byteLength,c=0){for(let f=0;f<u;f++)w[S+f]=c}function o(w,S,u="0"){for(;w.length<S;)w=u+w;return w}function d(w,S=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(u=>u.toString(16).padStart(2,"0")).join(""):o((w>>>0).toString(16),S/4)}e.toHexString=d;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const u=S.length;if(u!==0){const c=this._buff;let f=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=S.charCodeAt(0),s=0);;){let r=n;if(b.isHighSurrogate(n))if(s+1<u){const a=S.charCodeAt(s+1);b.isLowSurrogate(a)?(s++,r=b.computeCodePoint(n,a)):r=65533}else{t=n;break}else b.isLowSurrogate(n)&&(r=65533);if(f=this._push(c,f,r),s++,s<u)n=S.charCodeAt(s);else break}this._buffLen=f,this._leftoverHighSurrogate=t}}_push(S,u,c){return c<128?S[u++]=c:c<2048?(S[u++]=192|(c&1984)>>>6,S[u++]=128|(c&63)>>>0):c<65536?(S[u++]=224|(c&61440)>>>12,S[u++]=128|(c&4032)>>>6,S[u++]=128|(c&63)>>>0):(S[u++]=240|(c&1835008)>>>18,S[u++]=128|(c&258048)>>>12,S[u++]=128|(c&4032)>>>6,S[u++]=128|(c&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=E._bigBlock32,u=this._buffDV;for(let m=0;m<64;m+=4)S.setUint32(m,u.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)S.setUint32(m,h(S.getUint32(m-12,!1)^S.getUint32(m-32,!1)^S.getUint32(m-56,!1)^S.getUint32(m-64,!1),1),!1);let c=this._h0,f=this._h1,t=this._h2,n=this._h3,s=this._h4,r,a,g;for(let m=0;m<80;m++)m<20?(r=f&t|~f&n,a=1518500249):m<40?(r=f^t^n,a=1859775393):m<60?(r=f&t|f&n|t&n,a=2400959708):(r=f^t^n,a=3395469782),g=h(c,5)+r+s+a+S.getUint32(m*4,!1)&4294967295,s=n,n=t,t=h(f,30),f=c,c=g;this._h0=this._h0+c&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[58],ge([0,1,8]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(L||(L={})),function(I){const T="error",y="warning",C="warn",D="info",k="ignore";function i(h){return h?b.equalsIgnoreCase(T,h)?I.Error:b.equalsIgnoreCase(y,h)||b.equalsIgnoreCase(C,h)?I.Warning:b.equalsIgnoreCase(D,h)?I.Info:I.Ignore:I.Ignore}I.fromValue=i;function P(h){switch(h){case I.Error:return T;case I.Warning:return y;case I.Info:return D;default:return k}}I.toString=P}(L||(L={})),e.default=L}),define(me[11],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(m){return Array.isArray(m)}e.isArray=b;function L(m){return typeof m=="string"}e.isString=L;function I(m){return Array.isArray(m)&&m.every(_=>L(_))}e.isStringArray=I;function T(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=T;function y(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=y;function C(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=C;function D(m){return m===!0||m===!1}e.isBoolean=D;function k(m){return typeof m=="undefined"}e.isUndefined=k;function i(m){return!P(m)}e.isDefined=i;function P(m){return k(m)||m===null}e.isUndefinedOrNull=P;function h(m,_){if(!m)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=h;function p(m){if(P(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=p;function o(...m){const _=[];for(let l=0;l<m.length;l++){const v=m[l];if(P(v))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);_.push(v)}return _}e.assertAllDefined=o;const d=Object.prototype.hasOwnProperty;function E(m){if(!T(m))return!1;for(let _ in m)if(d.call(m,_))return!1;return!0}e.isEmptyObject=E;function w(m){return typeof m=="function"}e.isFunction=w;function S(...m){return m.length>0&&m.every(w)}e.areFunctions=S;function u(m,_){const l=Math.min(m.length,_.length);for(let v=0;v<l;v++)c(m[v],_[v])}e.validateConstraints=u;function c(m,_){if(L(_)){if(typeof m!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(w(_)){try{if(m instanceof _)return}catch(l){}if(!P(m)&&m.constructor===_||_.length===1&&_.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function f(m){let _=[],l=Object.getPrototypeOf(m);for(;Object.prototype!==l;)_=_.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return _}e.getAllPropertyNames=f;function t(m){const _=[];for(const l of f(m))typeof m[l]=="function"&&_.push(l);return _}e.getAllMethodNames=t;function n(m,_){const l=R=>function(){const O=Array.prototype.slice.call(arguments,0);return _(R,O)};let v={};for(const R of m)v[R]=l(R);return v}e.createProxyObject=n;function s(m){return m===null?void 0:m}e.withNullAsUndefined=s;function r(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=r;function a(m){return class{constructor(){return new Proxy({},{get(_,l){if(_[l])return _[l];throw new Error(`Not Implemented: ${m}->${String(l)}`)}})}}}e.NotImplementedProxy=a;function g(m){throw new Error("Unreachable")}e.assertNever=g}),define(me[29],ge([0,1,10,8,9,11]),function(G,e,b,L,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(s){return s===47||s===92}e.isPathSeparator=y;function C(s){return s.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=C;function D(s){return s.indexOf("/")===-1&&(s=C(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=D;function k(s,r=I.posix.sep){if(!s)return"";const a=s.length,g=s.charCodeAt(0);if(y(g)){if(y(s.charCodeAt(1))&&!y(s.charCodeAt(2))){let _=3;const l=_;for(;_<a&&!y(s.charCodeAt(_));_++);if(l!==_&&!y(s.charCodeAt(_+1))){for(_+=1;_<a;_++)if(y(s.charCodeAt(_)))return s.slice(0,_+1).replace(/[\\/]/g,r)}}return r}else if(w(g)&&s.charCodeAt(1)===58)return y(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let m=s.indexOf("://");if(m!==-1){for(m+=3;m<a;m++)if(y(s.charCodeAt(m)))return s.slice(0,m+1)}return""}e.getRoot=k;function i(s){if(!b.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let a=2;const g=a;for(;a<s.length&&(r=s.charCodeAt(a),r!==92);a++);return!(g===a||(r=s.charCodeAt(a+1),isNaN(r)||r===92))}e.isUNC=i;const P=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(s,r=b.isWindows){const a=r?P:h;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||r&&p.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=o;function d(s,r,a){const g=s===r;return!a||g?g:!s||!r?!1:(0,L.equalsIgnoreCase)(s,r)}e.isEqual=d;function E(s,r,a,g=I.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(a){if(!(0,L.startsWithIgnoreCase)(s,r))return!1;if(r.length===s.length)return!0;let _=r.length;return r.charAt(r.length-1)===g&&_--,s.charAt(_)===g}return r.charAt(r.length-1)!==g&&(r+=g),s.indexOf(r)===0}e.isEqualOrParent=E;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function S(s,r){return b.isWindows&&s.endsWith(":")&&(s+=I.sep),(0,I.isAbsolute)(s)||(s=(0,I.join)(r,s)),s=(0,I.normalize)(s),b.isWindows?(s=(0,L.rtrim)(s,I.sep),s.endsWith(":")&&(s+=I.sep)):(s=(0,L.rtrim)(s,I.sep),s||(s=I.sep)),s}e.sanitizeFilePath=S;function u(s){const r=(0,I.normalize)(s);return b.isWindows?s.length>3?!1:c(r)&&(s.length===2||r.charCodeAt(2)===92):r===I.posix.sep}e.isRootOrDriveLetter=u;function c(s){return b.isWindows?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function f(s){return c(s)?s[0]:void 0}e.getDriveLetter=f;function t(s,r,a){return r.length>s.length?-1:s===r?0:(a&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=t;function n(s){const r=s.split(":");let a,g,m;if(r.forEach(_=>{const l=Number(_);(0,T.isNumber)(l)?g===void 0?g=l:m===void 0&&(m=l):a=a?[a,_].join(":"):_}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:g!==void 0?g:void 0,column:m!==void 0?m:g!==void 0?1:void 0}}e.parseLineAndColumnAware=n}),define(me[24],ge([0,1,11]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const E=Array.isArray(d)?[]:{};return Object.keys(d).forEach(w=>{d[w]&&typeof d[w]=="object"?E[w]=L(d[w]):E[w]=d[w]}),E}e.deepClone=L;function I(d){if(!d||typeof d!="object")return d;const E=[d];for(;E.length>0;){const w=E.shift();Object.freeze(w);for(const S in w)if(T.call(w,S)){const u=w[S];typeof u=="object"&&!Object.isFrozen(u)&&E.push(u)}}return d}e.deepFreeze=I;const T=Object.prototype.hasOwnProperty;function y(d,E){return C(d,E,new Set)}e.cloneAndChange=y;function C(d,E,w){if((0,b.isUndefinedOrNull)(d))return d;const S=E(d);if(typeof S!="undefined")return S;if((0,b.isArray)(d)){const u=[];for(const c of d)u.push(C(c,E,w));return u}if((0,b.isObject)(d)){if(w.has(d))throw new Error("Cannot clone recursive data-structure");w.add(d);const u={};for(let c in d)T.call(d,c)&&(u[c]=C(d[c],E,w));return w.delete(d),u}return d}function D(d,E,w=!0){return(0,b.isObject)(d)?((0,b.isObject)(E)&&Object.keys(E).forEach(S=>{S in d?w&&((0,b.isObject)(d[S])&&(0,b.isObject)(E[S])?D(d[S],E[S],w):d[S]=E[S]):d[S]=E[S]}),d):E}e.mixin=D;function k(d,E){if(d===E)return!0;if(d==null||E===null||E===void 0||typeof d!=typeof E||typeof d!="object"||Array.isArray(d)!==Array.isArray(E))return!1;let w,S;if(Array.isArray(d)){if(d.length!==E.length)return!1;for(w=0;w<d.length;w++)if(!k(d[w],E[w]))return!1}else{const u=[];for(S in d)u.push(S);u.sort();const c=[];for(S in E)c.push(S);if(c.sort(),!k(u,c))return!1;for(w=0;w<u.length;w++)if(!k(d[u[w]],E[u[w]]))return!1}return!0}e.equals=k;function i(d){const E=new Set;return JSON.stringify(d,(w,S)=>{if((0,b.isObject)(S)||Array.isArray(S)){if(E.has(S))return"[Circular]";E.add(S)}return S})}e.safeStringify=i;function P(d,E,w){const S=E(d);return typeof S=="undefined"?w:S}e.getOrDefault=P;function h(d,E){const w=Object.create(null);return!d||!E||Object.keys(E).forEach(u=>{const c=d[u],f=E[u];k(c,f)||(w[u]=f)}),w}e.distinct=h;function p(d,E){const w=E.toLowerCase(),S=Object.keys(d).find(u=>u.toLowerCase()===w);return S?d[S]:d[E]}e.getCaseInsensitive=p;function o(d,E){const w=Object.create(null);for(const S of Object.keys(d))E(S,d[S])&&(w[S]=d[S]);return w}e.filter=o}),define(me[95],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var b;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b=e.Constants||(e.Constants={}));function L(T){return T<0?0:T>255?255:T|0}e.toUint8=L;function I(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=I}),define(me[2],ge([0,1,10,9]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,T=/^\//,y=/^\/\//;function C(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!I.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!T.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(s,r){return!s&&!r?"file":s}function k(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==P&&(r=P+r):r=P;break}return r}const i="",P="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(r,a,g,m,_,l=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=D(r,l),this.authority=a||i,this.path=k(this.scheme,g||i),this.query=m||i,this.fragment=_||i,C(this,l))}static isUri(r){return r instanceof p?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return u(this,!1)}with(r){if(!r)return this;let{scheme:a,authority:g,path:m,query:_,fragment:l}=r;return a===void 0?a=this.scheme:a===null&&(a=i),g===void 0?g=this.authority:g===null&&(g=i),m===void 0?m=this.path:m===null&&(m=i),_===void 0?_=this.query:_===null&&(_=i),l===void 0?l=this.fragment:l===null&&(l=i),a===this.scheme&&g===this.authority&&m===this.path&&_===this.query&&l===this.fragment?this:new d(a,g,m,_,l)}static parse(r,a=!1){const g=h.exec(r);return g?new d(g[2]||i,n(g[4]||i),n(g[5]||i),n(g[7]||i),n(g[9]||i),a):new d(i,i,i,i,i)}static file(r){let a=i;if(b.isWindows&&(r=r.replace(/\\/g,P)),r[0]===P&&r[1]===P){const g=r.indexOf(P,2);g===-1?(a=r.substring(2),r=P):(a=r.substring(2,g),r=r.substring(g)||P)}return new d("file",a,r,i,i)}static from(r){const a=new d(r.scheme,r.authority,r.path,r.query,r.fragment);return C(a,!0),a}static joinPath(r,...a){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return b.isWindows&&r.scheme==="file"?g=p.file(L.win32.join(u(r,!0),...a)).path:g=L.posix.join(r.path,...a),r.with({path:g})}toString(r=!1){return c(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof p)return r;{const a=new d(r);return a._formatted=r.external,a._fsPath=r._sep===o?r.fsPath:null,a}}else return r}}e.URI=p;const o=b.isWindows?1:void 0;class d extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(r=!1){return r?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=o),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,r){let a,g=-1;for(let m=0;m<s.length;m++){const _=s.charCodeAt(m);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||r&&_===47)g!==-1&&(a+=encodeURIComponent(s.substring(g,m)),g=-1),a!==void 0&&(a+=s.charAt(m));else{a===void 0&&(a=s.substr(0,m));const l=E[_];l!==void 0?(g!==-1&&(a+=encodeURIComponent(s.substring(g,m)),g=-1),a+=l):g===-1&&(g=m)}}return g!==-1&&(a+=encodeURIComponent(s.substring(g))),a!==void 0?a:s}function S(s){let r;for(let a=0;a<s.length;a++){const g=s.charCodeAt(a);g===35||g===63?(r===void 0&&(r=s.substr(0,a)),r+=E[g]):r!==void 0&&(r+=s[a])}return r!==void 0?r:s}function u(s,r){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,b.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=u;function c(s,r){const a=r?S:w;let g="",{scheme:m,authority:_,path:l,query:v,fragment:R}=s;if(m&&(g+=m,g+=":"),(_||m==="file")&&(g+=P,g+=P),_){let O=_.indexOf("@");if(O!==-1){const H=_.substr(0,O);_=_.substr(O+1),O=H.indexOf(":"),O===-1?g+=a(H,!1):(g+=a(H.substr(0,O),!1),g+=":",g+=a(H.substr(O+1),!1)),g+="@"}_=_.toLowerCase(),O=_.indexOf(":"),O===-1?g+=a(_,!1):(g+=a(_.substr(0,O),!1),g+=_.substr(O))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const O=l.charCodeAt(1);O>=65&&O<=90&&(l=`/${String.fromCharCode(O+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const O=l.charCodeAt(0);O>=65&&O<=90&&(l=`${String.fromCharCode(O+32)}:${l.substr(2)}`)}g+=a(l,!0)}return v&&(g+="?",g+=a(v,!1)),R&&(g+="#",g+=r?R:w(R,!1)),g}function f(s){try{return decodeURIComponent(s)}catch(r){return s.length>3?s.substr(0,3)+f(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,r=>f(r)):s}});var nt=this&&this.__classPrivateFieldSet||function(G,e,b,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(G,b):I?I.value=b:e.set(G,b),b},$e=this&&this.__classPrivateFieldGet||function(G,e,b,L){if(b==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?L:b==="a"?L.call(G):L?L.value:e.get(G)};define(me[22],ge([0,1,2,8]),function(G,e,b,L){"use strict";var I,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,n,s){let r=t.get(n);return r===void 0&&(r=s,t.set(n,r)),r}e.getOrSet=C;function D(t){const n=[];return t.forEach((s,r)=>{n.push(`${r} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function k(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}e.StringIterator=i;class P{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class h{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var p;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(p||(p={}));class o{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,L.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(n){this._iter=n}static forUris(n=()=>!1){return new E(new o(n))}static forPaths(){return new E(new h)}static forStrings(){return new E(new i)}static forConfigKeys(){return new E(new P)}clear(){this._root=void 0}set(n,s){const r=this._iter.reset(n);let a;for(this._root||(this._root=new d,this._root.segment=r.value()),a=this._root;;){const m=r.cmp(a.segment);if(m>0)a.left||(a.left=new d,a.left.segment=r.value()),a=a.left;else if(m<0)a.right||(a.right=new d,a.right.segment=r.value()),a=a.right;else if(r.hasNext())r.next(),a.mid||(a.mid=new d,a.mid.segment=r.value()),a=a.mid;else break}const g=a.value;return a.value=s,a.key=n,g}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const a=s.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const r=this._iter.reset(n),a=[];let g=this._root;for(;g;){const m=r.cmp(g.segment);if(m>0)a.push([1,g]),g=g.left;else if(m<0)a.push([-1,g]),g=g.right;else if(r.hasNext())r.next(),a.push([0,g]),g=g.mid;else{for(s?(g.left=void 0,g.mid=void 0,g.right=void 0):g.value=void 0;a.length>0&&g.isEmpty();){let[_,l]=a.pop();switch(_){case 1:l.left=void 0;break;case 0:l.mid=void 0;break;case-1:l.right=void 0;break}g=l}break}}}findSubstr(n){const s=this._iter.reset(n);let r=this._root,a;for(;r;){const g=s.cmp(r.segment);if(g>0)r=r.left;else if(g<0)r=r.right;else if(s.hasNext())s.next(),a=r.value||a,r=r.mid;else break}return r&&r.value||a}findSuperstr(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const a=s.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[s,r]of this)n(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=E;class w{constructor(n,s){this[I]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=s!=null?s:w.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:w.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[r,a]of this.map)n(a,b.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield b.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[b.URI.parse(n[0]),n[1]]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[b.URI.parse(n[0]),n[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var S;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class u{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const r=this._map.get(n);if(!!r)return s!==0&&this.touch(r,s),r.value}set(n,s,r=0){let a=this._map.get(n);if(a)a.value=s,r!==0&&this.touch(a,r);else{switch(a={key:n,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(n,a),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,s){const r=this._state;let a=this._head;for(;a;){if(s?n.bind(s)(a.value,a.key,this):n(a.value,a.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const n=this,s=this._state;let r=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const g={value:r.key,done:!1};return r=r.next,g}else return{value:void 0,done:!0}}};return a}values(){const n=this,s=this._state;let r=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const g={value:r.value,done:!1};return r=r.next,g}else return{value:void 0,done:!0}}};return a}entries(){const n=this,s=this._state;let r=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const g={value:[r.key,r.value],done:!1};return r=r.next,g}else return{value:void 0,done:!0}}};return a}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>n;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,r=n.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const r=n.next,a=n.previous;n===this._tail?(a.next=void 0,this._tail=a):(r.previous=a,a.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const r=n.next,a=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=a,a.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,r)=>{n.push([r,s])}),n}fromJSON(n){this.clear();for(const[s,r]of n)this.set(s,r)}}e.LinkedMap=u;class c extends u{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class f{constructor(n){y.set(this,void 0),nt(this,y,n,"f")}get size(){return $e(this,y,"f").size}forEach(n,s){$e(this,y,"f").forEach(n,s)}get(n){return $e(this,y,"f").get(n)}has(n){return $e(this,y,"f").has(n)}entries(){return $e(this,y,"f").entries()}keys(){return $e(this,y,"f").keys()}values(){return $e(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return $e(this,y,"f").entries()}}e.ReadonlyMapView=f}),define(me[96],ge([0,1,22,8]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...pe){return function(ke,Fe){for(let He=0,be=pe.length;He<be;He++){const Ke=pe[He](ke,Fe);if(Ke)return Ke}return null}}e.or=I,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(pe,ke,Fe){if(!Fe||Fe.length<ke.length)return null;let He;return pe?He=L.startsWithIgnoreCase(Fe,ke):He=Fe.indexOf(ke)===0,He?ke.length>0?[{start:0,end:ke.length}]:[]:null}function y(pe,ke){const Fe=ke.toLowerCase().indexOf(pe.toLowerCase());return Fe===-1?null:[{start:Fe,end:Fe+pe.length}]}e.matchesContiguousSubString=y;function C(pe,ke){return D(pe.toLowerCase(),ke.toLowerCase(),0,0)}e.matchesSubString=C;function D(pe,ke,Fe,He){if(Fe===pe.length)return[];if(He===ke.length)return null;if(pe[Fe]===ke[He]){let be=null;return(be=D(pe,ke,Fe+1,He+1))?w({start:He,end:He+1},be):null}return D(pe,ke,Fe,He+1)}function k(pe){return 97<=pe&&pe<=122}function i(pe){return 65<=pe&&pe<=90}e.isUpper=i;function P(pe){return 48<=pe&&pe<=57}function h(pe){return pe===32||pe===9||pe===10||pe===13}const p=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(pe=>p.add(pe.charCodeAt(0)));function o(pe){return h(pe)||p.has(pe)}function d(pe,ke){return pe===ke||o(pe)&&o(ke)}function E(pe){return k(pe)||i(pe)||P(pe)}function w(pe,ke){return ke.length===0?ke=[pe]:pe.end===ke[0].start?ke[0].start=pe.start:ke.unshift(pe),ke}function S(pe,ke){for(let Fe=ke;Fe<pe.length;Fe++){const He=pe.charCodeAt(Fe);if(i(He)||P(He)||Fe>0&&!E(pe.charCodeAt(Fe-1)))return Fe}return pe.length}function u(pe,ke,Fe,He){if(Fe===pe.length)return[];if(He===ke.length)return null;if(pe[Fe]!==ke[He].toLowerCase())return null;{let be=null,Ke=He+1;for(be=u(pe,ke,Fe+1,He+1);!be&&(Ke=S(ke,Ke))<ke.length;)be=u(pe,ke,Fe+1,Ke),Ke++;return be===null?null:w({start:He,end:He+1},be)}}function c(pe){let ke=0,Fe=0,He=0,be=0,Ke=0;for(let je=0;je<pe.length;je++)Ke=pe.charCodeAt(je),i(Ke)&&ke++,k(Ke)&&Fe++,E(Ke)&&He++,P(Ke)&&be++;const K=ke/pe.length,te=Fe/pe.length,we=He/pe.length,Ue=be/pe.length;return{upperPercent:K,lowerPercent:te,alphaPercent:we,numericPercent:Ue}}function f(pe){const{upperPercent:ke,lowerPercent:Fe}=pe;return Fe===0&&ke>.6}function t(pe){const{upperPercent:ke,lowerPercent:Fe,alphaPercent:He,numericPercent:be}=pe;return Fe>.2&&ke<.8&&He>.6&&be<.2}function n(pe){let ke=0,Fe=0,He=0,be=0;for(let Ke=0;Ke<pe.length;Ke++)He=pe.charCodeAt(Ke),i(He)&&ke++,k(He)&&Fe++,h(He)&&be++;return(ke===0||Fe===0)&&be===0?pe.length<=30:ke<=5}function s(pe,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!n(pe)||ke.length>60)return null;const Fe=c(ke);if(!t(Fe)){if(!f(Fe))return null;ke=ke.toLowerCase()}let He=null,be=0;for(pe=pe.toLowerCase();be<ke.length&&(He=u(pe,ke,0,be))===null;)be=S(ke,be+1);return He}e.matchesCamelCase=s;function r(pe,ke,Fe=!1){if(!ke||ke.length===0)return null;let He=null,be=0;for(pe=pe.toLowerCase(),ke=ke.toLowerCase();be<ke.length&&(He=a(pe,ke,0,be,Fe))===null;)be=g(ke,be+1);return He}e.matchesWords=r;function a(pe,ke,Fe,He,be){if(Fe===pe.length)return[];if(He===ke.length)return null;if(d(pe.charCodeAt(Fe),ke.charCodeAt(He))){let Ke=null,K=He+1;if(Ke=a(pe,ke,Fe+1,He+1,be),!be)for(;!Ke&&(K=g(ke,K))<ke.length;)Ke=a(pe,ke,Fe+1,K,be),K++;return Ke===null?null:w({start:He,end:He+1},Ke)}else return null}function g(pe,ke){for(let Fe=ke;Fe<pe.length;Fe++)if(o(pe.charCodeAt(Fe))||Fe>0&&o(pe.charCodeAt(Fe-1)))return Fe;return pe.length}const m=I(e.matchesPrefix,s,y),_=I(e.matchesPrefix,s,C),l=new b.LRUCache(1e4);function v(pe,ke,Fe=!1){if(typeof pe!="string"||typeof ke!="string")return null;let He=l.get(pe);He||(He=new RegExp(L.convertSimple2RegExpPattern(pe),"i"),l.set(pe,He));const be=He.exec(ke);return be?[{start:be.index,end:be.index+be[0].length}]:Fe?_(pe,ke):m(pe,ke)}e.matchesFuzzy=v;function R(pe,ke){const Fe=j(pe,pe.toLowerCase(),0,ke,ke.toLowerCase(),0,!0);return Fe?H(Fe):null}e.matchesFuzzy2=R;function O(pe,ke,Fe,He,be,Ke){const K=Math.min(13,pe.length);for(;Fe<K;Fe++){const te=j(pe,ke,Fe,He,be,Ke,!1);if(te)return te}return[0,Ke]}e.anyScore=O;function H(pe){if(typeof pe=="undefined")return[];const ke=[],Fe=pe[1];for(let He=pe.length-1;He>1;He--){const be=pe[He]+Fe,Ke=ke[ke.length-1];Ke&&Ke.end===be?Ke.end=be+1:ke.push({start:be,end:be+1})}return ke}e.createMatches=H;const ne=128;function ie(){const pe=[],ke=[];for(let Fe=0;Fe<=ne;Fe++)ke[Fe]=0;for(let Fe=0;Fe<=ne;Fe++)pe.push(ke.slice(0));return pe}function N(pe){const ke=[];for(let Fe=0;Fe<=pe;Fe++)ke[Fe]=0;return ke}const B=N(2*ne),U=N(2*ne),A=ie(),x=ie(),F=ie(),M=!1;function W(pe,ke,Fe,He,be){function Ke(te,we,Ue=" "){for(;te.length<we;)te=Ue+te;return te}let K=` |   |${He.split("").map(te=>Ke(te,3)).join("|")}
`;for(let te=0;te<=Fe;te++)te===0?K+=" |":K+=`${ke[te-1]}|`,K+=pe[te].slice(0,be+1).map(we=>Ke(we.toString(),3)).join("|")+`
`;return K}function z(pe,ke,Fe,He){pe=pe.substr(ke),Fe=Fe.substr(He),console.log(W(x,pe,pe.length,Fe,Fe.length)),console.log(W(F,pe,pe.length,Fe,Fe.length)),console.log(W(A,pe,pe.length,Fe,Fe.length))}function Y(pe,ke){if(ke<0||ke>=pe.length)return!1;const Fe=pe.codePointAt(ke);switch(Fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(Fe)}}function le(pe,ke){if(ke<0||ke>=pe.length)return!1;switch(pe.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function ve(pe,ke,Fe){return ke[pe]!==Fe[pe]}function Te(pe,ke,Fe,He,be,Ke,K=!1){for(;ke<Fe&&be<Ke;)pe[ke]===He[be]&&(K&&(B[ke]=be),ke+=1),be+=1;return ke===Fe}e.isPatternInWord=Te;var ye;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var Oe;(function(pe){pe.Default=[-100,0];function ke(Fe){return!Fe||Fe.length===2&&Fe[0]===-100&&Fe[1]===0}pe.isDefault=ke})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function j(pe,ke,Fe,He,be,Ke,K){const te=pe.length>ne?ne:pe.length,we=He.length>ne?ne:He.length;if(!(Fe>=te||Ke>=we||te-Fe>we-Ke)&&!!Te(ke,Fe,te,be,Ke,we,!0)){Q(te,we,Fe,Ke,ke,be);let Ue=1,je=1,ze=Fe,Ze=Ke;const Ce=[!1];for(Ue=1,ze=Fe;ze<te;Ue++,ze++){const V=B[ze],J=U[ze],ce=ze+1<te?U[ze+1]:we;for(je=V-Ke+1,Ze=V;Ze<ce;je++,Ze++){let Ae=Number.MIN_SAFE_INTEGER,Ee=!1;Ze<=J&&(Ae=Z(pe,ke,ze,Fe,He,be,Ze,we,Ke,A[Ue-1][je-1]===0,Ce));let Me=0;Ae!==Number.MAX_SAFE_INTEGER&&(Ee=!0,Me=Ae+x[Ue-1][je-1]);const Ve=Ze>V,Xe=Ve?x[Ue][je-1]+(A[Ue][je-1]>0?-5:0):0,rt=Ze>V+1&&A[Ue][je-1]>0,Qe=rt?x[Ue][je-2]+(A[Ue][je-2]>0?-5:0):0;if(rt&&(!Ve||Qe>=Xe)&&(!Ee||Qe>=Me))x[Ue][je]=Qe,F[Ue][je]=3,A[Ue][je]=0;else if(Ve&&(!Ee||Xe>=Me))x[Ue][je]=Xe,F[Ue][je]=2,A[Ue][je]=0;else if(Ee)x[Ue][je]=Me,F[Ue][je]=1,A[Ue][je]=A[Ue-1][je-1]+1;else throw new Error("not possible")}}if(M&&z(pe,Fe,He,Ke),!(!Ce[0]&&!K)){Ue--,je--;const De=[x[Ue][je],Ke];let Pe=0,oe=0;for(;Ue>=1;){let V=je;do{const J=F[Ue][V];if(J===3)V=V-2;else if(J===2)V=V-1;else break}while(V>=1);Pe>1&&ke[Fe+Ue-1]===be[Ke+je-1]&&!ve(V+Ke-1,He,be)&&Pe+1>A[Ue][V]&&(V=je),V===je?Pe++:Pe=1,oe||(oe=V),Ue--,je=V-1,De.push(je)}we===te&&(De[0]+=2);const ue=oe-te;return De[0]-=ue,De}}}e.fuzzyScore=j;function Q(pe,ke,Fe,He,be,Ke){let K=pe-1,te=ke-1;for(;K>=Fe&&te>=He;)be[K]===Ke[te]&&(U[K]=te,K--),te--}function Z(pe,ke,Fe,He,be,Ke,K,te,we,Ue,je){if(ke[Fe]!==Ke[K])return Number.MIN_SAFE_INTEGER;let ze=1,Ze=!1;return K===Fe-He?ze=pe[Fe]===be[K]?7:5:ve(K,be,Ke)&&(K===0||!ve(K-1,be,Ke))?(ze=pe[Fe]===be[K]?7:5,Ze=!0):Y(Ke,K)&&(K===0||!Y(Ke,K-1))?ze=5:(Y(Ke,K-1)||le(Ke,K-1))&&(ze=5,Ze=!0),ze>1&&Fe===He&&(je[0]=!0),Ze||(Ze=ve(K,be,Ke)||Y(Ke,K-1)||le(Ke,K-1)),Fe===He?K>we&&(ze-=Ze?3:5):Ue?ze+=Ze?2:0:ze+=Ze?0:1,K+1===te&&(ze-=Ze?3:5),ze}function se(pe,ke,Fe,He,be,Ke,K){return _e(pe,ke,Fe,He,be,Ke,!0,K)}e.fuzzyScoreGracefulAggressive=se;function fe(pe,ke,Fe,He,be,Ke,K){return _e(pe,ke,Fe,He,be,Ke,!1,K)}e.fuzzyScoreGraceful=fe;function _e(pe,ke,Fe,He,be,Ke,K,te){let we=j(pe,ke,Fe,He,be,Ke,te);if(we&&!K)return we;if(pe.length>=3){const Ue=Math.min(7,pe.length-1);for(let je=Fe+1;je<Ue;je++){const ze=xe(pe,je);if(ze){const Ze=j(ze,ze.toLowerCase(),Fe,He,be,Ke,te);Ze&&(Ze[0]-=3,(!we||Ze[0]>we[0])&&(we=Ze))}}}return we}function xe(pe,ke){if(!(ke+1>=pe.length)){const Fe=pe[ke],He=pe[ke+1];if(Fe!==He)return pe.slice(0,ke)+He+Fe+pe.slice(ke+2)}}}),define(me[136],ge([0,1,46,96,8]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${T.source}`,"g");function C(d){return d.replace(y,(E,w)=>w?E:`\\${E}`)}e.escapeIcons=C;const D=new RegExp(`\\\\${T.source}`,"g");function k(d){return d.replace(D,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=k;const i=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function P(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(i,(E,w,S,u)=>S?E:w||u||"")}e.stripIcons=P;function h(d){const E=d.indexOf(e.iconStartMarker);return E===-1?{text:d}:p(d,E)}e.parseLabelWithIcons=h;function p(d,E){const w=[];let S="";function u(g){if(g){S+=g;for(const m of g)w.push(t)}}let c=-1,f="",t=0,n,s,r=E;const a=d.length;for(u(d.substr(0,E));r<a;)n=d[r],s=d[r+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(c=r,u(f),f=e.iconStartMarker,r++):n===")"&&c!==-1?(t+=r-c+1,c=-1,f=""):c!==-1?/^[a-z0-9\-]$/i.test(n)?f+=n:(u(f),c=-1,f=""):u(n),r++;return u(f),{text:S,iconOffsets:w}}function o(d,E,w=!1){const{text:S,iconOffsets:u}=E;if(!u||u.length===0)return(0,L.matchesFuzzy)(d,S,w);const c=(0,I.ltrim)(S," "),f=S.length-c.length,t=(0,L.matchesFuzzy)(d,c,w);if(t)for(const n of t){const s=u[n.start+f]+f;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=o}),define(me[97],ge([0,1,16,136,17]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(d="",E=!1){var w,S;if(this.value=d,typeof this.value!="string")throw(0,I.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1):(this.isTrusted=(w=E.isTrusted)!==null&&w!==void 0?w:void 0,this.supportThemeIcons=(S=E.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(d,E=0){return this.value+=P(this.supportThemeIcons?(0,L.escapeIcons)(d):d).replace(/([ \t]+)/g,(w,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,E){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}}e.MarkdownString=y;function C(o){return D(o)?!o.value:Array.isArray(o)?o.every(C):!0}e.isEmptyMarkdownString=C;function D(o){return o instanceof y?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function k(o,d){return!o&&!d?!0:!o||!d?!1:Array.isArray(o)&&Array.isArray(d)?(0,b.equals)(o,d,i):D(o)&&D(d)?i(o,d):!1}e.markedStringsEquals=k;function i(o,d){return o===d?!0:!o||!d?!1:o.value===d.value&&o.isTrusted===d.isTrusted&&o.supportThemeIcons===d.supportThemeIcons}function P(o){return o.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function h(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=h;function p(o){const d=[],E=o.split("|").map(S=>S.trim());o=E[0];const w=E[1];if(w){const S=/height=(\d+)/.exec(w),u=/width=(\d+)/.exec(w),c=S?S[1]:"",f=u?u[1]:"",t=isFinite(parseInt(f)),n=isFinite(parseInt(c));t&&d.push(`width="${f}"`),n&&d.push(`height="${c}"`)}return{href:o,dimensions:d}}e.parseHrefAndDimensions=p}),define(me[59],ge([0,1,23,8,2]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(k){return JSON.stringify(k,C)}e.stringify=T;function y(k){let i=JSON.parse(k);return i=D(i),i}e.parse=y;function C(k,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,L.regExpFlags)(i)}:i}function D(k,i=0){if(!k||i>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return I.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof b.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=D(k[P],i+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=D(k[P],i+1))}return k}e.revive=D}),define(me[12],ge([0,1,2,10]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var I;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(I=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,k,i){this._hosts[D]=k,this._ports[D]=i}setConnectionToken(D,k){this._connectionTokens[D]=k}rewrite(D){if(this._delegate)return this._delegate(D);const k=D.authority;let i=this._hosts[k];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const P=this._ports[k],h=this._connectionTokens[k];let p=`path=${encodeURIComponent(D.path)}`;return typeof h=="string"&&(p+=`&tkn=${encodeURIComponent(h)}`),b.URI.from({scheme:L.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${i}:${P}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new T;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,k,i){const P=this.toUri(D,k);return P.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(P):L.isNative&&(i||L.isPreferringBrowserCodeLoad)&&P.scheme===I.file?P.with({scheme:I.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(D,k){const i=this.toUri(D,k);return i.scheme===I.vscodeFileResource?i.with({scheme:I.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(D,k){return b.URI.isUri(D)?D:b.URI.parse(k.toUrl(D))}}e.FileAccess=new y}),define(me[76],ge([0,1,22]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const L=new b.LRUCache(1e4);function I(k){return D(k,"NFC",L)}e.normalizeNFC=I;const T=new b.LRUCache(1e4);function y(k){return D(k,"NFD",T)}e.normalizeNFD=y;const C=/[^\u0000-\u0080]/;function D(k,i,P){if(!e.canNormalize||!k)return k;const h=P.get(k);if(h)return h;let p;return C.test(k)?p=k.normalize(i):p=k,P.set(k,p),p}e.removeAccents=function(){if(e.canNormalize){const k=/[\u0300-\u036f]/g;return function(i){return y(i).replace(k,"")}}else return function(k){return k}}()}),define(me[25],ge([0,1,29,9,2,8,12,10]),function(G,e,b,L,I,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(p){return(0,I.uriToFsPath)(p,!0)}e.originalFSPath=D;class k{constructor(o){this._ignorePathCasing=o}compare(o,d,E=!1){return o===d?0:(0,T.compare)(this.getComparisonKey(o,E),this.getComparisonKey(d,E))}isEqual(o,d,E=!1){return o===d?!0:!o||!d?!1:this.getComparisonKey(o,E)===this.getComparisonKey(d,E)}getComparisonKey(o,d=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,d,E=!1){if(o.scheme===d.scheme){if(o.scheme===y.Schemas.file)return b.isEqualOrParent(D(o),D(d),this._ignorePathCasing(o))&&o.query===d.query&&(E||o.fragment===d.fragment);if((0,e.isEqualAuthority)(o.authority,d.authority))return b.isEqualOrParent(o.path,d.path,this._ignorePathCasing(o),"/")&&o.query===d.query&&(E||o.fragment===d.fragment)}return!1}joinPath(o,...d){return I.URI.joinPath(o,...d)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return L.posix.basename(o.path)}extname(o){return L.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let d;return o.scheme===y.Schemas.file?d=I.URI.file(L.dirname(D(o))).path:(d=L.posix.dirname(o.path),o.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),d="/")),o.with({path:d})}normalizePath(o){if(!o.path.length)return o;let d;return o.scheme===y.Schemas.file?d=I.URI.file(L.normalize(D(o))).path:d=L.posix.normalize(o.path),o.with({path:d})}relativePath(o,d){if(!(o.scheme!==d.scheme||!(0,e.isEqualAuthority)(o.authority,d.authority))){if(o.scheme===y.Schemas.file){const S=L.relative(D(o),D(d));return C.isWindows?b.toSlashes(S):S}let E=o.path||"/",w=d.path||"/";if(this._ignorePathCasing(o)){let S=0;for(const u=Math.min(E.length,w.length);S<u&&!(E.charCodeAt(S)!==w.charCodeAt(S)&&E.charAt(S).toLowerCase()!==w.charAt(S).toLowerCase());S++);E=w.substr(0,S)+E.substr(S)}return L.posix.relative(E,w)}}resolvePath(o,d){if(o.scheme===y.Schemas.file){const E=I.URI.file(L.resolve(D(o),d));return o.with({authority:E.authority,path:E.path})}return d=b.toPosixPath(d),o.with({path:L.posix.resolve(o.path,d)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,d){return o===d||(0,T.equalsIgnoreCase)(o,d)}hasTrailingPathSeparator(o,d=L.sep){if(o.scheme===y.Schemas.file){const E=D(o);return E.length>b.getRoot(E).length&&E[E.length-1]===d}else{const E=o.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,d=L.sep){return(0,e.hasTrailingPathSeparator)(o,d)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,d=L.sep){let E=!1;if(o.scheme===y.Schemas.file){const w=D(o);E=w!==void 0&&w.length===b.getRoot(w).length&&w[w.length-1]===d}else{d="/";const w=o.path;E=w.length===1&&w.charCodeAt(w.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(o,d)?o.with({path:o.path+"/"}):o}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(p=>p.scheme===y.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new k(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,o){const d=[];for(let E=0;E<p.length;E++){const w=o(p[E]);p.some((S,u)=>u===E?!1:(0,e.isEqualOrParent)(w,o(S)))||d.push(p[E])}return d}e.distinctParents=i;var P;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function o(d){const E=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(u=>{const[c,f]=u.split(":");c&&f&&E.set(c,f)});const S=d.path.substring(0,d.path.indexOf(";"));return S&&E.set(p.META_DATA_MIME,S),E}p.parseMetaData=o})(P=e.DataUri||(e.DataUri={}));function h(p,o,d){if(o){let E=p.path;return E&&E[0]!==L.posix.sep&&(E=L.posix.sep+E),p.with({scheme:d,authority:o,path:E})}return p.with({scheme:d})}e.toLocalResource=h}),define(me[13],ge([0,1,21,17,3,6,57,25]),function(G,e,b,L,I,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(x){return!!x&&typeof x.then=="function"}e.isThenable=D;function k(x){const F=new b.CancellationTokenSource,M=x(F.token),W=new Promise((z,Y)=>{F.token.onCancellationRequested(()=>{Y((0,L.canceled)())}),Promise.resolve(M).then(le=>{F.dispose(),z(le)},le=>{F.dispose(),Y(le)})});return new class{cancel(){F.cancel()}then(z,Y){return W.then(z,Y)}catch(z){return this.then(void 0,z)}finally(z){return W.finally(z)}}}e.createCancelablePromise=k;function i(x,F,M){return Promise.race([x,new Promise(W=>F.onCancellationRequested(()=>W(M)))])}e.raceCancellation=i;async function P(x){let F=-1;const M=x.map((z,Y)=>z.then(le=>(F=Y,le))),W=await Promise.race(M);return x.forEach((z,Y)=>{Y!==F&&z.cancel()}),W}e.raceCancellablePromises=P;function h(x,F,M){let W;const z=setTimeout(()=>{W==null||W(void 0),M==null||M()},F);return Promise.race([x.finally(()=>clearTimeout(z)),new Promise(Y=>W=Y)])}e.raceTimeout=h;function p(x){return new Promise((F,M)=>{const W=x();D(W)?W.then(F,M):F(W)})}e.asPromise=p;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(M,M).then(W)})}return new Promise((M,W)=>{this.queuedPromise.then(M,W)})}return this.activePromise=F(),new Promise((M,W)=>{this.activePromise.then(z=>{this.activePromise=null,M(z)},z=>{this.activePromise=null,W(z)})})}}e.Throttler=o;class d{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=d;class E{constructor(){this.promiseMap=new Map}queue(F,M){var W;const Y=((W=this.promiseMap.get(F))!==null&&W!==void 0?W:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(F)===Y&&this.promiseMap.delete(F)});return this.promiseMap.set(F,Y),Y}}e.SequencerByKey=E;class w{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,M=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,z)=>{this.doResolve=W,this.doReject=z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class S{constructor(F){this.delayer=new w(F),this.throttler=new o}trigger(F,M){return this.delayer.trigger(()=>this.throttler.queue(F),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,M)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class c extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function f(x,F){return F?new Promise((M,W)=>{const z=setTimeout(M,x);F.onCancellationRequested(()=>{clearTimeout(z),W((0,L.canceled)())})}):k(M=>f(x,M))}e.timeout=f;function t(x,F=0){const M=setTimeout(x,F);return(0,T.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=t;function n(x){return x.then(void 0,F=>{})}e.ignoreErrors=n;function s(x){const F=[];let M=0;const W=x.length;function z(){return M<W?x[M++]():null}function Y(le){le!=null&&F.push(le);const ve=z();return ve?ve.then(Y):Promise.resolve(F)}return Promise.resolve(null).then(Y)}e.sequence=s;function r(x,F=W=>!!W,M=null){let W=0;const z=x.length,Y=()=>{if(W>=z)return Promise.resolve(M);const le=x[W++];return Promise.resolve(le()).then(Te=>F(Te)?Promise.resolve(Te):Y())};return Y()}e.first=r;function a(x,F=W=>!!W,M=null){if(x.length===0)return Promise.resolve(M);let W=x.length;const z=()=>{var Y,le;W=-1;for(const ve of x)(le=(Y=ve).cancel)===null||le===void 0||le.call(Y)};return new Promise((Y,le)=>{for(const ve of x)ve.then(Te=>{--W>=0&&F(Te)?(z(),Y(Te)):W===0&&Y(M)}).catch(Te=>{--W>=0&&(z(),le(Te))})})}e.firstParallel=a;class g{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((M,W)=>{this.outstandingPromises.push({factory:F,c:M,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const M=F.factory();M.then(F.c,F.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=g;class m extends g{constructor(){super(1)}}e.Queue=m;class _{constructor(){this.queues=new Map}queueFor(F,M=C.extUri){const W=M.getComparisonKey(F);let z=this.queues.get(W);return z||(z=new m,I.Event.once(z.onFinished)(()=>{z==null||z.dispose(),this.queues.delete(W)}),this.queues.set(W,z)),z}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=_;class l{constructor(F,M){this._token=-1,typeof F=="function"&&typeof M=="number"&&this.setIfNotSet(F,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},M)}setIfNotSet(F,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},M))}}e.TimeoutTimer=l;class v{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setInterval(()=>{F()},M)}}e.IntervalTimer=v;class R{constructor(F,M){this.timeoutToken=-1,this.runner=F,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class O extends R{constructor(F,M){super(F,M);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const M=setTimeout(()=>F(x));let W=!1;return{dispose(){W||(W=!0,clearTimeout(M))}}}}else e.runWhenIdle=(x,F)=>{const M=requestIdleCallback(x,typeof F=="number"?{timeout:F}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(M))}}}}();class H{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=H;async function ne(x,F,M){let W;for(let z=0;z<M;z++)try{return await x()}catch(Y){W=Y,await f(F)}throw W}e.retry=ne;class ie{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,M,W){return this._pending={taskId:F,cancel:()=>W==null?void 0:W(),promise:M},M.then(()=>this.donePending(F),()=>this.donePending(F)),M}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let M,W;const z=new Promise((Y,le)=>{M=Y,W=le});this._next={run:F,promise:z,promiseResolve:M,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=ie;class N{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,M)=>{this.completeCallback=F,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(M=>{this.completeCallback(F),this.resolved=!0,M()})}error(F){return new Promise(M=>{this.errorCallback(F),this.rejected=!0,M()})}cancel(){new Promise(F=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=B;class U extends I.Emitter{async fireAsync(F,M,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const z of this._listeners)this._asyncDeliveryQueue.push([z,F]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[z,Y]=this._asyncDeliveryQueue.shift(),le=[],ve=Object.assign(Object.assign({},Y),{waitUntil:Te=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");W&&(Te=W(Te,typeof z=="function"?z:z[0])),le.push(Te)}});try{typeof z=="function"?z.call(void 0,ve):z[0].call(z[1],ve)}catch(Te){(0,L.onUnexpectedError)(Te);continue}Object.freeze(le),await A.settled(le).catch(Te=>(0,L.onUnexpectedError)(Te))}}}}e.AsyncEmitter=U;var A;(function(x){async function F(Y){return typeof Promise.allSettled=="function"?M(Y):W(Y)}x.allSettled=F;async function M(Y){return Promise.allSettled(Y)}async function W(Y){return Promise.all(Y.map(le=>le.then(ve=>({status:"fulfilled",value:ve}),ve=>({status:"rejected",reason:ve}))))}async function z(Y){let le;const ve=await Promise.all(Y.map(Te=>Te.then(ye=>ye,ye=>{le||(le=ye)})));if(typeof le!="undefined")throw le;return ve}x.settled=z})(A=e.Promises||(e.Promises={}))}),define(me[98],ge([0,1,9,13]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new L.IdleValue(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),T=new L.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new L.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(l,v,R=!1){const O=l||"",H=v||"",ne=I.value.collator.compare(O,H);return I.value.collatorIsNumeric&&ne===0&&O!==H?O<H?-1:1:ne}e.compareFileNames=C;function D(l,v){const R=T.value.collator;return l=l||"",v=v||"",f(R,l,v)}e.compareFileNamesDefault=D;function k(l,v){const R=T.value.collator;return l=l||"",v=v||"",r(l,v)||f(R,l,v)}e.compareFileNamesUpper=k;function i(l,v){const R=T.value.collator;return l=l||"",v=v||"",s(l,v)||f(R,l,v)}e.compareFileNamesLower=i;function P(l,v){return l=l||"",v=v||"",l===v?0:l<v?-1:1}e.compareFileNamesUnicode=P;function h(l,v,R=!1){R||(l=l&&l.toLowerCase(),v=v&&v.toLowerCase());const[O,H]=u(l),[ne,ie]=u(v);return O!==ne?O<ne?-1:1:H===ie?0:H<ie?-1:1}e.noIntlCompareFileNames=h;function p(l,v){const[R,O]=u(l),[H,ne]=u(v);let ie=I.value.collator.compare(O,ne);if(ie===0){if(I.value.collatorIsNumeric&&O!==ne)return O<ne?-1:1;if(ie=I.value.collator.compare(R,H),I.value.collatorIsNumeric&&ie===0&&R!==H)return R<H?-1:1}return ie}e.compareFileExtensions=p;function o(l,v){l=l||"",v=v||"";const R=c(l),O=c(v),H=T.value.collator,ne=y.value.collator;return f(ne,R,O)||f(H,l,v)}e.compareFileExtensionsDefault=o;function d(l,v){l=l||"",v=v||"";const R=c(l),O=c(v),H=T.value.collator,ne=y.value.collator;return f(ne,R,O)||r(l,v)||f(H,l,v)}e.compareFileExtensionsUpper=d;function E(l,v){l=l||"",v=v||"";const R=c(l),O=c(v),H=T.value.collator,ne=y.value.collator;return f(ne,R,O)||s(l,v)||f(H,l,v)}e.compareFileExtensionsLower=E;function w(l,v){l=l||"",v=v||"";const R=c(l).toLowerCase(),O=c(v).toLowerCase();return R!==O?R<O?-1:1:l!==v?l<v?-1:1:0}e.compareFileExtensionsUnicode=w;const S=/^(.*?)(\.([^.]*))?$/;function u(l,v=!1){const R=l?S.exec(l):[];let O=[R&&R[1]||"",R&&R[3]||""];return v&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function c(l){const v=l?S.exec(l):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function f(l,v,R){let O=l.compare(v,R);return O!==0?O:v.length!==R.length?v.length<R.length?-1:1:0}function t(l){const v=l.charAt(0);return v.toLocaleUpperCase()!==v}function n(l){const v=l.charAt(0);return v.toLocaleLowerCase()!==v}function s(l,v){return t(l)&&n(v)?-1:n(l)&&t(v)?1:0}function r(l,v){return n(l)&&t(v)?-1:t(l)&&n(v)?1:0}function a(l,v,R=!1){return R||(l=l&&l.toLowerCase(),v=v&&v.toLowerCase()),l===v?0:l<v?-1:1}function g(l,v,R=!1){const O=l.split(b.sep),H=v.split(b.sep),ne=O.length-1,ie=H.length-1;let N,B;for(let U=0;;U++){if(N=ne===U,B=ie===U,N&&B)return C(O[U],H[U],R);if(N)return-1;if(B)return 1;const A=a(O[U],H[U],R);if(A!==0)return A}}e.comparePaths=g;function m(l,v,R){const O=l.toLowerCase(),H=v.toLowerCase(),ne=_(l,v,R);if(ne)return ne;const ie=O.endsWith(R),N=H.endsWith(R);if(ie!==N)return ie?-1:1;const B=C(O,H);return B!==0?B:O.localeCompare(H)}e.compareAnything=m;function _(l,v,R){const O=l.toLowerCase(),H=v.toLowerCase(),ne=O.startsWith(R),ie=H.startsWith(R);if(ne!==ie)return ne?-1:1;if(ne&&ie){if(O.length<H.length)return-1;if(O.length>H.length)return 1}return 0}e.compareByPrefix=_}),define(me[99],ge([0,1,98,96,9,10,8]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,D=[C,[]];function k(N,B,U,A){if(!N||!B)return D;const x=N.length,F=B.length;if(x<F)return D;const M=N.toLowerCase();return!A&&!M.includes(U)?D:i(B,U,F,N,M,x)}e.scoreFuzzy=k;function i(N,B,U,A,x,F){const M=[],W=[];for(let ve=0;ve<U;ve++){const Te=ve*F,ye=Te-F,Oe=ve>0,j=N[ve],Q=B[ve];for(let Z=0;Z<F;Z++){const se=Z>0,fe=Te+Z,_e=fe-1,xe=ye+Z-1,pe=se?M[_e]:0,ke=Oe&&se?M[xe]:0,Fe=Oe&&se?W[xe]:0;let He;!ke&&Oe?He=0:He=P(j,Q,A,x,Z,Fe),He&&ke+He>=pe?(W[fe]=Fe+1,M[fe]=ke+He):(W[fe]=C,M[fe]=pe)}}const z=[];let Y=U-1,le=F-1;for(;Y>=0&&le>=0;){const ve=Y*F+le;W[ve]===C||(z.push(le),Y--),le--}return[M[U*F-1],z.reverse()]}function P(N,B,U,A,x,F){let M=0;if(!h(B,A[x]))return M;if(M+=1,F>0&&(M+=F*5),N===U[x]&&(M+=1),x===0)M+=8;else{const W=p(U.charCodeAt(x-1));W?M+=W:(0,L.isUpper)(U.charCodeAt(x))&&(M+=2)}return M}function h(N,B){return N===B?!0:N==="/"||N==="\\"?B==="/"||B==="\\":!1}function p(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const o=[void 0,[]];function d(N,B,U=0,A=0){const x=B;return x.values&&x.values.length>1?E(N,x.values,U,A):w(N,B,U,A)}e.scoreFuzzy2=d;function E(N,B,U,A){let x=0;const F=[];for(const M of B){const[W,z]=w(N,M,U,A);if(typeof W!="number")return o;x+=W,F.push(...z)}return[x,g(F)]}function w(N,B,U,A){const x=(0,L.fuzzyScore)(B.original,B.originalLowercase,U,N,N.toLowerCase(),A,!0);return x?[x[0],(0,L.createMatches)(x)]:o}const S=Object.freeze({score:0}),u=1<<18,c=1<<17,f=1<<16;function t(N,B,U,A,x){if(!N||!B.normalized)return S;const F=A.getItemLabel(N);if(!F)return S;const M=A.getItemDescription(N);let W;M?W=`${F}${M}${B.normalized}${Array.isArray(B.values)?B.values.length:""}${U}`:W=`${F}${B.normalized}${Array.isArray(B.values)?B.values.length:""}${U}`;const z=x[W];if(z)return z;const Y=n(F,M,A.getItemPath(N),B,U);return x[W]=Y,Y}e.scoreItemFuzzy=t;function n(N,B,U,A,x){const F=!U||!A.containsPathSeparator;return U&&(T.isLinux?A.pathNormalized===U:(0,y.equalsIgnoreCase)(A.pathNormalized,U))?{score:u,labelMatch:[{start:0,end:N.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:A.values&&A.values.length>1?s(N,B,U,A.values,F,x):r(N,B,U,A,F,x)}function s(N,B,U,A,x,F){let M=0;const W=[],z=[];for(const Y of A){const{score:le,labelMatch:ve,descriptionMatch:Te}=r(N,B,U,Y,x,F);if(le===C)return S;M+=le,ve&&W.push(...ve),Te&&z.push(...Te)}return{score:M,labelMatch:g(W),descriptionMatch:g(z)}}function r(N,B,U,A,x,F){if(x||!B){const[M,W]=k(N,A.normalized,A.normalizedLowercase,F);if(M){const z=(0,L.matchesPrefix)(A.normalized,N);let Y;return z?(Y=c,Y+=Math.round(A.normalized.length/N.length*100)):Y=f,{score:Y+M,labelMatch:z||a(W)}}}if(B){let M=B;U&&(M=`${B}${I.sep}`);const W=M.length,z=`${M}${N}`,[Y,le]=k(z,A.normalized,A.normalizedLowercase,F);if(Y){const ve=a(le),Te=[],ye=[];return ve.forEach(Oe=>{Oe.start<W&&Oe.end>W?(Te.push({start:0,end:Oe.end-W}),ye.push({start:Oe.start,end:W})):Oe.start>=W?Te.push({start:Oe.start-W,end:Oe.end-W}):ye.push(Oe)}),{score:Y,labelMatch:Te,descriptionMatch:ye}}}return S}function a(N){const B=[];if(!N)return B;let U;for(const A of N)U&&U.end===A?U.end+=1:(U={start:A,end:A+1},B.push(U));return B}function g(N){const B=N.sort((x,F)=>x.start-F.start),U=[];let A;for(const x of B)!A||!m(A,x)?(A=x,U.push(x)):(A.start=Math.min(A.start,x.start),A.end=Math.max(A.end,x.end));return U}function m(N,B){return!(N.end<B.start||B.end<N.start)}function _(N,B,U,A,x,F){const M=t(N,U,A,x,F),W=t(B,U,A,x,F),z=M.score,Y=W.score;if((z===u||Y===u)&&z!==Y)return z===u?-1:1;if(z>f||Y>f){if(z!==Y)return z>Y?-1:1;if(z<c&&Y<c){const Q=v(M.labelMatch,W.labelMatch);if(Q!==0)return Q}const Oe=x.getItemLabel(N)||"",j=x.getItemLabel(B)||"";if(Oe.length!==j.length)return Oe.length-j.length}if(z!==Y)return z>Y?-1:1;const le=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,ve=Array.isArray(W.labelMatch)&&W.labelMatch.length>0;if(le&&!ve)return-1;if(ve&&!le)return 1;const Te=l(N,M,x),ye=l(B,W,x);return Te&&ye&&Te!==ye?ye>Te?-1:1:R(N,B,U,x)}e.compareItemsByFuzzyScore=_;function l(N,B,U){let A=-1,x=-1;if(B.descriptionMatch&&B.descriptionMatch.length?A=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(A=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(x=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const F=U.getItemDescription(N);F&&(x+=F.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(x=B.descriptionMatch[B.descriptionMatch.length-1].end);return x-A}function v(N,B){if(!N&&!B||(!N||!N.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!N||!N.length)return 1;const U=N[0].start,x=N[N.length-1].end-U,F=B[0].start,W=B[B.length-1].end-F;return x===W?0:W<x?1:-1}function R(N,B,U,A){const x=A.getItemLabel(N)||"",F=A.getItemLabel(B)||"",M=A.getItemDescription(N),W=A.getItemDescription(B),z=x.length+(M?M.length:0),Y=F.length+(W?W.length:0);if(z!==Y)return z-Y;const le=A.getItemPath(N),ve=A.getItemPath(B);return le&&ve&&le.length!==ve.length?le.length-ve.length:x!==F?(0,b.compareAnything)(x,F,U.normalized):M&&W&&M!==W?(0,b.compareAnything)(M,W,U.normalized):le&&ve&&le!==ve?(0,b.compareAnything)(le,ve,U.normalized):0}const O=" ";function H(N){typeof N!="string"&&(N="");const B=N.toLowerCase(),{pathNormalized:U,normalized:A,normalizedLowercase:x}=ne(N),F=U.indexOf(I.sep)>=0;let M;const W=N.split(O);if(W.length>1)for(const z of W){const{pathNormalized:Y,normalized:le,normalizedLowercase:ve}=ne(z);le&&(M||(M=[]),M.push({original:z,originalLowercase:z.toLowerCase(),pathNormalized:Y,normalized:le,normalizedLowercase:ve}))}return{original:N,originalLowercase:B,pathNormalized:U,normalized:A,normalizedLowercase:x,values:M,containsPathSeparator:F}}e.prepareQuery=H;function ne(N){let B;T.isWindows?B=N.replace(/\//g,I.sep):B=N.replace(/\\/g,I.sep);const U=(0,y.stripWildcards)(B).replace(/\s/g,"");return{pathNormalized:B,normalized:U,normalizedLowercase:U.toLowerCase()}}function ie(N){return Array.isArray(N)?H(N.map(B=>B.original).join(O)):H(N.original)}e.pieceToQuery=ie}),define(me[32],ge([0,1,8,29,9,22,13]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const D="**",k="/",i="[/\\\\]",P="[^/\\\\]",h=/\//g;function p(M){switch(M){case 0:return"";case 1:return`${P}*?`;default:return`(?:${i}|${P}+${i}|${i}${P}+)*?`}}function o(M,W){if(!M)return[];const z=[];let Y=!1,le=!1,ve="";for(const Te of M){switch(Te){case W:if(!Y&&!le){z.push(ve),ve="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":le=!0;break;case"]":le=!1;break}ve+=Te}return ve&&z.push(ve),z}e.splitGlobAware=o;function d(M){if(!M)return"";let W="";const z=o(M,k);if(z.every(Y=>Y===D))W=".*";else{let Y=!1;z.forEach((le,ve)=>{if(le===D){Y||(W+=p(2),Y=!0);return}let Te=!1,ye="",Oe=!1,j="";for(const Q of le){if(Q!=="}"&&Te){ye+=Q;continue}if(Oe&&(Q!=="]"||!j)){let Z;Q==="-"?Z=Q:(Q==="^"||Q==="!")&&!j?Z="^":Q===k?Z="":Z=b.escapeRegExpCharacters(Q),j+=Z;continue}switch(Q){case"{":Te=!0;continue;case"[":Oe=!0;continue;case"}":W+=`(?:${o(ye,",").map(fe=>d(fe)).join("|")})`,Te=!1,ye="";break;case"]":W+="["+j+"]",Oe=!1,j="";break;case"?":W+=P;continue;case"*":W+=p(1);continue;default:W+=b.escapeRegExpCharacters(Q)}}ve<z.length-1&&(z[ve+1]!==D||ve+2<z.length)&&(W+=i),Y=!1})}return W}const E=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},s=function(){return null};function r(M,W){if(!M)return s;let z;typeof M!="string"?z=M.pattern:z=M,z=z.trim();const Y=`${z}_${!!W.trimForExclusions}`;let le=t.get(Y);if(le)return a(le,M);let ve;if(E.test(z)){const Te=z.substr(4);le=function(ye,Oe){return typeof ye=="string"&&ye.endsWith(Te)?z:null}}else(ve=w.exec(g(z,W)))?le=m(ve[1],z):(W.trimForExclusions?u:S).test(z)?le=_(z,W):(ve=c.exec(g(z,W)))?le=l(ve[1].substr(1),z,!0):(ve=f.exec(g(z,W)))?le=l(ve[1],z,!1):le=v(z);return t.set(Y,le),a(le,M)}function a(M,W){return typeof W=="string"?M:function(z,Y){return L.isEqualOrParent(z,W.base)?M(I.relative(W.base,z),Y):null}}function g(M,W){return W.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function m(M,W){const z=`/${M}`,Y=`\\${M}`,le=function(Te,ye){return typeof Te!="string"?null:ye?ye===M?W:null:Te===M||Te.endsWith(z)||Te.endsWith(Y)?W:null},ve=[M];return le.basenames=ve,le.patterns=[W],le.allBasenames=ve,le}function _(M,W){const z=F(M.slice(1,-1).split(",").map(ye=>r(ye,W)).filter(ye=>ye!==s),M),Y=z.length;if(!Y)return s;if(Y===1)return z[0];const le=function(ye,Oe){for(let j=0,Q=z.length;j<Q;j++)if(z[j](ye,Oe))return M;return null},ve=z.find(ye=>!!ye.allBasenames);ve&&(le.allBasenames=ve.allBasenames);const Te=z.reduce((ye,Oe)=>Oe.allPaths?ye.concat(Oe.allPaths):ye,[]);return Te.length&&(le.allPaths=Te),le}function l(M,W,z){const Y=I.sep===I.posix.sep,le=Y?M:M.replace(h,I.sep),ve=I.sep+le,Te=I.posix.sep+M,ye=z?function(Oe,j){return typeof Oe=="string"&&(Oe===le||Oe.endsWith(ve)||!Y&&(Oe===M||Oe.endsWith(Te)))?W:null}:function(Oe,j){return typeof Oe=="string"&&(Oe===le||!Y&&Oe===M)?W:null};return ye.allPaths=[(z?"*/":"./")+M],ye}function v(M){try{const W=new RegExp(`^${d(M)}$`);return function(z){return W.lastIndex=0,typeof z=="string"&&W.test(z)?M:null}}catch(W){return s}}function R(M,W,z){return!M||typeof W!="string"?!1:O(M)(W,void 0,z)}e.match=R;function O(M,W={}){if(!M)return n;if(typeof M=="string"||N(M)){const z=r(M,W);if(z===s)return n;const Y=function(le,ve){return!!z(le,ve)};return z.allBasenames&&(Y.allBasenames=z.allBasenames),z.allPaths&&(Y.allPaths=z.allPaths),Y}return A(M,W)}e.parse=O;function H(M){if(!!M){let W;return z=>(W||(W=(M()||Promise.resolve([])).then(Y=>Y?ie(Y):{})),W.then(Y=>!!Y[z]))}}e.hasSiblingPromiseFn=H;function ne(M){if(!!M){let W;return z=>{if(!W){const Y=M();W=Y?ie(Y):{}}return!!W[z]}}}e.hasSiblingFn=ne;function ie(M){const W={};for(const z of M)W[z]=!0;return W}function N(M){const W=M;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=N;function B(M){return M.allBasenames||[]}e.getBasenameTerms=B;function U(M){return M.allPaths||[]}e.getPathTerms=U;function A(M,W){const z=F(Object.getOwnPropertyNames(M).map(ye=>x(ye,M[ye],W)).filter(ye=>ye!==s)),Y=z.length;if(!Y)return s;if(!z.some(ye=>!!ye.requiresSiblings)){if(Y===1)return z[0];const ye=function(Q,Z){for(let se=0,fe=z.length;se<fe;se++){const _e=z[se](Q,Z);if(_e)return _e}return null},Oe=z.find(Q=>!!Q.allBasenames);Oe&&(ye.allBasenames=Oe.allBasenames);const j=z.reduce((Q,Z)=>Z.allPaths?Q.concat(Z.allPaths):Q,[]);return j.length&&(ye.allPaths=j),ye}const le=function(ye,Oe,j){let Q;for(let Z=0,se=z.length;Z<se;Z++){const fe=z[Z];fe.requiresSiblings&&j&&(Oe||(Oe=I.basename(ye)),Q||(Q=Oe.substr(0,Oe.length-I.extname(ye).length)));const _e=fe(ye,Oe,Q,j);if(_e)return _e}return null},ve=z.find(ye=>!!ye.allBasenames);ve&&(le.allBasenames=ve.allBasenames);const Te=z.reduce((ye,Oe)=>Oe.allPaths?ye.concat(Oe.allPaths):ye,[]);return Te.length&&(le.allPaths=Te),le}function x(M,W,z){if(W===!1)return s;const Y=r(M,z);if(Y===s)return s;if(typeof W=="boolean")return Y;if(W){const le=W.when;if(typeof le=="string"){const ve=(Te,ye,Oe,j)=>{if(!j||!Y(Te,ye))return null;const Q=le.replace("$(basename)",Oe),Z=j(Q);return(0,y.isThenable)(Z)?Z.then(se=>se?M:null):Z?M:null};return ve.requiresSiblings=!0,ve}}return Y}function F(M,W){const z=M.filter(ye=>!!ye.basenames);if(z.length<2)return M;const Y=z.reduce((ye,Oe)=>{const j=Oe.basenames;return j?ye.concat(j):ye},[]);let le;if(W){le=[];for(let ye=0,Oe=Y.length;ye<Oe;ye++)le.push(W)}else le=z.reduce((ye,Oe)=>{const j=Oe.patterns;return j?ye.concat(j):ye},[]);const ve=function(ye,Oe){if(typeof ye!="string")return null;if(!Oe){let Q;for(Q=ye.length;Q>0;Q--){const Z=ye.charCodeAt(Q-1);if(Z===47||Z===92)break}Oe=ye.substr(Q)}const j=Y.indexOf(Oe);return j!==-1?le[j]:null};ve.basenames=Y,ve.patterns=le,ve.allBasenames=Y;const Te=M.filter(ye=>!ye.basenames);return Te.push(ve),Te}}),define(me[77],ge([0,1,2,9,8,12,10,25,29]),function(G,e,b,L,I,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(r,a,g){if(typeof r=="string"&&(r=b.URI.file(r)),g){const _=g.getWorkspaceFolder(r);if(_){const l=g.getWorkspace().folders.length>1;let v;if((0,C.isEqual)(_.uri,r)?v="":v=(0,C.relativePath)(_.uri,r),l){const R=_.name?_.name:(0,C.basename)(_.uri);v=v?R+" \u2022 "+v:R}return v}}if(r.scheme!==T.Schemas.file&&r.scheme!==T.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(r.fsPath))return(0,L.normalize)(P(r.fsPath));let m=(0,L.normalize)(r.fsPath);return!y.isWindows&&(a==null?void 0:a.userHome)&&(m=p(m,a.userHome.fsPath)),m}e.getPathLabel=k;function i(r){if(!!r){typeof r=="string"&&(r=b.URI.file(r));const a=(0,C.basename)(r)||(r.scheme===T.Schemas.file?r.fsPath:r.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(a)?P(a):a}}e.getBaseLabel=i;function P(r){return(0,D.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=P;let h=Object.create(null);function p(r,a){if(y.isWindows||!r||!a)return r;let g=h.original===a?h.normalized:void 0;return g||(g=`${(0,I.rtrim)(a,L.posix.sep)}${L.posix.sep}`,h={original:a,normalized:g}),(y.isLinux?r.startsWith(g):(0,I.startsWithIgnoreCase)(r,g))&&(r=`~/${r.substr(g.length)}`),r}e.tildify=p;function o(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=o;const d="\u2026",E="\\\\",w="~";function S(r,a=L.sep){const g=new Array(r.length);let m=!1;for(let _=0;_<r.length;_++){let l=r[_];if(l===""){g[_]=`.${a}`;continue}if(!l){g[_]=l;continue}m=!0;let v="";l.indexOf(E)===0?(v=l.substr(0,l.indexOf(E)+E.length),l=l.substr(l.indexOf(E)+E.length)):l.indexOf(a)===0?(v=l.substr(0,l.indexOf(a)+a.length),l=l.substr(l.indexOf(a)+a.length)):l.indexOf(w)===0&&(v=l.substr(0,l.indexOf(w)+w.length),l=l.substr(l.indexOf(w)+w.length));const R=l.split(a);for(let O=1;m&&O<=R.length;O++)for(let H=R.length-O;m&&H>=0;H--){m=!1;let ne=R.slice(H,H+O).join(a);for(let ie=0;!m&&ie<r.length;ie++)if(ie!==_&&r[ie]&&r[ie].indexOf(ne)>-1){const N=H+O===R.length,B=H>0&&r[ie].indexOf(a)>-1?a+ne:ne,U=r[ie].endsWith(B);m=!N||U}if(!m){let ie="";(R[0].endsWith(":")||v!=="")&&(H===1&&(H=0,O++,ne=R[0]+a+ne),H>0&&(ie=R[0]+a),ie=v+ie),H>0&&(ie=ie+d+a),ie=ie+ne,H+O<R.length&&(ie=ie+a+d),g[_]=ie}}m&&(g[_]=l)}return g}e.shorten=S;var u;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function c(r,a=Object.create(null)){const g=[];let m=!1,_="";for(const l of r)if(l==="$"||m&&l==="{")_&&g.push({value:_,type:u.TEXT}),_="",m=!0;else if(l==="}"&&m){const v=a[_];if(typeof v=="string")v.length&&g.push({value:v,type:u.VARIABLE});else if(v){const R=g[g.length-1];(!R||R.type!==u.SEPARATOR)&&g.push({value:v.label,type:u.SEPARATOR})}_="",m=!1}else _+=l;return _&&!m&&g.push({value:_,type:u.TEXT}),g.filter((l,v)=>{if(l.type===u.SEPARATOR){const R=g[v-1],O=g[v+1];return[R,O].every(H=>H&&(H.type===u.VARIABLE||H.type===u.TEXT)&&H.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=c;function f(r,a){return y.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):r.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function t(r,a){return y.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):y.isWindows?r.replace(/&&|&/g,g=>g==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(r){const a=r.indexOf("/")!==-1?L.posix:L.win32,g=a.basename(r),m=a.dirname(r);return g.length?{name:g,parentPath:m}:{name:m,parentPath:""}}e.splitName=s}),define(me[100],ge([0,1,2]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class I{constructor(P){this._uriTransformer=P}transformIncoming(P){const h=this._uriTransformer.transformIncoming(P);return h===P?P:L(b.URI.from(h))}transformOutgoing(P){const h=this._uriTransformer.transformOutgoing(P);return h===P?P:L(b.URI.from(h))}transformOutgoingURI(P){const h=this._uriTransformer.transformOutgoing(P);return h===P?P:b.URI.from(h)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,P,h){if(!i||h>200)return null;if(typeof i=="object"){if(i instanceof b.URI)return P.transformOutgoing(i);for(let p in i)if(Object.hasOwnProperty.call(i,p)){const o=T(i[p],P,h+1);o!==null&&(i[p]=o)}}return null}function y(i,P){const h=T(i,P,0);return h===null?i:h}e.transformOutgoingURIs=y;function C(i,P,h,p){if(!i||p>200)return null;if(typeof i=="object"){if(i.$mid===1)return h?b.URI.revive(P.transformIncoming(i)):P.transformIncoming(i);for(let o in i)if(Object.hasOwnProperty.call(i,o)){const d=C(i[o],P,h,p+1);d!==null&&(i[o]=d)}}return null}function D(i,P){const h=C(i,P,!1,0);return h===null?i:h}e.transformIncomingURIs=D;function k(i,P){const h=C(i,P,!0,0);return h===null?i:h}e.transformAndReviveIncomingURIs=k}),define(me[30],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(D){return b.test(D)}e.isUUID=L;const I=new Uint8Array(16),T=[];for(let D=0;D<256;D++)T.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let k=0;k<D.length;k++)D[k]=Math.floor(Math.random()*256);return D};function C(){y(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let D=0,k="";return k+=T[I[D++]],k+=T[I[D++]],k+=T[I[D++]],k+=T[I[D++]],k+="-",k+=T[I[D++]],k+=T[I[D++]],k+="-",k+=T[I[D++]],k+=T[I[D++]],k+="-",k+=T[I[D++]],k+=T[I[D++]],k+="-",k+=T[I[D++]],k+=T[I[D++]],k+=T[I[D++]],k+=T[I[D++]],k+=T[I[D++]],k+=T[I[D++]],k}e.generateUuid=C}),define(me[137],ge([0,1,101]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(T="utf8"){this.stringDecoder=new b.StringDecoder(T),this.remaining=null}write(T){const y=[],C=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(C.length<1)return y;let D=0,k,i=D;for(;i<C.length;)if(k=C.charCodeAt(i),k===13||k===10){if(y.push(C.substring(D,i)),i++,i<C.length){const P=k;k=C.charCodeAt(i),(P===13&&k===10||P===10&&k===13)&&i++}D=i}else i++;return this.remaining=D<C.length?C.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=L}),define(me[28],ge([0,1,37,102,9,13,10,29,30,76,25,2]),function(G,e,b,L,I,T,y,C,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var h;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(h=e.RimRafMode||(e.RimRafMode={}));async function p(B,U=h.UNLINK){if((0,C.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return U===h.UNLINK?d(B):o(B)}e.rimraf=p;async function o(B){try{const U=(0,I.join)((0,L.tmpdir)(),(0,D.generateUuid)());try{await b.promises.rename(B,U)}catch(A){return d(B)}d(U).catch(A=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function d(B){return b.promises.rmdir(B,{recursive:!0,maxRetries:3})}function E(B){if((0,C.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");b.rmdirSync(B,{recursive:!0})}e.rimrafSync=E;async function w(B,U){return c(await(U?S(B):b.promises.readdir(B)))}e.readdir=w;async function S(B){try{return await b.promises.readdir(B,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const U=[],A=await w(B);for(const x of A){let F=!1,M=!1,W=!1;try{const z=await b.promises.lstat((0,I.join)(B,x));F=z.isFile(),M=z.isDirectory(),W=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}U.push({name:x,isFile:()=>F,isDirectory:()=>M,isSymbolicLink:()=>W})}return U}function u(B){return c(b.readdirSync(B))}e.readdirSync=u;function c(B){return B.map(U=>typeof U=="string"?y.isMacintosh?(0,k.normalizeNFC)(U):U:(U.name=y.isMacintosh?(0,k.normalizeNFC)(U.name):U.name,U))}async function f(B){const U=await w(B),A=[];for(const x of U)await n.existsDirectory((0,I.join)(B,x))&&A.push(x);return A}e.readDirsInDir=f;function t(B,U=1e3){return new Promise(A=>{let x=!1;const F=setInterval(()=>{x||(x=!0,b.access(B,M=>{x=!1,M&&(clearInterval(F),A(void 0))}))},U)})}e.whenDeleted=t;var n;(function(B){async function U(F){let M;try{if(M=await b.promises.lstat(F),!M.isSymbolicLink())return{stat:M}}catch(W){}try{return{stat:await b.promises.stat(F),symbolicLink:(M==null?void 0:M.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(y.isWindows&&W.code==="EACCES")try{return{stat:await b.promises.stat(await b.promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw z}throw W}}B.stat=U;async function A(F){try{const{stat:M,symbolicLink:W}=await B.stat(F);return M.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(M){}return!1}B.existsFile=A;async function x(F){try{const{stat:M,symbolicLink:W}=await B.stat(F);return M.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(M){}return!1}B.existsDirectory=x})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new T.ResourceQueue;function r(B,U,A){return s.queueFor(P.URI.file(B),i.extUriBiasedIgnorePathCase).queue(()=>{const x=_(A);return new Promise((F,M)=>g(B,U,x,W=>W?M(W):F()))})}e.writeFile=r;let a=!0;function g(B,U,A,x){if(!a)return b.writeFile(B,U,{mode:A.mode,flag:A.flag},x);b.open(B,A.flag,A.mode,(F,M)=>{if(F)return x(F);b.writeFile(M,U,W=>{if(W)return b.close(M,()=>x(W));b.fdatasync(M,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),a=!1),b.close(M,Y=>x(Y))))})})}function m(B,U,A){const x=_(A);if(!a)return b.writeFileSync(B,U,{mode:x.mode,flag:x.flag});const F=b.openSync(B,x.flag,x.mode);try{b.writeFileSync(F,U);try{b.fdatasyncSync(F)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),a=!1}}finally{b.closeSync(F)}}e.writeFileSync=m;function _(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function l(B,U){if(B!==U){async function A(x){try{const F=await b.promises.lstat(x);if(F.isDirectory()||F.isSymbolicLink())return;const M=await b.promises.open(x,"a");try{await M.utimes(F.atime,new Date)}finally{await M.close()}}catch(F){}}try{await b.promises.rename(B,U),await A(U)}catch(x){if(B.toLowerCase()!==U.toLowerCase()&&x.code==="EXDEV"||B.endsWith("."))await v(B,U,{preserveSymlinks:!1}),await p(B,h.MOVE),await A(U);else throw x}}}e.move=l;async function v(B,U,A){return O(B,U,{root:{source:B,target:U},options:A,handledSourcePaths:new Set})}e.copy=v;const R=511;async function O(B,U,A){if(!A.handledSourcePaths.has(B)){A.handledSourcePaths.add(B);const{stat:x,symbolicLink:F}=await n.stat(B);if(F){if(A.options.preserveSymlinks)try{return await ie(B,U,A)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(F.dangling)return}return x.isDirectory()?H(B,U,x.mode&R,A):ne(B,U,x.mode&R)}}async function H(B,U,A,x){await b.promises.mkdir(U,{recursive:!0,mode:A});const F=await w(B);for(const M of F)await O((0,I.join)(B,M),(0,I.join)(U,M),x)}async function ne(B,U,A){await b.promises.copyFile(B,U),await b.promises.chmod(U,A)}async function ie(B,U,A){let x=await b.promises.readlink(B);(0,C.isEqualOrParent)(x,A.root.source,!y.isLinux)&&(x=(0,I.join)(A.root.target,x.substr(A.root.source.length+1))),await b.promises.symlink(x,U)}async function N(B){try{return await b.promises.access(B),!0}catch(U){return!1}}e.exists=N}),define(me[103],ge([0,1,37,278,8,9,28]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function C(P){const h=(0,T.dirname)(P);if(P===h)return P;const p=((0,T.basename)(P)||P).toLowerCase();try{const d=(0,y.readdirSync)(h).filter(E=>E.toLowerCase()===p);if(d.length===1){const E=C(h);if(E)return(0,T.join)(E,d[0])}else if(d.length>1){const E=d.indexOf(p);if(E>=0){const w=C(h);if(w)return(0,T.join)(w,d[E])}}}catch(o){}return null}e.realcaseSync=C;async function D(P){try{return await(0,L.promisify)(b.realpath)(P)}catch(h){const p=i(P);return await b.promises.access(p,b.constants.R_OK),p}}e.realpath=D;function k(P){try{return b.realpathSync(P)}catch(h){const p=i(P);return b.accessSync(p,b.constants.R_OK),p}}e.realpathSync=k;function i(P){return(0,I.rtrim)((0,T.normalize)(P),T.sep)}});var qe=this&&this.__decorate||function(G,e,b,L){var I=arguments.length,T=I<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,b):L,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(G,e,b,L);else for(var C=G.length-1;C>=0;C--)(y=G[C])&&(T=(I<3?y(T):I>3?y(e,b,T):y(e,b))||T);return I>3&&T&&Object.defineProperty(e,b,T),T};define(me[104],ge([0,1,3,6,13,21,17,23,16,11,59,8,54]),function(G,e,b,L,I,T,y,C,D,k,i,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function o(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function E(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(w||(w={}));class S{constructor(M){this.buffer=M,this.pos=0}read(M){const W=this.buffer.slice(this.pos,this.pos+M);return this.pos+=W.byteLength,W}}class u{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var c;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(c||(c={}));function f(F){const M=C.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function t(F){return F.read(4).readUInt32BE(0)}function n(F){const M=C.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const s={Undefined:n(c.Undefined),String:n(c.String),Buffer:n(c.Buffer),VSBuffer:n(c.VSBuffer),Array:n(c.Array),Object:n(c.Object)},r=typeof Buffer!="undefined";function a(F,M){if(typeof M=="undefined")F.write(s.Undefined);else if(typeof M=="string"){const W=C.VSBuffer.fromString(M);F.write(s.String),F.write(f(W.byteLength)),F.write(W)}else if(r&&Buffer.isBuffer(M)){const W=C.VSBuffer.wrap(M);F.write(s.Buffer),F.write(f(W.byteLength)),F.write(W)}else if(M instanceof C.VSBuffer)F.write(s.VSBuffer),F.write(f(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(s.Array),F.write(f(M.length));for(const W of M)a(F,W)}else{const W=C.VSBuffer.fromString(JSON.stringify(M));F.write(s.Object),F.write(f(W.byteLength)),F.write(W)}}function g(F){switch(F.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return F.read(t(F)).toString();case c.Buffer:return F.read(t(F)).buffer;case c.VSBuffer:return F.read(t(F));case c.Array:{const W=t(F),z=[];for(let Y=0;Y<W;Y++)z.push(g(F));return z}case c.Object:return JSON.parse(F.read(t(F)).toString())}}class m{constructor(M,W,z=null,Y=1e3){this.protocol=M,this.ctx=W,this.logger=z,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(M,W){this.channels.set(M,W),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const W=this.send([M.type]);this.logger&&this.logger.logOutgoing(W,0,1,E(M.type));return}case 201:case 202:case 204:case 203:{const W=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(W,M.id,1,E(M.type),M.data);return}}}send(M,W=void 0){const z=new u;return a(z,M),a(z,W),this.sendBuffer(z.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(W){return 0}}onRawMessage(M){const W=new S(M),z=g(W),Y=g(W),le=z[0];switch(le){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,z[1],1,`${o(le)}: ${z[2]}.${z[3]}`,Y),this.onPromise({type:le,id:z[1],channelName:z[2],name:z[3],arg:Y});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,z[1],1,`${o(le)}: ${z[2]}.${z[3]}`,Y),this.onEventListen({type:le,id:z[1],channelName:z[2],name:z[3],arg:Y});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,z[1],1,`${o(le)}`),this.disposeActiveRequest({type:le,id:z[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,z[1],1,`${o(le)}`),this.disposeActiveRequest({type:le,id:z[1]})}}onPromise(M){const W=this.channels.get(M.channelName);if(!W){this.collectPendingRequest(M);return}const z=new T.CancellationTokenSource;let Y;try{Y=W.call(this.ctx,M.name,M.arg,z.token)}catch(Te){Y=Promise.reject(Te)}const le=M.id;Y.then(Te=>{this.sendResponse({id:le,data:Te,type:201}),this.activeRequests.delete(M.id)},Te=>{Te instanceof Error?this.sendResponse({id:le,data:{message:Te.message,name:Te.name,stack:Te.stack?Te.stack.split?Te.stack.split(`
`):Te.stack:void 0},type:202}):this.sendResponse({id:le,data:Te,type:203}),this.activeRequests.delete(M.id)});const ve=(0,L.toDisposable)(()=>z.cancel());this.activeRequests.set(M.id,ve)}onEventListen(M){const W=this.channels.get(M.channelName);if(!W){this.collectPendingRequest(M);return}const z=M.id,le=W.listen(this.ctx,M.name,M.arg)(ve=>this.sendResponse({id:z,data:ve,type:204}));this.activeRequests.set(M.id,le)}disposeActiveRequest(M){const W=this.activeRequests.get(M.id);W&&(W.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let W=this.pendingRequests.get(M.channelName);W||(W=[],this.pendingRequests.set(M.channelName,W));const z=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:M,timeoutTimer:z})}flushPendingRequests(M){const W=this.pendingRequests.get(M);if(W){for(const z of W)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var _;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(_=e.RequestInitiator||(e.RequestInitiator={}));class l{constructor(M,W=null){this.protocol=M,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=W}getChannel(M){const W=this;return{call(z,Y,le){return W.isDisposed?Promise.reject(y.canceled()):W.requestPromise(M,z,Y,le)},listen(z,Y){return W.isDisposed?Promise.reject(y.canceled()):W.requestEvent(M,z,Y)}}}requestPromise(M,W,z,Y=T.CancellationToken.None){const le=this.lastRequestId++,Te={id:le,type:100,channelName:M,name:W,arg:z};if(Y.isCancellationRequested)return Promise.reject(y.canceled());let ye;return new Promise((j,Q)=>{if(Y.isCancellationRequested)return Q(y.canceled());const Z=()=>{const xe=pe=>{switch(pe.type){case 201:this.handlers.delete(le),j(pe.data);break;case 202:this.handlers.delete(le);const ke=new Error(pe.data.message);ke.stack=pe.data.stack,ke.name=pe.data.name,Q(ke);break;case 203:this.handlers.delete(le),Q(pe.data);break}};this.handlers.set(le,xe),this.sendRequest(Te)};let se=null;this.state===w.Idle?Z():(se=(0,I.createCancelablePromise)(xe=>this.whenInitialized()),se.then(()=>{se=null,Z()}));const fe=()=>{se?(se.cancel(),se=null):this.sendRequest({id:le,type:101}),Q(y.canceled())},_e=Y.onCancellationRequested(fe);ye=(0,L.combinedDisposable)((0,L.toDisposable)(fe),_e),this.activeRequests.add(ye)}).finally(()=>{this.activeRequests.delete(ye)})}requestEvent(M,W,z){const Y=this.lastRequestId++,ve={id:Y,type:102,channelName:M,name:W,arg:z};let Te=null;const ye=new b.Emitter({onFirstListenerAdd:()=>{Te=(0,I.createCancelablePromise)(j=>this.whenInitialized()),Te.then(()=>{Te=null,this.activeRequests.add(ye),this.sendRequest(ve)})},onLastListenerRemove:()=>{Te?(Te.cancel(),Te=null):(this.activeRequests.delete(ye),this.sendRequest({id:Y,type:103}))}}),Oe=j=>ye.fire(j.data);return this.handlers.set(Y,Oe),ye.event}sendRequest(M){switch(M.type){case 100:case 102:{const W=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(W,M.id,0,`${o(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const W=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(W,M.id,0,o(M.type));return}}}send(M,W=void 0){const z=new u;return a(z,M),a(z,W),this.sendBuffer(z.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(W){return 0}}onBuffer(M){const W=new S(M),z=g(W),Y=g(W),le=z[0];switch(le){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,E(le)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,z[1],0,E(le),Y),this.onResponse({type:z[0],id:z[1],data:Y})}}onResponse(M){if(M.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(M.id);W&&W(M)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}qe([h.memoize],l.prototype,"onDidInitializePromise",null),e.ChannelClient=l;class v{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:W,onDidClientDisconnect:z})=>{b.Event.once(W.onMessage)(le=>{const ve=new S(le),Te=g(ve),ye=new m(W,Te),Oe=new l(W);this.channels.forEach((Q,Z)=>ye.registerChannel(Z,Q));const j={channelServer:ye,channelClient:Oe,ctx:Te};this._connections.add(j),this._onDidAddConnection.fire(j),z(()=>{ye.dispose(),Oe.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const M=[];return this._connections.forEach(W=>M.push(W)),M}getChannel(M,W){const z=this;return{call(Y,le,ve){let Te;if((0,k.isFunction)(W)){let Oe=(0,D.getRandomElement)(z.connections.filter(W));Te=Oe?Promise.resolve(Oe):b.Event.toPromise(b.Event.filter(z.onDidAddConnection,W))}else Te=W.routeCall(z,Y,le);const ye=Te.then(Oe=>Oe.channelClient.getChannel(M));return O(ye).call(Y,le,ve)},listen(Y,le){if((0,k.isFunction)(W))return z.getMulticastEvent(M,W,Y,le);const ve=W.routeEvent(z,Y,le).then(Te=>Te.channelClient.getChannel(M));return O(ve).listen(Y,le)}}}getMulticastEvent(M,W,z,Y){const le=this;let ve=new L.DisposableStore;const Te=new b.Emitter({onFirstListenerAdd:()=>{ve=new L.DisposableStore;const ye=new b.EventMultiplexer,Oe=new Map,j=Z=>{const fe=Z.channelClient.getChannel(M).listen(z,Y),_e=ye.add(fe);Oe.set(Z,_e)},Q=Z=>{const se=Oe.get(Z);!se||(se.dispose(),Oe.delete(Z))};le.connections.filter(W).forEach(j),b.Event.filter(le.onDidAddConnection,W)(j,void 0,ve),le.onDidRemoveConnection(Q,void 0,ve),ye.event(Te.fire,Te,ve),ve.add(ye)},onLastListenerRemove:()=>{ve.dispose()}});return Te.event}registerChannel(M,W){this.channels.set(M,W),this._connections.forEach(z=>{z.channelServer.registerChannel(M,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=v;class R{constructor(M,W,z=null){const Y=new u;a(Y,W),M.send(Y.buffer),this.channelClient=new l(M,z),this.channelServer=new m(M,W,z)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,W){this.channelServer.registerChannel(M,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function O(F){return{call(M,W,z){return F.then(Y=>Y.call(M,W,z))},listen(M,W){const z=new b.Relay;return F.then(Y=>z.input=Y.listen(M,W)),z.event}}}e.getDelayedChannel=O;function H(F){let M=!1;return{call(W,z,Y){return M?F.call(W,z,Y):(0,I.timeout)(0).then(()=>M=!0).then(()=>F.call(W,z,Y))},listen(W,z){if(M)return F.listen(W,z);const Y=new b.Relay;return(0,I.timeout)(0).then(()=>M=!0).then(()=>Y.input=F.listen(W,z)),Y.event}}}e.getNextTickChannel=H;class ne{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const W of M.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await b.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=ne;var ie;(function(F){function M(Y,le){const ve=Y,Te=le&&le.disableMarshalling,ye=new Map;for(const Oe in ve)z(Oe)&&ye.set(Oe,b.Event.buffer(ve[Oe],!0));return new class{listen(Oe,j){const Q=ye.get(j);if(Q)return Q;throw new Error(`Event not found: ${j}`)}call(Oe,j,Q){const Z=ve[j];if(typeof Z=="function"){if(!Te&&Array.isArray(Q))for(let se=0;se<Q.length;se++)Q[se]=(0,i.revive)(Q[se]);return Z.apply(ve,Q)}throw new Error(`Method not found: ${j}`)}}}F.fromService=M;function W(Y,le){const ve=le&&le.disableMarshalling;return new Proxy({},{get(Te,ye){var Oe;if(typeof ye=="string")return((Oe=le==null?void 0:le.properties)===null||Oe===void 0?void 0:Oe.has(ye))?le.properties.get(ye):z(ye)?Y.listen(ye):async function(...j){let Q;le&&!(0,k.isUndefinedOrNull)(le.context)?Q=[le.context,...j]:Q=j;const Z=await Y.call(ye,Q);return ve?Z:(0,i.revive)(Z)};throw new Error(`Property not found: ${String(ye)}`)}})}F.toService=W;function z(Y){return Y[0]==="o"&&Y[1]==="n"&&P.isUpperAsciiLetter(Y.charCodeAt(2))}})(ie=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function U(F){return Array.isArray(F)?F.map(B):B(F)}function A(F,M,W,z,Y,le,ve){ve=U(ve);const Te=N[Y],ye=Te[z%Te.length];let Oe=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(le)?(Oe=Oe.concat(ve),Oe.push(")")):Oe.push(ve),console.log.apply(console,Oe)}e.logWithColors=A;class x{constructor(M,W){this._outgoingPrefix=M,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,W,z,Y,le){this._totalOutgoing+=M,A(this._outgoingPrefix,this._totalOutgoing,M,W,z,Y,le)}logIncoming(M,W,z,Y,le){this._totalIncoming+=M,A(this._incomingPrefix,this._totalIncoming,M,W,z,Y,le)}}e.IPCLogger=x}),define(me[105],ge([0,1,3,104,6,23,10,36]),function(G,e,b,L,I,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function k(){return D||(D=T.VSBuffer.alloc(0)),D}class i{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,r){if(s===0)return k();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const _=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=s),_}if(this._chunks[0].byteLength>s){const _=this._chunks[0].slice(0,s);return r&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),_}let a=T.VSBuffer.alloc(s),g=0,m=0;for(;s>0;){const _=this._chunks[m];if(_.byteLength>s){const l=_.slice(0,s);a.set(l,g),g+=s,r&&(this._chunks[m]=_.slice(s),this._totalLength-=s),s-=s}else a.set(_,g),g+=_.byteLength,r?(this._chunks.shift(),this._totalLength-=_.byteLength):m++,s-=_.byteLength}return a}}e.ChunkStream=i;var P;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(P||(P={}));var h;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(s,r,a,g){this.type=s,this.id=r,this.ack=a,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class o extends I.Disposable{constructor(s){super();this._onMessage=this._register(new b.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new i,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const a=this._state.messageType,g=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new p(a,g,m,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=T.VSBuffer.alloc(13);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this._writeSoon(r,s.data)}}_bufferAdd(s,r){const a=this._totalLength===0;return this._data.push(s,r),this._totalLength+=s.byteLength+r.byteLength,a}_bufferTake(){const s=T.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,r){this._bufferAdd(s,r)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends I.Disposable{constructor(s){super();this._onMessage=new b.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new o(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new p(1,0,0,s))}}e.Protocol=E;class w extends L.IPCClient{constructor(s,r,a=null){super(s,r,a);this.protocol=s}static fromSocket(s,r){return new w(new E(s),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=w;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new b.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,C.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class u{constructor(s){this.data=s,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],r=0,a=this._first;for(;a;)s[r++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const r=new u(s);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class f{constructor(){this.lastRuns=[];const s=Date.now();for(let r=0;r<f._HISTORY_LENGTH;r++)this.lastRuns[r]=s-1e3*r;setInterval(()=>{for(let r=f._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return f._INSTANCE||(f._INSTANCE=new f),f._INSTANCE}load(){const s=Date.now(),r=(1+f._HISTORY_LENGTH)*1e3;let a=0;for(let g=0;g<f._HISTORY_LENGTH;g++)s-this.lastRuns[g]<=r&&a++;return 1-a/f._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}f._HISTORY_LENGTH=10,f._INSTANCE=null;class t{constructor(s,r=null){this._loadEstimator=f.getInstance(),this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new o(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new p(5,0,0,k());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const r=new p(4,0,0,k());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,r){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new o(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let r=0,a=s.length;r<a;r++)this._socketWriter.write(s[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new p(6,0,0,k())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const r=this._outgoingUnackMsg.toArray();for(let a=0,g=r.length;a<g;a++)this._socketWriter.write(r[a]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new p(1,r,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const r=new p(2,0,0,s);this._socketWriter.write(r)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),r=Date.now()-s.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,k());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(me[106],ge([0,1,95]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(C){let D=(0,b.toUint8)(C);this._defaultValue=D,this._asciiMap=L._createAsciiMap(D),this._map=new Map}static _createAsciiMap(C){let D=new Uint8Array(256);for(let k=0;k<256;k++)D[k]=C;return D}set(C,D){let k=(0,b.toUint8)(D);C>=0&&C<256?this._asciiMap[C]=k:this._map.set(C,k)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=L;var I;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(I||(I={}));class T{constructor(){this._actual=new L(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=T}),define(me[138],ge([0,1,106]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends b.CharacterClassifier{constructor(C){super(0);for(let D=0,k=C.length;D<k;D++)this.set(C.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function T(y){let C={};return D=>(C.hasOwnProperty(D)||(C[D]=y(D)),C[D])}e.getMapForWordSeparators=T(y=>new I(y))}),define(me[47],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(I,T){this.lineNumber=I,this.column=T}with(I=this.lineNumber,T=this.column){return I===this.lineNumber&&T===this.column?this:new b(I,T)}delta(I=0,T=0){return this.with(this.lineNumber+I,this.column+T)}equals(I){return b.equals(this,I)}static equals(I,T){return!I&&!T?!0:!!I&&!!T&&I.lineNumber===T.lineNumber&&I.column===T.column}isBefore(I){return b.isBefore(this,I)}static isBefore(I,T){return I.lineNumber<T.lineNumber?!0:T.lineNumber<I.lineNumber?!1:I.column<T.column}isBeforeOrEqual(I){return b.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,T){return I.lineNumber<T.lineNumber?!0:T.lineNumber<I.lineNumber?!1:I.column<=T.column}static compare(I,T){let y=I.lineNumber|0,C=T.lineNumber|0;if(y===C){let D=I.column|0,k=T.column|0;return D-k}return y-C}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new b(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=b}),define(me[43],ge([0,1,47]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(T,y,C,D){T>C||T===C&&y>D?(this.startLineNumber=C,this.startColumn=D,this.endLineNumber=T,this.endColumn=y):(this.startLineNumber=T,this.startColumn=y,this.endLineNumber=C,this.endColumn=D)}isEmpty(){return L.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return L.containsPosition(this,T)}static containsPosition(T,y){return!(y.lineNumber<T.startLineNumber||y.lineNumber>T.endLineNumber||y.lineNumber===T.startLineNumber&&y.column<T.startColumn||y.lineNumber===T.endLineNumber&&y.column>T.endColumn)}containsRange(T){return L.containsRange(this,T)}static containsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>T.endColumn)}strictContainsRange(T){return L.strictContainsRange(this,T)}static strictContainsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<=T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>=T.endColumn)}plusRange(T){return L.plusRange(this,T)}static plusRange(T,y){let C,D,k,i;return y.startLineNumber<T.startLineNumber?(C=y.startLineNumber,D=y.startColumn):y.startLineNumber===T.startLineNumber?(C=y.startLineNumber,D=Math.min(y.startColumn,T.startColumn)):(C=T.startLineNumber,D=T.startColumn),y.endLineNumber>T.endLineNumber?(k=y.endLineNumber,i=y.endColumn):y.endLineNumber===T.endLineNumber?(k=y.endLineNumber,i=Math.max(y.endColumn,T.endColumn)):(k=T.endLineNumber,i=T.endColumn),new L(C,D,k,i)}intersectRanges(T){return L.intersectRanges(this,T)}static intersectRanges(T,y){let C=T.startLineNumber,D=T.startColumn,k=T.endLineNumber,i=T.endColumn,P=y.startLineNumber,h=y.startColumn,p=y.endLineNumber,o=y.endColumn;return C<P?(C=P,D=h):C===P&&(D=Math.max(D,h)),k>p?(k=p,i=o):k===p&&(i=Math.min(i,o)),C>k||C===k&&D>i?null:new L(C,D,k,i)}equalsRange(T){return L.equalsRange(this,T)}static equalsRange(T,y){return!!T&&!!y&&T.startLineNumber===y.startLineNumber&&T.startColumn===y.startColumn&&T.endLineNumber===y.endLineNumber&&T.endColumn===y.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(T){return new b.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(T){return new b.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,y){return new L(this.startLineNumber,this.startColumn,T,y)}setStartPosition(T,y){return new L(T,y,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(T){return new L(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,y=T){return new L(T.lineNumber,T.column,y.lineNumber,y.column)}static lift(T){return T?new L(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn)}static areIntersecting(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,y){if(T&&y){const k=T.startLineNumber|0,i=y.startLineNumber|0;if(k===i){const P=T.startColumn|0,h=y.startColumn|0;if(P===h){const p=T.endLineNumber|0,o=y.endLineNumber|0;if(p===o){const d=T.endColumn|0,E=y.endColumn|0;return d-E}return p-o}return P-h}return k-i}return(T?1:0)-(y?1:0)}static compareRangesUsingEnds(T,y){return T.endLineNumber===y.endLineNumber?T.endColumn===y.endColumn?T.startLineNumber===y.startLineNumber?T.startColumn-y.startColumn:T.startLineNumber-y.startLineNumber:T.endColumn-y.endColumn:T.endLineNumber-y.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=L}),define(me[139],ge([0,1,47,43]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class T extends L.Range{constructor(C,D,k,i){super(C,D,k,i);this.selectionStartLineNumber=C,this.selectionStartColumn=D,this.positionLineNumber=k,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return T.selectionsEqual(this,C)}static selectionsEqual(C,D){return C.selectionStartLineNumber===D.selectionStartLineNumber&&C.selectionStartColumn===D.selectionStartColumn&&C.positionLineNumber===D.positionLineNumber&&C.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,D){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,C,D):new T(C,D,this.startLineNumber,this.startColumn)}getPosition(){return new b.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,D){return this.getDirection()===0?new T(C,D,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,C,D)}static fromPositions(C,D=C){return new T(C.lineNumber,C.column,D.lineNumber,D.column)}static liftSelection(C){return new T(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,D){if(C&&!D||!C&&D)return!1;if(!C&&!D)return!0;if(C.length!==D.length)return!1;for(let k=0,i=C.length;k<i;k++)if(!this.selectionsEqual(C[k],D[k]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,D,k,i,P){return P===0?new T(C,D,k,i):new T(k,i,C,D)}}e.Selection=T}),define(me[107],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var b;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(b=e.OverviewRulerLane||(e.OverviewRulerLane={}));var L;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(L=e.MinimapPosition||(e.MinimapPosition={}));var I;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(I=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(d){this.tabSize=Math.max(1,d.tabSize|0),this.indentSize=d.tabSize|0,this.insertSpaces=Boolean(d.insertSpaces),this.defaultEOL=d.defaultEOL|0,this.trimAutoWhitespace=Boolean(d.trimAutoWhitespace)}equals(d){return this.tabSize===d.tabSize&&this.indentSize===d.indentSize&&this.insertSpaces===d.insertSpaces&&this.defaultEOL===d.defaultEOL&&this.trimAutoWhitespace===d.trimAutoWhitespace}createChangeEvent(d){return{tabSize:this.tabSize!==d.tabSize,indentSize:this.indentSize!==d.indentSize,insertSpaces:this.insertSpaces!==d.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==d.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class D{constructor(d,E){this.range=d,this.matches=E}}e.FindMatch=D;var k;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right"})(i=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var P;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class h{constructor(d,E,w,S,u,c){this.identifier=d,this.range=E,this.text=w,this.forceMoveMarkers=S,this.isAutoWhitespaceEdit=u,this._isTracked=c}}e.ValidAnnotatedEditOperation=h;class p{constructor(d,E,w){this.reverseEdits=d,this.changes=E,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=p}),define(me[140],ge([0,1,8,138,47,43,107]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class D{constructor(u,c,f,t){this.searchString=u,this.isRegex=c,this.matchCase=f,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=k(this.searchString):u=this.searchString.indexOf(`
`)>=0;let c=null;try{c=b.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let f=!this.isRegex&&!u;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new i(c,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=D;function k(S){if(!S||S.length===0)return!1;for(let u=0,c=S.length;u<c;u++)if(S.charCodeAt(u)===92){if(u++,u>=c)break;const t=S.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class i{constructor(u,c,f){this.regex=u,this.wordSeparators=c,this.simpleSearch=f}}e.SearchData=i;function P(S,u,c){if(!c)return new y.FindMatch(S,null);let f=[];for(let t=0,n=u.length;t<n;t++)f[t]=u[t];return new y.FindMatch(S,f)}e.createFindMatch=P;class h{constructor(u){let c=[],f=0;for(let t=0,n=u.length;t<n;t++)u.charCodeAt(t)===10&&(c[f++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(u){const c=this._lineFeedsOffsets;let f=0,t=c.length-1;if(t===-1||u<=c[0])return 0;for(;f<t;){const n=f+((t-f)/2>>0);c[n]>=u?t=n-1:c[n+1]>=u?(f=n,t=n):f=n+1}return f+1}}class p{static findMatches(u,c,f,t,n){const s=c.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(u,f,new w(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(u,f,s,t,n):[]}static _getMultilineMatchRange(u,c,f,t,n,s){let r,a=0;t?(a=t.findLineFeedCountBeforeOffset(n),r=c+n+a):r=c+n;let g;if(t){let v=t.findLineFeedCountBeforeOffset(n+s.length)-a;g=r+s.length+v}else g=r+s.length;const m=u.getPositionAt(r),_=u.getPositionAt(g);return new T.Range(m.lineNumber,m.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(u,c,f,t,n){const s=u.getOffsetAt(c.getStartPosition()),r=u.getValueInRange(c,1),a=u.getEOL()===`\r
`?new h(r):null,g=[];let m=0,_;for(f.reset(0);_=f.next(r);)if(g[m++]=P(this._getMultilineMatchRange(u,s,r,a,_.index,_[0]),_,t),m>=n)return g;return g}static _doFindMatchesLineByLine(u,c,f,t,n){const s=[];let r=0;if(c.startLineNumber===c.endLineNumber){const g=u.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return r=this._findMatchesInLine(f,g,c.startLineNumber,c.startColumn-1,r,s,t,n),s}const a=u.getLineContent(c.startLineNumber).substring(c.startColumn-1);r=this._findMatchesInLine(f,a,c.startLineNumber,c.startColumn-1,r,s,t,n);for(let g=c.startLineNumber+1;g<c.endLineNumber&&r<n;g++)r=this._findMatchesInLine(f,u.getLineContent(g),g,0,r,s,t,n);if(r<n){const g=u.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);r=this._findMatchesInLine(f,g,c.endLineNumber,0,r,s,t,n)}return s}static _findMatchesInLine(u,c,f,t,n,s,r,a){const g=u.wordSeparators;if(!r&&u.simpleSearch){const l=u.simpleSearch,v=l.length,R=c.length;let O=-v;for(;(O=c.indexOf(l,O+v))!==-1;)if((!g||E(g,c,R,O,v))&&(s[n++]=new y.FindMatch(new T.Range(f,O+1+t,f,O+1+v+t),null),n>=a))return n;return n}const m=new w(u.wordSeparators,u.regex);let _;m.reset(0);do if(_=m.next(c),_&&(s[n++]=P(new T.Range(f,_.index+1+t,f,_.index+1+_[0].length+t),_,r),n>=a))return n;while(_);return n}static findNextMatch(u,c,f,t){const n=c.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(u,f,s,t):this._doFindNextMatchLineByLine(u,f,s,t)}static _doFindNextMatchMultiline(u,c,f,t){const n=new I.Position(c.lineNumber,1),s=u.getOffsetAt(n),r=u.getLineCount(),a=u.getValueInRange(new T.Range(n.lineNumber,n.column,r,u.getLineMaxColumn(r)),1),g=u.getEOL()===`\r
`?new h(a):null;f.reset(c.column-1);let m=f.next(a);return m?P(this._getMultilineMatchRange(u,s,a,g,m.index,m[0]),m,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(u,new I.Position(1,1),f,t):null}static _doFindNextMatchLineByLine(u,c,f,t){const n=u.getLineCount(),s=c.lineNumber,r=u.getLineContent(s),a=this._findFirstMatchInLine(f,r,s,c.column,t);if(a)return a;for(let g=1;g<=n;g++){const m=(s+g-1)%n,_=u.getLineContent(m+1),l=this._findFirstMatchInLine(f,_,m+1,1,t);if(l)return l}return null}static _findFirstMatchInLine(u,c,f,t,n){u.reset(t-1);const s=u.next(c);return s?P(new T.Range(f,s.index+1,f,s.index+1+s[0].length),s,n):null}static findPreviousMatch(u,c,f,t){const n=c.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(u,f,s,t):this._doFindPreviousMatchLineByLine(u,f,s,t)}static _doFindPreviousMatchMultiline(u,c,f,t){const n=this._doFindMatchesMultiline(u,new T.Range(1,1,c.lineNumber,c.column),f,t,10*C);if(n.length>0)return n[n.length-1];const s=u.getLineCount();return c.lineNumber!==s||c.column!==u.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(u,new I.Position(s,u.getLineMaxColumn(s)),f,t):null}static _doFindPreviousMatchLineByLine(u,c,f,t){const n=u.getLineCount(),s=c.lineNumber,r=u.getLineContent(s).substring(0,c.column-1),a=this._findLastMatchInLine(f,r,s,t);if(a)return a;for(let g=1;g<=n;g++){const m=(n+s-g-1)%n,_=u.getLineContent(m+1),l=this._findLastMatchInLine(f,_,m+1,t);if(l)return l}return null}static _findLastMatchInLine(u,c,f,t){let n=null,s;for(u.reset(0);s=u.next(c);)n=P(new T.Range(f,s.index+1,f,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=p;function o(S,u,c,f,t){if(f===0)return!0;const n=u.charCodeAt(f-1);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=u.charCodeAt(f);if(S.get(s)!==0)return!0}return!1}function d(S,u,c,f,t){if(f+t===c)return!0;const n=u.charCodeAt(f+t);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=u.charCodeAt(f+t-1);if(S.get(s)!==0)return!0}return!1}function E(S,u,c,f,t){return o(S,u,c,f,t)&&d(S,u,c,f,t)}e.isValidMatch=E;class w{constructor(u,c){this._wordSeparators=u,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const c=u.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(f=this._searchRegex.exec(u),!f))return null;const t=f.index,n=f[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){b.getNextCodePoint(u,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||E(this._wordSeparators,u,c,t,n))return f}while(f);return null}}e.Searcher=w}),define(me[108],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function b(C=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)C.indexOf(k)>=0||(D+="\\"+k);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=b();function L(C){let D=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)D=C;else{let k="g";C.ignoreCase&&(k+="i"),C.multiline&&(k+="m"),C.unicode&&(k+="u"),D=new RegExp(C.source,k)}return D.lastIndex=0,D}e.ensureValidWordDefinition=L;const I={maxLen:1e3,windowSize:15,timeBudget:150};function T(C,D,k,i,P=I){if(k.length>P.maxLen){let E=C-P.maxLen/2;return E<0?E=0:i+=E,k=k.substring(E,C+P.maxLen/2),T(C,D,k,i,P)}const h=Date.now(),p=C-1-i;let o=-1,d=null;for(let E=1;!(Date.now()-h>=P.timeBudget);E++){const w=p-P.windowSize*E;D.lastIndex=Math.max(0,w);const S=y(D,k,p,o);if(!S&&d||(d=S,w<=0))break;o=w}if(d){let E={word:d[0],startColumn:i+1+d.index,endColumn:i+1+d.index+d[0].length};return D.lastIndex=0,E}return null}e.getWordAtText=T;function y(C,D,k,i){let P;for(;P=C.exec(D);){const h=P.index||0;if(h<=k&&C.lastIndex>=k)return P;if(i>0&&h>i)return null}return null}}),define(me[141],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var b;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(b=e.IndentAction||(e.IndentAction={}));class L{constructor(C){if(this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let D=0,k=C.notIn.length;D<k;D++)switch(C.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=L;class I{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of C)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=I;function T(y,C,D){y.has(C)?y.get(C).push(D):y.set(C,[D])}}),define(me[78],ge([0,1,32,9]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(T,y,C,D){if(Array.isArray(T)){let k=0;for(const i of T){const P=I(i,y,C,D);if(P===10)return P;P>k&&(k=P)}return k}else{if(typeof T=="string")return D?T==="*"?5:T===C?10:0:0;if(T){const{language:k,pattern:i,scheme:P,hasAccessToAllModels:h}=T;if(!D&&!h)return 0;let p=0;if(P)if(P===y.scheme)p=10;else if(P==="*")p=5;else return 0;if(k)if(k===C)p=10;else if(k==="*")p=Math.max(p,5);else return 0;if(i){let o;if(typeof i=="string"?o=i:o=Object.assign(Object.assign({},i),{base:(0,L.normalize)(i.base)}),o===y.fsPath||(0,b.match)(o,y.fsPath))p=10;else return 0}return p}else return 0}}e.score=I}),define(me[142],ge([0,1,106]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class I{constructor(o,d,E){const w=new Uint8Array(o*d);for(let S=0,u=o*d;S<u;S++)w[S]=E;this._data=w,this.rows=o,this.cols=d}get(o,d){return this._data[o*this.cols+d]}set(o,d,E){this._data[o*this.cols+d]=E}}e.Uint8Matrix=I;class T{constructor(o){let d=0,E=0;for(let S=0,u=o.length;S<u;S++){let[c,f,t]=o[S];f>d&&(d=f),c>E&&(E=c),t>E&&(E=t)}d++,E++;let w=new I(E,d,0);for(let S=0,u=o.length;S<u;S++){let[c,f,t]=o[S];w.set(c,f,t)}this._states=w,this._maxCharCode=d}nextState(o,d){return d<0||d>=this._maxCharCode?0:this._states.get(o,d)}}e.StateMachine=T;let y=null;function C(){return y===null&&(y=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let k=null;function i(){if(k===null){k=new b.CharacterClassifier(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<p.length;d++)k.set(p.charCodeAt(d),1);const o=".,;";for(let d=0;d<o.length;d++)k.set(o.charCodeAt(d),2)}return k}class P{static _createLink(o,d,E,w,S){let u=S-1;do{const c=d.charCodeAt(u);if(o.get(c)!==2)break;u--}while(u>w);if(w>0){const c=d.charCodeAt(w-1),f=d.charCodeAt(u);(c===40&&f===41||c===91&&f===93||c===123&&f===125)&&u--}return{range:{startLineNumber:E,startColumn:w+1,endLineNumber:E,endColumn:u+2},url:d.substring(w,u+1)}}static computeLinks(o,d=C()){const E=i();let w=[];for(let S=1,u=o.getLineCount();S<=u;S++){const c=o.getLineContent(S),f=c.length;let t=0,n=0,s=0,r=1,a=!1,g=!1,m=!1,_=!1;for(;t<f;){let l=!1;const v=c.charCodeAt(t);if(r===13){let R;switch(v){case 40:a=!0,R=0;break;case 41:R=a?0:1;break;case 91:m=!0,g=!0,R=0;break;case 93:m=!1,R=g?0:1;break;case 123:_=!0,R=0;break;case 125:R=_?0:1;break;case 39:R=s===34||s===96?0:1;break;case 34:R=s===39||s===96?0:1;break;case 96:R=s===39||s===34?0:1;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=m?0:1;break;default:R=E.get(v)}R===1&&(w.push(P._createLink(E,c,S,n,t)),l=!0)}else if(r===12){let R;v===91?(g=!0,R=0):R=E.get(v),R===1?l=!0:r=13}else r=d.nextState(r,v),r===0&&(l=!0);l&&(r=1,a=!1,g=!1,_=!1,n=t+1,s=v),t++}r===13&&w.push(P._createLink(E,c,S,n,f))}return w}}e.LinkComputer=P;function h(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:P.computeLinks(p)}e.computeLinks=h}),define(me[143],ge([0,1,3,6]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class I{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,C){return this._map.set(y,C),this.fire([y]),(0,L.toDisposable)(()=>{this._map.get(y)===C&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,C){let D=null,k=!1;return this._promises.set(y,C.then(i=>{this._promises.delete(y),!(k||!i)&&(D=this.register(y,i))})),(0,L.toDisposable)(()=>{k=!0,D&&D.dispose()})}getPromise(y){const C=this.get(y);if(C)return Promise.resolve(C);const D=this._promises.get(y);return D?D.then(k=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=I}),define(me[109],ge([0,1,23,10]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(I||(I={}));function T(P){for(let h=0,p=P.length;h<p;h+=4){const o=P[h+0],d=P[h+1],E=P[h+2],w=P[h+3];P[h+0]=w,P[h+1]=E,P[h+2]=d,P[h+3]=o}}function y(P){const h=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return L.isLittleEndian()||T(h),b.VSBuffer.wrap(h)}function C(P){const h=P.buffer;if(L.isLittleEndian()||T(h),h.byteOffset%4==0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const p=new Uint8Array(h.byteLength);return p.set(h),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function D(P){const h=new Uint32Array(k(P));let p=0;if(h[p++]=P.id,P.type==="full")h[p++]=1,h[p++]=P.data.length,h.set(P.data,p),p+=P.data.length;else{h[p++]=2,h[p++]=P.deltas.length;for(const o of P.deltas)h[p++]=o.start,h[p++]=o.deleteCount,o.data?(h[p++]=o.data.length,h.set(o.data,p),p+=o.data.length):h[p++]=0}return y(h)}e.encodeSemanticTokensDto=D;function k(P){let h=0;if(h+=1+1,P.type==="full")h+=1+P.data.length;else{h+=1,h+=(1+1+1)*P.deltas.length;for(const p of P.deltas)p.data&&(h+=p.data.length)}return h}function i(P){const h=C(P);let p=0;const o=h[p++];if(h[p++]===1){const S=h[p++],u=h.subarray(p,p+S);return p+=S,{id:o,type:"full",data:u}}const E=h[p++];let w=[];for(let S=0;S<E;S++){const u=h[p++],c=h[p++],f=h[p++];let t;f>0&&(t=h.subarray(p,p+f),p+=f),w[S]={start:u,deleteCount:c,data:t}}return{id:o,type:"delta",deltas:w}}e.decodeSemanticTokensDto=i}),define(me[110],ge([0,1,95]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(y,C){this.index=y,this.remainder=C}}e.PrefixSumIndexOfResult=L;class I{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,C){y=(0,b.toUint32)(y);const D=this.values,k=this.prefixSum,i=C.length;return i===0?!1:(this.values=new Uint32Array(D.length+i),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+i),this.values.set(C,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,C){return y=(0,b.toUint32)(y),C=(0,b.toUint32)(C),this.values[y]===C?!1:(this.values[y]=C,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,C){y=(0,b.toUint32)(y),C=(0,b.toUint32)(C);const D=this.values,k=this.prefixSum;if(y>=D.length)return!1;let i=D.length-y;return C>=i&&(C=i),C===0?!1:(this.values=new Uint32Array(D.length-C),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+C),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,b.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),y>=this.values.length&&(y=this.values.length-1);for(let D=C;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let C=0,D=this.values.length-1,k=0,i=0,P=0;for(;C<=D;)if(k=C+(D-C)/2|0,i=this.prefixSum[k],P=i-this.values[k],y<P)D=k-1;else if(y>=i)C=k+1;else break;return new L(k,y-P)}}e.PrefixSumComputer=I}),define(me[144],ge([0,1,8,47,110]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(C,D,k,i){this._uri=C,this._lines=D,this._eol=k,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const D=C.changes;for(const k of D)this._acceptDeleteRange(k.range),this._acceptInsertText(new L.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,D=this._lines.length,k=new Uint32Array(D);for(let i=0;i<D;i++)k[i]=this._lines[i].length+C;this._lineStarts=new I.PrefixSumComputer(k)}}_setLineText(C,D){this._lines[C]=D,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,D){if(D.length!==0){let k=(0,b.splitLines)(D);if(k.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}k[k.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]);let i=new Uint32Array(k.length-1);for(let P=1;P<k.length;P++)this._lines.splice(C.lineNumber+P-1,0,k[P]),i[P-1]=k[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,i)}}}e.MirrorTextModel=T}),define(me[145],ge([18,19]),function(G,e){return G.create("vs/base/common/date",e)}),define(me[146],ge([0,1,145]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,I=L*60,T=I*24,y=T*7,C=T*30,D=T*365;function k(P,h){typeof P!="number"&&(P=P.getTime());const p=Math.round((new Date().getTime()-P)/1e3);if(p<-30)return(0,b.localize)(0,null,k(new Date().getTime()+p*1e3,!1));if(p<30)return(0,b.localize)(1,null);let o;return p<L?(o=p,h?o===1?(0,b.localize)(2,null,o):(0,b.localize)(3,null,o):o===1?(0,b.localize)(4,null,o):(0,b.localize)(5,null,o)):p<I?(o=Math.floor(p/L),h?o===1?(0,b.localize)(6,null,o):(0,b.localize)(7,null,o):o===1?(0,b.localize)(8,null,o):(0,b.localize)(9,null,o)):p<T?(o=Math.floor(p/I),h?o===1?(0,b.localize)(10,null,o):(0,b.localize)(11,null,o):o===1?(0,b.localize)(12,null,o):(0,b.localize)(13,null,o)):p<y?(o=Math.floor(p/T),h?o===1?(0,b.localize)(14,null,o):(0,b.localize)(15,null,o):o===1?(0,b.localize)(16,null,o):(0,b.localize)(17,null,o)):p<C?(o=Math.floor(p/y),h?o===1?(0,b.localize)(18,null,o):(0,b.localize)(19,null,o):o===1?(0,b.localize)(20,null,o):(0,b.localize)(21,null,o)):p<D?(o=Math.floor(p/C),h?o===1?(0,b.localize)(22,null,o):(0,b.localize)(23,null,o):o===1?(0,b.localize)(24,null,o):(0,b.localize)(25,null,o)):(o=Math.floor(p/D),h?o===1?(0,b.localize)(26,null,o):(0,b.localize)(27,null,o):o===1?(0,b.localize)(28,null,o):(0,b.localize)(29,null,o))}e.fromNow=k;function i(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(me[147],ge([18,19]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(me[60],ge([0,1,147,11,16]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(k,i){return i&&(k.stack||k.stacktrace)?b.localize(0,null,C(k),y(k.stack)||y(k.stacktrace)):C(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function C(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?b.localize(1,null,k.message):k.message||b.localize(2,null)}function D(k=null,i=!1){if(!k)return b.localize(3,null);if(Array.isArray(k)){const P=I.coalesce(k),h=D(P[0],i);return P.length>1?b.localize(4,null,h,P.length):h}if(L.isString(k))return k;if(k.detail){const P=k.detail;if(P.error)return T(P.error,i);if(P.exception)return T(P.exception,i)}return k.stack?T(k,i):k.message?k.message:b.localize(5,null)}e.toErrorMessage=D}),define(me[148],ge([18,19]),function(G,e){return G.create("vs/base/node/processes",e)}),define(me[111],ge([0,1,9,37,28,38,148,36,11,24,29,10,137,12]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function o(f){switch(f){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(f,t){if(P.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const s=T.execFile("taskkill",["/T","/F","/PID",f.pid.toString()],n);return new Promise(r=>{s.once("error",a=>{r({success:!1,error:a})}),s.once("exit",(a,g)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?o(n.status):1})}else if(P.isLinux||P.isMacintosh)try{const n=p.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(s=>{T.execFile(n,[f.pid.toString()],{encoding:"utf8",shell:!0},(r,a,g)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else f.kill("SIGKILL");return Promise.resolve({success:!0})}function E(f=C.env){return f.comspec||"cmd.exe"}e.getWindowsShell=E;class w{constructor(t,n,s,r){if(n!==void 0&&s!==void 0&&r!==void 0)this.cmd=t,this.args=n,this.shell=s,this.options=r;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(C.env).forEach(g=>{a[g]=C.env[g]}),Object.keys(this.options.env).forEach(g=>{a[g]=this.options.env[g]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(b.sep);return n!==-1&&(t=t.substring(n+1)),w.WellKnowCommands[t]?t:"other"}start(t){return P.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(C.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(n=>{let s,r;const a=new Promise((g,m)=>{s=g,r=m});if(n){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=T.exec(g,this.options,(m,_,l)=>{this.childProcess=null;const v=m;v&&v.killed?r({killed:this.terminateRequested,stdout:_.toString(),stderr:l.toString()}):this.handleExec(s,t,m,_,l)})}else{let g=null;const m=_=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(_,s,t,r);const l={terminated:this.terminateRequested};D.isNumber(_)&&(l.cmdCode=_),s(l)};if(this.shell&&P.isWindows){const _=k.deepClone(this.options);_.windowsVerbatimArguments=!0,_.detached=!1;let l=!1,v=!1;const R=[];let O=this.ensureQuotes(this.cmd);R.push(O.value),l=O.quoted,this.args&&this.args.forEach(ne=>{O=this.ensureQuotes(ne),R.push(O.value),v=v&&O.quoted});const H=["/s","/c"];l?v?H.push('"'+R.join(" ")+'"'):R.length>1?H.push('"'+R[0]+'" '+R.slice(1).join(" ")):H.push('"'+R[0]+'"'):H.push(R.join(" ")),g=T.spawn(E(),H,_)}else this.cmd&&(g=T.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(D.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",_=>{this.childProcess=null,r({terminated:this.terminateRequested,error:_})}),g.pid&&(this.childProcess.on("close",m),this.handleSpawn(g,s,t,r,!0)))}return a})}handleClose(t,n,s,r){}ensureQuotes(t){return w.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,d(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!P.isWindows)return t(!1);const n=T.spawn(E(),["/s","/c"]);n.on("error",s=>t(!0)),n.on("exit",s=>t(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class S extends w{constructor(t,n,s,r){super(t,n,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,s,r,a){[r,a].forEach((g,m)=>{const _=new h.LineDecoder;_.write(g).forEach(R=>{n({line:R,source:m===0?0:1})});const v=_.end();v&&n({line:v,source:m===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,n,s,r,a){const g=new h.LineDecoder,m=new h.LineDecoder;t.stdout.on("data",_=>{g.write(_).forEach(v=>s({line:v,source:0}))}),t.stderr.on("data",_=>{m.write(_).forEach(v=>s({line:v,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=m}handleClose(t,n,s,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&s({line:a,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&s({line:g,source:1})}}e.LineProcess=S;function u(f){let t=[],n=!1;const s=function(r){if(n){t.push(r);return}(!f.send(r,g=>{if(g&&console.error(g),n=!1,t.length>0){const m=t.slice(0);t=[],m.forEach(_=>s(_))}})||P.isWindows)&&(n=!0)};return{send:s}}e.createQueuedSender=u;var c;(function(f){async function t(n,s,r){if(b.isAbsolute(n))return n;if(s===void 0&&(s=C.cwd()),b.dirname(n)!=="."||(r===void 0&&D.isString(C.env.PATH)&&(r=C.env.PATH.split(b.delimiter)),r===void 0||r.length===0))return b.join(s,n);async function g(m){return await I.exists(m)?!(await L.promises.stat(m)).isDirectory():!1}for(let m of r){let _;if(b.isAbsolute(m)?_=b.join(m,n):_=b.join(s,m,n),await g(_))return _;let l=_+".com";if(await g(l)||(l=_+".exe",await g(l)))return l}return b.join(s,n)}f.findExecutable=t})(c=e.win32||(e.win32={}))}),define(me[149],ge([18,19]),function(G,e){return G.create("vs/editor/common/config/editorOptions",e)}),define(me[150],ge([0,1,149,10,108]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=y;class C{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,we){this._values[te]=we}}e.ValidatedEditorOptions=C;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class k{constructor(te,we,Ue,je){this.id=te,this.name=we,this.defaultValue=Ue,this.schema=je}compute(te,we,Ue){return Ue}}class i{constructor(te,we=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=we}validate(te){return this.defaultValue}}class P{constructor(te,we,Ue,je){this.id=te,this.name=we,this.defaultValue=Ue,this.schema=je}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,we,Ue){return Ue}}function h(K,te){return typeof K=="undefined"?te:K==="false"?!1:Boolean(K)}e.boolean=h;class p extends P{constructor(te,we,Ue,je=void 0){typeof je!="undefined"&&(je.type="boolean",je.default=Ue),super(te,we,Ue,je)}validate(te){return h(te,this.defaultValue)}}class o extends P{constructor(te,we,Ue,je,ze,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=Ue,Ze.minimum=je,Ze.maximum=ze),super(te,we,Ue,Ze),this.minimum=je,this.maximum=ze}static clampedInt(te,we,Ue,je){if(typeof te=="undefined")return we;let ze=parseInt(te,10);return isNaN(ze)?we:(ze=Math.max(Ue,ze),ze=Math.min(je,ze),ze|0)}validate(te){return o.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class d extends P{constructor(te,we,Ue,je,ze){typeof ze!="undefined"&&(ze.type="number",ze.default=Ue),super(te,we,Ue,ze),this.validationFn=je}static clamp(te,we,Ue){return te<we?we:te>Ue?Ue:te}static float(te,we){if(typeof te=="number")return te;if(typeof te=="undefined")return we;const Ue=parseFloat(te);return isNaN(Ue)?we:Ue}validate(te){return this.validationFn(d.float(te,this.defaultValue))}}class E extends P{static string(te,we){return typeof te!="string"?we:te}constructor(te,we,Ue,je=void 0){typeof je!="undefined"&&(je.type="string",je.default=Ue),super(te,we,Ue,je)}validate(te){return E.string(te,this.defaultValue)}}function w(K,te,we){return typeof K!="string"||we.indexOf(K)===-1?te:K}e.stringSet=w;class S extends P{constructor(te,we,Ue,je,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.enum=je,ze.default=Ue),super(te,we,Ue,ze),this._allowedValues=je}validate(te){return w(te,this.defaultValue,this._allowedValues)}}class u extends k{constructor(te,we,Ue,je,ze,Ze,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="string",Ce.enum=ze,Ce.default=je),super(te,we,Ue,Ce),this._allowedValues=ze,this._convert=Ze}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function c(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",description:b.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,we,Ue){return Ue===0?te.accessibilitySupport:Ue}}class t extends k{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:b.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{insertSpace:h(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(K){switch(K){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function g(K){switch(K){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class m extends i{constructor(){super(124,[62,31])}compute(te,we,Ue){const je=["monaco-editor"];return we.get(31)&&je.push(we.get(31)),te.extraEditorClassName&&je.push(te.extraEditorClassName),we.get(62)==="default"?je.push("mouse-default"):we.get(62)==="copy"&&je.push("mouse-copy"),we.get(97)&&je.push("showUnused"),we.get(122)&&je.push("showDeprecated"),je.join(" ")}}class _ extends p{constructor(){super(30,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(te,we,Ue){return Ue&&te.emptySelectionClipboard}}class l extends k{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:te.seedSearchStringFromSelection,description:b.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[b.localize(9,null),b.localize(10,null),b.localize(11,null)],description:b.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:b.localize(13,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:b.localize(14,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:b.localize(15,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{cursorMoveOnType:h(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:h(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":w(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(we.loop,this.defaultValue.loop)}}}class v extends k{constructor(){super(41,"fontLigatures",v.OFF,{anyOf:[{type:"boolean",description:b.localize(16,null)},{type:"string",description:b.localize(17,null)}],description:b.localize(18,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?v.OFF:te==="true"?v.ON:te:Boolean(te)?v.ON:v.OFF}}e.EditorFontLigatures=v,v.OFF='"liga" off, "calt" off',v.ON='"liga" on, "calt" on';class R extends i{constructor(){super(40)}compute(te,we,Ue){return te.fontInfo}}class O extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(19,null)})}validate(te){let we=d.float(te,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(we,6,100)}compute(te,we,Ue){return te.fontInfo.fontSize}}class H extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.MINIMUM_VALUE,maximum:H.MAXIMUM_VALUE,errorMessage:b.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(21,null)})}validate(te){return te==="normal"||te==="bold"?te:String(o.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,H.MINIMUM_VALUE,H.MAXIMUM_VALUE))}}H.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],H.MINIMUM_VALUE=1,H.MAXIMUM_VALUE=1e3;class ne extends k{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[b.localize(22,null),b.localize(23,null),b.localize(24,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:b.localize(26,null)},we),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:b.localize(27,null)},we),"editor.gotoLocation.multipleDeclarations":Object.assign({description:b.localize(28,null)},we),"editor.gotoLocation.multipleImplementations":Object.assign({description:b.localize(29,null)},we),"editor.gotoLocation.multipleReferences":Object.assign({description:b.localize(30,null)},we),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:Ue,description:b.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:Ue,description:b.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:Ue,description:b.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:Ue,description:b.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:Ue,description:b.localize(35,null)}})}validate(te){var we,Ue,je,ze,Ze;if(!te||typeof te!="object")return this.defaultValue;const Ce=te;return{multiple:w(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(we=Ce.multipleDefinitions)!==null&&we!==void 0?we:w(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ue=Ce.multipleTypeDefinitions)!==null&&Ue!==void 0?Ue:w(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(je=Ce.multipleDeclarations)!==null&&je!==void 0?je:w(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(ze=Ce.multipleImplementations)!==null&&ze!==void 0?ze:w(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ze=Ce.multipleReferences)!==null&&Ze!==void 0?Ze:w(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ie extends k{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(50,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:b.localize(36,null)},"editor.hover.delay":{type:"number",default:te.delay,description:b.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:b.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{enabled:h(we.enabled,this.defaultValue.enabled),delay:o.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:h(we.sticky,this.defaultValue.sticky)}}}var N;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class B extends i{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(te,we,Ue){return B.computeLayout(we,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const we=te.height/te.lineHeight,Ue=te.scrollBeyondLastLine?we-1:0,je=(te.viewLineCount+Ue)/(te.pixelRatio*te.height),ze=Math.floor(te.viewLineCount/je);return{typicalViewportLineCount:we,extraLinesBeyondLastLine:Ue,desiredRatio:je,minimapLineCount:ze}}static _computeMinimapLayout(te,we){const Ue=te.outerWidth,je=te.outerHeight,ze=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ze*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const Ze=we.stableMinimapLayoutInput,Ce=Ze&&te.outerHeight===Ze.outerHeight&&te.lineHeight===Ze.lineHeight&&te.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&te.pixelRatio===Ze.pixelRatio&&te.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&te.minimap.enabled===Ze.minimap.enabled&&te.minimap.side===Ze.minimap.side&&te.minimap.size===Ze.minimap.size&&te.minimap.showSlider===Ze.minimap.showSlider&&te.minimap.renderCharacters===Ze.minimap.renderCharacters&&te.minimap.maxColumn===Ze.minimap.maxColumn&&te.minimap.scale===Ze.minimap.scale&&te.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&te.isViewportWrapping===Ze.isViewportWrapping,De=te.lineHeight,Pe=te.typicalHalfwidthCharacterWidth,oe=te.scrollBeyondLastLine,ue=te.minimap.renderCharacters;let V=ze>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const J=te.minimap.maxColumn,ce=te.minimap.size,Ae=te.minimap.side,Ee=te.verticalScrollbarWidth,Me=te.viewLineCount,Ve=te.remainingWidth,Xe=te.isViewportWrapping,rt=ue?2:3;let Qe=Math.floor(ze*je);const et=Qe/ze;let pt=!1,bt=!1,de=rt*V,Se=V/ze,ae=1;if(ce==="fill"||ce==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Ye,desiredRatio:lt,minimapLineCount:ft}=B.computeContainedMinimapLineCount({viewLineCount:Me,scrollBeyondLastLine:oe,height:je,lineHeight:De,pixelRatio:ze});if(Me/ft>1)pt=!0,bt=!0,V=1,de=1,Se=V/ze;else{let _t=!1,vt=V+1;if(ce==="fit"){const kt=Math.ceil((Me+Ye)*de);Xe&&Ce&&Ve<=we.stableFitRemainingWidth?(_t=!0,vt=we.stableFitMaxMinimapScale):(_t=kt>Qe,Xe&&_t?(we.stableMinimapLayoutInput=te,we.stableFitRemainingWidth=Ve):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0))}if(ce==="fill"||_t){pt=!0;const kt=V;de=Math.min(De*ze,Math.max(1,Math.floor(1/lt))),V=Math.min(vt,Math.max(1,Math.floor(de/rt))),V>kt&&(ae=Math.min(2,V/kt)),Se=V/ze/ae,Qe=Math.ceil(Math.max(ht,Me+Ye)*de),Xe&&_t&&(we.stableFitMaxMinimapScale=V)}}}const X=Math.floor(J*Se),Be=Math.min(X,Math.max(0,Math.floor((Ve-Ee-2)*Se/(Pe+Se)))+e.MINIMAP_GUTTER_WIDTH);let Le=Math.floor(ze*Be);const Je=Le/ze;Le=Math.floor(Le*ae);const it=ue?1:2,at=Ae==="left"?0:Ue-Be-Ee;return{renderMinimap:it,minimapLeft:at,minimapWidth:Be,minimapHeightIsEditorHeight:pt,minimapIsSampling:bt,minimapScale:V,minimapLineHeight:de,minimapCanvasInnerWidth:Le,minimapCanvasInnerHeight:Qe,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:et}}static computeLayout(te,we){const Ue=we.outerWidth|0,je=we.outerHeight|0,ze=we.lineHeight|0,Ze=we.lineNumbersDigitCount|0,Ce=we.typicalHalfwidthCharacterWidth,De=we.maxDigitWidth,Pe=we.pixelRatio,oe=we.viewLineCount,ue=te.get(119),V=ue==="inherit"?te.get(118):ue,J=V==="inherit"?te.get(114):V,ce=te.get(117),Ae=te.get(2),Ee=we.isDominatedByLongLines,Me=te.get(46),Ve=te.get(56).renderType!==0,Xe=te.get(57),rt=te.get(91),Qe=te.get(61),et=te.get(89),pt=et.verticalScrollbarSize,bt=et.verticalHasArrows,de=et.arrowSize,Se=et.horizontalScrollbarSize,ae=te.get(54),X=te.get(35);let Be;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const Ft=parseFloat(ae.substr(0,ae.length-2));Be=o.clampedInt(Ft*Ce,0,0,1e3)}else Be=o.clampedInt(ae,0,0,1e3);X&&(Be+=16);let Le=0;if(Ve){const Ft=Math.max(Ze,Xe);Le=Math.round(Ft*De)}let Je=0;Me&&(Je=ze);let it=0,at=it+Je,ht=at+Le,Ye=ht+Be;const lt=Ue-Je-Le-Be;let ft=!1,ct=!1,_t=-1;Ae!==2&&(V==="inherit"&&Ee?(ft=!0,ct=!0):J==="on"||J==="bounded"?ct=!0:J==="wordWrapColumn"&&(_t=ce));const vt=B._computeMinimapLayout({outerWidth:Ue,outerHeight:je,lineHeight:ze,typicalHalfwidthCharacterWidth:Ce,pixelRatio:Pe,scrollBeyondLastLine:rt,minimap:Qe,verticalScrollbarWidth:pt,viewLineCount:oe,remainingWidth:lt,isViewportWrapping:ct},we.memory||new D);vt.renderMinimap!==0&&vt.minimapLeft===0&&(it+=vt.minimapWidth,at+=vt.minimapWidth,ht+=vt.minimapWidth,Ye+=vt.minimapWidth);const kt=lt-vt.minimapWidth,Lt=Math.max(1,Math.floor((kt-pt-2)/Ce)),Et=bt?de:0;return ct&&(_t=Math.max(1,Lt),J==="bounded"&&(_t=Math.min(_t,ce))),{width:Ue,height:je,glyphMarginLeft:it,glyphMarginWidth:Je,lineNumbersLeft:at,lineNumbersWidth:Le,decorationsLeft:ht,decorationsWidth:Be,contentLeft:Ye,contentWidth:kt,minimap:vt,viewportColumn:Lt,isWordWrapMinified:ft,isViewportWrapping:ct,wrappingColumn:_t,verticalScrollbarWidth:pt,horizontalScrollbarHeight:Se,overviewRuler:{top:Et,width:pt,height:je-2*Et,right:0}}}}e.EditorLayoutInfoComputer=B;class U extends k{constructor(){const te={enabled:!0};super(53,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:b.localize(39,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:h(te.enabled,this.defaultValue.enabled)}}}class A extends k{constructor(){const te={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:b.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,description:b.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,description:b.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{enabled:h(we.enabled,this.defaultValue.enabled),fontSize:o.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(we.fontFamily,this.defaultValue.fontFamily)}}}class x extends o{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:b.localize(43,null)})}compute(te,we,Ue){return te.fontInfo.lineHeight}}class F extends k{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:b.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(45,null),b.localize(46,null),b.localize(47,null)],default:te.size,description:b.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:b.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:b.localize(50,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:b.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:b.localize(53,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{enabled:h(we.enabled,this.defaultValue.enabled),size:w(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(we.side,this.defaultValue.side,["right","left"]),showSlider:w(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(we.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(we.scale,1,1,3),maxColumn:o.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(K){return K==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class W extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(55,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{top:o.clampedInt(we.top,0,0,1e3),bottom:o.clampedInt(we.bottom,0,0,1e3)}}}class z extends k{constructor(){const te={enabled:!0,cycle:!1};super(72,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:b.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:b.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{enabled:h(we.enabled,this.defaultValue.enabled),cycle:h(we.cycle,this.defaultValue.cycle)}}}class Y extends i{constructor(){super(125)}compute(te,we,Ue){return te.pixelRatio}}class le extends k{constructor(){const te={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:b.localize(58,null)},comments:{type:"boolean",default:te.comments,description:b.localize(59,null)},other:{type:"boolean",default:te.other,description:b.localize(60,null)}}}],default:te,description:b.localize(61,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const we=te,Ue={other:h(we.other,this.defaultValue.other),comments:h(we.comments,this.defaultValue.comments),strings:h(we.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var ve;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(62,null),b.localize(63,null),b.localize(64,null),b.localize(65,null)],default:"on",description:b.localize(66,null)})}validate(te){let we=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(we=4,Ue=te):te==="interval"?we=3:te==="relative"?we=2:te==="on"?we=1:we=0),{renderType:we,renderFn:Ue}}}function ye(K){const te=K.get(84);return te==="editable"?K.get(77):te!=="on"}e.filterValidationDecorations=ye;class Oe extends k{constructor(){const te=[],we={type:"number",description:b.localize(67,null)};super(88,"rulers",te,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:b.localize(68,null),format:"color-hex"}}}]},default:te,description:b.localize(69,null)})}validate(te){if(Array.isArray(te)){let we=[];for(let Ue of te)if(typeof Ue=="number")we.push({column:o.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const je=Ue;we.push({column:o.clampedInt(je.column,0,0,1e4),color:je.color})}return we.sort((Ue,je)=>Ue.column-je.column),we}return this.defaultValue}}function j(K,te){if(typeof K!="string")return te;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class Q extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te,Ue=o.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=o.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(we.vertical,this.defaultValue.vertical),horizontal:j(we.horizontal,this.defaultValue.horizontal),useShadows:h(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:o.clampedInt(we.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:je,verticalSliderSize:o.clampedInt(we.verticalSliderSize,je,0,1e3),scrollByPage:h(we.scrollByPage,this.defaultValue.scrollByPage)}}}class Z extends k{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(70,null),b.localize(71,null)],default:te.insertMode,description:b.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:b.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:b.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:b.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:b.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:b.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:b.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:b.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(109,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{insertMode:w(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(we.showIcons,this.defaultValue.showIcons),showStatusBar:h(we.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:h(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(we.showMethods,this.defaultValue.showMethods),showFunctions:h(we.showFunctions,this.defaultValue.showFunctions),showConstructors:h(we.showConstructors,this.defaultValue.showConstructors),showFields:h(we.showFields,this.defaultValue.showFields),showVariables:h(we.showVariables,this.defaultValue.showVariables),showClasses:h(we.showClasses,this.defaultValue.showClasses),showStructs:h(we.showStructs,this.defaultValue.showStructs),showInterfaces:h(we.showInterfaces,this.defaultValue.showInterfaces),showModules:h(we.showModules,this.defaultValue.showModules),showProperties:h(we.showProperties,this.defaultValue.showProperties),showEvents:h(we.showEvents,this.defaultValue.showEvents),showOperators:h(we.showOperators,this.defaultValue.showOperators),showUnits:h(we.showUnits,this.defaultValue.showUnits),showValues:h(we.showValues,this.defaultValue.showValues),showConstants:h(we.showConstants,this.defaultValue.showConstants),showEnums:h(we.showEnums,this.defaultValue.showEnums),showEnumMembers:h(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(we.showKeywords,this.defaultValue.showKeywords),showWords:h(we.showWords,this.defaultValue.showWords),showColors:h(we.showColors,this.defaultValue.showColors),showFiles:h(we.showFiles,this.defaultValue.showFiles),showReferences:h(we.showReferences,this.defaultValue.showReferences),showFolders:h(we.showFolders,this.defaultValue.showFolders),showTypeParameters:h(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(we.showSnippets,this.defaultValue.showSnippets),showUsers:h(we.showUsers,this.defaultValue.showUsers),showIssues:h(we.showIssues,this.defaultValue.showIssues)}}}class se extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(110,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends i{constructor(){super(126,[77])}compute(te,we,Ue){return we.get(77)?!0:te.tabFocusMode}}var _e;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(_e=e.WrappingIndent||(e.WrappingIndent={}));function xe(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class pe extends i{constructor(){super(128,[127])}compute(te,we,Ue){const je=we.get(127);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",Fe="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Fe:L.isLinux?He:ke,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(K){return e.editorOptionsRegistry[K.id]=K,K}var Ke;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.codeLens=12]="codeLens",K[K.codeLensFontFamily=13]="codeLensFontFamily",K[K.codeLensFontSize=14]="codeLensFontSize",K[K.colorDecorators=15]="colorDecorators",K[K.columnSelection=16]="columnSelection",K[K.comments=17]="comments",K[K.contextmenu=18]="contextmenu",K[K.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",K[K.cursorBlinking=20]="cursorBlinking",K[K.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",K[K.cursorStyle=22]="cursorStyle",K[K.cursorSurroundingLines=23]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",K[K.cursorWidth=25]="cursorWidth",K[K.disableLayerHinting=26]="disableLayerHinting",K[K.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",K[K.domReadOnly=28]="domReadOnly",K[K.dragAndDrop=29]="dragAndDrop",K[K.emptySelectionClipboard=30]="emptySelectionClipboard",K[K.extraEditorClassName=31]="extraEditorClassName",K[K.fastScrollSensitivity=32]="fastScrollSensitivity",K[K.find=33]="find",K[K.fixedOverflowWidgets=34]="fixedOverflowWidgets",K[K.folding=35]="folding",K[K.foldingStrategy=36]="foldingStrategy",K[K.foldingHighlight=37]="foldingHighlight",K[K.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=39]="fontFamily",K[K.fontInfo=40]="fontInfo",K[K.fontLigatures=41]="fontLigatures",K[K.fontSize=42]="fontSize",K[K.fontWeight=43]="fontWeight",K[K.formatOnPaste=44]="formatOnPaste",K[K.formatOnType=45]="formatOnType",K[K.glyphMargin=46]="glyphMargin",K[K.gotoLocation=47]="gotoLocation",K[K.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",K[K.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",K[K.hover=50]="hover",K[K.inDiffEditor=51]="inDiffEditor",K[K.letterSpacing=52]="letterSpacing",K[K.lightbulb=53]="lightbulb",K[K.lineDecorationsWidth=54]="lineDecorationsWidth",K[K.lineHeight=55]="lineHeight",K[K.lineNumbers=56]="lineNumbers",K[K.lineNumbersMinChars=57]="lineNumbersMinChars",K[K.linkedEditing=58]="linkedEditing",K[K.links=59]="links",K[K.matchBrackets=60]="matchBrackets",K[K.minimap=61]="minimap",K[K.mouseStyle=62]="mouseStyle",K[K.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=64]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",K[K.multiCursorModifier=66]="multiCursorModifier",K[K.multiCursorPaste=67]="multiCursorPaste",K[K.occurrencesHighlight=68]="occurrencesHighlight",K[K.overviewRulerBorder=69]="overviewRulerBorder",K[K.overviewRulerLanes=70]="overviewRulerLanes",K[K.padding=71]="padding",K[K.parameterHints=72]="parameterHints",K[K.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",K[K.quickSuggestions=75]="quickSuggestions",K[K.quickSuggestionsDelay=76]="quickSuggestionsDelay",K[K.readOnly=77]="readOnly",K[K.renameOnType=78]="renameOnType",K[K.renderControlCharacters=79]="renderControlCharacters",K[K.renderIndentGuides=80]="renderIndentGuides",K[K.renderFinalNewline=81]="renderFinalNewline",K[K.renderLineHighlight=82]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=84]="renderValidationDecorations",K[K.renderWhitespace=85]="renderWhitespace",K[K.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",K[K.roundedSelection=87]="roundedSelection",K[K.rulers=88]="rulers",K[K.scrollbar=89]="scrollbar",K[K.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=91]="scrollBeyondLastLine",K[K.scrollPredominantAxis=92]="scrollPredominantAxis",K[K.selectionClipboard=93]="selectionClipboard",K[K.selectionHighlight=94]="selectionHighlight",K[K.selectOnLineNumbers=95]="selectOnLineNumbers",K[K.showFoldingControls=96]="showFoldingControls",K[K.showUnused=97]="showUnused",K[K.snippetSuggestions=98]="snippetSuggestions",K[K.smartSelect=99]="smartSelect",K[K.smoothScrolling=100]="smoothScrolling",K[K.stickyTabStops=101]="stickyTabStops",K[K.stopRenderingLineAfter=102]="stopRenderingLineAfter",K[K.suggest=103]="suggest",K[K.suggestFontSize=104]="suggestFontSize",K[K.suggestLineHeight=105]="suggestLineHeight",K[K.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",K[K.suggestSelection=107]="suggestSelection",K[K.tabCompletion=108]="tabCompletion",K[K.tabIndex=109]="tabIndex",K[K.unusualLineTerminators=110]="unusualLineTerminators",K[K.useShadowDOM=111]="useShadowDOM",K[K.useTabStops=112]="useTabStops",K[K.wordSeparators=113]="wordSeparators",K[K.wordWrap=114]="wordWrap",K[K.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=117]="wordWrapColumn",K[K.wordWrapOverride1=118]="wordWrapOverride1",K[K.wordWrapOverride2=119]="wordWrapOverride2",K[K.wrappingIndent=120]="wrappingIndent",K[K.wrappingStrategy=121]="wrappingStrategy",K[K.showDeprecated=122]="showDeprecated",K[K.inlayHints=123]="inlayHints",K[K.editorClassName=124]="editorClassName",K[K.pixelRatio=125]="pixelRatio",K[K.tabFocusMode=126]="tabFocusMode",K[K.layoutInfo=127]="layoutInfo",K[K.wrappingInfo=128]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(111,null)})),acceptSuggestionOnEnter:be(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(112,null),""],markdownDescription:b.localize(113,null)})),accessibilitySupport:be(new f),accessibilityPageSize:be(new o(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(114,null)})),ariaLabel:be(new E(4,"ariaLabel",b.localize(115,null))),autoClosingBrackets:be(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(116,null),b.localize(117,null),""],description:b.localize(118,null)})),autoClosingDelete:be(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(119,null),""],description:b.localize(120,null)})),autoClosingOvertype:be(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(121,null),""],description:b.localize(122,null)})),autoClosingQuotes:be(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(123,null),b.localize(124,null),""],description:b.localize(125,null)})),autoIndent:be(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[b.localize(126,null),b.localize(127,null),b.localize(128,null),b.localize(129,null),b.localize(130,null)],description:b.localize(131,null)})),automaticLayout:be(new p(10,"automaticLayout",!1)),autoSurround:be(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(132,null),b.localize(133,null),b.localize(134,null),""],description:b.localize(135,null)})),stickyTabStops:be(new p(101,"stickyTabStops",!1,{description:b.localize(136,null)})),codeLens:be(new p(12,"codeLens",!0,{description:b.localize(137,null)})),codeLensFontFamily:be(new E(13,"codeLensFontFamily","",{description:b.localize(138,null)})),codeLensFontSize:be(new o(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:b.localize(139,null)})),colorDecorators:be(new p(15,"colorDecorators",!0,{description:b.localize(140,null)})),columnSelection:be(new p(16,"columnSelection",!1,{description:b.localize(141,null)})),comments:be(new t),contextmenu:be(new p(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new p(19,"copyWithSyntaxHighlighting",!0,{description:b.localize(142,null)})),cursorBlinking:be(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:b.localize(143,null)})),cursorSmoothCaretAnimation:be(new p(21,"cursorSmoothCaretAnimation",!1,{description:b.localize(144,null)})),cursorStyle:be(new u(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],g,{description:b.localize(145,null)})),cursorSurroundingLines:be(new o(23,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(146,null)})),cursorSurroundingLinesStyle:be(new S(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(147,null),b.localize(148,null)],description:b.localize(149,null)})),cursorWidth:be(new o(25,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(150,null)})),disableLayerHinting:be(new p(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new p(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new p(28,"domReadOnly",!1)),dragAndDrop:be(new p(29,"dragAndDrop",!0,{description:b.localize(151,null)})),emptySelectionClipboard:be(new _),extraEditorClassName:be(new E(31,"extraEditorClassName","")),fastScrollSensitivity:be(new d(32,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:b.localize(152,null)})),find:be(new l),fixedOverflowWidgets:be(new p(34,"fixedOverflowWidgets",!1)),folding:be(new p(35,"folding",!0,{description:b.localize(153,null)})),foldingStrategy:be(new S(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(154,null),b.localize(155,null)],description:b.localize(156,null)})),foldingHighlight:be(new p(37,"foldingHighlight",!0,{description:b.localize(157,null)})),unfoldOnClickAfterEndOfLine:be(new p(38,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(158,null)})),fontFamily:be(new E(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(159,null)})),fontInfo:be(new R),fontLigatures2:be(new v),fontSize:be(new O),fontWeight:be(new H),formatOnPaste:be(new p(44,"formatOnPaste",!1,{description:b.localize(160,null)})),formatOnType:be(new p(45,"formatOnType",!1,{description:b.localize(161,null)})),glyphMargin:be(new p(46,"glyphMargin",!0,{description:b.localize(162,null)})),gotoLocation:be(new ne),hideCursorInOverviewRuler:be(new p(48,"hideCursorInOverviewRuler",!1,{description:b.localize(163,null)})),highlightActiveIndentGuide:be(new p(49,"highlightActiveIndentGuide",!0,{description:b.localize(164,null)})),hover:be(new ie),inDiffEditor:be(new p(51,"inDiffEditor",!1)),letterSpacing:be(new d(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>d.clamp(K,-5,20),{description:b.localize(165,null)})),lightbulb:be(new U),lineDecorationsWidth:be(new P(54,"lineDecorationsWidth",10)),lineHeight:be(new x),lineNumbers:be(new Te),lineNumbersMinChars:be(new o(57,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new p(58,"linkedEditing",!1,{description:b.localize(166,null)})),links:be(new p(59,"links",!0,{description:b.localize(167,null)})),matchBrackets:be(new S(60,"matchBrackets","always",["always","near","never"],{description:b.localize(168,null)})),minimap:be(new F),mouseStyle:be(new S(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new d(63,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:b.localize(169,null)})),mouseWheelZoom:be(new p(64,"mouseWheelZoom",!1,{markdownDescription:b.localize(170,null)})),multiCursorMergeOverlapping:be(new p(65,"multiCursorMergeOverlapping",!0,{description:b.localize(171,null)})),multiCursorModifier:be(new u(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[b.localize(172,null),b.localize(173,null)],markdownDescription:b.localize(174,null)})),multiCursorPaste:be(new S(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(175,null),b.localize(176,null)],markdownDescription:b.localize(177,null)})),occurrencesHighlight:be(new p(68,"occurrencesHighlight",!0,{description:b.localize(178,null)})),overviewRulerBorder:be(new p(69,"overviewRulerBorder",!0,{description:b.localize(179,null)})),overviewRulerLanes:be(new o(70,"overviewRulerLanes",3,0,3)),padding:be(new W),parameterHints:be(new z),peekWidgetDefaultFocus:be(new S(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(180,null),b.localize(181,null)],description:b.localize(182,null)})),definitionLinkOpensInPeek:be(new p(74,"definitionLinkOpensInPeek",!1,{description:b.localize(183,null)})),quickSuggestions:be(new le),quickSuggestionsDelay:be(new o(76,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(184,null)})),readOnly:be(new p(77,"readOnly",!1)),renameOnType:be(new p(78,"renameOnType",!1,{description:b.localize(185,null),markdownDeprecationMessage:b.localize(186,null)})),renderControlCharacters:be(new p(79,"renderControlCharacters",!1,{description:b.localize(187,null)})),renderIndentGuides:be(new p(80,"renderIndentGuides",!0,{description:b.localize(188,null)})),renderFinalNewline:be(new p(81,"renderFinalNewline",!0,{description:b.localize(189,null)})),renderLineHighlight:be(new S(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(190,null)],description:b.localize(191,null)})),renderLineHighlightOnlyWhenFocus:be(new p(83,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(192,null)})),renderValidationDecorations:be(new S(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new S(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(193,null),b.localize(194,null),b.localize(195,null),""],description:b.localize(196,null)})),revealHorizontalRightPadding:be(new o(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new p(87,"roundedSelection",!0,{description:b.localize(197,null)})),rulers:be(new Oe),scrollbar:be(new Q),scrollBeyondLastColumn:be(new o(90,"scrollBeyondLastColumn",5,0,1073741824,{description:b.localize(198,null)})),scrollBeyondLastLine:be(new p(91,"scrollBeyondLastLine",!0,{description:b.localize(199,null)})),scrollPredominantAxis:be(new p(92,"scrollPredominantAxis",!0,{description:b.localize(200,null)})),selectionClipboard:be(new p(93,"selectionClipboard",!0,{description:b.localize(201,null),included:L.isLinux})),selectionHighlight:be(new p(94,"selectionHighlight",!0,{description:b.localize(202,null)})),selectOnLineNumbers:be(new p(95,"selectOnLineNumbers",!0)),showFoldingControls:be(new S(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[b.localize(203,null),b.localize(204,null)],description:b.localize(205,null)})),showUnused:be(new p(97,"showUnused",!0,{description:b.localize(206,null)})),showDeprecated:be(new p(122,"showDeprecated",!0,{description:b.localize(207,null)})),inlayHints:be(new A),snippetSuggestions:be(new S(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(208,null),b.localize(209,null),b.localize(210,null),b.localize(211,null)],description:b.localize(212,null)})),smartSelect:be(new se),smoothScrolling:be(new p(100,"smoothScrolling",!1,{description:b.localize(213,null)})),stopRenderingLineAfter:be(new o(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new Z),suggestFontSize:be(new o(104,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(214,null)})),suggestLineHeight:be(new o(105,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(215,null)})),suggestOnTriggerCharacters:be(new p(106,"suggestOnTriggerCharacters",!0,{description:b.localize(216,null)})),suggestSelection:be(new S(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(217,null),b.localize(218,null),b.localize(219,null)],description:b.localize(220,null)})),tabCompletion:be(new S(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null)],description:b.localize(224,null)})),tabIndex:be(new o(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new S(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(225,null),b.localize(226,null),b.localize(227,null)],description:b.localize(228,null)})),useShadowDOM:be(new p(111,"useShadowDOM",!0)),useTabStops:be(new p(112,"useTabStops",!0,{description:b.localize(229,null)})),wordSeparators:be(new E(113,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:b.localize(230,null)})),wordWrap:be(new S(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(231,null),b.localize(232,null),b.localize(233,null),b.localize(234,null)],description:b.localize(235,null)})),wordWrapBreakAfterCharacters:be(new E(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new E(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new o(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(236,null)})),wordWrapOverride1:be(new S(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new S(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new u(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],xe,{enumDescriptions:[b.localize(237,null),b.localize(238,null),b.localize(239,null),b.localize(240,null)],description:b.localize(241,null)})),wrappingStrategy:be(new S(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[b.localize(242,null),b.localize(243,null)],description:b.localize(244,null)})),editorClassName:be(new m),pixelRatio:be(new Y),tabFocusMode:be(new fe),layoutInfo:be(new B),wrappingInfo:be(new pe)}}),define(me[151],ge([18,19]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[152],ge([18,19]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[153],ge([18,19]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[154],ge([18,19]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[155],ge([18,19]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(me[156],ge([18,19]),function(G,e){return G.create("vs/platform/markers/common/markers",e)}),define(me[157],ge([18,19]),function(G,e){return G.create("vs/platform/theme/common/iconRegistry",e)}),define(me[158],ge([18,19]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(me[159],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[160],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[161],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostProgress",e)}),define(me[162],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[163],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[164],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[165],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[166],ge([18,19]),function(G,e){return G.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[167],ge([18,19]),function(G,e){return G.create("vs/workbench/common/views",e)}),define(me[168],ge([18,19]),function(G,e){return G.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[169],ge([18,19]),function(G,e){return G.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[170],ge([18,19]),function(G,e){return G.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[171],ge([18,19]),function(G,e){return G.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[172],ge([18,19]),function(G,e){return G.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[173],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var b;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(b=e.EditorActivation||(e.EditorActivation={}));var L;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(L=e.EditorOverride||(e.EditorOverride={}));var I;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[174],ge([0,1,153]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function T(h){return h=h.trim(),h==="*"||L.test(h)}e.isValidVersionStr=T;function y(h){if(!T(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=h.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=y;function C(h){if(!h)return null;let p=h.majorBase,o=h.majorMustEqual,d=h.minorBase,E=h.minorMustEqual,w=h.patchBase,S=h.patchMustEqual;h.hasCaret&&(p===0||(E=!1),S=!1);let u=0;if(h.preRelease){const c=I.exec(h.preRelease);if(c){const[,f,t,n]=c;u=Date.UTC(Number(f),Number(t)-1,Number(n))}}return{majorBase:p,majorMustEqual:o,minorBase:d,minorMustEqual:E,patchBase:w,patchMustEqual:S,isMinimum:h.hasGreaterEquals,notBefore:u}}e.normalizeVersion=C;function D(h,p,o){let d;typeof h=="string"?d=C(y(h)):d=h;let E;p instanceof Date?E=p.getTime():typeof p=="string"&&(E=new Date(p).getTime());let w;if(typeof o=="string"?w=C(y(o)):w=o,!d||!w)return!1;let S=d.majorBase,u=d.minorBase,c=d.patchBase,f=w.majorBase,t=w.minorBase,n=w.patchBase,s=w.notBefore,r=w.majorMustEqual,a=w.minorMustEqual,g=w.patchMustEqual;return w.isMinimum?S>f?!0:S<f?!1:u>t?!0:u<t||E&&E<s?!1:c>=n:(S===1&&f===0&&(!r||!a||!g)&&(f=1,t=0,n=0,r=!0,a=!1,g=!1),S<f?!1:S>f?!r:u<t?!1:u>t?!a:c<n?!1:c>n?!g:!(E&&E<s))}e.isValidVersion=D;function k(h,p,o,d){return o.isBuiltin||typeof o.main=="undefined"?!0:P(h,p,o.engines.vscode,d)}e.isValidExtensionVersion=k;function i(h,p,o){return h==="*"||P(p,o,h)}e.isEngineValid=i;function P(h,p,o,d=[]){let E=C(y(o));if(!E)return d.push(b.localize(0,null,o)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return d.push(b.localize(1,null,o)),!1}else if(!E.majorMustEqual)return d.push(b.localize(2,null,o)),!1;return D(h,p,E)?!0:(d.push(b.localize(3,null,h,o)),!1)}}),define(me[112],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class b{constructor(T,y=[],C=!1){this.ctor=T,this.staticArguments=y,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=b;const L=(I,...T)=>new b(I,T);e.createSyncDescriptor=L}),define(me[79],ge([0,1,112]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function I(y,C,D){C instanceof b.SyncDescriptor||(C=new b.SyncDescriptor(C,[],D)),L.push([y,C])}e.registerSingleton=I;function T(){return L}e.getSingletonServiceDescriptors=T}),define(me[175],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=b;class L{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let y of this._nodes.values())y.outgoing.size===0&&T.push(y);return T}insertEdge(T,y){const C=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(y);C.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(T),C)}removeNode(T){const y=this._hashFn(T);this._nodes.delete(y);for(let C of this._nodes.values())C.outgoing.delete(y),C.incoming.delete(y)}lookupOrInsertNode(T){const y=this._hashFn(T);let C=this._nodes.get(y);return C||(C=new b(T),this._nodes.set(y,C)),C}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[y,C]of this._nodes)T.push(`${y}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,y]of this._nodes){const C=new Set([T]),D=this._findCycle(y,C);if(D)return D}}_findCycle(T,y){for(let[C,D]of T.outgoing){if(y.has(C))return[...y,C].join(" -> ");y.add(C);const k=this._findCycle(D,y);if(k)return k;y.delete(C)}}}e.Graph=L}),define(me[4],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(k){return k[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(b=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function L(C,D,k,i){D[b.DI_TARGET]===D?D[b.DI_DEPENDENCIES].push({id:C,index:k,optional:i}):(D[b.DI_DEPENDENCIES]=[{id:C,index:k,optional:i}],D[b.DI_TARGET]=D)}function I(C){if(b.serviceIds.has(C))return b.serviceIds.get(C);const D=function(k,i,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(D,k,P,!1)};return D.toString=()=>C,b.serviceIds.set(C,D),D}e.createDecorator=I;function T(C){return C}e.refineServiceDecorator=T;function y(C){return function(D,k,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(C,D,i,!0)}}e.optional=y}),define(me[176],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,b.createDecorator)("modelService");function L(I){return!I.isTooLargeForSyncing()&&!I.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(me[177],ge([0,1,3,75,6,22,74,78,176]),function(G,e,b,L,I,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(h){return typeof h=="string"?!1:Array.isArray(h)?h.every(k):!!h.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new b.Emitter}get onDidChange(){return this._onDidChange.event}register(p,o){let d={selector:p,provider:o,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,I.toDisposable)(()=>{if(d){let E=this._entries.indexOf(d);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const o=[];for(let d of this._entries)d._score>0&&o.push(d.provider);return o}ordered(p){const o=[];return this._orderedForEach(p,d=>o.push(d.provider)),o}orderedGroups(p){const o=[];let d,E;return this._orderedForEach(p,w=>{d&&E===w._score?d.push(w.provider):(E=w._score,d=[w.provider],o.push(d))}),o}_orderedForEach(p,o){if(!!p){this._updateScores(p);for(const d of this._entries)d._score>0&&o(d)}}_updateScores(p){let o={uri:p.uri.toString(),language:p.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===o.language&&this._lastCandidate.uri===o.uri)){this._lastCandidate=o;for(let d of this._entries)if(d._score=(0,C.score)(d.selector,p.uri,p.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(p)),k(d.selector)&&d._score>0){for(let E of this._entries)E._score=0;d._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(p,o){return p._score<o._score?1:p._score>o._score?-1:p._time<o._time?1:p._time>o._time?-1:0}}e.LanguageFeatureRegistry=i;class P{constructor(p,o,d=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=o,this.max=d,this._cache=new T.LRUCache(50,.7)}_key(p){return p.id+(0,L.hash)(this._registry.all(p))}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const o=this._key(p),d=this._cache.get(o);return this._clamp(d==null?void 0:d.value)}update(p,o){const d=this._key(p);let E=this._cache.get(d);return E||(E=new y.MovingAverage,this._cache.set(d,E)),E.update(o),this.get(p)}}e.LanguageFeatureRequestDelays=P}),define(me[80],ge([0,1,2,43,177,143,46]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class D{constructor(v,R){this.language=v,this.id=R}}e.LanguageIdentifier=D;var k;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var i;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var P;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var h;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",l[l.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",l[l.ITALIC_MASK=2048]="ITALIC_MASK",l[l.BOLD_MASK=4096]="BOLD_MASK",l[l.UNDERLINE_MASK=8192]="UNDERLINE_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(h=e.MetadataConsts||(e.MetadataConsts={}));class p{static getLanguageId(v){return(v&255)>>>0}static getTokenType(v){return(v&1792)>>>8}static getFontStyle(v){return(v&14336)>>>11}static getForeground(v){return(v&8372224)>>>14}static getBackground(v){return(v&4286578688)>>>23}static getClassNameFromMetadata(v){let R=this.getForeground(v),O="mtk"+R,H=this.getFontStyle(v);return H&1&&(O+=" mtki"),H&2&&(O+=" mtkb"),H&4&&(O+=" mtku"),O}static getInlineStyleFromMetadata(v,R){const O=this.getForeground(v),H=this.getFontStyle(v);let ne=`color: ${R[O]};`;return H&1&&(ne+="font-style: italic;"),H&2&&(ne+="font-weight: bold;"),H&4&&(ne+="text-decoration: underline;"),ne}}e.TokenMetadata=p;var o;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(o=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let l=Object.create(null);return l[0]="symbol-method",l[1]="symbol-function",l[2]="symbol-constructor",l[3]="symbol-field",l[4]="symbol-variable",l[5]="symbol-class",l[6]="symbol-struct",l[7]="symbol-interface",l[8]="symbol-module",l[9]="symbol-property",l[10]="symbol-event",l[11]="symbol-operator",l[12]="symbol-unit",l[13]="symbol-value",l[14]="symbol-constant",l[15]="symbol-enum",l[16]="symbol-enum-member",l[17]="symbol-keyword",l[27]="symbol-snippet",l[18]="symbol-text",l[19]="symbol-color",l[20]="symbol-file",l[21]="symbol-reference",l[22]="symbol-customcolor",l[23]="symbol-folder",l[24]="symbol-type-parameter",l[25]="account",l[26]="issues",function(v){const R=l[v];let O=R&&y.iconRegistry.get(R);return O||(console.info("No codicon found for CompletionItemKind "+v),O=y.Codicon.symbolProperty),O.classNames}}(),e.completionKindFromString=function(){let l=Object.create(null);return l.method=0,l.function=1,l.constructor=2,l.field=3,l.variable=4,l.class=5,l.struct=6,l.interface=7,l.module=8,l.property=9,l.event=10,l.operator=11,l.unit=12,l.value=13,l.constant=14,l.enum=15,l["enum-member"]=16,l.enumMember=16,l.keyword=17,l.snippet=27,l.text=18,l.color=19,l.file=20,l.reference=21,l.customcolor=22,l.folder=23,l["type-parameter"]=24,l.typeParameter=24,l.account=25,l.issue=26,function(v,R){let O=l[v];return typeof O=="undefined"&&!R&&(O=9),O}}();var d;(function(l){l[l.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(S=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var u;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(u=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function f(l){return l&&b.URI.isUri(l.uri)&&L.Range.isIRange(l.range)&&(L.Range.isIRange(l.originSelectionRange)||L.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=f;var t;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(l){l[l.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var s;(function(l){const v=new Map;v.set("file",0),v.set("module",1),v.set("namespace",2),v.set("package",3),v.set("class",4),v.set("method",5),v.set("property",6),v.set("field",7),v.set("constructor",8),v.set("enum",9),v.set("interface",10),v.set("function",11),v.set("variable",12),v.set("constant",13),v.set("string",14),v.set("number",15),v.set("boolean",16),v.set("array",17),v.set("object",18),v.set("key",19),v.set("null",20),v.set("enum-member",21),v.set("struct",22),v.set("event",23),v.set("operator",24),v.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function O(ie){return v.get(ie)}l.fromString=O;function H(ie){return R.get(ie)}l.toString=H;function ne(ie,N){const B=R.get(ie);let U=B&&y.iconRegistry.get("symbol-"+B);return U||(console.info("No codicon found for SymbolKind "+ie),U=y.Codicon.symbolProperty),`${N?"inline":"block"} ${U.classNames}`}l.toCssClassName=ne})(s=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(v){this.value=v}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var a;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var g;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(g=e.CommentMode||(e.CommentMode={}));var m;(function(l){l[l.Other=0]="Other",l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(m=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var _;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(_=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[178],ge([0,1,6,11,4,3,57,55]),function(G,e,b,L,I,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,I.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,k){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:D,handler:k})}if(D.description){const o=[];for(let E of D.description.args)o.push(E.constraint);const d=D.handler;D.handler=function(E,...w){return(0,L.validateConstraints)(w,o),d(E,...w)}}const{id:i}=D;let P=this._commands.get(i);P||(P=new y.LinkedList,this._commands.set(i,P));let h=P.unshift(D),p=(0,b.toDisposable)(()=>{h();const o=this._commands.get(i);(o==null?void 0:o.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),p}registerCommandAlias(D,k){return e.CommandsRegistry.registerCommand(D,(i,...P)=>i.get(e.ICommandService).executeCommand(k,...P))}getCommand(D){const k=this._commands.get(D);if(!(!k||k.isEmpty()))return C.Iterable.first(k)}getCommands(){const D=new Map;for(const k of this._commands.keys()){const i=this.getCommand(k);i&&D.set(k,i)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>b.Disposable.None,onDidExecuteCommand:()=>b.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(me[81],ge([0,1,8,4,10]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=I.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",I.isMacintosh),y.set("isLinux",I.isLinux),y.set("isWindows",I.isWindows),y.set("isWeb",I.isWeb),y.set("isMacNative",I.isMacintosh&&!I.isWeb),y.set("isEdge",T.indexOf("Edg/")>=0),y.set("isFirefox",T.indexOf("Firefox")>=0),y.set("isChrome",T.indexOf("Chrome")>=0),y.set("isSafari",T.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var D;(function(l){l[l.False=0]="False",l[l.True=1]="True",l[l.Defined=2]="Defined",l[l.Not=3]="Not",l[l.Equals=4]="Equals",l[l.NotEquals=5]="NotEquals",l[l.And=6]="And",l[l.Regex=7]="Regex",l[l.NotRegex=8]="NotRegex",l[l.Or=9]="Or",l[l.In=10]="In",l[l.NotIn=11]="NotIn",l[l.Greater=12]="Greater",l[l.GreaterEquals=13]="GreaterEquals",l[l.Smaller=14]="Smaller",l[l.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return P.INSTANCE}static true(){return h.INSTANCE}static has(v){return p.create(v)}static equals(v,R){return o.create(v,R)}static notEquals(v,R){return w.create(v,R)}static regex(v,R){return n.create(v,R)}static in(v,R){return d.create(v,R)}static not(v){return S.create(v)}static and(...v){return r.create(v)}static or(...v){return a.create(v)}static greater(v,R){return u.create(v,R)}static less(v,R){return f.create(v,R)}static deserialize(v,R=!1){if(!!v)return this._deserializeOrExpression(v,R)}static _deserializeOrExpression(v,R){let O=v.split("||");return a.create(O.map(H=>this._deserializeAndExpression(H,R)))}static _deserializeAndExpression(v,R){let O=v.split("&&");return r.create(O.map(H=>this._deserializeOne(H,R)))}static _deserializeOne(v,R){if(v=v.trim(),v.indexOf("!=")>=0){let O=v.split("!=");return w.create(O[0].trim(),this._deserializeValue(O[1],R))}if(v.indexOf("==")>=0){let O=v.split("==");return o.create(O[0].trim(),this._deserializeValue(O[1],R))}if(v.indexOf("=~")>=0){let O=v.split("=~");return n.create(O[0].trim(),this._deserializeRegexValue(O[1],R))}if(v.indexOf(" in ")>=0){let O=v.split(" in ");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(v)){const O=v.split(">=");return c.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(v)){const O=v.split(">");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(v)){const O=v.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(v)){const O=v.split("<");return f.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(v)?S.create(v.substr(1).trim()):p.create(v)}static _deserializeValue(v,R){if(v=v.trim(),v==="true")return!0;if(v==="false")return!1;let O=/^'([^']*)'$/.exec(v);return O?O[1].trim():v}static _deserializeRegexValue(v,R){if((0,b.isFalsyOrWhitespace)(v)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=v.indexOf("/"),H=v.lastIndexOf("/");if(O===H||O<0){if(R)throw new Error(`bad regexp-value '${v}', missing /-enclosure`);return console.warn(`bad regexp-value '${v}', missing /-enclosure`),null}let ne=v.slice(O+1,H),ie=v[H+1]==="i"?"i":"";try{return new RegExp(ne,ie)}catch(N){if(R)throw new Error(`bad regexp-value '${v}', parse error: ${N}`);return console.warn(`bad regexp-value '${v}', parse error: ${N}`),null}}}e.ContextKeyExpr=k;function i(l,v){return l.cmp(v)}class P{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class h{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class p{constructor(v){this.key=v,this.type=2}static create(v){const R=y.get(v);return typeof R=="boolean"?R?h.INSTANCE:P.INSTANCE:new p(v)}cmp(v){return v.type!==this.type?this.type-v.type:m(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return S.create(this.key)}}e.ContextKeyDefinedExpr=p;class o{constructor(v,R){this.key=v,this.value=R,this.type=4}static create(v,R){if(typeof R=="boolean")return R?p.create(v):S.create(v);const O=y.get(v);return typeof O=="boolean"?R===(O?"true":"false")?h.INSTANCE:P.INSTANCE:new o(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(v){return v.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=o;class d{constructor(v,R){this.key=v,this.valueKey=R,this.type=10}static create(v,R){return new d(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.valueKey,v.key,v.valueKey)}equals(v){return v.type===this.type?this.key===v.key&&this.valueKey===v.valueKey:!1}evaluate(v){const R=v.getValue(this.valueKey),O=v.getValue(this.key);return Array.isArray(R)?R.indexOf(O)>=0:typeof O=="string"&&typeof R=="object"&&R!==null?C.call(R,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(v){return v.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=d;class E{constructor(v){this._actual=v,this.type=11}static create(v){return new E(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new E(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class w{constructor(v,R){this.key=v,this.value=R,this.type=5}static create(v,R){if(typeof R=="boolean")return R?S.create(v):p.create(v);const O=y.get(v);return typeof O=="boolean"?R===(O?"true":"false")?P.INSTANCE:h.INSTANCE:new w(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(v){return v.mapNotEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class S{constructor(v){this.key=v,this.type=3}static create(v){const R=y.get(v);return typeof R=="boolean"?R?P.INSTANCE:h.INSTANCE:new S(v)}cmp(v){return v.type!==this.type?this.type-v.type:m(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!v.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(v){return v.mapNot(this.key)}negate(){return p.create(this.key)}}e.ContextKeyNotExpr=S;class u{constructor(v,R){this.key=v,this.value=R,this.type=12}static create(v,R){return new u(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class c{constructor(v,R){this.key=v,this.value=R,this.type=13}static create(v,R){return new c(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreaterEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class f{constructor(v,R){this.key=v,this.value=R,this.type=14}static create(v,R){return new f(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=f;class t{constructor(v,R){this.key=v,this.value=R,this.type=15}static create(v,R){return new t(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(v,R){this.key=v,this.regexp=R,this.type=7}static create(v,R){return new n(v,R)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.key<v.key)return-1;if(this.key>v.key)return 1;const R=this.regexp?this.regexp.source:"",O=v.regexp?v.regexp.source:"";return R<O?-1:R>O?1:0}equals(v){if(v.type===this.type){const R=this.regexp?this.regexp.source:"",O=v.regexp?v.regexp.source:"";return this.key===v.key&&R===O}return!1}evaluate(v){let R=v.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const v=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${v}`}keys(){return[this.key]}map(v){return v.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(v){this._actual=v,this.type=8}static create(v){return new s(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new s(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class r{constructor(v){this.expr=v,this.type=6}static create(v){return r._normalizeArr(v)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let R=0,O=this.expr.length;R<O;R++){const H=i(this.expr[R],v.expr[R]);if(H!==0)return H}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].equals(v.expr[R]))return!1;return!0}return!1}evaluate(v){for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].evaluate(v))return!1;return!0}static _normalizeArr(v){const R=[];let O=!1;for(const H of v)if(!!H){if(H.type===1){O=!0;continue}if(H.type===0)return P.INSTANCE;if(H.type===6){R.push(...H.expr);continue}R.push(H)}if(R.length===0&&O)return h.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(i);R.length>1;){const H=R[R.length-1];if(H.type!==9)break;R.pop();const ne=R.pop(),ie=a.create(H.expr.map(N=>r.create([N,ne])));ie&&(R.push(ie),R.sort(i))}return R.length===1?R[0]:new r(R)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(let R of this.expr)v.push(...R.keys());return v}map(v){return new r(this.expr.map(R=>R.map(v)))}negate(){let v=[];for(let R of this.expr)v.push(R.negate());return a.create(v)}}e.ContextKeyAndExpr=r;class a{constructor(v){this.expr=v,this.type=9}static create(v){const R=a._normalizeArr(v);if(R.length!==0)return R.length===1?R[0]:new a(R)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let R=0,O=this.expr.length;R<O;R++){const H=i(this.expr[R],v.expr[R]);if(H!==0)return H}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].equals(v.expr[R]))return!1;return!0}return!1}evaluate(v){for(let R=0,O=this.expr.length;R<O;R++)if(this.expr[R].evaluate(v))return!0;return!1}static _normalizeArr(v){let R=[],O=!1;if(v){for(let H=0,ne=v.length;H<ne;H++){const ie=v[H];if(!!ie){if(ie.type===0){O=!0;continue}if(ie.type===1)return[h.INSTANCE];if(ie.type===9){R=R.concat(ie.expr);continue}R.push(ie)}}if(R.length===0&&O)return[P.INSTANCE];R.sort(i)}return R}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(let R of this.expr)v.push(...R.keys());return v}map(v){return new a(this.expr.map(R=>R.map(v)))}negate(){let v=[];for(let O of this.expr)v.push(O.negate());const R=O=>O.type===9?O.expr:[O];for(;v.length>1;){const O=v.shift(),H=v.shift(),ne=[];for(const ie of R(O))for(const N of R(H))ne.push(k.and(ie,N));v.unshift(k.or(...ne))}return v[0]}}e.ContextKeyOrExpr=a;class g extends p{constructor(v,R,O){super(v);this._defaultValue=R,typeof O=="object"?g._info.push(Object.assign(Object.assign({},O),{key:v})):O!==!0&&g._info.push({key:v,description:O,type:R!=null?typeof R:void 0})}static all(){return g._info.values()}bindTo(v){return v.createKey(this.key,this._defaultValue)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(v){return k.equals(this.key,v)}notEqualsTo(v){return k.notEquals(this.key,v)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(l,v){return l<v?-1:l>v?1:0}function _(l,v,R,O){return l<R?-1:l>R?1:v<O?-1:v>O?1:0}}),define(me[179],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(me[180],ge([0,1,152,4,12]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function T(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=T;var y;(function(P){P[P.NoneOrRelevance=0]="NoneOrRelevance",P[P.LastUpdatedDate=1]="LastUpdatedDate",P[P.Title=2]="Title",P[P.PublisherName=3]="PublisherName",P[P.InstallCount=4]="InstallCount",P[P.PublishedDate=5]="PublishedDate",P[P.AverageRating=6]="AverageRating",P[P.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var C;(function(P){P[P.Default=0]="Default",P[P.Ascending=1]="Ascending",P[P.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var D;(function(P){P.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var k;(function(P){P[P.None=0]="None",P[P.Install=1]="Install",P[P.Update=2]="Update"})(k=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(h,p){super(h);this.code=p}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=I.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,b.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,b.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,8,4]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function I(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class y{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,P){if(typeof i=="undefined"||i===null)return typeof P=="undefined"||P===null;if(typeof P=="undefined"||P===null)return!1;if(typeof i=="string"||typeof P=="string"){let h=typeof i=="string"?i:i.value,p=typeof P=="string"?P:P.value;return b.equalsIgnoreCase(h,p)}return i._lower===P._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=y;function C(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function D(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[181],ge([0,1,8,26]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(p,o){return p.uuid&&o.uuid?p.uuid===o.uuid:p.id===o.id?!0:(0,b.compareIgnoreCase)(p.id,o.id)===0}e.areSameExtensions=I;class T{constructor(o,d){this.version=d,this.id=o.id,this.uuid=o.uuid}key(){return`${this.id}-${this.version}`}equals(o){return o instanceof T?I(this,o)&&this.version===o.version:!1}}e.ExtensionIdentifierWithVersion=T;function y(p,o){return`${p}.${o}`}e.getExtensionId=y;function C(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function D(p,o){return C(y(p,o))}e.getGalleryExtensionId=D;function k(p,o){const d=[],E=w=>{for(const S of d)if(S.some(u=>I(o(u),o(w))))return S;return null};for(const w of p){const S=E(w);S?S.push(w):d.push([w])}return d}e.groupByExtension=k;function i(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function P(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function h(p){const o=new Set;for(const d of p)d.malicious&&o.add(d.id.id);return o}e.getMaliciousExtensionsSet=h}),define(me[182],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,b.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,b.createDecorator)("externalTerminal")}),define(me[44],ge([0,1,155,9,2,4,8,11,22]),function(G,e,b,L,I,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function k(N){return N.create===!0}e.isFileOpenForWriteOptions=k;var i;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var P;(function(N){N[N.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var h;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(h=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=p;function o(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=o;function d(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function E(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=E;var w;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(B,U){super(B);this.code=U}}e.FileSystemProviderError=S;function u(N,B){const U=new S(N.toString(),B);return f(U,B),U}e.createFileSystemProviderError=u;function c(N){return N||u((0,b.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=c;function f(N,B){return N.name=B?`${B} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=f;function t(N){if(!N)return w.Unknown;if(N instanceof S)return N.code;const B=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!B)return w.Unknown;switch(B[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function n(N){if(N instanceof _)return N.fileOperationResult;switch(t(N)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(B,U,A){this.resource=B,this.operation=U,this.target=A}isOperation(B){return this.operation===B}}e.FileOperationEvent=r;var a;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class g{constructor(B,U){this.ignorePathCasing=U,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const A of B)switch(A.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(A.resource,A);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(A.resource,A);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(A.resource,A);break}}contains(B,...U){return this.doContains(B,{includeChildren:!1},...U)}affects(B,...U){return this.doContains(B,{includeChildren:!0},...U)}doContains(B,U,...A){var x,F,M,W,z,Y;if(!B)return!1;const le=A.length>0;return!!((!le||A.includes(1))&&(((x=this.added)===null||x===void 0?void 0:x.get(B))||U.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(B)))||(!le||A.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(B))||U.includeChildren&&((W=this.updated)===null||W===void 0?void 0:W.findSuperstr(B)))||(!le||A.includes(2))&&(((z=this.deleted)===null||z===void 0?void 0:z.findSubstr(B))||U.includeChildren&&((Y=this.deleted)===null||Y===void 0?void 0:Y.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const U=[],A=B===1?this.added:B===0?this.updated:this.deleted;if(A)for(const[,x]of A)U.push(x);return U}filter(B){return new g(this.changes.filter(U=>B(U)),this.ignorePathCasing)}}e.FileChangesEvent=g;function m(N,B,U){return!N||!B||N===B||B.length>N.length?!1:(B.charAt(B.length-1)!==L.sep&&(B+=L.sep),U?(0,y.startsWithIgnoreCase)(N,B):N.indexOf(B)===0)}e.isParent=m;class _ extends Error{constructor(B,U,A){super(B);this.fileOperationResult=U,this.options=A}static isFileOperationError(B){return B instanceof Error&&!(0,C.isUndefinedOrNull)(B.fileOperationResult)}}e.FileOperationError=_;var l;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(l=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var v;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(v=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=R;async function O(N,B){if(!B.canHandleResource(I.URI.from({scheme:N.scheme})))return new Promise(U=>{const A=B.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===N.scheme&&x.added&&(A.dispose(),U())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(B){return(0,C.isNumber)(B)||(B=0),B<H.KB?(0,b.localize)(1,null,B.toFixed(0)):B<H.MB?(0,b.localize)(2,null,(B/H.KB).toFixed(2)):B<H.GB?(0,b.localize)(3,null,(B/H.MB).toFixed(2)):B<H.TB?(0,b.localize)(4,null,(B/H.GB).toFixed(2)):(0,b.localize)(5,null,(B/H.TB).toFixed(2))}}e.ByteSize=H,H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB;var ne;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(ne=e.Arch||(e.Arch={}));function ie(N){return{maxFileSize:N===0?300*H.MB:16*H.GB,maxHeapSize:N===0?700*H.MB:2*700*H.MB}}e.getPlatformLimits=ie}),define(me[82],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...I){this._entries=new Map;for(let[T,y]of I)this.set(T,y)}set(I,T){const y=this._entries.get(I);return this._entries.set(I,T),y}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=b}),define(me[183],ge([0,1,17,175,112,4,82,13]),function(G,e,b,L,I,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class k extends Error{constructor(o){var d;super("cyclic dependency between services");this.message=(d=o.findCycleSlow())!==null&&d!==void 0?d:`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class i{constructor(o=new y.ServiceCollection,d=!1,E){this._activeInstantiations=new Set,this._services=o,this._strict=d,this._parent=E,this._services.set(T.IInstantiationService,this)}createChild(o){return new i(o,this._strict,this)}invokeFunction(o,...d){let E=h.traceInvocation(o),w=!1;try{return o({get:(u,c)=>{if(w)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(u,E);if(!f&&c!==T.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return f}},...d)}finally{w=!0,E.stop()}}createInstance(o,...d){let E,w;return o instanceof I.SyncDescriptor?(E=h.traceCreation(o.ctor),w=this._createInstance(o.ctor,o.staticArguments.concat(d),E)):(E=h.traceCreation(o),w=this._createInstance(o,d,E)),E.stop(),w}_createInstance(o,d=[],E){let w=T._util.getServiceDependencies(o).sort((c,f)=>c.index-f.index),S=[];for(const c of w){let f=this._getOrCreateServiceInstance(c.id,E);if(!f&&this._strict&&!c.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${c.id}.`);S.push(f)}let u=w.length>0?w[0].index:d.length;if(d.length!==u){console.warn(`[createInstance] First service dependency of ${o.name} at position ${u+1} conflicts with ${d.length} static arguments`);let c=u-d.length;c>0?d=d.concat(new Array(c)):d=d.slice(0,u)}return new o(...[...d,...S])}_setServiceInstance(o,d){if(this._services.get(o)instanceof I.SyncDescriptor)this._services.set(o,d);else if(this._parent)this._parent._setServiceInstance(o,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let d=this._services.get(o);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):d}_getOrCreateServiceInstance(o,d){let E=this._getServiceInstanceOrDescriptor(o);return E instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,E,d.branch(o,!0)):(d.branch(o,!1),E)}_safeCreateAndCacheServiceInstance(o,d,E){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,d,E)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,d,E){const w=new L.Graph(c=>c.id.toString());let S=0;const u=[{id:o,desc:d,_trace:E}];for(;u.length;){const c=u.pop();if(w.lookupOrInsertNode(c),S++>1e3)throw new k(w);for(let f of T._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(f.id);if(!t&&!f.optional&&console.warn(`[createInstance] ${o} depends on ${f.id} which is NOT registered.`),t instanceof I.SyncDescriptor){const n={id:f.id,desc:t,_trace:c._trace.branch(f.id,!0)};w.insertEdge(c,n),u.push(n)}}}for(;;){const c=w.roots();if(c.length===0){if(!w.isEmpty())throw new k(w);break}for(const{data:f}of c){if(this._getServiceInstanceOrDescriptor(f.id)instanceof I.SyncDescriptor){const n=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,n)}w.removeNode(f)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,d,E=[],w,S){if(this._services.get(o)instanceof I.SyncDescriptor)return this._createServiceInstance(d,E,w,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,d,E,w,S);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(o,d=[],E,w){if(E){const S=new C.IdleValue(()=>this._createInstance(o,d,w));return new Proxy(Object.create(null),{get(u,c){if(c in u)return u[c];let f=S.value,t=f[c];return typeof t!="function"||(t=t.bind(f),u[c]=t),t},set(u,c,f){return S.value[c]=f,!0}})}else return this._createInstance(o,d,w)}}e.InstantiationService=i;var P;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(P||(P={}));class h{constructor(o,d){this.type=o,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return D?new h(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(o){return D?new h(0,o.name):h._None}branch(o,d){let E=new h(2,o.toString());return this._dep.push([o,d,E]),E}stop(){let o=Date.now()-this._start;h._totals+=o;let d=!1;function E(S,u){let c=[],f=new Array(S+1).join("	");for(const[t,n,s]of u._dep)if(n&&s){d=!0,c.push(`${f}CREATES -> ${t}`);let r=E(S+1,s);r&&c.push(r)}else c.push(`${f}uses -> ${t}`);return c.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(o>2||d)&&console.log(w.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(me[14],ge([0,1,4,6,10,3,60]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function C(){return new Date().toISOString()}var D;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class k extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class i extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(D.Error,this.format(s))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}n+=(s>0?" ":"")+r}return n}}e.AbstractMessageLogger=i;class P extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!I.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...n):console.warn(`[main ${C()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class h extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=h;class p extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class o extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=o;class d extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=d;class E extends L.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class w{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=w;function S(f){if(f.verbose)return D.Trace;if(typeof f.logLevel=="string"){const t=u(f.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function u(f){switch(f){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=u;function c(f){switch(f){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=c}),define(me[113],ge([0,1,14,44]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function I(D,k,i,P){try{return(await new Promise((p,o)=>{G(["spdlog"],p,o)})).createAsyncRotatingLogger(D,k,i,P)}catch(h){console.error(h)}return null}function T(D,k,i,P){return G.__$__nodeRequire("spdlog").createRotatingLogger(D,k,i,P)}e.createRotatingLogger=T;function y(D,k,i){switch(k){case b.LogLevel.Trace:D.trace(i);break;case b.LogLevel.Debug:D.debug(i);break;case b.LogLevel.Info:D.info(i);break;case b.LogLevel.Warning:D.warn(i);break;case b.LogLevel.Error:D.error(i);break;case b.LogLevel.Critical:D.critical(i);break;default:throw new Error("Invalid log level")}D.flush()}class C extends b.AbstractMessageLogger{constructor(k,i,P,h){super();this.name=k,this.filepath=i,this.rotating=P,this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const k=this.rotating?6:1,i=30/k*L.ByteSize.MB;return I(this.name,this.filepath,i,k).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:h,message:p}of this.buffer)y(this._logger,h,p);this.buffer=[]}})}log(k,i){this._logger?y(this._logger,k,i):this.getLevel()<=k&&this.buffer.push({level:k,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(me[114],ge([0,1,4,156,58]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function k(o,d){return d-o}D.compare=k;const i=Object.create(null);i[D.Error]=(0,L.localize)(0,null),i[D.Warning]=(0,L.localize)(1,null),i[D.Info]=(0,L.localize)(2,null);function P(o){return i[o]||""}D.toString=P;function h(o){switch(o){case I.default.Error:return D.Error;case I.default.Warning:return D.Warning;case I.default.Info:return D.Info;case I.default.Ignore:return D.Hint}}D.fromSeverity=h;function p(o){switch(o){case D.Error:return I.default.Error;case D.Warning:return I.default.Warning;case D.Info:return I.default.Info;case D.Hint:return I.default.Ignore}}D.toSeverity=p}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(D){const k="";function i(h){return P(h,!0)}D.makeKey=i;function P(h,p){let o=[k];return h.source?o.push(h.source.replace("\xA6","\\\xA6")):o.push(k),h.code?typeof h.code=="string"?o.push(h.code.replace("\xA6","\\\xA6")):o.push(h.code.value.replace("\xA6","\\\xA6")):o.push(k),h.severity!==void 0&&h.severity!==null?o.push(y.toString(h.severity)):o.push(k),h.message&&p?o.push(h.message.replace("\xA6","\\\xA6")):o.push(k),h.startLineNumber!==void 0&&h.startLineNumber!==null?o.push(h.startLineNumber.toString()):o.push(k),h.startColumn!==void 0&&h.startColumn!==null?o.push(h.startColumn.toString()):o.push(k),h.endLineNumber!==void 0&&h.endLineNumber!==null?o.push(h.endLineNumber.toString()):o.push(k),h.endColumn!==void 0&&h.endColumn!==null?o.push(h.endColumn.toString()):o.push(k),o.push(k),o.join("\xA6")}D.makeKeyOptionalMessage=P})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(me[184],ge([0,1,58,4,3]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=b.default,e.INotificationService=(0,L.createDecorator)("notificationService");var T;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new D,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=C;class D{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=D}),define(me[185],ge([0,1,12,10,36,25]),function(G,e,b,L,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const C=L.globals.vscode.context.configuration();if(C)y=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const C=(0,T.dirname)(b.FileAccess.asFileUri("",G));y=G.__$__nodeRequire((0,T.joinPath)(C,"product.json").fsPath);const D=G.__$__nodeRequire((0,T.joinPath)(C,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.57.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var We=this&&this.__param||function(G,e){return function(b,L){e(b,L,G)}};define(me[115],ge([0,1,4,21,6,13]),function(G,e,b,L,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,b.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let D=class extends I.Disposable{constructor(P,h){super();this.deferred=new T.DeferredPromise,h.withProgress(P,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};D=qe([We(1,e.IProgressService)],D),e.UnmanagedProgress=D;class k extends I.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(P){this.stop();const h=++this.currentOperationId,p=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{h===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:h,token:p.token,stop:()=>this.doStop(h),isCurrent:()=>this.currentOperationId===h}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,b.createDecorator)("editorProgressService")}),define(me[39],ge([0,1,11,52]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(y,C){L.ok(b.isString(y)),L.ok(b.isObject(C)),L.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,C)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new I}),define(me[116],ge([0,1,39,3]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class T{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,k){this.schemasById[I(D)]=k,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new T;b.Registry.add(e.Extensions.JSONContribution,y)}),define(me[83],ge([0,1,151,3,39,11,116]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=I.Registry.as(y.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,S=!0){this.registerConfigurations([w],S)}registerConfigurations(w,S=!0){const u=[];w.forEach(c=>{u.push(...this.validateAndRegisterProperties(c,S,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(w){const S=[],u=c=>{if(c.properties)for(const f in c.properties)S.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,c.properties[f]);c.allOf&&c.allOf.forEach(f=>u(f))};for(const c of w){u(c);const f=this.configurationContributors.indexOf(c);f!==-1&&this.configurationContributors.splice(f,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(w){const S=[],u=[];for(const c of w)for(const f in c)if(S.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]=Object.assign(Object.assign({},this.defaultValues[f]||{}),c[f]);const t={type:"object",default:this.defaultValues[f],description:b.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};u.push(P(f)),this.configurationProperties[f]=t,this.defaultLanguageConfigurationOverridesNode.properties[f]=t}else{this.defaultValues[f]=c[f];const t=this.configurationProperties[f];t&&(this.updatePropertyDefaultValue(f,t),this.updateSchema(f,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(w){const S=[];for(const u of w)for(const c in u)if(S.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const f=this.configurationProperties[c];f&&(this.updatePropertyDefaultValue(c,f),this.updateSchema(c,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const S of w)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,S=!0,u,c=3){var f;c=T.isUndefinedOrNull(w.scope)?c:w.scope;let t=[],n=w.properties;if(n)for(let r in n){if(S&&o(r)){delete n[r];continue}const a=n[r];if(this.updatePropertyDefaultValue(r,a),e.OVERRIDE_PROPERTY_PATTERN.test(r)?a.scope=void 0:(a.scope=T.isUndefinedOrNull(a.scope)?c:a.scope,a.restricted=T.isUndefinedOrNull(a.restricted)?!!((f=u==null?void 0:u.restrictedConfigurations)===null||f===void 0?void 0:f.includes(r)):a.restricted),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let s=w.allOf;if(s)for(let r of s)t.push(...this.validateAndRegisterProperties(r,S,u,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const S=u=>{let c=u.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let f=u.allOf;f&&f.forEach(S)};S(w)}updateSchema(w,S){switch(e.allSettings.properties[w]=S,S.scope){case 1:e.applicationSettings.properties[w]=S;break;case 2:e.machineSettings.properties[w]=S;break;case 6:e.machineOverridableSettings.properties[w]=S;break;case 3:e.windowSettings.properties[w]=S;break;case 4:e.resourceSettings.properties[w]=S;break;case 5:e.resourceSettings.properties[w]=S,this.resourceLanguageSettingsSchema.properties[w]=S;break}}removeFromSchema(w,S){switch(delete e.allSettings.properties[w],S.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const S=`[${w}]`,u={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,u),e.allSettings.properties[S]=u,e.applicationSettings.properties[S]=u,e.machineSettings.properties[S]=u,e.machineOverridableSettings.properties[S]=u,e.windowSettings.properties[S]=u,e.resourceSettings.properties[S]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,S){let u=this.defaultValues[w];T.isUndefined(u)&&(u=S.default),T.isUndefined(u)&&(u=h(S.type)),S.default=u}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function P(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=P;function h(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const p=new k;I.Registry.add(e.Extensions.Configuration,p);function o(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?b.localize(5,null,E):p.getConfigurationProperties()[E]!==void 0?b.localize(6,null,E):null:b.localize(4,null)}e.validateProperty=o;function d(){const E=[],w=p.getConfigurationProperties();for(const S of Object.keys(w))E.push([S,w[S].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=d}),define(me[84],ge([0,1,24,11,2,39,4,83]),function(G,e,b,L,I,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof I.URI)}e.isConfigurationOverrides=D;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function P(n,s){const r=s?n?s.keys.filter(R=>n.keys.indexOf(R)===-1):[...s.keys]:[],a=n?s?n.keys.filter(R=>s.keys.indexOf(R)===-1):[...n.keys]:[],g=[];if(s&&n){for(const R of n.keys)if(s.keys.indexOf(R)!==-1){const O=w(n.contents,R),H=w(s.contents,R);b.equals(O,H)||g.push(R)}}const m=[],_=R=>{const O={};for(const H of R)for(const ne of H.identifiers)O[f(ne)]=H;return O},l=s?_(s.overrides):{},v=n?_(n.overrides):{};if(Object.keys(l).length)for(const R of r){const O=l[R];O&&m.push([(0,C.overrideIdentifierFromKey)(R),O.keys])}if(Object.keys(v).length)for(const R of a){const O=v[R];O&&m.push([(0,C.overrideIdentifierFromKey)(R),O.keys])}if(Object.keys(l).length&&Object.keys(v).length)for(const R of g){const O=v[R],H=l[R];if(O&&H){const ne=P({contents:O.contents,keys:O.keys,overrides:[]},{contents:H.contents,keys:H.keys,overrides:[]});m.push([(0,C.overrideIdentifierFromKey)(R),[...ne.added,...ne.removed,...ne.updated]])}}return{added:r,removed:a,updated:g,overrides:m}}e.compare=P;function h(n,s){const r=[];for(const a of Object.keys(n))if(C.OVERRIDE_PROPERTY_PATTERN.test(a)){const g={};for(const m in n[a])g[m]=n[a][m];r.push({identifiers:[(0,C.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(g),contents:p(g,s)})}return r}e.toOverrides=h;function p(n,s){const r=Object.create(null);for(let a in n)o(r,a,n[a],s);return r}e.toValuesTree=p;function o(n,s,r,a){const g=s.split("."),m=g.pop();let _=n;for(let l=0;l<g.length;l++){let v=g[l],R=_[v];switch(typeof R){case"undefined":R=_[v]=Object.create(null);break;case"object":break;default:a(`Ignoring ${s} as ${g.slice(0,l+1).join(".")} is ${JSON.stringify(R)}`);return}_=R}if(typeof _=="object"&&_!==null)try{_[m]=r}catch(l){a(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(_)}`)}else a(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=o;function d(n,s){const r=s.split(".");E(n,r)}e.removeFromValueTree=d;function E(n,s){const r=s.shift();if(s.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const a=n[r];typeof a=="object"&&!Array.isArray(a)&&(E(a,s),Object.keys(a).length===0&&delete n[r])}}function w(n,s,r){function a(_,l){let v=_;for(const R of l){if(typeof v!="object"||v===null)return;v=v[R]}return v}const g=s.split("."),m=a(n,g);return typeof m=="undefined"?r:m}e.getConfigurationValue=w;function S(n,s,r){Object.keys(s).forEach(a=>{a!=="__proto__"&&(a in n?L.isObject(n[a])&&L.isObject(s[a])?S(n[a],s[a],r):r&&(n[a]=s[a]):n[a]=s[a])})}e.merge=S;function u(){const n=T.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=u;function c(){const n=Object.create(null),s=T.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let r in s){let a=s[r].default;o(n,r,a,g=>console.error(`Conflict in default settings: ${g}`))}return n}e.getDefaultValues=c;function f(n){return`[${n}]`}e.keyFromOverrideIdentifier=f;function t(n,s,r){const a=n.inspect(s),g=n.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:a.defaultValue}e.getMigratedSettingValue=t}),define(me[186],ge([0,1,56,22,16,11,24,2,83,84,39,6,3]),function(G,e,b,L,I,T,y,C,D,k,i,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,k.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const r of I.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[r],g=n[r];g&&(typeof a=="object"&&typeof g=="object"?(a=y.deepClone(a),this.mergeContents(a,g)):a=g),s[r]=a}return new p(s,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),s=y.deepClone(this.overrides),r=[...this.keys];for(const a of t){this.mergeContents(n,a.contents);for(const g of a.overrides){const[m]=s.filter(_=>I.equals(_.identifiers,g.identifiers));m?this.mergeContents(m.contents,g.contents):s.push(y.deepClone(g))}for(const g of a.keys)r.indexOf(g)===-1&&r.push(g)}return new p(n,r,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&T.isObject(t[s])&&T.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=y.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class o extends p{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),s=[];for(const r of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,D.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,k.toValuesTree)(t[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,n,s)}}e.DefaultConfigurationModel=o;class d{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:r,overrides:a,restricted:g}=this.doParseRaw(t,n);this._configurationModel=new p(s,r,a),this._restrictedConfigurations=g||[]}doParseContent(t){let n={},s=null,r=[],a=[],g=[];function m(l){Array.isArray(r)?r.push(l):s&&(r[s]=l)}let _={onObjectBegin:()=>{let l={};m(l),a.push(r),r=l,s=null},onObjectProperty:l=>{s=l},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let l=[];m(l),a.push(r),r=l,s=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:m,onError:(l,v,R)=>{g.push({error:l,offset:v,length:R})}};if(t)try{b.visit(t,_),n=r[0]||{}}catch(l){console.error(`Error while parsing settings file ${this._name}: ${l}`),this._parseErrors=[l]}return n}doParseRaw(t,n){const s=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,n);t=r.raw;const a=(0,k.toValuesTree)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),g=Object.keys(t),m=(0,k.toOverrides)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:a,keys:g,overrides:m,restricted:r.restricted}}filter(t,n,s,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.skipRestricted))return{raw:t,restricted:[]};const a={},g=[];for(let m in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(m)&&s){const _=this.filter(t[m],n,!1,r);a[m]=_.raw,g.push(..._.restricted)}else{const _=n[m],l=_?typeof _.scope!="undefined"?_.scope:3:void 0;(_==null?void 0:_.restricted)&&g.push(m),(l===void 0||r.scopes===void 0||r.scopes.includes(l))&&(r.skipRestricted&&(_==null?void 0:_.restricted)||(a[m]=t[m]))}return{raw:a,restricted:g}}}e.ConfigurationModelParser=d;class E extends P.Disposable{constructor(t,n,s,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new h.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(h.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class w{constructor(t,n,s=new p,r=new p,a=new L.ResourceMap,g=new p,m=new L.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=g,this._memoryConfigurationByResource=m,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new p,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const r=this.getConsolidateConfigurationModel(n,s),a=this.getFolderConfigurationModelForResource(n.resource,s),g=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,m=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),l=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),v=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,H=n.overrideIdentifier?g.override(n.overrideIdentifier).getValue(t):g.getValue(t),ne=r.getValue(t),ie=I.distinct(I.flatten(r.overrides.map(N=>N.identifiers))).filter(N=>r.getOverrideValue(t,N)!==void 0);return{defaultValue:m,userValue:_,userLocalValue:l,userRemoteValue:v,workspaceValue:R,workspaceFolderValue:O,memoryValue:H,value:ne,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:l!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:v!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:n.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:g.getValue(t),override:n.overrideIdentifier?g.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ie.length?ie:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(r=>D.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,D.overrideIdentifierFromKey)(r),g=this._defaultConfiguration.getKeysForOverrideIdentifier(a),m=t.getKeysForOverrideIdentifier(a),_=[...m.filter(l=>g.indexOf(l)===-1),...g.filter(l=>m.indexOf(l)===-1),...g.filter(l=>!y.equals(this._defaultConfiguration.override(a).getValue(l),t.override(a).getValue(l)))];return[a,_]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:a}=(0,k.compare)(this.localUserConfiguration,t),g=[...n,...s,...r];return g.length&&this.updateLocalUserConfiguration(t),{keys:g,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:a}=(0,k.compare)(this.remoteUserConfiguration,t);let g=[...n,...s,...r];return g.length&&this.updateRemoteUserConfiguration(t),{keys:g,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:r,overrides:a}=(0,k.compare)(this.workspaceConfiguration,t);let g=[...n,...s,...r];return g.length&&this.updateWorkspaceConfiguration(t),{keys:g,overrides:a}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:r,updated:a,removed:g,overrides:m}=(0,k.compare)(s,n);let _=[...r,...a,...g];return(_.length||!s)&&this.updateFolderConfiguration(t,n),{keys:_,overrides:m}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:a,overrides:g}=(0,k.compare)(n,void 0);return{keys:[...s,...r,...a],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const a=this._memoryConfigurationByResource.get(t);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=s.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:r,keys:a}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:r,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((g,m)=>(g.set(C.URI.revive(m[0]),this.parseConfigurationModel(m[1])),g),new L.ResourceMap);return new w(n,s,new p,r,a,new p,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function S(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const t=new Set,n=new Map;for(const r of f)r.keys.forEach(a=>t.add(a)),r.overrides.forEach(([a,g])=>{const m=(0,L.getOrSet)(n,a,new Set);g.forEach(_=>m.add(_))});const s=[];return n.forEach((r,a)=>s.push([a,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=S;class u{constructor(t,n,s,r){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(m=>a.add(m)),t.overrides.forEach(([,m])=>m.forEach(_=>a.add(_))),this.affectedKeys=[...a.values()];const g=new p;this.affectedKeys.forEach(m=>g.setValue(m,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,a=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,k.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=u;class c extends u{constructor(t,n,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=c}),define(me[187],ge([0,1,38,9,111,154,28,10,182,84,4,12,135]),function(G,e,b,L,I,T,y,C,D,k,i,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const p=T.localize(0,null);class o{async getDefaultTerminalForPlatforms(){const t=await w.getDefaultTerminalLinuxReady();return{windows:d.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let d=class Ht extends o{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,I.getWindowsShell(),t)}spawnTerminal(t,n,s,r){const a=n.terminal.external,g=(a==null?void 0:a.windowsExec)||Ht.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const m=L.basename(g).toLowerCase();if(m==="cmder"||m==="cmder.exe")return t.spawn(g,r?[r]:void 0),Promise.resolve(void 0);const _=["/c","start","/wait"];return g.indexOf(" ")>=0&&_.push('""'),_.push(g),(m==="wt"||m==="wt.exe")&&_.push("-d ."),new Promise((l,v)=>{const R=S(process),O=t.spawn(s,_,{cwd:r,env:R});O.on("error",v),O.on("exit",()=>l())})}runInTerminal(t,n,s,r,a){const g="windowsExec"in a&&a.windowsExec?a.windowsExec:Ht.getDefaultTerminalWindows();return new Promise((m,_)=>{const l=`"${n} - ${p}"`,v=`""${s.join('" "')}" & pause"`,R=["/c","start",l,"/wait",g,"/c",v],O=Object.assign({},S(process),r);Object.keys(O).filter(ie=>O[ie]===null).forEach(ie=>delete O[ie]);const H={cwd:n,env:O,windowsVerbatimArguments:!0};b.spawn(Ht.CMD,R,H).on("error",ie=>{_(u(ie))}),m(void 0)})}static getDefaultTerminalWindows(){if(!Ht._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Ht._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return Ht._DEFAULT_TERMINAL_WINDOWS}};d.CMD="cmd.exe",d=qe([We(0,(0,i.optional)(k.IConfigurationService))],d),e.WindowsExternalTerminalService=d;let E=class Ln extends o{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,t)}runInTerminal(t,n,s,r,a){const g=a.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((m,_)=>{if(g===D.DEFAULT_TERMINAL_OSX||g==="iTerm.app"){const l=g===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[P.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,G).fsPath,"-t",t||p,"-w",n];for(let ne of s)R.push("-a"),R.push(ne);if(r)for(let ne in r){const ie=r[ne];ie===null?(R.push("-u"),R.push(ne)):(R.push("-e"),R.push(`${ne}=${ie}`))}let O="";const H=b.spawn(Ln.OSASCRIPT,R);H.on("error",ne=>{_(u(ne))}),H.stderr.on("data",ne=>{O+=ne.toString()}),H.on("exit",ne=>{if(ne===0)m(void 0);else if(O){const ie=O.split(`
`,1);_(new Error(ie[0]))}else _(new Error(T.localize(1,null,l,ne)))})}else _(new Error(T.localize(2,null,g)))})}spawnTerminal(t,n,s){const r=n.terminal.external,a=(r==null?void 0:r.osxExec)||D.DEFAULT_TERMINAL_OSX;return new Promise((g,m)=>{const _=["-a",a];s&&_.push(s);const l=t.spawn("/usr/bin/open",_);l.on("error",m),l.on("exit",()=>g())})}};E.OSASCRIPT="/usr/bin/osascript",E=qe([We(0,(0,i.optional)(k.IConfigurationService))],E),e.MacExternalTerminalService=E;let w=class zt extends o{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,t)}runInTerminal(t,n,s,r,a){const g=a.linuxExec?Promise.resolve(a.linuxExec):zt.getDefaultTerminalLinuxReady();return new Promise((m,_)=>{let l=[];g.then(v=>{v.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const R=`${c(s)}; echo; read -p "${zt.WAIT_MESSAGE}" -n1;`;l.push(`''${R}''`);const O=Object.assign({},process.env,r);Object.keys(O).filter(N=>O[N]===null).forEach(N=>delete O[N]);const H={cwd:n,env:O};let ne="";const ie=b.spawn(v,l,H);ie.on("error",N=>{_(u(N))}),ie.stderr.on("data",N=>{ne+=N.toString()}),ie.on("exit",N=>{if(N===0)m(void 0);else if(ne){const B=ne.split(`
`,1);_(new Error(B[0]))}else _(new Error(T.localize(4,null,v,N)))})})})}static async getDefaultTerminalLinuxReady(){return zt._DEFAULT_TERMINAL_LINUX_READY||(zt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{C.isLinux?await y.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),zt._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,n,s){const r=n.terminal.external,a=(r==null?void 0:r.linuxExec)?Promise.resolve(r.linuxExec):zt.getDefaultTerminalLinuxReady();return new Promise((g,m)=>{a.then(_=>{const l=S(process),v=t.spawn(_,[],{cwd:s,env:l});v.on("error",m),v.on("exit",()=>g())})})}};w.WAIT_MESSAGE=T.localize(3,null),w=qe([We(0,(0,i.optional)(k.IConfigurationService))],w),e.LinuxExternalTerminalService=w;function S(f){const t=f.env;return(0,h.sanitizeProcessEnvironment)(t),t}function u(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(T.localize(5,null,f.path)):f}function c(f){let t="";for(let n of f)n.indexOf(" ")>=0?t+='"'+n+'"':t+=n,t+=" ";return t}}),define(me[85],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,b.createDecorator)("remoteAuthorityResolverService");var L;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(L=e.RemoteTrustOption||(e.RemoteTrustOption={}));var I;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(C,D=I.Unknown,k){super(C);this._message=C,this._code=D,this._detail=k,this.isHandled=D===I.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(C){return C instanceof T&&C._code===I.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof T&&C._code===I.NoResolverFound}static isHandled(C){return C instanceof T&&C.isHandled}}e.RemoteAuthorityResolverError=T}),define(me[117],ge([0,1,12]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function L(D){return D.scheme===b.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=L;function I(D){if(!!D){const k=D.indexOf("+");return k<0?D:D.substr(0,k)}}e.getRemoteName=I;function T(D){return D.scheme!==b.Schemas.file&&D.scheme!==b.Schemas.vscodeRemote}function y(D){if(D.folders.length)return D.folders.every(k=>T(k.uri))?D.folders[0].uri:void 0;if(D.configuration&&T(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function C(D){var k;return(k=y(D))===null||k===void 0?void 0:k.scheme}e.getVirtualWorkspaceScheme=C}),define(me[188],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class b{vsda(){return new Promise((I,T)=>G(["vsda"],I,T))}async sign(I){try{const T=await this.vsda(),y=new T.signer;if(y)return y.sign(I)}catch(T){}return I}}e.SignService=b}),define(me[189],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class b{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,T,y=5){let C;return C=T(D=>{const k=typeof D=="string"?D:D.data;let i=this._terminalBufferMap.get(I);if(i){i.data.push(k);return}const P=setTimeout(()=>this.flushBuffer(I),y);i={data:[k],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(I),C.dispose()}},this._terminalBufferMap.set(I,i)}),C}stopBuffering(I){const T=this._terminalBufferMap.get(I);T&&T.dispose()}flushBuffer(I){const T=this._terminalBufferMap.get(I);T&&(this._terminalBufferMap.delete(I),this._callback(I,T.data.join("")))}}e.TerminalDataBufferer=b}),define(me[190],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var b;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(b=e.ColorScheme||(e.ColorScheme={}))}),define(me[191],ge([0,1,4,6,39,3,190,46]),function(G,e,b,L,I,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,b.createDecorator)("themeService");var D;(function(E){function w(S){return S&&typeof S=="object"&&typeof S.id=="string"}E.isThemeColor=w})(D=e.ThemeColor||(e.ThemeColor={}));function k(E){return{id:E}}e.themeColorFromId=k;var i;(function(E){function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}E.isThemeIcon=w;const S=new RegExp(`^\\$\\((${C.CSSIcon.iconNameExpression}(?:${C.CSSIcon.iconModifierExpression})?)\\)$`);function u(t){const n=S.exec(t);if(!!n){let[,s]=n;return{id:s}}}E.fromString=u;function c(t,n){let s=t.id;const r=s.lastIndexOf("~");return r!==-1&&(s=s.substring(0,r)),n&&(s=`${s}~${n}`),{id:s}}E.modify=c;function f(t,n){var s,r;return t.id===n.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((r=n.color)===null||r===void 0?void 0:r.id)}E.isEqual=f,E.asClassNameArray=C.CSSIcon.asClassNameArray,E.asClassName=C.CSSIcon.asClassName,E.asCSSSelector=C.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=C.Codicon.file,e.FolderThemeIcon=C.Codicon.folder;function P(E){switch(E){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,L.toDisposable)(()=>{const S=this.themingParticipants.indexOf(w);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new h;I.Registry.add(e.Extensions.ThemingContribution,p);function o(E){return p.onColorThemeChange(E)}e.registerThemingParticipant=o;class d extends L.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,S){let u=this.theme.getColor(w);return u&&S&&(u=S(u,this.theme)),u?u.toString():null}}e.Themable=d}),define(me[192],ge([0,1,39,191,3,157,116,13,46]),function(G,e,b,L,I,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,S,u,c){const f=this.iconsById[w];if(f){if(u&&!f.description){f.description=u,this.iconSchema.properties[w].markdownDescription=`${u} $(${w})`;const s=this.iconReferenceSchema.enum.indexOf(w);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=u),this._onDidChange.fire()}return f}let t={id:w,description:u,defaults:S,deprecationMessage:c};this.iconsById[w]=t;let n={$ref:"#/definitions/icons"};return c&&(n.deprecationMessage=c),u&&(n.markdownDescription=`${u}: $(${w})`),this.iconSchema.properties[w]=n,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(u||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const S=this.iconReferenceSchema.enum.indexOf(w);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,S){const u=this.iconFontsById[w];if(u)return u;let c={id:w,definition:S};return this.iconFontsById[w]=c,this._onDidChange.fire(),c}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(f,t)=>f.id.localeCompare(t.id),S=f=>{for(;L.ThemeIcon.isThemeIcon(f.defaults);)f=this.iconsById[f.defaults.id];return`codicon codicon-${f?f.id:""}`};let u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(f=>this.iconsById[f]);for(const f of c.filter(t=>!!t.description).sort(w))u.push(`|<i class="${S(f)}"></i>|${f.id}|${L.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const f of c.filter(t=>!L.ThemeIcon.isThemeIcon(t.defaults)).sort(w))u.push(`|<i class="${S(f)}"></i>|${f.id}|`);return u.join(`
`)}}const i=new k;b.Registry.add(e.Extensions.IconContribution,i);function P(E,w,S,u){return i.registerIcon(E,w,S,u)}e.registerIcon=P;function h(){return i}e.getIconRegistry=h;function p(){for(const E of D.iconRegistry.all)i.registerIcon(E.id,E.definition,E.description);D.iconRegistry.onDidRegister(E=>i.registerIcon(E.id,E.definition,E.description))}p(),e.iconsSchemaId="vscode://schemas/icons";let o=b.Registry.as(y.Extensions.JSONContribution);o.registerSchema(e.iconsSchemaId,i.getIconSchema());const d=new C.RunOnceScheduler(()=>o.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.widgetClose=P("widget-close",D.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=P("goto-previous-location",D.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=P("goto-next-location",D.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=L.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(me[61],ge([0,1,2,25,4,22]),function(G,e,b,L,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");var y;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function C(h){const p=h;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=C;function D(h){const p=h;return!!(p&&typeof p=="object"&&b.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=D;class k{constructor(p,o,d,E){this._id=p,this._configuration=d,this._ignorePathCasing=E,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class i{constructor(p,o){this.raw=o,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,L.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function P(h){return new i({uri:h,index:0,name:(0,L.basenameOrAuthority)(h)},{uri:h.toString()})}e.toWorkspaceFolder=P}),define(me[118],ge([0,1,4,158,61,2,10,9,25,133,56,12,77,29,117]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(B){return(typeof B=="string"?(0,C.extname)(B):(0,D.extname)(B))===d}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function w(B){return B.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function S(B){return B.hasOwnProperty("folderUri")}e.isRecentFolder=S;function u(B){return B.hasOwnProperty("fileUri")}e.isRecentFile=u;function c(B){const U=B;return typeof(U==null?void 0:U.id)=="string"&&T.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=c;function f(B){if(B.configuration)return{id:B.id,configPath:B.configuration};if(B.folders.length===1)return{id:B.id,uri:B.folders[0].uri}}e.toWorkspaceIdentifier=f;function t(B){const U=B;return typeof(U==null?void 0:U.id)=="string"&&T.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function n(B){const U=B;if(U==null?void 0:U.uri)return{id:U.id,uri:T.URI.revive(U.uri)};const A=B;if(A==null?void 0:A.configPath)return{id:A.id,configPath:T.URI.revive(A.configPath)};if(B==null?void 0:B.id)return{id:B.id}}e.reviveIdentifier=n;function s(B,U){return D.extUriBiasedIgnorePathCase.isEqualOrParent(B,U.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(B){return a(B)||g(B)}e.isStoredWorkspaceFolder=r;function a(B){const U=B;return typeof(U==null?void 0:U.path)=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=a;function g(B){const U=B;return typeof(U==null?void 0:U.uri)=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=g;function m(B,U,A,x,F=!y.isWindows,M){if(B.scheme!==x.scheme)return{name:A,uri:B.toString(!0)};let W=U?void 0:M.relativePath(x,B);if(W!==void 0)W.length===0?W=".":y.isWindows&&B.scheme===P.Schemas.file&&!F&&(W=W.replace(/\//g,"\\"));else if(B.scheme===P.Schemas.file)W=B.fsPath,y.isWindows&&(W=(0,h.normalizeDriveLetter)(W),F&&(W=(0,p.toSlashes)(W)));else{if(!M.isEqualAuthority(B.authority,x.authority))return{name:A,uri:B.toString(!0)};W=B.path}return{name:A,path:W}}e.getStoredWorkspaceFolder=m;function _(B,U,A){let x=[],F=new Set;const M=A.dirname(U);for(let W of B){let z;if(a(W))W.path&&(z=A.resolvePath(M,W.path));else if(g(W))try{z=T.URI.parse(W.uri),z.path[0]!=="/"&&(z=z.with({path:"/"+z.path}))}catch(Y){console.warn(Y)}if(z){let Y=A.getComparisonKey(z);if(!F.has(Y)){F.add(Y);const le=W.name||A.basenameOrAuthority(z);x.push(new I.WorkspaceFolder({uri:z,name:le,index:x.length},W))}}}return x}e.toWorkspaceFolders=_;function l(B,U,A,x,F){let M=v(U,B);const W=F.dirname(U),z=F.dirname(x),Y=[],le=R(M.folders);for(const Oe of M.folders){const j=a(Oe)?F.resolvePath(W,Oe.path):T.URI.parse(Oe.uri);let Q;A?Q=!1:Q=!a(Oe)||(0,C.isAbsolute)(Oe.path),Y.push(m(j,Q,Oe.name,z,le,F))}const ve={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Te=k.setProperty(B,["folders"],Y,ve);let ye=k.applyEdits(B,Te);return M.remoteAuthority===(0,o.getRemoteAuthority)(x)&&(ye=k.applyEdits(ye,k.removeProperty(ye,["remoteAuthority"],ve))),ye}e.rewriteWorkspaceFileForNewLocation=l;function v(B,U){let A=i.parse(U);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(x=>r(x));else throw new Error(`${B} looks like an invalid workspace file.`);return A}function R(B){return y.isWindows?B.some(U=>a(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function O(B){return B.workspace&&typeof B.workspace=="object"&&typeof B.workspace.id=="string"&&typeof B.workspace.configPath=="string"}function H(B){return typeof B.folderUri=="string"}function ne(B){return typeof B.fileUri=="string"}function ie(B,U){const A={workspaces:[],files:[]};if(B){const x=function(M,W){for(let z=0;z<M.length;z++)try{W(M[z],z)}catch(Y){U.warn(`Error restoring recent entry ${JSON.stringify(M[z])}: ${Y.toString()}. Skip entry.`)}},F=B;if(Array.isArray(F.entries))x(F.entries,M=>{const W=M.label,z=M.remoteAuthority;O(M)?A.workspaces.push({label:W,remoteAuthority:z,workspace:{id:M.workspace.id,configPath:T.URI.parse(M.workspace.configPath)}}):H(M)?A.workspaces.push({label:W,remoteAuthority:z,folderUri:T.URI.parse(M.folderUri)}):ne(M)&&A.files.push({label:W,remoteAuthority:z,fileUri:T.URI.parse(M.fileUri)})});else{const M=B;Array.isArray(M.workspaces3)&&x(M.workspaces3,(W,z)=>{const Y=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[z]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?A.workspaces.push({label:Y,workspace:{id:W.id,configPath:T.URI.parse(W.configURIPath)}}):typeof W=="string"&&A.workspaces.push({label:Y,folderUri:T.URI.parse(W)})}),Array.isArray(M.files2)&&x(M.files2,(W,z)=>{const Y=Array.isArray(M.fileLabels)&&M.fileLabels[z]||void 0;typeof W=="string"&&A.files.push({label:Y,fileUri:T.URI.parse(W)})})}}return A}e.restoreRecentlyOpened=ie;function N(B){const U={entries:[]};for(const A of B.workspaces)S(A)?U.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):U.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of B.files)U.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return U}e.toStoreData=N}),define(me[86],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class b{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const T=this._idPool++;return this._data.set(T,I),this.logDebugInfo(),T}get(I,T){return this._data.has(I)?this._data.get(I)[T]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!b.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=b,b.enableDebugLogging=!1}),define(me[48],ge([0,1,2,3,4]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class T{constructor(){this._onDidChangeTabs=new L.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(D=>({name:D.name,group:D.group,resource:b.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(me[62],ge([0,1,12,4]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class I{constructor(){this._systemSchemes=new Set(Object.keys(b.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,C){C===null?this._providerInfo.delete(y):this._providerInfo.set(y,C)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=I,e.IExtHostFileSystemInfo=(0,L.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,b.createDecorator)("IExtHostInitDataService")}),define(me[193],ge([0,1,13]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(y,C,D){this._deferredPromises=new Map,this._id=y,this._shared=C,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new b.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of k.values())i.complete()}catch(i){for(const P of k.values())P.error(i)}})()},0)}get keys(){var y;return Object.entries((y=this._value)!==null&&y!==void 0?y:{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(y,C){let D=this._value[y];return typeof D=="undefined"&&(D=C),D}update(y,C){this._value[y]=C;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const k=new b.DeferredPromise;return this._deferredPromises.set(y,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class I extends L{constructor(y,C){super(y.identifier.value,!0,C);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=I}),define(me[15],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class L{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=L});var nt=this&&this.__classPrivateFieldSet||function(G,e,b,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(G,b):I?I.value=b:e.set(G,b),b},$e=this&&this.__classPrivateFieldGet||function(G,e,b,L){if(b==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?L:b==="a"?L.call(G):L?L.value:e.get(G)};define(me[194],ge([0,1,26,3]),function(G,e,b,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(C,D){I.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=b.ExtensionIdentifier.toKey(C.identifier),nt(this,I,D,"f"),$e(this,I,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(C){return $e(this,I,"f").get(this._id,C)}store(C,D){return $e(this,I,"f").store(this._id,C,D)}delete(C){return $e(this,I,"f").delete(this._id,C)}}e.ExtensionSecrets=T,I=new WeakMap}),define(me[119],ge([0,1,4,3]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,b.createDecorator)("IExtHostTelemetry")}),define(me[87],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var L;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(L=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const I=new WeakMap,T=y=>{let C=I.get(y);return C||(C={children:new Map,bus:new b.Emitter},I.set(y,C)),C};e.getPrivateApiFor=T}),define(me[49],ge([0,1,4,3,15]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(C){function D(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}C.fromApiTunnel=D;function k(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}C.fromServiceTunnel=k})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,b.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,k){return{dispose:()=>{}}}async $providePortAttributes(D,k,i,P,h){return[]}async $forwardPort(D,k){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=qe([We(0,I.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var nt=this&&this.__classPrivateFieldSet||function(G,e,b,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(G,b):I?I.value=b:e.set(G,b),b},$e=this&&this.__classPrivateFieldGet||function(G,e,b,L){if(b==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?L:b==="a"?L.call(G):L?L.value:e.get(G)},Gt=this&&this.__rest||function(G,e){var b={};for(var L in G)Object.prototype.hasOwnProperty.call(G,L)&&e.indexOf(L)<0&&(b[L]=G[L]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var I=0,L=Object.getOwnPropertySymbols(G);I<L.length;I++)e.indexOf(L[I])<0&&Object.prototype.propertyIsEnumerable.call(G,L[I])&&(b[L[I]]=G[L[I]]);return b};define(me[7],ge([0,1,16,17,97,22,8,11,2,30,44,85,87]),function(G,e,b,L,I,T,y,C,D,k,i,P,h){"use strict";var p,o,d,E,w,S,u,c,f,t,n,s,r,a,g,m;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(q){function $(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf($,q),Object.setPrototypeOf($.prototype,q.prototype),$}let l=d=class{constructor($){p.set(this,void 0),nt(this,p,$,"f")}static from(...$){let re=$;return new d(function(){if(re){for(const Ie of re)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();re=void 0}})}dispose(){typeof $e(this,p,"f")=="function"&&($e(this,p,"f").call(this),nt(this,p,void 0,"f"))}};p=new WeakMap,l=d=qe([_],l),e.Disposable=l;let v=E=class{constructor($,re){if($<0)throw(0,L.illegalArgument)("line must be non-negative");if(re<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=$,this._character=re}static Min(...$){if($.length===0)throw new TypeError;let re=$[0];for(let Ie=1;Ie<$.length;Ie++){const Ge=$[Ie];Ge.isBefore(re)&&(re=Ge)}return re}static Max(...$){if($.length===0)throw new TypeError;let re=$[0];for(let Ie=1;Ie<$.length;Ie++){const Ge=$[Ie];Ge.isAfter(re)&&(re=Ge)}return re}static isPosition($){if(!$)return!1;if($ instanceof E)return!0;let{line:re,character:Ie}=$;return typeof re=="number"&&typeof Ie=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,re=0){if($===null||re===null)throw(0,L.illegalArgument)();let Ie;return typeof $=="undefined"?Ie=0:typeof $=="number"?Ie=$:(Ie=typeof $.lineDelta=="number"?$.lineDelta:0,re=typeof $.characterDelta=="number"?$.characterDelta:0),Ie===0&&re===0?this:new E(this.line+Ie,this.character+re)}with($,re=this.character){if($===null||re===null)throw(0,L.illegalArgument)();let Ie;return typeof $=="undefined"?Ie=this.line:typeof $=="number"?Ie=$:(Ie=typeof $.line=="number"?$.line:this.line,re=typeof $.character=="number"?$.character:this.character),Ie===this.line&&re===this.character?this:new E(Ie,re)}toJSON(){return{line:this.line,character:this.character}}};v=E=qe([_],v),e.Position=v;let R=w=class{constructor($,re,Ie,Ge){let tt,ot;if(typeof $=="number"&&typeof re=="number"&&typeof Ie=="number"&&typeof Ge=="number"?(tt=new v($,re),ot=new v(Ie,Ge)):$ instanceof v&&re instanceof v&&(tt=$,ot=re),!tt||!ot)throw new Error("Invalid arguments");tt.isBefore(ot)?(this._start=tt,this._end=ot):(this._start=ot,this._end=tt)}static isRange($){return $ instanceof w?!0:$?v.isPosition($.start)&&v.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof w?this.contains($._start)&&this.contains($._end):$ instanceof v?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const re=v.Max($.start,this._start),Ie=v.Min($.end,this._end);if(!re.isAfter(Ie))return new w(re,Ie)}union($){if(this.contains($))return this;if($.contains(this))return $;const re=v.Min($.start,this._start),Ie=v.Max($.end,this.end);return new w(re,Ie)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,re=this.end){if($===null||re===null)throw(0,L.illegalArgument)();let Ie;return $?v.isPosition($)?Ie=$:(Ie=$.start||this.start,re=$.end||this.end):Ie=this.start,Ie.isEqual(this._start)&&re.isEqual(this.end)?this:new w(Ie,re)}toJSON(){return[this.start,this.end]}};R=w=qe([_],R),e.Range=R;let O=S=class extends R{constructor($,re,Ie,Ge){let tt,ot;if(typeof $=="number"&&typeof re=="number"&&typeof Ie=="number"&&typeof Ge=="number"?(tt=new v($,re),ot=new v(Ie,Ge)):$ instanceof v&&re instanceof v&&(tt=$,ot=re),!tt||!ot)throw new Error("Invalid arguments");super(tt,ot);this._anchor=tt,this._active=ot}static isSelection($){return $ instanceof S?!0:$?R.isRange($)&&v.isPosition($.anchor)&&v.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=S=qe([_],O),e.Selection=O;class H{constructor($,re,Ie){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,L.illegalArgument)("port");if(typeof Ie!="undefined"&&(typeof Ie!="string"||Ie.length===0||!/^[0-9A-Za-z\-]+$/.test(Ie)))throw(0,L.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(re),this.connectionToken=Ie}}e.ResolvedAuthority=H;class ne extends Error{constructor($,re=P.RemoteAuthorityResolverErrorCode.Unknown,Ie){super($);this._message=$,this._code=re,this._detail=Ie,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ne.prototype)}static NotAvailable($,re){return new ne($,P.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable($){return new ne($,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ne;var ie;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(ie=e.EndOfLine||(e.EndOfLine={}));var N;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(N=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=u=class{constructor($,re){this._range=$,this._newText=re}static isTextEdit($){return $ instanceof u?!0:$?R.isRange($)&&typeof $.newText=="string":!1}static replace($,re){return new u($,re)}static insert($,re){return u.replace(new R($,$),re)}static delete($){return u.replace($,"")}static setEndOfLine($){const re=new u(new R(new v(0,0),new v(0,0)),"");return re.newEol=$,re}get range(){return this._range}set range($){if($&&!R.isRange($))throw(0,L.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,L.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,L.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=u=qe([_],B),e.TextEdit=B;var U;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellOutput=4]="CellOutput",q[q.CellReplace=5]="CellReplace",q[q.CellOutputItem=6]="CellOutputItem"})(U=e.FileEditType||(e.FileEditType={}));let A=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,re,Ie,Ge){this._edits.push({_type:1,from:$,to:re,options:Ie,metadata:Ge})}createFile($,re,Ie){this._edits.push({_type:1,from:void 0,to:$,options:re,metadata:Ie})}deleteFile($,re,Ie){this._edits.push({_type:1,from:$,to:void 0,options:re,metadata:Ie})}replaceNotebookMetadata($,re,Ie){this._edits.push({_type:3,metadata:Ie,uri:$,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells($,re,Ie,Ge,tt){let ot,dt,St=[],Ct;if(Bt.isNotebookRange(re)&&Tt.isNotebookCellDataArray(Ie)&&!Tt.isNotebookCellDataArray(Ge)?(ot=re.start,dt=re.end,St=Ie,Ct=Ge):typeof re=="number"&&typeof Ie=="number"&&Tt.isNotebookCellDataArray(Ge)&&(ot=re,dt=Ie,St=Ge,Ct=tt),ot===void 0||dt===void 0)throw new Error("Invalid arguments");(ot!==dt||St.length>0)&&this._edits.push({_type:5,uri:$,index:ot,count:dt-ot,cells:St,metadata:Ct})}replaceNotebookCellMetadata($,re,Ie,Ge){this._edits.push({_type:3,metadata:Ge,uri:$,edit:{editType:8,index:re,metadata:Ie}})}replace($,re,Ie,Ge){this._edits.push({_type:2,uri:$,edit:new B(re,Ie),metadata:Ge})}insert($,re,Ie,Ge){this.replace($,new R(re,re),Ie,Ge)}delete($,re,Ie){this.replace($,re,"",Ie)}has($){return this._edits.some(re=>re._type===2&&re.uri.toString()===$.toString())}set($,re){if(re)for(const Ie of re)Ie&&this._edits.push({_type:2,uri:$,edit:Ie});else{for(let Ie=0;Ie<this._edits.length;Ie++){const Ge=this._edits[Ie];Ge._type===2&&Ge.uri.toString()===$.toString()&&(this._edits[Ie]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get($){const re=[];for(let Ie of this._edits)Ie._type===2&&Ie.uri.toString()===$.toString()&&re.push(Ie.edit);return re}entries(){const $=new T.ResourceMap;for(let re of this._edits)if(re._type===2){let Ie=$.get(re.uri);Ie||(Ie=[re.uri,[]],$.set(re.uri,Ie)),Ie[1].push(re.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};A=qe([_],A),e.WorkspaceEdit=A;let x=c=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof c?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=c._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,re=this._tabstop++){if(typeof $=="function"){const Ie=new c;Ie._tabstop=this._tabstop,$(Ie),this._tabstop=Ie._tabstop,$=Ie.value}else $=c._escape($);return this.value+="${",this.value+=re,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,re=this._tabstop++){const Ie=$.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable($,re){if(typeof re=="function"){const Ie=new c;Ie._tabstop=this._tabstop,re(Ie),this._tabstop=Ie._tabstop,re=Ie.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,re&&(this.value+=":",this.value+=re),this.value+="}",this}};x=c=qe([_],x),e.SnippetString=x;var F;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(F=e.DiagnosticTag||(e.DiagnosticTag={}));var M;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(M=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let W=f=class{constructor($,re){if(this.uri=$,re)if(re instanceof R)this.range=re;else if(re instanceof v)this.range=new R(re,re);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof f?!0:$?R.isRange($.range)&&D.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};W=f=qe([_],W),e.Location=W;let z=class{constructor($,re){this.location=$,this.message=re}static is($){return $?typeof $.message=="string"&&$.location&&R.isRange($.location.range)&&D.URI.isUri($.location.uri):!1}static isEqual($,re){return $===re?!0:!$||!re?!1:$.message===re.message&&$.location.range.isEqual(re.location.range)&&$.location.uri.toString()===re.location.uri.toString()}};z=qe([_],z),e.DiagnosticRelatedInformation=z;let Y=class{constructor($,re,Ie=M.Error){if(!R.isRange($))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=$,this.message=re,this.severity=Ie}toJSON(){return{severity:M[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,re){return $===re?!0:!$||!re?!1:$.message===re.message&&$.severity===re.severity&&$.code===re.code&&$.severity===re.severity&&$.source===re.source&&$.range.isEqual(re.range)&&(0,b.equals)($.tags,re.tags)&&(0,b.equals)($.relatedInformation,re.relatedInformation,z.isEqual)}};Y=qe([_],Y),e.Diagnostic=Y;let le=class{constructor($,re){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:(0,I.isMarkdownString)($)?this.contents=[$]:this.contents=[$],this.range=re}};le=qe([_],le),e.Hover=le;var ve;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(ve=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Te=class{constructor($,re=ve.Text){this.range=$,this.kind=re}toJSON(){return{range:this.range,kind:ve[this.kind]}}};Te=qe([_],Te),e.DocumentHighlight=Te;var ye;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(ye=e.SymbolKind||(e.SymbolKind={}));var Oe;(function(q){q[q.Deprecated=1]="Deprecated"})(Oe=e.SymbolTag||(e.SymbolTag={}));let j=t=class{constructor($,re,Ie,Ge,tt){this.name=$,this.kind=re,this.containerName=tt,typeof Ie=="string"&&(this.containerName=Ie),Ge instanceof W?this.location=Ge:Ie instanceof R&&(this.location=new W(Ge,Ie)),t.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ye[this.kind],location:this.location,containerName:this.containerName}}};j=t=qe([_],j),e.SymbolInformation=j;let Q=n=class{constructor($,re,Ie,Ge,tt){this.name=$,this.detail=re,this.kind=Ie,this.range=Ge,this.selectionRange=tt,this.children=[],n.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(n.validate)}};Q=n=qe([_],Q),e.DocumentSymbol=Q;var Z;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor($,re){this.title=$,this.kind=re}};se=qe([_],se),e.CodeAction=se;let fe=s=class{constructor($){this.value=$}append($){return new s(this.value?this.value+s.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+s.sep)}};fe.sep=".",fe=s=qe([_],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let _e=class{constructor($,re){if(this.range=$,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};_e=qe([_],_e),e.SelectionRange=_e;class xe{constructor($,re,Ie,Ge,tt,ot){this.kind=$,this.name=re,this.detail=Ie,this.uri=Ge,this.range=tt,this.selectionRange=ot}}e.CallHierarchyItem=xe;class pe{constructor($,re){this.fromRanges=re,this.from=$}}e.CallHierarchyIncomingCall=pe;class ke{constructor($,re){this.fromRanges=re,this.to=$}}e.CallHierarchyOutgoingCall=ke;let Fe=class{constructor($,re){this.range=$,this.command=re}get isResolved(){return!!this.command}};Fe=qe([_],Fe),e.CodeLens=Fe;let He=r=class{constructor($,re=!1){o.set(this,void 0),nt(this,o,new I.MarkdownString($,{supportThemeIcons:re}),"f")}static isMarkdownString($){return $ instanceof r?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return $e(this,o,"f").value}set value($){$e(this,o,"f").value=$}get isTrusted(){return $e(this,o,"f").isTrusted}set isTrusted($){$e(this,o,"f").isTrusted=$}get supportThemeIcons(){return $e(this,o,"f").supportThemeIcons}appendText($){return $e(this,o,"f").appendText($),this}appendMarkdown($){return $e(this,o,"f").appendMarkdown($),this}appendCodeblock($,re){return $e(this,o,"f").appendCodeblock(re!=null?re:"",$),this}};o=new WeakMap,He=r=qe([_],He),e.MarkdownString=He;let be=class{constructor($,re){this.label=$,this.documentation=re}};be=qe([_],be),e.ParameterInformation=be;let Ke=class{constructor($,re){this.label=$,this.documentation=re,this.parameters=[]}};Ke=qe([_],Ke),e.SignatureInformation=Ke;let K=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};K=qe([_],K),e.SignatureHelp=K;var te;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var we;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(we=e.InlayHintKind||(e.InlayHintKind={}));let Ue=class{constructor($,re,Ie){this.text=$,this.position=re,this.kind=Ie}};Ue=qe([_],Ue),e.InlayHint=Ue;var je;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(q){q[q.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let Ce=class{constructor($,re){this.label=$,this.kind=re}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&ze[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ce=qe([_],Ce),e.CompletionItem=Ce;let De=class{constructor($=[],re=!1){this.items=$,this.isIncomplete=re}};De=qe([_],De),e.CompletionList=De;var Pe;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(Pe=e.ViewColumn||(e.ViewColumn={}));var oe;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(oe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ue;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(ue=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var V;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(V=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var J;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(J=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ce;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ae;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(Ae=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function $(re){switch(re){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=$}(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ee=class{constructor($,re){if(re&&!D.URI.isUri(re))throw(0,L.illegalArgument)("target");if(!R.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.target=re}};Ee=qe([_],Ee),e.DocumentLink=Ee;let Me=class{constructor($,re,Ie,Ge){this.red=$,this.green=re,this.blue=Ie,this.alpha=Ge}};Me=qe([_],Me),e.Color=Me;let Ve=class{constructor($,re){if(re&&!(re instanceof Me))throw(0,L.illegalArgument)("color");if(!R.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.color=re}};Ve=qe([_],Ve),e.ColorInformation=Ve;let Xe=class{constructor($){if(!$||typeof $!="string")throw(0,L.illegalArgument)("label");this.label=$}};Xe=qe([_],Xe),e.ColorPresentation=Xe;var rt;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(rt=e.ColorFormat||(e.ColorFormat={}));var Qe;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(Qe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var et;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(et=e.TaskRevealKind||(e.TaskRevealKind={}));var pt;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(pt=e.TaskPanelKind||(e.TaskPanelKind={}));let bt=a=class{constructor($,re){if(typeof $!="string"||typeof re!="string")throw(0,L.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};bt.Clean=new a("clean","Clean"),bt.Build=new a("build","Build"),bt.Rebuild=new a("rebuild","Rebuild"),bt.Test=new a("test","Test"),bt=a=qe([_],bt),e.TaskGroup=bt;function de(q){let $="";for(let re=0;re<q.length;re++)$+=q[re].replace(/,/g,",,")+",";return $}let Se=class{constructor($,re,Ie){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=$,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=Ie):this._options=re)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let re of this._args)$.push(re);return de($)}};Se=qe([_],Se),e.ProcessExecution=Se;let ae=class{constructor($,re,Ie){if(this._args=[],Array.isArray(re)){if(!$)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$,this._args=re,this._options=Ie}else{if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$,this._options=re}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)$.push(typeof re=="string"?re:re.value);return de($)}};ae=qe([_],ae),e.ShellExecution=ae;var X;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(X=e.ShellQuoting||(e.ShellQuoting={}));var Be;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Be=e.TaskScope||(e.TaskScope={}));class Le{constructor($){this._callback=$}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=Le;let Je=g=class{constructor($,re,Ie,Ge,tt,ot){this.__deprecated=!1,this._definition=this.definition=$;let dt;typeof re=="string"?(this._name=this.name=re,this._source=this.source=Ie,this.execution=Ge,dt=tt,this.__deprecated=!0):re===Be.Global||re===Be.Workspace?(this.target=re,this._name=this.name=Ie,this._source=this.source=Ge,this.execution=tt,dt=ot):(this.target=re,this._name=this.name=Ie,this._source=this.source=Ge,this.execution=tt,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Se?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof ae?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const re=this._definition.type;(g.EmptyType===re||g.ProcessType===re||g.ShellType===re||g.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};Je.ExtensionCallbackType="customExecution",Je.ProcessType="process",Je.ShellType="shell",Je.EmptyType="$empty",Je=g=qe([_],Je),e.Task=Je;var it;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(it=e.ProgressLocation||(e.ProgressLocation={}));let at=class{constructor($,re=ht.None){this.collapsibleState=re,D.URI.isUri($)?this.resourceUri=$:this.label=$}};at=qe([_],at),e.TreeItem=at;var ht;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ye=class{constructor($,re){this.id=$,this.color=re}};Ye=qe([_],Ye),e.ThemeIcon=Ye,Ye.File=new Ye("file"),Ye.Folder=new Ye("folder");let lt=class{constructor($){this.id=$}};lt=qe([_],lt),e.ThemeColor=lt;var ft;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ct=class{constructor($,re){if(typeof $!="string"&&(!$||!D.URI.isUri($)&&!D.URI.isUri($.uri)))throw(0,L.illegalArgument)("base");if(typeof re!="string")throw(0,L.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=D.URI.file($),this.base=$):D.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=re}};ct=qe([_],ct),e.RelativePattern=ct;let _t=class{constructor($,re,Ie,Ge){this.enabled=typeof $=="boolean"?$:!0,typeof re=="string"&&(this.condition=re),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};_t=qe([_],_t),e.Breakpoint=_t;let vt=class extends _t{constructor($,re,Ie,Ge,tt){super(re,Ie,Ge,tt);if($===null)throw(0,L.illegalArgument)("location");this.location=$}};vt=qe([_],vt),e.SourceBreakpoint=vt;let kt=class extends _t{constructor($,re,Ie,Ge,tt){super(re,Ie,Ge,tt);this.functionName=$}};kt=qe([_],kt),e.FunctionBreakpoint=kt;let Lt=class extends _t{constructor($,re,Ie,Ge,tt,ot,dt){super(Ge,tt,ot,dt);if(!re)throw(0,L.illegalArgument)("dataId");this.label=$,this.dataId=re,this.canPersist=Ie}};Lt=qe([_],Lt),e.DataBreakpoint=Lt;let Et=class{constructor($,re,Ie){this.command=$,this.args=re||[],this.options=Ie}};Et=qe([_],Et),e.DebugAdapterExecutable=Et;let Ft=class{constructor($,re){this.port=$,this.host=re}};Ft=qe([_],Ft),e.DebugAdapterServer=Ft;let Qt=class{constructor($){this.path=$}};Qt=qe([_],Qt),e.DebugAdapterNamedPipeServer=Qt;let mt=class{constructor($){this.implementation=$}};mt=qe([_],mt),e.DebugAdapterInlineImplementation=mt;let Xt=class{constructor($,re){this.range=$,this.expression=re}};Xt=qe([_],Xt),e.EvaluatableExpression=Xt;let yt=class{constructor($,re){this.range=$,this.text=re}};yt=qe([_],yt),e.InlineValueText=yt;let jt=class{constructor($,re,Ie=!0){this.range=$,this.variableName=re,this.caseSensitiveLookup=Ie}};jt=qe([_],jt),e.InlineValueVariableLookup=jt;let Yt=class{constructor($,re){this.range=$,this.expression=re}};Yt=qe([_],Yt),e.InlineValueEvaluatableExpression=Yt;let Ut=class{constructor($,re){this.frameId=$,this.stoppedLocation=re}};Ut=qe([_],Ut),e.InlineValueContext=Ut;var ut;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(ut=e.FileChangeType||(e.FileChangeType={}));let Jt=m=class extends Error{constructor($,re=i.FileSystemProviderErrorCode.Unknown,Ie){var Ge;super(D.URI.isUri($)?$.toString(!0):$);this.code=(Ge=Ie==null?void 0:Ie.name)!==null&&Ge!==void 0?Ge:"Unknown",(0,i.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}static FileExists($){return new m($,i.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound($){return new m($,i.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory($){return new m($,i.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory($){return new m($,i.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions($){return new m($,i.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable($){return new m($,i.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}};Jt=m=qe([_],Jt),e.FileSystemError=Jt;let It=class{constructor($,re,Ie){this.start=$,this.end=re,this.kind=Ie}};It=qe([_],It),e.FoldingRange=It;var xt;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(xt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var cn;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(cn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var wn;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(wn=e.CommentMode||(e.CommentMode={}));class un{constructor($,re=[]){this.tokenTypes=$,this.tokenModifiers=re}}e.SemanticTokensLegend=un;function bn(q){return typeof q=="undefined"||(0,C.isStringArray)(q)}class qt{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let re=0,Ie=$.tokenTypes.length;re<Ie;re++)this._tokenTypeStrToInt.set($.tokenTypes[re],re);for(let re=0,Ie=$.tokenModifiers.length;re<Ie;re++)this._tokenModifierStrToInt.set($.tokenModifiers[re],re)}}push($,re,Ie,Ge,tt){if(typeof $=="number"&&typeof re=="number"&&typeof Ie=="number"&&typeof Ge=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded($,re,Ie,Ge,tt);if(R.isRange($)&&typeof re=="string"&&bn(Ie))return this._push($,re,Ie);throw(0,L.illegalArgument)()}_push($,re,Ie){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ge=$.start.line,tt=$.start.character,ot=$.end.character-$.start.character,dt=this._tokenTypeStrToInt.get(re);let St=0;if(Ie)for(const Ct of Ie){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const Pt=this._tokenModifierStrToInt.get(Ct);St|=1<<Pt>>>0}this._pushEncoded(Ge,tt,ot,dt,St)}_pushEncoded($,re,Ie,Ge,tt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let Ct=0,Pt=0;for(let Rt=0;Rt<St;Rt++){let Ot=this._data[5*Rt],an=this._data[5*Rt+1];Ot===0?(Ot=Ct,an+=Pt):Ot+=Ct,this._data[5*Rt]=Ot,this._data[5*Rt+1]=an,Ct=Ot,Pt=an}}let ot=$,dt=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ie,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=tt,this._prevLine=$,this._prevChar=re}static _sortAndDeltaEncode($){let re=[];const Ie=$.length/5|0;for(let dt=0;dt<Ie;dt++)re[dt]=dt;re.sort((dt,St)=>{const Ct=$[5*dt],Pt=$[5*St];if(Ct===Pt){const Rt=$[5*dt+1],Ot=$[5*St+1];return Rt-Ot}return Ct-Pt});const Ge=new Uint32Array($.length);let tt=0,ot=0;for(let dt=0;dt<Ie;dt++){const St=5*re[dt],Ct=$[St+0],Pt=$[St+1],Rt=$[St+2],Ot=$[St+3],an=$[St+4],Rn=Ct-tt,xn=Rn===0?Pt-ot:Pt,ln=5*dt;Ge[ln+0]=Rn,Ge[ln+1]=xn,Ge[ln+2]=Rt,Ge[ln+3]=Ot,Ge[ln+4]=an,tt=Ct,ot=Pt}return Ge}build($){return this._dataIsSortedAndDeltaEncoded?new At(new Uint32Array(this._data),$):new At(qt._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=qt;class At{constructor($,re){this.resultId=re,this.data=$}}e.SemanticTokens=At;class _n{constructor($,re,Ie){this.start=$,this.deleteCount=re,this.data=Ie}}e.SemanticTokensEdit=_n;class Zt{constructor($,re){this.resultId=re,this.edits=$}}e.SemanticTokensEdits=Zt;var en;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(en=e.DebugConsoleMode||(e.DebugConsoleMode={}));var En;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(En=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new Ye("arrow-left")},Kt=qe([_],Kt),e.QuickInputButtons=Kt;var Mt;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Mt=e.ExtensionKind||(e.ExtensionKind={}));class Sn{constructor($,re,Ie){this.badge=$,this.tooltip=re,this.color=Ie}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Sn;let tn=class{constructor($){this.kind=$}};tn=qe([_],tn),e.ColorTheme=tn;var yn;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(yn=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor($,re){if($<0)throw(0,L.illegalArgument)("start must be positive");if(re<0)throw(0,L.illegalArgument)("end must be positive");$<=re?(this._start=$,this._end=re):(this._start=re,this._end=$)}static isNotebookRange($){return $ instanceof Bt?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let re=this._start,Ie=this._end;return $.start!==void 0&&(re=$.start),$.end!==void 0&&(Ie=$.end),re===this._start&&Ie===this._end?this:new Bt(re,Ie)}}e.NotebookRange=Bt;class $t{constructor($,re){typeof $=="object"?Object.assign(this,$):(this.inputCollapsed=$,this.outputCollapsed=re)}with($){let{inputCollapsed:re,outputCollapsed:Ie}=$,Ge=Gt($,["inputCollapsed","outputCollapsed"]);return re===void 0?re=this.inputCollapsed:re===null&&(re=void 0),Ie===void 0?Ie=this.outputCollapsed:Ie===null&&(Ie=void 0),re===this.inputCollapsed&&Ie===this.outputCollapsed&&Object.keys(Ge).length===0?this:new $t(Object.assign({inputCollapsed:re,outputCollapsed:Ie},Ge))}}e.NotebookCellMetadata=$t;class Wt{constructor($={}){Object.assign(this,$)}with($){return new Wt($)}}e.NotebookDocumentMetadata=Wt;class Tt{constructor($,re,Ie,Ge,tt,ot){this.kind=$,this.value=re,this.languageId=Ie,this.outputs=Ge!=null?Ge:[],this.metadata=tt,this.executionSummary=ot,Tt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(re=>Tt.isNotebookCellData(re))}static isNotebookCellData($){return!0}}e.NotebookCellData=Tt;class nn{constructor($,re){this.cells=$,this.metadata=re!=null?re:new Wt}}e.NotebookData=nn;class Ne{constructor($,re,Ie){if(this.mime=$,this.value=re,this.metadata=Ie,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem($){return $ instanceof Ne?!0:$?typeof $.mime=="string":!1}static error($){return new Ne("application/x.notebook.error",JSON.stringify({name:$.name,message:$.message,stack:$.stack}))}}e.NotebookCellOutputItem=Ne;class rn{constructor($,re,Ie){this.outputs=$,typeof re=="string"?(this.id=re,this.metadata=Ie):(this.id=(0,k.generateUuid)(),this.metadata=re!=null?re:Ie)}}e.NotebookCellOutput=rn;var dn;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(dn=e.NotebookCellKind||(e.NotebookCellKind={}));var gt;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(gt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Dn;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(Dn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Cn;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Cn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class hn{constructor($,re,Ie,Ge,tt,ot){this.text=$,this.alignment=re,this.command=Ie,this.tooltip=Ge,this.priority=tt,this.accessibilityInformation=ot}}e.NotebookCellStatusBarItem=hn;var fn;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(fn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class sn{constructor($,re=[]){this.uri=$,this.provides=typeof re=="string"?[re]:re}}e.NotebookKernelPreload=sn;let on=class{constructor($,re){this.label=$,this.timestamp=re}};on=qe([_],on),e.TimelineItem=on;var kn;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(kn=e.ExtensionMode||(e.ExtensionMode={}));var In;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(In=e.ExtensionRuntime||(e.ExtensionRuntime={}));var mn;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(mn=e.StandardTokenType||(e.StandardTokenType={}));class Pn{constructor($,re){this.ranges=$,this.wordPattern=re}}e.LinkedEditingRanges=Pn;class An{constructor($,re){this._port=$,this._autoForwardAction=re}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=An;var Tn;(function(q){q[q.Unset=0]="Unset",q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(Tn=e.TestResultState||(e.TestResultState={}));var gn;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information",q[q.Hint=3]="Hint"})(gn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var pn;(function(q){q[q.Pending=0]="Pending",q[q.Resolved=1]="Resolved"})(pn=e.TestItemStatus||(e.TestItemStatus={}));const ee=(q,$,re,Ie)=>{let Ge=re;return{enumerable:!0,configurable:!1,get(){return Ge},set(tt){Ie(Ge,tt)||(Ge=tt,q.bus.fire([3,$,tt]))}}},he=(q,$)=>q===$,Re=(q,$)=>q===$?!0:!q||!$?!1:q.isEqual($);class st{constructor($,re,Ie,Ge){this.label=re,this.data=Ge;const tt=(0,h.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:$,enumerable:!0,writable:!1},uri:{value:Ie,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>tt.parent},children:{value:new T.ReadonlyMapView(tt.children),enumerable:!0,writable:!1},range:ee(tt,"range",void 0,Re),description:ee(tt,"description",void 0,he),runnable:ee(tt,"runnable",!0,he),debuggable:ee(tt,"debuggable",!1,he),status:ee(tt,"status",pn.Resolved,he),error:ee(tt,"error",void 0,he)})}invalidate(){(0,h.getPrivateApiFor)(this).bus.fire([2])}dispose(){const $=(0,h.getPrivateApiFor)(this);$.parent&&(0,h.getPrivateApiFor)($.parent).children.delete(this.id),$.bus.fire([1])}addChild($){if(!($ instanceof st))throw new Error("Test child must be created through vscode.test.createTestItem()");const re=(0,h.getPrivateApiFor)(this);if(re.children.has($.id))throw new Error(`Attempted to insert a duplicate test item ID ${$.id}`);re.children.set($.id,$),re.bus.fire([0,$])}}e.TestItemImpl=st;class wt{constructor($){this.message=$,this.severity=gn.Error}static diff($,re,Ie){const Ge=new wt($);return Ge.expectedOutput=re,Ge.actualOutput=Ie,Ge}}e.TestMessage=wt;var Dt;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(Dt=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Nn;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(Nn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Un;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore"})(Un=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(me[120],ge([0,1,52,12,8,144,108,7,16]),function(G,e,b,L,I,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function i(o,d){d?k.set(o,d):k.delete(o)}e.setWordDefinitionFor=i;function P(o){return k.get(o)}e.getWordDefinitionFor=P;class h extends T.MirrorTextModel{constructor(d,E,w,S,u,c,f,t){super(E,w,S,u);this._proxy=d,this._languageId=c,this._isDirty=f,this._notebook=t,this._isDisposed=!1}dispose(){(0,b.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,D.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===L.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(E){return E?d._getTextInRange(E):d.getText()},get eol(){return d._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(E){return d._lineAt(E)},offsetAt(E){return d._offsetAt(E)},positionAt(E){return d._positionAt(E)},validateRange(E){return d._validateRange(E)},validatePosition(E){return d._validatePosition(E)},getWordRangeAtPosition(E,w){return d._getWordRangeAtPosition(E,w)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,b.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,b.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const E=this._validateRange(d);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const w=this._eol,S=E.start.line,u=E.end.line,c=[];c.push(this._lines[S].substring(E.start.character));for(let f=S+1;f<u;f++)c.push(this._lines[f]);return c.push(this._lines[u].substring(0,E.end.character)),c.join(w)}_lineAt(d){let E;if(d instanceof C.Position?E=d.line:typeof d=="number"&&(E=d),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new p(E,this._lines[E],E===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(d),w=this._lines[E.index].length;return new C.Position(E.index,Math.min(E.remainder,w))}_validateRange(d){if(!(d instanceof C.Range))throw new Error("Invalid argument");const E=this._validatePosition(d.start),w=this._validatePosition(d.end);return E===d.start&&w===d.end?d:new C.Range(E.line,E.character,w.line,w.character)}_validatePosition(d){if(!(d instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:E,character:w}=d,S=!1;if(E<0)E=0,w=0,S=!0;else if(E>=this._lines.length)E=this._lines.length-1,w=this._lines[E].length,S=!0;else{const u=this._lines[E].length;w<0?(w=0,S=!0):w>u&&(w=u,S=!0)}return S?new C.Position(E,w):d}_getWordRangeAtPosition(d,E){const w=this._validatePosition(d);if(!E)E=P(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const S=(0,y.getWordAtText)(w.character+1,(0,y.ensureValidWordDefinition)(E),this._lines[w.line],0);if(S)return new C.Range(w.line,S.startColumn-1,w.line,S.endColumn-1)}}e.ExtHostDocumentData=h;class p{constructor(d,E,w){this._line=d,this._text=E,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(me[195],ge([0,1,7,3,110,6,78,22,2,30]),function(G,e,b,L,I,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(h,p,o,d){this._notebook=o,this._selector=d,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(w=>{const S=this._cellUris.get(w.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(h.onDidChangeNotebookCells(w=>E(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const h=[],p=[];for(const o of this._notebook.getCells())o.kind===b.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),h.push(o.document.getText().length+1),p.push(o.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(h)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(h){var p,o;if(!h){let u="";for(const c of this._cells)u+=c.document.getText()+`
`;return u=u.slice(0,-1),u}if(h.isEmpty)return"";const d=this.locationAt(h.start),E=this.locationAt(h.end),w=this._cells[(p=this._cellUris.get(d.uri))!==null&&p!==void 0?p:-1],S=this._cells[(o=this._cellUris.get(E.uri))!==null&&o!==void 0?o:-1];if(!w||!S)return"";if(w===S)return w.document.getText(new b.Range(d.range.start,E.range.end));{const u=w.document.getText(new b.Range(d.range.start,new b.Position(w.document.lineCount,0))),c=S.document.getText(new b.Range(new b.Position(0,0),E.range.end));return u+`
`+c}}offsetAt(h){const p=this._cellLines.getIndexOf(h.line),o=this._cellLengths.getAccumulatedValue(p.index-1),d=this._cells[p.index].document.offsetAt(h.with(p.remainder));return o+d}positionAt(h){if(typeof h=="number"){const o=this._cellLengths.getIndexOf(h),d=this._cellLines.getAccumulatedValue(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(d)}const p=this._cellUris.get(h.uri);if(p!==void 0){const o=this._cellLines.getAccumulatedValue(p-1);return new b.Position(o+h.range.start.line,h.range.start.character)}return new b.Position(0,0)}locationAt(h){b.Range.isRange(h)||(h=new b.Range(h,h));const p=this._cellLines.getIndexOf(h.start.line);let o=p;h.isEmpty||(o=this._cellLines.getIndexOf(h.end.line));const d=new b.Position(p.remainder,h.start.character),E=new b.Position(o.remainder,h.end.character),w=new b.Range(d,E),S=this._cells[p.index];return new b.Location(S.document.uri,S.document.validateRange(w))}contains(h){return this._cellUris.has(h)}validateRange(h){const p=this.validatePosition(h.start),o=this.validatePosition(h.end);return h.with(p,o)}validatePosition(h){const p=this._cellLines.getIndexOf(h.line),o=new b.Position(p.remainder,h.character),d=this._cells[p.index].document.validatePosition(o),E=this._cellLines.getAccumulatedValue(p.index-1);return new b.Position(E+d.line,d.character)}}e.ExtHostNotebookConcatDocument=i}),define(me[196],ge([0,1,7,15,3]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(C){this._actual=new b.ColorTheme(b.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let D=C==="light"?b.ColorThemeKind.Light:C==="dark"?b.ColorThemeKind.Dark:b.ColorThemeKind.HighContrast;this._actual=new b.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=qe([We(0,L.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(me[63],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,b.createDecorator)("IURITransformerService");class L{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=L}),define(me[197],ge([0,1,23]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(D){let k=this.buffers.indexOf(D);return k<0&&(k=this.buffers.length,this.buffers.push(D)),k}}function I(C,D){if(D.serializeBuffersForPostMessage){const k=new L,i=(p,o)=>{if(o instanceof ArrayBuffer){const d=k.add(o);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(o)){const d=T(o);if(d){const E=k.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:d,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},P=JSON.stringify(C,i),h=k.buffers.map(p=>{const o=new Uint8Array(p);return b.VSBuffer.wrap(o)});return{message:P,buffers:h}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=I;function T(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(C,D){const k=D.map(h=>{const p=new ArrayBuffer(h.byteLength);return new Uint8Array(p).set(h.buffer),p}),i=D.length?(h,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const o=p,{index:d}=o,E=k[d];if(o.view)switch(o.view.type){case 1:return new Int8Array(E,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return p}:void 0;return{message:JSON.parse(C,i),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(me[88],ge([0,1,2]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function L(I,T,y){var C;const D=I.webviewResourceRoot.replace("{{resource}}",((C=I.remote.authority)!==null&&C!==void 0?C:"")+"/"+y.scheme+"/"+encodeURIComponent(y.authority)+y.path).replace("{{uuid}}",T);return b.URI.parse(D).with({fragment:y.fragment,query:y.query})}e.asWebviewUri=L}),define(me[198],ge([0,1,3,6,88,30]),function(G,e,b,L,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,k,i){this._proxy=D,this._editors=k,this._initData=i,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const P=k.getVisibleTextEditors();for(const h of this._insets.values())P.indexOf(h.editor)<0&&h.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,k,i,P,h){let p;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===D){p=c;break}if(!p)throw new Error("not a visible editor");const o=this,d=this._handlePool++,E=new b.Emitter,w=new b.Emitter,S=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,I.asWebviewUri)(o._initData,this._uuid,c)}get cspSource(){return o._initData.webviewCspSource}set options(c){this._options=c,o._proxy.$setOptions(d,c)}get options(){return this._options}set html(c){this._html=c,o._proxy.$setHtml(d,c)}get html(){return this._html}get onDidReceiveMessage(){return E.event}postMessage(c){return o._proxy.$postMessage(d,c)}},u=new class{constructor(){this.editor=D,this.line=k,this.height=i,this.webview=S,this.onDidDispose=w.event}dispose(){o._insets.has(d)&&(o._insets.delete(d),o._proxy.$disposeEditorInset(d),w.fire(),w.dispose(),E.dispose())}};return this._proxy.$createEditorInset(d,p.id,p.value.document.uri,k+1,i,P||{},h.identifier,h.extensionLocation),this._insets.set(d,{editor:D,inset:u,onDidReceiveMessage:E}),u}$onDidDispose(D){const k=this._insets.get(D);k&&k.inset.dispose()}$onDidReceiveMessage(D,k){const i=this._insets.get(D);i&&i.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=y}),define(me[199],ge([0,1,3,81,167,4,6,22,39,16,53,24,46,192]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,p.registerIcon)("default-view-icon",h.Codicon.window,(0,I.localize)(0,null));var o;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(o=e.Extensions||(e.Extensions={}));var d;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(d=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function w(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=w;class S extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new b.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new b.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(g,m,_){var l;const v=this.get(g.id);if(v)return v;const R=g;return R.openCommandActionDescriptor=(_==null?void 0:_.donotRegisterOpenCommand)?void 0:(l=R.openCommandActionDescriptor)!==null&&l!==void 0?l:{id:R.id},(0,C.getOrSet)(this.viewContainers,m,[]).push(R),(_==null?void 0:_.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:m}),R}deregisterViewContainer(g){for(const m of this.viewContainers.keys()){const _=this.viewContainers.get(m),l=_==null?void 0:_.indexOf(g);if(l!==-1){_==null||_.splice(l,1),_.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:g,viewContainerLocation:m});return}}}get(g){return this.all.filter(m=>m.id===g)[0]}getViewContainers(g){return[...this.viewContainers.get(g)||[]]}getViewContainerLocation(g){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(_=>(_==null?void 0:_.id)===g.id).length>0)[0]}getDefaultViewContainer(g){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===g)}}D.Registry.add(o.ViewContainersRegistry,new S);var u;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function c(a,g){var m,_,l,v;const R=(m=a.group)!==null&&m!==void 0?m:u.More,O=(_=g.group)!==null&&_!==void 0?_:u.More;return R!==O?R.localeCompare(O):((l=a.order)!==null&&l!==void 0?l:5)-((v=g.order)!==null&&v!==void 0?v:5)}class f extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new b.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new b.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new b.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new b.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(g,m){this.registerViews2([{views:g,viewContainer:m}])}registerViews2(g){g.forEach(({views:m,viewContainer:_})=>this.addViews(m,_)),this._onViewsRegistered.fire(g)}deregisterViews(g,m){const _=this.removeViews(g,m);_.length&&this._onViewsDeregistered.fire({views:_,viewContainer:m})}moveViews(g,m){for(const _ of this._views.keys())if(_!==m){const l=this.removeViews(g,_);l.length&&(this.addViews(l,m),this._onDidChangeContainer.fire({views:l,from:_,to:m}))}}getViews(g){return this._views.get(g)||[]}getView(g){for(const m of this._viewContainers){const _=(this._views.get(m)||[]).filter(l=>l.id===g)[0];if(_)return _}return null}getViewContainer(g){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(l=>l.id===g)[0])return m;return null}registerViewWelcomeContent(g,m){return this._viewWelcomeContents.add(g,m),this._onDidChangeViewWelcomeContent.fire(g),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(g,m),this._onDidChangeViewWelcomeContent.fire(g)})}registerViewWelcomeContent2(g,m){const _=new Map;for(const[l,v]of m)this._viewWelcomeContents.add(g,v),_.set(l,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(g,v),this._onDidChangeViewWelcomeContent.fire(g)}));return this._onDidChangeViewWelcomeContent.fire(g),_}getViewWelcomeContent(g){const m=[];return this._viewWelcomeContents.forEach(g,_=>m.push(_)),m.sort(c)}addViews(g,m){let _=this._views.get(m);_||(_=[],this._views.set(m,_),this._viewContainers.push(m));for(const l of g){if(this.getView(l.id)!==null)throw new Error((0,I.localize)(1,null,l.id));_.push(l)}}removeViews(g,m){const _=this._views.get(m);if(!_)return[];const l=[],v=[];for(const R of _)g.includes(R)?l.push(R):v.push(R);return l.length&&(v.length?this._views.set(m,v):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),l}}D.Registry.add(o.ViewsRegistry,new f),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,I.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(g,m){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,g),this._hasResolve=!!m,this.resolve=async _=>{var l,v;if(m&&!this.resolved){const R=await m(_);R&&(this.tooltip=(l=this.tooltip)!==null&&l!==void 0?l:R.tooltip,this.command=(v=this.command)!==null&&v!==void 0?v:R.command)}_.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(me[200],ge([0,1,2,178,118,14,179,199]),function(G,e,b,L,I,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(o){return(d,...E)=>o(d.get(L.ICommandService),...E)}class k{static execute(d,E){const w={forceReuseWindow:E&&E.reuseWindow,remoteAuthority:E&&E.remoteAuthority};return d.executeCommand("_files.newWindow",w)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",L.CommandsRegistry.registerCommand({id:k.ID,handler:D(k.execute),description:{description:"Opens an new window",args:[]}}),L.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(o,d){return o.get(I.IWorkspacesService).removeRecentlyOpened([d])});class i{static execute(d,E){return typeof E=="string"?E=E.match(/^[^:/?#]+:\/\//)?b.URI.parse(E):b.URI.file(E):E=b.URI.revive(E),d.executeCommand("_workbench.removeFromRecentlyOpened",E)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",L.CommandsRegistry.registerCommand(i.ID,D(i.execute)),L.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(o,d){const E=o.get(I.IWorkspacesService);let w;const S=d.uri,u=d.label,c=d.remoteAuthority;return d.type==="workspace"?w={workspace:await E.getWorkspaceIdentifier(S),label:u,remoteAuthority:c}:d.type==="folder"?w={folderUri:S,label:u,remoteAuthority:c}:w={fileUri:S,label:u,remoteAuthority:c},E.addRecentlyOpened([w])}),L.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(o){return o.get(I.IWorkspacesService).getRecentlyOpened()}),L.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(o,d){const E=o.get(T.ILogService),w=o.get(y.IEnvironmentService);w.isExtensionDevelopment&&!!w.extensionTestsLocationURI&&E.setLevel(d)}),L.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(o){return o.get(T.ILogService).getLevel()}),L.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(o,d){const E=o.get(C.IViewDescriptorService),w=E.getViewContainerById(d.destinationId);if(!!w){for(const S of d.viewIds){const u=E.getViewDescriptorById(S);(u==null?void 0:u.canMoveView)&&E.moveViewsToContainer([u],w,C.ViewVisibilityState.Default)}await o.get(C.IViewsService).openViewContainer(w.id,!0)}});class P{static execute(d,E){return!Array.isArray(E==null?void 0:E.viewIds)||typeof(E==null?void 0:E.destinationId)!="string"?Promise.reject("Invalid arguments"):d.executeCommand("_workbench.action.moveViews",E)}}e.MoveViewsAPICommand=P,P.ID="vscode.moveViews",L.CommandsRegistry.registerCommand({id:P.ID,handler:D(P.execute),description:{description:"Move Views",args:[]}});class h{static execute(d,E){return d.executeCommand("_workbench.open",E)}}h.ID="vscode.open",L.CommandsRegistry.registerCommand(h.ID,D(h.execute));class p{static execute(d,E,w,S,u){return d.executeCommand("_workbench.diff",[E,w,S])}}p.ID="vscode.diff",L.CommandsRegistry.registerCommand(p.ID,D(p.execute))}),define(me[121],ge([0,1,3,13,168]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new b.Emitter,this._onExit=new b.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,D,k,i){const P={command:C};if(D&&Object.keys(D).length>0&&(P.arguments=D),this.internalSend("request",P),typeof i=="number"){const h=setTimeout(()=>{clearTimeout(h);const p=this.pendingRequests.get(P.seq);if(p){this.pendingRequests.delete(P.seq);const o={type:"response",seq:0,request_seq:P.seq,success:!1,command:C,message:(0,I.localize)(0,null,i,C)};p(o)}},i)}return k&&this.pendingRequests.set(P.seq,k),P.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,D){return C.type!=="event"||D.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,L.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const D=C,k=this.pendingRequests.get(D.request_seq);k&&(this.pendingRequests.delete(D.request_seq),k(D));break}}}internalSend(C,D){D.type=C,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((D,k)=>C.set(k,D)),await(0,L.timeout)(500),C.forEach((D,k)=>{D({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(me[201],ge([0,1,8,2,9,24,12]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function D(n,s,r){return n.replace(C,function(a,g){return s&&g.length>0&&g[0]!=="_"?a:r&&r.hasOwnProperty(g)?r[g]:a})}e.formatPII=D;function k(n){const s={};for(const r of Object.keys(n))r.startsWith("!")||(s[r]=n[r]);return s}e.filterExceptionsFromTelemetry=k;function i(n){return n.configuration.request==="attach"&&!P(n)}e.isSessionAttach=i;function P(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,b.equalsIgnoreCase)(s,"extensionhost")||(0,b.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?P(n.parentSession):void 0}e.getExtensionHostDebugSession=P;function h(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=h;function p(n,s,r){let a,g=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=m.exec(n);){let l=_.index+1,v=l+_[0].length;if(l<=s&&v>=r){a=_[0],g=l;break}}if(a){let l=/\w+/g,v=null;for(;(v=l.exec(a))&&!(v.index+1+g+v[0].length>=r););v&&(a=a.substring(0,l.lastIndex))}return a?{start:g,end:g+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(n){return!!(n&&n.match(o))}e.isUri=d;function E(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(d(n.path))return L.URI.parse(n.path);if((0,I.isAbsolute)(n.path))return L.URI.file(n.path)}return n.path}function w(n){if(typeof n.path=="object"){const s=L.URI.revive(n.path);if(s)return s.scheme===y.Schemas.file?s.fsPath:s.toString()}return n.path}function S(n,s){const r=s?E:w,a=(0,T.deepClone)(n);return c(a,(g,m)=>{g&&m&&(m.path=r(m))}),a}e.convertToDAPaths=S;function u(n,s){const r=s?E:w,a=(0,T.deepClone)(n);return c(a,(g,m)=>{!g&&m&&(m.path=r(m))}),a}e.convertToVSCPaths=u;function c(n,s){switch(n.type){case"event":const r=n;switch(r.event){case"output":s(!1,r.body.source);break;case"loadedSource":s(!1,r.body.source);break;case"breakpoint":s(!1,r.body.breakpoint.source);break;default:break}break;case"request":const a=n;switch(a.command){case"setBreakpoints":s(!0,a.arguments.source);break;case"breakpointLocations":s(!0,a.arguments.source);break;case"source":s(!0,a.arguments.source);break;case"gotoTargets":s(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(m=>s(!1,m));break;default:break}break;case"response":const g=n;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(m=>s(!1,m.source));break;case"loadedSources":g.body.sources.forEach(m=>s(!1,m));break;case"scopes":g.body.scopes.forEach(m=>s(!1,m.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(m=>s(!1,m.source));break;case"setBreakpoints":g.body.breakpoints.forEach(m=>s(!1,m.source));break;default:break}break}}function f(n){return n.filter(s=>{var r;return!((r=s.presentation)===null||r===void 0?void 0:r.hidden)}).sort((s,r)=>s.presentation?r.presentation?s.presentation.group?r.presentation.group?s.presentation.group!==r.presentation.group?s.presentation.group.localeCompare(r.presentation.group):t(s.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(s.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=f;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(me[202],ge([0,1,28,38,169,122,9,8,24,10,180,121]),function(G,e,b,L,I,T,y,C,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class h extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(S,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,S.on("data",c=>this.handleData(c))}sendMessage(S){if(this.outputStream){const u=JSON.stringify(S);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${h.TWO_CRLF}${u}`,"utf8")}}handleData(S){for(this.rawData=Buffer.concat([this.rawData,S]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+u))}continue}}else{const u=this.rawData.indexOf(h.TWO_CRLF);if(u!==-1){const f=this.rawData.toString("utf8",0,u).split(h.HEADER_LINESEPARATOR);for(const t of f){const n=t.split(h.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(u+h.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=h,h.TWO_CRLF=`\r
\r
`,h.HEADER_LINESEPARATOR=/\r?\n/,h.HEADER_FIELDSEPARATOR=/: */;class p extends h{startSession(){return new Promise((S,u)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),S(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",f=>{c?this._onError.fire(f):u(f)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class o extends p{constructor(S){super();this.adapterServer=S}createConnection(S){return T.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",S)}}e.SocketDebugAdapter=o;class d extends p{constructor(S){super();this.adapterServer=S}createConnection(S){return T.createConnection(this.adapterServer.path,S)}}e.NamedPipeDebugAdapter=d;class E extends h{constructor(S,u,c){super();this.adapterExecutable=S,this.debugType=u,this.outputService=c}async startSession(){const S=this.adapterExecutable.command,u=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(S)if(y.isAbsolute(S)){if(!await(0,b.exists)(S))throw new Error(I.localize(0,null,S))}else S.indexOf("/")<0&&S.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let f=process.env;if(c.env&&Object.keys(c.env).length>0&&(f=D.mixin(D.deepClone(process.env),c.env)),S==="node")if(Array.isArray(u)&&u.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:f,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(s.cwd=c.cwd);const r=L.fork(u[0],u.slice(1),s);if(!r.pid)throw new Error(I.localize(2,null,u[0]));this.serverProcess=r}else throw new Error(I.localize(3,null));else{const n={env:f};c.cwd&&(n.cwd=c.cwd),this.serverProcess=L.spawn(S,u,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,s)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const r=t.getChannel(i.ExtensionsChannelId);r&&r.append(n(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(f){this._onError.fire(f)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),k.isWindows?new Promise((S,u)=>{const c=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(f,t,n){if(f)return u(f)});c.on("exit",S),c.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(S,u){if(!!S){const c=Object.create(null);S.runtime&&(S.runtime.indexOf("./")===0?c.runtime=y.join(u,S.runtime):c.runtime=S.runtime),S.runtimeArgs&&(c.runtimeArgs=S.runtimeArgs),S.program&&(y.isAbsolute(S.program)?c.program=S.program:c.program=y.join(u,S.program)),S.args&&(c.args=S.args);const f=S;return f.win&&(c.win=E.extract(f.win,u)),f.winx86&&(c.winx86=E.extract(f.winx86,u)),f.windows&&(c.windows=E.extract(f.windows,u)),f.osx&&(c.osx=E.extract(f.osx,u)),f.linux&&(c.linux=E.extract(f.linux,u)),c}}static platformAdapterExecutable(S,u){let c=Object.create(null);u=u.toLowerCase();for(const a of S)if(a.contributes){const g=a.contributes.debuggers;g&&g.length>0&&g.filter(m=>typeof m.type=="string"&&C.equalsIgnoreCase(m.type,u)).forEach(m=>{const _=E.extract(m,a.extensionLocation.fsPath);c=D.mixin(c,_,a.isBuiltin)})}let f;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?f=c.winx86||c.win||c.windows:k.isWindows?f=c.win||c.windows:k.isMacintosh?f=c.osx:k.isLinux&&(f=c.linux),f=f||c;let t=f.program||c.program;const n=f.args||c.args;let s=f.runtime||c.runtime;const r=f.runtimeArgs||c.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=E}),define(me[203],ge([0,1,38,10,29,187]),function(G,e,b,L,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function y(h,p){return new Promise((o,d)=>{let E="";const w=b.spawn(h,p);w.pid&&w.stdout.on("data",S=>{E+=S.toString()}),w.on("error",S=>{d(S)}),w.on("close",S=>{o(E)})})}let C;function D(h,p){if(!C)if(L.isWindows)C=new T.WindowsExternalTerminalService(void 0);else if(L.isMacintosh)C=new T.MacExternalTerminalService(void 0);else if(L.isLinux)C=new T.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const o=p.getConfiguration("terminal");return C.runInTerminal(h.title,h.cwd,h.args,h.env||{},o.external||{})}e.runInExternalTerminal=D;function k(h){return h?L.isWindows?new Promise(async p=>{(await new Promise((d,E)=>{G(["windows-process-tree"],d,E)})).getProcessTree(h,d=>{p(d.children.length>0)})}):y("/usr/bin/pgrep",["-lP",String(h)]).then(p=>{const o=p.trim();return!(o.length===0||o.indexOf(" tmux")>=0)},p=>!0):Promise.resolve(!0)}e.hasChildProcesses=k;var i;(function(h){h[h.cmd=0]="cmd",h[h.powershell=1]="powershell",h[h.bash=2]="bash"})(i||(i={}));function P(h,p,o,d){h=h.trim().toLowerCase();let E;h.indexOf("powershell")>=0||h.indexOf("pwsh")>=0?E=1:h.indexOf("cmd.exe")>=0?E=0:h.indexOf("bash")>=0?E=2:L.isWindows?E=0:E=2;let w,S=" ";switch(E){case 1:if(w=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),o){const c=(0,I.getDriveLetter)(o);c&&(S+=`${c}:; `),S+=`cd ${w(o)}; `}if(d)for(let c in d){const f=d[c];f===null?S+=`Remove-Item env:${c}; `:S+=`\${env:${c}}='${f}'; `}if(p.length>0){const c=w(p.shift());S+=c[0]==="'"?`& ${c} `:`${c} `;for(let f of p)S+=`${w(f)} `}break;case 0:if(w=c=>(c=c.replace(/\"/g,'""'),c.indexOf(" ")>=0||c.indexOf('"')>=0||c.length===0?`"${c}"`:c),o){const c=(0,I.getDriveLetter)(o);c&&(S+=`${c}: && `),S+=`cd ${w(o)} && `}if(d){S+='cmd /C "';for(let c in d){let f=d[c];f===null?S+=`set "${c}=" && `:(f=f.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),S+=`set "${c}=${f}" && `)}}for(let c of p)S+=`${w(c)} `;d&&(S+='"');break;case 2:w=c=>(c=c.replace(/(["'\\\$])/g,"\\$1"),c.indexOf(" ")>=0||c.indexOf(";")>=0||c.length===0?`"${c}"`:c);const u=c=>/[^\w@%\/+=,.:^-]/.test(c)?`'${c.replace(/'/g,"'\\''")}'`:c;if(o&&(S+=`cd ${w(o)} ; `),d){S+="/usr/bin/env";for(let c in d){const f=d[c];f===null?S+=` -u ${u(c)}`:S+=` ${u(`${c}=${f}`)}`}S+=" "}for(let c of p)S+=`${w(c)} `;break}return S}e.prepareCommand=P}),define(me[64],ge([0,1,32,12,9,10,81]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.ExperimentalUndoRedoPerCell=e.ExperimentalCompactView=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(l){l[l.Markup=1]="Markup",l[l.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(l){l[l.Running=1]="Running",l[l.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var k;(function(l){l[l.Pending=2]="Pending",l[l.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(l){l[l.WithHardKernelDependency=0]="WithHardKernelDependency",l[l.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",l[l.Pure=2]="Pure",l[l.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var P;(function(l){l[l.ModelChange=1]="ModelChange",l[l.Move=2]="Move",l[l.CellClearOutput=3]="CellClearOutput",l[l.CellsClearOutput=4]="CellsClearOutput",l[l.ChangeLanguage=5]="ChangeLanguage",l[l.Initialize=6]="Initialize",l[l.ChangeCellMetadata=7]="ChangeCellMetadata",l[l.Output=8]="Output",l[l.OutputItem=9]="OutputItem",l[l.ChangeCellContent=10]="ChangeCellContent",l[l.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",l[l.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",l[l.Unknown=100]="Unknown"})(P=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(l){l[l.Handle=0]="Handle",l[l.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(l){l[l.Replace=1]="Replace",l[l.Output=2]="Output",l[l.Metadata=3]="Metadata",l[l.CellLanguage=4]="CellLanguage",l[l.DocumentMetadata=5]="DocumentMetadata",l[l.Move=6]="Move",l[l.OutputItems=7]="OutputItems",l[l.PartialMetadata=8]="PartialMetadata",l[l.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));function o(l,v){if(v)return l.toString();const R=d.parse(l);return R?R.notebook.toString():l.toString()}e.getCellUndoRedoComparisonKey=o;var d;(function(l){l.scheme=L.Schemas.vscodeNotebookCell;const v=/^ch(\d{7,})/;function R(N,B){return N.with({scheme:l.scheme,fragment:`ch${B.toString().padStart(7,"0")}${N.scheme!==L.Schemas.file?N.scheme:""}`})}l.generate=R;function O(N){if(N.scheme===l.scheme){const B=v.exec(N.fragment);if(!!B)return{handle:Number(B[1]),notebook:N.with({scheme:N.fragment.substr(B[0].length)||L.Schemas.file,fragment:null})}}}l.parse=O;function H(N){if(N.scheme===L.Schemas.vscodeNotebookCellMetadata){const B=v.exec(N.fragment);if(!!B)return{handle:Number(B[1]),notebook:N.with({scheme:N.fragment.substr(B[0].length)||L.Schemas.file,fragment:null})}}}l.parseCellMetadataUri=H;function ne(N,B,U){return N.with({scheme:U,fragment:`ch${B.toString().padStart(7,"0")}${N.scheme!==L.Schemas.file?N.scheme:""}`})}l.generateCellUri=ne;function ie(N,B){if(N.scheme===B){const U=v.exec(N.fragment);if(!!U)return{handle:Number(U[1]),notebook:N.with({scheme:N.fragment.substr(U[0].length)||L.Schemas.file,fragment:null})}}}l.parseCellUri=ie})(d=e.CellUri||(e.CellUri={}));const E=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(l){var v,R;return(R=(v=E.get(l))===null||v===void 0?void 0:v.alwaysSecure)!==null&&R!==void 0?R:!1}e.mimeTypeIsAlwaysSecure=w;function S(l){var v,R;return(R=(v=E.get(l))===null||v===void 0?void 0:v.supportedByCore)!==null&&R!==void 0?R:!1}e.mimeTypeSupportedByCore=S;function u(l){var v,R;return(R=(v=E.get(l))===null||v===void 0?void 0:v.mergeable)!==null&&R!==void 0?R:!1}e.mimeTypeIsMergeable=u;function c(l,v){return T.isWindows&&(l=l.replace(/\//g,"\\"),v=v.replace(/\//g,"\\")),b.match(l,v)}function f(l,v,R){let O=0;for(let H=0;H<v.length;H++){if(c(v[H],l))return O;O++}for(let H=0;H<R.length;H++){if(c(R[H],l))return O;O++}return O}function t(l,v,R){return l.sort((O,H)=>f(O,v,R)-f(H,v,R))}e.sortMimeTypes=t;function n(l,v,R,O=(H,ne)=>H===ne){const H=[];function ne(B,U,A){if(!(U===0&&A.length===0)){const x=H[H.length-1];x&&x.start+x.deleteCount===B?(x.deleteCount+=U,x.toInsert.push(...A)):H.push({start:B,deleteCount:U,toInsert:A})}}let ie=0,N=0;for(;;){if(ie===l.length){ne(ie,0,v.slice(N));break}if(N===v.length){ne(ie,l.length-ie,[]);break}const B=l[ie],U=v[N];if(O(B,U)){ie+=1,N+=1;continue}R(U)?(ne(ie,1,[]),ie+=1):(ne(ie,0,[U]),N+=1)}return H}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(l){l.default="default",l.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(l){const v=l;return!!((typeof v.include=="string"||b.isRelativePattern(v.include))&&(typeof v.exclude=="string"||b.isRelativePattern(v.exclude)))}e.isDocumentExcludePattern=r;function a(l,v,R){if(Array.isArray(l.viewType)&&l.viewType.indexOf(v)>=0||l.viewType===v)return!0;if(l.filenamePattern){let O=r(l.filenamePattern)?l.filenamePattern.include:l.filenamePattern,H=r(l.filenamePattern)?l.filenamePattern.exclude:void 0;if(b.match(O,(0,I.basename)(R.fsPath).toLowerCase()))return!(H&&b.match(H,(0,I.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a;class g{constructor(v){this.textModel=v}getElements(){const v=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)v[R]=this.textModel.cells[R].getHashValue();return v}}e.CellSequence=g,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalCompactView="notebook.experimental.compactView",e.ExperimentalUndoRedoPerCell="notebook.experimental.undoRedoPerCell";var m;(function(l){l[l.Left=1]="Left",l[l.Right=2]="Right"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class _{static create(v){return`${_._prefix}/${v}`}static parse(v){if(v.startsWith(_._prefix))return v.substr(_._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=_,_._prefix="notebook/"}),define(me[204],ge([0,1,171,4,81]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,b.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,b.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,b.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[205],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=b;function L(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=L}),define(me[123],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var b;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));const L=(D,k)=>{k.expand!==void 0&&(D.expand=k.expand),k.item!==void 0&&(D.item=D.item?Object.assign(D.item,k.item):k.item)};e.applyTestItemUpdate=L;var I;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(I=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(D,k)=>`${D}:${k.toString()}`;e.getTestSubscriptionKey=T;class y{add(k){}update(k){}remove(k,i){}complete(){}}e.IncrementalChangeCollector=y;class C{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const i=this.createChangeCollector();for(const P of k)switch(P[0]){case 0:{const h=P[1];if(h.parent){if(this.items.has(h.parent)){const p=this.items.get(h.parent);p.children.add(h.item.extId);const o=this.createItem(h,p);this.items.set(h.item.extId,o),i.add(o)}}else{this.roots.add(h.item.extId);const p=this.createItem(h);this.items.set(h.item.extId,p),i.add(p)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=P[1],p=this.items.get(h.extId);if(!p)break;h.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,h),i.update(p);break}case 2:{const h=this.items.get(P[1]);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h.item.extId);const p=[[P[1]]];for(;p.length;)for(const o of p.pop()){const d=this.items.get(o);d&&(p.push(d.children),this.items.delete(o),i.remove(d,d!==h),d.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(P[1]);break;case 3:this.updatePendingRoots(P[1]);break}i.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=C}),define(me[206],ge([0,1,9,36,11,24,10,77,172]),function(G,e,b,L,I,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(P,h,p){this._contributedVariables=new Map,this._context=P,this._labelService=h,p&&(this._envVariablesPromise=p.then(o=>this.prepareEnv(o)))}prepareEnv(P){if(y.isWindows){const h=Object.create(null);return Object.keys(P).forEach(p=>{h[p.toLowerCase()]=P[p]}),h}return P}resolveWithEnvironment(P,h,p){return this.recursiveResolve(this.prepareEnv(P),h?h.uri:void 0,p)}async resolveAsync(P,h){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,h)}async resolveAnyBase(P,h,p,o){const d=T.deepClone(h);return y.isWindows&&d.windows?Object.keys(d.windows).forEach(E=>d[E]=d.windows[E]):y.isMacintosh&&d.osx?Object.keys(d.osx).forEach(E=>d[E]=d.osx[E]):y.isLinux&&d.linux&&Object.keys(d.linux).forEach(E=>d[E]=d.linux[E]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,d,p,o)}async resolveAnyAsync(P,h,p){return this.resolveAnyBase(P,h,p)}async resolveAnyMap(P,h,p){const o=new Map;return{newConfig:await this.resolveAnyBase(P,h,p,o),resolvedVariables:o}}resolveWithInteractionReplace(P,h,p,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,h,p,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,h){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,h)}recursiveResolve(P,h,p,o,d){if(I.isString(p))return this.resolveString(P,h,p,o,d);if(I.isArray(p))return p.map(E=>this.recursiveResolve(P,h,E,o,d));if(I.isObject(p)){let E=Object.create(null);return Object.keys(p).forEach(w=>{const S=this.resolveString(P,h,w,o,d);E[S]=this.recursiveResolve(P,h,p[w],o,d)}),E}return p}resolveString(P,h,p,o,d){return p.replace(k.VARIABLE_REGEXP,(w,S)=>{if(S.includes(k.VARIABLE_LHS))return w;let u=this.evaluateSingleVariable(P,w,S,h,o);return d&&d.set(S,u),u})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,h,p,o,d){let E;const w=p.split(":");w.length>1&&(p=w[0],E=w[1]);const S=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error((0,D.localize)(0,null,h))},u=()=>{const f=S();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,h,b.basename(f)))},c=()=>{if(E){const f=this._context.getFolderUri(E);if(f)return f;throw new Error((0,D.localize)(2,null,h,E))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,h)):new Error((0,D.localize)(4,null,h))};switch(p){case"env":if(E){if(P){const f=P[y.isWindows?E.toLowerCase():E];if(I.isString(f))return f}return""}throw new Error((0,D.localize)(5,null,h));case"config":if(E){const f=this._context.getConfigurationValue(o,E);if(I.isUndefinedOrNull(f))throw new Error((0,D.localize)(6,null,h,E));if(I.isObject(f))throw new Error((0,D.localize)(7,null,h,E));return f}throw new Error((0,D.localize)(8,null,h));case"command":return this.resolveFromMap(h,E,d,"command");case"input":return this.resolveFromMap(h,E,d,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return o||E?(0,C.normalizeDriveLetter)(this.fsPath(c())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(c()));case"lineNumber":const f=this._context.getLineNumber();if(f)return f;throw new Error((0,D.localize)(9,null,h));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,h));case"file":return S();case"fileWorkspaceFolder":return u();case"relativeFile":return o||E?b.relative(this.fsPath(c()),S()):S();case"relativeFileDirname":const n=b.dirname(S());if(o||E){const g=b.relative(this.fsPath(c()),n);return g.length===0?".":g}return n;case"fileDirname":return b.dirname(S());case"fileExtname":return b.extname(S());case"fileBasename":return b.basename(S());case"fileBasenameNoExtension":const s=b.basename(S());return s.slice(0,s.length-b.extname(s).length);case"fileDirnameBasename":return b.basename(b.dirname(S()));case"execPath":const r=this._context.getExecPath();return r||h;case"execInstallFolder":const a=this._context.getAppRoot();return a||h;case"pathSeparator":return b.sep;default:try{const g=E?`${p}:${E}`:p;return this.resolveFromMap(h,g,d,void 0)}catch(g){return h}}}}resolveFromMap(P,h,p,o){if(h&&p){const d=o===void 0?p[h]:p[o+":"+h];if(typeof d=="string")return d;throw new Error((0,D.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[207],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var L;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(L=e.GroupDirection||(e.GroupDirection={}));var I;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(I=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(h){h[h.GROUP_ACTIVE=0]="GROUP_ACTIVE",h[h.GROUP_INDEX=1]="GROUP_INDEX",h[h.EDITOR_OPEN=2]="EDITOR_OPEN",h[h.EDITOR_CLOSE=3]="EDITOR_CLOSE",h[h.EDITOR_MOVE=4]="EDITOR_MOVE",h[h.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",h[h.EDITOR_LABEL=6]="EDITOR_LABEL",h[h.EDITOR_PIN=7]="EDITOR_PIN",h[h.EDITOR_STICKY=8]="EDITOR_STICKY",h[h.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function P(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(me[208],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(me[20],ge([0,1,16,97,279,59,24,11,2,43,80,173,114,64,208,7]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(de){function Se(X){const{selectionStartLineNumber:Be,selectionStartColumn:Le,positionLineNumber:Je,positionColumn:it}=X,at=new d.Position(Be-1,Le-1),ht=new d.Position(Je-1,it-1);return new d.Selection(at,ht)}de.to=Se;function ae(X){const{anchor:Be,active:Le}=X;return{selectionStartLineNumber:Be.line+1,selectionStartColumn:Be.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}de.from=ae})(E=e.Selection||(e.Selection={}));var w;(function(de){function Se(X){if(!!X){const{start:Be,end:Le}=X;return{startLineNumber:Be.line+1,startColumn:Be.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}}de.from=Se;function ae(X){if(!!X){const{startLineNumber:Be,startColumn:Le,endLineNumber:Je,endColumn:it}=X;return new d.Range(Be-1,Le-1,Je-1,it-1)}}de.to=ae})(w=e.Range||(e.Range={}));var S;(function(de){function Se(ae){switch(ae){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}de.to=Se})(S=e.TokenType||(e.TokenType={}));var u;(function(de){function Se(X){return new d.Position(X.lineNumber-1,X.column-1)}de.to=Se;function ae(X){return{lineNumber:X.line+1,column:X.character+1}}de.from=ae})(u=e.Position||(e.Position={}));var c;(function(de){function Se(X){switch(X){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}de.from=Se;function ae(X){switch(X){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}de.to=ae})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(de){function Se(X){let Be;return X.code&&((0,C.isString)(X.code)||(0,C.isNumber)(X.code)?Be=String(X.code):Be={value:String(X.code.value),target:X.code.target}),Object.assign(Object.assign({},w.from(X.range)),{message:X.message,source:X.source,code:Be,severity:n.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(t.from),tags:Array.isArray(X.tags)?(0,b.coalesce)(X.tags.map(c.from)):void 0})}de.from=Se;function ae(X){var Be;const Le=new d.Diagnostic(w.to(X),X.message,n.to(X.severity));return Le.source=X.source,Le.code=(0,C.isString)(X.code)?X.code:(Be=X.code)===null||Be===void 0?void 0:Be.value,Le.relatedInformation=X.relatedInformation&&X.relatedInformation.map(t.to),Le.tags=X.tags&&(0,b.coalesce)(X.tags.map(c.to)),Le}de.to=ae})(f=e.Diagnostic||(e.Diagnostic={}));var t;(function(de){function Se(X){return Object.assign(Object.assign({},w.from(X.location.range)),{message:X.message,resource:X.location.uri})}de.from=Se;function ae(X){return new d.DiagnosticRelatedInformation(new d.Location(X.resource,w.to(X)),X.message)}de.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(de){function Se(X){switch(X){case d.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}de.from=Se;function ae(X){switch(X){case h.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}de.to=ae})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(de){function Se(X){return typeof X=="number"&&X>=d.ViewColumn.One?X-1:X===d.ViewColumn.Beside?o.SIDE_GROUP:o.ACTIVE_GROUP}de.from=Se;function ae(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=ae})(s=e.ViewColumn||(e.ViewColumn={}));function r(de){return typeof de.range!="undefined"}function a(de){return de.length===0?!0:!!r(de[0])}e.isDecorationOptionsArr=a;var g;(function(de){function Se(it){return it.map(de.from)}de.fromMany=Se;function ae(it){return it&&typeof it=="object"&&typeof it.language=="string"&&typeof it.value=="string"}function X(it){let at;if(ae(it)){const{language:ft,value:ct}=it;at={value:"```"+ft+`
`+ct+"\n```\n"}}else d.MarkdownString.isMarkdownString(it)?at={value:it.value,isTrusted:it.isTrusted,supportThemeIcons:it.supportThemeIcons}:typeof it=="string"?at={value:it}:at={value:""};const ht=Object.create(null);at.uris=ht;const Ye=ft=>{try{let ct=D.URI.parse(ft,!0);ct=ct.with({query:Be(ct.query,ht)}),ht[ft]=ct}catch(ct){}return""},lt=new I.Renderer;return lt.link=Ye,lt.image=ft=>Ye(L.parseHrefAndDimensions(ft).href),I(at.value,{renderer:lt}),at}de.from=X;function Be(it,at){if(!it)return it;let ht;try{ht=(0,T.parse)(it)}catch(lt){}if(!ht)return it;let Ye=!1;return ht=(0,y.cloneAndChange)(ht,lt=>{if(D.URI.isUri(lt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[ft]=lt,Ye=!0,ft}else return}),Ye?JSON.stringify(ht):it}function Le(it){const at=new d.MarkdownString(it.value,it.supportThemeIcons);return at.isTrusted=it.isTrusted,at}de.to=Le;function Je(it){if(!!it)return typeof it=="string"?it:de.from(it)}de.fromStrict=Je})(g=e.MarkdownString||(e.MarkdownString={}));function m(de){return a(de)?de.map(Se=>({range:w.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?g.fromMany(Se.hoverMessage):Se.hoverMessage?g.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):de.map(Se=>({range:w.from(Se)}))}e.fromRangeOrRangeWithMessage=m;function _(de){return typeof de=="undefined"?de:typeof de=="string"?D.URI.file(de):de}e.pathOrURIToURI=_;var l;(function(de){function Se(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?_(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}de.from=Se})(l=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var v;(function(de){function Se(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?_(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?l.from(ae.before):void 0,after:ae.after?l.from(ae.after):void 0}}de.from=Se})(v=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(de){function Se(ae){if(typeof ae=="undefined")return ae;switch(ae){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=Se})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(de){function Se(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?R.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?v.from(ae.light):void 0,dark:ae.dark?v.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?_(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?l.from(ae.before):void 0,after:ae.after?l.from(ae.after):void 0}}de.from=Se})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(de){function Se(X){return{text:X.newText,eol:X.newEol&&te.from(X.newEol),range:w.from(X.range)}}de.from=Se;function ae(X){const Be=new d.TextEdit(w.to(X.range),X.text);return Be.newEol=typeof X.eol=="undefined"?void 0:te.to(X.eol),Be}de.to=ae})(H=e.TextEdit||(e.TextEdit={}));var ne;(function(de){function Se(X,Be,Le){var Je,it,at;const ht={edits:[]};if(X instanceof d.WorkspaceEdit)for(let Ye of X._allEntries())if(Ye._type===1)ht.edits.push({_type:1,oldUri:Ye.from,newUri:Ye.to,options:Ye.options,metadata:Ye.metadata});else if(Ye._type===2){const lt=Be==null?void 0:Be.getDocument(Ye.uri);ht.edits.push({_type:2,resource:Ye.uri,edit:H.from(Ye.edit),modelVersionId:lt==null?void 0:lt.version,metadata:Ye.metadata})}else Ye._type===3?ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:(Je=Le==null?void 0:Le.getNotebookDocument(Ye.uri,!0))===null||Je===void 0?void 0:Je.apiNotebook.version}):Ye._type===4?(Ye.newOutputs&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:2,index:Ye.index,append:Ye.append,outputs:Ye.newOutputs.map(Ae.from)}}),Ye.newMetadata&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:8,index:Ye.index,metadata:Ye.newMetadata}})):Ye._type===5?ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:(it=Le==null?void 0:Le.getNotebookDocument(Ye.uri,!0))===null||it===void 0?void 0:it.apiNotebook.version,edit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(J.from)}}):Ye._type===6&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:7,outputId:Ye.outputId,items:((at=Ye.newOutputItems)===null||at===void 0?void 0:at.map(ce.from))||[],append:Ye.append}});return ht}de.from=Se;function ae(X){const Be=new d.WorkspaceEdit;for(const Le of X.edits)Le.edit?Be.replace(D.URI.revive(Le.resource),w.to(Le.edit.range),Le.edit.text):Be.renameFile(D.URI.revive(Le.oldUri),D.URI.revive(Le.newUri),Le.options);return Be}de.to=ae})(ne=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ie;(function(de){const Se=Object.create(null);Se[d.SymbolKind.File]=0,Se[d.SymbolKind.Module]=1,Se[d.SymbolKind.Namespace]=2,Se[d.SymbolKind.Package]=3,Se[d.SymbolKind.Class]=4,Se[d.SymbolKind.Method]=5,Se[d.SymbolKind.Property]=6,Se[d.SymbolKind.Field]=7,Se[d.SymbolKind.Constructor]=8,Se[d.SymbolKind.Enum]=9,Se[d.SymbolKind.Interface]=10,Se[d.SymbolKind.Function]=11,Se[d.SymbolKind.Variable]=12,Se[d.SymbolKind.Constant]=13,Se[d.SymbolKind.String]=14,Se[d.SymbolKind.Number]=15,Se[d.SymbolKind.Boolean]=16,Se[d.SymbolKind.Array]=17,Se[d.SymbolKind.Object]=18,Se[d.SymbolKind.Key]=19,Se[d.SymbolKind.Null]=20,Se[d.SymbolKind.EnumMember]=21,Se[d.SymbolKind.Struct]=22,Se[d.SymbolKind.Event]=23,Se[d.SymbolKind.Operator]=24,Se[d.SymbolKind.TypeParameter]=25;function ae(Be){return typeof Se[Be]=="number"?Se[Be]:6}de.from=ae;function X(Be){for(const Le in Se)if(Se[Le]===Be)return Number(Le);return d.SymbolKind.Property}de.to=X})(ie=e.SymbolKind||(e.SymbolKind={}));var N;(function(de){function Se(X){switch(X){case d.SymbolTag.Deprecated:return 1}}de.from=Se;function ae(X){switch(X){case 1:return d.SymbolTag.Deprecated}}de.to=ae})(N=e.SymbolTag||(e.SymbolTag={}));var B;(function(de){function Se(X){return{name:X.name,kind:ie.from(X.kind),tags:X.tags&&X.tags.map(N.from),containerName:X.containerName,location:M.from(X.location)}}de.from=Se;function ae(X){const Be=new d.SymbolInformation(X.name,ie.to(X.kind),X.containerName,M.to(X.location));return Be.tags=X.tags&&X.tags.map(N.to),Be}de.to=ae})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(de){function Se(X){var Be,Le;const Je={name:X.name||"!!MISSING: name!!",detail:X.detail,range:w.from(X.range),selectionRange:w.from(X.selectionRange),kind:ie.from(X.kind),tags:(Le=(Be=X.tags)===null||Be===void 0?void 0:Be.map(N.from))!==null&&Le!==void 0?Le:[]};return X.children&&(Je.children=X.children.map(Se)),Je}de.from=Se;function ae(X){const Be=new d.DocumentSymbol(X.name,X.detail,ie.to(X.kind),w.to(X.range),w.to(X.selectionRange));return(0,b.isNonEmptyArray)(X.tags)&&(Be.tags=X.tags.map(N.to)),X.children&&(Be.children=X.children.map(ae)),Be}de.to=ae})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var A;(function(de){function Se(ae){const X=new d.CallHierarchyItem(ie.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),w.to(ae.range),w.to(ae.selectionRange));return X._sessionId=ae._sessionId,X._itemId=ae._itemId,X}de.to=Se})(A=e.CallHierarchyItem||(e.CallHierarchyItem={}));var x;(function(de){function Se(ae){return new d.CallHierarchyIncomingCall(A.to(ae.from),ae.fromRanges.map(X=>w.to(X)))}de.to=Se})(x=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(de){function Se(ae){return new d.CallHierarchyOutgoingCall(A.to(ae.to),ae.fromRanges.map(X=>w.to(X)))}de.to=Se})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(de){function Se(X){return{range:X.range&&w.from(X.range),uri:X.uri}}de.from=Se;function ae(X){return new d.Location(D.URI.revive(X.uri),w.to(X.range))}de.to=ae})(M=e.location||(e.location={}));var W;(function(de){function Se(X){const Be=X,Le=X;return{originSelectionRange:Be.originSelectionRange?w.from(Be.originSelectionRange):void 0,uri:Be.targetUri?Be.targetUri:Le.uri,range:w.from(Be.targetRange?Be.targetRange:Le.range),targetSelectionRange:Be.targetSelectionRange?w.from(Be.targetSelectionRange):void 0}}de.from=Se;function ae(X){return{targetUri:D.URI.revive(X.uri),targetRange:w.to(X.range),targetSelectionRange:X.targetSelectionRange?w.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?w.to(X.originSelectionRange):void 0}}de.to=ae})(W=e.DefinitionLink||(e.DefinitionLink={}));var z;(function(de){function Se(X){return{range:w.from(X.range),contents:g.fromMany(X.contents)}}de.from=Se;function ae(X){return new d.Hover(X.contents.map(g.to),w.to(X.range))}de.to=ae})(z=e.Hover||(e.Hover={}));var Y;(function(de){function Se(X){return{range:w.from(X.range),expression:X.expression}}de.from=Se;function ae(X){return new d.EvaluatableExpression(w.to(X.range),X.expression)}de.to=ae})(Y=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(de){function Se(X){if(X instanceof d.InlineValueText)return{type:"text",range:w.from(X.range),text:X.text};if(X instanceof d.InlineValueVariableLookup)return{type:"variable",range:w.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}de.from=Se;function ae(X){switch(X.type){case"text":return{range:w.to(X.range),text:X.text};case"variable":return{range:w.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:w.to(X.range),expression:X.expression}}}de.to=ae})(le=e.InlineValue||(e.InlineValue={}));var ve;(function(de){function Se(X){return{frameId:X.frameId,stoppedLocation:w.from(X.stoppedLocation)}}de.from=Se;function ae(X){return new d.InlineValueContext(X.frameId,w.to(X.stoppedLocation))}de.to=ae})(ve=e.InlineValueContext||(e.InlineValueContext={}));var Te;(function(de){function Se(X){return{range:w.from(X.range),kind:X.kind}}de.from=Se;function ae(X){return new d.DocumentHighlight(w.to(X.range),X.kind)}de.to=ae})(Te=e.DocumentHighlight||(e.DocumentHighlight={}));var ye;(function(de){function Se(ae){switch(ae){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}de.to=Se})(ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(de){function Se(ae){return{triggerKind:ye.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}de.to=Se})(Oe=e.CompletionContext||(e.CompletionContext={}));var j;(function(de){function Se(X){switch(X){case d.CompletionItemTag.Deprecated:return 1}}de.from=Se;function ae(X){switch(X){case 1:return d.CompletionItemTag.Deprecated}}de.to=ae})(j=e.CompletionItemTag||(e.CompletionItemTag={}));var Q;(function(de){const Se=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ae(Le){var Je;return(Je=Se.get(Le))!==null&&Je!==void 0?Je:9}de.from=ae;const X=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Be(Le){var Je;return(Je=X.get(Le))!==null&&Je!==void 0?Je:d.CompletionItemKind.Property}de.to=Be})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(de){function Se(ae,X){var Be;const Le=new d.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Le.label2=ae.label),Le.insertText=ae.insertText,Le.kind=Q.to(ae.kind),Le.tags=(Be=ae.tags)===null||Be===void 0?void 0:Be.map(j.to),Le.detail=ae.detail,Le.documentation=L.isMarkdownString(ae.documentation)?g.to(ae.documentation):ae.documentation,Le.sortText=ae.sortText,Le.filterText=ae.filterText,Le.preselect=ae.preselect,Le.commitCharacters=ae.commitCharacters,k.Range.isIRange(ae.range)?Le.range=w.to(ae.range):typeof ae.range=="object"&&(Le.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),Le.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Le.insertText=new d.SnippetString(ae.insertText):(Le.insertText=ae.insertText,Le.textEdit=Le.range instanceof d.Range?new d.TextEdit(Le.range,Le.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Le.additionalTextEdits=ae.additionalTextEdits.map(Je=>H.to(Je))),Le.command=X&&ae.command?X.fromInternal(ae.command):void 0,Le}de.to=Se})(Z=e.CompletionItem||(e.CompletionItem={}));var se;(function(de){function Se(X){return{label:X.label,documentation:X.documentation?g.fromStrict(X.documentation):void 0}}de.from=Se;function ae(X){return{label:X.label,documentation:L.isMarkdownString(X.documentation)?g.to(X.documentation):X.documentation}}de.to=ae})(se=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(de){function Se(X){return{label:X.label,documentation:X.documentation?g.fromStrict(X.documentation):void 0,parameters:Array.isArray(X.parameters)?X.parameters.map(se.from):[],activeParameter:X.activeParameter}}de.from=Se;function ae(X){return{label:X.label,documentation:L.isMarkdownString(X.documentation)?g.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(se.to):[],activeParameter:X.activeParameter}}de.to=ae})(fe=e.SignatureInformation||(e.SignatureInformation={}));var _e;(function(de){function Se(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(fe.from):[]}}de.from=Se;function ae(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(fe.to):[]}}de.to=ae})(_e=e.SignatureHelp||(e.SignatureHelp={}));var xe;(function(de){function Se(X){var Be;return{text:X.text,position:u.from(X.position),kind:pe.from((Be=X.kind)!==null&&Be!==void 0?Be:d.InlayHintKind.Other),whitespaceBefore:X.whitespaceBefore,whitespaceAfter:X.whitespaceAfter}}de.from=Se;function ae(X){const Be=new d.InlayHint(X.text,u.to(X.position),pe.to(X.kind));return Be.whitespaceAfter=X.whitespaceAfter,Be.whitespaceBefore=X.whitespaceBefore,Be}de.to=ae})(xe=e.InlayHint||(e.InlayHint={}));var pe;(function(de){function Se(X){return X}de.from=Se;function ae(X){return X}de.to=ae})(pe=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(de){function Se(X){return{range:w.from(X.range),url:X.target,tooltip:X.tooltip}}de.from=Se;function ae(X){let Be;if(X.url)try{Be=typeof X.url=="string"?D.URI.parse(X.url,!0):D.URI.revive(X.url)}catch(Le){}return new d.DocumentLink(w.to(X.range),Be)}de.to=ae})(ke=e.DocumentLink||(e.DocumentLink={}));var Fe;(function(de){function Se(X){const Be=new d.ColorPresentation(X.label);return X.textEdit&&(Be.textEdit=H.to(X.textEdit)),X.additionalTextEdits&&(Be.additionalTextEdits=X.additionalTextEdits.map(Le=>H.to(Le))),Be}de.to=Se;function ae(X){return{label:X.label,textEdit:X.textEdit?H.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Be=>H.from(Be)):void 0}}de.from=ae})(Fe=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(de){function Se(X){return new d.Color(X[0],X[1],X[2],X[3])}de.to=Se;function ae(X){return[X.red,X.green,X.blue,X.alpha]}de.from=ae})(He=e.Color||(e.Color={}));var be;(function(de){function Se(X){return{range:w.from(X.range)}}de.from=Se;function ae(X){return new d.SelectionRange(w.to(X.range))}de.to=ae})(be=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(de){function Se(ae){switch(ae){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}de.to=Se})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var K;(function(de){function Se(X){switch(X){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}de.from=Se;function ae(X){switch(X){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}de.to=ae})(K=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(de){function Se(X){if(X===d.EndOfLine.CRLF)return 1;if(X===d.EndOfLine.LF)return 0}de.from=Se;function ae(X){if(X===1)return d.EndOfLine.CRLF;if(X===0)return d.EndOfLine.LF}de.to=ae})(te=e.EndOfLine||(e.EndOfLine={}));var we;(function(de){function Se(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=Se})(we=e.ProgressLocation||(e.ProgressLocation={}));var Ue;(function(de){function Se(ae){const X={start:ae.start+1,end:ae.end+1};return ae.kind&&(X.kind=je.from(ae.kind)),X}de.from=Se})(Ue=e.FoldingRange||(e.FoldingRange={}));var je;(function(de){function Se(ae){if(ae)switch(ae){case d.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}de.from=Se})(je=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ze;(function(de){function Se(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?P.EditorOverride.DISABLED:void 0}}de.from=Se})(ze=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(de){function Se(X){return X instanceof d.RelativePattern||typeof X=="string"?X:ae(X)?new d.RelativePattern(X.base,X.pattern):X}de.from=Se;function ae(X){const Be=X;return Be&&typeof Be.base=="string"&&typeof Be.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var Ce;(function(de){function Se(ae){if(ae){if(Array.isArray(ae))return ae.map(Se);if(typeof ae=="string")return ae;{const X=ae;return{language:X.language,scheme:X.scheme,pattern:typeof X.pattern=="undefined"?void 0:Ze.from(X.pattern),exclusive:X.exclusive}}}else return}de.from=Se})(Ce=e.LanguageSelector||(e.LanguageSelector={}));var De;(function(de){function Se(X){return{start:X.start,end:X.end}}de.from=Se;function ae(X){return new d.NotebookRange(X.start,X.end)}de.to=ae})(De=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(de){function Se(ae){return new d.NotebookCellMetadata().with(Object.assign(Object.assign({},ae),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}de.to=Se})(Pe=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var oe;(function(de){function Se(X){return X}de.from=Se;function ae(X){return new d.NotebookDocumentMetadata().with(X)}de.to=ae})(oe=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ue;(function(de){function Se(X){return{startTime:X.runStartTime,endTime:X.runEndTime,executionOrder:X.executionOrder,success:X.lastRunSuccess}}de.to=Se;function ae(X){return{lastRunSuccess:X.success,runStartTime:X.startTime,runEndTime:X.endTime,executionOrder:X.executionOrder}}de.from=ae})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var V;(function(de){function Se(X){switch(X){case d.NotebookCellKind.Markup:return p.CellKind.Markup;case d.NotebookCellKind.Code:default:return p.CellKind.Code}}de.from=Se;function ae(X){switch(X){case p.CellKind.Markup:return d.NotebookCellKind.Markup;case p.CellKind.Code:default:return d.NotebookCellKind.Code}}de.to=ae})(V=e.NotebookCellKind||(e.NotebookCellKind={}));var J;(function(de){function Se(X){var Be;return{cellKind:V.from(X.kind),language:X.languageId,source:X.value,metadata:X.metadata,internalMetadata:ue.from((Be=X.executionSummary)!==null&&Be!==void 0?Be:{}),outputs:X.outputs?X.outputs.map(Ae.from):[]}}de.from=Se;function ae(X){return new d.NotebookCellData(V.to(X.cellKind),X.source,X.language,X.outputs?X.outputs.map(Ae.to):void 0,X.metadata?Pe.to(X.metadata):void 0)}de.to=ae})(J=e.NotebookCellData||(e.NotebookCellData={}));var ce;(function(de){function Se(X){return{mime:X.mime,value:X.value,metadata:X.metadata}}de.from=Se;function ae(X){return new d.NotebookCellOutputItem(X.mime,X.value,X.metadata)}de.to=ae})(ce=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(de){function Se(X){return{outputId:X.id,outputs:X.outputs.map(ce.from),metadata:X.metadata}}de.from=Se;function ae(X){const Be=X.outputs.map(ce.to);return new d.NotebookCellOutput(Be,X.outputId,X.metadata)}de.to=ae})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ee;(function(de){function Se(Le){if(Le!=null){if(Le instanceof d.RelativePattern||typeof Le=="string")return Le;if(Be(Le))return new d.RelativePattern(Le.base,Le.pattern);if(X(Le))return{include:Ze.from(Le.include)||void 0,exclude:Ze.from(Le.exclude)||void 0}}}de.from=Se;function ae(Le){return typeof Le=="string"?Le:Be(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}de.to=ae;function X(Le){const Je=Le,it=Ze.from(Je.include);if(!(it&&it instanceof d.RelativePattern||typeof it=="string"))return!1;const at=Ze.from(Je.exclude);return!!(at&&at instanceof d.RelativePattern||typeof at=="string")}function Be(Le){const Je=Le;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Ee=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Me;(function(de){function Se(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?l.from(ae.top):void 0}}de.from=Se})(Me=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ve;(function(de){function Se(ae,X,Be){const Le=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Le,Be),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}de.from=Se})(Ve=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Xe;(function(de){function Se(ae){var X,Be,Le;return{transientOutputs:(X=ae==null?void 0:ae.transientOutputs)!==null&&X!==void 0?X:!1,transientCellMetadata:(Be=ae==null?void 0:ae.transientCellMetadata)!==null&&Be!==void 0?Be:{},transientDocumentMetadata:(Le=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Le!==void 0?Le:{}}}de.from=Se})(Xe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var rt;(function(de){function Se(X){var Be;return{uri:X.uri,provides:typeof X.provides=="string"?[X.provides]:(Be=X.provides)!==null&&Be!==void 0?Be:[]}}de.from=Se;function ae(X){return new d.NotebookKernelPreload(D.URI.revive(X.uri),X.provides)}de.to=ae})(rt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var Qe;(function(de){function Se(X){return{message:g.fromStrict(X.message)||"",severity:X.severity,expectedOutput:X.expectedOutput,actualOutput:X.actualOutput,location:X.location?M.from(X.location):void 0}}de.from=Se;function ae(X){const Be=new d.TestMessage(typeof X.message=="string"?X.message:g.to(X.message));return Be.severity=X.severity,Be.actualOutput=X.actualOutput,Be.expectedOutput=X.expectedOutput,Be}de.to=ae})(Qe=e.TestMessage||(e.TestMessage={}));var et;(function(de){function Se(Le){var Je,it;return{extId:Le.id,label:Le.label,uri:Le.uri,range:w.from(Le.range)||null,debuggable:(Je=Le.debuggable)!==null&&Je!==void 0?Je:!1,description:Le.description||null,runnable:(it=Le.runnable)!==null&&it!==void 0?it:!0,error:Le.error&&g.fromStrict(Le.error)||null}}de.from=Se;function ae(Le){return{extId:Le.id,label:Le.label,uri:Le.uri,range:w.from(Le.range)||null,debuggable:!1,description:Le.description||null,error:null,runnable:!0}}de.fromResultSnapshot=ae;function X(Le){return{id:Le.extId,label:Le.label,uri:D.URI.revive(Le.uri),range:w.to(Le.range||void 0),addChild:()=>{},dispose:()=>{},status:d.TestItemStatus.Pending,data:void 0,debuggable:Le.debuggable,description:Le.description||void 0,runnable:Le.runnable}}de.toPlain=X;function Be(Le){const Je=new d.TestItemImpl(Le.extId,Le.label,D.URI.revive(Le.uri),void 0);return Je.range=w.to(Le.range||void 0),Je.debuggable=Le.debuggable,Je.description=Le.description||void 0,Je.runnable=Le.runnable,Je}de.to=Be})(et=e.TestItem||(e.TestItem={}));var pt;(function(de){const Se=(X,Be)=>Object.assign(Object.assign({},et.toPlain(X.item)),{taskStates:X.tasks.map(Le=>({state:Le.state,duration:Le.duration,messages:Le.messages.map(Qe.to)})),children:X.children.map(Le=>Be.get(Le)).filter(C.isDefined).map(Le=>Se(Le,Be))});function ae(X){const Be=[],Le=new Map;for(const Je of X.items)Le.set(Je.item.extId,Je),Je.direct&&Be.push(Je);return{completedAt:X.completedAt,results:Be.map(Je=>Se(Je,Le))}}de.to=ae})(pt=e.TestResults||(e.TestResults={}));var bt;(function(de){function Se(ae){switch(ae){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}de.to=Se})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(me[209],ge([0,1,2,17,7,20,57]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(k,i,P,h={timeout:1500,errors:3}){this._logService=k,this._documents=i,this._mainThreadBulkEdits=P,this._thresholds=h,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(i,P,h)=>{const o={dispose:this._callbacks.push([i,P,k])};return Array.isArray(h)&&h.push(o),o}}async $participateInSave(k,i){const P=b.URI.revive(k);let h=!1;const p=setTimeout(()=>h=!0,this._thresholds.timeout),o=[];try{for(let d of[...this._callbacks]){if(h)break;const E=this._documents.getDocument(P),w=await this._deliverEventAsyncAndBlameBadListeners(d,{document:E,reason:T.TextDocumentSaveReason.to(i)});o.push(w)}}finally{clearTimeout(p)}return o}_deliverEventAsyncAndBlameBadListeners([k,i,P],h){const p=this._badListeners.get(k);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,k,i,h).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const d=this._badListeners.get(k);this._badListeners.set(k,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,i,P,h){const p=[],o=Date.now(),{document:d,reason:E}=h,{version:w}=d,S=Object.freeze({document:d,reason:E,waitUntil(u){if(Object.isFrozen(p))throw(0,L.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(u))}});try{i.apply(P,[S])}catch(u){return Promise.reject(u)}return Object.freeze(p),new Promise((u,c)=>{const f=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(f),u(t)}).catch(t=>{clearTimeout(f),c(t)})}).then(u=>{const c={edits:[]};for(const f of u)if(Array.isArray(f)&&f.every(t=>t instanceof I.TextEdit))for(const{newText:t,newEol:n,range:s}of f)c.edits.push({_type:2,resource:d.uri,edit:{range:s&&T.Range.from(s),text:t,eol:n&&T.EndOfLine.from(n)}});if(c.edits.length!==0)return w===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(me[210],ge([0,1,3,13,32,2,20,7]),function(G,e,b,L,I,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(P,h,p,o,d){this._onDidCreate=new b.Emitter,this._onDidChange=new b.Emitter,this._onDidDelete=new b.Emitter,this._config=0,p&&(this._config+=1),o&&(this._config+=2),d&&(this._config+=4);const E=(0,I.parse)(h),w=P(S=>{if(!p)for(let u of S.created){const c=T.URI.revive(u);E(c.fsPath)&&this._onDidCreate.fire(c)}if(!o)for(let u of S.changed){const c=T.URI.revive(u);E(c.fsPath)&&this._onDidChange.fire(c)}if(!d)for(let u of S.deleted){const c=T.URI.revive(u);E(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(P,h,p){this._logService=h,this._extHostDocumentsAndEditors=p,this._onFileSystemEvent=new b.Emitter,this._onDidRenameFile=new b.Emitter,this._onDidCreateFile=new b.Emitter,this._onDidDeleteFile=new b.Emitter,this._onWillRenameFile=new L.AsyncEmitter,this._onWillCreateFile=new L.AsyncEmitter,this._onWillDeleteFile=new L.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,h,p,o){return new D(this._onFileSystemEvent.event,P,h,p,o)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,h){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:h.map(p=>({oldUri:T.URI.revive(p.source),newUri:T.URI.revive(p.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:h.map(p=>T.URI.revive(p.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:h.map(p=>T.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,h){return(p,o,d)=>{const E=function(S){p.call(o,S)};return E.extension=P,h.event(E,void 0,d)}}async $onWillRunFileOperation(P,h,p,o){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:h.map(d=>({oldUri:T.URI.revive(d.source),newUri:T.URI.revive(d.target)}))},p,o);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:h.map(d=>T.URI.revive(d.target))},p,o);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:h.map(d=>T.URI.revive(d.target))},p,o)}}async _fireWillEvent(P,h,p,o){const d=new Set,E=[];if(await P.fireAsync(h,o,async(S,u)=>{var c;const f=Date.now(),t=await Promise.resolve(S);t instanceof C.WorkspaceEdit&&(E.push(t),d.add((c=u.extension.displayName)!==null&&c!==void 0?c:u.extension.identifier.value)),Date.now()-f>p&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),!o.isCancellationRequested&&E.length!==0){const w={edits:[]};for(let S of E){let{edits:u}=y.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(u)}return{edit:w,extensionNames:Array.from(d)}}}}e.ExtHostFileSystemEventService=k}),define(me[211],ge([0,1,12,24,2,20,7,64]),function(G,e,b,L,I,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(h,p,o,d){this.start=h,this.deletedCount=p,this.deletedItems=o,this.items=d}static asApiEvents(h){return h.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(o=>o.apiCell)}))}}class k{constructor(h,p,o){var d,E,w;this.notebook=h,this._extHostDocument=p,this._cellData=o,this.handle=o.handle,this.uri=I.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(d=o.internalMetadata)!==null&&d!==void 0?d:{},this._metadata=T.NotebookCellMetadata.to((E=o.metadata)!==null&&E!==void 0?E:{}),this._previousResult=T.NotebookCellExecutionSummary.to((w=o.internalMetadata)!==null&&w!==void 0?w:{})}static asModelAddData(h,p){return{EOL:p.eol,lines:p.source,modeId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:h}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const h=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return h.notebook.getCellIndex(h)},notebook:h.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get outputs(){return h._outputs.slice(0)},get metadata(){return h._metadata},get executionSummary(){return h._previousResult}})}return this._apiCell}setOutputs(h){this._outputs=h.map(T.NotebookCellOutput.to)}setOutputItems(h,p,o){const d=o.map(T.NotebookCellOutputItem.to),E=this._outputs.find(w=>w.id===h);E&&(p||(E.outputs.length=0),E.outputs.push(...d))}setMetadata(h){this._metadata=T.NotebookCellMetadata.to(h)}setInternalMetadata(h){this._internalMetadata=h,this._previousResult=T.NotebookCellExecutionSummary.to(h)}}e.ExtHostCell=k;class i{constructor(h,p,o,d,E,w,S){this._proxy=h,this._textDocumentsAndEditors=p,this._textDocuments=o,this._emitter=d,this._viewType=E,this._metadata=w,this.uri=S,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const h=this;this._notebook={get uri(){return h.uri},get version(){return h._versionId},get viewType(){return h._viewType},get isDirty(){return h._isDirty},get isUntitled(){return h.uri.scheme===b.Schemas.untitled},get isClosed(){return h._disposed},get metadata(){return h._metadata},get cellCount(){return h._cells.length},cellAt(p){return p=h._validateIndex(p),h._cells[p].apiCell},getCells(p){return(p?h._getCells(p):h._cells).map(d=>d.apiCell)},save(){return h._save()}}}return this._notebook}updateBackup(h){var p;(p=this._backup)===null||p===void 0||p.delete(),this._backup=h}disposeBackup(){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(h){h.metadata&&(this._metadata=this._metadata.with(h.metadata))}acceptModelChanged(h,p){this._versionId=h.versionId,this._isDirty=p;for(const o of h.rawEvents)o.kind===C.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(o.changes,!0),o.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===C.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(h){return h=h|0,h<0?0:h>=this._cells.length?this._cells.length-1:h}_validateRange(h){let p=h.start|0,o=h.end|0;return p<0&&(p=0),o>this._cells.length&&(o=this._cells.length),h.with({start:p,end:o})}_getCells(h){h=this._validateRange(h);const p=[];for(let o=h.start;o<h.end;o++)p.push(this._cells[o]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(h,p){if(!this._disposed){const o=[],d=[],E=[];h.reverse().forEach(w=>{const u=w[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return p||d.push(k.asModelAddData(this.apiNotebook,t)),n}),c=new D(w[0],w[1],[],u),f=this._cells.splice(w[0],w[1],...u);for(const t of f)E.push(t.uri),c.deletedItems.push(t.apiCell);o.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:E}),p||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(o)}))}}_moveCell(h,p){const o=this._cells.splice(h,1);this._cells.splice(p,0,...o);const d=[new D(h,1,o.map(E=>E.apiCell),[]),new D(p,0,[],o)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(d)}))}_setCellOutputs(h,p){const o=this._cells[h];o.setOutputs(p),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(h,p,o,d){const E=this._cells[h];E.setOutputItems(p,o,d),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(h,p){const o=this._cells[h];o.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(o.uri,p)}_changeCellMetadata(h,p){const o=this._cells[h],d=o.apiCell.metadata;o.setMetadata(p);const E=o.apiCell.metadata;(0,L.equals)(d,E)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(h,p){var o;const d=this._cells[h],E=d.internalMetadata;if(d.setInternalMetadata(p),E.runState!==p.runState){const w=(o=p.runState)!==null&&o!==void 0?o:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:d.apiCell,executionState:w}))}}getCellFromApiCell(h){return this._cells.find(p=>p.apiCell===h)}getCellFromIndex(h){return this._cells[h]}getCell(h){return this._cells.find(p=>p.handle===h)}getCellIndex(h){return this._cells.indexOf(h)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(me[212],ge([0,1,7,20]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class I{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:D})}replaceCells(C,D,k){this._throwIfFinalized(),!(C===D&&k.length===0)&&this._collectedEdits.push({editType:1,index:C,count:D-C,cells:k.map(L.NotebookCellData.from)})}}class T{constructor(C,D,k,i,P,h){this.id=C,this._proxy=D,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=P,this._visibleRanges=i,this._viewColumn=h}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},get visibleRanges(){return C._visibleRanges},revealRange(D,k){C._proxy.$tryRevealRange(C.id,L.NotebookRange.from(D),k!=null?k:b.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(D){const k=new I(this.document.version);return D(k),C._applyEdit(k.finalize())},setDecorations(D,k){return C.setDecorations(D,k)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const D=[];let k=-1;for(let i=0;i<C.cellEdits.length;i++){if(k<0){D.push(C.cellEdits[i]),k++;continue}const h=D[k],p=C.cellEdits[i];if(h.editType===1&&p.editType===1&&h.index===p.index){h.cells.push(...C.cellEdits[i].cells),h.count+=C.cellEdits[i].count;continue}D.push(C.cellEdits[i]),k++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,D)}setDecorations(C,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return D.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(D),C.key)}}e.ExtHostNotebookEditor=T}),define(me[213],ge([0,1,20,115,161,21,54]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,h,p){const o=this._handles++,{title:d,location:E,cancellable:w}=h,S={label:(0,I.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(o,{location:b.ProgressLocation.from(E),title:d,source:S,cancellable:w},P),this._withProgress(o,p,!!w)}_withProgress(P,h,p){let o;p&&(o=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,o));const d=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),o&&o.dispose()};let E;try{E=h(new k(this._proxy,P),p&&o?o.token:T.CancellationToken.None)}catch(w){throw d(P),w}return E.then(w=>d(P),w=>d(P)),E}$acceptProgressCanceled(P){const h=this._mapHandleToCancellationSource.get(P);h&&(h.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=C;function D(i,P){return i.message=P.message,typeof P.increment=="number"&&(typeof i.increment=="number"?i.increment+=P.increment:i.increment=P.increment),i}class k extends L.Progress{constructor(P,h){super(p=>this.throttledReport(p));this._proxy=P,this._handle=h}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}qe([(0,y.throttle)(100,(i,P)=>D(i,P),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(me[124],ge([0,1,52,17,73,20,7]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(h,p){const o=C._Keys.nextId();h.$registerTextEditorDecorationType(o,T.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:o,dispose(){h.$removeTextEditorDecorationType(o)}})}}e.TextEditorDecorationType=C,C._Keys=new I.IdGenerator("TextEditorDecorationType");class D{constructor(h,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=h,this._documentVersionId=h.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(h,p){this._throwIfFinalized();let o=null;if(h instanceof y.Position)o=new y.Range(h,h);else if(h instanceof y.Range)o=h;else throw new Error("Unrecognized location");this._pushEdit(o,p,!1)}insert(h,p){this._throwIfFinalized(),this._pushEdit(new y.Range(h,h),p,!0)}delete(h){this._throwIfFinalized();let p=null;if(h instanceof y.Range)p=h;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(h,p,o){const d=this._document.validateRange(h);this._collectedEdits.push({range:d,text:p,forceMoveMarkers:o})}setEndOfLine(h){if(this._throwIfFinalized(),h!==y.EndOfLine.LF&&h!==y.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=h}}e.TextEditorEdit=D;class k{constructor(h,p,o,d){this._proxy=h,this._id=p,this._accept(o),this._logService=d;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(w){E._setTabSize(w)},get insertSpaces(){return E._insertSpaces},set insertSpaces(w){E._setInsertSpaces(w)},get cursorStyle(){return E._cursorStyle},set cursorStyle(w){E._setCursorStyle(w)},get lineNumbers(){return E._lineNumbers},set lineNumbers(w){E._setLineNumbers(w)}}}_accept(h){this._tabSize=h.tabSize,this._insertSpaces=h.insertSpaces,this._cursorStyle=h.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(h.lineNumbers)}_validateTabSize(h){if(h==="auto")return"auto";if(typeof h=="number"){const p=Math.floor(h);return p>0?p:null}if(typeof h=="string"){const p=parseInt(h,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(h){const p=this._validateTabSize(h);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(h){return h==="auto"?"auto":h==="false"?!1:Boolean(h)}_setInsertSpaces(h){const p=this._validateInsertSpaces(h);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(h){this._cursorStyle!==h&&(this._cursorStyle=h,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:h})))}_setLineNumbers(h){this._lineNumbers!==h&&(this._lineNumbers=h,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(h)})))}assign(h){const p={};let o=!1;if(typeof h.tabSize!="undefined"){const d=this._validateTabSize(h.tabSize);d==="auto"?(o=!0,p.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,o=!0,p.tabSize=d)}if(typeof h.insertSpaces!="undefined"){const d=this._validateInsertSpaces(h.insertSpaces);d==="auto"?(o=!0,p.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,o=!0,p.insertSpaces=d)}typeof h.cursorStyle!="undefined"&&this._cursorStyle!==h.cursorStyle&&(this._cursorStyle=h.cursorStyle,o=!0,p.cursorStyle=h.cursorStyle),typeof h.lineNumbers!="undefined"&&this._lineNumbers!==h.lineNumbers&&(this._lineNumbers=h.lineNumbers,o=!0,p.lineNumbers=T.TextEditorLineNumbersStyle.from(h.lineNumbers)),o&&this._warnOnError(this._proxy.$trySetOptions(this._id,p))}_warnOnError(h){h.catch(p=>this._logService.warn(p))}}e.ExtHostTextEditorOptions=k;class i{constructor(h,p,o,d,E,w,S,u){this.id=h,this._proxy=p,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new k(this._proxy,this.id,w,o),this._visibleRanges=S,this._viewColumn=u;const c=this;this.value=Object.freeze({get document(){return d.getValue()},set document(f){throw(0,L.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(f){if(!(f instanceof y.Selection))throw(0,L.illegalArgument)("selection");c._selections=[f],c._trySetSelection()},get selections(){return c._selections},set selections(f){if(!Array.isArray(f)||f.some(t=>!(t instanceof y.Selection)))throw(0,L.illegalArgument)("selections");c._selections=f,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(f){throw(0,L.readonly)("visibleRanges")},get options(){return c._options.value},set options(f){c._disposed||c._options.assign(f)},get viewColumn(){return c._viewColumn},set viewColumn(f){throw(0,L.readonly)("viewColumn")},edit(f,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(d.getValue(),t);return f(n),c._applyEdit(n)},insertSnippet(f,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=c._selections.map(r=>T.Range.from(r));else if(t instanceof y.Position){const{lineNumber:r,column:a}=T.Position.from(t);s=[{startLineNumber:r,startColumn:a,endLineNumber:r,endColumn:a}]}else if(t instanceof y.Range)s=[T.Range.from(t)];else{s=[];for(const r of t)if(r instanceof y.Range)s.push(T.Range.from(r));else{const{lineNumber:a,column:g}=T.Position.from(r);s.push({startLineNumber:a,startColumn:g,endLineNumber:a,endColumn:g})}}return p.$tryInsertSnippet(h,f.value,s,n)},setDecorations(f,t){const n=t.length===0;n&&!c._hasDecorationsForKey.has(f.key)||(n?c._hasDecorationsForKey.delete(f.key):c._hasDecorationsForKey.add(f.key),c._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return p.$trySetDecorations(h,f.key,T.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let r=0,a=t.length;r<a;r++){const g=t[r];s[4*r]=g.start.line+1,s[4*r+1]=g.start.character+1,s[4*r+2]=g.end.line+1,s[4*r+3]=g.end.character+1}return p.$trySetDecorationsFast(h,f.key,s)}}))},revealRange(f,t){c._runOnProxy(()=>p.$tryRevealRange(h,T.Range.from(f),t||y.TextEditorRevealType.Default))},show(f){p.$tryShowEditor(h,T.ViewColumn.from(f))},hide(){p.$tryHideEditor(h)}})}dispose(){(0,b.ok)(!this._disposed),this._disposed=!0}_acceptOptions(h){(0,b.ok)(!this._disposed),this._options._accept(h)}_acceptVisibleRanges(h){(0,b.ok)(!this._disposed),this._visibleRanges=h}_acceptViewColumn(h){(0,b.ok)(!this._disposed),this._viewColumn=h}_acceptSelections(h){(0,b.ok)(!this._disposed),this._selections=h}async _trySetSelection(){const h=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,h)),this.value}_applyEdit(h){const p=h.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const o=p.edits.map(E=>E.range);o.sort((E,w)=>E.end.line===w.end.line?E.end.character===w.end.character?E.start.line===w.start.line?E.start.character-w.start.character:E.start.line-w.start.line:E.end.character-w.end.character:E.end.line-w.end.line);for(let E=0,w=o.length-1;E<w;E++){const S=o[E].end;if(o[E+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=p.edits.map(E=>({range:T.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,d,{setEndOfLine:typeof p.setEndOfLine=="number"?T.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(h){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=i}),define(me[214],ge([0,1,164,25,2,3,6,13,7,11,16,20,21]),function(G,e,b,L,I,T,y,C,D,k,i,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(E,w){if((0,k.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let S;return Array.isArray(E.highlights)&&(S=E.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),S=S.length?S:void 0),{label:E.label,highlights:S}}}class o{constructor(w,S,u){this._proxy=w,this.commands=S,this.logService=u,this.treeViews=new Map;function c(f){return f&&f.$treeViewId&&f.$treeItemHandle}S.registerArgumentProcessor({processArgument:f=>c(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(t=>c(t)?this.convertArgument(t):t):f})}registerTreeDataProvider(w,S,u){const c=this.createTreeView(w,{treeDataProvider:S},u);return{dispose:()=>c.dispose()}}createTreeView(w,S,u){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=S.dragAndDropController!==void 0,f=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany,canDragAndDrop:c}),t=this.createExtHostTreeView(w,S,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(n){t.message=n},get title(){return t.title},set title(n){t.title=n},get description(){return t.description},set description(n){t.description=n},reveal:(n,s)=>t.reveal(n,s),dispose:async()=>{await f,this.treeViews.delete(w),t.dispose()}}}$getChildren(w,S){const u=this.treeViews.get(w);return u?u.getChildren(S):Promise.reject(new Error((0,b.localize)(0,null,w)))}$onDrop(w,S,u){const c=this.treeViews.get(w);return c?c.onDrop(S,u):Promise.reject(new Error((0,b.localize)(1,null,w)))}async $hasResolve(w){const S=this.treeViews.get(w);if(!S)throw new Error((0,b.localize)(2,null,w));return S.hasResolve}$resolve(w,S,u){const c=this.treeViews.get(w);if(!c)throw new Error((0,b.localize)(3,null,w));return c.resolveTreeItem(S,u)}$setExpanded(w,S,u){const c=this.treeViews.get(w);if(!c)throw new Error((0,b.localize)(4,null,w));c.setExpanded(S,u)}$setSelection(w,S){const u=this.treeViews.get(w);if(!u)throw new Error((0,b.localize)(5,null,w));u.setSelection(S)}$setVisible(w,S){const u=this.treeViews.get(w);if(!u)throw new Error((0,b.localize)(6,null,w));u.setVisible(S)}createExtHostTreeView(w,S,u){const c=new d(w,S,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(w,c),c}convertArgument(w){const S=this.treeViews.get(w.$treeViewId);return S?S.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=o;class d extends y.Disposable{constructor(w,S,u,c,f,t){super();if(this.viewId=w,this.proxy=u,this.commands=c,this.logService=f,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const a of t.contributes.views[r])a.id===w&&(this._title=a.name);this.dataProvider=S.treeDataProvider,this.dndController=S.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,s;this._register(T.Event.debounce(this._onDidChangeData.event,(r,a)=>(r||(r={message:!1,elements:[]}),a.element!==!1&&(n||(n=new Promise(g=>s=g),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(a.element)),a.message&&(r.message=!0),r),200,!0)(({message:r,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=s;return n=null,this.refresh(a).then(()=>g())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,k.isUndefinedOrNull)(w))}getChildren(w){const S=w?this.getExtensionElement(w):void 0;if(w&&!S)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(w);return(u?Promise.resolve(u):this.fetchChildrenNodes(S)).then(c=>c.map(f=>f.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,S){S=S||{select:!0,focus:!1};const u=(0,k.isUndefinedOrNull)(S.select)?!0:S.select,c=(0,k.isUndefinedOrNull)(S.focus)?!1:S.focus,f=(0,k.isUndefinedOrNull)(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:u,focus:c,expand:f})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:c,expand:f})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,S){const u=this.getExtensionElement(w);u&&(S?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(w){(0,i.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(w,S){const u=w.map(f=>this.getExtensionElement(f)).filter(f=>!(0,k.isUndefinedOrNull)(f)),c=this.getExtensionElement(S);return u&&c?(0,C.asPromise)(()=>{var f;return(f=this.dndController)===null||f===void 0?void 0:f.onDrop(u,c)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,S){var u;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(w);if(c){const f=this.nodes.get(c);if(f){const t=(u=await this.dataProvider.resolveTreeItem(f.extensionItem,c,S))!==null&&u!==void 0?u:f.extensionItem;return f.item.tooltip=this.getTooltip(t.tooltip),f.item.command=this.getCommand(f.disposableStore,t.command),f.item}}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(S=>S?this.resolveUnknownParentChain(S).then(u=>this.resolveTreeNode(S,u[u.length-1]).then(c=>(u.push(c),u))):Promise.resolve([]))}resolveParent(w){const S=this.nodes.get(w);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,S){const u=this.nodes.get(w);return u?Promise.resolve(u):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(c=>this.createHandle(w,c,S,!0)).then(c=>this.getChildren(S?S.item.handle:void 0).then(()=>{const f=this.getExtensionElement(c);if(f){const t=this.nodes.get(f);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(w){if(w){let S;if(typeof w=="string"){const u=this.getExtensionElement(w);S=u?this.nodes.get(u):void 0}else S=w;return S&&S.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const S=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=w?this.nodes.get(w):void 0,c=await this.dataProvider.getChildren(w);if(S.token.isCancellationRequested)return[];const f=await Promise.all((0,i.coalesce)(c||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,u):null}));return S.token.isCancellationRequested?[]:(0,i.coalesce)(f)}finally{S.dispose()}}refresh(w){if(w.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(w);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const S=new Set,u=w.map(f=>this.nodes.get(f));for(const f of u)if(f&&!S.has(f.item.handle)){let t=f;for(;t&&t.parent&&u.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&S.add(f.item.handle)}const c=[];return S.forEach(f=>{const t=this.elements.get(f);if(t){const n=this.nodes.get(t);n&&(!n.parent||!S.has(n.parent.item.handle))&&c.push(f)}}),c}refreshHandles(w){const S={};return Promise.all(w.map(u=>this.refreshNode(u).then(c=>{c&&(S[u]=c.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(w){const S=this.getExtensionElement(w);if(S){const u=this.nodes.get(S);if(u)return this.clearChildren(S),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(S)).then(c=>{if(c){const f=this.createTreeNode(S,c,u.parent);return this.updateNodeCache(S,f,u,u.parent),u.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,S,u){const c=this.createTreeNode(w,S,u);if(S.id&&this.elements.has(c.item.handle))throw new Error((0,b.localize)(7,null,S.id));return this.addNodeToCache(w,c),this.addNodeToParentCache(c,u),c}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?P.MarkdownString.from(w):w}getCommand(w,S){return S?this.commands.toInternal(S,w):void 0}createTreeNode(w,S,u){const c=new y.DisposableStore,f=this.createHandle(w,S,u),t=this.getLightIconPath(S);return{item:{handle:f,parentHandle:u?u.item.handle:void 0,label:p(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(c,S.command),contextValue:S.contextValue,icon:t,iconDark:this.getDarkIconPath(S)||t,themeIcon:this.getThemeIcon(S),collapsibleState:(0,k.isUndefinedOrNull)(S.collapsibleState)?D.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:u,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:S,label:u,resourceUri:c},f,t){if(S)return`${d.ID_HANDLE_PREFIX}/${S}`;const n=p(u,this.extension),s=f?f.item.handle:d.LABEL_HANDLE_PREFIX;let r=n?n.label:c?(0,L.basename)(c):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const a=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,g=this.getChildrenNodes(f)||[];let m,_=0;do{if(m=`${s}/${_}:${r}`,t||!this.elements.has(m)||a===m)break;_++}while(_<=g.length);return m}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||I.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return I.URI.isUri(w)?w:I.URI.file(w)}addNodeToCache(w,S){this.elements.set(S.item.handle,w),this.nodes.set(w,S)}updateNodeCache(w,S,u,c){this.elements.delete(S.item.handle),this.nodes.delete(w),S.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(w,S);const f=this.getChildrenNodes(c)||[],t=f.filter(n=>n.item.handle===u.item.handle)[0];t&&f.splice(f.indexOf(t),1,S)}addNodeToParentCache(w,S){S?(S.children||(S.children=[]),S.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const S=this.nodes.get(w);if(S){if(S.children)for(const u of S.children){const c=this.elements.get(u.item.handle);c&&this.clear(c)}S.children=void 0}}else this.clearAll()}clear(w){const S=this.nodes.get(w);if(S){if(S.children)for(const u of S.children){const c=this.elements.get(u.item.handle);c&&this.clear(c)}this.nodes.delete(w),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(me[215],ge([0,1,16,13,21,11,87,20,7,123]),function(G,e,b,L,I,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(E,w){if(w!==void 0){const S=this.testIdsToInternal.get(w),u=S==null?void 0:S.get(E);if(u)return[S,u]}return(0,b.mapFind)(this.testIdsToInternal.values(),S=>{const u=S.get(E);return u&&[S,u]})}createForHierarchy(E=()=>{}){return new o(this.createIdMap(h++),E)}createIdMap(E){const w=new p(E);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=i;var P;(function(d){d[d.Disconnected=0]="Disconnected",d[d.IsChild=1]="IsChild",d[d.IsParent=2]="IsParent",d[d.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));let h=0;class p{constructor(E){this.id=E,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(E){if(this.map.has(E.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${E.item.extId}`);this.map.set(E.item.extId,E),E.parent||this._roots.add(E)}has(E){return this.map.has(E)}delete(E){const w=this.map.get(E);return w?(this.map.delete(E),this._roots.delete(w),!0):!1}get(E){return this.map.get(E)}comparePositions(E,w){const S=typeof E=="string"?this.map.get(E):E,u=typeof w=="string"?this.map.get(w):w;if(!S||!u)return 0;if(S===u)return 3;for(let c=this.map.get(u.parent);c;c=this.map.get(c.parent))if(c===S)return 1;for(let c=this.map.get(S.parent);c;c=this.map.get(c.parent))if(c===u)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=p;class o{constructor(E,w){this.testIdToInternal=E,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new L.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(E,w){this.addItem(E,w,null)}getTestByReference(E){return this.testItemToInternal.get(E)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const w=this.diff[this.diff.length-1];if(w&&E[0]===1){if(w[0]===1&&w[1].extId===E[1].extId){(0,k.applyTestItemUpdate)(w[1],E[1]);return}if(w[0]===0&&w[1].item.extId===E[1].extId){(0,k.applyTestItemUpdate)(w[1],E[1]);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,w){var S;const u=this.testIdToInternal.object.get(E);if(!!u){if((u.expandLevels===void 0||w>u.expandLevels)&&(u.expandLevels=w),u.expand===1){const c=this.refreshChildren(u);return c.isSettled?this.expandChildren(u,w-1):c.p.then(()=>this.expandChildren(u,w-1))}else if(u.expand===3)return((S=u.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?u.initialExpand.p.then(()=>this.expandChildren(u,w-1)):this.expandChildren(u,w-1)}}dispose(){var E;for(const w of this.testItemToInternal.values())(E=w.discoverCts)===null||E===void 0||E.dispose(!0),(0,y.getPrivateApiFor)(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(E,w){const S=E==null?void 0:E.actual.id;switch(w[0]){case 2:this.pushDiff([4,S]);break;case 1:this.removeItem(E);break;case 0:this.addItem(w[1],E.src.controller,E);break;case 3:const[u,c,f]=w;switch(c){case"status":this.updateExpandability(E);break;case"range":this.pushDiff([1,{extId:S,item:{range:C.Range.from(f)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:C.MarkdownString.fromStrict(f)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[c]:f!=null?f:null}}]);break}break;default:(0,T.assertNever)(w[0])}}addItem(E,w,S){if(!(E instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${E.id} did not`);if(this.testItemToInternal.has(E))throw new Error(`Attempted to add a single TestItem ${E.id} multiple times to the tree`);if(this.testIdToInternal.object.has(E.id))throw new Error(`Attempted to insert a duplicate test item ID ${E.id}`);const u=S?S.item.extId:null,c=E.resolveHandler?1:0,f=S?S.expandLevels:1,t={controller:w,tree:this.testIdToInternal.object.id},n={actual:E,parent:u,item:C.TestItem.from(E),expandLevels:f?f-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(E,n),this.pushDiff([0,{parent:u,src:t,expand:c,item:n.item}]);const s=(0,y.getPrivateApiFor)(E);s.parent=S==null?void 0:S.actual,s.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const r of s.children.values())this.testItemToInternal.has(r)||this.addItem(r,w,n)}updateExpandability(E){var w;let S;E.actual.resolveHandler?E.actual.status===D.TestItemStatus.Pending?S=E.discoverCts?2:1:((w=E.initialExpand)===null||w===void 0||w.complete(),S=3):S=0,S!==E.expand&&(E.expand=S,this.pushDiff([1,{extId:E.actual.id,expand:S}]),S===1&&E.expandLevels!==void 0&&this.refreshChildren(E))}expandChildren(E,w){if(!(w<0)){const S=[...E.actual.children.values()].map(u=>this.expand(u.id,w)).filter(L.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(E){if(E.discoverCts&&E.discoverCts.dispose(!0),!E.actual.resolveHandler){const w=new L.DeferredPromise;return w.complete(),w}return E.expand=2,E.discoverCts=new I.CancellationTokenSource,this.pushExpandStateUpdate(E),E.initialExpand=new L.DeferredPromise,E.actual.resolveHandler(E.discoverCts.token),E.initialExpand}pushExpandStateUpdate(E){this.pushDiff([1,{extId:E.actual.id,expand:E.expand}])}removeItem(E){var w;this.pushDiff([2,E.actual.id]);const S=[E];for(;S.length;){const u=S.pop();if(!!u){(w=u.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(u.item.extId),this.testItemToInternal.delete(u.actual);for(const c of u.actual.children.values())S.push(this.testIdToInternal.object.get(c.id))}}}flushDiff(){const E=this.collectDiff();E.length&&this.publishDiff(E)}}e.SingleUseTestCollection=o}),define(me[216],ge([0,1,26,3,9]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class y{constructor(i){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(b.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(b.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let P of i.activationEvents)P==="onUri"&&(P=`onUri:${b.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(i)}}keepOnly(i){const P=new Set;i.forEach(h=>P.add(b.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>P.has(b.ExtensionIdentifier.toKey(h.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,P){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const h=y._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(h.map(p=>p.identifier)),P.length>0){const p=new Set;P.forEach(o=>p.add(b.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!p.has(b.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(h)}static _findLoopingExtensions(i){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,w){this.addNode(E),this.addNode(w),this._arcs.has(E)?this._arcs.get(E).push(w):this._arcs.set(E,[w])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,w){const S=P.getArcs(E);for(let u=0;u<S.length;u++)if(!w.has(S[u]))return!1;return!0}getNodes(){return this._nodesArr}};let h=new Map;for(let E of i){const w=b.ExtensionIdentifier.toKey(E.identifier);if(h.set(w,E),E.extensionDependencies)for(let S of E.extensionDependencies){const u=b.ExtensionIdentifier.toKey(S);P.addArc(w,u)}}let p=new Set;P.getNodes().filter(E=>P.getArcs(E).length===0).forEach(E=>p.add(E));let o=P.getNodes().filter(E=>!p.has(E)),d;do{d=!1;for(let E=0;E<o.length;E++){const w=o[E];P.hasOnlyGoodArcs(w,p)&&(o.splice(E,1),E--,p.add(w),d=!0)}}while(d);return o.map(E=>h.get(E))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(b.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const P=this._activationMap.get(i);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const P=this._extensionsMap.get(b.ExtensionIdentifier.toKey(i));return P||void 0}}e.ExtensionDescriptionRegistry=y;var C;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(C||(C={}));function D(k,i){const P=k.isBuiltin?0:k.isUnderDevelopment?2:1,h=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(P!==h)return P-h;const p=I.posix.basename(k.extensionLocation.path),o=I.posix.basename(i.extensionLocation.path);return p<o?-1:p>o?1:0}}),define(me[217],ge([0,1,23]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function T(C){const D=b.VSBuffer.alloc(1);switch(C){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=T;function y(C,D){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(me[40],ge([0,1,3,2,4,26,181]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");class C{constructor(S){this.dependency=S}}e.MissingExtensionDependency=C;var D;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(S,u,c,f){this.codeLoadingTime=S,this.activateCallTime=u,this.activateResolvedTime=c,this.activationReason=f}}e.ActivationTimes=k;class i{constructor(S,u){this.description=S,this.value=u}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var P;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function h(w){w.enableProposedApi||p(w)}e.checkProposedApiEnabled=h;function p(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=p;function o(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=o;function d(w){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=d;class E{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,u){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,u,c,f,t){}_onDidActivateExtensionError(S,u){}_onExtensionRuntimeError(S,u){}_onExtensionHostExit(S){}}e.NullExtensionService=E}),define(me[218],ge([0,1,26,40,14]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class y{constructor(o,d,E,w){this.startup=o,this.codeLoadingTime=d,this.activateCallTime=E,this.activateResolvedTime=w}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class C{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,d){return o===-1||d===-1?-1:d-o}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class D{constructor(o,d,E,w,S,u){this.activationFailed=o,this.activationFailedError=d,this.activationTimes=E,this.module=w,this.exports=S,this.subscriptions=u}}e.ActivatedExtension=D;class k extends D{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class i extends D{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class P extends D{constructor(o){super(!0,o,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let h=class{constructor(o,d,E,w,S){this._logService=S,this._registry=o,this._resolvedExtensionsSet=new Set,d.forEach(u=>this._resolvedExtensionsSet.add(b.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,E.forEach(u=>this._hostExtensionsMap.set(b.ExtensionIdentifier.toKey(u),u)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(o){const d=b.ExtensionIdentifier.toKey(o);return this._activatedExtensions.has(d)}getActivatedExtension(o){const d=b.ExtensionIdentifier.toKey(o),E=this._activatedExtensions.get(d);if(!E)throw new Error("Extension `"+o.value+"` is not known or not activated");return E}activateByEvent(o,d){if(this._alreadyActivatedEvents[o])return T;const E=this._registry.getExtensionDescriptionsForActivationEvent(o);return this._activateExtensions(E.map(w=>({id:w.identifier,reason:{startup:d,extensionId:w.identifier,activationEvent:o}}))).then(()=>{this._alreadyActivatedEvents[o]=!0})}activateById(o,d){const E=this._registry.getExtensionDescription(o);if(!E)throw new Error("Extension `"+o+"` is not known");return this._activateExtensions([{id:E.identifier,reason:d}])}_handleActivateRequest(o,d,E){if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(o.id))){d[b.ExtensionIdentifier.toKey(o.id)]=o;return}const w=this._registry.getExtensionDescription(o.id);if(!w){const c=new Error(`Cannot activate unknown extension '${o.id.value}'`);this._host.onExtensionActivationError(o.id,c,new L.MissingExtensionDependency(o.id.value)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(o.id),new P(c));return}const S=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let u=!0;for(let c=0,f=S.length;c<f;c++){const t=S[c];if(!this._resolvedExtensionsSet.has(b.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(b.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const g=w.displayName||w.identifier.value,m=this._registry.getExtensionDescription(t),_=m&&m.displayName||t,l=new Error(`Cannot activate the '${g}' extension because its dependency '${_}' failed to activate`);l.detail=n.activationFailedError,this._host.onExtensionActivationError(w.identifier,l,null),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(w.identifier),new P(l));return}if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(t))){u=!1,d[b.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(b.ExtensionIdentifier.toKey(t)),reason:o.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){u=!1,d[b.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:o.reason};continue}const r=w.displayName||w.identifier.value,a=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,a,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(w.identifier),new P(a));return}}}u?d[b.ExtensionIdentifier.toKey(w.identifier)]=o:E.push(o)}_activateExtensions(o){if(o.length===0||(o=o.filter(S=>!this._activatedExtensions.has(b.ExtensionIdentifier.toKey(S.id))),o.length===0))return Promise.resolve(void 0);const d=Object.create(null),E=[];for(let S=0,u=o.length;S<u;S++)this._handleActivateRequest(o[S],d,E);for(let S=0,u=E.length;S<u;S++){const c=b.ExtensionIdentifier.toKey(E[S].id);d[c]&&delete d[c]}const w=Object.keys(d).map(S=>d[S]);return E.length===0?Promise.all(w.map(S=>this._activateExtension(S.id,S.reason))).then(S=>{}):this._activateExtensions(w).then(S=>this._activateExtensions(E))}_activateExtension(o,d){const E=b.ExtensionIdentifier.toKey(o);if(this._activatedExtensions.has(E))return Promise.resolve(void 0);const w=this._activatingExtensions.get(E);if(w)return w;const S=this._host.actualActivateExtension(o,d).then(void 0,u=>{const c=new Error;return u&&u.name&&(c.name=u.name),u&&u.message?c.message=`Activating extension '${o.value}' failed: ${u.message}.`:c.message=`Activating extension '${o.value}' failed: ${u}.`,u&&u.stack&&(c.stack=u.stack),this._host.onExtensionActivationError(o,c,null),this._logService.error(`Activating extension ${o.value} failed due to an error:`),this._logService.error(u),new P(u)}).then(u=>{this._activatedExtensions.set(E,u),this._activatingExtensions.delete(E)});return this._activatingExtensions.set(E,S),S}};h=qe([We(4,I.ILogService)],h),e.ExtensionsActivator=h}),define(me[219],ge([0,1,14,40,27,12,113]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends b.LogService{constructor(k){if(k.logFile.scheme!==T.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(L.ExtensionHostLogFileName,k.logFile.fsPath,!0,k.logLevel))}$setLevel(k){this.setLevel(k)}};C=qe([We(0,I.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(me[220],ge([0,1,17]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,y)=>{this._actualOk=T,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,b.onUnexpectedError)(T))}then(T,y){return this._ensureActual().then(T,y)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=L}),define(me[125],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(D,k){this.isMain=D,this.sid=k,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const L=[];function I(C){const D=new b(!0,C);return L[D.nid]=D,D}e.createMainContextProxyIdentifier=I;function T(C){const D=new b(!1,C);return L[D.nid]=D,D}e.createExtHostContextProxyIdentifier=T;function y(C){return L[C].sid}e.getStringIdentifierForProxy=y}),define(me[5],ge([0,1,59,2,125]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var h;(function(u){u.name="$ident";function c(t,n){return Object.defineProperty(t,u.name,{value:n,enumerable:!0}),t}u.mixin=c;function f(t){return t[u.name]}u.of=f})(h=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(c){return c._id=p._n++,c}}e.IdObject=p,p._n=0;var o;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var d;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(d=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(E=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(u){if(u&&u.edits)for(const c of u.edits)typeof c.resource=="object"?c.resource=L.URI.revive(c.resource):(c.newUri=L.URI.revive(c.newUri),c.oldUri=L.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,b.revive)(c.metadata));return u}e.reviveWorkspaceEditDto=w;var S;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[89],ge([0,1,5,3,4]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(C){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(b.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,D){return this._proxy.$getPassword(C,D)}store(C,D,k){return this._proxy.$setPassword(C,D,k)}delete(C,D){return this._proxy.$deletePassword(C,D)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(me[65],ge([0,1,4,14,5,15]),function(G,e,b,L,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,b.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(I.MainContext.MainThreadTelemetry)}report(D,k,i){const P=this.getUsageKey(D,k);this._reportedUsages.has(P)||(this._reportedUsages.add(P),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:D}))}getUsageKey(D,k){return`${D}-${k.identifier.value}`}};y=qe([We(0,T.IExtHostRpcService),We(1,L.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(C,D,k){}})}),define(me[221],ge([0,1,3,5,7,26]),function(G,e,b,L,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new b.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new b.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,k,i,P={}){const h=T.ExtensionIdentifier.toKey(D.identifier),p=this._inFlightRequests.get(h)||[],o=i.sort().join(" ");let d=p.find(E=>E.scopes===o);if(d)return d.result;{const E=this._getSession(D,h,k,i,P);d={scopes:o,result:E},p.push(d),this._inFlightRequests.set(h,p);try{await E}finally{const w=p.findIndex(S=>S.scopes===o);w>-1&&(p.splice(w),this._inFlightRequests.set(h,p))}return E}}async _getSession(D,k,i,P,h={}){await this._proxy.$ensureProvider(i);const p=D.displayName||D.name;return this._proxy.$getSession(i,P,k,p,h)}async removeSession(D,k){const i=this._authenticationProviders.get(D);return i?i.provider.removeSession(k):this._proxy.$removeSession(D,k)}registerAuthenticationProvider(D,k,i,P){var h;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:k,provider:i,options:P!=null?P:{supportsMultipleAccounts:!1}}),this._providers.find(o=>o.id===D)||this._providers.push({id:D,label:k});const p=i.onDidChangeSessions(o=>{var d,E,w;this._proxy.$sendDidChangeSessions(D,{added:(d=o.added)!==null&&d!==void 0?d:[],changed:(E=o.changed)!==null&&E!==void 0?E:[],removed:(w=o.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(D,k,(h=P==null?void 0:P.supportsMultipleAccounts)!==null&&h!==void 0?h:!1),new I.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(D);const o=this._providers.findIndex(d=>d.id===D);o>-1&&this._providers.splice(o),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,k){return this._onDidChangeSessions.fire({provider:{id:D,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,k){return D.forEach(i=>{this._providers.some(P=>P.id===i.id)||this._providers.push(i)}),k.forEach(i=>{const P=this._providers.findIndex(h=>h.id===i.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(me[222],ge([0,1,5,15,20]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(C,D){this._extHostDocumentsAndEditors=D,this._proxy=C.getProxy(b.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const D=I.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};T=qe([We(0,L.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(me[223],ge([0,1,5]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(T){const y=T.getProxy(b.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(C){return y.$writeText(C)}})}}e.ExtHostClipboard=L}),define(me[50],ge([0,1,11,7,20,24,5,16,14,59,43,47,2,6,4,15]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new w(this,s=>{const r=this._apiCommands.get(s);return(r==null?void 0:r.result)===u.Void?r:void 0},n),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,T.cloneAndChange)(s,function(r){if(i.Range.isIRange(r))return I.Range.to(r);if(P.Position.isIPosition(r))return I.Position.to(r);if(i.Range.isIRange(r.range)&&h.URI.isUri(r.uri))return I.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const r=t.args.map((g,m)=>{if(!g.validate(s[m]))throw new Error(`Invalid argument '${g.name}' when running '${t.id}', received: ${s[m]}`);return g.convert(s[m])}),a=await this.executeCommand(t.internalId,...r);return t.result.convert(a,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new L.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,r,a){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:r,description:a}),t&&this._proxy.$registerCommand(n),new L.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=(0,T.cloneAndChange)(n,function(a){if(a instanceof L.Position)return I.Position.from(a);if(a instanceof L.Range)return I.Range.from(a);if(a instanceof L.Location)return I.location.from(a);if(L.NotebookRange.isNotebookRange(a))return I.NotebookRange.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,r,s);return(0,k.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw a}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:r,thisArg:a,description:g}=s;if(g)for(let m=0;m<g.args.length;m++)try{(0,b.validateConstraint)(n[m],g.args[m].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${g.args[m].name}' - ${g.args[m].description}`)}try{return await r.apply(a,n)}catch(m){if(t===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...n);_&&(t=_.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((r,a)=>a.processArgument(r),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:r}=s;r&&(t[n]=r)}return Promise.resolve(t)}};E=qe([We(0,d.IExtHostRpcService),We(1,D.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class w{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const r=this._lookupApiCommand(t.command);if(r)s.id=r.internalId,s.arguments=r.args.map((a,g)=>a.convert(t.arguments&&t.arguments[g]));else if((0,C.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),n.add((0,p.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),s.$ident=a,s.id=this.delegatingCommandId,s.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return s}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class S{constructor(t,n,s,r){this.name=t,this.description=n,this.validate=s,this.convert=r}optional(){return new S(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new S(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",f=>h.URI.isUri(f),f=>f),S.Position=new S("position","A position in a text document",f=>L.Position.isPosition(f),I.Position.from),S.Range=new S("range","A range in a text document",f=>L.Range.isRange(f),I.Range.from),S.Selection=new S("selection","A selection in a text document",f=>L.Selection.isSelection(f),I.Selection.from),S.Number=new S("number","",f=>typeof f=="number",f=>f),S.String=new S("string","",f=>typeof f=="string",f=>f),S.CallHierarchyItem=new S("item","A call hierarchy item",f=>f instanceof L.CallHierarchyItem,I.CallHierarchyItem.to);class u{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=u,u.Void=new u("no result",f=>f);class c{constructor(t,n,s,r,a){this.id=t,this.internalId=n,this.description=s,this.args=r,this.result=a}}e.ApiCommand=c}),define(me[224],ge([0,1,6,20,7,80,50,200,16,109]),function(G,e,b,L,I,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",h(L.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,d)=>{if(!(0,D.isFalsyOrEmpty)(o)){class E extends I.SymbolInformation{static to(S){const u=new E(S.name,L.SymbolKind.to(S.kind),S.containerName||"",new I.Location(d[0],L.Range.to(S.range)));return u.detail=S.detail,u.range=u.location.range,u.selectionRange=L.Range.to(S.selectionRange),u.children=S.children?S.children.map(E.to):[],u}}return o.map(E.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(L.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(L.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(L.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",p)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",h(L.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",h(L.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(d=>I.Position.isPosition(d)),o=>o.map(L.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(d=>{let E;for(const w of d.reverse())E=new I.SelectionRange(L.Range.to(w),E);return E}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>{const d=[];if(Array.isArray(o))for(let E of o)d.push(...E[1].map(L.WorkspaceSymbol.to));return d})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(L.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(L.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(L.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return L.WorkspaceEdit.to(o)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(L.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new I.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!!o){const d=(0,k.decodeSemanticTokensDto)(o);if(d.type==="full")return new I.SemanticTokens(d.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new I.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!!o){const d=(0,k.decodeSemanticTokensDto)(o);if(d.type==="full")return new I.SemanticTokens(d.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,d,E)=>{if(!o)return new I.CompletionList([]);const w=o.suggestions.map(S=>L.CompletionItem.to(S,E));return new I.CompletionList(w,o.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return L.SignatureHelp.to(o)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,d,E)=>h(w=>new I.CodeLens(L.Range.to(w.range),w.command&&E.fromInternal(w.command)))(o))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>I.Range.isRange(o),o=>I.Selection.isSelection(o)?L.Selection.from(o):L.Range.from(o)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,d,E)=>h(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return E.fromInternal(w.command)}else{const S=new I.CodeAction(w.title,w.kind?new I.CodeActionKind(w.kind):void 0);return w.edit&&(S.edit=L.WorkspaceEdit.to(w.edit)),w.command&&(S.command=E.fromInternal(w.command)),S.isPreferred=w.isPreferred,S}})(o))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(d=>new I.ColorInformation(L.Range.to(d.range),L.Color.to(d.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",o=>o instanceof I.Color,L.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:L.Range.from(o.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(L.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",o=>o.map(L.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",h(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(d=>L.NotebookExclusiveDocumentPattern.to(d))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(L.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[L.ViewColumn.from(o.viewColumn),L.TextEditorOpenOptions.from(o)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[L.ViewColumn.from(o.viewColumn),L.TextEditorOpenOptions.from(o)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[L.ViewColumn.from(o.viewColumn),L.TextEditorOpenOptions.from(o)]).optional()],y.ApiCommandResult.Void)];class P{constructor(d){this._disposables=new b.DisposableStore,this._commands=d}static register(d){return i.forEach(d.registerApiCommand,d),new P(d).registerCommands()}registerCommands(){const d=E=>(...w)=>E(this._commands,...w);this._register(C.RemoveFromRecentlyOpenedAPICommand.ID,d(C.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:E=>typeof E=="string"}]})}_register(d,E,w){const S=this._commands.registerCommand(!1,d,E,this,w);this._disposables.add(S)}}e.ExtHostApiCommands=P;function h(o){return d=>{if(Array.isArray(d))return d.map(o)}}function p(o){if(!!Array.isArray(o)){const d=[];for(const E of o)T.isLocationLink(E)?d.push(L.DefinitionLink.to(E)):d.push(L.location.to(E));return d}}}),define(me[225],ge([0,1,13,54,3,6,2,80,26,20,7,5]),function(G,e,b,L,I,T,y,C,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class h{constructor(c,f,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(P.MainContext.MainThreadComments),f.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let a=n.commentUniqueId,g=r.getCommentByUniqueId(a);return g||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let a=n.text,g=n.commentUniqueId,m=r.getCommentByUniqueId(g);return m?(m.body=a,m):n}return n}})}createCommentController(c,f,t){const n=h.handlePool++,s=new o(c,n,this._proxy,f,t);this._commentControllers.set(s.handle,s);const r=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(c.identifier))||[];return r.push(s),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(c.identifier),r),s}$createCommentThreadTemplate(c,f,t){const n=this._commentControllers.get(c);!n||n.$createCommentThreadTemplate(f,t)}async $updateCommentThreadTemplate(c,f,t){const n=this._commentControllers.get(c);!n||n.$updateCommentThreadTemplate(f,t)}$deleteCommentThread(c,f){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(f)}$provideCommentingRanges(c,f,t){const n=this._commentControllers.get(c);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(y.URI.revive(f));return(0,b.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(r=>r?r.map(a=>k.Range.from(a)):void 0)}$toggleReaction(c,f,t,n,s){const r=this._commentControllers.get(c);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,b.asPromise)(()=>{const a=r.getCommentThread(f);if(a){const g=a.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&g&&r.reactionHandler)return r.reactionHandler(g,w(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=h,h.handlePool=0;class p{constructor(c,f,t,n,s,r,a){this._proxy=c,this._commentController=f,this._id=t,this._uri=n,this._range=s,this._comments=r,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${f.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),f={};c("range")&&(f.range=k.Range.from(this._range)),c("label")&&(f.label=this.label),c("contextValue")&&(f.contextValue=this.contextValue),c("comments")&&(f.comments=this._comments.map(t=>d(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(f.collapseState=S(this._collapseState)),c("canReply")&&(f.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,f)}}getCommentByUniqueId(c){for(let f of this._commentsMap){let t=f[0],n=f[1];if(c===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}p._handlePool=0,qe([(0,L.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=p;class o{constructor(c,f,t,n,s){this._extension=c,this._handle=f,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,f,t,n){if(typeof c=="string"){const s=new p(this._proxy,this,c,f,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new p(this._proxy,this,void 0,c,f,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(c,f){const t=new p(this._proxy,this,void 0,y.URI.revive(c),k.Range.to(f),[],this._extension.identifier);return t.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,f){let t=this._threads.get(c);t&&(t.range=k.Range.to(f))}$deleteCommentThread(c){let f=this._threads.get(c);f&&f.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function d(u,c,f,t){let n=t.get(f);n||(n=++u.commentHandle,t.set(f,n));const s=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(f.body),userName:f.author.name,userIconPath:s,label:f.label,commentReactions:f.reactions?f.reactions.map(r=>E(r)):void 0}}function E(u){return{label:u.label,iconPath:u.iconPath?k.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function w(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?y.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function S(u){if(u!==void 0)switch(u){case i.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}}),define(me[126],ge([0,1,2,5,7,4,15,14,16,8,9]),function(G,e,b,L,I,T,y,C,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class vn{constructor(p,o){this._logService=o,this._provider=new Map,this._proxy=p.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,o){const d=vn._handlePool++;this._provider.set(d,{provider:p,extensionId:o}),this._proxy.$registerDecorationProvider(d,o.value);const E=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(d,null);return}let S=(0,D.asArray)(w);if(S.length<=vn._maxEventSize){this._proxy.$onDidChange(d,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,S.length);const u=S.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),c=(0,D.groupBy)(u,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let f=[];e:for(let t of c){let n;for(let s of t){let r=(0,i.dirname)(s.uri.path);if(n!==r&&(n=r,f.push(s.uri)>=vn._maxEventSize))break e}}this._proxy.$onDidChange(d,f)});return new I.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(p,o,d){if(!this._provider.has(p))return Object.create(null);const E=Object.create(null),{provider:w,extensionId:S}=this._provider.get(p);return await Promise.all(o.map(async u=>{try{const{uri:c,id:f}=u,t=await Promise.resolve(w.provideFileDecoration(b.URI.revive(c),d));if(!t)return;try{I.FileDecoration.validate(t),E[f]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${S.value}': ${n}`)}}catch(c){this._logService.error(c)}})),E}};P._handlePool=0,P._maxEventSize=250,P=qe([We(0,y.IExtHostRpcService),We(1,C.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(me[226],ge([0,1,159,114,2,5,7,20,3,14,22]),function(G,e,b,L,I,T,y,C,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(o,d,E,w,S){this._name=o,this._owner=d,this._maxDiagnosticsPerFile=E,this._proxy=w,this._onDidChangeDiagnostics=S,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,d){if(!o){this.clear();return}this._checkDisposed();let E=[];if(I.URI.isUri(o)){if(!d){this.delete(o);return}this._data.set(o,d.slice()),E=[o]}else if(Array.isArray(o)){E=[];let S;o=[...o].sort(P._compareIndexedTuplesByUri);for(const u of o){const[c,f]=u;if((!S||c.toString()!==S.toString())&&(S&&this._data.get(S).length===0&&this._data.delete(S),S=c,E.push(c),this._data.set(c,[])),f){const t=this._data.get(c);t&&t.push(...f)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!!this._proxy){const w=[];for(let S of E){let u=[];const c=this._data.get(S);if(c)if(c.length>this._maxDiagnosticsPerFile){u=[];const f=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of c)if(n.severity===f[t]&&u.push(C.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;u.push({severity:L.MarkerSeverity.Info,message:(0,b.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=c.map(f=>C.Diagnostic.from(f));w.push([S,u])}this._proxy.$changeMany(this._owner,w)}}delete(o){this._checkDisposed(),this._onDidChangeDiagnostics.fire([o]),this._data.delete(o),this._proxy&&this._proxy.$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(o,d){this._checkDisposed();for(let E of this._data.keys())o.apply(d,[E,this.get(E),this])}get(o){this._checkDisposed();const d=this._data.get(o);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(this._data.get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,d){return o[0].toString()<d[0].toString()?-1:o[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=P;let h=class Vt{constructor(o,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,Vt._debouncer,50),Vt._mapper),this._proxy=o.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(o,d){return o?o.concat(d):d}static _mapper(o){const d=new i.ResourceMap;for(const E of o)d.set(E,E);return{uris:Object.freeze(Array.from(d.values()))}}createDiagnosticCollection(o,d){const{_collections:E,_proxy:w,_onDidChangeDiagnostics:S,_logService:u}=this,c=new class{$changeMany(n,s){w.$changeMany(n,s),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,n,s.length===0?"CLEARING":s)}$clear(n){w.$clear(n),u.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,n)}dispose(){w.dispose()}};let f;if(!d)d="_generated_diagnostic_collection_name_#"+Vt._idPool++,f=d;else if(!E.has(d))f=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do f=d+Vt._idPool++;while(E.has(f))}return new class extends P{constructor(){super(d,f,Vt._maxDiagnosticsPerFile,c,S);E.set(f,this)}dispose(){super.dispose(),E.delete(f)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const d=new Map,E=[];for(const w of this._collections.values())w.forEach((S,u)=>{let c=d.get(S.toString());typeof c=="undefined"&&(c=E.length,d.set(S.toString(),c),E.push([S,[]])),E[c][1]=E[c][1].concat(...u)});return E}}_getDiagnostics(o){let d=[];for(let E of this._collections.values())E.has(o)&&(d=d.concat(E.get(o)));return d}$acceptMarkersChange(o){if(!this._mirrorCollection){const d="_generated_mirror",E=new P(d,d,Vt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,E),this._mirrorCollection=E}for(const[d,E]of o)this._mirrorCollection.set(I.URI.revive(d),E.map(C.Diagnostic.to))}};h._idPool=0,h._maxDiagnosticsPerFile=1e3,h=qe([We(1,k.ILogService)],h),e.ExtHostDiagnostics=h}),define(me[227],ge([0,1,2,5]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(y){this._proxy=y.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(C=>C?C.map(D=>b.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(C=>C?b.URI.revive(C):void 0)}}e.ExtHostDialogs=I}),define(me[228],ge([0,1,17,2,7,5,12,21,8]),function(G,e,b,L,I,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(P,h,p){this._documentsAndEditors=h,this._logService=p,this._documentContentProviders=new Map,this._proxy=P.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,h){if(Object.keys(y.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const p=k._handlePool++;this._documentContentProviders.set(p,h),this._proxy.$registerTextContentProvider(p,P);let o;return typeof h.onDidChange=="function"&&(o=h.onDidChange(d=>{if(d.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(p,d).then(E=>{if(!(!E&&typeof E!="string")){const w=this._documentsAndEditors.getDocument(d);if(!!w){const S=(0,D.splitLines)(E);if(!w.equalLines(S))return this._proxy.$onVirtualDocumentChange(d,E)}}},b.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(P,h){const p=this._documentContentProviders.get(P);return p?Promise.resolve(p.provideTextDocumentContent(L.URI.revive(h),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(me[229],ge([0,1,3,6,2,5,120,20,11,24]),function(G,e,b,L,I,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(h,p){this._onDidAddDocument=new b.Emitter,this._onDidRemoveDocument=new b.Emitter,this._onDidChangeDocument=new b.Emitter,this._onDidSaveDocument=new b.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(o=>{for(const d of o)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(o=>{for(const d of o)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!!h){const p=this._documentsAndEditors.getDocument(h);if(p)return p}}getDocument(h){const p=this.getDocumentData(h);if(!(p==null?void 0:p.document))throw new Error(`Unable to retrieve document from URI '${h}'`);return p.document}ensureDocumentData(h){const p=this._documentsAndEditors.getDocument(h);if(p)return Promise.resolve(p);let o=this._documentLoader.get(h.toString());return o||(o=this._proxy.$tryOpenDocument(h).then(d=>{this._documentLoader.delete(h.toString());const E=I.URI.revive(d);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(E))},d=>(this._documentLoader.delete(h.toString()),Promise.reject(d))),this._documentLoader.set(h.toString(),o)),o}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(p=>I.URI.revive(p))}$acceptModelModeChanged(h,p){const o=I.URI.revive(h),d=this._documentsAndEditors.getDocument(o);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(p),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(h){const p=I.URI.revive(h),o=this._documentsAndEditors.getDocument(p);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(o.document)}$acceptDirtyStateChanged(h,p){const o=I.URI.revive(h),d=this._documentsAndEditors.getDocument(o);if(!d)throw new Error("unknown document");d._acceptIsDirty(p),this._onDidChangeDocument.fire({document:d.document,contentChanges:[]})}$acceptModelChanged(h,p,o){const d=I.URI.revive(h),E=this._documentsAndEditors.getDocument(d);if(!E)throw new Error("unknown document");E._acceptIsDirty(o),E.onEvents(p),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:E.document,contentChanges:p.changes.map(w=>({range:C.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(h,p){(0,y.setWordDefinitionFor)(h,p)}}e.ExtHostDocuments=i}),define(me[41],ge([0,1,52,3,6,2,4,5,120,15,124,20,14,22,12,55,134]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(c,f){this._extHostRpc=c,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const f=[],t=[],n=[];if(c.removedDocuments)for(const s of c.removedDocuments){const r=T.URI.revive(s),a=this._documents.get(r);(a==null?void 0:a.unref())&&(this._documents.delete(r),f.push(a.value))}if(c.addedDocuments)for(const s of c.addedDocuments){const r=T.URI.revive(s.uri);let a=this._documents.get(r);if(a&&r.scheme!==o.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);a||(a=new w(new D.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),r,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(r,a),t.push(a.value)),a.ref()}if(c.removedEditors)for(const s of c.removedEditors){const r=this._editors.get(s);this._editors.delete(s),r&&n.push(r)}if(c.addedEditors)for(const s of c.addedEditors){const r=T.URI.revive(s.documentUri);b.ok(this._documents.has(r),`document '${r}' does not exist`),b.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const a=this._documents.get(r).value,g=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>a.document),s.selections.map(P.Selection.to),s.options,s.visibleRanges.map(m=>P.Range.to(m)),typeof s.editorPosition=="number"?P.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,g)}c.newActiveEditor!==void 0&&(b.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,I.dispose)(f),(0,I.dispose)(n),c.removedDocuments&&this._onDidRemoveDocuments.fire(f),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var f;return(f=this._documents.get(c))===null||f===void 0?void 0:f.value}allDocuments(){return d.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const f=this._editors.get(this._activeEditorId);return c?f:f==null?void 0:f.value}}allEditors(){return[...this._editors.values()]}};S=qe([We(0,k.IExtHostRpcService),We(1,h.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[230],ge([0,1,2,5,6,7,20,142,8,23]),function(G,e,b,L,I,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const o=this._schemes.indexOf(p);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),o=[];let d,E,w=14,S=14;for(const u of p){let c=d?(0,D.commonPrefixLength)(d,u):0;for(c===0?E=1:E=S;c<u.length;c++)c+1===u.length?(w=S,S=9):S+=1,o.push([E,u.toUpperCase().charCodeAt(c),S]),o.push([E,u.toLowerCase().charCodeAt(c),S]),E=S;d=u,S=w}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new C.StateMachine(o)}}provideDocumentLinks(p){this._initStateMachine();const o=[],d=C.LinkComputer.computeLinks({getLineContent(E){return p.lineAt(E-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const E of d){const w=y.DocumentLink.to(E);w.target&&o.push(w)}return o}}class P{constructor(p,o){this._extHostLanguageFeatures=o,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=p.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){var p;(p=this._linkProviderRegistration)===null||p===void 0||p.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(p,o,d,E={},w){if(this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const S=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(S,d),this._enableProposedApi.set(S,w!=null?w:!1);let u=2;E.isCaseSensitive&&(u+=1024),E.isReadonly&&(u+=2048),typeof d.copy=="function"&&(u+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(S,o,u).catch(f=>{console.error(`FAILED to register filesystem provider of ${p.value}-extension for the scheme ${o}`),console.error(f)});const c=d.onDidChangeFile(f=>{const t=[];for(const n of f){let{uri:s,type:r}=n;if(s.scheme===o){let a;switch(r){case T.FileChangeType.Changed:a=0;break;case T.FileChangeType.Created:a=1;break;case T.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:a})}}this._proxy.$onFileSystemChange(S,t)});return(0,I.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(S),this._enableProposedApi.delete(S),this._proxy.$unregisterProvider(S)})}static _asIStat(p,o){const{type:d,ctime:E,mtime:w,size:S,permissions:u}=p;return o?{type:d,ctime:E,mtime:w,size:S,permissions:u}:{type:d,ctime:E,mtime:w,size:S}}$stat(p,o){return Promise.resolve(this._getFsProvider(p).stat(b.URI.revive(o))).then(d=>{var E;return P._asIStat(d,(E=this._enableProposedApi.get(p))!==null&&E!==void 0?E:!1)})}$readdir(p,o){return Promise.resolve(this._getFsProvider(p).readDirectory(b.URI.revive(o)))}$readFile(p,o){return Promise.resolve(this._getFsProvider(p).readFile(b.URI.revive(o))).then(d=>k.VSBuffer.wrap(d))}$writeFile(p,o,d,E){return Promise.resolve(this._getFsProvider(p).writeFile(b.URI.revive(o),d.buffer,E))}$delete(p,o,d){return Promise.resolve(this._getFsProvider(p).delete(b.URI.revive(o),d))}$rename(p,o,d,E){return Promise.resolve(this._getFsProvider(p).rename(b.URI.revive(o),b.URI.revive(d),E))}$copy(p,o,d,E){const w=this._getFsProvider(p);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(b.URI.revive(o),b.URI.revive(d),E))}$mkdir(p,o){return Promise.resolve(this._getFsProvider(p).createDirectory(b.URI.revive(o)))}$watch(p,o,d,E){const w=this._getFsProvider(p).watch(b.URI.revive(d),E);this._watches.set(o,w)}$unwatch(p,o){const d=this._watches.get(o);d&&(d.dispose(),this._watches.delete(o))}$open(p,o,d){const E=this._getFsProvider(p);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(b.URI.revive(o),d))}$close(p,o){const d=this._getFsProvider(p);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(o))}$read(p,o,d,E){const w=this._getFsProvider(p);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const S=k.VSBuffer.alloc(E);return Promise.resolve(w.read(o,d,S.buffer,0,E)).then(u=>S.slice(0,u))}$write(p,o,d,E){const w=this._getFsProvider(p);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(o,d,E.buffer,0,E.byteLength))}_getFsProvider(p){const o=this._fsProvider.get(p);if(!o){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return o}}e.ExtHostFileSystem=P}),define(me[90],ge([0,1,5,44,7,23,4,15,62]),function(G,e,b,L,I,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Nt{constructor(P,h){const p=P.getProxy(b.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(o){return p.$stat(o).catch(Nt._handleError)},readDirectory(o){return p.$readdir(o).catch(Nt._handleError)},createDirectory(o){return p.$mkdir(o).catch(Nt._handleError)},async readFile(o){return p.$readFile(o).then(d=>d.buffer).catch(Nt._handleError)},writeFile(o,d){return p.$writeFile(o,T.VSBuffer.wrap(d)).catch(Nt._handleError)},delete(o,d){return p.$delete(o,Object.assign({recursive:!1,useTrash:!1},d)).catch(Nt._handleError)},rename(o,d,E){return p.$rename(o,d,Object.assign({overwrite:!1},E)).catch(Nt._handleError)},copy(o,d,E){return p.$copy(o,d,Object.assign({overwrite:!1},E)).catch(Nt._handleError)},isWritableFileSystem(o){const d=h.getCapabilities(o);if(typeof d=="number")return!(d&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new I.FileSystemError(String(P));if(P.name==="ENOPRO")throw I.FileSystemError.Unavailable(P.message);switch(P.name){case L.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(P.message);case L.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(P.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(P.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(P.message);case L.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(P.message);case L.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(P.message);default:throw new I.FileSystemError(P.message,P.name)}}};k=qe([We(0,C.IExtHostRpcService),We(1,D.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(me[231],ge([0,1,6,5]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(y){this._handlePool=0,this._proxy=y.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,y),(0,b.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=I}),define(me[232],ge([0,1,2,24,20,7,13,5,8,43,16,11,139,6,109,73,86,45,17]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(j,Q){this._documents=j,this._provider=Q}provideDocumentSymbols(j,Q){const Z=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(Z,Q)).then(se=>{if(!(0,i.isFalsyOrEmpty)(se))return se[0]instanceof T.DocumentSymbol?se.map(I.DocumentSymbol.from):u._asDocumentSymbolTree(se)})}static _asDocumentSymbolTree(j){var Q;j=j.slice(0).sort((fe,_e)=>{let xe=fe.location.range.start.compareTo(_e.location.range.start);return xe===0&&(xe=_e.location.range.end.compareTo(fe.location.range.end)),xe});const Z=[],se=[];for(const fe of j){const _e={name:fe.name||"!!MISSING: name!!",kind:I.SymbolKind.from(fe.kind),tags:((Q=fe.tags)===null||Q===void 0?void 0:Q.map(I.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:I.Range.from(fe.location.range),selectionRange:I.Range.from(fe.location.range),children:[]};for(;;){if(se.length===0){se.push(_e),Z.push(_e);break}const xe=se[se.length-1];if(k.Range.containsRange(xe.range,_e.range)&&!k.Range.equalsRange(xe.range,_e.range)){xe.children&&xe.children.push(_e),se.push(_e);break}se.pop()}}return Z}}class c{constructor(j,Q,Z){this._documents=j,this._commands=Q,this._provider=Z,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,Q){const Z=this._documents.getDocument(j),se=await this._provider.provideCodeLenses(Z,Q);if(!(!se||Q.isCancellationRequested)){const fe=this._cache.add(se),_e=new p.DisposableStore;this._disposables.set(fe,_e);const xe={cacheId:fe,lenses:[]};for(let pe=0;pe<se.length;pe++)xe.lenses.push({cacheId:[fe,pe],range:I.Range.from(se[pe].range),command:this._commands.toInternal(se[pe].command,_e)});return xe}}async resolveCodeLens(j,Q){var Z;const se=j.cacheId&&this._cache.get(...j.cacheId);if(!!se){let fe;if(typeof this._provider.resolveCodeLens!="function"||se.isResolved?fe=se:fe=await this._provider.resolveCodeLens(se,Q),fe||(fe=se),!Q.isCancellationRequested){const _e=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!_e)return j.command=this._commands.toInternal((Z=fe.command)!==null&&Z!==void 0?Z:c._badCmd,_e),j}}}releaseCodeLenses(j){var Q;(Q=this._disposables.get(j))===null||Q===void 0||Q.dispose(),this._disposables.delete(j),this._cache.delete(j)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function f(Oe){return Array.isArray(Oe)?Oe.map(I.DefinitionLink.from):Oe?[I.DefinitionLink.from(Oe)]:[]}class t{constructor(j,Q){this._documents=j,this._provider=Q}provideDefinition(j,Q,Z){const se=this._documents.getDocument(j),fe=I.Position.to(Q);return(0,y.asPromise)(()=>this._provider.provideDefinition(se,fe,Z)).then(f)}}class n{constructor(j,Q){this._documents=j,this._provider=Q}provideDeclaration(j,Q,Z){const se=this._documents.getDocument(j),fe=I.Position.to(Q);return(0,y.asPromise)(()=>this._provider.provideDeclaration(se,fe,Z)).then(f)}}class s{constructor(j,Q){this._documents=j,this._provider=Q}provideImplementation(j,Q,Z){const se=this._documents.getDocument(j),fe=I.Position.to(Q);return(0,y.asPromise)(()=>this._provider.provideImplementation(se,fe,Z)).then(f)}}class r{constructor(j,Q){this._documents=j,this._provider=Q}provideTypeDefinition(j,Q,Z){const se=this._documents.getDocument(j),fe=I.Position.to(Q);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(se,fe,Z)).then(f)}}class a{constructor(j,Q){this._documents=j,this._provider=Q}provideHover(j,Q,Z){const se=this._documents.getDocument(j),fe=I.Position.to(Q);return(0,y.asPromise)(()=>this._provider.provideHover(se,fe,Z)).then(_e=>{if(!(!_e||(0,i.isFalsyOrEmpty)(_e.contents)))return _e.range||(_e.range=se.getWordRangeAtPosition(fe)),_e.range||(_e.range=new T.Range(fe,fe)),I.Hover.from(_e)})}}class g{constructor(j,Q){this._documents=j,this._provider=Q}provideEvaluatableExpression(j,Q,Z){const se=this._documents.getDocument(j),fe=I.Position.to(Q);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(se,fe,Z)).then(_e=>{if(_e)return I.EvaluatableExpression.from(_e)})}}class m{constructor(j,Q){this._documents=j,this._provider=Q}provideInlineValues(j,Q,Z,se){const fe=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideInlineValues(fe,I.Range.to(Q),I.InlineValueContext.to(Z),se)).then(_e=>{if(Array.isArray(_e))return _e.map(xe=>I.InlineValue.from(xe))})}}class _{constructor(j,Q){this._documents=j,this._provider=Q}provideDocumentHighlights(j,Q,Z){const se=this._documents.getDocument(j),fe=I.Position.to(Q);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(se,fe,Z)).then(_e=>{if(Array.isArray(_e))return _e.map(I.DocumentHighlight.from)})}}class l{constructor(j,Q){this._documents=j,this._provider=Q}provideLinkedEditingRanges(j,Q,Z){const se=this._documents.getDocument(j),fe=I.Position.to(Q);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(se,fe,Z)).then(_e=>{if(_e&&Array.isArray(_e.ranges))return{ranges:(0,i.coalesce)(_e.ranges.map(I.Range.from)),wordPattern:_e.wordPattern}})}}class v{constructor(j,Q){this._documents=j,this._provider=Q}provideReferences(j,Q,Z,se){const fe=this._documents.getDocument(j),_e=I.Position.to(Q);return(0,y.asPromise)(()=>this._provider.provideReferences(fe,_e,Z,se)).then(xe=>{if(Array.isArray(xe))return xe.map(I.location.from)})}}class R{constructor(j,Q,Z,se,fe,_e,xe){this._documents=j,this._commands=Q,this._diagnostics=Z,this._provider=se,this._logService=fe,this._extension=_e,this._apiDeprecation=xe,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(j,Q,Z,se){const fe=this._documents.getDocument(j),_e=h.Selection.isISelection(Q)?I.Selection.to(Q):I.Range.to(Q),xe=[];for(const ke of this._diagnostics.getDiagnostics(j))if(_e.intersection(ke.range)&&xe.push(ke)>R._maxCodeActionsPerFile)break;const pe={diagnostics:xe,only:Z.only?new T.CodeActionKind(Z.only):void 0,triggerKind:I.CodeActionTriggerKind.to(Z.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(fe,_e,pe,se)).then(ke=>{var Fe;if(!(!(0,i.isNonEmptyArray)(ke)||se.isCancellationRequested)){const He=this._cache.add(ke),be=new p.DisposableStore;this._disposables.set(He,be);const Ke=[];for(let K=0;K<ke.length;K++){const te=ke[K];!te||(R._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,be)})):(pe.only&&(te.kind?pe.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[He,K],title:te.title,command:te.command&&this._commands.toInternal(te.command,be),diagnostics:te.diagnostics&&te.diagnostics.map(I.Diagnostic.from),edit:te.edit&&I.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:(Fe=te.disabled)===null||Fe===void 0?void 0:Fe.reason})))}return{cacheId:He,actions:Ke}}})}async resolveCodeAction(j,Q){var Z;const[se,fe]=j,_e=this._cache.get(se,fe);if(!(!_e||R._isCommand(_e))&&!!this._provider.resolveCodeAction){const xe=(Z=await this._provider.resolveCodeAction(_e,Q))!==null&&Z!==void 0?Z:_e;return(xe==null?void 0:xe.edit)?I.WorkspaceEdit.from(xe.edit):void 0}}releaseCodeActions(j){var Q;(Q=this._disposables.get(j))===null||Q===void 0||Q.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}R._maxCodeActionsPerFile=1e3;class O{constructor(j,Q){this._documents=j,this._provider=Q}provideDocumentFormattingEdits(j,Q,Z){const se=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(se,Q,Z)).then(fe=>{if(Array.isArray(fe))return fe.map(I.TextEdit.from)})}}class H{constructor(j,Q){this._documents=j,this._provider=Q}provideDocumentRangeFormattingEdits(j,Q,Z,se){const fe=this._documents.getDocument(j),_e=I.Range.to(Q);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,_e,Z,se)).then(xe=>{if(Array.isArray(xe))return xe.map(I.TextEdit.from)})}}class ne{constructor(j,Q){this._documents=j,this._provider=Q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(j,Q,Z,se,fe){const _e=this._documents.getDocument(j),xe=I.Position.to(Q);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(_e,xe,Z,se,fe)).then(pe=>{if(Array.isArray(pe))return pe.map(I.TextEdit.from)})}}class ie{constructor(j,Q){this._provider=j,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(j,Q){const Z=C.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(j,Q)).then(se=>{if((0,i.isNonEmptyArray)(se)){for(const fe of se)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const _e=C.IdObject.mixin(I.WorkspaceSymbol.from(fe));this._symbolCache.set(_e._id,fe),Z.symbols.push(_e)}}}).then(()=>(Z.symbols.length>0&&this._resultCache.set(Z._id,[Z.symbols[0]._id,Z.symbols[Z.symbols.length-1]._id]),Z))}async resolveWorkspaceSymbol(j,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const Z=this._symbolCache.get(j._id);if(Z){const se=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(Z,Q));return se&&(0,L.mixin)(j,I.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(j){const Q=this._resultCache.get(j);if(Q){for(let[Z,se]=Q;Z<=se;Z++)this._symbolCache.delete(Z);this._resultCache.delete(j)}}}class N{constructor(j,Q,Z){this._documents=j,this._provider=Q,this._logService=Z}static supportsResolving(j){return typeof j.prepareRename=="function"}provideRenameEdits(j,Q,Z,se){const fe=this._documents.getDocument(j),_e=I.Position.to(Q);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(fe,_e,Z,se)).then(xe=>{if(!!xe)return I.WorkspaceEdit.from(xe)},xe=>{const pe=N._asMessage(xe);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(xe)})}resolveRenameLocation(j,Q,Z){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(j),fe=I.Position.to(Q);return(0,y.asPromise)(()=>this._provider.prepareRename(se,fe,Z)).then(_e=>{let xe,pe;if(T.Range.isRange(_e)?(xe=_e,pe=se.getText(_e)):(0,P.isObject)(_e)&&(xe=_e.range,pe=_e.placeholder),!!xe){if(xe.start.line>fe.line||xe.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(xe),text:pe}}},_e=>{const xe=N._asMessage(_e);return xe?{rejectReason:xe,range:void 0,text:void 0}:Promise.reject(_e)})}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class B{constructor(j,Q){this.resultId=j,this.tokens=Q}}class U{constructor(j,Q){this._documents=j,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(j,Q,Z){const se=this._documents.getDocument(j),fe=Q!==0?this._previousResults.get(Q):null;return(0,y.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(se,fe.resultId,Z):this._provider.provideDocumentSemanticTokens(se,Z)).then(_e=>(fe&&this._previousResults.delete(Q),_e?(_e=U._fixProvidedSemanticTokens(_e),this._send(U._convertToEdits(fe,_e),_e)):null))}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return U._isSemanticTokens(j)?U._isCorrectSemanticTokens(j)?j:new T.SemanticTokens(new Uint32Array(j.data),j.resultId):U._isSemanticTokensEdits(j)?U._isCorrectSemanticTokensEdits(j)?j:new T.SemanticTokensEdits(j.edits.map(Q=>new T.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const Q of j.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,Q){if(!U._isSemanticTokens(Q)||!j||!j.tokens)return Q;const Z=j.tokens,se=Z.length,fe=Q.data,_e=fe.length;let xe=0;const pe=Math.min(se,_e);for(;xe<pe&&Z[xe]===fe[xe];)xe++;if(xe===se&&xe===_e)return new T.SemanticTokensEdits([],Q.resultId);let ke=0;const Fe=pe-xe;for(;ke<Fe&&Z[se-ke-1]===fe[_e-ke-1];)ke++;return new T.SemanticTokensEdits([{start:xe,deleteCount:se-xe-ke,data:fe.subarray(xe,_e-ke)}],Q.resultId)}_send(j,Q){if(U._isSemanticTokens(j)){const Z=this._nextResultId++;return this._previousResults.set(Z,new B(j.resultId,j.data)),(0,o.encodeSemanticTokensDto)({id:Z,type:"full",data:j.data})}if(U._isSemanticTokensEdits(j)){const Z=this._nextResultId++;return U._isSemanticTokens(Q)?this._previousResults.set(Z,new B(Q.resultId,Q.data)):this._previousResults.set(Z,new B(j.resultId)),(0,o.encodeSemanticTokensDto)({id:Z,type:"delta",deltas:(j.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class A{constructor(j,Q){this._documents=j,this._provider=Q}provideDocumentRangeSemanticTokens(j,Q,Z){const se=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(se,I.Range.to(Q),Z)).then(fe=>fe?this._send(fe):null)}_send(j){return(0,o.encodeSemanticTokensDto)({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=A;class x{constructor(j,Q,Z,se,fe){this._documents=j,this._commands=Q,this._provider=Z,this._apiDeprecation=se,this._extension=fe,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,Q,Z,se){const fe=this._documents.getDocument(j),_e=I.Position.to(Q),xe=fe.getWordRangeAtPosition(_e)||new T.Range(_e,_e),pe=xe.with({end:_e}),ke=new w.StopWatch(!0),Fe=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(fe,_e,se,I.CompletionContext.to(Z)));if(!!Fe&&!se.isCancellationRequested){const He=Array.isArray(Fe)?new T.CompletionList(Fe):Fe,be=x.supportsResolving(this._provider)?this._cache.add(He.items):this._cache.add([]),Ke=new p.DisposableStore;this._disposables.set(be,Ke);const K=[],te={x:be,b:K,a:{replace:I.Range.from(xe),insert:I.Range.from(pe)},c:He.isIncomplete||void 0,d:ke.elapsed()};for(let we=0;we<He.items.length;we++){const Ue=He.items[we],je=this._convertCompletionItem(Ue,[be,we],pe,xe);K.push(je)}return te}}async resolveCompletionItem(j,Q){if(typeof this._provider.resolveCompletionItem=="function"){const Z=this._cache.get(...j);if(!!Z){const se=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(Z,Q));if(!!se)return this._convertCompletionItem(se,j)}}}releaseCompletionItems(j){var Q;(Q=this._disposables.get(j))===null||Q===void 0||Q.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,Q,Z,se){var fe;const _e=this._disposables.get(Q[0]);if(!_e)throw Error("DisposableStore is missing...");const xe={x:Q,a:(fe=j.label)!==null&&fe!==void 0?fe:"",o:j.label2,b:j.kind!==void 0?I.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(I.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(j.command,_e)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),xe.h=j.textEdit.newText):typeof j.insertText=="string"?xe.h=j.insertText:j.insertText instanceof T.SnippetString&&(xe.h=j.insertText.value,xe.i|=4);let pe;return j.textEdit?pe=j.textEdit.range:j.range&&(pe=j.range),T.Range.isRange(pe)?xe.j=I.Range.from(pe):pe&&(!(Z==null?void 0:Z.isEqual(pe.inserting))||!(se==null?void 0:se.isEqual(pe.replacing)))&&(xe.j={insert:I.Range.from(pe.inserting),replace:I.Range.from(pe.replacing)}),xe}}class F{constructor(j,Q){this._documents=j,this._provider=Q,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(j,Q,Z,se){const fe=this._documents.getDocument(j),_e=I.Position.to(Q),xe=this.reviveContext(Z);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(fe,_e,se,xe)).then(pe=>{if(pe){const ke=this._cache.add([pe]);return Object.assign(Object.assign({},I.SignatureHelp.from(pe)),{id:ke})}})}reviveContext(j){let Q;if(j.activeSignatureHelp){const Z=I.SignatureHelp.to(j.activeSignatureHelp),se=this._cache.get(j.activeSignatureHelp.id,0);se?(Q=se,Q.activeSignature=Z.activeSignature,Q.activeParameter=Z.activeParameter):Q=Z}return Object.assign(Object.assign({},j),{activeSignatureHelp:Q})}releaseSignatureHelp(j){this._cache.delete(j)}}class M{constructor(j,Q){this._documents=j,this._provider=Q}provideInlayHints(j,Q,Z){const se=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideInlayHints(se,I.Range.to(Q),Z)).then(fe=>fe?{hints:fe.map(I.InlayHint.from)}:void 0)}}class W{constructor(j,Q){this._documents=j,this._provider=Q,this._cache=new E.Cache("DocumentLink")}provideLinks(j,Q){const Z=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(Z,Q)).then(se=>{if(!(!Array.isArray(se)||se.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.map(I.DocumentLink.from)};{const fe=this._cache.add(se),_e={links:[],id:fe};for(let xe=0;xe<se.length;xe++){const pe=I.DocumentLink.from(se[xe]);pe.cacheId=[fe,xe],_e.links.push(pe)}return _e}}})}resolveLink(j,Q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const Z=this._cache.get(...j);return Z?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(Z,Q)).then(se=>se&&I.DocumentLink.from(se)||void 0):Promise.resolve(void 0)}releaseLinks(j){this._cache.delete(j)}}class z{constructor(j,Q){this._documents=j,this._provider=Q}provideColors(j,Q){const Z=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(Z,Q)).then(se=>Array.isArray(se)?se.map(_e=>({color:I.Color.from(_e.color),range:I.Range.from(_e.range)})):[])}provideColorPresentations(j,Q,Z){const se=this._documents.getDocument(j),fe=I.Range.to(Q.range),_e=I.Color.to(Q.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(_e,{document:se,range:fe},Z)).then(xe=>{if(!!Array.isArray(xe))return xe.map(I.ColorPresentation.from)})}}class Y{constructor(j,Q){this._documents=j,this._provider=Q}provideFoldingRanges(j,Q,Z){const se=this._documents.getDocument(j);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(se,Q,Z)).then(fe=>{if(!!Array.isArray(fe))return fe.map(I.FoldingRange.from)})}}class le{constructor(j,Q,Z){this._documents=j,this._provider=Q,this._logService=Z}provideSelectionRanges(j,Q,Z){const se=this._documents.getDocument(j),fe=Q.map(I.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(se,fe,Z)).then(_e=>{if(!(0,i.isNonEmptyArray)(_e))return[];if(_e.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const xe=[];for(let pe=0;pe<fe.length;pe++){const ke=[];xe.push(ke);let Fe=fe[pe],He=_e[pe];for(;;){if(!He.range.contains(Fe))throw new Error("INVALID selection range, must contain the previous range");if(ke.push(I.SelectionRange.from(He)),!He.parent)break;Fe=He.range,He=He.parent}}return xe})}}class ve{constructor(j,Q){this._documents=j,this._provider=Q,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(j,Q,Z){const se=this._documents.getDocument(j),fe=I.Position.to(Q),_e=await this._provider.prepareCallHierarchy(se,fe,Z);if(!!_e){const xe=this._idPool.nextId();return this._cache.set(xe,new Map),Array.isArray(_e)?_e.map(pe=>this._cacheAndConvertItem(xe,pe)):[this._cacheAndConvertItem(xe,_e)]}}async provideCallsTo(j,Q,Z){const se=this._itemFromCache(j,Q);if(!se)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(se,Z);if(!!fe)return fe.map(_e=>({from:this._cacheAndConvertItem(j,_e.from),fromRanges:_e.fromRanges.map(xe=>I.Range.from(xe))}))}async provideCallsFrom(j,Q,Z){const se=this._itemFromCache(j,Q);if(!se)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(se,Z);if(!!fe)return fe.map(_e=>({to:this._cacheAndConvertItem(j,_e.to),fromRanges:_e.fromRanges.map(xe=>I.Range.from(xe))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,Q){var Z;const se=this._cache.get(j),fe={_sessionId:j,_itemId:se.size.toString(36),name:Q.name,detail:Q.detail,kind:I.SymbolKind.from(Q.kind),uri:Q.uri,range:I.Range.from(Q.range),selectionRange:I.Range.from(Q.selectionRange),tags:(Z=Q.tags)===null||Z===void 0?void 0:Z.map(I.SymbolTag.from)};return se.set(fe._itemId,Q),fe}_itemFromCache(j,Q){const Z=this._cache.get(j);return Z==null?void 0:Z.get(Q)}}class Te{constructor(j,Q){this.adapter=j,this.extension=Q}}class ye{constructor(j,Q,Z,se,fe,_e,xe){this._adapter=new Map,this._uriTransformer=Q,this._proxy=j.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=Z,this._commands=se,this._diagnostics=fe,this._logService=_e,this._apiDeprecation=xe}_transformDocumentSelector(j){return(0,i.coalesce)((0,i.asArray)(j).map(Q=>this._doTransformDocumentSelector(Q)))}_doTransformDocumentSelector(j){if(typeof j=="string")return{$serialized:!0,language:j};if(j)return{$serialized:!0,language:j.language,scheme:this._transformScheme(j.scheme),pattern:typeof j.pattern=="undefined"?void 0:I.GlobPattern.from(j.pattern),exclusive:j.exclusive}}_transformScheme(j){return this._uriTransformer&&typeof j=="string"?this._uriTransformer.transformOutgoingScheme(j):j}_createDisposable(j){return new T.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return ye._handlePool++}_withAdapter(j,Q,Z,se,fe=!1){const _e=this._adapter.get(j);if(!_e)return Promise.resolve(se);if(_e.adapter instanceof Q){let xe;_e.extension&&(xe=Date.now(),this._logService.trace(`[${_e.extension.identifier.value}] INVOKE provider '${Q.name}'`));const pe=Z(_e.adapter,_e.extension),ke=_e.extension;return ke&&Promise.resolve(pe).then(()=>this._logService.trace(`[${ke.identifier.value}] provider DONE after ${Date.now()-xe}ms`),Fe=>{fe&&Fe instanceof S.CancellationError||(this._logService.error(`[${ke.identifier.value}] provider FAILED`),this._logService.error(Fe))}),pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,Q){const Z=this._nextHandle();return this._adapter.set(Z,new Te(j,Q)),Z}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,Q,Z,se){const fe=this._addNewAdapter(new u(this._documents,Z),j),_e=se&&se.label||ye._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(Q),_e),this._createDisposable(fe)}$provideDocumentSymbols(j,Q,Z){return this._withAdapter(j,u,se=>se.provideDocumentSymbols(b.URI.revive(Q),Z),void 0)}registerCodeLensProvider(j,Q,Z){const se=this._nextHandle(),fe=typeof Z.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Te(new c(this._documents,this._commands.converter,Z),j)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(Q),fe);let _e=this._createDisposable(se);if(fe!==void 0){const xe=Z.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(fe));_e=T.Disposable.from(_e,xe)}return _e}$provideCodeLenses(j,Q,Z){return this._withAdapter(j,c,se=>se.provideCodeLenses(b.URI.revive(Q),Z),void 0)}$resolveCodeLens(j,Q,Z){return this._withAdapter(j,c,se=>se.resolveCodeLens(Q,Z),void 0)}$releaseCodeLenses(j,Q){this._withAdapter(j,c,Z=>Promise.resolve(Z.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(j,Q,Z){const se=this._addNewAdapter(new t(this._documents,Z),j);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideDefinition(j,Q,Z,se){return this._withAdapter(j,t,fe=>fe.provideDefinition(b.URI.revive(Q),Z,se),[])}registerDeclarationProvider(j,Q,Z){const se=this._addNewAdapter(new n(this._documents,Z),j);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideDeclaration(j,Q,Z,se){return this._withAdapter(j,n,fe=>fe.provideDeclaration(b.URI.revive(Q),Z,se),[])}registerImplementationProvider(j,Q,Z){const se=this._addNewAdapter(new s(this._documents,Z),j);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideImplementation(j,Q,Z,se){return this._withAdapter(j,s,fe=>fe.provideImplementation(b.URI.revive(Q),Z,se),[])}registerTypeDefinitionProvider(j,Q,Z){const se=this._addNewAdapter(new r(this._documents,Z),j);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideTypeDefinition(j,Q,Z,se){return this._withAdapter(j,r,fe=>fe.provideTypeDefinition(b.URI.revive(Q),Z,se),[])}registerHoverProvider(j,Q,Z,se){const fe=this._addNewAdapter(new a(this._documents,Z),j);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(Q)),this._createDisposable(fe)}$provideHover(j,Q,Z,se){return this._withAdapter(j,a,fe=>fe.provideHover(b.URI.revive(Q),Z,se),void 0)}registerEvaluatableExpressionProvider(j,Q,Z,se){const fe=this._addNewAdapter(new g(this._documents,Z),j);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(Q)),this._createDisposable(fe)}$provideEvaluatableExpression(j,Q,Z,se){return this._withAdapter(j,g,fe=>fe.provideEvaluatableExpression(b.URI.revive(Q),Z,se),void 0)}registerInlineValuesProvider(j,Q,Z,se){const fe=typeof Z.onDidChangeInlineValues=="function"?this._nextHandle():void 0,_e=this._addNewAdapter(new m(this._documents,Z),j);this._proxy.$registerInlineValuesProvider(_e,this._transformDocumentSelector(Q),fe);let xe=this._createDisposable(_e);if(fe!==void 0){const pe=Z.onDidChangeInlineValues(ke=>this._proxy.$emitInlineValuesEvent(fe));xe=T.Disposable.from(xe,pe)}return xe}$provideInlineValues(j,Q,Z,se,fe){return this._withAdapter(j,m,_e=>_e.provideInlineValues(b.URI.revive(Q),Z,se,fe),void 0)}registerDocumentHighlightProvider(j,Q,Z){const se=this._addNewAdapter(new _(this._documents,Z),j);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideDocumentHighlights(j,Q,Z,se){return this._withAdapter(j,_,fe=>fe.provideDocumentHighlights(b.URI.revive(Q),Z,se),void 0)}registerLinkedEditingRangeProvider(j,Q,Z){const se=this._addNewAdapter(new l(this._documents,Z),j);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideLinkedEditingRanges(j,Q,Z,se){return this._withAdapter(j,l,async fe=>{const _e=await fe.provideLinkedEditingRanges(b.URI.revive(Q),Z,se);if(_e)return{ranges:_e.ranges,wordPattern:_e.wordPattern?ye._serializeRegExp(_e.wordPattern):void 0}},void 0)}registerReferenceProvider(j,Q,Z){const se=this._addNewAdapter(new v(this._documents,Z),j);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideReferences(j,Q,Z,se,fe){return this._withAdapter(j,v,_e=>_e.provideReferences(b.URI.revive(Q),Z,se,fe),void 0)}registerCodeActionProvider(j,Q,Z,se){var fe,_e;const xe=new p.DisposableStore,pe=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,Z,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(pe,this._transformDocumentSelector(Q),{providedKinds:(fe=se==null?void 0:se.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(ke=>ke.value),documentation:(_e=se==null?void 0:se.documentation)===null||_e===void 0?void 0:_e.map(ke=>({kind:ke.kind.value,command:this._commands.converter.toInternal(ke.command,xe)}))},ye._extLabel(j),Boolean(Z.resolveCodeAction)),xe.add(this._createDisposable(pe)),xe}$provideCodeActions(j,Q,Z,se,fe){return this._withAdapter(j,R,_e=>_e.provideCodeActions(b.URI.revive(Q),Z,se,fe),void 0)}$resolveCodeAction(j,Q,Z){return this._withAdapter(j,R,se=>se.resolveCodeAction(Q,Z),void 0)}$releaseCodeActions(j,Q){this._withAdapter(j,R,Z=>Promise.resolve(Z.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(j,Q,Z){const se=this._addNewAdapter(new O(this._documents,Z),j);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(Q),j.identifier,j.displayName||j.name),this._createDisposable(se)}$provideDocumentFormattingEdits(j,Q,Z,se){return this._withAdapter(j,O,fe=>fe.provideDocumentFormattingEdits(b.URI.revive(Q),Z,se),void 0)}registerDocumentRangeFormattingEditProvider(j,Q,Z){const se=this._addNewAdapter(new H(this._documents,Z),j);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(Q),j.identifier,j.displayName||j.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(j,Q,Z,se,fe){return this._withAdapter(j,H,_e=>_e.provideDocumentRangeFormattingEdits(b.URI.revive(Q),Z,se,fe),void 0)}registerOnTypeFormattingEditProvider(j,Q,Z,se){const fe=this._addNewAdapter(new ne(this._documents,Z),j);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(Q),se,j.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(j,Q,Z,se,fe,_e){return this._withAdapter(j,ne,xe=>xe.provideOnTypeFormattingEdits(b.URI.revive(Q),Z,se,fe,_e),void 0)}registerWorkspaceSymbolProvider(j,Q){const Z=this._addNewAdapter(new ie(Q,this._logService),j);return this._proxy.$registerNavigateTypeSupport(Z),this._createDisposable(Z)}$provideWorkspaceSymbols(j,Q,Z){return this._withAdapter(j,ie,se=>se.provideWorkspaceSymbols(Q,Z),{symbols:[]})}$resolveWorkspaceSymbol(j,Q,Z){return this._withAdapter(j,ie,se=>se.resolveWorkspaceSymbol(Q,Z),void 0)}$releaseWorkspaceSymbols(j,Q){this._withAdapter(j,ie,Z=>Z.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(j,Q,Z){const se=this._addNewAdapter(new N(this._documents,Z,this._logService),j);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(Q),N.supportsResolving(Z)),this._createDisposable(se)}$provideRenameEdits(j,Q,Z,se,fe){return this._withAdapter(j,N,_e=>_e.provideRenameEdits(b.URI.revive(Q),Z,se,fe),void 0)}$resolveRenameLocation(j,Q,Z,se){return this._withAdapter(j,N,fe=>fe.resolveRenameLocation(b.URI.revive(Q),Z,se),void 0)}registerDocumentSemanticTokensProvider(j,Q,Z,se){const fe=this._nextHandle(),_e=typeof Z.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Te(new U(this._documents,Z),j)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(Q),se,_e);let xe=this._createDisposable(fe);if(_e){const pe=Z.onDidChangeSemanticTokens(ke=>this._proxy.$emitDocumentSemanticTokensEvent(_e));xe=T.Disposable.from(xe,pe)}return xe}$provideDocumentSemanticTokens(j,Q,Z,se){return this._withAdapter(j,U,fe=>fe.provideDocumentSemanticTokens(b.URI.revive(Q),Z,se),null,!0)}$releaseDocumentSemanticTokens(j,Q){this._withAdapter(j,U,Z=>Z.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(j,Q,Z,se){const fe=this._addNewAdapter(new A(this._documents,Z),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(Q),se),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(j,Q,Z,se){return this._withAdapter(j,A,fe=>fe.provideDocumentRangeSemanticTokens(b.URI.revive(Q),Z,se),null,!0)}registerCompletionItemProvider(j,Q,Z,se){const fe=this._addNewAdapter(new x(this._documents,this._commands.converter,Z,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(Q),se,x.supportsResolving(Z),`${j.identifier.value}(${se.join("")})`),this._createDisposable(fe)}$provideCompletionItems(j,Q,Z,se,fe){return this._withAdapter(j,x,_e=>_e.provideCompletionItems(b.URI.revive(Q),Z,se,fe),void 0)}$resolveCompletionItem(j,Q,Z){return this._withAdapter(j,x,se=>se.resolveCompletionItem(Q,Z),void 0)}$releaseCompletionItems(j,Q){this._withAdapter(j,x,Z=>Z.releaseCompletionItems(Q),void 0)}registerSignatureHelpProvider(j,Q,Z,se){const fe=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,_e=this._addNewAdapter(new F(this._documents,Z),j);return this._proxy.$registerSignatureHelpProvider(_e,this._transformDocumentSelector(Q),fe),this._createDisposable(_e)}$provideSignatureHelp(j,Q,Z,se,fe){return this._withAdapter(j,F,_e=>_e.provideSignatureHelp(b.URI.revive(Q),Z,se,fe),void 0)}$releaseSignatureHelp(j,Q){this._withAdapter(j,F,Z=>Z.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider(j,Q,Z){const se=typeof Z.onDidChangeInlayHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new M(this._documents,Z),j);this._proxy.$registerInlayHintsProvider(fe,this._transformDocumentSelector(Q),se);let _e=this._createDisposable(fe);if(se!==void 0){const xe=Z.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(se));_e=T.Disposable.from(_e,xe)}return _e}$provideInlayHints(j,Q,Z,se){return this._withAdapter(j,M,fe=>fe.provideInlayHints(b.URI.revive(Q),Z,se),void 0)}registerDocumentLinkProvider(j,Q,Z){const se=this._addNewAdapter(new W(this._documents,Z),j);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(Q),typeof Z.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(j,Q,Z){return this._withAdapter(j,W,se=>se.provideLinks(b.URI.revive(Q),Z),void 0)}$resolveDocumentLink(j,Q,Z){return this._withAdapter(j,W,se=>se.resolveLink(Q,Z),void 0)}$releaseDocumentLinks(j,Q){this._withAdapter(j,W,Z=>Z.releaseLinks(Q),void 0)}registerColorProvider(j,Q,Z){const se=this._addNewAdapter(new z(this._documents,Z),j);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideDocumentColors(j,Q,Z){return this._withAdapter(j,z,se=>se.provideColors(b.URI.revive(Q),Z),[])}$provideColorPresentations(j,Q,Z,se){return this._withAdapter(j,z,fe=>fe.provideColorPresentations(b.URI.revive(Q),Z,se),void 0)}registerFoldingRangeProvider(j,Q,Z){const se=this._nextHandle(),fe=typeof Z.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Te(new Y(this._documents,Z),j)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(Q),fe);let _e=this._createDisposable(se);if(fe!==void 0){const xe=Z.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));_e=T.Disposable.from(_e,xe)}return _e}$provideFoldingRanges(j,Q,Z,se){return this._withAdapter(j,Y,fe=>fe.provideFoldingRanges(b.URI.revive(Q),Z,se),void 0)}registerSelectionRangeProvider(j,Q,Z){const se=this._addNewAdapter(new le(this._documents,Z,this._logService),j);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideSelectionRanges(j,Q,Z,se){return this._withAdapter(j,le,fe=>fe.provideSelectionRanges(b.URI.revive(Q),Z,se),[])}registerCallHierarchyProvider(j,Q,Z){const se=this._addNewAdapter(new ve(this._documents,Z),j);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$prepareCallHierarchy(j,Q,Z,se){return this._withAdapter(j,ve,fe=>Promise.resolve(fe.prepareSession(b.URI.revive(Q),Z,se)),void 0)}$provideCallHierarchyIncomingCalls(j,Q,Z,se){return this._withAdapter(j,ve,fe=>fe.provideCallsTo(Q,Z,se),void 0)}$provideCallHierarchyOutgoingCalls(j,Q,Z,se){return this._withAdapter(j,ve,fe=>fe.provideCallsFrom(Q,Z,se),void 0)}$releaseCallHierarchy(j,Q){this._withAdapter(j,ve,Z=>Promise.resolve(Z.releaseSession(Q)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:(0,D.regExpFlags)(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:ye._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:ye._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?ye._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?ye._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:ye._serializeRegExp(j.beforeText),afterText:j.afterText?ye._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?ye._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(ye._serializeOnEnterRule)}setLanguageConfiguration(j,Q,Z){let{wordPattern:se}=Z;if(se&&(0,D.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(Q,se):this._documents.setWordDefinitionFor(Q,void 0),Z.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),Z.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const fe=this._nextHandle(),_e={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?ye._serializeRegExp(Z.wordPattern):void 0,indentationRules:Z.indentationRules?ye._serializeIndentationRule(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?ye._serializeOnEnterRules(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,Q,_e),this._createDisposable(fe)}$setWordDefinitions(j){for(const Q of j)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=ye,ye._handlePool=0}),define(me[233],ge([0,1,5,20,7]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(C,D){this._proxy=C.getProxy(b.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,D){await this._proxy.$changeLanguage(C,D);const k=this._documents.getDocumentData(C);if(!k)throw new Error(`document '${C.toString}' NOT found`);return k.document}async tokenAtPosition(C,D){var k;const i=C.version,P=L.Position.from(D),h=await this._proxy.$tokensAtPosition(C.uri,P),p={type:I.StandardTokenType.Other,range:(k=C.getWordRangeAtPosition(D))!==null&&k!==void 0?k:new I.Range(D.line,D.character,D.line,D.character)};if(!h)return p;const o={range:L.Range.to(h.range),type:L.TokenType.to(h.type)};return!o.range.contains(D)||i!==C.version?p:o}}e.ExtHostLanguages=T}),define(me[234],ge([0,1,5,14,40]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(C){return C&&C.title}let y=class{constructor(D,k){this._logService=k,this._proxy=D.getProxy(b.MainContext.MainThreadMessageService)}showMessage(D,k,i,P,h){const p={extension:D};let o;typeof P=="string"||T(P)?o=[P,...h]:(p.modal=P&&P.modal,p.useCustom=P&&P.useCustom,o=h),p.useCustom&&(0,I.checkProposedApiEnabled)(D);const d=[];for(let E=0;E<o.length;E++){const w=o[E];if(typeof w=="string")d.push({title:w,handle:E,isCloseAffordance:!1});else if(typeof w=="object"){let{title:S,isCloseAffordance:u}=w;d.push({title:S,isCloseAffordance:!!u,handle:E})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(k,i,p,d).then(E=>{if(typeof E=="number")return o[E]})}};y=qe([We(1,L.ILogService)],y),e.ExtHostMessageService=y}),define(me[235],ge([0,1,23,3,75,73,6,22,8,11,2,86,5,20,7,64,211,212]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class S{constructor(f,t){const n=S._Keys.nextId();f.$registerNotebookEditorDecorationType(n,p.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){f.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=S,S._Keys=new T.IdGenerator("NotebookEditorDecorationType");class u{constructor(f,t,n,s,r,a){this._textDocumentsAndEditors=n,this._textDocuments=s,this.logService=r,this._extensionStoragePaths=a,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new L.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new L.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new L.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new L.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=f.getProxy(h.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(h.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(h.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:g=>{var m;if(g&&g.$mid===12){const _=(m=g.notebookEditor)===null||m===void 0?void 0:m.notebookUri,l=g.cell.handle,v=this._documents.get(_),R=v==null?void 0:v.getCell(l);if(R)return R.apiCell}return g}})}get activeNotebookEditor(){var f;return(f=this._activeNotebookEditor)===null||f===void 0?void 0:f.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}getEditorById(f){return this._editors.get(f)}getIdByEditor(f){for(const[t,n]of this._editors)if(n.apiEditor===f)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,t){const n=this._documents.get(f);if(!n&&!t)throw new Error(`NO notebook document for '${f}'`);return n}_getProviderData(f){const t=this._notebookContentProviders.get(f);if(!t)throw new Error(`NO provider for '${f}'`);return t}registerNotebookContentProvider(f,t,n,s,r){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:f,provider:n});let a;return n.onDidChangeNotebookContentOptions&&(a=n.onDidChangeNotebookContentOptions(()=>{const g=p.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,g)})),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},t,p.NotebookDocumentContentOptions.from(s),u._convertNotebookRegistrationData(f,r)),new o.Disposable(()=>{a==null||a.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(f,t){if(!!t){const n=t.filenamePattern.map(s=>p.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}}registerNotebookCellStatusBarItemProvider(f,t,n){const s=u._notebookStatusBarItemProviderHandlePool++,r=typeof n.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,r,t);let a;return r!==void 0&&(a=n.onDidChangeCellStatusBarItems(g=>this._notebookProxy.$emitCellStatusBarEvent(r))),new o.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,r),a&&a.dispose()})}createNotebookEditorDecorationType(f){return new S(this._notebookEditorsProxy,f).value}async openNotebookDocument(f){const t=this._documents.get(f);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenDocument(f),s=this._documents.get(i.URI.revive(n));return(0,k.assertIsDefined)(s==null?void 0:s.apiNotebook)}async showNotebookDocument(f,t){var n;i.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let s;typeof t=="object"?s={position:p.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(p.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:s={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.viewType,s),a=r&&((n=this._editors.get(r))===null||n===void 0?void 0:n.apiEditor);if(a)return a;throw r?new Error(`Could NOT open editor for "${f.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.toString()}".`)}async $provideNotebookCellStatusBarItems(f,t,n,s){var r;const a=this._notebookStatusBarItemProviders.get(f),g=i.URI.revive(t),m=this._documents.get(g);if(!(!m||!a)){const _=m.getCellFromIndex(n);if(!!_){const l=await a.provideCellStatusBarItems(_.apiCell,s);if(!!l){const v=new y.DisposableStore,R=this._statusBarCache.add([v]),O=(r=l&&l.map(H=>p.NotebookStatusBarItem.from(H,this._commandsConverter,v)))!==null&&r!==void 0?r:void 0;return{cacheId:R,items:O}}}}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,t,n,s,r){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,n),this._notebookProxy.$registerNotebookSerializer(a,{id:f.identifier,location:f.extensionLocation},t,p.NotebookDocumentContentOptions.from(s),u._convertNotebookRegistrationData(f,r)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(f,t,n){const s=this._notebookSerializer.get(f);if(!s)throw new Error("NO serializer found");const r=await s.deserializeNotebook(t.buffer,n),a={metadata:p.NotebookDocumentMetadata.from(r.metadata),cells:[]};for(let g of r.cells)o.NotebookCellData.validate(g),a.cells.push(p.NotebookCellData.from(g));return a}async $notebookToData(f,t,n){const s=this._notebookSerializer.get(f);if(!s)throw new Error("NO serializer found");const r=await s.serializeNotebook({metadata:p.NotebookDocumentMetadata.to(t.metadata),cells:t.cells.map(p.NotebookCellData.to)},n);return b.VSBuffer.wrap(r)}async $openNotebook(f,t,n,s,r){const{provider:a}=this._getProviderData(f),g=await a.openNotebook(i.URI.revive(t),{backupId:n,untitledDocumentData:s==null?void 0:s.buffer},r);return{metadata:p.NotebookDocumentMetadata.from(g.metadata),cells:g.cells.map(p.NotebookCellData.from)}}async $saveNotebook(f,t,n){const s=this.getNotebookDocument(i.URI.revive(t)),{provider:r}=this._getProviderData(f);return await r.saveNotebook(s.apiNotebook,n),!0}async $saveNotebookAs(f,t,n,s){const r=this.getNotebookDocument(i.URI.revive(t)),{provider:a}=this._getProviderData(f);return await a.saveNotebookAs(i.URI.revive(n),r.apiNotebook,s),!0}async $backupNotebook(f,t,n){var s;const r=this.getNotebookDocument(i.URI.revive(t)),a=this._getProviderData(f),g=(s=this._extensionStoragePaths.workspaceValue(a.extension))!==null&&s!==void 0?s:this._extensionStoragePaths.globalValue(a.extension),m=String((0,I.hash)([r.uri.toString(),this._backupIdPool++])),_=i.URI.joinPath(g,m),l=await a.provider.backupNotebook(r.apiNotebook,{destination:_},n);return r.updateBackup(l),l.id}$acceptModelChanged(f,t,n){this.getNotebookDocument(i.URI.revive(f)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(f,t){const n=this.getNotebookDocument(i.URI.revive(f));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(f){const t=this.getNotebookDocument(i.URI.revive(f));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",f,t);const n=this._editors.get(f);if(!n)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(p.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(p.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(f){for(const t in f){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(p.ViewColumn.to(f[t]))}}$acceptDocumentPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",f.path,t);const n=this.getNotebookDocument(i.URI.revive(f));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(f,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const s=new w.ExtHostNotebookEditor(t,this._notebookEditorsProxy,f,n.visibleRanges.map(p.NotebookRange.to),n.selections.map(p.NotebookRange.to),typeof n.viewColumn=="number"?p.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,s)}$acceptDocumentAndEditorsDelta(f){var t,n,s;if(f.removedDocuments)for(const a of f.removedDocuments){const g=i.URI.revive(a),m=this._documents.get(g);m&&(m.dispose(),this._documents.delete(g),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(_=>_.document.uri)}),this._onDidCloseNotebookDocument.fire(m.apiNotebook));for(const _ of this._editors.values())_.notebookData.uri.toString()===g.toString()&&this._editors.delete(_.id)}if(f.addedDocuments){const a=[];for(const g of f.addedDocuments){const m=i.URI.revive(g.uri),_=g.viewType;if(this._documents.has(m))throw new Error(`adding EXISTING notebook ${m} `);const l=this,v=new E.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(R){l._onDidChangeNotebookCells.fire(R)},emitCellOutputsChange(R){l._onDidChangeCellOutputs.fire(R)},emitCellMetadataChange(R){l._onDidChangeCellMetadata.fire(R)},emitCellExecutionStateChange(R){l._onDidChangeCellExecutionState.fire(R)}},_,g.metadata?p.NotebookDocumentMetadata.to(g.metadata):new o.NotebookDocumentMetadata,m);v.acceptModelChanged({versionId:g.versionId,rawEvents:[{kind:d.NotebookCellsChangeType.Initialize,changes:[[0,0,g.cells]]}]},!1),a.push(...g.cells.map(R=>E.ExtHostCell.asModelAddData(v.apiNotebook,R))),(t=this._documents.get(m))===null||t===void 0||t.dispose(),this._documents.set(m,v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:a}),this._onDidOpenNotebookDocument.fire(v.apiNotebook)}}if(f.addedEditors)for(const a of f.addedEditors){if(this._editors.has(a.id))return;const g=i.URI.revive(a.documentUri),m=this._documents.get(g);m&&this._createExtHostEditor(m,a.id,a)}const r=[];if(f.removedEditors)for(const a of f.removedEditors){const g=this._editors.get(a);g&&(this._editors.delete(a),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===g.id&&(this._activeNotebookEditor=void 0),r.push(g))}if(f.visibleEditors){this._visibleNotebookEditors=f.visibleEditors.map(g=>this._editors.get(g)).filter(g=>!!g);const a=new Set;this._visibleNotebookEditors.forEach(g=>a.add(g.id));for(const g of this._editors.values()){const m=a.has(g.id);g._acceptVisibility(m)}this._visibleNotebookEditors=[...this._editors.values()].map(g=>g).filter(g=>g.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.newActiveEditor===null?this._activeNotebookEditor=void 0:f.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.newActiveEditor)),f.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor)}}e.ExtHostNotebookController=u,u._notebookStatusBarItemProviderHandlePool=0}),define(me[236],ge([0,1,3,6,5,26,2,20,88,22,13,64,21,16,14]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let d=class{constructor(c,f,t,n){this._mainContext=c,this._initData=f,this._extHostNotebook=t,this._logService=n,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=c.getProxy(I.MainContext.MainThreadNotebookKernels)}createNotebookController(c,f,t,n,s,r){for(let A of this._kernelData.values())if(A.controller.id===f&&T.ExtensionIdentifier.equals(c.identifier,A.extensionId))throw new Error(`notebook controller with id '${f}' ALREADY exist`);const a=this._handlePool++,g=this;this._logService.trace(`NotebookController[${a}], CREATED by ${c.identifier.value}, ${f}`);const m=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${c.identifier}'`);let _=!1;const l=new L.DisposableStore,v=new b.Emitter,R=new b.Emitter,O={id:`${c.identifier.value}/${f}`,viewType:t,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:n||c.identifier.value,preloads:r?r.map(C.NotebookKernelPreload.from):[]};let H=s!=null?s:m,ne;this._proxy.$addKernel(a,O).catch(A=>{console.log(A),_=!0});let ie=0;const N=()=>{if(!_){const A=++ie;Promise.resolve().then(()=>{A===ie&&this._proxy.$updateKernel(a,O)})}},B=new k.ResourceMap,U={get id(){return f},get viewType(){return O.viewType},onDidChangeNotebookAssociation:v.event,get label(){return O.label},set label(A){var x;O.label=(x=A!=null?A:c.displayName)!==null&&x!==void 0?x:c.name,N()},get detail(){var A;return(A=O.detail)!==null&&A!==void 0?A:""},set detail(A){O.detail=A,N()},get description(){var A;return(A=O.description)!==null&&A!==void 0?A:""},set description(A){O.description=A,N()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(A){O.supportedLanguages=A,N()},get hasExecutionOrder(){var A;return(A=O.hasExecutionOrder)!==null&&A!==void 0?A:!1},set hasExecutionOrder(A){O.hasExecutionOrder=A,N()},get preloads(){return O.preloads?O.preloads.map(C.NotebookKernelPreload.to):[]},get executeHandler(){return H},set executeHandler(A){H=A!=null?A:m},get interruptHandler(){return ne},set interruptHandler(A){ne=A,O.supportsInterrupt=Boolean(A),N()},createNotebookCellExecutionTask(A){if(_)throw new Error("notebook controller is DISPOSED");if(!B.has(A.notebook.uri))throw g._logService.trace(`NotebookController[${a}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(B.keys()).map(x=>x.toString())),new Error(`notebook controller is NOT associated to notebook: ${A.notebook.uri.toString()}`);return g._createNotebookCellExecution(A)},dispose:()=>{_||(this._logService.trace(`NotebookController[${a}], DISPOSED`),_=!0,this._kernelData.delete(a),l.dispose(),v.dispose(),R.dispose(),this._proxy.$removeKernel(a))},onDidReceiveMessage:R.event,postMessage(A,x){return g._proxy.$postMessage(a,x&&g._extHostNotebook.getIdByEditor(x),A)},asWebviewUri(A){return(0,D.asWebviewUri)(Object.assign(Object.assign({},g._initData.environment),{remote:g._initData.remote}),String(a),A)},updateNotebookAffinity(A,x){g._proxy.$updateNotebookPriority(a,A.uri,x)}};return this._kernelData.set(a,{extensionId:c.identifier,controller:U,onDidReceiveMessage:R,onDidChangeSelection:v,associatedNotebooks:B}),U}$acceptNotebookAssociation(c,f,t){const n=this._kernelData.get(c);if(n){const s=this._extHostNotebook.getNotebookDocument(y.URI.revive(f));t?n.associatedNotebooks.set(s.uri,!0):n.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${c}] ASSOCIATE notebook`,s.uri.toString(),t),n.onDidChangeSelection.fire({selected:t,notebook:s.apiNotebook})}}async $executeCells(c,f,t){const n=this._kernelData.get(c);if(!!n){const s=this._extHostNotebook.getNotebookDocument(y.URI.revive(f)),r=[];for(let a of t){const g=s.getCell(a);g&&r.push(g.apiCell)}try{this._logService.trace(`NotebookController[${c}] EXECUTE cells`,s.uri.toString(),r.length),await n.controller.executeHandler.call(n.controller,r,s.apiNotebook,n.controller)}catch(a){this._logService.error(`NotebookController[${c}] execute cells FAILED`,a),console.error(a)}}}async $cancelCells(c,f,t){var n;const s=this._kernelData.get(c);if(!!s){const r=this._extHostNotebook.getNotebookDocument(y.URI.revive(f));s.controller.interruptHandler&&await s.controller.interruptHandler.call(s.controller,r.apiNotebook);for(let a of t){const g=r.getCell(a);g&&((n=this._activeExecutions.get(g.uri))===null||n===void 0||n.cancel())}}}$acceptKernelMessageFromRenderer(c,f,t){const n=this._kernelData.get(c);if(!!n){const s=this._extHostNotebook.getEditorById(f);if(!s)throw new Error(`send message for UNKNOWN editor: ${f}`);n.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:t}))}}_createNotebookCellExecution(c){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this._extHostNotebook.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!t)throw new Error("invalid cell");if(this._activeExecutions.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const n=new w(t.notebook,t,this._mainContext.getProxy(I.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(t.uri,n);const s=n.onDidChangeState(()=>{n.state===E.Resolved&&(n.dispose(),s.dispose(),this._activeExecutions.delete(t.uri))});return n.asApiObject()}};d=qe([We(3,o.ILogService)],d),e.ExtHostNotebookKernels=d;var E;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(E||(E={}));class w extends L.Disposable{constructor(c,f,t){super();this._document=c,this._cell=f,this._proxy=t,this._onDidChangeState=new b.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=E.Init,this._tokenSource=this._register(new h.CancellationTokenSource),this._collector=new S(10,n=>this.applyEdits(n)),this._executionOrder=f.internalMetadata.executionOrder,this.mixinMetadata({runState:P.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(c){await this._collector.addItem(c)}async applyEdits(c){return this._proxy.$applyEdits(this._document.uri,c,!1)}verifyStateForOutput(){if(this._state===E.Init)throw new Error("Must call start before modifying cell output");if(this._state===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(c){const f={editType:9,handle:this._cell.handle,internalMetadata:c};this.applyEdits([f])}cellIndexToHandle(c){if(typeof c!="number")return this._cell.handle;const f=this._document.getCellFromIndex(c);if(!f)throw new Error("INVALID cell index");return f.handle}asApiObject(){const c=this;return Object.freeze({get document(){return c._document.apiNotebook},get cell(){return c._cell.apiCell},get executionOrder(){return c._executionOrder},set executionOrder(f){c._executionOrder=f,c.mixinMetadata({executionOrder:f})},start(f){var t;if(c._state===E.Resolved||c._state===E.Started)throw new Error("Cannot call start again");c._state=E.Started,c._onDidChangeState.fire(),c.mixinMetadata({runState:P.NotebookCellExecutionState.Executing,runStartTime:(t=f==null?void 0:f.startTime)!==null&&t!==void 0?t:null})},end(f){var t,n;if(c._state===E.Resolved)throw new Error("Cannot call resolve twice");c._state=E.Resolved,c._onDidChangeState.fire(),c.mixinMetadata({runState:null,lastRunSuccess:(t=f==null?void 0:f.success)!==null&&t!==void 0?t:null,runEndTime:(n=f==null?void 0:f.endTime)!==null&&n!==void 0?n:null})},clearOutput(f){return c.verifyStateForOutput(),this.replaceOutput([],f)},async appendOutput(f,t){c.verifyStateForOutput();const n=c.cellIndexToHandle(t);return f=(0,p.asArray)(f),c.applyEditSoon({editType:2,handle:n,append:!0,outputs:f.map(C.NotebookCellOutput.from)})},async replaceOutput(f,t){c.verifyStateForOutput();const n=c.cellIndexToHandle(t);return f=(0,p.asArray)(f),c.applyEditSoon({editType:2,handle:n,outputs:f.map(C.NotebookCellOutput.from)})},async appendOutputItems(f,t){return c.verifyStateForOutput(),f=(0,p.asArray)(f),c.applyEditSoon({editType:7,append:!0,items:f.map(C.NotebookCellOutputItem.from),outputId:t})},async replaceOutputItems(f,t){return c.verifyStateForOutput(),f=(0,p.asArray)(f),c.applyEditSoon({editType:7,items:f.map(C.NotebookCellOutputItem.from),outputId:t})},token:c._tokenSource.token})}}class S{constructor(c,f){this.delay=c,this.callback=f,this.batch=[]}addItem(c){return this.batch.push(c),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const f=this.batch;return this.batch=[],this.callback(f)})),this.waitPromise}}}),define(me[66],ge([0,1,5,3,6,23,4,15]),function(G,e,b,L,I,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends I.Disposable{constructor(o,d,E,w){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=o,this._proxy=w,this._id=w.$register(this.name,d,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(o){this.validate(),this._offset+=o?T.VSBuffer.fromString(o).byteLength:0}update(){this._id.then(o=>this._proxy.$update(o))}appendLine(o){this.validate(),this.append(o+`
`)}clear(){this.validate();const o=this._offset;this._id.then(d=>this._proxy.$clear(d,o))}show(o,d){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof o=="boolean"?o:d)))}hide(){this.validate(),this._id.then(o=>this._proxy.$close(o))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(o=>this._proxy.$dispose(o)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class k extends D{constructor(o,d){super(o,!1,void 0,d)}append(o){super.append(o),this._id.then(d=>this._proxy.$append(d,o)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class i extends D{constructor(o,d,E){super(o,!0,d,E)}append(o){throw new Error("Not supported")}}class P{constructor(o,d){this.name=o,this._channel=d}append(o){this._channel.then(d=>d.append(o))}appendLine(o){this._channel.then(d=>d.appendLine(o))}clear(){this._channel.then(o=>o.clear())}show(o,d){this._channel.then(E=>E.show(o,d))}hide(){this._channel.then(o=>o.hide())}dispose(){this._channel.then(o=>o.dispose())}}e.LazyOutputChannel=P;let h=class{constructor(o){this._proxy=o.getProxy(b.MainContext.MainThreadOutputService)}$setVisibleChannel(o){}createOutputChannel(o){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");return new k(o,this._proxy)}createOutputChannelFromLogFile(o,d){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new i(o,d,this._proxy)}};h=qe([We(0,C.IExtHostRpcService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(me[237],ge([0,1,13,21,3,6,5,2,7,17,16,58]),function(G,e,b,L,I,T,y,C,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(p,o,d){const E=p.getProxy(y.MainContext.MainThreadQuickOpen);class w{constructor(r,a){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=a}showQuickPick(r,a,g,m=L.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(r),l=++this._instances,v=E.$show(l,{title:g==null?void 0:g.title,placeHolder:g==null?void 0:g.placeHolder,matchOnDescription:g==null?void 0:g.matchOnDescription,matchOnDetail:g==null?void 0:g.matchOnDetail,ignoreFocusLost:g==null?void 0:g.ignoreFocusOut,canPickMany:g==null?void 0:g.canPickMany},m),R={},O=v.then(()=>R);return Promise.race([O,_]).then(H=>{if(H!==R)return _.then(ne=>{const ie=[];for(let N=0;N<ne.length;N++){const B=ne[N];let U,A,x,F,M;typeof B=="string"?U=B:(U=B.label,A=B.description,x=B.detail,F=B.picked,M=B.alwaysShow),ie.push({label:U,description:A,handle:N,detail:x,picked:F,alwaysShow:M})}return g&&typeof g.onDidSelectItem=="function"&&(this._onDidSelectItem=N=>{g.onDidSelectItem(ne[N])}),E.$setItems(l,ie),v.then(N=>{if(typeof N=="number")return ne[N];if(Array.isArray(N))return N.map(B=>ne[B])})})}).then(void 0,H=>{if(!(0,k.isPromiseCanceledError)(H))return E.$setError(l,H),Promise.reject(H)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,a=L.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,E.$input(r,typeof this._validateInput=="function",a).then(void 0,g=>{if(!(0,k.isPromiseCanceledError)(g))return Promise.reject(g)})}$validateInput(r){return this._validateInput?(0,b.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,a=L.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!g){const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(_=>_.uri.toString()===g.uri.toString())}}createQuickPick(r,a){const g=new t(r,a,()=>this._sessions.delete(g._id));return this._sessions.set(g._id,g),g}createInputBox(r){const a=new n(r,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(r,a){const g=this._sessions.get(r);g&&g._fireDidChangeValue(a)}$onDidAccept(r){const a=this._sessions.get(r);a&&a._fireDidAccept()}$onDidChangeActive(r,a){const g=this._sessions.get(r);g instanceof t&&g._fireDidChangeActive(a)}$onDidChangeSelection(r,a){const g=this._sessions.get(r);g instanceof t&&g._fireDidChangeSelection(a)}$onDidTriggerButton(r,a){const g=this._sessions.get(r);g&&g._fireDidTriggerButton(a)}$onDidHide(r){const a=this._sessions.get(r);a&&a._fireDidHide()}}class S{constructor(r,a){this._extensionId=r,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((a,g)=>{const m=a===D.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(m,a)}),this.update({buttons:r.map((a,g)=>({iconPath:u(a.iconPath),tooltip:a.tooltip,handle:a===D.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const a=this._handlesToButtons.get(r);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(r){if(!this._disposed){for(const a of Object.keys(r)){const g=r[a];this._pendingUpdate[a]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function u(s){if(s instanceof D.ThemeIcon)return{id:s.id};const r=f(s),a=c(s);return{dark:typeof r=="string"?C.URI.file(r):r,light:typeof a=="string"?C.URI.file(a):a}}function c(s){return typeof s=="object"&&"light"in s?s.light:s}function f(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends S{constructor(r,a,g){super(r,g);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((a,g)=>{this._handlesToItems.set(g,a),this._itemsToHandles.set(a,g)}),this.update({items:r.map((a,g)=>({label:a.label,description:a.description,handle:g,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(r){const a=(0,i.coalesce)(r.map(g=>this._handlesToItems.get(g)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(r){const a=(0,i.coalesce)(r.map(g=>this._handlesToItems.get(g)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class n extends S{constructor(r,a){super(r,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?P.default.Error:P.default.Ignore})}}return new w(o,d)}e.createExtHostQuickOpen=h}),define(me[238],ge([0,1,2,3,54,6,13,5,16,98,14,26,40]),function(G,e,b,L,I,T,y,C,D,k,i,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(r){if(r)return typeof r.iconPath=="string"?b.URI.file(r.iconPath):r.iconPath}function o(r,a){if(!r.iconPath&&!a.iconPath)return 0;if(r.iconPath){if(!a.iconPath)return 1}else return-1;const g=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,m=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath;return(0,k.comparePaths)(g,m)}function d(r,a){let g=0;if(r.strikeThrough!==a.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==a.faded)return r.faded?1:-1;if(r.tooltip!==a.tooltip)return(r.tooltip||"").localeCompare(a.tooltip||"");if(g=o(r,a),g!==0)return g;if(r.light&&a.light)g=o(r.light,a.light);else{if(r.light)return 1;if(a.light)return-1}if(g!==0)return g;if(r.dark&&a.dark)g=o(r.dark,a.dark);else{if(r.dark)return 1;if(a.dark)return-1}return g}function E(r,a){if(r.command!==a.command)return r.command<a.command?-1:1;if(r.title!==a.title)return r.title<a.title?-1:1;if(r.tooltip!==a.tooltip){if(r.tooltip!==void 0&&a.tooltip!==void 0)return r.tooltip<a.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(r.arguments===a.arguments)return 0;if(r.arguments)if(a.arguments){if(r.arguments.length!==a.arguments.length)return r.arguments.length-a.arguments.length}else return 1;else return-1;for(let g=0;g<r.arguments.length;g++){const m=r.arguments[g],_=a.arguments[g];if(m!==_)return m<_?-1:1}return 0}function w(r,a){let g=(0,k.comparePaths)(r.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(g!==0)return g;if(r.command&&a.command)g=E(r.command,a.command);else{if(r.command)return 1;if(a.command)return-1}if(g!==0)return g;if(r.decorations&&a.decorations)g=d(r.decorations,a.decorations);else{if(r.decorations)return 1;if(a.decorations)return-1}return g}function S(r,a){for(let g=0;g<r.length;g++)if(r[g]!==a[g])return!1;return!0}function u(r,a){return r.command===a.command&&r.title===a.title&&r.tooltip===a.tooltip&&(r.arguments&&a.arguments?S(r.arguments,a.arguments):r.arguments===a.arguments)}function c(r,a){return(0,D.equals)(r,a,u)}class f{constructor(a,g,m){this._extension=a,this._proxy=g,this._sourceControlHandle=m,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return(0,h.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(a){if((0,h.checkProposedApiEnabled)(this._extension),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}focus(){(0,h.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(a,g){(0,h.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,a,g)}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=f;class t{constructor(a,g,m,_,l){this._proxy=a,this._commands=g,this._sourceControlHandle=m,this._id=_,this._label=l,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,g){const m=this._resourceStatesCommandsMap.get(a);return m?(0,y.asPromise)(()=>this._commands.executeCommand(m.command,...m.arguments||[],g)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var a;const g=[...this._resourceStates].sort(w),_=(0,D.sortedDiff)(this._resourceSnapshot,g,w).map(R=>{const O=R.toInsert.map(H=>{const ne=this._resourceHandlePool++;this._resourceStatesMap.set(ne,H);const ie=H.resourceUri,N=p(H.decorations),B=H.decorations&&p(H.decorations.light)||N,U=H.decorations&&p(H.decorations.dark)||N,A=[];let x;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const le=new T.DisposableStore;x=this._commands.converter.toInternal(H.command,le),this._resourceStatesDisposablesMap.set(ne,le)}else this._resourceStatesCommandsMap.set(ne,H.command);B&&A.push(B),U&&U.toString()!==(B==null?void 0:B.toString())&&A.push(U);const F=H.decorations&&H.decorations.tooltip||"",M=H.decorations&&!!H.decorations.strikeThrough,W=H.decorations&&!!H.decorations.faded,z=H.contextValue||"";return{rawResource:[ne,ie,A,F,M,W,z,x],handle:ne}});return{start:R.start,deleteCount:R.deleteCount,toInsert:O}}),l=_.map(({start:R,deleteCount:O,toInsert:H})=>[R,O,H.map(ne=>ne.rawResource)]),v=_.reverse();for(const{start:R,deleteCount:O,toInsert:H}of v){const ne=H.map(N=>N.handle),ie=this._handlesSnapshot.splice(R,O,...ne);for(const N of ie)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),(a=this._resourceStatesDisposablesMap.get(N))===null||a===void 0||a.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=g,l}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(a,g,m,_,l,v){this._proxy=g,this._commands=m,this._id=_,this._label=l,this._rootUri=v,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,l,v)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=a;const g=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:g})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(!(this._statusBarCommands&&a&&c(this._statusBarCommands,a))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=a;const g=(a||[]).map(m=>this._commands.converter.toInternal(m,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:g})}}get selected(){return this._selected}createResourceGroup(a,g){const m=new t(this._proxy,this._commands,this.handle,a,g),_=L.Event.once(m.onDidDispose)(()=>this.createdResourceGroups.delete(m));return this.createdResourceGroups.set(m,_),this.eventuallyAddResourceGroups(),m}eventuallyAddResourceGroups(){const a=[],g=[];for(const[m,_]of this.createdResourceGroups){_.dispose();const l=m.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(m),this.eventuallyUpdateResourceStates()});L.Event.once(m.onDidDispose)(()=>{this.updatedResourceGroups.delete(m),l.dispose(),this._groups.delete(m.handle),this._proxy.$unregisterGroup(this.handle,m.handle)}),a.push([m.handle,m.id,m.label,m.features]);const v=m._takeResourceStateSnapshot();v.length>0&&g.push([m.handle,v]),this._groups.set(m.handle,m)}this._proxy.$registerGroups(this.handle,a,g),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(g=>{const m=g._takeResourceStateSnapshot();m.length!==0&&a.push([g.handle,m])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,qe([(0,I.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),qe([(0,I.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Fn{constructor(a,g,m){this._commands=g,this.logService=m,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=a.getProxy(C.MainContext.MainThreadSCM),this._telemetry=a.getProxy(C.MainContext.MainThreadTelemetry),g.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const l=this._sourceControls.get(_.sourceControlHandle);if(!l)return _;const v=l.getResourceGroup(_.groupHandle);return v?v.getResourceState(_.handle):_}else if(_&&_.$mid===4){const l=this._sourceControls.get(_.sourceControlHandle);return l?l.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const l=this._sourceControls.get(_.handle);return l||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,g,m,_){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,g,m,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const l=Fn._handlePool++,v=new n(a,this._proxy,this._commands,g,m,_);this._sourceControls.set(l,v);const R=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(a.identifier))||[];return R.push(v),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(a.identifier),R),v}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const g=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(a.identifier)),m=g&&g[g.length-1];return m&&m.inputBox}$provideOriginalResource(a,g,m){const _=b.URI.revive(g);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,_.toString());const l=this._sourceControls.get(a);return!l||!l.quickDiffProvider||!l.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>l.quickDiffProvider.provideOriginalResource(_,m)).then(v=>v||null)}$onInputBoxValueChange(a,g){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const m=this._sourceControls.get(a);return m&&m.inputBox.$onInputBoxValueChange(g),Promise.resolve(void 0)}$executeResourceCommand(a,g,m,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,g,m);const l=this._sourceControls.get(a);if(!l)return Promise.resolve(void 0);const v=l.getResourceGroup(g);return v?v.$executeResourceCommand(m,_):Promise.resolve(void 0)}$validateInput(a,g,m){this.logService.trace("ExtHostSCM#$validateInput",a);const _=this._sourceControls.get(a);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>_.inputBox.validateInput(g,m)).then(l=>l?Promise.resolve([l.message,l.type]):Promise.resolve(void 0))}$setSelectedSourceControl(a){var g,m;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&((g=this._sourceControls.get(a))===null||g===void 0||g.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((m=this._sourceControls.get(this._selectedSourceControlHandle))===null||m===void 0||m.setSelectionState(!1)),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};s._handlePool=0,s=qe([We(2,i.ILogService)],s),e.ExtHostSCM=s});var nt=this&&this.__classPrivateFieldSet||function(G,e,b,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(G,b):I?I.value=b:e.set(G,b),b},$e=this&&this.__classPrivateFieldGet||function(G,e,b,L){if(b==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?L:b==="a"?L.call(G):L?L.value:e.get(G)};define(me[239],ge([0,1,7,5,162,6]),function(G,e,b,L,I,T){"use strict";var y,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(h,p,o,d,E=b.StatusBarAlignment.Left,w){y.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,nt(this,y,h,"f"),nt(this,C,p,"f"),this._entryId=D.ID_GEN++,this._extension=o,this._id=d,this._alignment=E,this._priority=w}get id(){var h;return(h=this._id)!==null&&h!==void 0?h:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var h;return(h=this._command)===null||h===void 0?void 0:h.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!D.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){var p;((p=this._command)===null||p===void 0?void 0:p.fromApi)!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:$e(this,C,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:$e(this,C,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var h;this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let o;this._name?o=this._name:o=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),$e(this,y,"f").$setEntry(this._entryId,p,o,this._text,this._tooltip,(h=this._command)===null||h===void 0?void 0:h.internal,d,this._backgroundColor,this._alignment===b.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,C=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new b.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",b.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const p={message:h};return this._messages.unshift(p),this._update(),new b.Disposable(()=>{const o=this._messages.indexOf(p);o>=0&&(this._messages.splice(o,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(h,p){this._proxy=h.getProxy(L.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new k(this)}createStatusBarEntry(h,p,o,d){return new D(this._proxy,this._commands,h,p,o,d)}setStatusBarMessage(h,p){const o=this._statusMessage.setMessage(h);let d;return typeof p=="number"?d=setTimeout(()=>o.dispose(),p):typeof p!="undefined"&&p.then(()=>o.dispose(),()=>o.dispose()),new b.Disposable(()=>{o.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=i}),define(me[91],ge([0,1,5,3,4]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(C){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(b.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,D){this._proxy.$registerExtensionStorageKeysToSync(C,D)}getValue(C,D,k){return this._proxy.$getValue(C,D).then(i=>i||k)}setValue(C,D,k){return this._proxy.$setValue(C,D,k)}$acceptValue(C,D,k){this._onDidChangeStorage.fire({shared:C,key:D,value:k})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(me[92],ge([0,1,4,27,14,90,2]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,b.createDecorator)("IExtensionStoragePaths");let C=class{constructor(k,i,P){var h;this._logService=i,this._extHostFileSystem=P,this._workspace=(h=k.workspace)!==null&&h!==void 0?h:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,P=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch(h){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=y.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),P}catch(h){this._logService.error("[ExtHostStorage]",h);return}}workspaceValue(k){if(this._value)return y.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return y.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};C=qe([We(0,L.IExtHostInitDataService),We(1,I.ILogService),We(2,T.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(me[33],ge([0,1,3,5,4,2,15,6,7,163,17,205,21,30,189]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class d{constructor(t,n,s,r){this._proxy=t,this._id=n,this._creationOptions=s,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(g=>this._pidPromiseComplete=g);const a=this;this.value={get name(){return a._name||""},get processId(){return a._pidPromise},get creationOptions(){return a._creationOptions},get exitStatus(){return a._exitStatus},sendText(g,m=!0){a._checkDisposed(),a._proxy.$sendText(a._id,g,m)},show(g){a._checkDisposed(),a._proxy.$show(a._id,g)},hide(){a._checkDisposed(),a._proxy.$hide(a._id)},dispose(){a._disposed||(a._disposed=!0,a._proxy.$dispose(a._id))},get dimensions(){if(!(a._cols===void 0||a._rows===void 0))return{columns:a._cols,rows:a._rows}}}}async create(t,n,s,r,a,g,m,_,l,v,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:s,env:r,icon:a,initialText:g,waitOnExit:m,strictEnv:_,hideFromUser:l,isFeatureTerminal:v,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=d;class E{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new b.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new b.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new b.Emitter,this._onProcessTitleChanged=new b.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new b.Emitter,this._onProcessShellTypeChanged=new b.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let w=1,S=class extends C.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new b.Emitter,this._onDidOpenTerminal=new b.Emitter,this._onDidChangeActiveTerminal=new b.Emitter,this._onDidChangeTerminalDimensions=new b.Emitter,this._proxy=n.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new b.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(t){const n=t?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.path)||""}getDefaultShellArgs(t){const n=t?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.args)||[""]}createExtensionTerminal(t){const n=new d(this._proxy,(0,p.generateUuid)(),t,t.name),s=new E(t.pty);return n.createExtensionTerminal().then(r=>{const a=this._setupExtHostProcessListeners(r,s);this._terminalProcessDisposables[r]=a}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new E(n),a=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=a}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:n})}async $acceptTerminalDimensions(t,n,s){const r=this._getTerminalById(t);r&&r.setDimensions(n,s)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,s){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}async $acceptTerminalTitleChange(t,n){const s=this._getTerminalById(t);s&&(s.name=n)}async $acceptTerminalClosed(t,n){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const r=this._terminals.splice(s,1)[0];r.setExitCode(n),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,n,s,r){if(n){const m=this._getTerminalObjectIndexById(this._terminals,n);if(m!==null){this._terminals[m]._id=t,this._onDidOpenTerminal.fire(this.terminals[m]),this._terminals[m].isOpen=!0;return}}const a={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:T.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},g=new d(this._proxy,t,a,s);this._terminals.push(g),this._onDidOpenTerminal.fire(g.value),g.isOpen=!0}async $acceptTerminalProcessId(t,n){const s=this._getTerminalById(t);s&&s._setProcessId(n)}async $startExtensionTerminal(t,n){const s=this._getTerminalById(t);if(!s)return{message:(0,k.localize)(0,null,t)};s.isOpen||await new Promise(a=>{const g=this.onDidOpenTerminal(async m=>{m===s.value&&(g.dispose(),a())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const s=new C.DisposableStore;s.add(n.onProcessReady(a=>this._proxy.$sendProcessReady(t,a.pid,a.cwd))),s.add(n.onProcessTitleChanged(a=>this._proxy.$sendProcessTitle(t,a))),this._bufferer.startBuffering(t,n.onProcessData),s.add(n.onProcessExit(a=>this._onProcessExit(t,a))),n.onProcessOverrideDimensions&&s.add(n.onProcessOverrideDimensions(a=>this._proxy.$sendOverrideDimensions(t,a))),this._terminalProcesses.set(t,n);const r=this._extensionTerminalAwaitingStart[t];return r&&n instanceof E&&(n.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(n)}$acceptProcessResize(t,n,s){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}catch(a){if(a.code!=="EPIPE"&&a.code!=="ERR_IPC_CHANNEL_CLOSED")throw a}}$acceptProcessShutdown(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const a=new h.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,a);const g=[],m={terminal:s.value,line:n},_=[];for(const R of this._linkProviders)_.push(new Promise(async O=>{a.token.onCancellationRequested(()=>O({provider:R,links:[]}));const H=await R.provideTerminalLinks(m,a.token)||[];a.token.isCancellationRequested||O({provider:R,links:H})}));const l=await Promise.all(_);if(a.token.isCancellationRequested)return[];const v=new Map;for(const R of l)R&&R.links.length>0&&g.push(...R.links.map(O=>{const H={id:w++,startIndex:O.startIndex,length:O.length,label:O.tooltip};return v.set(H.id,{provider:R.provider,link:O}),H}));return this._terminalLinkCache.set(t,v),g}$activateLink(t,n){var s;const r=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(n);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const s=this._getTerminalObjectIndexById(t,n);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,n){let s=null;return t.some((r,a)=>r._id===n?(s=a,!0):!1),s}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new u,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const s=(0,P.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const s=n[0],r=new u(n[1]);this._setEnvironmentVariableCollection(s,r)})}$acceptDefaultProfile(t,n){this._defaultProfile=t,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};S=qe([We(1,y.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class u{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new b.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const s=this.map.get(t);(!s||s.value!==n.value||s.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((s,r)=>t.call(n,r,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let c=class extends S{constructor(t){super(!1,t)}createTerminal(t,n,s){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}};c=qe([We(0,y.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(me[240],ge([0,1,3,16,5,124,20,7]),function(G,e,b,L,I,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(i,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new b.Emitter,this._onDidChangeTextEditorOptions=new b.Emitter,this._onDidChangeTextEditorVisibleRanges=new b.Emitter,this._onDidChangeTextEditorViewColumn=new b.Emitter,this._onDidChangeActiveTextEditor=new b.Emitter,this._onDidChangeVisibleTextEditors=new b.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(h=>this._onDidChangeVisibleTextEditors.fire(h)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(h=>this._onDidChangeActiveTextEditor.fire(h))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const P=this._extHostDocumentsAndEditors.allEditors();return i?P:P.map(h=>h.value)}async showTextDocument(i,P,h){let p;typeof P=="number"?p={position:y.ViewColumn.from(P),preserveFocus:h}:typeof P=="object"?p={position:y.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?y.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:p={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(i.uri,p),d=o&&this._extHostDocumentsAndEditors.getEditor(o);if(d)return d.value;throw o?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new T.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,P){const h=this._extHostDocumentsAndEditors.getEditor(i);if(!h)throw new Error("unknown text editor");if(P.options&&h._acceptOptions(P.options),P.selections){const p=P.selections.selections.map(y.Selection.to);h._acceptSelections(p)}if(P.visibleRanges){const p=L.coalesce(P.visibleRanges.map(y.Range.to));h._acceptVisibleRanges(p)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:h.value,options:Object.assign(Object.assign({},P.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(P.options.lineNumbers)})}),P.selections){const p=C.TextEditorSelectionChangeKind.fromValue(P.selections.source),o=P.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:h.value,selections:o,kind:p})}if(P.visibleRanges){const p=L.coalesce(P.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:h.value,visibleRanges:p})}}$acceptEditorPositionData(i){for(const P in i){const h=this._extHostDocumentsAndEditors.getEditor(P);if(!h)throw new Error("Unknown text editor");const p=y.ViewColumn.to(i[P]);h.value.viewColumn!==p&&(h._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:h.value,viewColumn:p}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=D});var Gt=this&&this.__rest||function(G,e){var b={};for(var L in G)Object.prototype.hasOwnProperty.call(G,L)&&e.indexOf(L)<0&&(b[L]=G[L]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var I=0,L=Object.getOwnPropertySymbols(G);I<L.length;I++)e.indexOf(L[I])<0&&Object.prototype.propertyIsEnumerable.call(G,L[I])&&(b[L[I]]=G[L[I]]);return b};define(me[241],ge([0,1,2,4,5,6,7]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class C{constructor(i,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(I.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:h=>{var p,o;if(h&&h.$mid===11){const d=h.uri===void 0?void 0:b.URI.revive(h.uri);return(o=(p=this._itemsBySourceAndUriMap.get(h.source))===null||p===void 0?void 0:p.get(D(d)))===null||o===void 0?void 0:o.get(h.handle)}return h}})}async $getTimeline(i,P,h,p,o){const d=this._providers.get(i);return d==null?void 0:d.provideTimeline(b.URI.revive(P),h,p,o)}registerTimelineProvider(i,P,h,p){const o=new T.DisposableStore,d=this.convertTimelineItem(P.id,p,o).bind(this);let E;P.onDidChange&&(E=P.onDidChange(S=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},S),{id:P.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},P),{scheme:i,onDidChange:void 0,async provideTimeline(S,u,c,f){var t;(f==null?void 0:f.resetCache)&&(o.clear(),(t=w.get(P.id))===null||t===void 0||t.clear());const n=await P.provideTimeline(S,u,c);if(n!=null){const s=d(S,f);return Object.assign(Object.assign({},n),{source:P.id,items:n.items.map(s)})}},dispose(){var S;for(const u of w.values())(S=u.get(P.id))===null||S===void 0||S.clear();E==null||E.dispose(),o.dispose()}}))}convertTimelineItem(i,P,h){return(p,o)=>{let d;if(o==null?void 0:o.cacheResults){let E=this._itemsBySourceAndUriMap.get(i);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(i,E));const w=D(p);d=E.get(w),d===void 0&&(d=new Map,E.set(w,d))}return E=>{var w,S;const{iconPath:u}=E,c=Gt(E,["iconPath"]),f=`${i}|${(w=E.id)!==null&&w!==void 0?w:E.timestamp}`;d==null||d.set(f,E);let t,n,s;return E.iconPath&&(u instanceof y.ThemeIcon?s={id:u.id}:b.URI.isUri(u)?(t=u,n=u):{light:t,dark:n}=u),Object.assign(Object.assign({},c),{id:(S=c.id)!==null&&S!==void 0?S:void 0,handle:f,source:i,command:E.command?P.toInternal(E.command,h):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,T.toDisposable)(()=>{var h;for(const p of this._itemsBySourceAndUriMap.values())(h=p.get(i.id))===null||h===void 0||h.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=C;function D(k){return k==null?void 0:k.toString()}}),define(me[242],ge([0,1,6,12,2,5]),function(G,e,b,L,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,k,i,P){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const h=P.schemes.find(p=>!y.supportedSchemes.has(p));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,i),this._proxy.$registerUriOpener(k,P.schemes,D,P.label),(0,b.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(D,k,i){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener with id: ${D}`);const h=I.URI.revive(k);return P.canOpenExternalUri(h,i)}async $openUri(D,k,i){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener id: '${D}'`);return P.openExternalUri(I.URI.revive(k.resolvedUri),{sourceUri:I.URI.revive(k.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(me[243],ge([0,1,5,2,6,17,26]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(b.MainContext.MainThreadUrls)}registerUriHandler(k,i){if(this.handles.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const P=C.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(k)),this.handlers.set(P,i),this._proxy.$registerUriHandler(P,k),(0,I.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(k)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(k,i){const P=this.handlers.get(k);if(!P)return Promise.resolve(void 0);try{P.handleUri(L.URI.revive(i))}catch(h){(0,T.onUnexpectedError)(h)}return Promise.resolve(void 0)}async createAppUri(k){return L.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=C,C.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(G,e,b,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(G,b):I?I.value=b:e.set(G,b),b},$e=this&&this.__classPrivateFieldGet||function(G,e,b,L){if(b==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?L:b==="a"?L.call(G):L?L.value:e.get(G)};define(me[67],ge([0,1,3,2,174,197,88,5]),function(G,e,b,L,I,T,y,C){"use strict";var D,k,i,P,h,p,o,d,E,w,S,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class c{constructor(m,_,l,v,R,O,H){D.set(this,void 0),k.set(this,void 0),i.set(this,void 0),P.set(this,void 0),h.set(this,void 0),p.set(this,void 0),o.set(this,""),d.set(this,void 0),E.set(this,!1),w.set(this,!1),S.set(this,!1),this._onMessageEmitter=new b.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new b.Emitter),this._onDidDispose=$e(this,u,"f").event,nt(this,D,m,"f"),nt(this,k,_,"f"),nt(this,d,l,"f"),nt(this,P,v,"f"),nt(this,h,R,"f"),nt(this,p,O,"f"),nt(this,S,f(O),"f"),nt(this,i,H,"f")}dispose(){nt(this,E,!0,"f"),$e(this,u,"f").fire(),$e(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return nt(this,w,!0,"f"),(0,y.asWebviewUri)($e(this,P,"f"),$e(this,D,"f"),m)}get cspSource(){return $e(this,P,"f").webviewCspSource.replace("{{uuid}}",$e(this,D,"f"))}get html(){return this.assertNotDisposed(),$e(this,o,"f")}set html(m){this.assertNotDisposed(),$e(this,o,"f")!==m&&(nt(this,o,m,"f"),!$e(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(nt(this,w,!0,"f"),$e(this,i,"f").report("Webview vscode-resource: uris",$e(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,k,"f").$setHtml($e(this,D,"f"),m))}get options(){return this.assertNotDisposed(),$e(this,d,"f")}set options(m){this.assertNotDisposed(),$e(this,k,"f").$setOptions($e(this,D,"f"),s($e(this,p,"f"),$e(this,h,"f"),m)),nt(this,d,m,"f")}async postMessage(m){if($e(this,E,"f"))return!1;const _=(0,T.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:$e(this,S,"f")});return $e(this,k,"f").$postMessage($e(this,D,"f"),_.message,..._.buffers)}assertNotDisposed(){if($e(this,E,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=c,D=new WeakMap,k=new WeakMap,i=new WeakMap,P=new WeakMap,h=new WeakMap,p=new WeakMap,o=new WeakMap,d=new WeakMap,E=new WeakMap,w=new WeakMap,S=new WeakMap,u=new WeakMap;function f(g){try{const m=(0,I.normalizeVersion)((0,I.parseVersion)(g.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch(m){return!1}}e.shouldSerializeBuffersForPostMessage=f;class t{constructor(m,_,l,v,R){this.initData=_,this.workspace=l,this._logService=v,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=m.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(m,_,...l){const v=this.getWebview(m);if(v){const{message:R}=(0,T.deserializeWebviewMessage)(_,l);v._onMessageEmitter.fire(R)}}$onMissingCsp(m,_){this._logService.warn(`${_} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,_,l){const v=new c(m,this._webviewProxy,r(_),this.initData,this.workspace,l,this._deprecationService);return this._webviews.set(m,v),v._onDidDispose(()=>{this._webviews.delete(m)}),v}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=t;function n(g){return{id:g.identifier,location:g.extensionLocation}}e.toExtensionData=n;function s(g,m,_){return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:_.localResourceRoots||a(g,m)}}e.serializeWebviewOptions=s;function r(g){var m;return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,portMapping:g.portMapping,localResourceRoots:(m=g.localResourceRoots)===null||m===void 0?void 0:m.map(_=>L.URI.from(_))}}e.reviveOptions=r;function a(g,m){return[...((m==null?void 0:m.getWorkspaceFolders())||[]).map(_=>_.uri),g.extensionLocation]}}),define(me[244],ge([0,1,21,75,6,12,25,2,20,67,86,5,7]),function(G,e,b,L,I,T,y,C,D,k,i,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class o{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const a=new p(n,s);return this._documents.set(r,a),a}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var d;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(d||(d={}));class E{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:r}),new h.Disposable(()=>this._providers.delete(n))}}class w{constructor(t,n,s,r,a){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=r,this._extHostWebviewPanels=a,this._editorProviders=new E,this._documents=new o,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,r){const a=new I.DisposableStore;return S(s)?(a.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,r.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&a.add(s.onDidChangeCustomDocument(g=>{const m=this.getCustomDocumentEntry(n,g.document.uri);if(u(g)){const _=m.addEdit(g);this._proxy.$onDidEdit(g.document.uri,n,_,g.label)}else this._proxy.$onContentChange(g.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),h.Disposable.from(a,new h.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,r,a){var g;const m=this._editorProviders.get(n);if(!m)throw new Error(`No provider found for '${n}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${n}'`);const _=C.URI.revive(t),l=await m.provider.openCustomDocument(_,{backupId:s,untitledDocumentData:r==null?void 0:r.buffer},a);let v;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(v=(g=this._extensionStoragePaths.workspaceValue(m.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(n,l,v),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=C.URI.revive(t),{document:a}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,a),a.dispose()}async $resolveWebviewEditor(t,n,s,r,a,g){const m=this._editorProviders.get(s);if(!m)throw new Error(`No provider found for '${s}'`);const _=D.ViewColumn.to(a),l=this._extHostWebview.createNewWebview(n,r.webviewOptions,m.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(n,s,r.title,_,r.panelOptions,l),R=C.URI.revive(t);switch(m.type){case 1:{const{document:O}=this.getCustomDocumentEntry(s,R);return m.provider.resolveCustomEditor(O,v,g)}case 0:{const O=this._extHostDocuments.getDocument(R);return m.provider.resolveCustomTextEditor(O,v,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const g=C.URI.revive(n),m=this._extHostDocuments.getDocument(g);await r.provider.moveCustomTextEditor(m,a,b.CancellationToken.None)}async $undo(t,n,s,r){return this.getCustomDocumentEntry(n,t).undo(s,r)}async $redo(t,n,s,r){return this.getCustomDocumentEntry(n,t).redo(s,r)}async $revert(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,s),r.disposeBackup()}async $onSave(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,s),r.disposeBackup()}async $onSaveAs(t,n,s,r){const a=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(a.document,C.URI.revive(s),r)}async $backup(t,n,s){const r=this.getCustomDocumentEntry(n,t),g=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},s);return r.updateBackup(g),g.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,C.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function S(f){return typeof f.resolveCustomTextEditor=="function"}function u(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function c(f){const t=f.scheme===T.Schemas.file||f.scheme===T.Schemas.untitled?f.fsPath:f.toString();return(0,L.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(G,e,b,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(G,b):I?I.value=b:e.set(G,b),b},$e=this&&this.__classPrivateFieldGet||function(G,e,b,L){if(b==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?L:b==="a"?L.call(G):L?L.value:e.get(G)};define(me[245],ge([0,1,3,6,2,30,20,67,5,7]),function(G,e,b,L,I,T,y,C,D,k){"use strict";var i,P,h,p,o,d,E,w,S,u,c,f,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends L.Disposable{constructor(g,m,_,l,v,R,O){super();i.set(this,void 0),P.set(this,void 0),h.set(this,void 0),p.set(this,void 0),o.set(this,void 0),d.set(this,void 0),E.set(this,void 0),w.set(this,void 0),S.set(this,!0),u.set(this,!0),c.set(this,!1),f.set(this,this._register(new b.Emitter)),this.onDidDispose=$e(this,f,"f").event,t.set(this,this._register(new b.Emitter)),this.onDidChangeViewState=$e(this,t,"f").event,nt(this,i,g,"f"),nt(this,P,m,"f"),nt(this,h,_,"f"),nt(this,o,R,"f"),nt(this,w,v,"f"),nt(this,d,l,"f"),nt(this,p,O,"f")}dispose(){$e(this,c,"f")||(nt(this,c,!0,"f"),$e(this,f,"f").fire(),$e(this,P,"f").$disposeWebview($e(this,i,"f")),$e(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,p,"f")}get viewType(){return this.assertNotDisposed(),$e(this,h,"f")}get title(){return this.assertNotDisposed(),$e(this,d,"f")}set title(g){this.assertNotDisposed(),$e(this,d,"f")!==g&&(nt(this,d,g,"f"),$e(this,P,"f").$setTitle($e(this,i,"f"),g))}get iconPath(){return this.assertNotDisposed(),$e(this,E,"f")}set iconPath(g){this.assertNotDisposed(),$e(this,E,"f")!==g&&(nt(this,E,g,"f"),$e(this,P,"f").$setIconPath($e(this,i,"f"),I.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return $e(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,w,"f")=="number"&&$e(this,w,"f")<0))return $e(this,w,"f")}get active(){return this.assertNotDisposed(),$e(this,u,"f")}get visible(){return this.assertNotDisposed(),$e(this,S,"f")}_updateViewState(g){$e(this,c,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(nt(this,u,g.active,"f"),nt(this,S,g.visible,"f"),nt(this,w,g.viewColumn,"f"),$e(this,t,"f").fire({webviewPanel:this}))}reveal(g,m){this.assertNotDisposed(),$e(this,P,"f").$reveal($e(this,i,"f"),{viewColumn:g?y.ViewColumn.from(g):void 0,preserveFocus:!!m})}assertNotDisposed(){if($e(this,c,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,P=new WeakMap,h=new WeakMap,p=new WeakMap,o=new WeakMap,d=new WeakMap,E=new WeakMap,w=new WeakMap,S=new WeakMap,u=new WeakMap,c=new WeakMap,f=new WeakMap,t=new WeakMap;class s{constructor(g,m,_){this.webviews=m,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(g,m,_,l,v={}){const R=typeof l=="object"?l.viewColumn:l,O={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof l=="object"&&!!l.preserveFocus},H=(0,C.shouldSerializeBuffersForPostMessage)(g),ne=s.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(g),ne,m,{title:_,panelOptions:r(v),webviewOptions:(0,C.serializeWebviewOptions)(g,this.workspace,v),serializeBuffersForPostMessage:H},O);const ie=this.webviews.createNewWebview(ne,v,g);return this.createNewWebviewPanel(ne,m,_,R,v,ie)}$onDidChangeWebviewPanelViewStates(g){const m=Object.keys(g);m.sort((_,l)=>{const v=g[_],R=g[l];return v.active?1:R.active?-1:+v.visible-+R.visible});for(const _ of m){const l=this.getWebviewPanel(_);if(!!l){const v=g[_];l._updateViewState({active:v.active,visible:v.visible,viewColumn:y.ViewColumn.to(v.position)})}}}async $onDidDisposeWebviewPanel(g){const m=this.getWebviewPanel(g);m==null||m.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,m,_){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:_,extension:g}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(g)}),new k.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(g,m,_,l){const v=this._serializers.get(m);if(!v)throw new Error(`No serializer found for '${m}'`);const{serializer:R,extension:O}=v,H=this.webviews.createNewWebview(g,_.webviewOptions,O),ne=this.createNewWebviewPanel(g,m,_.title,l,_.panelOptions,H);await R.deserializeWebviewPanel(ne,_.state)}createNewWebviewPanel(g,m,_,l,v,R){const O=new n(g,this._proxy,m,_,l,v,R);return this._webviewPanels.set(g,O),O}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=s;function r(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(G,e,b,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(G,b):I?I.value=b:e.set(G,b),b},$e=this&&this.__classPrivateFieldGet||function(G,e,b,L){if(b==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?L:b==="a"?L.call(G):L?L.value:e.get(G)};define(me[246],ge([0,1,3,6,67,5,7]),function(G,e,b,L,I,T,y){"use strict";var C,D,k,i,P,h,p,o,d,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends L.Disposable{constructor(c,f,t,n,s,r){super();C.set(this,void 0),D.set(this,void 0),k.set(this,void 0),i.set(this,void 0),P.set(this,!1),h.set(this,void 0),p.set(this,void 0),o.set(this,void 0),d.set(this,this._register(new b.Emitter)),this.onDidChangeVisibility=$e(this,d,"f").event,E.set(this,this._register(new b.Emitter)),this.onDidDispose=$e(this,E,"f").event,nt(this,k,t,"f"),nt(this,p,n,"f"),nt(this,C,c,"f"),nt(this,D,f,"f"),nt(this,i,s,"f"),nt(this,h,r,"f")}dispose(){$e(this,P,"f")||(nt(this,P,!0,"f"),$e(this,E,"f").fire(),$e(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,p,"f")}set title(c){this.assertNotDisposed(),$e(this,p,"f")!==c&&(nt(this,p,c,"f"),$e(this,D,"f").$setWebviewViewTitle($e(this,C,"f"),c))}get description(){return this.assertNotDisposed(),$e(this,o,"f")}set description(c){this.assertNotDisposed(),$e(this,o,"f")!==c&&(nt(this,o,c,"f"),$e(this,D,"f").$setWebviewViewDescription($e(this,C,"f"),c))}get visible(){return $e(this,h,"f")}get webview(){return $e(this,i,"f")}get viewType(){return $e(this,k,"f")}_setVisible(c){c===$e(this,h,"f")||$e(this,P,"f")||(nt(this,h,c,"f"),$e(this,d,"f").fire())}show(c){this.assertNotDisposed(),$e(this,D,"f").$show($e(this,C,"f"),!!c)}assertNotDisposed(){if($e(this,P,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,D=new WeakMap,k=new WeakMap,i=new WeakMap,P=new WeakMap,h=new WeakMap,p=new WeakMap,o=new WeakMap,d=new WeakMap,E=new WeakMap;class S{constructor(c,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,f,t,n){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(c),f,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(c,f,t,n,s){const r=this._viewProviders.get(f);if(!r)throw new Error(`No view provider found for '${f}'`);const{provider:a,extension:g}=r,m=this._extHostWebview.createNewWebview(c,{},g),_=new w(c,this._proxy,f,t,m,!0);this._webviewViews.set(c,_),await a.resolveWebviewView(_,{state:n},s)}async $onDidChangeWebviewViewVisibility(c,f){this.getWebviewView(c)._setVisible(f)}async $disposeWebviewView(c){const f=this.getWebviewView(c);this._webviewViews.delete(c),f.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const f=this._webviewViews.get(c);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=S}),define(me[127],ge([0,1,3,5,2,12,8,4,15]),function(G,e,b,L,I,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Mn{constructor(P){this._onDidChangeWindowState=new b.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Mn.InitialState,this._proxy=P.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(h=>this.$onDidChangeWindowFocus(h))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:P}),this._onDidChangeWindowState.fire(this._state))}openUri(P,h){let p;if(typeof P=="string"){p=P;try{P=I.URI.parse(P)}catch(o){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,y.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,p,h)}async asExternalUri(P,h){if((0,y.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(P.scheme))return Promise.reject(`Invalid scheme '${P.scheme}'`);const p=await this._proxy.$asExternalUri(P,h);return I.URI.from(p)}};k.InitialState={focused:!0},k=qe([We(0,D.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(me[247],ge([0,1,9,102,30,50,6,5,2,15]),function(G,e,b,L,I,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends y.Disposable{constructor(h,p){super();const o=h.getProxy(C.MainContext.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async d=>{const E=D.URI.file((0,b.join)((0,L.tmpdir)(),(0,I.generateUuid)()));return await o.$download(d,E),E})}};i=qe([We(0,k.IExtHostRpcService),We(1,T.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(me[248],ge([0,1,2,9,146,28,37,66,27,15,6,14,113,44]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class o{constructor(S,u,c){this.name=S,this.file=u,this.appender=c}static async create(S,u){const c=await(0,h.createRotatingLogger)(S,u,30*p.ByteSize.MB,1);return c.clearFormatters(),new o(S,u,c)}append(S){this.appender.critical(S),this.flush()}flush(){this.appender.flush()}}class d extends C.AbstractExtHostOutputChannel{constructor(S,u,c){super(S,!1,b.URI.file(u.file),c);this._appender=u}append(S){super.append(S),this._appender.append(S),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(S,u){this._appender.flush(),super.show(S,u)}clear(){this._appender.flush(),super.clear()}}let E=class extends C.ExtHostOutputService{constructor(S,u,c){super(S);this.logService=u,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new i.MutableDisposable,this._logsLocation=c.logsLocation}$setVisibleChannel(S){if(S){const u=this._channels.get(S);u&&(this._visibleChannelDisposable.value=u.onDidAppend(()=>u.update()))}}createOutputChannel(S){if(S=S.trim(),!S)throw new Error("illegal argument `name`. must not be falsy");const u=this._doCreateOutChannel(S);return u.then(c=>c._id.then(f=>this._channels.set(f,c))),new C.LazyOutputChannel(S,u)}async _doCreateOutChannel(S){try{const u=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await T.SymlinkSupport.existsDirectory(u)||await y.promises.mkdir(u,{recursive:!0});const f=`${this._namePool++}-${S.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=b.URI.file((0,L.join)(u,`${f}.log`)),n=await o.create(f,t.fsPath);return new d(S,n,this._proxy)}catch(u){return this.logService.error(u),new C.ExtHostPushOutputChannel(S,this._proxy)}}};E=qe([We(0,k.IExtHostRpcService),We(1,P.ILogService),We(2,D.IExtHostInitDataService)],E),e.ExtHostOutputService2=E}),define(me[249],ge([0,1,11,30,15,33]),function(G,e,b,L,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends T.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,k,i){const P=new T.ExtHostTerminal(this._proxy,(0,L.generateUuid)(),{name:D,shellPath:k,shellArgs:i},D);return this._terminals.push(P),P.create(k,i),P.value}createTerminalFromOptions(D,k){const i=new T.ExtHostTerminal(this._proxy,(0,L.generateUuid)(),D,D.name);return this._terminals.push(i),i.create((0,b.withNullAsUndefined)(D.shellPath),(0,b.withNullAsUndefined)(D.shellArgs),(0,b.withNullAsUndefined)(D.cwd),(0,b.withNullAsUndefined)(D.env),(0,b.withNullAsUndefined)(D.icon),(0,b.withNullAsUndefined)(D.message),void 0,(0,b.withNullAsUndefined)(D.strictEnv),(0,b.withNullAsUndefined)(D.hideFromUser),(0,b.withNullAsUndefined)(k),!0),i.value}};y=qe([We(0,I.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(me[250],ge([0,1,5,15,6,27,2,38,25,37,28,7,10,49,3,74,14]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(m,_,l){this.remoteAddress=m,this.localAddress=_,this._dispose=l,this._onDispose=new o.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function S(g){const m=g.trim().split(`
`),_=[];return m.forEach(v=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(v);R&&R.length>=3&&_.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),_.reduce((v,R)=>(v[R.socket]=R,v),{})}e.getSockets=S;function u(...g){const m=[].concat(...g.map(f));return[...new Map(m.filter(_=>_.st==="0A").map(_=>{const l=_.local_address.split(":");return{socket:parseInt(_.inode,10),ip:c(l[0]),port:parseInt(l[1],16)}}).map(_=>[_.ip+":"+_.port,_])).values()]}e.loadListeningPorts=u;function c(g){let m="";if(g.length===8)for(let _=g.length-2;_>=0;_-=2)m+=parseInt(g.substr(_,2),16),_!==0&&(m+=".");else for(let _=g.length-4;_>=0;_-=4)m+=parseInt(g.substr(_,4),16).toString(16),_!==0&&(m+=":");return m}e.parseIpAddress=c;function f(g){const m=g.trim().split(`
`),_=m.shift().trim().split(/\s+/).filter(v=>v!=="rx_queue"&&v!=="tm->when");return m.map(v=>v.trim().split(/\s+/).reduce((R,O,H)=>(R[_[H]||H]=O,R),{}))}e.loadConnectionTable=f;function t(g){return!!g.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||g.indexOf("out/vs/server/main.js")!==-1||g.indexOf("_productName=VSCode")!==-1}function n(g){const m=g.trim().split(`
`),_=[];return m.forEach(l=>{const v=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(l);v&&v.length>=4&&_.push({pid:parseInt(v[1],10),ppid:parseInt(v[2]),cmd:v[3]})}),_}e.getRootProcesses=n;async function s(g,m,_){const l=_.reduce((R,O)=>(R[O.pid]=O,R),{}),v=[];return g.forEach(({socket:R,ip:O,port:H})=>{var ne;const ie=m[R]?m[R].pid:void 0,N=ie?(ne=l[ie])===null||ne===void 0?void 0:ne.cmd:void 0;ie&&N&&!t(N)&&v.push({host:O,port:H,detail:N,pid:ie})}),v}e.findPorts=s;function r(g,m,_){const l=new Map,v=n(m);for(const R of g){const O=_.get(R.port);if(O){l.set(R.port,O);continue}const H=v.find(ne=>ne.cmd.includes(`${R.port}`));if(H){let ne=H,ie;do ie=v.find(N=>N.ppid===ne.pid),ie&&(ne=ie);while(ie);l.set(R.port,{host:R.ip,port:R.port,pid:ne.pid,detail:ne.cmd,ppid:ne.ppid})}else l.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return l}e.tryFindRootPorts=r;let a=class extends I.Disposable{constructor(m,_,l){super();this.logService=l,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new o.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(b.MainContext.MainThreadTunnelService),h.isLinux&&_.remote.isRemote&&_.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,_){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${_.remoteAddress.host}:${_.remoteAddress.port}.`);const l=await this._proxy.$openTunnel(_,m.displayName);if(l){const v=new w(l.remoteAddress,l.localAddress,()=>this._proxy.$closeTunnel(l.remoteAddress));return this._register(v),v}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,_){const l=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(l,{selector:m,provider:_}),this._proxy.$registerPortsAttributesProvider(m,l),new P.Disposable(()=>{this._portAttributesProviders.delete(l),this._proxy.$unregisterPortsAttributesProvider(l)})}async $providePortAttributes(m,_,l,v,R){const O=[];for(const ne of m){const ie=this._portAttributesProviders.get(ne);if(!ie)return[];O.push(...await Promise.all(_.map(async N=>ie.provider.providePortAttributes(N,l,v,R))))}const H=O.filter(ne=>!!ne);return H.length>0?H.map(ne=>({autoForwardAction:ne.autoForwardAction,port:ne.port})):[]}async $registerCandidateFinder(m){if(!(m&&this._candidateFindingEnabled)){this._candidateFindingEnabled=m;let _=new d.MovingAverage,l;for(;this._candidateFindingEnabled;){const v=new Date().getTime(),R=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(H=>H.port).join(", ")}`);const O=new Date().getTime()-v;_.update(O),(!l||JSON.stringify(l)!==JSON.stringify(R))&&(l=R,await this._proxy.$onFoundNewCandidates(l)),await new Promise(H=>setTimeout(()=>H(),this.calculateDelay(_.value)))}}}async setTunnelExtensionFunctions(m){var _;return m?(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,this._proxy.$setTunnelProvider((_=m.tunnelFeatures)!==null&&_!==void 0?_:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,I.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,_){if(this._extensionTunnels.has(m.host)){const l=this._extensionTunnels.get(m.host);l.has(m.port)&&(_&&l.get(m.port).disposeListener.dispose(),await l.get(m.port).tunnel.dispose(),l.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,_){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const l=this._forwardPortProvider(m,_);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),l!==void 0){const v=await l;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const R=this._register(v.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(v.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:v,disposeListener:R}),p.TunnelDto.fromApiTunnel(v)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(l){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const _=await Promise.all(m.map(v=>{var R;return this._showCandidatePort(v.host,v.port,(R=v.detail)!==null&&R!==void 0?R:"")})),l=m.filter((v,R)=>_[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(v=>v.port).join(", ")} to ${l.map(v=>v.port).join(", ")}`),l}async findCandidatePorts(){let m="",_="";try{m=await k.promises.readFile("/proc/net/tcp","utf8"),_=await k.promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const l=u(m,_),v=await new Promise(U=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(A,x,F)=>{U(x)})}),R=S(v),O=await i.readdir("/proc"),H=[];for(let U of O)try{const A=Number(U),x=D.joinPath(y.URI.file("/proc"),U);if((await k.promises.stat(x.fsPath)).isDirectory()&&!isNaN(A)){const M=await k.promises.readlink(D.joinPath(x,"cwd").fsPath),W=await k.promises.readFile(D.joinPath(x,"cmdline").fsPath,"utf8");H.push({pid:A,cwd:M,cmd:W})}}catch(A){}const ne=[],ie=l.filter(U=>{const A=R[U.socket];return A||ne.push(U),A}),N=s(ie,R,H);let B;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${ne.length}`),ne.length>0){const U=await new Promise(A=>{(0,C.exec)("ps -F -A -l | grep root",(x,F,M)=>{A(F)})});this._foundRootPorts=r(ne,U,this._foundRootPorts),B=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.join(", ")}`)}return N.then(U=>B?U.concat(B):U)}};a=qe([We(0,L.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,E.ILogService)],a),e.ExtHostTunnelService=a}),define(me[251],ge([0,1,13,21,17,3,6,100,220,125,23]),function(G,e,b,L,I,T,y,C,D,k,i){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function h(r,a){try{return JSON.stringify(r,a)}catch(g){return"null"}}function p(r,a){return JSON.stringify(r,a)}function o(r){return r?(a,g)=>g&&g.$mid===1?r.transformOutgoing(g):g:null}var d;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},S=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class c extends y.Disposable{constructor(a,g=null,m=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=g,this._uriTransformer=m,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,l=k.ProxyIdentifier.count;_<l;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new b.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(I.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,C.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:g,sid:m}=a;return this._proxies[g]||(this._proxies[g]=this._createProxy(g,m)),this._proxies[g]}_createProxy(a,g){let m={get:(_,l)=>(typeof l=="string"&&!_[l]&&l.charCodeAt(0)===36&&(_[l]=(...v)=>this._remoteCall(a,l,v)),l===u?g:_[l])};return new Proxy(Object.create(null),m)}set(a,g){return this._locals[a.nid]=g,g}assertRegistered(a){for(let g=0,m=a.length;g<m;g++){const _=a[g];if(!this._locals[_.nid])throw new Error(`Missing actor ${_.sid} (isMain: ${_.isMain})`)}}_receiveOneMessage(a){if(!this._isDisposed){const g=a.byteLength,m=f.read(a,0),_=m.readUInt8(),l=m.readUInt32();switch(_){case 1:case 2:{let{rpcId:v,method:R,args:O}=t.deserializeRequestJSONArgs(m);this._uriTransformer&&(O=(0,C.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(g,l,v,R,O,_===2);break}case 3:case 4:{let{rpcId:v,method:R,args:O}=t.deserializeRequestMixedArgs(m);this._uriTransformer&&(O=(0,C.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(g,l,v,R,O,_===4);break}case 5:{this._logger&&this._logger.logIncoming(g,l,0,"ack"),this._onDidReceiveAcknowledge(l);break}case 6:{this._receiveCancel(g,l);break}case 7:{this._receiveReply(g,l,void 0);break}case 9:{let v=t.deserializeReplyOKJSON(m);this._uriTransformer&&(v=(0,C.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReply(g,l,v);break}case 8:{let v=t.deserializeReplyOKVSBuffer(m);this._receiveReply(g,l,v);break}case 10:{let v=t.deserializeReplyErrError(m);this._uriTransformer&&(v=(0,C.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReplyErr(g,l,v);break}case 11:{this._receiveReplyErr(g,l,void 0);break}default:console.error("received unexpected message"),console.error(a)}}}_receiveRequest(a,g,m,_,l,v){this._logger&&this._logger.logIncoming(a,g,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(m)}.${_}(`,l);const R=String(g);let O,H;if(v){const ie=new L.CancellationTokenSource;l.push(ie.token),O=this._invokeHandler(m,_,l),H=()=>ie.cancel()}else O=this._invokeHandler(m,_,l),H=w;this._cancelInvokedHandlers[R]=H;const ne=t.serializeAcknowledged(g);this._logger&&this._logger.logOutgoing(ne.byteLength,g,1,"ack"),this._protocol.send(ne),O.then(ie=>{delete this._cancelInvokedHandlers[R];const N=t.serializeReplyOK(g,ie,this._uriReplacer);this._logger&&this._logger.logOutgoing(N.byteLength,g,1,"reply:",ie),this._protocol.send(N)},ie=>{delete this._cancelInvokedHandlers[R];const N=t.serializeReplyErr(g,ie);this._logger&&this._logger.logOutgoing(N.byteLength,g,1,"replyErr:",ie),this._protocol.send(N)})}_receiveCancel(a,g){this._logger&&this._logger.logIncoming(a,g,1,"receiveCancel");const m=String(g);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(a,g,m){this._logger&&this._logger.logIncoming(a,g,0,"receiveReply:",m);const _=String(g);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const l=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],l.resolveOk(m)}}_receiveReplyErr(a,g,m){this._logger&&this._logger.logIncoming(a,g,0,"receiveReplyErr:",m);const _=String(g);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const l=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let v;m&&(m.$isError?(v=new Error,v.name=m.name,v.message=m.message,v.stack=m.stack):v=m),l.resolveErr(v)}}_invokeHandler(a,g,m){try{return Promise.resolve(this._doInvokeHandler(a,g,m))}catch(_){return Promise.reject(_)}}_doInvokeHandler(a,g,m){const _=this._locals[a];if(!_)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(a));let l=_[g];if(typeof l!="function")throw new Error("Unknown method "+g+" on actor "+(0,k.getStringIdentifierForProxy)(a));return l.apply(_,m)}_remoteCall(a,g,m){if(this._isDisposed)return Promise.reject(I.canceled());let _=null;if(m.length>0&&L.CancellationToken.isCancellationToken(m[m.length-1])&&(_=m.pop()),_&&_.isCancellationRequested)return Promise.reject(I.canceled());const l=t.serializeRequestArguments(m,this._uriReplacer),v=++this._lastMessageId,R=String(v),O=new D.LazyPromise;_&&_.onCancellationRequested(()=>{const ne=t.serializeCancel(v);this._logger&&this._logger.logOutgoing(ne.byteLength,v,0,"cancel"),this._protocol.send(t.serializeCancel(v))}),this._pendingRPCReplies[R]=O,this._onWillSendRequest(v);const H=t.serializeRequest(v,a,g,l,!!_);return this._logger&&this._logger.logOutgoing(H.byteLength,v,0,`request: ${(0,k.getStringIdentifierForProxy)(a)}.${g}(`,m),this._protocol.send(H),O}}e.RPCProtocol=c,P=S,c.UNRESPONSIVE_TIME=3*1e3;class f{constructor(a,g){this._buff=a,this._offset=g}static alloc(a,g,m){let _=new f(i.VSBuffer.alloc(m+1+4),0);return _.writeUInt8(a),_.writeUInt32(g),_}static read(a,g){return new f(a,g)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,m}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,m}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,g}static sizeMixedArray(a,g){let m=0;m+=1;for(let _=0,l=a.length;_<l;_++){const v=a[_],R=g[_];switch(m+=1,R){case 1:m+=this.sizeLongString(v);break;case 2:m+=this.sizeVSBuffer(v);break;case 3:break}}return m}writeMixedArray(a,g){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let m=0,_=a.length;m<_;m++){const l=a[m];switch(g[m]){case 1:this.writeUInt8(1),this.writeLongString(l);break;case 2:this.writeUInt8(2),this.writeVSBuffer(l);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let g=new Array(a);for(let m=0;m<a;m++)switch(this.readUInt8()){case 1:g[m]=this.readLongString();break;case 2:g[m]=this.readVSBuffer();break;case 3:g[m]=void 0;break}return g}}class t{static _arrayContainsBufferOrUndefined(a){for(let g=0,m=a.length;g<m;g++)if(a[g]instanceof i.VSBuffer||typeof a[g]=="undefined")return!0;return!1}static serializeRequestArguments(a,g){if(this._arrayContainsBufferOrUndefined(a)){let m=[],_=[];for(let l=0,v=a.length;l<v;l++){const R=a[l];R instanceof i.VSBuffer?(m[l]=R,_[l]=2):typeof R=="undefined"?(m[l]=i.VSBuffer.alloc(0),_[l]=3):(m[l]=i.VSBuffer.fromString(p(R,g)),_[l]=1)}return{type:"mixed",args:m,argsType:_}}return{type:"simple",args:p(a,g)}}static serializeRequest(a,g,m,_,l){return _.type==="mixed"?this._requestMixedArgs(a,g,m,_.args,_.argsType,l):this._requestJSONArgs(a,g,m,_.args,l)}static _requestJSONArgs(a,g,m,_,l){const v=i.VSBuffer.fromString(m),R=i.VSBuffer.fromString(_);let O=0;O+=f.sizeUInt8(),O+=f.sizeShortString(v),O+=f.sizeLongString(R);let H=f.alloc(l?2:1,a,O);return H.writeUInt8(g),H.writeShortString(v),H.writeLongString(R),H.buffer}static deserializeRequestJSONArgs(a){const g=a.readUInt8(),m=a.readShortString(),_=a.readLongString();return{rpcId:g,method:m,args:JSON.parse(_)}}static _requestMixedArgs(a,g,m,_,l,v){const R=i.VSBuffer.fromString(m);let O=0;O+=f.sizeUInt8(),O+=f.sizeShortString(R),O+=f.sizeMixedArray(_,l);let H=f.alloc(v?4:3,a,O);return H.writeUInt8(g),H.writeShortString(R),H.writeMixedArray(_,l),H.buffer}static deserializeRequestMixedArgs(a){const g=a.readUInt8(),m=a.readShortString(),_=a.readMixedArray(),l=new Array(_.length);for(let v=0,R=_.length;v<R;v++){const O=_[v];typeof O=="string"?l[v]=JSON.parse(O):l[v]=O}return{rpcId:g,method:m,args:l}}static serializeAcknowledged(a){return f.alloc(5,a,0).buffer}static serializeCancel(a){return f.alloc(6,a,0).buffer}static serializeReplyOK(a,g,m){return typeof g=="undefined"?this._serializeReplyOKEmpty(a):g instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(a,g):this._serializeReplyOKJSON(a,h(g,m))}static _serializeReplyOKEmpty(a){return f.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,g){let m=0;m+=f.sizeVSBuffer(g);let _=f.alloc(8,a,m);return _.writeVSBuffer(g),_.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,g){const m=i.VSBuffer.fromString(g);let _=0;_+=f.sizeLongString(m);let l=f.alloc(9,a,_);return l.writeLongString(m),l.buffer}static deserializeReplyOKJSON(a){const g=a.readLongString();return JSON.parse(g)}static serializeReplyErr(a,g){return g?this._serializeReplyErrEror(a,g):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,g){const m=i.VSBuffer.fromString(h(I.transformErrorForSerialization(g),null));let _=0;_+=f.sizeLongString(m);let l=f.alloc(10,a,_);return l.writeLongString(m),l.buffer}static deserializeReplyErrError(a){const g=a.readLongString();return JSON.parse(g)}static _serializeReplyErrEmpty(a){return f.alloc(11,a,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(s||(s={}))}),define(me[252],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(me[253],ge([0,1,12,9,10,2,4,252]),function(G,e,b,L,I,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(i,P){this.localUserHome=i,this.remoteAgentService=P,this.resolveOS=(async()=>{const h=await this.remoteAgentService.getEnvironment();return(h==null?void 0:h.os)||I.OS})(),this.resolveUserHome=(async()=>{const h=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(h==null?void 0:h.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?L.win32:L.posix)}async fileURI(i){let P="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const p=i.indexOf("/",2);p===-1?(P=i.substring(2),i="/"):(P=i.substring(2,p),i=i.substring(p)||"/")}return T.URI.from({scheme:b.Schemas.file,authority:P,path:i,query:"",fragment:""})}};D=qe([We(1,C.IRemoteAgentService)],D),e.AbstractPathService=D}),define(me[68],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class b{constructor(y,C){this.line=y,this.character=C}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,C){return new b(0,0)}with(y){return new b(0,0)}}e.Position=b;class L{constructor(y,C,D,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(y,C),this.end=new b(D,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new L(0,0,0,0)}with(y){return new L(0,0,0,0)}}e.Range=L;var I;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,16,32,24,29,8,4,9,17,68]),function(G,e,b,L,I,T,y,C,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",h=" characters skipped \u27EB",p=(P.length+h.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var o;(function(A){A[A.file=0]="file",A[A.text=1]="text"})(o=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(A){A[A.File=1]="File",A[A.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function E(A){return!!A.preview}e.resultIsMatch=E;function w(A){return!!A.resource}e.isFileMatch=w;function S(A){return!!A.message}e.isProgressMessage=S;var u;(function(A){A[A.Normal=0]="Normal",A[A.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class c{constructor(x){this.resource=x,this.results=[]}}e.FileMatch=c;class f{constructor(x,F,M){this.ranges=F;const W=Array.isArray(F)?F:[F];if(M&&M.matchLines===1&&t(W)){x=(0,y.getNLines)(x,M.matchLines);let z="",Y=0,le=0;const ve=Math.floor(M.charsPerLine/5),Te=[];for(const ye of W){const Oe=Math.max(ye.startColumn-ve,0),j=ye.startColumn+M.charsPerLine;if(Oe>le+ve+p){const Q=P+(Oe-le)+h;z+=Q+x.slice(Oe,j),Y+=Oe-(le+Q.length)}else z+=x.slice(le,j);Te.push(new s(0,ye.startColumn-Y,ye.endColumn-Y)),le=j}this.preview={text:z,matches:Array.isArray(this.ranges)?Te:Te[0]}}else{const z=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:x,matches:(0,b.mapArrayOrNot)(F,Y=>new n(Y.startLineNumber-z,Y.startColumn,Y.endLineNumber-z,Y.endColumn))}}}}e.TextSearchMatch=f;function t(A){const x=A[0].startLineNumber;for(const F of A)if(F.startLineNumber!==x||F.endLineNumber!==x)return!1;return!0}class n{constructor(x,F,M,W){this.startLineNumber=x,this.startColumn=F,this.endLineNumber=M,this.endColumn=W}}e.SearchRange=n;class s extends n{constructor(x,F,M){super(x,F,x,M)}}e.OneLineRange=s;var r;(function(A){A.Default="default",A.FileNames="fileNames",A.Type="type",A.Modified="modified",A.CountDescending="countDescending",A.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function a(A,x=!0){const F=A&&A.files&&A.files.exclude,M=x&&A&&A.search&&A.search.exclude;if(!(!F&&!M)){if(!F||!M)return F||M;let W=Object.create(null);return W=I.mixin(W,I.deepClone(F)),W=I.mixin(W,I.deepClone(M),!0),W}}e.getExcludes=a;function g(A,x){return A.excludePattern&&L.match(A.excludePattern,x)?!1:A.includePattern||A.usingSearchPaths?A.includePattern&&L.match(A.includePattern,x)?!0:A.usingSearchPaths?!!A.folderQueries&&A.folderQueries.some(F=>{const M=F.folder.fsPath;if(T.isEqualOrParent(x,M)){const W=D.relative(M,x);return!F.includePattern||!!L.match(F.includePattern,W)}else return!1}):!1:!0}e.pathIncludedInQuery=g;var m;(function(A){A[A.unknownEncoding=1]="unknownEncoding",A[A.regexParseError=2]="regexParseError",A[A.globParseError=3]="globParseError",A[A.invalidLiteral=4]="invalidLiteral",A[A.rgProcessError=5]="rgProcessError",A[A.other=6]="other",A[A.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(x,F){super(x);this.code=F}}e.SearchError=_;function l(A){const x=A.message;if((0,k.isPromiseCanceledError)(A))return new _(x,m.canceled);try{const F=JSON.parse(x);return new _(F.message,F.code)}catch(F){return new _(x,m.other)}}e.deserializeSearchError=l;function v(A){const x={message:A.message,code:A.code};return new Error(JSON.stringify(x))}e.serializeSearchError=v;function R(A){return A.type==="error"?!0:A.type==="success"}e.isSerializedSearchComplete=R;function O(A){return A.type==="success"}e.isSerializedSearchSuccess=O;function H(A){return!!A.path}e.isSerializedFileMatch=H;function ne(A,x){const F=A.searchPath?A.searchPath:A.relativePath;return(0,y.fuzzyContains)(F,x)}e.isFilePatternMatch=ne;class ie{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ie;function N(A,x){const F=Object.assign(Object.assign({},A||{}),x||{});return Object.keys(F).filter(M=>{const W=F[M];return typeof W=="boolean"&&W})}e.resolvePatternsForProvider=N;class B{constructor(x,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},x.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=L.parse(this._excludeExpression);let M=x.includePattern;F.includePattern&&(M?M=Object.assign(Object.assign({},M),F.includePattern):M=F.includePattern),M&&(this._parsedIncludeExpression=L.parse(M))}includedInQuerySync(x,F,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(x,F,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(x,F,M))}includedInQuery(x,F,M){return Promise.resolve(this._parsedExcludeExpression(x,F,M)).then(z=>!!z).then(z=>z?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(x,F,M)).then(Y=>!!Y):Promise.resolve(!0)).then(z=>z)}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=B;function U(A){for(const x in A)if(typeof A[x]!="boolean")return!0;return!1}}),define(me[34],ge([0,1,16,13,21,3,22,12,74,25,8,11,2,165,4,14,184,61,62,27,15,7,31,5]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E,w,S,u,c,f,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(R,O,H){return new k.ExtUri(ne=>m(ne,H)).isEqual(R,O)}function r(R,O,H){return s(R.uri,O.uri,H)?0:(0,i.compare)(R.uri.toString(),O.uri.toString())}function a(R,O,H){return R.index!==O.index?R.index<O.index?-1:1:s(R.uri,O.uri,H)?(0,i.compare)(R.name,O.name):(0,i.compare)(R.uri.toString(),O.uri.toString())}function g(R,O,H,ne){const ie=R.slice(0).sort((B,U)=>H(B,U,ne)),N=O.slice(0).sort((B,U)=>H(B,U,ne));return(0,b.delta)(ie,N,(B,U)=>H(B,U,ne))}function m(R,O){const H=O.getCapabilities(R.scheme);return!(H&&H&1024)}class _ extends w.Workspace{constructor(O,H,ne,ie,N,B){super(O,ne.map(U=>new w.WorkspaceFolder(U)),ie,B);this._name=H,this._isUntitled=N,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(B),ne.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(O,H,ne,ie){if(!O)return{workspace:null,added:[],removed:[]};const{id:N,name:B,folders:U,configuration:A,isUntitled:x}=O,F=[],M=H;H?U.forEach((le,ve)=>{const Te=h.URI.revive(le.uri),ye=_._findFolder(ne||H,Te,ie);ye?(ye.name=le.name,ye.index=le.index,F.push(ye)):F.push({uri:Te,name:le.name,index:ve})}):F.push(...U.map(({uri:le,name:ve,index:Te})=>({uri:h.URI.revive(le),name:ve,index:Te}))),F.sort((le,ve)=>le.index<ve.index?-1:1);const W=new _(N,B,F,A?h.URI.revive(A):null,!!x,le=>m(le,ie)),{added:z,removed:Y}=g(M?M.workspaceFolders:[],W.workspaceFolders,r,ie);return{workspace:W,added:z,removed:Y}}static _findFolder(O,H,ne){for(let ie=0;ie<O.folders.length;ie++){const N=O.workspaceFolders[ie];if(s(N.uri,H,ne))return N}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,H){return H&&this._structure.get(O)&&(O=(0,k.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let l=class{constructor(O,H,ne,ie){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ie,this._extHostFileSystemInfo=ne,this._requestIdProvider=new D.Counter,this._barrier=new L.Barrier,this._proxy=O.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(n.MainContext.MainThreadMessageService);const N=H.workspace;this._confirmedWorkspace=N?new _(N.id,N.name,[],N.configuration?h.URI.revive(N.configuration):null,!!N.isUntitled,B=>m(B,ne)):void 0}$initializeWorkspace(O,H){this._trusted=H,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?h.URI.from({scheme:C.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,H,ne,...ie){const N=[];if(Array.isArray(ie)&&ie.forEach(F=>{h.URI.isUri(F.uri)&&!N.some(M=>s(M.uri,F.uri,this._extHostFileSystemInfo))&&N.push({uri:F.uri,name:F.name||(0,k.basenameOrAuthority)(F.uri)})}),this._unconfirmedWorkspace||[H,ne].some(F=>typeof F!="number"||F<0)||ne===0&&N.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(H+ne>B.length)return!1;const U=B.slice(0);U.splice(H,ne,...N.map(F=>({uri:F.uri,name:F.name||(0,k.basenameOrAuthority)(F.uri),index:void 0})));for(let F=0;F<U.length;F++){const M=U[F];if(U.some((W,z)=>z!==F&&s(M.uri,W.uri,this._extHostFileSystemInfo)))return!1}U.forEach((F,M)=>F.index=M);const{added:A,removed:x}=g(B,U,a,this._extHostFileSystemInfo);if(A.length===0&&x.length===0)return!1;if(this._proxy){const F=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(F,H,ne,N).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,p.localize)(0,null,F,M.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(O,H){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,H)}async getWorkspaceFolder2(O,H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,H)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!!this._actualWorkspace){const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}}getRelativePath(O,H){let ne,ie="";if(typeof O=="string"?(ne=h.URI.file(O),ie=O):typeof O!="undefined"&&(ne=O,ie=O.fsPath),!ne)return ie;const N=this.getWorkspaceFolder(ne,!0);if(!N)return ie;typeof H=="undefined"&&this._actualWorkspace&&(H=this._actualWorkspace.folders.length>1);let B=(0,k.relativePath)(N.uri,ne);return H&&N.name&&(B=`${N.name}/${B}`),B}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:H,added:ne,removed:ie}=_.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=H||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ne,removed:ie}))}findFiles(O,H,ne,ie,N=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ie.value}, entryPoint: findFiles`);let B;if(H===null?B=!1:H&&(typeof H=="string"?B=H:B=H.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:A}=v(O);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(U),(0,P.withUndefinedAsNull)(A),(0,P.withUndefinedAsNull)(B),(0,P.withUndefinedAsNull)(ne),N).then(x=>Array.isArray(x)?x.map(F=>h.URI.revive(F)):[])}async findTextInFiles(O,H,ne,ie,N=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ie.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),U=typeof H.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:A,folder:x}=v(H.include),F=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,M={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:U,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:A,excludePattern:F},W=!1;if(this._activeSearchCallbacks[B]=z=>{if(!W){const Y=h.URI.revive(z.resource);z.results.forEach(le=>{(0,t.resultIsMatch)(le)?ne({uri:Y,preview:{text:le.preview.text,matches:(0,b.mapArrayOrNot)(le.preview.matches,ve=>new f.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,b.mapArrayOrNot)(le.ranges,ve=>new f.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):ne({uri:Y,text:le.text,lineNumber:le.lineNumber})})}},N.isCancellationRequested)return{};try{const z=await this._proxy.$startTextSearch(O,(0,P.withUndefinedAsNull)(x),M,B,N);return delete this._activeSearchCallbacks[B],z||{}}catch(z){throw delete this._activeSearchCallbacks[B],z}}$handleTextSearchResult(O,H){this._activeSearchCallbacks[H]&&this._activeSearchCallbacks[H](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};l=qe([We(0,c.IExtHostRpcService),We(1,u.IExtHostInitDataService),We(2,S.IExtHostFileSystemInfo),We(3,d.ILogService)],l),e.ExtHostWorkspace=l,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function v(R){let O,H;return R&&(typeof R=="string"?O=R:(O=R.pattern,H=R.baseFolder||h.URI.file(R.base))),{includePattern:O,folder:H}}}),define(me[35],ge([0,1,24,3,34,5,7,186,83,11,13,4,15,14,2]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(n,s){if(s){const r=s.split(".");let a=n;for(let g=0;a&&g<r.length;g++)a=a[r[g]];return a}}function E(n){return n instanceof o.URI}function w(n){return n&&n.uri instanceof o.URI&&n.languageId&&typeof n.languageId=="string"}function S(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function u(n){return n&&n.uri instanceof o.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function c(n){if(E(n))return{resource:n};if(w(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(S(n))return{overrideIdentifier:n.languageId};if(u(n))return{resource:n.uri};if(n===null)return{resource:null}}let f=class{constructor(s,r,a){this._proxy=s.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=a,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,r){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(s,r))}};f=qe([We(0,h.IExtHostRpcService),We(1,I.IExtHostWorkspace),We(2,p.ILogService)],f),e.ExtHostConfiguration=f;class t{constructor(s,r,a,g){this._onDidChangeConfiguration=new L.Emitter,this._proxy=s,this._logService=g,this._extHostWorkspace=r,this._configuration=C.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,r){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,a))}getConfiguration(s,r,a){const g=c(r)||{},m=this._toReadonlyValue(s?d(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,g,a==null?void 0:a.identifier);function _(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const l={has(v){return typeof d(m,v)!="undefined"},get:(v,R)=>{this._validateConfigurationAccess(s?`${s}.${v}`:v,g,a==null?void 0:a.identifier);let O=d(m,v);if(typeof O=="undefined")O=R;else{let H;const ne=(ie,N)=>{let B;const U=()=>{H=H||(0,b.deepClone)(m),B=B||d(H,N)};return(0,k.isObject)(ie)?new Proxy(ie,{get:(A,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return U(),()=>B;if(H)return B=B||d(H,N),B[x];const F=A[x];return typeof x=="string"?ne(F,`${N}.${x}`):F},set:(A,x,F)=>(U(),B&&(B[x]=F),!0),deleteProperty:(A,x)=>(U(),B&&delete B[x],!0),defineProperty:(A,x,F)=>(U(),B&&Object.defineProperty(B,x,F),!0)}):ie};O=ne(O,v)}return O},update:(v,R,O,H)=>{v=s?`${s}.${v}`:v;const ne=_(O);return R!==void 0?this._proxy.$updateConfigurationOption(ne,v,R,g,H):this._proxy.$removeConfigurationOption(ne,v,g,H)},inspect:v=>{var R,O,H,ne,ie,N,B,U;v=s?`${s}.${v}`:v;const A=(0,b.deepClone)(this._configuration.inspect(v,g,this._extHostWorkspace.workspace));if(A)return{key:v,defaultValue:(R=A.default)===null||R===void 0?void 0:R.value,globalValue:(O=A.user)===null||O===void 0?void 0:O.value,workspaceValue:(H=A.workspace)===null||H===void 0?void 0:H.value,workspaceFolderValue:(ne=A.workspaceFolder)===null||ne===void 0?void 0:ne.value,defaultLanguageValue:(ie=A.default)===null||ie===void 0?void 0:ie.override,globalLanguageValue:(N=A.user)===null||N===void 0?void 0:N.override,workspaceLanguageValue:(B=A.workspace)===null||B===void 0?void 0:B.override,workspaceFolderLanguageValue:(U=A.workspaceFolder)===null||U===void 0?void 0:U.override,languageIds:A.overrideIdentifiers}}};return typeof m=="object"&&(0,b.mixin)(l,m,!1),Object.freeze(l)}_toReadonlyValue(s){const r=a=>(0,k.isObject)(a)?new Proxy(a,{get:(g,m)=>r(g[m]),set:(g,m,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(g,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(g,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return r(s)}_validateConfigurationAccess(s,r,a){const g=D.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),m=a?`[${a.value}] `:"";if(g===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){(r==null?void 0:r.resource)&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,r){const a=new C.ConfigurationChangeEvent(s,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,m)=>a.affectsConfiguration(g,c(m))})}_toMap(s){return s.reduce((r,a)=>(r.set(a[0],a[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(G,e,b,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(G,b):I?I.value=b:e.set(G,b),b},$e=this&&this.__classPrivateFieldGet||function(G,e,b,L){if(b==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?L:b==="a"?L.call(G):L?L.value:e.get(G)};define(me[69],ge([0,1,2,13,3,5,7,34,41,35,21,33,15,27,4,12,10,14,65,204,17]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E,w,S,u,c){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(ie){function N(U){if(U!=null)return U}ie.from=N;function B(U){if(U!=null)return U}ie.to=B})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(ie){function N(U){if(U!=null)return U}ie.from=N;function B(U){if(U!=null)return U}ie.to=B})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(ie){function N(U){if(U!=null)return U}ie.from=N;function B(U){if(U!=null)return U}ie.to=B})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(ie){function N(A){if(A){const x=A;return x&&!!x.process}else return!1}ie.is=N;function B(A){if(A!=null){const x={process:A.process,args:A.args};return A.options&&(x.options=s.from(A.options)),x}}ie.from=B;function U(A){if(A!=null)return new y.ProcessExecution(A.process,A.args,A.options)}ie.to=U})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(ie){function N(U){if(U!=null)return U}ie.from=N;function B(U){if(U!=null)return U}ie.to=B})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var g;(function(ie){function N(A){if(A){const x=A;return x&&(!!x.commandLine||!!x.command)}else return!1}ie.is=N;function B(A){if(A!=null){const x={};return A.commandLine!==void 0?x.commandLine=A.commandLine:(x.command=A.command,x.args=A.args),A.options&&(x.options=a.from(A.options)),x}}ie.from=B;function U(A){if(!(A==null||A.command===void 0&&A.commandLine===void 0))return A.commandLine?new y.ShellExecution(A.commandLine,A.options):new y.ShellExecution(A.command,A.args?A.args:[],A.options)}ie.to=U})(g=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(ie){function N(A){if(A){let x=A;return x&&x.customExecution==="customExecution"}else return!1}ie.is=N;function B(A){return{customExecution:"customExecution"}}ie.from=B;function U(A,x){return x.get(A)}ie.to=U})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(ie){function N(B,U){let A;return B.scope!==void 0&&typeof B.scope!="number"?A=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===y.TaskScope.Workspace&&U&&U.workspaceFile?A=U.workspaceFile:A=u.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:A}}ie.from=N})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var l;(function(ie){function N(A,x){if(A==null)return[];const F=[];for(let M of A){const W=B(M,x);W&&F.push(W)}return F}ie.fromMany=N;function B(A,x){if(A!=null){let F;A.execution instanceof y.ProcessExecution?F=r.from(A.execution):A.execution instanceof y.ShellExecution?F=g.from(A.execution):A.execution&&A.execution instanceof y.CustomExecution&&(F=m.from(A.execution));const M=t.from(A.definition);let W;if(A.scope?typeof A.scope=="number"?W=A.scope:W=A.scope.uri:W=y.TaskScope.Workspace,!(!M||!W)){const z=A.group?A.group.id:void 0;return{_id:A._id,definition:M,name:A.name,source:{extensionId:x.identifier.value,label:A.source,scope:W},execution:F,isBackground:A.isBackground,group:z,presentationOptions:n.from(A.presentationOptions),problemMatchers:A.problemMatchers,hasDefinedMatchers:A.hasDefinedMatchers,runOptions:A.runOptions?A.runOptions:{reevaluateOnRerun:!0},detail:A.detail}}}}ie.from=B;async function U(A,x,F){if(A!=null){let M;r.is(A.execution)?M=r.to(A.execution):g.is(A.execution)?M=g.to(A.execution):m.is(A.execution)&&(M=m.to(A._id,F));const W=t.to(A.definition);let z;if(A.source&&(A.source.scope!==void 0?typeof A.source.scope=="number"?z=A.source.scope:z=await x.resolveWorkspaceFolder(b.URI.revive(A.source.scope)):z=y.TaskScope.Workspace),!(!W||!z)){const Y=new y.Task(W,z,A.name,A.source.label,M,A.problemMatchers);return A.isBackground!==void 0&&(Y.isBackground=A.isBackground),A.group!==void 0&&(Y.group=y.TaskGroup.from(A.group)),A.presentationOptions&&(Y.presentationOptions=n.to(A.presentationOptions)),A._id&&(Y._id=A._id),A.detail&&(Y.detail=A.detail),Y}}}ie.to=U})(l=e.TaskDTO||(e.TaskDTO={}));var v;(function(ie){function N(U){return U}ie.from=N;function B(U){if(!!U)return Object.assign(Object.create(null),U)}ie.to=B})(v=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(N,B,U){this._id=B,this._task=U,f.set(this,void 0),nt(this,f,N,"f")}get task(){return this._task}terminate(){$e(this,f,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}f=new WeakMap;var O;(function(ie){function N(B){return{id:B._id,task:void 0}}ie.from=N})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let H=class{constructor(N,B,U,A,x,F,M,W){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=N.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=A,this._configurationService=x,this._terminalService=F,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=W,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,B,U){if(!U)return new y.Disposable(()=>{});const A=this.nextHandle();return this._handlers.set(A,{type:B,provider:U,extension:N}),this._proxy.$registerTaskProvider(A,B),new y.Disposable(()=>{this._handlers.delete(A),this._proxy.$unregisterTaskProvider(A)})}registerTaskSystem(N,B){this._proxy.$registerTaskSystem(N,B)}fetchTasks(N){return this._proxy.$fetchTasks(v.from(N)).then(async B=>{const U=[];for(let A of B){const x=await l.to(A,this._workspaceProvider,this._providedCustomExecutions2);x&&U.push(x)}return U})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(B=>N.push(B)),N}terminateTask(N){if(!(N instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,B,U){const A=this._providedCustomExecutions2.get(N.id);if(A){if(this._activeCustomExecutions2.get(N.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(N.id,A),this._terminalService.attachPtyToTerminal(B,await A.callback(U))}this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const B=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const B=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:B,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const B=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:N.exitCode})}$provideTasks(N,B){const U=this._handlers.get(N);if(!U)return Promise.reject(new Error("no handler found"));const A=[],x=(0,L.asPromise)(()=>U.provider.provideTasks(i.CancellationToken.None)).then(F=>this.provideTasksInternal(B,A,U,F));return new Promise(F=>{x.then(M=>{Promise.all(A).then(()=>{F(M)})})})}async $resolveTask(N,B){const U=this._handlers.get(N);if(!U)return Promise.reject(new Error("no handler found"));if(B.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${U.type}].`);const A=await l.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!A)throw new Error("Unexpected: Task cannot be resolved.");const x=await U.provider.resolveTask(A,i.CancellationToken.None);if(!!x){this.checkDeprecation(x,U);const F=l.from(x,U.extension);if(!F)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==A.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(F.execution)&&await this.addCustomExecution(F,x,!0),await this.resolveTaskInternal(F)}}nextHandle(){return this._handleCounter++}async addCustomExecution(N,B,U){const A=await this._proxy.$createTaskId(N);!U&&!this._providedCustomExecutions2.has(A)&&this._notProvidedCustomExecutions.add(A),this._providedCustomExecutions2.set(A,B.execution)}async getTaskExecution(N,B){if(typeof N=="string"){const x=this._taskExecutionPromises.get(N);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}let U=this._taskExecutionPromises.get(N.id);if(U)return U;const A=new Promise(async(x,F)=>{const M=B||await l.to(N.task,this._workspaceProvider,this._providedCustomExecutions2);M?x(new R(this,N.id,M)):F("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(N.id,A),A.then(x=>(this._taskExecutions.set(N.id,x),x),x=>Promise.reject(x))}checkDeprecation(N,B){N._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let U=this._notProvidedCustomExecutions.values(),A=U.next();for(;!A.done;)!this._activeCustomExecutions2.has(A.value)&&this._lastStartedTask!==A.value&&(this._providedCustomExecutions2.delete(A.value),this._notProvidedCustomExecutions.delete(A.value)),A=U.next()}};H=qe([We(0,h.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,C.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,w.ILogService),We(7,S.IExtHostApiDeprecationService)],H),e.ExtHostTaskBase=H;let ne=class extends H{constructor(N,B,U,A,x,F,M,W){super(N,B,U,A,x,F,M,W);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(N,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const U=l.from(B,N);if(U===void 0)throw new Error("Task is not valid");if(m.is(U.execution))await this.addCustomExecution(U,B,!1);else throw new c.NotSupportedError;const A=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),B);return this._proxy.$executeTask(U).catch(x=>{throw new Error(x)}),A}provideTasksInternal(N,B,U,A){const x=[];if(A)for(let F of A){this.checkDeprecation(F,U),(!F.definition||!N[F.definition.type])&&this._logService.warn(`The task [${F.source}, ${F.name}] uses an undefined task type. The task will be ignored in the future.`);const M=l.from(F,U.extension);M&&m.is(M.execution)?(x.push(M),B.push(this.addCustomExecution(M,F,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:U.extension}}async resolveTaskInternal(N){if(m.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,B,U){}};ne=qe([We(0,h.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,C.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,w.ILogService),We(7,S.IExtHostApiDeprecationService)],ne),e.WorkerExtHostTask=ne,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")});var nt=this&&this.__classPrivateFieldSet||function(G,e,b,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(G,b):I?I.value=b:e.set(G,b),b},$e=this&&this.__classPrivateFieldGet||function(G,e,b,L){if(b==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?L:b==="a"?L.call(G):L?L.value:e.get(G)},Gt=this&&this.__rest||function(G,e){var b={};for(var L in G)Object.prototype.hasOwnProperty.call(G,L)&&e.indexOf(L)<0&&(b[L]=G[L]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var I=0,L=Object.getOwnPropertySymbols(G);I<L.length;I++)e.indexOf(L[I])<0&&Object.prototype.propertyIsEnumerable.call(G,L[I])&&(b[L[I]]=G[L[I]]);return b};define(me[254],ge([0,1,16,13,23,21,3,72,55,6,24,11,2,30,5,41,15,87,20,7,34,215,123]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E,w,S,u,c,f,t){"use strict";var n,s,r,a;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const g=(U,A)=>`${U}:${A.toString()}`;let m=class{constructor(A,x,F){this.documents=x,this.workspace=F,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new f.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(o.MainContext.MainThreadTesting),this.runQueue=new _(this.proxy),this.workspaceObservers=new N(this.proxy),this.textDocumentObservers=new B(this.proxy,x)}registerTestController(A,x){const F=(0,p.generateUuid)();this.controllers.set(F,{instance:x,extensionId:A}),this.proxy.$registerTestController(F);const M=[...this.testControllers.keys()];return setTimeout(()=>{var W;for(const z of M)(W=this.testControllers.get(z))===null||W===void 0||W.subscribeFn(F,x)},0),new u.Disposable(()=>{this.controllers.delete(F),this.proxy.$unregisterTestController(F)})}createTextDocumentTestObserver(A){return this.textDocumentObservers.checkout(A.uri)}createWorkspaceTestObserver(A){return this.workspaceObservers.checkout(A.uri)}async runTests(A,x=T.CancellationToken.None){const F=M=>M.map(this.getInternalTestForReference,this).filter(P.isDefined).map(W=>({src:W.src,testId:W.item.extId}));await this.proxy.$runTests({exclude:A.exclude?F(A.exclude).map(M=>M.testId):void 0,tests:F(A.tests),debug:A.debug},x)}createTestRun(A,x,F,M=!0){return this.runQueue.createTestRun(A,x,F,M)}$publishTestResults(A){this.results=Object.freeze(A.map(x=>(0,i.deepFreeze)(S.TestResults.to(x))).concat(this.results).sort((x,F)=>F.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(A,x){const F=h.URI.revive(x),M=g(A,F);if(!this.testControllers.has(M)){const W=new T.CancellationTokenSource;let z;if(A===1){let ye=this.documents.getDocument(F);if(!ye){const Oe=new k.DisposableStore;ye=await new Promise(j=>{Oe.add((0,L.disposableTimeout)(()=>j(void 0),5e3)),Oe.add(this.documents.onDidAddDocuments(Q=>{const Z=Q.find(se=>se.document.uri.toString()===F.toString());Z&&j(Z)}))}).finally(()=>Oe.dispose())}if(ye){const Oe=await this.workspace.getWorkspaceFolder2(F,!1);z=j=>j.createDocumentTestRoot?j.createDocumentTestRoot(ye.document,W.token):(0,e.createDefaultDocumentTestRoot)(j,ye.document,Oe,W.token)}}else{const ye=await this.workspace.getWorkspaceFolder2(F,!1);ye&&(z=Oe=>Oe.createWorkspaceTestRoot(ye,W.token))}if(!!z){const Y=async(ye,Oe)=>{try{const j=await z(Oe);j&&ve.addRoot(j,ye)}catch(j){console.error(j)}},le=new k.DisposableStore,ve=le.add(this.ownedTests.createForHierarchy(ye=>this.proxy.$publishDiff(A,x,ye)));le.add((0,k.toDisposable)(()=>W.dispose(!0)));const Te=[];for(const[ye,Oe]of this.controllers)Te.push(Y(ye,Oe.instance));Promise.all(Te).then(()=>ve.pushDiff([3,-1])),this.testControllers.set(M,{store:le,collection:ve,subscribeFn:Y})}}}async $expandTest(A,x){const F=(0,b.mapFind)(this.testControllers.values(),M=>M.collection.treeId===A.src.tree?M:void 0);await(F==null?void 0:F.collection.expand(A.testId,x<0?Infinity:x)),this.flushCollectionDiffs()}$unsubscribeFromTests(A,x){var F;const M=h.URI.revive(x),W=g(A,M);(F=this.testControllers.get(W))===null||F===void 0||F.store.dispose(),this.testControllers.delete(W)}$acceptDiff(A,x,F){A===1?this.textDocumentObservers.acceptDiff(h.URI.revive(x),F):this.workspaceObservers.acceptDiff(h.URI.revive(x),F)}async $runTestsForProvider(A,x){const F=this.controllers.get(A.tests[0].src.controller);if(!!F){const M=A.tests.map(({testId:Y,src:le})=>this.ownedTests.getTestById(Y,le==null?void 0:le.tree)).filter(P.isDefined).map(([Y,le])=>le),W=A.excludeExtIds.map(Y=>this.ownedTests.getTestById(Y)).filter(P.isDefined).filter(([Y,le])=>M.some(ve=>Y.comparePositions(ve,le)===1));if(!!M.length){const z={tests:M.map(Y=>O.unwrap(Y.actual)),exclude:W.map(([,Y])=>O.unwrap(Y.actual)),debug:A.debug};await this.runQueue.enqueueRun({dto:l.fromInternal(A),token:x,extensionId:F.extensionId,req:z,doRun:()=>F.instance.runTests(z,x)})}}}$lookupTest(A){const x=this.ownedTests.getTestById(A.testId);if(!x)return Promise.resolve(void 0);const F=x[1],{actual:M,discoverCts:W,expandLevels:z}=F,Y=Gt(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(Y)}flushCollectionDiffs(){for(const{collection:A}of this.testControllers.values())A.flushDiff()}getInternalTestForReference(A){var x,F;return(F=(x=this.workspaceObservers.getMirroredTestDataByReference(A))!==null&&x!==void 0?x:(0,b.mapFind)(this.testControllers.values(),M=>M.collection.getTestByReference(A)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(A)}};m=qe([We(0,E.IExtHostRpcService),We(1,d.IExtHostDocumentsAndEditors),We(2,c.IExtHostWorkspace)],m),e.ExtHostTesting=m;class _{constructor(A){this.proxy=A,this.state=new Map}enqueueRun(A){let x=this.state.get(A.extensionId);x||(x={queue:[],current:void 0},this.state.set(A.extensionId,x));const F=new L.DeferredPromise,M=()=>{const W=[],z=new Set;x.current={publicReq:A.req,factory:Y=>{const le=new v(Y,A.dto,z,this.proxy);return W.push(le),A.token.onCancellationRequested(()=>le.end()),le}},this.invokeRunner(A.extensionId,A.dto.id,A.doRun,W).finally(()=>F.complete())};return x.queue.push(M),x.queue.length===1&&M(),F.p}createTestRun(A,x,F,M){var W,z;const Y=this.state.get(A);if((Y==null?void 0:Y.current.publicReq)===x)return Y.current.factory(F);const le=l.fromPublic(x),ve=new v(F,le,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:x.debug,exclude:(z=(W=x.exclude)===null||W===void 0?void 0:W.map(Te=>Te.id))!==null&&z!==void 0?z:[],id:le.id,tests:x.tests.map(Te=>Te.id),persist:M}),ve.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(le.id)),ve}invokeRunner(A,x,F,M){try{const W=F();return(0,L.isThenable)(W)?W.then(()=>this.handleInvokeResult(A,x,M,void 0)).catch(z=>this.handleInvokeResult(A,x,M,z)):this.handleInvokeResult(A,x,M,void 0)}catch(W){return this.handleInvokeResult(A,x,M,W)}}async handleInvokeResult(A,x,F,M){const W=this.state.get(A);!W||(W.queue.shift(),W.queue.length>0?W.queue[0]():this.state.delete(A),await Promise.all(F.map(z=>z.onEnd.wait())))}}class l{constructor(A,x,F){this.id=A,this.include=x,this.exclude=F}static fromPublic(A){var x,F;return new l((0,p.generateUuid)(),new Set(A.tests.map(M=>M.id)),new Set((F=(x=A.exclude)===null||x===void 0?void 0:x.map(M=>M.id))!==null&&F!==void 0?F:D.Iterable.empty()))}static fromInternal(A){return new l(A.runId,new Set(A.tests.map(x=>x.testId)),new Set(A.excludeExtIds))}isIncluded(A){for(let x=A;x;x=x.parent){if(this.include.has(x.id))return!0;if(this.exclude.has(x.id))return!1}return!0}}class v{constructor(A,x,F,M){this.name=A,n.set(this,void 0),s.set(this,void 0),r.set(this,(0,p.generateUuid)()),a.set(this,void 0),this.onEnd=new L.Barrier,nt(this,n,M,"f"),nt(this,s,x,"f"),nt(this,a,F,"f"),M.$startedTestRunTask(x.id,{id:$e(this,r,"f"),name:A,running:!0})}setState(A,x,F){$e(this,s,"f").isIncluded(A)&&(this.ensureTestIsKnown(A),$e(this,n,"f").$updateTestStateInRun($e(this,s,"f").id,$e(this,r,"f"),A.id,x,F))}appendMessage(A,x){$e(this,s,"f").isIncluded(A)&&(this.ensureTestIsKnown(A),$e(this,n,"f").$appendTestMessageInRun($e(this,s,"f").id,$e(this,r,"f"),A.id,S.TestMessage.from(x)))}appendOutput(A){$e(this,n,"f").$appendOutputToRun($e(this,s,"f").id,$e(this,r,"f"),I.VSBuffer.fromString(A))}end(){$e(this,n,"f").$finishedTestRunTask($e(this,s,"f").id,$e(this,r,"f")),this.onEnd.open()}ensureTestIsKnown(A){const x=$e(this,a,"f");if(!x.has(A.id)){const F=[];for(;F.unshift(S.TestItem.from(A)),!(x.has(A.id)||(x.add(A.id),!A.parent));)A=A.parent;$e(this,n,"f").$addTestsToRun($e(this,s,"f").id,F)}}}n=new WeakMap,s=new WeakMap,r=new WeakMap,a=new WeakMap;const R=async(U,A,x,F)=>{if(!!x){const M=await U.createWorkspaceTestRoot(x,F);if(!!M){F.onCancellationRequested(()=>{O.removeFilter(A)});const W=O.getWrapperForTestItem(M,A);return W.refreshMatch(),W}}};e.createDefaultDocumentTestRoot=R;class O extends u.TestItemImpl{constructor(A,x,F){super(A.id,A.label,A.uri,void 0);if(this.actual=A,this.filterDocument=x,this.actualParent=F,!(A instanceof u.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${A.id} did not`);this.debuggable=A.debuggable,this.runnable=A.runnable,this.description=A.description,this.error=A.error,this.status=A.status,this.range=A.range,this.resolveHandler=A.resolveHandler;const M=(0,w.getPrivateApiFor)(this);(0,w.getPrivateApiFor)(A).bus.event(z=>{switch(z[0]){case 3:this[z[1]]=z[2];break;case 0:const Y=O.getWrapperForTestItem(z[1],this.filterDocument,this);(0,w.getPrivateApiFor)(Y).parent=A,Y.refreshMatch();break;default:M.bus.fire(z)}})}static removeFilter(A){this.wrapperMap.delete(A)}static getWrapperForTestItem(A,x,F){let M=this.wrapperMap.get(x);if(M==null?void 0:M.has(A))return M.get(A);M||(M=new WeakMap,this.wrapperMap.set(x,M));const W=new O(A,x,F);return M.set(A,W),W}static unwrap(A){return A instanceof O?A.actual:A}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var A,x;const F=this._cachedMatchesFilter;for(const W of this.actual.children.values()){const z=O.getWrapperForTestItem(W,this.filterDocument,this);z.hasNodeMatchingFilter?this.children.has(z.id)||this.addChild(z):z.dispose()}const M=this.children.size>0||((A=this.actual.uri)===null||A===void 0?void 0:A.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==F&&((x=this.actualParent)===null||x===void 0||x.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,w.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,w.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=O,O.wrapperMap=new WeakMap;class H extends t.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,S.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:x,removed:F}=this;return{get added(){return[...A].map(M=>M.revived)},get updated(){return[...x].map(M=>M.revived)},get removed(){return[...F].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ne extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(A){let x=[];for(const F of A){const M=this.items.get(F);M&&x.push(M.revived)}return x}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,x){return Object.assign(Object.assign({},A),{revived:S.TestItem.toPlain(A.item),depth:x?x.depth+1:0,children:new Set})}createChangeCollector(){return new H(this.changeEmitter)}}e.MirroredTestCollection=ne;class ie{constructor(){this.resources=new Map}checkout(A){var x,F;const M=A.toString(),W=(x=this.resources.get(M))!==null&&x!==void 0?x:this.createObserverData(A);return(F=W.pendingDeletion)===null||F===void 0||F.dispose(),W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return W.tests.rootTestItems},dispose:(0,C.once)(()=>{--W.observers||(W.pendingDeletion=this.eventuallyDispose(A))})}}getMirroredTestDataByReference(A){for(const{tests:x}of this.resources.values()){const F=x.getMirroredTestDataByReference(A);if(F)return F}}eventuallyDispose(A){return(0,L.disposableTimeout)(()=>this.unlisten(A),10*1e3)}createObserverData(A){const x=new ne,F=this.listen(A,W=>x.apply(W)),M={observers:0,tests:x,listener:F};return this.resources.set(A.toString(),M),M}unlisten(A){var x;const F=A.toString(),M=this.resources.get(F);M&&(M.observers=-1,(x=M.pendingDeletion)===null||x===void 0||x.dispose(),M.listener.dispose(),this.resources.delete(F))}}class N extends ie{constructor(A){super();this.proxy=A,this.diffListeners=new Map}acceptDiff(A,x){var F;(F=this.diffListeners.get(A.toString()))===null||F===void 0||F(x)}listen(A,x){this.proxy.$subscribeToDiffs(0,A);const F=A.toString();return this.diffListeners.set(F,x),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,A),this.diffListeners.delete(F)})}}class B extends ie{constructor(A,x){super();this.proxy=A,this.documents=x,this.diffListeners=new Map}acceptDiff(A,x){var F;(F=this.diffListeners.get(A.toString()))===null||F===void 0||F(x)}listen(A,x){if(!this.documents.getDocument(A))return new u.Disposable(()=>{});const M=A.toString();return this.diffListeners.set(M,x),this.proxy.$subscribeToDiffs(1,A),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,A),this.diffListeners.delete(M)})}}}),define(me[255],ge([0,1,16,53,32,77,22,12,9,25,8,11,2,140,170,84,61,207,253,31]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E,w,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(_,l,v,R){this.configurationService=_,this.workspaceContextService=l,this.editorGroupsService=v,this.pathService=R}text(_,l,v={}){_=this.getContentPattern(_,v);const R=this.configurationService.getValue(),O=l&&l.some(ne=>!this.configurationService.getValue({resource:ne}).search.useRipgrep),H=this.commonQuery(l==null?void 0:l.map(E.toWorkspaceFolder),v);return Object.assign(Object.assign({},H),{type:2,contentPattern:_,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:R.search.usePCRE2||O||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles})}getContentPattern(_,l){const v=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},_),{wordSeparators:v.editor.wordSeparators});return this.isCaseSensitive(_,l)&&(R.isCaseSensitive=!0),this.isMultiline(_)&&(R.isMultiline=!0),R}file(_,l={}){const v=this.commonQuery(_,l);return Object.assign(Object.assign({},v),{type:1,filePattern:l.filePattern?l.filePattern.trim():l.filePattern,exists:l.exists,sortByScore:l.sortByScore,cacheKey:l.cacheKey})}handleIncludeExclude(_,l){return _?(_=Array.isArray(_)?_.map(r):r(_),l?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],l={}){const v=this.handleIncludeExclude(l.includePattern,l.expandPatterns),R=this.handleIncludeExclude(l.excludePattern,l.expandPatterns),O=_.length>1,H=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,l,R)):_.map(N=>this.getFolderQueryForRoot(N,l,R,O))).filter(N=>!!N),ne={_reason:l._reason,folderQueries:H,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:l.extraFileResources,excludePattern:R.pattern,includePattern:v.pattern,onlyOpenEditors:l.onlyOpenEditors,maxResults:l.maxResults};if(l.onlyOpenEditors){const B=b.coalesce(b.flatten(this.editorGroupsService.groups.map(A=>A.editors.map(x=>x.resource)))).filter(A=>(0,u.pathIncludedInQuery)(ne,A.fsPath)),U=this.commonQueryFromFileList(B);return Object.assign(Object.assign({},ne),U)}const ie=l.extraFileResources&&l.extraFileResources.filter(N=>(0,u.pathIncludedInQuery)(ne,N.fsPath));return ne.extraFileResources=ie&&ie.length?ie:void 0,ne}commonQueryFromFileList(_){const l=[],v=new y.ResourceMap,R={};let O=!1;return _.forEach(H=>{var ne,ie;if(H.scheme!==C.Schemas.walkThrough)if((0,k.isAbsolutePath)(H)){const B=(ie=(ne=this.workspaceContextService.getWorkspaceFolder(H))===null||ne===void 0?void 0:ne.uri)!==null&&ie!==void 0?ie:H.with({path:D.dirname(H.fsPath)});let U=v.get(B);U||(O=!0,U={folder:B,includePattern:{}},l.push(U),v.set(B,U));const A=D.relative(B.fsPath,H.fsPath);(0,P.assertIsDefined)(U.includePattern)[A.replace(/\\/g,"/")]=!0}else H.fsPath&&(O=!0,R[H.fsPath]=!0)}),{folderQueries:l,includePattern:R,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(_,l){if(l.isSmartCase){if(_.isRegExp){if(i.containsUppercaseCharacter(_.pattern,!0))return!0}else if(i.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,p.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const l=U=>D.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),R=(Array.isArray(_)?_:n(_)).map(U=>{const A=this.pathService.resolvedUserHome;return A?(0,T.untildify)(U,A.scheme===C.Schemas.file?A.fsPath:A.path):U}),O=L.groupBy(R,U=>l(U)?"searchPaths":"exprSegments"),H=(O.exprSegments||[]).map(U=>i.rtrim(U,"/")).map(U=>i.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),s(U))),ne={},ie=this.expandSearchPathPatterns(O.searchPaths||[]);ie&&ie.length&&(ne.searchPaths=ie);const N=b.flatten(H),B=t(...N);return B&&(ne.pattern=B),ne}getExcludesForFolder(_,l){return l.disregardExcludeSettings?void 0:(0,u.getExcludes)(_,!l.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const l=b.flatten(_.map(R=>{let{pathPortion:O,globPortion:H}=f(R);H&&(H=a(H));const ne=this.expandOneSearchPath(O);return b.flatten(ne.map(ie=>this.resolveOneSearchPathPattern(ie,H)))})),v=new Map;return l.forEach(R=>{const O=R.searchPath.toString(),H=v.get(O);H?R.pattern&&(H.pattern=H.pattern||{},H.pattern[R.pattern]=!0):v.set(O,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(_){if(D.isAbsolute(_)){const l=this.workspaceContextService.getWorkspace().folders;return l[0]&&l[0].uri.scheme!==C.Schemas.file?[{searchPath:l[0].uri.with({path:_})}]:[{searchPath:h.URI.file(D.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const l=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=r(_),_.startsWith("../")||_===".."){const R=D.posix.resolve(l.path,_);return[{searchPath:l.with({path:R})}]}const v=a(_);return[{searchPath:l,pattern:v}]}else{if(_==="./"||_===".\\")return[];{const l=_.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(O=>{const H=l.match(new RegExp(`^${O.name}(?:/(.*))?`));return H?{match:H,folder:O}:null}).filter(P.isDefined);if(R.length)return R.map(O=>{const H=O.match[1];return{searchPath:O.folder.uri,pattern:H&&a(H)}});{const O=_.match(/\.[\/\\](.+)[\/\\]?/),H=O?O[1]:_,ne=o.localize(0,null,H);throw new Error(ne)}}}}resolveOneSearchPathPattern(_,l){const v=_.pattern&&l?`${_.pattern}/${l}`:_.pattern||l,R=[{searchPath:_.searchPath,pattern:v}];return v&&!v.endsWith("**")&&R.push({searchPath:_.searchPath,pattern:v+"/**"}),R}getFolderQueryForSearchPath(_,l,v){const R=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(_.searchPath),l,v,!1);return R?Object.assign(Object.assign({},R),{includePattern:_.pattern}):null}getFolderQueryForRoot(_,l,v,R){let O;const H=h.URI.isUri(_)?_:_.uri;if(v.searchPaths){const U=v.searchPaths.filter(A=>(0,k.isEqual)(A.searchPath,H))[0];if(U&&!U.pattern)return null;U&&(O=U.pattern)}const ne=this.configurationService.getValue({resource:H}),ie=this.getExcludesForFolder(ne,l),N=Object.assign(Object.assign({},ie||{}),O||{}),B=h.URI.isUri(_)?(0,k.basename)(_):_.name;return{folder:H,folderName:R?B:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:ne.files&&ne.files.encoding,disregardIgnoreFiles:typeof l.disregardIgnoreFiles=="boolean"?l.disregardIgnoreFiles:!ne.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof l.disregardGlobalIgnoreFiles=="boolean"?l.disregardGlobalIgnoreFiles:!ne.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof l.ignoreSymlinks=="boolean"?l.ignoreSymlinks:!ne.search.followSymlinks}}};c=qe([We(0,d.IConfigurationService),We(1,E.IWorkspaceContextService),We(2,w.IEditorGroupsService),We(3,S.IPathService)],c),e.QueryBuilder=c;function f(m){const _=m.match(/[\*\{\}\(\)\[\]\?]/);if(_){const l=_.index,v=m.substr(0,l).match(/[/|\\][^/\\]*$/);if(v){let R=m.substr(0,v.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:m.substr((v.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((_,l)=>(_[l]=!0,_),Object.create(null)):void 0}function n(m){return I.splitGlobAware(m,",").map(_=>_.trim()).filter(_=>!!_.length)}function s(m){return[`**/${m}/**`,`**/${m}`].map(l=>l.replace(/\*\*\/\*\*/g,"**"))}function r(m){return m.replace(/\\/g,"/")}function a(m){return r(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(m,_){m=b.distinct(m,R=>R.toString());const l=[],v=_.getWorkspace();return m&&m.forEach(R=>{let O;if(_.getWorkbenchState()===2)O=(0,k.relativePath)(v.folders[0].uri,R),O&&O!=="."&&(O="./"+O);else{const H=_.getWorkspaceFolder(R);if(H){const ne=H.name;if(v.folders.filter(N=>N.name===ne).length===1){const N=(0,k.relativePath)(H.uri,R);N===""?O=`./${H.name}`:O=`./${H.name}/${N}`}else O=R.fsPath}}O&&l.push(O)}),l}e.resolveResourcesForSearchIncludes=g}),define(me[256],ge([0,1,25,2,21,17,4,255,31,61]),function(G,e,b,L,I,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function P(d,E){const w=E.activationEvents;if(!w)return Promise.resolve(void 0);const S=[],u=[];for(const r of w)if(/^workspaceContains:/.test(r)){const a=r.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||d.forceUsingSearch?u.push(a):S.push(a)}if(S.length===0&&u.length===0)return Promise.resolve(void 0);let c;const f=new Promise((r,a)=>{c=r}),t=r=>c({activationEvent:r}),n=Promise.all(S.map(r=>h(d,r,t))).then(()=>{}),s=p(d,E.identifier,u,t);return Promise.all([n,s]).then(()=>{c(void 0)}),f}e.checkActivateWorkspaceContainsExtension=P;async function h(d,E,w){for(const S of d.folders)if(await d.exists(b.joinPath(L.URI.revive(S),E))){w(`workspaceContains:${E}`);return}}async function p(d,E,w,S){if(w.length===0)return Promise.resolve(void 0);const u=new I.CancellationTokenSource,c=d.checkExists(d.folders,w,u.token),f=setTimeout(async()=>{u.cancel(),S(`workspaceContainsTimeout:${w.join(",")}`)},i);let t=!1;try{t=await c}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}u.dispose(),clearTimeout(f),t&&S(`workspaceContains:${w.join(",")}`)}function o(d,E,w,S){const u=d.get(y.IInstantiationService),c=d.get(D.ISearchService),t=u.createInstance(C.QueryBuilder).file(E.map(n=>(0,k.toWorkspaceFolder)(L.URI.revive(n))),{_reason:"checkExists",includePattern:w,exists:!0});return c.fileSearch(t,S).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=o});var nt=this&&this.__classPrivateFieldSet||function(G,e,b,L,I){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?I.call(G,b):I?I.value=b:e.set(G,b),b},$e=this&&this.__classPrivateFieldGet||function(G,e,b,L){if(b==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?L:b==="a"?L.call(G):L?L.value:e.get(G)};define(me[42],ge([0,1,160,9,70,25,13,6,22,2,14,5,35,218,91,34,40,216,17,26,23,193,7,85,4,27,92,15,82,49,33,3,256,89,194]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E,w,S,u,c,f,t,n,s,r,a,g,m,_,l,v,R,O,H){"use strict";var ne,ie,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let B=class On extends C.Disposable{constructor(F,M,W,z,Y,le,ve,Te,ye,Oe){super();this._onDidChangeRemoteConnectionData=this._register(new v.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=W,this._initData=ve,this._extHostWorkspace=z,this._extHostConfiguration=Y,this._logService=le,this._extHostTunnelService=ye,this._extHostTerminalService=Oe,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=F.createChild(new m.ServiceCollection([o.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const j=new Set;this._initData.hostExtensions.forEach(Q=>j.add(u.ExtensionIdentifier.toKey(Q))),this._activator=new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Q,Z,se)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Q,S.transformErrorForSerialization(Z),se)},actualActivateExtension:async(Q,Z)=>{if(j.has(u.ExtensionIdentifier.toKey(Q)))return await this._mainThreadExtensionsProxy.$activateExtension(Q,Z),new p.HostExtension;const se=this._registry.getExtensionDescription(Q);return this._activateExtension(se,Z)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){S.onUnexpectedError(F)}}async deactivateAll(){let F=[];try{F=this._registry.getAllExtensionDescriptions().map(Y=>Y.identifier).filter(Y=>this.isActivated(Y)).map(Y=>this._deactivate(Y))}catch(M){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,M){return this._activator.activateByEvent(F,M)}_activateById(F,M){return this._activator.activateById(F,M)}activateByIdWithErrors(F,M){return this._activateById(F,M).then(()=>{const W=this._activator.getActivatedExtension(F);if(W.activationFailed)return Promise.reject(W.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=D.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(W=>{if(!!this._getEntryPoint(W))return this._hostUtils.realpath(W.extensionLocation.fsPath).then(z=>F.set(k.URI.file(z).fsPath,W))});this._extensionPathIndex=Promise.all(M).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return M;const W=this._activator.getActivatedExtension(F);if(!W)return M;try{typeof W.module.deactivate=="function"&&(M=Promise.resolve(W.module.deactivate()).then(void 0,z=>(this._logService.error(z),Promise.resolve(void 0))))}catch(z){this._logService.error(z)}try{(0,C.dispose)(W.subscriptions)}catch(z){this._logService.error(z)}return M}async _activateExtension(F,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,M).then(W=>{const z=W.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,z.codeLoadingTime,z.activateCallTime,z.activateResolvedTime,M),this._logExtensionActivationTimes(F,M,"success",z),W},W=>{throw this._logExtensionActivationTimes(F,M,"failure"),W})}_logExtensionActivationTimes(F,M,W,z){const Y=U(F,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},Y),z||{}),{outcome:W}))}_doActivateExtension(F,M){const W=U(F,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",W);const z=this._getEntryPoint(F);if(!z)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const Y=new p.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(F.identifier,(0,T.joinPath)(F.extensionLocation,z),Y),this._loadExtensionContext(F)]).then(le=>(I.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),On._callActivate(this._logService,F.identifier,le[0],le[1],Y))).then(le=>(I.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),le))}_loadExtensionContext(F){const M=new f.ExtensionGlobalMemento(F,this._storage),W=new f.ExtensionMemento(F.identifier.value,!1,this._storage),z=new H.ExtensionSecrets(F,this._secretState),Y=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([M.whenReady,W.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Te;return Object.freeze({globalState:M,workspaceState:W,secrets:z,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(ye){return L.join(F.extensionLocation.fsPath,ye)},get storagePath(){var ye;return(ye=ve._storagePath.workspaceValue(F))===null||ye===void 0?void 0:ye.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(F).fsPath},get logPath(){return L.join(ve._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return k.URI.joinPath(ve._initData.logsLocation,F.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(F)},get globalStorageUri(){return ve._storagePath.globalValue(F)},get extensionMode(){return Y},get extension(){return Te===void 0&&(Te=new A(ve,F.identifier,F,le)),Te},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(F),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,M,W,z,Y){return W=W||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,M,W,z,Y).then(le=>new p.ActivatedExtension(!1,null,Y.build(),W,le,z.subscriptions))}static _callActivateOptional(F,M,W,z,Y){if(typeof W.activate=="function")try{Y.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${M.value}`);const le=typeof global=="object"?global:self,ve=W.activate.apply(le,[z]);return Y.activateCallStop(),Y.activateResolveStart(),Promise.resolve(ve).then(Te=>(Y.activateResolveStop(),Te))}catch(le){return Promise.reject(le)}else return Promise.resolve(W)}_activateOneStartupFinished(F,M){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:M}).then(void 0,W=>{this._logService.error(W)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const M of F.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(F,M)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,Y=>{this._logService.error(Y)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Y=>this._handleWorkspaceContainsEagerExtensions(Y.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],W=this._handleWorkspaceContainsEagerExtensions(M),z=Promise.all([F,W]).then(()=>{});return Promise.race([z,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),z}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(F,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,M){if(!this.isActivated(M.identifier)){const W=!this._initData.remote.isRemote&&!!this._initData.remote.authority,z={folders:F.map(le=>le.uri),forceUsingSearch:W,exists:le=>this._hostUtils.exists(le.fsPath),checkExists:(le,ve,Te)=>this._mainThreadWorkspaceProxy.$checkExists(le,ve,Te)},Y=await(0,R.checkActivateWorkspaceContainsExtension)(z,M);if(!!Y)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:Y.activationEvent}).then(void 0,le=>this._logService.error(le))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:M}=this._initData.environment;if(!F||!M)throw new Error(b.localize(0,null));const W=await this._loadCommonJSModule(null,M,new p.ExtensionActivationTimesBuilder(!1));if(!W||typeof W.run!="function")throw new Error(b.localize(1,null,M.toString()));return new Promise((z,Y)=>{const le=(ye,Oe)=>{ye?Y(ye):z(typeof Oe=="number"&&Oe>0?1:0)},ve=(0,T.originalFSPath)(M),Te=W.run(ve,le);Te&&Te.then&&Te.then(()=>{z(0)}).catch(ye=>{Y(ye.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,M){return this._resolvers[F]=M,(0,C.toDisposable)(()=>{delete this._resolvers[F]})}async $resolveAuthority(F,M){const W=F.indexOf("+");if(W===-1)throw new Error("Not an authority that can be resolved!");const z=F.substr(0,W);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${z}`,!1);const Y=this._resolvers[z];if(!Y)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${z}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(Y)),I.mark(`code/extHost/willResolveAuthority/${z}`);const le=await Y.resolve(F,{resolveAttempt:M});I.mark(`code/extHost/didResolveAuthorityOK/${z}`);const ve={authority:F,host:le.host,port:le.port,connectionToken:le.connectionToken},Te={extensionHostEnv:le.extensionHostEnv,trust:le.trust};return{type:"ok",value:{authority:ve,options:Te,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(I.mark(`code/extHost/didResolveAuthorityError/${z}`),le instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,M){return M===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then(W=>this._activateByEvent(F,!1))}async $activate(F,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,M),!0):!1}async $deltaExtensions(F,M){F.forEach(z=>z.extensionLocation=k.URI.revive(z.extensionLocation));const W=await this.getExtensionPathIndex();return await Promise.all(M.map(async z=>{const Y=this._registry.getExtensionDescription(z);if(!!Y){const le=await this._hostUtils.realpath(Y.extensionLocation.fsPath);W.delete(k.URI.file(le).fsPath)}})),await Promise.all(F.map(async z=>{const Y=await this._hostUtils.realpath(z.extensionLocation.fsPath);W.set(k.URI.file(Y).fsPath,z)})),this._registry.deltaExtensions(F,M),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let M=c.VSBuffer.alloc(F),W=Math.random()%256;for(let z=0;z<F;z++)M.writeUInt8(W,z);return M}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};B=qe([We(0,s.IInstantiationService),We(1,e.IHostUtils),We(2,g.IExtHostRpcService),We(3,d.IExtHostWorkspace),We(4,h.IExtHostConfiguration),We(5,i.ILogService),We(6,r.IExtHostInitDataService),We(7,a.IExtensionStoragePaths),We(8,_.IExtHostTunnelService),We(9,l.IExtHostTerminalService)],B),e.AbstractExtHostExtensionService=B;function U(x,F){return{id:x.identifier.value,name:x.name,extensionVersion:x.version,publisherDisplayName:x.publisher,activationEvents:x.activationEvents?x.activationEvents.join(","):null,isBuiltin:x.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class A{constructor(F,M,W,z){ne.set(this,void 0),ie.set(this,void 0),N.set(this,void 0),nt(this,ne,F,"f"),nt(this,ie,M,"f"),nt(this,N,W.identifier,"f"),this.id=W.identifier.value,this.extensionUri=W.extensionLocation,this.extensionPath=L.normalize((0,T.originalFSPath)(W.extensionLocation)),this.packageJSON=W,this.extensionKind=z}get isActive(){return $e(this,ne,"f").isActivated($e(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return $e(this,ne,"f").getExtensionExports($e(this,N,"f"))}activate(){return $e(this,ne,"f").activateByIdWithErrors($e(this,N,"f"),{startup:!1,extensionId:$e(this,ie,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=A,ne=new WeakMap,ie=new WeakMap,N=new WeakMap}),define(me[51],ge([0,1,9,2,3,13,5,7,121,34,42,41,206,35,201,15,4,11,36,48]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E,w,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let c=class{constructor(m,_,l,v,R,O){this._workspaceService=_,this._extensionService=l,this._editorsService=v,this._configurationService=R,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=m.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(H=>{H.onDidChange(ne=>{this.registerAllDebugTypes(H)}),this.registerAllDebugTypes(H)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,_){const l=m;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let v=`debug:${encodeURIComponent(l.path||"")}`,R="?";return _&&(v+=`${R}session=${encodeURIComponent(_.id)}`,R="&"),v+=`${R}ref=${l.sourceReference}`,L.URI.parse(v)}else{if(l.path)return L.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const _=[];for(const l of m.getAllExtensionDescriptions())if(l.contributes){const v=l.contributes.debuggers;if(v&&v.length>0)for(const R of v)(0,o.isDebuggerMainContribution)(R)&&_.push(R.type)}this._debugServiceProxy.$registerDebugTypes(_)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(_=>m.push(_)),m}addBreakpoints(m){this.startBreakpoints();const _=m.filter(R=>{const O=R.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,R),!0)});this.fireBreakpointChanges(_,[],[]);const l=[],v=new Map;for(const R of _)if(R instanceof C.SourceBreakpoint){let O=v.get(R.location.uri.toString());O||(O={type:"sourceMulti",uri:R.location.uri,lines:[]},v.set(R.location.uri.toString(),O),l.push(O)),O.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof C.FunctionBreakpoint&&l.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(l)}removeBreakpoints(m){this.startBreakpoints();const _=m.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],_,[]);const l=_.filter(O=>O instanceof C.SourceBreakpoint).map(O=>O.id),v=_.filter(O=>O instanceof C.FunctionBreakpoint).map(O=>O.id),R=_.filter(O=>O instanceof C.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(l,v,R)}startDebugging(m,_,l){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,_,{parentSessionID:l.parentSession?l.parentSession.id:void 0,repl:l.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,_,l){if(!_)return new C.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:v,provider:_}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,l,!!_.provideDebugConfigurations,!!_.resolveDebugConfiguration,!!_.resolveDebugConfigurationWithSubstitutedVariables,v),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==_),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(m,_,l){if(!l)return new C.Disposable(()=>{});if(!this.definesDebugType(m,_))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${_}' debugger.`);if(this.getAdapterDescriptorFactoryByType(_))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:_,handle:v,factory:l}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(_,v),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==l),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(m,_){if(!_)return new C.Disposable(()=>{});const l=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:l,factory:_}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==_)})}async $runInTerminal(m,_){return Promise.resolve(void 0)}async $substituteVariables(m,_){if(!this._variableResolver){const[R,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,O)}let l;const v=await this.getFolder(m);return v&&(l={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(l,_)}createDebugAdapter(m,_){if(m.type==="implementation")return new r(m.implementation)}createSignService(){}async $startDASession(m,_){const l=this,v=await this.getSession(_);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const O=this.convertToDto(R),H=this.createDebugAdapter(O,v);if(!H)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const ne=H;return this._debugAdapters.set(m,ne),this.getDebugAdapterTrackers(v).then(ie=>(ie&&this._debugAdaptersTrackers.set(m,ie),ne.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const B=N,U={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const A=await this._signService.sign(B.arguments.value);U.body={signature:A},ne.sendResponse(U)}else throw new Error("no signer")}catch(A){U.success=!1,U.message=A.message,ne.sendResponse(U)}}else ie&&ie.onDidSendMessage&&ie.onDidSendMessage(N),N=(0,o.convertToVSCPaths)(N,!0),l._debugServiceProxy.$acceptDAMessage(m,N)}),ne.onError(N=>{ie&&ie.onError&&ie.onError(N),this._debugServiceProxy.$acceptDAError(m,N.name,N.message,N.stack)}),ne.onExit(N=>{ie&&ie.onExit&&ie.onExit((0,w.withNullAsUndefined)(N),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,w.withNullAsUndefined)(N),void 0)}),ie&&ie.onWillStartSession&&ie.onWillStartSession(),ne.startSession()))})}$sendDAMessage(m,_){_=(0,o.convertToDAPaths)(_,!1);const l=this._debugAdaptersTrackers.get(m);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(_);const v=this._debugAdapters.get(m);v&&v.sendMessage(_)}$stopDASession(m){const _=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),_&&_.onWillStopSession&&_.onWillStopSession();const l=this._debugAdapters.get(m);return this._debugAdapters.delete(m),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const _=[],l=[],v=[];if(m.added)for(const R of m.added){const O=R.id;if(O&&!this._breakpoints.has(O)){let H;if(R.type==="function")H=new C.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")H=new C.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const ne=L.URI.revive(R.uri);H=new C.SourceBreakpoint(new C.Location(ne,new C.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}H._id=O,this._breakpoints.set(O,H),_.push(H)}}if(m.removed)for(const R of m.removed){const O=this._breakpoints.get(R);O&&(this._breakpoints.delete(R),l.push(O))}if(m.changed){for(const R of m.changed)if(R.id){const O=this._breakpoints.get(R.id);if(O){if(O instanceof C.FunctionBreakpoint&&R.type==="function"){const H=O;H.enabled=R.enabled,H.condition=R.condition,H.hitCondition=R.hitCondition,H.logMessage=R.logMessage,H.functionName=R.functionName}else if(O instanceof C.SourceBreakpoint&&R.type==="source"){const H=O;H.enabled=R.enabled,H.condition=R.condition,H.hitCondition=R.hitCondition,H.logMessage=R.logMessage,H.location=new C.Location(L.URI.revive(R.uri),new C.Position(R.line,R.character))}v.push(O)}}}this.fireBreakpointChanges(_,l,v)}$provideDebugConfigurations(m,_,l){return(0,T.asPromise)(async()=>{const v=this.getConfigProviderByHandle(m);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(_);return v.provideDebugConfigurations(R,l)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(m,_,l,v){return(0,T.asPromise)(async()=>{const R=this.getConfigProviderByHandle(m);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(_);return R.resolveDebugConfiguration(O,l,v)})}$resolveDebugConfigurationWithSubstitutedVariables(m,_,l,v){return(0,T.asPromise)(async()=>{const R=this.getConfigProviderByHandle(m);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(_);return R.resolveDebugConfigurationWithSubstitutedVariables(O,l,v)})}async $provideDebugAdapter(m,_){const l=this.getAdapterDescriptorFactoryByHandle(m);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(_);return this.getAdapterDescriptor(l,v).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(m){const _=await this.getSession(m);this._onDidStartDebugSession.fire(_)}async $acceptDebugSessionTerminated(m){const _=await this.getSession(m);_&&(this._onDidTerminateDebugSession.fire(_),this._debugSessions.delete(_.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,_){const l=await this.getSession(m);l&&l._acceptNameChanged(_)}async $acceptDebugSessionCustomEvent(m,_){const v={session:await this.getSession(m),event:_.event,body:_.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(m){if(m instanceof C.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof C.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const _=this._adapterFactories.filter(l=>l.type===m);if(_.length>0)return _[0].factory}getAdapterDescriptorFactoryByHandle(m){const _=this._adapterFactories.filter(l=>l.handle===m);if(_.length>0)return _[0].factory}getConfigProviderByHandle(m){const _=this._configProviders.filter(l=>l.handle===m);if(_.length>0)return _[0].provider}definesDebugType(m,_){if(m.contributes){const l=m.contributes.debuggers;if(l&&l.length>0){for(const v of l)if(v.label&&v.type&&v.type===_)return!0}}return!1}getDebugAdapterTrackers(m){const l=m.configuration.type,v=this._trackerFactories.filter(R=>R.type===l||R.type==="*").map(R=>(0,T.asPromise)(()=>R.factory.createDebugAdapterTracker(m)).then(O=>O,O=>null));return Promise.race([Promise.all(v).then(R=>{const O=R.filter(H=>!!H);if(O.length>0)return new s(O)}),new Promise((R,O)=>{const H=setTimeout(()=>{clearTimeout(H),O(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(m,_){const l=_.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new C.DebugAdapterServer(l));if(m){const R=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>m.createDebugAdapterDescriptor(_,this.daExecutableFromPackage(_,R))).then(O=>{if(O)return O})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(_,v))}daExecutableFromPackage(m,_){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,_,l){(m.length>0||_.length>0||l.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:_,changed:l}))}async getSession(m){if(m)if(typeof m=="string"){const _=this._debugSessions.get(m);if(_)return _}else{let _=this._debugSessions.get(m.id);if(!_){const l=await this.getFolder(m.folderUri),v=m.parent?this._debugSessions.get(m.parent):void 0;_=new f(this._debugServiceProxy,m.id,m.type,m.name,l,m.configuration,v),this._debugSessions.set(_.id,_),this._debugServiceProxy.$sessionCached(_.id)}return _}throw new Error("cannot find session")}getFolder(m){if(m){const _=L.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(_)}return Promise.resolve(void 0)}};c=qe([We(0,d.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,i.IExtHostExtensionService),We(3,P.IExtHostDocumentsAndEditors),We(4,p.IExtHostConfiguration),We(5,u.IExtHostEditorTabs)],c),e.ExtHostDebugServiceBase=c;class f{constructor(m,_,l,v,R,O,H){this._debugServiceProxy=m,this._id=_,this._type=l,this._name=v,this._workspaceFolder=R,this._configuration=O,this._parentSession=H}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,_){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,_)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=f;class t{constructor(m){this.value=Object.freeze({append(_){m.$appendDebugConsole(_)},appendLine(_){this.append(_+`
`)}})}}e.ExtHostDebugConsole=t;class n extends h.AbstractVariableResolverService{constructor(m,_,l,v,R){function O(){if(_){const H=_.activeEditor();if(H)return H.document.uri;const ne=v.tabs.filter(ie=>ie.isActive);if(ne.length>0)return ne[0].resource}}super({getFolderUri:H=>{const ne=m.filter(ie=>ie.name===H);if(ne&&ne.length>0)return ne[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:(H,ne)=>l.getConfiguration(void 0,H).get(ne),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{const H=O();if(H)return b.normalize(H.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const H=O();if(H){const ne=R.getWorkspaceFolder(H);if(ne)return b.normalize(ne.uri.fsPath)}}},getSelectedText:()=>{if(_){const H=_.activeEditor();if(H&&!H.selection.isEmpty)return H.document.getText(H.selection)}},getLineNumber:()=>{if(_){const H=_.activeEditor();if(H)return String(H.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=n;class s{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(_=>_.onWillReceiveMessage?_.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(_=>_.onDidSendMessage?_.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(_=>_.onError?_.onError(m):void 0)}onExit(m,_){this.trackers.forEach(l=>l.onExit?l.onExit(m,_):void 0)}}class r extends D.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(_=>{this.acceptMessage(_)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends c{constructor(m,_,l,v,R,O){super(m,_,l,v,R,O)}createVariableResolver(m,_,l){return new n(m,_,l,this._editorTabs)}};a=qe([We(0,d.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,i.IExtHostExtensionService),We(3,P.IExtHostDocumentsAndEditors),We(4,p.IExtHostConfiguration),We(5,u.IExtHostEditorTabs)],a),e.WorkerExtHostDebugService=a}),define(me[257],ge([0,1,70,2,5,35,40,26,15,27,4,42,36,14]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(u,c,f,t,n,s,r){this._apiFactory=u,this._extensionRegistry=c,this._instaService=f,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),b.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,c,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,c,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let c of u.nodeModuleName)this._factories.set(c,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(c=>u.alternativeModuleName(c))}};o=qe([We(2,i.IInstantiationService),We(3,T.IExtHostConfiguration),We(4,P.IExtHostExtensionService),We(5,k.IExtHostInitDataService),We(6,p.ILogService)],o),e.RequireInterceptor=o;class d{constructor(u,c,f,t,n){this._apiFactory=u,this._extensionPaths=c,this._extensionRegistry=f,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,c){const f=this._extensionPaths.findSubstr(c.fsPath);if(f){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(f.identifier));return t||(t=this._apiFactory(f,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(f.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(u,c){this.nodeModuleName="keytar";const{environment:f}=c,t=u.getProxy(I.MainContext.MainThreadKeytar);if(f.appRoot){let n=f.appRoot.fsPath;h.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,r)=>t.$setPassword(n,s,r),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(u,c){return this._impl}alternativeModuleName(u){const c=u.length;if(!(c<=7||!this.alternativeNames)){const f=c-7;if((u.charAt(f)==="/"||u.charAt(f)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}}};E=qe([We(0,D.IExtHostRpcService),We(1,k.IExtHostInitDataService)],E);let w=class{constructor(u,c,f){this._extensionPaths=u,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=f.getProxy(I.MainContext.MainThreadTelemetry);const t=f.getProxy(I.MainContext.MainThreadWindow);this._impl=(n,s)=>{const r=L.URI.parse(n);return s?this.callOriginal(n,s):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,s)}}load(u,c,f){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=f(u),this._impl}callOriginal(u,c){return this.sendNoForwardTelemetry(),this._original(u,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=qe([We(2,D.IExtHostRpcService)],w)}),define(me[258],ge([0,1,166,10,7,202,34,42,41,35,33,15,51,188,13,203,48]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends h.ExtHostDebugServiceBase{constructor(c,f,t,n,s,r,a){super(c,f,t,n,s,a);this._terminalService=r,this._integratedTerminalInstances=new S}createDebugAdapter(c,f){switch(c.type){case"server":return new T.SocketDebugAdapter(c);case"pipeServer":return new T.NamedPipeDebugAdapter(c);case"executable":return new T.ExecutableDebugAdapter(c,f.type)}return super.createDebugAdapter(c,f)}daExecutableFromPackage(c,f){const t=T.ExecutableDebugAdapter.platformAdapterExecutable(f.getAllExtensionDescriptions(),c.type);if(t)return new I.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new p.SignService}async $runInTerminal(c,f){if(c.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const t=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),r=JSON.stringify({shell:n,shellArgs:s});let a=await this._integratedTerminalInstances.checkout(r),g,m=!1;if(a)g=c.cwd;else{const R={shellPath:n,shellArgs:s,cwd:c.cwd,name:c.title||b.localize(0,null)};m=!0,a=this._terminalService.createTerminalFromOptions(R,!0),this._integratedTerminalInstances.insert(a,r)}a.show(!0);const _=await a.processId;m?await new Promise(R=>setTimeout(R,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?a.sendText("cls"):n.indexOf("bash")>=0?a.sendText("clear"):L.isWindows?a.sendText("cls"):a.sendText("clear"));const l=(0,d.prepareCommand)(n,c.args,g,c.env);a.sendText(l);const v=this.onDidTerminateDebugSession(R=>{R.id===f&&(this._integratedTerminalInstances.free(a),v.dispose())});return _}else if(c.kind==="external")return(0,d.runInExternalTerminal)(c,await this._configurationService.getConfigProvider());return super.$runInTerminal(c,f)}createVariableResolver(c,f,t){return new h.ExtHostVariableResolverService(c,f,t,this._editorTabs,this._workspaceService)}};w=qe([We(0,P.IExtHostRpcService),We(1,y.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,D.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,i.IExtHostTerminalService),We(6,E.IExtHostEditorTabs)],w),e.ExtHostDebugService=w;class S{constructor(){this._terminalInstances=new Map}async checkout(c){const t=[...this._terminalInstances.entries()].map(([n,s])=>(0,o.createCancelablePromise)(async r=>{if(s.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await n.processId))return null;const a=Date.now();return s.lastUsedAt+S.minUseDelay>a||r.isCancellationRequested||s.config!==c?null:(s.lastUsedAt=a,n)}));return await(0,o.firstParallel)(t,n=>!!n)}insert(c,f){this._terminalInstances.set(c,{lastUsedAt:Date.now(),config:f})}free(c){const f=this._terminalInstances.get(c);f&&(f.lastUsedAt=-1)}onTerminalClosed(c){this._terminalInstances.delete(c)}}S.minUseDelay=1e3}),define(me[259],ge([0,1,9,2,111,34,51,41,35,33,15,27,69,12,14,65,48]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends h.ExtHostTaskBase{constructor(u,c,f,t,n,s,r,a,g){super(u,c,f,t,n,s,r,a);this.workspaceService=f,this.editorTabs=g,c.remote.isRemote&&c.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:c.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(u,c){const f=c;if(!c.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const t=h.TaskHandleDTO.from(f,this.workspaceService),n=await this._proxy.$getTaskExecution(t);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(n,c);return this._proxy.$executeTask(t).catch(()=>{}),s}else{const t=h.TaskDTO.from(c,u);if(t===void 0)return Promise.reject(new Error("Task is not valid"));h.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,c,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),c);return this._proxy.$executeTask(t).catch(()=>{}),n}}provideTasksInternal(u,c,f,t){const n=[];if(t)for(let s of t){this.checkDeprecation(s,f),(!s.definition||!u[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const r=h.TaskDTO.from(s,f.extension);r&&(n.push(r),h.CustomExecutionDTO.is(r.execution)&&c.push(this.addCustomExecution(r,s,!0)))}return{tasks:n,extension:f.extension}}async resolveTaskInternal(u){return u}async getVariableResolver(u){if(this._variableResolver===void 0){const c=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(u,this._editorService,c,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(u,c){const f=L.URI.revive(u),t={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(f),s=await this._workspaceProvider.getWorkspaceFolders2();if(!s||!n)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const r=await this.getVariableResolver(s),a={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}};for(let g of c.variables)t.variables[g]=await r.resolveAsync(a,g);if(c.process!==void 0){let g;if(c.process.path!==void 0){g=c.process.path.split(b.delimiter);for(let m=0;m<g.length;m++)g[m]=await r.resolveAsync(a,g[m])}t.process=await I.win32.findExecutable(await r.resolveAsync(a,c.process.name),c.process.cwd!==void 0?await r.resolveAsync(a,c.process.cwd):void 0,g)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(u,c,f){return I.win32.findExecutable(u,c,f)}};w=qe([We(0,i.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,T.IExtHostWorkspace),We(3,C.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,o.ILogService),We(7,d.IExtHostApiDeprecationService),We(8,E.IExtHostEditorTabs)],w),e.ExtHostTask=w}),define(me[260],ge([0,1,13,17,70,6,2,5,251,14,79,82,27,183,15,63,42,33]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(c,f,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(c,null,n),f=S._transform(f,this._rpcProtocol);const s=new P.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());s.set(h.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},f)),s.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),s.set(d.IURITransformerService,new d.URITransformerService(n)),s.set(E.IHostUtils,t);const r=new p.InstantiationService(s,!0),a=r.invokeFunction(l=>l.get(w.IExtHostTerminalService));this._disposables.add(a),this._logService=r.invokeFunction(l=>l.get(k.ILogService)),I.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",f),this._extensionService=r.invokeFunction(l=>l.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(l=>{Error.prepareStackTrace=(v,R)=>{let O="",H,ne;for(const ie of R)O+=`
	at ${ie.toString()}`,ne=ie.getFileName(),!H&&ne&&(H=l.findSubstr(ne));return g.set(v,H),`${v.name||"Error"}: ${v.message||""}${O}`}});const m=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),_=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(l=>{const v=L.transformErrorForSerialization(l),R=g.get(l);R?m.$onExtensionRuntimeError(R.identifier,v):_.$onUnexpectedError(v)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const f=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,b.timeout)(4e3),f]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,f){c.extensions.forEach(n=>n.extensionLocation=y.URI.revive(f.transformIncomingURIs(n.extensionLocation))),c.environment.appRoot=y.URI.revive(f.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(f.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=y.URI.revive(f.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=y.URI.revive(f.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=y.URI.revive(f.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=y.URI.revive(f.transformIncomingURIs(c.logsLocation)),c.logFile=y.URI.revive(f.transformIncomingURIs(c.logFile)),c.workspace=f.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=S}),define(me[261],ge([0,1,9,21,60,32,25,45,31]),function(G,e,b,L,I,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(h,p,o){this.config=h,this.provider=p,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=h.filePattern,this.includePattern=h.includePattern&&T.parse(h.includePattern),this.maxResults=h.maxResults||void 0,this.exists=h.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=h.excludePattern&&T.parse(h.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(h=>h.cancel()),this.activeCancellationTokens=new Set}search(h){const p=this.config.folderQueries||[];return new Promise((o,d)=>{const E=w=>{this.resultCount++,h(w)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const S=w.toString(),u=b.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,u)||this.matchFile(E,{base:w,basename:u})}),Promise.all(p.map(w=>this.searchInFolder(w,E))).then(w=>{o({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{d(new Error((0,I.toErrorMessage)(w)))})})}async searchInFolder(h,p){const o=new L.CancellationTokenSource,d=this.getSearchOptionsForFolder(h),E=this.initDirectoryTree(),w=new D.QueryGlobTester(this.config,h),S=!w.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(o),u=C.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,o.token),f=u.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(n=>{const s=b.posix.relative(h.folder.path,n.path);if(S){const r=b.basename(n.path);this.matchFile(p,{base:h.folder,relativePath:s,basename:r});return}this.addDirectoryEntries(E,h.folder,s,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,w,p),{providerTime:f,postProcessTime:t.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(h){const p=(0,D.resolvePatternsForProvider)(this.config.includePattern,h.includePattern),o=(0,D.resolvePatternsForProvider)(this.config.excludePattern,h.excludePattern);return{folder:h.folder,excludes:o,includes:p,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}addDirectoryEntries({pathToEntries:h},p,o,d){if(o===this.filePattern){const w=b.basename(this.filePattern);this.matchFile(d,{base:p,relativePath:this.filePattern,basename:w})}function E(w){const S=b.basename(w),u=b.dirname(w);let c=h[u];c||(c=h[u]=[],E(u)),c.push({base:p,relativePath:w,basename:S})}E(o)}matchDirectoryTree({rootEntries:h,pathToEntries:p},o,d){const E=this,w=this.filePattern;function S(u){const c=T.hasSiblingFn(()=>u.map(f=>f.basename));for(let f=0,t=u.length;f<t;f++){const n=u[f],{relativePath:s,basename:r}=n;if(!!o.includedInQuerySync(s,r,w!==r?c:void 0)){const a=p[s];if(a)S(a);else{if(s===w)continue;E.matchFile(d,n)}if(E.isLimitHit)break}}}S(h)}matchFile(h,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||h(p))}}class i{constructor(){this.sessions=new Map}fileSearch(h,p,o,d){const E=this.getSessionTokenSource(h.cacheKey),w=new k(h,p,E&&E.token);let S=0;const u=c=>{S+=c.length,o(c.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(w,i.BATCH_SIZE,u,d).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:c.stats}}))}clearCache(h){const p=this.getSessionTokenSource(h);p&&p.cancel()}getSessionTokenSource(h){if(!!h)return this.sessions.has(h)||this.sessions.set(h,new L.CancellationTokenSource),this.sessions.get(h)}rawMatchToSearchItem(h){return h.relativePath?{resource:y.joinPath(h.base,h.relativePath)}:{resource:h.base}}doSearch(h,p,o,d){d.onCancellationRequested(()=>{h.cancel()});const E=S=>{S&&(w.push(S),p>0&&w.length>=p&&(o(w),w=[]))};let w=[];return h.search(E).then(S=>(w.length&&o(w),S),S=>(w.length&&o(w),Promise.reject(S)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(me[128],ge([0,1,9,16,21,60,25,32,2,31,12,11]),function(G,e,b,L,I,T,y,C,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class h{constructor(u,c,f){this.query=u,this.provider=c,this.fileUtils=f,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,c){const f=this.query.folderQueries||[],t=new I.CancellationTokenSource;return c.onCancellationRequested(()=>t.cancel()),new Promise((n,s)=>{this.collector=new o(u);let r=!1;const a=(g,m)=>{if(!r&&!this.isLimitHit){const _=this.resultSize(g);E(g)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const l=this.resultSize(g);this.resultCount+=l,(l>0||!E(g))&&this.collector.add(g,m)}};Promise.all(f.map((g,m)=>this.searchInFolder(g,_=>a(_,m),t.token))).then(g=>{t.dispose(),this.collector.flush();const m=g.some(_=>!!_&&!!_.limitHit);n({limitHit:this.isLimitHit||m,messages:(0,L.flatten)(g.map(_=>(_==null?void 0:_.message)?(0,P.isArray)(_.message)?_.message:[_.message]:[])),stats:{type:"textSearchProvider"}})},g=>{t.dispose();const m=(0,T.toErrorMessage)(g);s(new Error(m))})})}resultSize(u){return E(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,c){const f=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:f.slice(0,c),preview:{matches:t.slice(0,c),text:u.preview.text},uri:u.uri}}async searchInFolder(u,c,f){const t=new k.QueryGlobTester(this.query,u),n=[],s={report:g=>{if(!!this.validateProviderResult(g)){const m=u.folder.scheme===i.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(g.uri))):void 0,_=y.relativePath(u.folder,g.uri);_&&n.push(t.includedInQuery(_,b.basename(_),m).then(l=>{l&&c(g)}))}}},r=this.getSearchOptionsForFolder(u),a=await this.provider.provideTextSearchResults(p(this.query.contentPattern),r,s,f);return await Promise.all(n),a}validateProviderResult(u){if(E(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const c=(0,k.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),f=(0,k.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),t={folder:D.URI.from(u.folder),excludes:f,includes:c,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=h;function p(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class o{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,c=>this.sendItems(c))}add(u,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!y.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(d(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=o;function d(S){return E(S)?{preview:{matches:(0,L.mapArrayOrNot)(S.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:S.preview.text},ranges:(0,L.mapArrayOrNot)(S.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function E(S){return!!S.preview}e.extensionResultIsMatch=E;class w{constructor(u,c){this.maxBatchSize=u,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,c){!u||this.addItemToBatch(u,c)}addItems(u,c){!u||this.addItemsToBatch(u,c)}addItemToBatch(u,c){this.batch.push(u),this.batchSize+=c,this.onUpdate()}addItemsToBatch(u,c){this.batch=this.batch.concat(u),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(me[71],ge([0,1,6,5,4,261,15,63,14,2,128]),function(G,e,b,L,I,T,y,C,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let P=class{constructor(d,E,w){this.extHostRpc=d,this._uriTransformer=E,this._logService=w,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,E){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const w=this._handlePool++;return this._textSearchProvider.set(w,E),this._proxy.$registerTextSearchProvider(w,this._transformScheme(d)),(0,b.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(d,E){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const w=this._handlePool++;return this._fileSearchProvider.set(w,E),this._proxy.$registerFileSearchProvider(w,this._transformScheme(d)),(0,b.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(d,E,w,S){const u=h(w),c=this._fileSearchProvider.get(d);if(c)return this._fileSearchManager.fileSearch(u,c,f=>{this._proxy.$handleFileMatch(d,E,f.map(t=>t.resource))},S);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,E,w,S){const u=this._textSearchProvider.get(d);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const c=h(w);return this.createTextSearchManager(c,u).search(t=>this._proxy.$handleTextMatch(d,E,t),S)}createTextSearchManager(d,E){return new i.TextSearchManager(d,E,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};P=qe([We(0,y.IExtHostRpcService),We(1,C.IURITransformerService),We(2,D.ILogService)],P),e.ExtHostSearch=P;function h(o){return Object.assign(Object.assign({},o),{folderQueries:o.folderQueries&&o.folderQueries.map(p),extraFileResources:o.extraFileResources&&o.extraFileResources.map(d=>k.URI.revive(d))})}e.reviveQuery=h;function p(o){return Object.assign(Object.assign({},o),{folder:k.URI.revive(o.folder)})}}),define(me[262],ge([0,1,21,17,3,58,2,150,107,141,78,44,5,224,223,50,225,35,226,227,228,209,229,41,42,230,210,232,233,234,66,213,237,238,239,91,33,240,214,20,7,243,67,127,34,40,53,198,231,117,126,69,51,71,14,63,15,27,235,196,49,65,221,241,195,92,90,246,244,245,222,62,254,242,89,48,119,236,85,68]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E,w,S,u,c,f,t,n,s,r,a,g,m,_,l,v,R,O,H,ne,ie,N,B,U,A,x,F,M,W,z,Y,le,ve,Te,ye,Oe,j,Q,Z,se,fe,_e,xe,pe,ke,Fe,He,be,Ke,K,te,we,Ue,je,ze,Ze,Ce,De,Pe,oe,ue,V,J,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ae(Ee){const Me=Ee.get(_e.IExtHostInitDataService),Ve=Ee.get(Ze.IExtHostFileSystemInfo),Xe=Ee.get(te.IExtHostConsumerFileSystem),rt=Ee.get(s.IExtHostExtensionService),Qe=Ee.get(W.IExtHostWorkspace),et=Ee.get(ue.IExtHostTelemetry),pt=Ee.get(w.IExtHostConfiguration),bt=Ee.get(se.IURITransformerService),de=Ee.get(fe.IExtHostRpcService),Se=Ee.get(ne.IExtHostStorage),ae=Ee.get(K.IExtensionStoragePaths),X=Ee.get(Z.ILogService),Be=Ee.get(ke.IExtHostTunnelService),Le=Ee.get(Fe.IExtHostApiDeprecationService),Je=Ee.get(M.IExtHostWindow),it=Ee.get(Pe.IExtHostSecretState),at=Ee.get(oe.IExtHostEditorTabs);de.set(h.ExtHostContext.ExtHostFileSystemInfo,Ve),de.set(h.ExtHostContext.ExtHostLogService,X),de.set(h.ExtHostContext.ExtHostWorkspace,Qe),de.set(h.ExtHostContext.ExtHostConfiguration,pt),de.set(h.ExtHostContext.ExtHostExtensionService,rt),de.set(h.ExtHostContext.ExtHostStorage,Se),de.set(h.ExtHostContext.ExtHostTunnelService,Be),de.set(h.ExtHostContext.ExtHostWindow,Je),de.set(h.ExtHostContext.ExtHostSecretState,it),de.set(h.ExtHostContext.ExtHostTelemetry,et),de.set(h.ExtHostContext.ExtHostEditorTabs,at);const ht=de.set(h.ExtHostContext.ExtHostDecorations,Ee.get(ye.IExtHostDecorations)),Ye=de.set(h.ExtHostContext.ExtHostDocumentsAndEditors,Ee.get(n.IExtHostDocumentsAndEditors)),lt=de.set(h.ExtHostContext.ExtHostCommands,Ee.get(d.IExtHostCommands)),ft=de.set(h.ExtHostContext.ExtHostTerminalService,Ee.get(ie.IExtHostTerminalService)),ct=de.set(h.ExtHostContext.ExtHostDebugService,Ee.get(j.IExtHostDebugService)),_t=de.set(h.ExtHostContext.ExtHostSearch,Ee.get(Q.IExtHostSearch)),vt=de.set(h.ExtHostContext.ExtHostTask,Ee.get(Oe.IExtHostTask)),kt=de.set(h.ExtHostContext.ExtHostOutputService,Ee.get(l.IExtHostOutputService)),Lt=de.set(h.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(de)),Et=de.set(h.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(de,Ye)),Ft=de.set(h.ExtHostContext.ExtHostDocumentContentProviders,new c.ExtHostDocumentContentProvider(de,Ye,X)),Qt=de.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new f.ExtHostDocumentSaveParticipant(X,Et,de.getProxy(h.MainContext.MainThreadBulkEdits))),mt=de.set(h.ExtHostContext.ExtHostNotebook,new xe.ExtHostNotebookController(de,lt,Ye,Et,X,ae)),Xt=de.set(h.ExtHostContext.ExtHostNotebookKernels,new V.ExtHostNotebookKernels(de,Me,mt,X)),yt=de.set(h.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(de,Ye)),jt=de.set(h.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(de.getProxy(h.MainContext.MainThreadTreeViews),lt,X)),Yt=de.set(h.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(de.getProxy(h.MainContext.MainThreadEditorInsets),yt,Object.assign(Object.assign({},Me.environment),{remote:Me.remote}))),Ut=de.set(h.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(de,X)),ut=de.set(h.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(de,bt,Et,lt,Ut,X,Le)),Jt=de.set(h.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(de,ut)),It=de.set(h.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(de,X,Ye)),xt=de.set(h.ExtHostContext.ExtHostQuickOpen,(0,R.createExtHostQuickOpen)(de,Qe,lt)),cn=de.set(h.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(de,lt,X)),wn=de.set(h.ExtHostContext.ExtHostComments,new E.ExtHostComments(de,lt,Et)),un=de.set(h.ExtHostContext.ExtHostProgress,new v.ExtHostProgress(de.getProxy(h.MainContext.MainThreadProgress))),bn=de.set(h.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(de)),qt=de.set(h.ExtHostContext.ExtHostTheming,new pe.ExtHostTheming(de)),At=de.set(h.ExtHostContext.ExtHostAuthentication,new He.ExtHostAuthentication(de)),_n=de.set(h.ExtHostContext.ExtHostTimeline,new be.ExtHostTimeline(de,lt)),Zt=de.set(h.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(de,Object.assign(Object.assign({},Me.environment),{remote:Me.remote}),Qe,X,Le)),en=de.set(h.ExtHostContext.ExtHostWebviewPanels,new je.ExtHostWebviewPanels(de,Zt,Qe)),En=de.set(h.ExtHostContext.ExtHostCustomEditors,new Ue.ExtHostCustomEditors(de,Et,ae,Zt,en)),Kt=de.set(h.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(de,Zt)),Mt=de.set(h.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(de,Ye,Qe)),Sn=de.set(h.ExtHostContext.ExtHostUriOpeners,new De.ExtHostUriOpeners(de)),tn=(0,Y.values)(h.ExtHostContext);de.assertRegistered(tn);const yn=new ze.ExtHostBulkEdits(de,Ye),Bt=new o.ExtHostClipboard(de),$t=new _.ExtHostMessageService(de,X),Wt=new u.ExtHostDialogs(de),Tt=new H.ExtHostStatusBar(de,lt.converter),nn=new m.ExtHostLanguages(de,Et);return p.ExtHostApiCommands.register(lt),function(Ne,rn,dn){const gt=function(){let ee=!Ne.isUnderDevelopment;function he(Re){ee||(X.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Re(st){if(Array.isArray(st))st.forEach(Re);else if(typeof st=="string")he(st);else{const wt=st;typeof wt.scheme=="undefined"&&he(st),!Ne.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,z.throwProposedApiError)(Ne)}return st}}(),Dn={getSession(ee,he,Re){return At.getSession(Ne,ee,he,Re)},get onDidChangeSessions(){return At.onDidChangeSessions},registerAuthenticationProvider(ee,he,Re,st){return At.registerAuthenticationProvider(ee,he,Re,st)},get onDidChangeAuthenticationProviders(){return(0,z.checkProposedApiEnabled)(Ne),At.onDidChangeAuthenticationProviders},get providers(){return(0,z.checkProposedApiEnabled)(Ne),At.providers},logout(ee,he){return(0,z.checkProposedApiEnabled)(Ne),At.removeSession(ee,he)}},Cn={registerCommand(ee,he,Re){return lt.registerCommand(!0,ee,he,Re)},registerTextEditorCommand(ee,he,Re){return lt.registerCommand(!0,ee,(...st)=>{const wt=yt.getActiveTextEditor();if(!wt){X.warn("Cannot execute "+ee+" because there is no active text editor.");return}return wt.edit(Dt=>{he.apply(Re,[wt,Dt,...st])}).then(Dt=>{Dt||X.warn("Edits from command "+ee+" were not applied.")},Dt=>{X.warn("An error occurred while running command "+ee,Dt)})})},registerDiffInformationCommand:(ee,he,Re)=>((0,z.checkProposedApiEnabled)(Ne),lt.registerCommand(!0,ee,async(...st)=>{const wt=Ye.activeEditor(!0);if(!wt){X.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Dt=await yt.getDiffInformation(wt.id);he.apply(Re,[Dt,...st])})),executeCommand(ee,...he){return lt.executeCommand(ee,...he)},getCommands(ee=!1){return lt.getCommands(ee)}},hn={get machineId(){return Me.telemetryInfo.machineId},get sessionId(){return Me.telemetryInfo.sessionId},get language(){return Me.environment.appLanguage},get appName(){return Me.environment.appName},get appRoot(){var ee,he;return(he=(ee=Me.environment.appRoot)===null||ee===void 0?void 0:ee.fsPath)!==null&&he!==void 0?he:""},get uriScheme(){return Me.environment.appUriScheme},get clipboard(){return Bt.value},get shell(){return ft.getDefaultShell(!1)},get isTelemetryEnabled(){return et.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return et.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ee=Date.now()-new Date(Me.telemetryInfo.firstSessionDate).getTime();return isNaN(ee)?!1:ee<1e3*60*60*24},openExternal(ee,he){return Je.openUri(ee,{allowTunneling:!!Me.remote.authority,allowContributedOpeners:he==null?void 0:he.allowContributedOpeners})},asExternalUri(ee){return ee.scheme===Me.environment.appUriScheme?Lt.createAppUri(ee):Je.asExternalUri(ee,{allowTunneling:!!Me.remote.authority})},get remoteName(){return(0,Te.getRemoteName)(Me.remote.authority)},get uiKind(){return Me.uiKind}};Me.environment.extensionTestsLocationURI||Object.freeze(hn);const fn=Me.remote.isRemote?A.ExtensionKind.Workspace:A.ExtensionKind.UI,sn={registerTestController(ee){return(0,z.checkProposedApiEnabled)(Ne),Mt.registerTestController(Ne.identifier.value,ee)},createDocumentTestObserver(ee){return(0,z.checkProposedApiEnabled)(Ne),Mt.createTextDocumentTestObserver(ee)},createWorkspaceTestObserver(ee){return(0,z.checkProposedApiEnabled)(Ne),Mt.createWorkspaceTestObserver(ee)},runTests(ee){return(0,z.checkProposedApiEnabled)(Ne),Mt.runTests(ee)},createTestItem(ee,he){return new A.TestItemImpl(ee.id,ee.label,ee.uri,he)},createTestRun(ee,he,Re){return(0,z.checkProposedApiEnabled)(Ne),Mt.createTestRun(Ne.identifier.value,ee,he,Re)},get onDidChangeTestResults(){return(0,z.checkProposedApiEnabled)(Ne),Mt.onResultsChanged},get testResults(){return(0,z.checkProposedApiEnabled)(Ne),Mt.results}};sn.createTestRunTask=sn.createTestRun;const on={getExtension(ee){const he=rn.getExtensionDescription(ee);if(he)return new s.Extension(rt,Ne.identifier,he,fn)},get all(){return rn.getAllExtensionDescriptions().map(ee=>new s.Extension(rt,Ne.identifier,ee,fn))},get onDidChange(){return rn.onDidChange}},kn={createDiagnosticCollection(ee){return Ut.createDiagnosticCollection(Ne.identifier,ee)},get onDidChangeDiagnostics(){return Ut.onDidChangeDiagnostics},getDiagnostics:ee=>Ut.getDiagnostics(ee),getLanguages(){return nn.getLanguages()},setTextDocumentLanguage(ee,he){return nn.changeLanguage(ee.uri,he)},match(ee,he){return(0,i.score)(U.LanguageSelector.from(ee),he.uri,he.languageId,!0)},registerCodeActionsProvider(ee,he,Re){return ut.registerCodeActionProvider(Ne,gt(ee),he,Re)},registerCodeLensProvider(ee,he){return ut.registerCodeLensProvider(Ne,gt(ee),he)},registerDefinitionProvider(ee,he){return ut.registerDefinitionProvider(Ne,gt(ee),he)},registerDeclarationProvider(ee,he){return ut.registerDeclarationProvider(Ne,gt(ee),he)},registerImplementationProvider(ee,he){return ut.registerImplementationProvider(Ne,gt(ee),he)},registerTypeDefinitionProvider(ee,he){return ut.registerTypeDefinitionProvider(Ne,gt(ee),he)},registerHoverProvider(ee,he){return ut.registerHoverProvider(Ne,gt(ee),he,Ne.identifier)},registerEvaluatableExpressionProvider(ee,he){return ut.registerEvaluatableExpressionProvider(Ne,gt(ee),he,Ne.identifier)},registerInlineValuesProvider(ee,he){return ut.registerInlineValuesProvider(Ne,gt(ee),he,Ne.identifier)},registerDocumentHighlightProvider(ee,he){return ut.registerDocumentHighlightProvider(Ne,gt(ee),he)},registerLinkedEditingRangeProvider(ee,he){return ut.registerLinkedEditingRangeProvider(Ne,gt(ee),he)},registerReferenceProvider(ee,he){return ut.registerReferenceProvider(Ne,gt(ee),he)},registerRenameProvider(ee,he){return ut.registerRenameProvider(Ne,gt(ee),he)},registerDocumentSymbolProvider(ee,he,Re){return ut.registerDocumentSymbolProvider(Ne,gt(ee),he,Re)},registerWorkspaceSymbolProvider(ee){return ut.registerWorkspaceSymbolProvider(Ne,ee)},registerDocumentFormattingEditProvider(ee,he){return ut.registerDocumentFormattingEditProvider(Ne,gt(ee),he)},registerDocumentRangeFormattingEditProvider(ee,he){return ut.registerDocumentRangeFormattingEditProvider(Ne,gt(ee),he)},registerOnTypeFormattingEditProvider(ee,he,Re,...st){return ut.registerOnTypeFormattingEditProvider(Ne,gt(ee),he,[Re].concat(st))},registerDocumentSemanticTokensProvider(ee,he,Re){return ut.registerDocumentSemanticTokensProvider(Ne,gt(ee),he,Re)},registerDocumentRangeSemanticTokensProvider(ee,he,Re){return ut.registerDocumentRangeSemanticTokensProvider(Ne,gt(ee),he,Re)},registerSignatureHelpProvider(ee,he,Re,...st){return typeof Re=="object"?ut.registerSignatureHelpProvider(Ne,gt(ee),he,Re):ut.registerSignatureHelpProvider(Ne,gt(ee),he,typeof Re=="undefined"?[]:[Re,...st])},registerCompletionItemProvider(ee,he,...Re){return ut.registerCompletionItemProvider(Ne,gt(ee),he,Re)},registerDocumentLinkProvider(ee,he){return ut.registerDocumentLinkProvider(Ne,gt(ee),he)},registerColorProvider(ee,he){return ut.registerColorProvider(Ne,gt(ee),he)},registerFoldingRangeProvider(ee,he){return ut.registerFoldingRangeProvider(Ne,gt(ee),he)},registerSelectionRangeProvider(ee,he){return ut.registerSelectionRangeProvider(Ne,ee,he)},registerCallHierarchyProvider(ee,he){return ut.registerCallHierarchyProvider(Ne,ee,he)},setLanguageConfiguration:(ee,he)=>ut.setLanguageConfiguration(Ne,ee,he),getTokenInformationAtPosition(ee,he){return(0,z.checkProposedApiEnabled)(Ne),nn.tokenAtPosition(ee,he)},registerInlayHintsProvider(ee,he){return(0,z.checkProposedApiEnabled)(Ne),ut.registerInlayHintsProvider(Ne,ee,he)}},In={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(ee,he,Re){const st=await(y.URI.isUri(ee)?Promise.resolve(mn.openTextDocument(ee)):Promise.resolve(ee));return yt.showTextDocument(st,he,Re)},createTextEditorDecorationType(ee){return yt.createTextEditorDecorationType(ee)},onDidChangeActiveTextEditor(ee,he,Re){return yt.onDidChangeActiveTextEditor(ee,he,Re)},onDidChangeVisibleTextEditors(ee,he,Re){return yt.onDidChangeVisibleTextEditors(ee,he,Re)},onDidChangeTextEditorSelection(ee,he,Re){return yt.onDidChangeTextEditorSelection(ee,he,Re)},onDidChangeTextEditorOptions(ee,he,Re){return yt.onDidChangeTextEditorOptions(ee,he,Re)},onDidChangeTextEditorVisibleRanges(ee,he,Re){return yt.onDidChangeTextEditorVisibleRanges(ee,he,Re)},onDidChangeTextEditorViewColumn(ee,he,Re){return yt.onDidChangeTextEditorViewColumn(ee,he,Re)},onDidCloseTerminal(ee,he,Re){return ft.onDidCloseTerminal(ee,he,Re)},onDidOpenTerminal(ee,he,Re){return ft.onDidOpenTerminal(ee,he,Re)},onDidChangeActiveTerminal(ee,he,Re){return ft.onDidChangeActiveTerminal(ee,he,Re)},onDidChangeTerminalDimensions(ee,he,Re){return(0,z.checkProposedApiEnabled)(Ne),ft.onDidChangeTerminalDimensions(ee,he,Re)},onDidWriteTerminalData(ee,he,Re){return(0,z.checkProposedApiEnabled)(Ne),ft.onDidWriteTerminalData(ee,he,Re)},get state(){return Je.state},onDidChangeWindowState(ee,he,Re){return Je.onDidChangeWindowState(ee,he,Re)},showInformationMessage(ee,...he){return $t.showMessage(Ne,T.default.Info,ee,he[0],he.slice(1))},showWarningMessage(ee,...he){return $t.showMessage(Ne,T.default.Warning,ee,he[0],he.slice(1))},showErrorMessage(ee,...he){return $t.showMessage(Ne,T.default.Error,ee,he[0],he.slice(1))},showQuickPick(ee,he,Re){return xt.showQuickPick(ee,!!Ne.enableProposedApi,he,Re)},showWorkspaceFolderPick(ee){return xt.showWorkspaceFolderPick(ee)},showInputBox(ee,he){return xt.showInput(ee,he)},showOpenDialog(ee){return Wt.showOpenDialog(ee)},showSaveDialog(ee){return Wt.showSaveDialog(ee)},createStatusBarItem(ee,he,Re){let st,wt,Dt;return typeof ee=="string"?(st=ee,wt=he,Dt=Re):(wt=ee,Dt=he),Tt.createStatusBarEntry(Ne,st,wt,Dt)},setStatusBarMessage(ee,he){return Tt.setStatusBarMessage(ee,he)},withScmProgress(ee){return Le.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),un.withProgress(Ne,{location:A.ProgressLocation.SourceControl},(he,Re)=>ee({report(st){}}))},withProgress(ee,he){return un.withProgress(Ne,ee,he)},createOutputChannel(ee){return kt.createOutputChannel(ee)},createWebviewPanel(ee,he,Re,st){return en.createWebviewPanel(Ne,ee,he,Re,st)},createWebviewTextEditorInset(ee,he,Re,st){return(0,z.checkProposedApiEnabled)(Ne),Yt.createWebviewEditorInset(ee,he,Re,st,Ne)},createTerminal(ee,he,Re){return typeof ee=="object"?"pty"in ee?ft.createExtensionTerminal(ee):(ee.icon&&(0,z.checkProposedApiEnabled)(Ne),ft.createTerminalFromOptions(ee)):ft.createTerminal(ee,he,Re)},registerTerminalLinkProvider(ee){return ft.registerLinkProvider(ee)},registerTreeDataProvider(ee,he){return jt.registerTreeDataProvider(ee,he,Ne)},createTreeView(ee,he){return jt.createTreeView(ee,he,Ne)},registerWebviewPanelSerializer:(ee,he)=>en.registerWebviewPanelSerializer(Ne,ee,he),registerCustomEditorProvider:(ee,he,Re={})=>En.registerCustomEditorProvider(Ne,ee,he,Re),registerFileDecorationProvider(ee){return ht.registerFileDecorationProvider(ee,Ne.identifier)},registerUriHandler(ee){return Lt.registerUriHandler(Ne.identifier,ee)},createQuickPick(){return xt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return xt.createInputBox(Ne.identifier)},get activeColorTheme(){return qt.activeColorTheme},onDidChangeActiveColorTheme(ee,he,Re){return qt.onDidChangeActiveColorTheme(ee,he,Re)},registerWebviewViewProvider(ee,he,Re){return Kt.registerWebviewViewProvider(Ne,ee,he,Re==null?void 0:Re.webviewOptions)},get activeNotebookEditor(){return(0,z.checkProposedApiEnabled)(Ne),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,he,Re){return(0,z.checkProposedApiEnabled)(Ne),mt.onDidChangeActiveNotebookEditor(ee,he,Re)},get visibleNotebookEditors(){return(0,z.checkProposedApiEnabled)(Ne),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,z.checkProposedApiEnabled)(Ne),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,he,Re){return(0,z.checkProposedApiEnabled)(Ne),mt.onDidChangeNotebookEditorSelection(ee,he,Re)},onDidChangeNotebookEditorVisibleRanges(ee,he,Re){return(0,z.checkProposedApiEnabled)(Ne),mt.onDidChangeNotebookEditorVisibleRanges(ee,he,Re)},showNotebookDocument(ee,he){return(0,z.checkProposedApiEnabled)(Ne),mt.showNotebookDocument(ee,he)},registerExternalUriOpener(ee,he,Re){return(0,z.checkProposedApiEnabled)(Ne),Sn.registerExternalUriOpener(Ne.identifier,ee,he,Re)},get openEditors(){return(0,z.checkProposedApiEnabled)(Ne),at.tabs},get onDidChangeOpenEditors(){return(0,z.checkProposedApiEnabled)(Ne),at.onDidChangeTabs}},mn={get rootPath(){return Le.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Qe.getPath()},set rootPath(ee){throw L.readonly()},getWorkspaceFolder(ee){return Qe.getWorkspaceFolder(ee)},get workspaceFolders(){return Qe.getWorkspaceFolders()},get name(){return Qe.name},set name(ee){throw L.readonly()},get workspaceFile(){return Qe.workspaceFile},set workspaceFile(ee){throw L.readonly()},updateWorkspaceFolders:(ee,he,...Re)=>Qe.updateWorkspaceFolders(Ne,ee,he||0,...Re),onDidChangeWorkspaceFolders:function(ee,he,Re){return Qe.onDidChangeWorkspace(ee,he,Re)},asRelativePath:(ee,he)=>Qe.getRelativePath(ee,he),findFiles:(ee,he,Re,st)=>Qe.findFiles(U.GlobPattern.from(ee),U.GlobPattern.from(he),Re,Ne.identifier,st),findTextInFiles:(ee,he,Re,st)=>{let wt,Dt;return typeof he=="object"?(wt=he,Dt=Re):(wt={},Dt=he,st=Re),Qe.findTextInFiles(ee,wt||{},Dt,Ne.identifier,st)},saveAll:ee=>Qe.saveAll(ee),applyEdit(ee){return yn.applyWorkspaceEdit(ee)},createFileSystemWatcher:(ee,he,Re,st)=>It.createFileSystemWatcher(U.GlobPattern.from(ee),he,Re,st),get textDocuments(){return Et.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw L.readonly()},openTextDocument(ee){let he;const Re=ee;if(typeof ee=="string")he=Promise.resolve(y.URI.file(ee));else if(y.URI.isUri(ee))he=Promise.resolve(ee);else if(!Re||typeof Re=="object")he=Et.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>Et.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(ee,he,Re)=>Et.onDidAddDocument(ee,he,Re),onDidCloseTextDocument:(ee,he,Re)=>Et.onDidRemoveDocument(ee,he,Re),onDidChangeTextDocument:(ee,he,Re)=>Et.onDidChangeDocument(ee,he,Re),onDidSaveTextDocument:(ee,he,Re)=>Et.onDidSaveDocument(ee,he,Re),onWillSaveTextDocument:(ee,he,Re)=>Qt.getOnWillSaveTextDocumentEvent(Ne)(ee,he,Re),onDidChangeConfiguration:(ee,he,Re)=>dn.onDidChangeConfiguration(ee,he,Re),getConfiguration(ee,he){return he=arguments.length===1?void 0:he,dn.getConfiguration(ee,he,Ne)},registerTextDocumentContentProvider(ee,he){return Ft.registerTextDocumentContentProvider(ee,he)},registerTaskProvider:(ee,he)=>(Le.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Ne,ee,he)),registerFileSystemProvider(ee,he,Re){return Jt.registerFileSystemProvider(Ne.identifier,ee,he,Re,Ne.enableProposedApi)},get fs(){return Xe.value},registerFileSearchProvider:(ee,he)=>((0,z.checkProposedApiEnabled)(Ne),_t.registerFileSearchProvider(ee,he)),registerTextSearchProvider:(ee,he)=>((0,z.checkProposedApiEnabled)(Ne),_t.registerTextSearchProvider(ee,he)),registerRemoteAuthorityResolver:(ee,he)=>((0,z.checkProposedApiEnabled)(Ne),rt.registerRemoteAuthorityResolver(ee,he)),registerResourceLabelFormatter:ee=>((0,z.checkProposedApiEnabled)(Ne),bn.$registerResourceLabelFormatter(ee)),onDidCreateFiles:(ee,he,Re)=>It.onDidCreateFile(ee,he,Re),onDidDeleteFiles:(ee,he,Re)=>It.onDidDeleteFile(ee,he,Re),onDidRenameFiles:(ee,he,Re)=>It.onDidRenameFile(ee,he,Re),onWillCreateFiles:(ee,he,Re)=>It.getOnWillCreateFileEvent(Ne)(ee,he,Re),onWillDeleteFiles:(ee,he,Re)=>It.getOnWillDeleteFileEvent(Ne)(ee,he,Re),onWillRenameFiles:(ee,he,Re)=>It.getOnWillRenameFileEvent(Ne)(ee,he,Re),openTunnel:ee=>((0,z.checkProposedApiEnabled)(Ne),Be.openTunnel(Ne,ee).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,z.checkProposedApiEnabled)(Ne),Be.getTunnels()},onDidChangeTunnels:(ee,he,Re)=>((0,z.checkProposedApiEnabled)(Ne),Be.onDidChangeTunnels(ee,he,Re)),registerPortAttributesProvider:(ee,he)=>((0,z.checkProposedApiEnabled)(Ne),Be.registerPortsAttributesProvider(ee,he)),registerTimelineProvider:(ee,he)=>((0,z.checkProposedApiEnabled)(Ne),_n.registerTimelineProvider(ee,he,Ne.identifier,lt.converter)),get isTrusted(){return Qe.trusted},requestWorkspaceTrust:ee=>((0,z.checkProposedApiEnabled)(Ne),Qe.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,he,Re)=>Qe.onDidGrantWorkspaceTrust(ee,he,Re)},Pn={get inputBox(){return Le.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(Ne)},createSourceControl(ee,he,Re){return cn.createSourceControl(Ne,ee,he,Re)}},An={createCommentController(ee,he){return wn.createCommentController(Ne,ee,he)}},Tn={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(ee,he,Re){return ct.onDidStartDebugSession(ee,he,Re)},onDidTerminateDebugSession(ee,he,Re){return ct.onDidTerminateDebugSession(ee,he,Re)},onDidChangeActiveDebugSession(ee,he,Re){return ct.onDidChangeActiveDebugSession(ee,he,Re)},onDidReceiveDebugSessionCustomEvent(ee,he,Re){return ct.onDidReceiveDebugSessionCustomEvent(ee,he,Re)},onDidChangeBreakpoints(ee,he,Re){return ct.onDidChangeBreakpoints(ee,he,Re)},registerDebugConfigurationProvider(ee,he,Re){return ct.registerDebugConfigurationProvider(ee,he,Re||A.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,he){return ct.registerDebugAdapterDescriptorFactory(Ne,ee,he)},registerDebugAdapterTrackerFactory(ee,he){return ct.registerDebugAdapterTrackerFactory(ee,he)},startDebugging(ee,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?ct.startDebugging(ee,he,{parentSession:Re}):ct.startDebugging(ee,he,Re||{})},stopDebugging(ee){return ct.stopDebugging(ee)},addBreakpoints(ee){return ct.addBreakpoints(ee)},removeBreakpoints(ee){return ct.removeBreakpoints(ee)},asDebugSourceUri(ee,he){return ct.asDebugSourceUri(ee,he)}},gn={registerTaskProvider:(ee,he)=>vt.registerTaskProvider(Ne,ee,he),fetchTasks:ee=>vt.fetchTasks(ee),executeTask:ee=>vt.executeTask(Ne,ee),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(ee,he,Re)=>vt.onDidStartTask(ee,he,Re),onDidEndTask:(ee,he,Re)=>vt.onDidEndTask(ee,he,Re),onDidStartTaskProcess:(ee,he,Re)=>vt.onDidStartTaskProcess(ee,he,Re),onDidEndTaskProcess:(ee,he,Re)=>vt.onDidEndTaskProcess(ee,he,Re)},pn={openNotebookDocument:ee=>((0,z.checkProposedApiEnabled)(Ne),mt.openNotebookDocument(ee)),get onDidOpenNotebookDocument(){return(0,z.checkProposedApiEnabled)(Ne),mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,z.checkProposedApiEnabled)(Ne),mt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,z.checkProposedApiEnabled)(Ne),mt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,z.checkProposedApiEnabled)(Ne),mt.notebookDocuments.map(ee=>ee.apiNotebook)},registerNotebookSerializer(ee,he,Re,st){return(0,z.checkProposedApiEnabled)(Ne),mt.registerNotebookSerializer(Ne,ee,he,Re,Ne.enableProposedApi?st:void 0)},registerNotebookContentProvider:(ee,he,Re,st)=>((0,z.checkProposedApiEnabled)(Ne),mt.registerNotebookContentProvider(Ne,ee,he,Re,Ne.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(ee,he)=>((0,z.checkProposedApiEnabled)(Ne),mt.registerNotebookCellStatusBarItemProvider(Ne,ee,he)),createNotebookEditorDecorationType(ee){return(0,z.checkProposedApiEnabled)(Ne),mt.createNotebookEditorDecorationType(ee)},onDidChangeNotebookDocumentMetadata(ee,he,Re){return(0,z.checkProposedApiEnabled)(Ne),mt.onDidChangeNotebookDocumentMetadata(ee,he,Re)},onDidChangeNotebookCells(ee,he,Re){return(0,z.checkProposedApiEnabled)(Ne),mt.onDidChangeNotebookCells(ee,he,Re)},onDidChangeNotebookCellExecutionState(ee,he,Re){return(0,z.checkProposedApiEnabled)(Ne),mt.onDidChangeNotebookCellExecutionState(ee,he,Re)},onDidChangeCellOutputs(ee,he,Re){return(0,z.checkProposedApiEnabled)(Ne),mt.onDidChangeCellOutputs(ee,he,Re)},onDidChangeCellMetadata(ee,he,Re){return(0,z.checkProposedApiEnabled)(Ne),mt.onDidChangeCellMetadata(ee,he,Re)},createConcatTextDocument(ee,he){return(0,z.checkProposedApiEnabled)(Ne),new Ke.ExtHostNotebookConcatDocument(mt,Et,ee,he)},createNotebookController(ee,he,Re,st,wt){return(0,z.checkProposedApiEnabled)(Ne),Xt.createNotebookController(Ne,ee,he,Re,st,wt)}};return{version:Me.version,authentication:Dn,commands:Cn,comments:An,debug:Tn,env:hn,extensions:on,languages:kn,notebook:pn,scm:Pn,tasks:gn,test:sn,window:In,workspace:mn,Breakpoint:A.Breakpoint,CallHierarchyIncomingCall:A.CallHierarchyIncomingCall,CallHierarchyItem:A.CallHierarchyItem,CallHierarchyOutgoingCall:A.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:b.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:A.CodeAction,CodeActionKind:A.CodeActionKind,CodeActionTriggerKind:A.CodeActionTriggerKind,CodeLens:A.CodeLens,Color:A.Color,ColorInformation:A.ColorInformation,ColorPresentation:A.ColorPresentation,ColorThemeKind:A.ColorThemeKind,CommentMode:A.CommentMode,CommentThreadCollapsibleState:A.CommentThreadCollapsibleState,CompletionItem:A.CompletionItem,CompletionItemKind:A.CompletionItemKind,CompletionItemTag:A.CompletionItemTag,CompletionList:A.CompletionList,CompletionTriggerKind:A.CompletionTriggerKind,ConfigurationTarget:A.ConfigurationTarget,CustomExecution:A.CustomExecution,DebugAdapterExecutable:A.DebugAdapterExecutable,DebugAdapterInlineImplementation:A.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:A.DebugAdapterNamedPipeServer,DebugAdapterServer:A.DebugAdapterServer,DebugConfigurationProviderTriggerKind:A.DebugConfigurationProviderTriggerKind,DebugConsoleMode:A.DebugConsoleMode,DecorationRangeBehavior:A.DecorationRangeBehavior,Diagnostic:A.Diagnostic,DiagnosticRelatedInformation:A.DiagnosticRelatedInformation,DiagnosticSeverity:A.DiagnosticSeverity,DiagnosticTag:A.DiagnosticTag,Disposable:A.Disposable,DocumentHighlight:A.DocumentHighlight,DocumentHighlightKind:A.DocumentHighlightKind,DocumentLink:A.DocumentLink,DocumentSymbol:A.DocumentSymbol,EndOfLine:A.EndOfLine,EnvironmentVariableMutatorType:A.EnvironmentVariableMutatorType,EvaluatableExpression:A.EvaluatableExpression,InlineValueText:A.InlineValueText,InlineValueVariableLookup:A.InlineValueVariableLookup,InlineValueEvaluatableExpression:A.InlineValueEvaluatableExpression,EventEmitter:I.Emitter,ExtensionKind:A.ExtensionKind,ExtensionMode:A.ExtensionMode,ExternalUriOpenerPriority:A.ExternalUriOpenerPriority,FileChangeType:A.FileChangeType,FileDecoration:A.FileDecoration,FileSystemError:A.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:A.FoldingRange,FoldingRangeKind:A.FoldingRangeKind,FunctionBreakpoint:A.FunctionBreakpoint,Hover:A.Hover,IndentAction:k.IndentAction,Location:A.Location,MarkdownString:A.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:A.ParameterInformation,PortAutoForwardAction:A.PortAutoForwardAction,Position:A.Position,ProcessExecution:A.ProcessExecution,ProgressLocation:A.ProgressLocation,QuickInputButtons:A.QuickInputButtons,Range:A.Range,RelativePattern:A.RelativePattern,Selection:A.Selection,SelectionRange:A.SelectionRange,SemanticTokens:A.SemanticTokens,SemanticTokensBuilder:A.SemanticTokensBuilder,SemanticTokensEdit:A.SemanticTokensEdit,SemanticTokensEdits:A.SemanticTokensEdits,SemanticTokensLegend:A.SemanticTokensLegend,ShellExecution:A.ShellExecution,ShellQuoting:A.ShellQuoting,SignatureHelp:A.SignatureHelp,SignatureHelpTriggerKind:A.SignatureHelpTriggerKind,SignatureInformation:A.SignatureInformation,SnippetString:A.SnippetString,SourceBreakpoint:A.SourceBreakpoint,StandardTokenType:A.StandardTokenType,StatusBarAlignment:A.StatusBarAlignment,SymbolInformation:A.SymbolInformation,SymbolKind:A.SymbolKind,SymbolTag:A.SymbolTag,Task:A.Task,TaskGroup:A.TaskGroup,TaskPanelKind:A.TaskPanelKind,TaskRevealKind:A.TaskRevealKind,TaskScope:A.TaskScope,TextDocumentSaveReason:A.TextDocumentSaveReason,TextEdit:A.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:A.TextEditorLineNumbersStyle,TextEditorRevealType:A.TextEditorRevealType,TextEditorSelectionChangeKind:A.TextEditorSelectionChangeKind,ThemeColor:A.ThemeColor,ThemeIcon:A.ThemeIcon,TreeItem:A.TreeItem,TreeItemCollapsibleState:A.TreeItemCollapsibleState,UIKind:h.UIKind,Uri:y.URI,ViewColumn:A.ViewColumn,WorkspaceEdit:A.WorkspaceEdit,InlayHint:A.InlayHint,InlayHintKind:A.InlayHintKind,RemoteAuthorityResolverError:A.RemoteAuthorityResolverError,RemoteTrustOption:J.RemoteTrustOption,ResolvedAuthority:A.ResolvedAuthority,SourceControlInputBoxValidationType:A.SourceControlInputBoxValidationType,ExtensionRuntime:A.ExtensionRuntime,TimelineItem:A.TimelineItem,NotebookRange:A.NotebookRange,NotebookCellKind:A.NotebookCellKind,NotebookCellExecutionState:A.NotebookCellExecutionState,NotebookDocumentMetadata:A.NotebookDocumentMetadata,NotebookCellMetadata:A.NotebookCellMetadata,NotebookCellData:A.NotebookCellData,NotebookData:A.NotebookData,NotebookKernelPreload:A.NotebookKernelPreload,NotebookCellStatusBarAlignment:A.NotebookCellStatusBarAlignment,NotebookEditorRevealType:A.NotebookEditorRevealType,NotebookCellOutput:A.NotebookCellOutput,NotebookCellOutputItem:A.NotebookCellOutputItem,NotebookCellStatusBarItem:A.NotebookCellStatusBarItem,NotebookControllerAffinity:A.NotebookControllerAffinity,PortAttributes:A.PortAttributes,LinkedEditingRanges:A.LinkedEditingRanges,TestItemStatus:A.TestItemStatus,TestResultState:A.TestResultState,TestMessage:A.TestMessage,TextSearchCompleteMessageType:ce.TextSearchCompleteMessageType,TestMessageSeverity:A.TestMessageSeverity,WorkspaceTrustState:A.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ae}),define(me[263],ge([0,1,79,66,34,126,35,50,41,33,69,51,71,92,91,49,65,127,90,62,89,119,48]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E,w,S,u,c,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(p.IExtensionStoragePaths,p.ExtensionStoragePaths),(0,b.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),(0,b.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,b.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,b.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,b.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,b.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,b.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,b.registerSingleton)(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),(0,b.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,b.registerSingleton)(h.IExtHostSearch,h.ExtHostSearch),(0,b.registerSingleton)(o.IExtHostStorage,o.ExtHostStorage),(0,b.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,b.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,b.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,b.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,b.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,b.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,b.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,b.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(me[93],ge([0,1,16,14,31,68]),function(G,e,b,L,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=y;function C(P,h,p,o){const d=(0,b.mapArrayOrNot)(p,D),E=new I.TextSearchMatch(h,d,o),w=E.preview.matches;return{ranges:(0,b.mapArrayOrNot)(d,k),uri:P,preview:{text:E.preview.text,matches:(0,b.mapArrayOrNot)(w,k)}}}e.createTextSearchResult=C;function D(P){return new I.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function k(P){return new T.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let i=class{constructor(h,p){this.prefix=h,this.logService=p}appendLine(h){this.logService.debug(`${this.prefix}#search`,h)}};i=qe([We(1,L.ILogService)],i),e.OutputChannel=i}),define(me[264],ge([0,1,94,23]),function(G,e,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const T=512,y=512,C=512*8,D=512*128;class k{constructor(n){this.iconvLiteDecoder=n}static async create(n){let s;if(n!==e.UTF8)s=(await new Promise((a,g)=>{G(["iconv-lite-umd"],a,g)})).getDecoder(p(n));else{const r=new TextDecoder;s={write(a){return r.decode(a,{stream:!0})},end(){return r.decode()}}}return new k(s)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function i(t,n){var s;const r=((s=n.minBytesRequiredForDetection)!==null&&s!==void 0?s:n.guessEncoding)?C:y;return new Promise((a,g)=>{const m=(0,b.newWriteableStream)(O=>O.join("")),_=[];let l=0,v;const R=async()=>{try{const O=await f({buffer:L.VSBuffer.concat(_),bytesRead:l},n.guessEncoding);O.encoding=await n.overwriteEncoding(O.encoding),v=await k.create(O.encoding);const H=v.write(L.VSBuffer.concat(_).buffer);m.write(H),_.length=0,l=0,a({stream:m,detected:O})}catch(O){g(O)}};(0,b.listenStream)(t,{onData:async O=>{v?m.write(v.write(O.buffer)):(_.push(O),l+=O.byteLength,l>=r&&(t.pause(),await R(),setTimeout(()=>t.resume())))},onError:O=>m.error(O),onEnd:async()=>{v||await R(),m.end(v==null?void 0:v.end())}})})}e.toDecodeStream=i;async function P(t,n,s){const a=(await new Promise((_,l)=>{G(["iconv-lite-umd"],_,l)})).getEncoder(p(n),s);let g=!1,m=!1;return{read(){if(m)return null;const _=t.read();if(typeof _!="string"){if(m=!0,!g&&(s==null?void 0:s.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const l=a.end();return l&&l.length>0?(g=!0,L.VSBuffer.wrap(l)):null}return g=!0,L.VSBuffer.wrap(a.write(_))}}}e.toEncodeReadable=P;async function h(t){return(await new Promise((s,r)=>{G(["iconv-lite-umd"],s,r)})).encodingExists(p(t))}e.encodingExists=h;function p(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=p;function o(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),r=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return s===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=o;const d=["ascii","utf-16","utf-32"];async function E(t){const n=await new Promise((m,_)=>{G(["jschardet"],m,_)}),s=t.slice(0,D),r=u(s.buffer),a=n.detect(r);if(!a||!a.encoding)return null;const g=a.encoding.toLowerCase();return 0<=d.indexOf(g)?null:S(a.encoding)}const w={ibm866:"cp866",big5:"cp950"};function S(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[n]||n}function u(t){let n="";for(let s=0;s<t.length;s++)n+=String.fromCharCode(t[s]);return n}function c(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=c;function f({buffer:t,bytesRead:n},s){let r=o(t,n),a=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let g=!0,m=!0,_=!1;for(let l=0;l<n&&l<T;l++){const v=l%2==1,R=t.readUInt8(l)===0;if(R&&(_=!0),g&&(v&&!R||!v&&R)&&(g=!1),m&&(v&&R||!v&&!R)&&(m=!1),R&&!g&&!m)break}_&&(g?r=e.UTF16le:m?r=e.UTF16be:a=!0)}return s&&!a&&!r&&t?E(t.slice(0,n)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:a,encoding:r}}e.detectEncodingFromBuffer=f,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[129],ge([0,1,264,28,128]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class T extends I.TextSearchManager{constructor(C,D,k=L){super(C,D,{readdir:i=>k.readdir(i.fsPath),toCanonicalName:i=>(0,b.toCanonicalName)(i)})}}e.NativeTextSearchManager=T}),define(me[265],ge([0,1,266,280,281,2,282]),function(G,e,b,L,I,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(P,h,p,o,d,E){const w=E.environment.useHostProxy,S=typeof w=="boolean"?w:!E.remote.isRemote,u=(0,y.createProxyResolver)({resolveProxy:f=>P.resolveProxy(f),getHttpProxySetting:()=>h.getConfiguration("http").get("proxy"),log:(f,t,...n)=>{switch(f){case y.LogLevel.Trace:o.trace(t,...n);break;case y.LogLevel.Debug:o.debug(t,...n);break;case y.LogLevel.Info:o.info(t,...n);break;case y.LogLevel.Warning:o.warn(t,...n);break;case y.LogLevel.Error:o.error(t,...n);break;case y.LogLevel.Critical:o.critical(t,...n);break;case y.LogLevel.Off:break;default:s(f,t,n);break}function s(r,a,...g){o.error("Unknown log level",r),o.error(a,...g)}},getLogLevel:()=>o.getLevel(),proxyResolveTelemetry:f=>{d.$publicLog2("resolveProxy",f)},useHostProxy:S,env:process.env}),c=D(h,u);return i(p,c)}e.connectProxyResolver=C;function D(P,h){const p={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(d=>{p.config=P.getConfiguration("http").get("proxySupport")||"off"});const o={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(d=>{o.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},b,(0,y.createHttpPatch)(b,h,{config:"off"},o,!0)),on:Object.assign({},b,(0,y.createHttpPatch)(b,h,{config:"on"},o,!0)),override:Object.assign({},b,(0,y.createHttpPatch)(b,h,{config:"override"},o,!0)),onRequest:Object.assign({},b,(0,y.createHttpPatch)(b,h,p,o,!0)),default:Object.assign(b,(0,y.createHttpPatch)(b,h,p,o,!1))},https:{off:Object.assign({},L,(0,y.createHttpPatch)(L,h,{config:"off"},o,!0)),on:Object.assign({},L,(0,y.createHttpPatch)(L,h,{config:"on"},o,!0)),override:Object.assign({},L,(0,y.createHttpPatch)(L,h,{config:"override"},o,!0)),onRequest:Object.assign({},L,(0,y.createHttpPatch)(L,h,p,o,!0)),default:Object.assign(L,(0,y.createHttpPatch)(L,h,p,o,!1))},tls:Object.assign(I,(0,y.createTlsPatch)(I))}}const k=new Map;function i(P,h){return P.getExtensionPathIndex().then(p=>{const o=G.__$__nodeRequire("module"),d=o._load;o._load=function(w,S,u){if(w==="tls")return h.tls;if(w!=="http"&&w!=="https")return d.apply(this,arguments);const c=h[w],f=p.findSubstr(T.URI.file(S.filename).fsPath);let t=k.get(f);if(t||k.set(f,t={}),!t[w]){let n=c.default;f&&f.enableProposedApi&&(n=c[f.proxySupport]||c.onRequest),t[w]=Object.assign({},n)}return t[w]}})}}),define(me[267],ge([0,1,38,9,76,29,10,8,93,268]),function(G,e,b,L,I,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(u,c,f,t){const n=h(u,c,f,t),s=c.folder.fsPath;return{cmd:b.spawn(i,n.args,{cwd:s}),rgDiskPath:i,siblingClauses:n.siblingClauses,rgArgs:n,cwd:s}}e.spawnRipgrepCmd=P;function h(u,c,f,t){const n=["--files","--hidden","--case-sensitive"];o([c],f,!1).forEach(r=>{const a=(0,D.anchorGlob)(r);if(n.push("-g",a),y.isMacintosh){const g=(0,I.normalizeNFD)(a);g!==a&&n.push("-g",g)}});const s=p([c],t,void 0,!1);return s.globArgs.forEach(r=>{const a=`!${(0,D.anchorGlob)(r)}`;if(n.push("-g",a),y.isMacintosh){const g=(0,I.normalizeNFD)(a);g!==a&&n.push("-g",g)}}),c.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),c.ignoreSymlinks||n.push("--follow"),u.exists&&n.push("--quiet"),n.push("--no-config"),c.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:s.siblingClauses}}function p(u,c,f,t=!0){const n=[];let s={};return u.forEach(r=>{const a=Object.assign({},r.excludePattern||{},c||{}),g=d(a,t?r.folder.fsPath:void 0,f);n.push(...g.globArgs),g.siblingClauses&&(s=Object.assign(s,g.siblingClauses))}),{globArgs:n,siblingClauses:s}}e.foldersToRgExcludeGlobs=p;function o(u,c,f=!0){const t=[];return u.forEach(n=>{const s=Object.assign({},c||{},n.includePattern||{}),r=d(s,f?n.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=o;function d(u,c,f){const t=[],n={};return Object.keys(u).forEach(s=>{if(!(f&&f.has(s))&&!!s){const r=u[s];s=w(c?E(c,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof r=="boolean"&&r?(s.startsWith("\\\\")&&(s+="**"),t.push(S(s))):r&&r.when&&(n[s]=r)}}),{globArgs:t,siblingClauses:n}}function E(u,c){return L.isAbsolute(c)?c:L.join(u,c)}e.getAbsoluteGlob=E;function w(u){return u=C.rtrim(u,"\\"),C.rtrim(u,"/")}function S(u){return T.getRoot(u).toLowerCase()==="c:/"?u.replace(/^c:[/\\]/i,"/"):u}e.fixDriveC=S}),define(me[269],ge([0,1,38,37,9,101,16,60,32,76,29,10,45,8,11,28,31,267,99]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const u=new Set;process.on("exit",()=>{u.forEach(s=>s())});class c{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&D.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,S.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&D.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(a=>{const g=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),m=a.folder.fsPath;r.folderQueries.map(_=>_.folder.fsPath).filter(_=>_!==m).forEach(_=>{(0,i.isEqualOrParent)(_,m)&&(g[I.relative(m,_)]=!0)}),this.folderExcludePatterns.set(m,new t(g,m))})}cancel(){this.isCanceled=!0}walk(r,a,g,m,_){if(this.fileWalkSW=h.StopWatch.create(!1),this.isCanceled)return _(null,this.isLimitHit);a.forEach(l=>{const v=I.basename(l.fsPath);this.globalExcludePattern&&this.globalExcludePattern(l.fsPath,v)||this.matchFile(g,{relativePath:l.fsPath,searchPath:void 0})}),this.cmdSW=h.StopWatch.create(!1),this.parallel(r,(l,v)=>{this.call(this.cmdTraversal,this,l,g,m,R=>{if(R){const O=(0,C.toErrorMessage)(R);console.error(O),this.errors.push(O),v(R,void 0)}else v(null,void 0)})},(l,v)=>{this.fileWalkSW.stop();const R=l?y.coalesce(l)[0]:null;_(R,this.isLimitHit)})}parallel(r,a,g){const m=new Array(r.length),_=new Array(r.length);let l=!1,v=0;if(r.length===0)return g(null,[]);r.forEach((R,O)=>{a(R,(H,ne)=>{if(H?(l=!0,m[O]=null,_[O]=H):(m[O]=ne,_[O]=null),++v===r.length)return g(l?_:null,m)})})}call(r,a,...g){try{r.apply(a,g)}catch(m){g[g.length-1](m)}}cmdTraversal(r,a,g,m){const _=r.folder.fsPath,l=P.isMacintosh;let v;const R=()=>v&&v.kill();u.add(R);let O=A=>{u.delete(R),O=()=>{},m(A)},H="";const ne=this.initDirectoryTree();let ie;const N=(0,w.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);v=N.cmd,ie=!Object.keys(N.siblingClauses).length;const B=N.rgArgs.args.map(A=>A.match(/^-/)?A:`'${A}'`).join(" ");let U=`${N.rgDiskPath} ${B}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),g({message:U}),this.cmdResultCount=0,this.collectStdout(v,"utf8",g,(A,x,F)=>{if(A){O(A);return}if(this.isLimitHit){O();return}const W=(H+(l?k.normalizeNFC(x||""):x)).split(`
`);if(F){const z=W.length;W[z-1]=W[z-1].trim(),W[z-1]||W.pop()}else H=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,ie){for(const z of W)if(this.matchFile(a,{base:_,relativePath:z,searchPath:this.getSearchPath(r,z)}),this.isLimitHit){R();break}(F||this.isLimitHit)&&O();return}this.addDirectoryEntries(r,ne,_,W,a),F&&(this.matchDirectoryTree(ne,_,a),O())})}spawnFindCmd(r){const a=this.folderExcludePatterns.get(r.folder.fsPath),g=a.getBasenameTerms(),m=a.getPathTerms(),_=["-L","."];if(g.length||m.length){_.push("-not","(","(");for(const l of g)_.push("-name",l),_.push("-o");for(const l of m)_.push("-path",l),_.push("-o");_.pop(),_.push(")","-prune",")")}return _.push("-type","f"),b.spawn("find",_,{cwd:r.folder.fsPath})}readStdout(r,a,g){let m="";this.collectStdout(r,a,()=>{},(_,l,v)=>{if(_){g(_);return}m+=l,v&&g(null,m)})}collectStdout(r,a,g,m){let _=(R,O,H)=>{(R||H)&&(_=()=>{},this.cmdSW&&this.cmdSW.stop()),m(R,O,H)},l=!1;r.stdout?(this.forwardData(r.stdout,a,_),r.stdout.once("data",()=>l=!0)):g({message:"stdout is null"});let v;r.stderr?v=this.collectData(r.stderr):g({message:"stderr is null"}),r.on("error",R=>{_(R)}),r.on("close",R=>{let O;!l&&(O=this.decodeData(v,a))&&n(O)?_(new Error(`command failed with error code ${R}: ${this.decodeData(v,a)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),_(null,"",!0))})}forwardData(r,a,g){const m=new T.StringDecoder(a);return r.on("data",_=>{g(null,m.write(_))}),m}collectData(r){const a=[];return r.on("data",g=>{a.push(g)}),a}decodeData(r,a){const g=new T.StringDecoder(a);return r.map(m=>g.write(m)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:a},g,m,_){m.indexOf(this.filePattern)!==-1&&this.matchFile(_,{base:g,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const l=v=>{const R=I.basename(v),O=I.dirname(v);let H=a[O];H||(H=a[O]=[],l(O)),H.push({base:g,relativePath:v,basename:R,searchPath:this.getSearchPath(r,v)})};m.forEach(l)}matchDirectoryTree({rootEntries:r,pathToEntries:a},g,m){const _=this,l=this.folderExcludePatterns.get(g),v=this.filePattern;function R(O){_.directoriesWalked++;const H=D.hasSiblingFn(()=>O.map(ne=>ne.basename));for(let ne=0,ie=O.length;ne<ie;ne++){const N=O[ne],{relativePath:B,basename:U}=N;if(!l.test(B,U,v!==U?H:void 0)){const A=a[B];if(A)R(A);else{if(_.filesWalked++,B===v)continue;_.matchFile(m,N)}if(_.isLimitHit)break}}}R(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,a,g,m,_){const l=r.folder,v=D.hasSiblingFn(()=>g);this.parallel(g,(R,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const H=a?[a,R].join(I.sep):R;if(this.folderExcludePatterns.get(r.folder.fsPath).test(H,R,this.config.filePattern!==R?v:void 0))return O(null);const ne=[l.fsPath,H].join(I.sep);L.lstat(ne,(ie,N)=>{if(ie||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(ne,N,(B,U)=>B||this.isCanceled||this.isLimitHit?O(null):U.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ne,N,(A,x)=>A||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?O(null):(this.walkedPaths[x]=!0,(0,d.readdir)(ne).then(F=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(r,H,F,m,M=>O(M||null))},F=>{O(null)})))):(this.filesWalked++,H===this.filePattern||this.maxFilesize&&o.isNumber(U.size)&&U.size>this.maxFilesize||this.matchFile(m,{base:l.fsPath,relativePath:H,searchPath:this.getSearchPath(r,H)}),O(null,void 0)))})},R=>{const O=R&&y.coalesce(R);return _(O&&O.length>0?O[0]:void 0)})}matchFile(r,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,I.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(a))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,a,g){return a.isSymbolicLink()?L.stat(r,g):g(null,a)}realPathIfNeeded(r,a,g){return a.isSymbolicLink()?L.realpath(r,(m,_)=>m?g(m):g(null,_)):g(null,r)}getSearchPath(r,a){return r.folderName?I.join(r.folderName,a):a}}e.FileWalker=c;class f{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new c(r)}search(r,a,g){this.walker.walk(this.folderQueries,this.extraFiles,r,a,(m,_)=>{g(m,{limitHit:_,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=f;class t{constructor(r,a){this.expression=r,this.root=a,this.init(r)}init(r){let a,g;Object.keys(r).filter(m=>r[m]).forEach(m=>{I.isAbsolute(m)?(a=a||D.getEmptyExpression(),a[m]=r[m]):(g=g||D.getEmptyExpression(),g[m]=r[m])}),this.absoluteParsedExpr=a&&D.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=g&&D.parse(g,{trimForExclusions:!0})}test(r,a,g){return this.relativeParsedExpr&&this.relativeParsedExpr(r,a,g)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,r),a,g)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getPathTerms(this.relativeParsedExpr)),r}}function n(s){const r=s.trim().split(`
`),a=r[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return p.uppercaseFirstLetter(r[r.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=n}),define(me[130],ge([0,1,38,283,101,16,53,32,9,8,2,31,68,284,268,93]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=o.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(l){this.outputChannel=l}provideTextSearchResults(l,v,R,O){return this.outputChannel.appendLine(`provideTextSearchResults ${l.pattern}, ${JSON.stringify(Object.assign(Object.assign({},v),{folder:v.folder.toString()}))}`),new Promise((H,ne)=>{O.onCancellationRequested(()=>M());const ie=n(l,v),N=v.folder.fsPath,B=ie.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${E} ${B}
 - cwd: ${N}`);let U=b.spawn(E,ie,{cwd:N});U.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),ne((0,P.serializeSearchError)(new P.SearchError(ve&&ve.message,P.SearchErrorCode.rgProcessError)))});let A=!1;const x=new c(v.maxResults,N,v.previewOptions);x.on("result",ve=>{A=!0,z="",R.report(ve)});let F=!1;const M=()=>{F=!0,U&&U.kill(),x&&x.cancel()};let W=!1;x.on("hitLimit",()=>{W=!0,M()});let z="";U.stdout.on("data",ve=>{x.handleData(ve),A||(z+=ve)});let Y=!1;U.stdout.once("data",()=>Y=!0);let le="";U.stderr.on("data",ve=>{const Te=ve.toString();this.outputChannel.appendLine(Te),le+=Te}),U.on("close",()=>{if(this.outputChannel.appendLine(Y?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(A?"Got result from parser":"No result from parser"),z&&this.outputChannel.appendLine(`Got data without result: ${z}`),this.outputChannel.appendLine(""),F)H({limitHit:W});else{x.flush(),U=null;let ve;le&&!Y&&(ve=S(le))?ne((0,P.serializeSearchError)(new P.SearchError(ve.message,ve.code))):H({limitHit:W})}})})}}e.RipgrepTextSearchEngine=w;function S(_){const l=_.split(`
`),v=l[0].trim();if(l.some(O=>O.startsWith("regex parse error")))return new P.SearchError(u(l),P.SearchErrorCode.regexParseError);const R=v.match(/grep config error: unknown encoding: (.*)/);if(R)return new P.SearchError(`Unknown encoding: ${R[1]}`,P.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new P.SearchError(v.charAt(0).toUpperCase()+v.substr(1),P.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new P.SearchError(v.charAt(0).toUpperCase()+v.substr(1),P.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(v,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=S;function u(_){const l=["Regex parse error"],v=_.filter(R=>R.startsWith("PCRE2:"));if(v.length>=1){const R=v[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const O=R.split(":")[1];l.push(":"+O)}}return l.join("")}e.buildRegexParseError=u;class c extends L.EventEmitter{constructor(l,v,R){super();this.maxResults=l,this.rootFolder=v,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(l,v){return super.on(l,v),this}handleData(l){if(!this.isDone){const v=typeof l=="string"?l:this.stringDecoder.write(l);this.handleDecodedData(v)}}handleDecodedData(l){let v=l.indexOf(`
`);const R=this.remainder+l;if(v>=0)v+=this.remainder.length;else{this.remainder=R;return}let O=0;for(;v>=0;)this.handleLine(R.substring(O,v).trim()),O=v+1,v=R.indexOf(`
`,O);this.remainder=R.substring(O)}handleLine(l){if(!(this.isDone||!l)){let v;try{v=JSON.parse(l)}catch(R){throw new Error(`malformed line from rg: ${l}`)}if(v.type==="match"){const R=f(v.data.path),O=i.URI.file(D.join(this.rootFolder,R)),H=this.createTextSearchMatch(v.data,O);this.onResult(H),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const R=f(v.data.path),O=i.URI.file(D.join(this.rootFolder,R));this.createTextSearchContext(v.data,O).forEach(ne=>this.onResult(ne))}}}createTextSearchMatch(l,v){const R=l.line_number-1;let O=!1,H=f(l.lines);R===0&&(0,k.startsWithUTF8BOM)(H)&&(O=!0,H=(0,k.stripUTF8BOM)(H));const ne=Buffer.from(H);let ie=0,N=0,B=R;l.submatches.length===0&&l.submatches.push(H.length?{start:0,end:1,match:{text:H[0]}}:{start:0,end:0,match:{text:""}});const U=(0,T.coalesce)(l.submatches.map((A,x)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let F=f(A.match);R===0&&x===0&&O&&(F=(0,k.stripUTF8BOM)(F),A.start=A.start<=3?0:A.start-3,A.end=A.end<=3?0:A.end-3);const M=ne.slice(ie,A.start).toString().length,W=N+M,z=t(F),Y=B,le=z.numLines+Y,ve=z.numLines>0?z.lastLineLength:z.lastLineLength+W;return ie=A.end,N=ve,B=le,new h.Range(Y,W,le,ve)}));return(0,d.createTextSearchResult)(v,H,U,this.previewOptions)}createTextSearchContext(l,v){const R=f(l.lines),O=l.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((H,ne)=>({text:H,uri:v,lineNumber:O+ne}))}onResult(l){this.emit("result",l)}}e.RipgrepParser=c;function f(_){return _.bytes?Buffer.from(_.bytes,"base64").toString():_.text}function t(_){const l=/\n/g;let v=0,R=-1,O;for(;O=l.exec(_);)v++,R=O.index;const H=R>=0?_.length-R-1:_.length;return{numLines:v,lastLineLength:H}}function n(_,l){const v=["--hidden"];v.push(_.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:O}=(0,y.groupBy)(l.includes,ne=>ne.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const ne=new Set;O.forEach(ie=>{ne.add(ie)}),v.push("-g","!*"),ne.forEach(ie=>{s(ie).map(d.anchorGlob).forEach(N=>{v.push("-g",N)})})}R&&R.length&&R.forEach(ne=>{v.push("-g",ne)}),l.excludes.map(d.anchorGlob).forEach(ne=>v.push("-g",`!${ne}`)),l.maxFileSize&&v.push("--max-filesize",l.maxFileSize+""),l.useIgnoreFiles?v.push("--no-ignore-parent"):v.push("--no-ignore"),l.followSymlinks&&v.push("--follow"),l.encoding&&l.encoding!=="utf8"&&v.push("--encoding",l.encoding),_.pattern==="--"&&(_.isRegExp=!0,_.pattern="\\-\\-"),_.isMultiline&&!_.isRegExp&&(_.pattern=(0,k.escapeRegExpCharacters)(_.pattern),_.isRegExp=!0),l.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),_.isRegExp&&(_.pattern=r(_.pattern),v.push("--auto-hybrid-regex"));let H;if(_.isWordMatch){const ie=(0,k.createRegExp)(_.pattern,!!_.isRegExp,{wholeWord:_.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",ie)}else if(_.isRegExp){let ne=g(_.pattern);ne=m(ne),v.push("--regexp",ne)}else H=_.pattern,v.push("--fixed-strings");return v.push("--no-config"),l.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),_.isMultiline&&v.push("--multiline"),l.beforeContext&&v.push("--before-context",l.beforeContext+""),l.afterContext&&v.push("--after-context",l.afterContext+""),v.push("--"),H&&v.push(H),v.push("."),v}function s(_){const l=(0,C.splitGlobAware)(_,"/");return l.map((v,R)=>l.slice(0,R+1).join("/"))}e.spreadGlobComponents=s;function r(_){const l=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;_.match(l);)_=_.replace(l,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;_.match(v);)_=_.replace(v,"$1\\x{$2}");return _}e.unicodeEscapesToPCRE2=r;const a=_=>_.type==="Assertion"&&_.kind==="lookbehind";function g(_){let l;try{l=new p.RegExpParser().parsePattern(_)}catch(ie){return _}let v="",R=0;const O=(ie,N,B)=>{v+=_.slice(R,ie)+B,R=N},H=[];return new p.RegExpVisitor({onCharacterEnter(ie){if(ie.raw==="\\n"){const N=H[0];if(!N)O(ie.start,ie.end,"\\r?\\n");else if(!H.some(a))if(N.type==="CharacterClass")if(N.negate){const B=_.slice(N.start+2,ie.start)+_.slice(ie.end,N.end-1);O(N.start,N.end,"(?!\\r?\\n"+(B?`|[${B}]`:"")+")")}else{const B=_.slice(N.start+1,ie.start)+_.slice(ie.end,N.end-1);O(N.start,N.end,B===""?"\\r?\\n":`(?:[${B}]|\\r?\\n)`)}else N.type==="Quantifier"&&O(ie.start,ie.end,"(?:\\r?\\n)")}},onQuantifierEnter(ie){H.unshift(ie)},onQuantifierLeave(){H.shift()},onCharacterClassRangeEnter(ie){H.unshift(ie)},onCharacterClassRangeLeave(){H.shift()},onCharacterClassEnter(ie){H.unshift(ie)},onCharacterClassLeave(){H.shift()},onAssertionEnter(ie){a(ie)&&H.push(ie)},onAssertionLeave(ie){H[0]===ie&&H.shift()}}).visit(l),v+=_.slice(R),v}e.fixRegexNewline=g;function m(_){return _.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(me[270],ge([0,1,21,130,115,12]),function(G,e,b,L,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,i,P,h){const p=new L.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===T.Schemas.userData){const o=Object.assign(Object.assign({},i),{folder:i.folder.with({scheme:T.Schemas.file})}),d=new I.Progress(E=>P.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:i.folder.scheme})})));return this.withToken(h,E=>p.provideTextSearchResults(k,o,d,E))}else return this.withToken(h,o=>p.provideTextSearchResults(k,i,P,o))}async withToken(k,i){const P=C(k);this.inProgress.add(P);const h=await i(P.token);return this.inProgress.delete(P),h}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=y;function C(D){const k=new b.CancellationTokenSource;return D.onCancellationRequested(()=>k.cancel()),k}}),define(me[271],ge([0,1,28,130,129]),function(G,e,b,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class T{constructor(D){this.query=D}search(D,k,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(p){i({message:p})}},h=new I.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(P),b);return new Promise((p,o)=>h.search(d=>{k(d.map(y))},D).then(d=>p({limitHit:d.limitHit,type:"success"}),o))}}e.TextSearchEngineAdapter=T;function y(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((D,k)=>{if(k.ranges){const i=k;return D+(Array.isArray(i.ranges)?i.ranges.length:1)}else return D+1},0)}}}),define(me[272],ge([0,1,37,285,16,13,17,3,99,9,45,2,44,31,269,271]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(b);class E{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const s=u(t),r=new C.Emitter({onFirstListenerDidAdd:()=>{n=(0,T.createCancelablePromise)(a=>this.doFileSearchWithEngine(o.Engine,s,g=>r.fire(g),a)),n.then(a=>r.fire(a),a=>r.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}textSearch(t){let n;const s=u(t),r=new C.Emitter({onFirstListenerDidAdd:()=>{n=(0,T.createCancelablePromise)(a=>this.ripgrepTextSearch(s,g=>r.fire(g),a)),n.then(a=>r.fire(a),a=>r.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}ripgrepTextSearch(t,n,s){return t.maxFileSize=(0,h.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new d.TextSearchEngineAdapter(t).search(s,n,n)}doFileSearch(t,n,s){return this.doFileSearchWithEngine(o.Engine,t,n,s)}doFileSearchWithEngine(t,n,s,r,a=E.BATCH_SIZE){let g=0;const m=l=>{Array.isArray(l)?(g+=l.length,s(l.map(v=>this.rawMatchToSearchItem(v)))):l.relativePath?(g++,s(this.rawMatchToSearchItem(l))):s(l)};if(n.sortByScore){let l=this.trySortedSearchFromCache(n,m,r);if(!l){const v=n.maxResults?Object.assign({},n,{maxResults:null}):n,R=new t(v);l=this.doSortedSearch(R,n,s,m,r)}return new Promise((v,R)=>{l.then(([O,H])=>{const ne=H.map(ie=>this.rawMatchToSearchItem(ie));this.sendProgress(ne,s,a),v(O)},R)})}const _=new t(n);return this.doSearch(_,m,a,r).then(l=>({limitHit:l.limitHit,type:"success",stats:{detailStats:l.stats,type:"searchProcess",fromCache:!1,resultCount:g,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,k.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,s,r,a){const g=new C.Emitter;let m=(0,T.createCancelablePromise)(l=>{let v=[];const R=O=>{Array.isArray(O)?v=O:(r(O),g.fire(O))};return this.doSearch(t,R,-1,l).then(O=>[O,v])}),_;if(n.cacheKey){_=this.getOrCreateCache(n.cacheKey);const l={promise:m,event:g.event,resolved:!1};_.resultsToSearchCache[n.filePattern||""]=l,m.then(()=>{l.resolved=!0},v=>{delete _.resultsToSearchCache[n.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([l,v])=>{const R=_?_.scorerCache:Object.create(null),O=(typeof n.maxResults!="number"||n.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(n,v,R,a).then(H=>{const ne=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:l.stats,sortingTime:ne,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:H.length},messages:l.messages,limitHit:l.limitHit||typeof n.maxResults=="number"&&v.length>n.maxResults},H]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new w)}trySortedSearchFromCache(t,n,s){const r=t.cacheKey&&this.caches[t.cacheKey];if(!!r){const a=this.getResultsFromCache(r,t.filePattern||"",n,s);if(a)return a.then(([g,m,_])=>{const l=i.StopWatch.create(!1);return this.sortResults(t,m,r.scorerCache,s).then(v=>{const R=l.elapsed(),O={fromCache:!0,detailStats:_,type:"searchProcess",resultCount:m.length,sortingTime:R};return[{type:"success",limitHit:g.limitHit||typeof t.maxResults=="number"&&m.length>t.maxResults,stats:O},v]})})}}sortResults(t,n,s,r){const a=(0,D.prepareQuery)(t.filePattern||""),g=(_,l)=>(0,D.compareItemsByFuzzyScore)(_,l,a,!0,S,s),m=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return I.topAsync(n,g,m,1e4,r)}sendProgress(t,n,s){if(s&&s>0)for(let r=0;r<t.length;r+=s)n(t.slice(r,r+s));else n(t)}getResultsFromCache(t,n,s,r){const a=i.StopWatch.create(!1),g=n.indexOf(k.sep)>=0;let m;for(const R in t.resultsToSearchCache)if(n.startsWith(R)){if(g&&R.indexOf(k.sep)<0&&R!=="")continue;const O=t.resultsToSearchCache[R];m={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!m)return null;const _=a.elapsed(),l=i.StopWatch.create(!1),v=m.event(s);return r&&r.onCancellationRequested(()=>{v.dispose()}),m.promise.then(([R,O])=>{if(r&&r.isCancellationRequested)throw(0,y.canceled)();const H=[],ne=(0,D.prepareQuery)(n).normalizedLowercase;for(const ie of O)!(0,p.isFilePatternMatch)(ie,ne)||H.push(ie);return[R,H,{cacheWasResolved:m.resolved,cacheLookupTime:_,cacheFilterTime:l.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,n,s,r){return new Promise((a,g)=>{let m=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(_=>{_&&(s?(m.push(_),s>0&&m.length>=s&&(n(m),m=[])):n(_))},_=>{n(_)},(_,l)=>{m.length&&n(m),_?g(_):a(l)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,s){return t.then(n,s)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=E,E.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const S=new class{getItemLabel(f){return(0,k.basename)(f.relativePath)}getItemDescription(f){return(0,k.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function u(f){return Object.assign(Object.assign({},f),{folderQueries:f.folderQueries&&f.folderQueries.map(c),extraFileResources:f.extraFileResources&&f.extraFileResources.map(t=>P.URI.revive(t))})}function c(f){return Object.assign(Object.assign({},f),{folder:P.URI.revive(f.folder)})}}),define(me[273],ge([0,1,6,2,28,14,31,272,270,93,15,63,27,71,12,129]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends p.ExtHostSearch{constructor(S,u,c,f){super(S,c,f);this._pfs=I,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new k.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(o.Schemas.userData,new D.RipgrepSearchProvider(t)),u.remote.isRemote&&u.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const S=new k.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(o.Schemas.file,new D.RipgrepSearchProvider(S)),this.registerInternalFileSearchProvider(o.Schemas.file,new C.SearchService)}registerInternalFileSearchProvider(S,u){const c=this._handlePool++;return this._internalFileSearchProvider=u,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(S)),(0,b.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(S,u,c,f){const t=(0,p.reviveQuery)(c);return S===this._internalFileSearchHandle?this.doInternalFileSearch(S,u,t,f):super.$provideFileSearchResults(S,u,c,f)}doInternalFileSearch(S,u,c,f){const t=n=>{if((0,y.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(S,u,n.map(s=>L.URI.file(s.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,t,f)}$clearCache(S){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(S),super.$clearCache(S)}createTextSearchManager(S,u){return new d.NativeTextSearchManager(S,u)}};E=qe([We(0,i.IExtHostRpcService),We(1,h.IExtHostInitDataService),We(2,P.IURITransformerService),We(3,T.ILogService)],E),e.NativeExtHostSearch=E}),define(me[131],ge([0,1,286,122,287,3,104,9,102,30,6,23,105,17,10]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(m){this.socket=m,this._errorListener=_=>{if(_){if(_.code==="EPIPE")return;(0,p.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const _=l=>m(P.VSBuffer.wrap(l));return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(m){return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,p.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,p.onUnexpectedError)(_)}}end(){this.socket.end()}drain(){return new Promise((m,_)=>{if(this.socket.bufferSize===0){m();return}const l=()=>{this.socket.off("close",l),this.socket.off("end",l),this.socket.off("error",l),this.socket.off("timeout",l),this.socket.off("drain",l),m()};this.socket.on("close",l),this.socket.on("end",l),this.socket.on("error",l),this.socket.on("timeout",l),this.socket.on("drain",l)})}}e.NodeSocket=d;var E;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var w;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(w||(w={}));class S extends i.Disposable{constructor(m,_,l,v){super();this._onDidZlibFlush=this._register(new T.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new T.Emitter),this._onClose=this._register(new T.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=_,this._recordInflateBytes=v,_?(this._zlibInflate=I.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",R=>{console.error(R),(0,p.onUnexpectedError)(R),this._onClose.fire()}),this._zlibInflate.on("data",R=>{this._pendingInflateData.push(R)}),l&&(this._zlibInflate.write(l.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=I.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{console.error(R),(0,p.onUnexpectedError)(R),this._onClose.fire()}),this._zlibDeflate.on("data",R=>{this._pendingDeflateData.push(R)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new h.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):P.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let _=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.length-4),this._isEnded||this._write(P.VSBuffer.wrap(_),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,_){let l=2;m.byteLength<126?l+=0:m.byteLength<2**16?l+=2:l+=8;const v=P.VSBuffer.alloc(l);if(_?v.writeUInt8(194,0):v.writeUInt8(130,0),m.byteLength<126)v.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){v.writeUInt8(126,1);let R=1;v.writeUInt8(m.byteLength>>>8&255,++R),v.writeUInt8(m.byteLength>>>0&255,++R)}else{v.writeUInt8(127,1);let R=1;v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(m.byteLength>>>24&255,++R),v.writeUInt8(m.byteLength>>>16&255,++R),v.writeUInt8(m.byteLength>>>8&255,++R),v.writeUInt8(m.byteLength>>>0&255,++R)}this._totalOutgoingWireBytes+=v.byteLength+m.byteLength,this.socket.write(P.VSBuffer.concat([v,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),v=(_.readUInt8(0)&128)>>>7,R=_.readUInt8(1),O=(R&128)>>>7,H=R&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=v,this._state.mask=0}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),l=_.readUInt8(1),v=(l&128)>>>7;let R=l&127,O=1;R===126?R=_.readUInt8(++O)*2**8+_.readUInt8(++O):R===127&&(R=_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*2**24+_.readUInt8(++O)*2**16+_.readUInt8(++O)*2**8+_.readUInt8(++O));let H=0;v&&(H=_.readUInt8(++O)*2**24+_.readUInt8(++O)*2**16+_.readUInt8(++O)*2**8+_.readUInt8(++O)),this._state.state=3,this._state.readLen=R,this._state.mask=H}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);u(_,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(_.buffer)),this._zlibInflate.write(_.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const l=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=l.length,this._onData.fire(P.VSBuffer.wrap(l))})):(this._totalIncomingDataBytes+=_.byteLength,this._onData.fire(_))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await T.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=S;function u(g,m){if(m!==0){let _=g.byteLength>>>2;for(let ne=0;ne<_;ne++){const ie=g.readUInt32BE(ne*4);g.writeUInt32BE(ie^m,ne*4)}let l=_*4,v=g.byteLength-l;const R=m>>>24&255,O=m>>>16&255,H=m>>>8&255;v>=1&&g.writeUInt8(g.readUInt8(l)^R,l),v>=2&&g.writeUInt8(g.readUInt8(l+1)^O,l+1),v>=3&&g.writeUInt8(g.readUInt8(l+2)^H,l+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function f(){const g=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let m;return e.XDG_RUNTIME_DIR?m=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):m=(0,C.join)((0,D.tmpdir)(),`vscode-ipc-${g}.sock`),n(m),m}e.createRandomIPCHandle=f;function t(g,m,_){const l=(0,b.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${l}-${_}-${m}-sock`;let v;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?v=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${l.substr(0,8)}-${_}-${m}.sock`):v=(0,C.join)(g,`${_}-${m}.sock`),n(v),v}e.createStaticIPCHandle=t;function n(g){const m=c[o.platform];typeof m=="number"&&g.length>=m&&console.warn(`WARNING: IPC handle "${g}" is longer than ${m} chars, try a shorter --user-data-dir`)}class s extends y.IPCServer{constructor(m){super(s.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const _=T.Event.fromNodeEventEmitter(m,"connection");return T.Event.map(_,l=>({protocol:new h.Protocol(new d(l)),onDidClientDisconnect:T.Event.once(T.Event.fromNodeEventEmitter(l,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(g){return new Promise((m,_)=>{const l=(0,L.createServer)();l.on("error",_),l.listen(g,()=>{l.removeListener("error",_),m(new s(l))})})}e.serve=r;function a(g,m){return new Promise((_,l)=>{const v=(0,L.createConnection)(g,()=>{v.removeListener("error",l),_(h.Client.fromSocket(new d(v),m))});v.once("error",l)})}e.connect=a}),define(me[274],ge([0,1,131,266,37,50,2,118,14]),function(G,e,b,L,I,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(h,p,o){this._commands=h,this.logService=p,this._ipcHandlePath=o,this._server=L.createServer((d,E)=>this.onRequest(d,E)),this.setup().catch(d=>(p.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",h=>this.logService.error(h))}catch(h){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(h,p){const o=[];h.setEncoding("utf8"),h.on("data",d=>o.push(d)),h.on("end",()=>{const d=JSON.parse(o.join(""));switch(d.type){case"open":this.open(d,p);break;case"openExternal":this.openExternal(d,p);break;case"status":this.getStatus(d,p);break;case"extensionManagement":this.manageExtensions(d,p).catch(this.logService.error);break;default:p.writeHead(404),p.write(`Unknown message type: ${d.type}`,E=>{E&&this.logService.error(E)}),p.end();break}})}open(h,p){let{fileURIs:o,folderURIs:d,forceNewWindow:E,diffMode:w,addMode:S,forceReuseWindow:u,gotoLineMode:c,waitMarkerFilePath:f}=h;const t=[];if(Array.isArray(d))for(const n of d)try{t.push({folderUri:y.URI.parse(n)})}catch(s){}if(Array.isArray(o))for(const n of o)try{(0,C.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:y.URI.parse(n)}):t.push({fileUri:y.URI.parse(n)})}catch(s){}if(t.length){const n=f?y.URI.file(f):void 0,r={forceNewWindow:E,diffMode:w,addMode:S,gotoLineMode:c,forceReuseWindow:u,preferNewWindow:!u&&!n&&!S,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}p.writeHead(200),p.end()}async openExternal(h,p){for(const o of h.uris){const d=y.URI.parse(o),E=d.scheme==="file"?d:o;await this._commands.executeCommand("_remoteCLI.openExternal",E)}p.writeHead(200),p.end()}async manageExtensions(h,p){try{const o=w=>w==null?void 0:w.map(S=>/\.vsix$/i.test(S)?y.URI.parse(S):S),d={list:h.list,install:o(h.install),uninstall:o(h.uninstall),force:h.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",d);p.writeHead(200),p.write(E)}catch(o){p.writeHead(500),p.write(String(o),d=>{d&&this.logService.error(d)})}p.end()}async getStatus(h,p){try{const o=await this._commands.executeCommand("_remoteCLI.getSystemStatus");p.writeHead(200),p.write(o),p.end()}catch(o){p.writeHead(500),p.write(String(o),d=>{d&&this.logService.error(d)}),p.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let i=class extends k{constructor(h,p){super(h,p,(0,b.createRandomIPCHandle)())}};i=qe([We(0,T.IExtHostCommands),We(1,D.ILogService)],i),e.CLIServer=i}),define(me[275],ge([0,1,70,262,257,5,265,42,247,2,12,7,274,103]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class o extends I.RequireInterceptor{_installInterceptor(){const w=this,S=G.__$__nodeRequire("module"),u=S._load;S._load=function(f,t,n){for(let s of w._alternatives){let r=s(f);if(r){f=r;break}}return w._factories.has(f)?w._factories.get(f).load(f,k.URI.file((0,p.realpathSync)(t.filename)),s=>u.apply(this,[s,t,n])):u.apply(this,arguments)}}}class d extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(h.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(o,w,this._registry).install(),b.mark("code/extHost/didInitAPI");const u=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,u,this,this._logService,this._mainThreadTelemetryProxy,this._initData),b.mark("code/extHost/didInitProxyResolver");const c=process.send,f=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?c.apply(process,t):(f.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,S,u){if(S.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${S}', must be of file-scheme`);let c=null;u.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${S.toString(!0)}`),this._logService.flush();try{w&&b.mark(`code/extHost/willLoadExtensionCode/${w.value}`),c=G.__$__nodeRequire(S.fsPath)}catch(f){return Promise.reject(f)}finally{w&&b.mark(`code/extHost/didLoadExtensionCode/${w.value}`),u.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const S in w){const u=w[S];u===null?delete process.env[S]:process.env[S]=u}}}e.ExtHostExtensionService=d}),define(me[276],ge([0,1,79,248,249,259,258,273,275,219,250,51,42,66,71,69,33,49,14]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(h.IExtHostExtensionService,D.ExtHostExtensionService),(0,b.registerSingleton)(S.ILogService,k.ExtHostLogService),(0,b.registerSingleton)(P.IExtHostDebugService,y.ExtHostDebugService),(0,b.registerSingleton)(p.IExtHostOutputService,L.ExtHostOutputService2),(0,b.registerSingleton)(o.IExtHostSearch,C.NativeExtHostSearch),(0,b.registerSingleton)(d.IExtHostTask,T.ExtHostTask),(0,b.registerSingleton)(E.IExtHostTerminalService,I.ExtHostTerminalService),(0,b.registerSingleton)(w.IExtHostTunnelService,i.ExtHostTunnelService)}),define(me[277],ge([0,1,122,288,70,17,105,131,185,217,260,23,100,28,103,13,263,276]),function(G,e,b,L,I,T,y,C,D,k,i,P,h,p,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const E=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=G.__$__nodeRequire("module"),r=s._load;s._load=function(a){if(a==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const w=process.exit.bind(process);function S(s){process.exit=function(r){if(s)w(r);else{const a=new Error("An extension called process.exit() and this was prevented.");console.warn(a.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let u=function(s){w()};function c(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,r)=>{let a=null,g=setTimeout(()=>{u("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,_=3e5,l=new d.RunOnceScheduler(()=>u("renderer disconnected for too long (1)"),m),v=new d.RunOnceScheduler(()=>u("renderer disconnected for too long (2)"),_);process.on("message",(O,H)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ne=P.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let ie;if(O.skipWebSocketFrames)ie=new C.NodeSocket(H);else{const N=P.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));ie=new C.WebSocketNodeSocket(new C.NodeSocket(H),O.permessageDeflate,N,!1)}a?(l.cancel(),v.cancel(),a.beginAcceptReconnection(ie,ne),a.endAcceptReconnection()):(clearTimeout(g),a=new y.PersistentProtocol(ie,ne),a.onDidDispose(()=>u("renderer disconnected")),s(a),a.onSocketClose(()=>{l.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(v.isScheduled())return;l.isScheduled()&&v.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,a)=>{const g=b.createConnection(s,()=>{g.removeListener("error",a),r(new y.PersistentProtocol(new C.NodeSocket(g)))});g.once("error",a),g.on("close",()=>{u("renderer closed the socket")})})}}async function f(){const s=await c();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(r=>{(0,k.isMessageOfType)(r,2)?(this._terminating=!0,u("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||s.send(r)}drain(){return s.drain()}}}function t(s){return new Promise(r=>{const a=s.onMessage(g=>{a.dispose();const m=JSON.parse(g.toString()),_=m.commit,l=D.default.commit;_&&l&&_!==l&&w(55);const v=[];process.on("unhandledRejection",(H,ne)=>{v.push(ne),setTimeout(()=>{const ie=v.indexOf(ne);ie>=0&&ne.catch(N=>{v.splice(ie,1),console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),(0,T.onUnexpectedError)(H)})},1e3)}),process.on("rejectionHandled",H=>{const ne=v.indexOf(H);ne>=0&&v.splice(ne,1)}),process.on("uncaughtException",function(H){(0,T.onUnexpectedError)(H)});let R=0;setInterval(function(){try{process.kill(m.parentPid,0),R=0}catch(H){H&&H.code==="EPERM"?(R++,R>=3&&u(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${H.message} (code: ${H.code}) (errno: ${H.errno})`)):u(`parent process ${m.parentPid} does not exist anymore: ${H.message} (code: ${H.code}) (errno: ${H.errno})`)}},1e3);let O;try{O=G.__$__nodeRequire("native-watchdog"),O.start(m.parentPid)}catch(H){(0,T.onUnexpectedError)(H)}s.send((0,k.createMessageOfType)(0)),r({protocol:s,initData:m})});s.send((0,k.createMessageOfType)(1))})}async function n(){I.mark("code/extHost/willConnectToRenderer");const s=await f();I.mark("code/extHost/didConnectToRenderer");const r=await t(s);I.mark("code/extHost/didWaitForInitData");const{initData:a}=r;S(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0;const g=new class{exit(v){w(v)}exists(v){return(0,p.exists)(v)}realpath(v){return(0,o.realpath)(v)}};let m=null;if(a.remote.authority&&E.uriTransformerPath)try{const v=G.__$__nodeRequire(E.uriTransformerPath)(a.remote.authority);m=new h.URITransformer(v)}catch(l){console.error(l)}const _=new i.ExtensionHostMain(r.protocol,a,g,m);u=l=>_.terminate(l)}e.startExtensionHostProcess=n}),define(me[289],ge([0,1,277]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/53b58c89d44deb230dc526605561a1d42f6d1c50/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
